using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using CCPM.Data;
using System.Data;

namespace CCPM.Contact
{
	/// <summary>
	/// Associate a contact with a project and select the associate type.
	/// </summary>
	public class AssociateContact : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label lblExt;
		private System.Windows.Forms.Label lblOrganizationName;
		private System.Windows.Forms.Label lblName;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label1;
		private int contactId = 0;
		private int projectId = 0;
		private System.Windows.Forms.Button btnAdd;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ListBox lbContactType;
		private System.Windows.Forms.Label lable1;
		private System.Windows.Forms.Button btnCancel;
		private Genghis.Windows.Forms.RequiredFieldValidator rfvContactType;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		public int ContactId
		{
			get{return contactId;}
			set{contactId = value;}
		}
		public int ProjectId
		{
			get{return projectId;}
			set{projectId = value;}
		}
		public AssociateContact(int contactId, int projectId)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			ContactId = contactId;
			ProjectId = projectId;
			PopulateForm();
		}

		private void PopulateForm()
		{
			DataSet dsType = ContactData.ContactTypeList(1); //include inactive
			ContactDataSet cds = ContactData.GetContactForEdit(ContactId);

			lblName.Text = string.Concat(
				cds.Tables["ContactList"].Rows[0]["ContactFName"].ToString(),
				" ",
				cds.Tables["ContactList"].Rows[0]["ContactLName"].ToString());
			lblOrganizationName.Text = cds.Tables["ContactList"].Rows[0]["ContactOrg"].ToString();
			lbContactType.DataSource = dsType;
			lbContactType.DisplayMember = "Table.ContactType";
			lbContactType.ValueMember = "Table.ContactTypeId";
		}

		private bool IsValid()
		{
			this.lbContactType.Focus();
			this.groupBox1.Focus();
			return rfvContactType.IsValid;
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AssociateContact));
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnAdd = new System.Windows.Forms.Button();
			this.label3 = new System.Windows.Forms.Label();
			this.lbContactType = new System.Windows.Forms.ListBox();
			this.lblExt = new System.Windows.Forms.Label();
			this.lable1 = new System.Windows.Forms.Label();
			this.lblOrganizationName = new System.Windows.Forms.Label();
			this.lblName = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.rfvContactType = new Genghis.Windows.Forms.RequiredFieldValidator();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.rfvContactType)).BeginInit();
			this.SuspendLayout();
			// 
			// groupBox1
			// 
			this.groupBox1.BackColor = System.Drawing.SystemColors.Control;
			this.groupBox1.Controls.Add(this.btnCancel);
			this.groupBox1.Controls.Add(this.btnAdd);
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.lbContactType);
			this.groupBox1.Controls.Add(this.lblExt);
			this.groupBox1.Controls.Add(this.lable1);
			this.groupBox1.Controls.Add(this.lblOrganizationName);
			this.groupBox1.Controls.Add(this.lblName);
			this.groupBox1.Controls.Add(this.label8);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Location = new System.Drawing.Point(16, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(400, 304);
			this.groupBox1.TabIndex = 1;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Select Contact Type";
			// 
			// btnCancel
			// 
			this.btnCancel.Location = new System.Drawing.Point(264, 264);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 77;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// btnAdd
			// 
			this.btnAdd.Location = new System.Drawing.Point(120, 264);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.Size = new System.Drawing.Size(80, 23);
			this.btnAdd.TabIndex = 76;
			this.btnAdd.Text = "Add Contact";
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 152);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(80, 23);
			this.label3.TabIndex = 75;
			this.label3.Text = "Contact Type";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lbContactType
			// 
			this.lbContactType.Location = new System.Drawing.Point(120, 152);
			this.lbContactType.Name = "lbContactType";
			this.lbContactType.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple;
			this.lbContactType.Size = new System.Drawing.Size(248, 95);
			this.lbContactType.TabIndex = 74;
			// 
			// lblExt
			// 
			this.lblExt.Location = new System.Drawing.Point(600, 81);
			this.lblExt.Name = "lblExt";
			this.lblExt.Size = new System.Drawing.Size(64, 24);
			this.lblExt.TabIndex = 68;
			this.lblExt.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lable1
			// 
			this.lable1.Location = new System.Drawing.Point(16, 104);
			this.lable1.Name = "lable1";
			this.lable1.Size = new System.Drawing.Size(352, 40);
			this.lable1.TabIndex = 63;
			this.lable1.Text = "Select one or more contat types and click \"Add Contact\"";
			this.lable1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblOrganizationName
			// 
			this.lblOrganizationName.Location = new System.Drawing.Point(128, 56);
			this.lblOrganizationName.Name = "lblOrganizationName";
			this.lblOrganizationName.Size = new System.Drawing.Size(240, 24);
			this.lblOrganizationName.TabIndex = 57;
			this.lblOrganizationName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblName
			// 
			this.lblName.Location = new System.Drawing.Point(128, 33);
			this.lblName.Name = "lblName";
			this.lblName.Size = new System.Drawing.Size(240, 24);
			this.lblName.TabIndex = 56;
			this.lblName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(16, 56);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(104, 23);
			this.label8.TabIndex = 46;
			this.label8.Text = "Organization Name";
			this.label8.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 23);
			this.label1.TabIndex = 40;
			this.label1.Text = "Name";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// rfvContactType
			// 
			this.rfvContactType.ControlToValidate = this.lbContactType;
			this.rfvContactType.ErrorMessage = "Please select at least one contact type.";
			this.rfvContactType.Icon = ((System.Drawing.Icon)(resources.GetObject("rfvContactType.Icon")));
			// 
			// AssociateContact
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(440, 326);
			this.Controls.Add(this.groupBox1);
			this.Name = "AssociateContact";
			this.Text = "Add Existing Contact to Project";
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.rfvContactType)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.Ignore;
			this.Close();
		}

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			if(IsValid())
			{
				for(int i = 0; i < lbContactType.SelectedItems.Count; i++)
				{
					DataRowView drv = (DataRowView)lbContactType.SelectedItems[i];
					ContactData.Contact_ContactTypeInsert(this.ProjectId, this.ContactId, (int)drv["ContactTypeId"]);
				}
				AssociateContactConfirm acc = new AssociateContactConfirm();
				DialogResult dr = acc.ShowDialog(this);
				if(acc.DialogResult == DialogResult.Abort)
				{
					this.DialogResult = DialogResult.Abort;
					this.Close();
				}
				else
				{
					this.Close();
				}
			}
			else
			{
				MessageBox.Show("Please select at least one Contact Type!");
			}

		}
	}
}
