﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CCPM.Data;
using Microsoft.ApplicationBlocks.Data;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace CCPM.Contact
{
    public partial class CreateContact : Form
    {
        int ContactId = 0;
        int OrgId = 0;
        int OrgAddressID = 0;
        string Action = ""; string formType = "";
        string add, city, state, zip;
        bool blnViewOnly = false;

        public CreateContact(int contactId, string action, int OrgID, string type)
        {
            InitializeComponent();
            ContactId = contactId;
            OrgId = OrgID;
            Action = action;
            formType = type;
            //cmbOrganization.Items.Insert(0, "");

            retrieveData();
        }

        private void SetSecurity()
        {
            //if (GlobalSettings.IsAdministrator || GlobalSettings.IsContractsManager  || GlobalSettings.IsContractsStaff || GlobalSettings.IsProjectManager)
            //{
            //    blnViewOnly = false;
            //}
            //else
            //{
            //    blnViewOnly = true;
            //    btnSave.Visible = false;
            //}
        }

        private void loadOrgCombo()
        {
            DataSet dsOrg = ContactData.GetOrganizationList();
            cmbOrganization.DataSource = null;
            cmbOrganization.DataSource = dsOrg.Tables[0];
            cmbOrganization.DisplayMember = "Organization";
            cmbOrganization.ValueMember = "OrgID";

            //cmbOrganization.SelectedIndex = 1;
            
        }

        private void loadData()
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            DataSet ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select C.*, org.*, oa.* from Contact C LEFT OUTER JOIN Organization org ON C.OrgID = org.OrgID LEFT OUTER JOIN OrgAddress oa ON C.OrgAddressID = oa.OrgAddressID where ContactID = " + ContactId);
            //DataSet ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select C.*, org.*, oa.* from Contact C INNER JOIN Contact_Org_ProjectRole cop ON C.ContactID = cop.ContactId LEFT OUTER JOIN Organization org ON cop.OrgID = org.OrgID LEFT OUTER JOIN OrgAddress oa ON C.OrgAddressID = oa.OrgAddressID where cop.ContactID = " + ContactId);
            if (ds.Tables[0].Rows.Count > 0)
            {
                DataRow dr = ds.Tables[0].Rows[0];
                txtFname.Text = dr["ContactFName"].ToString();
                txtLname.Text = dr["ContactLName"].ToString();
                txtJobTitle.Text = dr["ContactJobTitle"].ToString();
                txtPhone.Text = dr["ContactPhone"].ToString();
                txtExtension.Text = dr["ContactExtension"].ToString();
                txtCell.Text = dr["ContactCellPhone"].ToString();
                txtFax.Text = dr["ContactFax"].ToString();
                txtEmail.Text = dr["ContactEmail"].ToString();
                txtContactNotes.Text = dr["ContactNotes"].ToString();
                cmbOrganization.Text = dr["Organization"].ToString();
                cmbDept.Text = dr["DepartmentOffice"].ToString();
                txtStreet.Text = dr["Address"].ToString();
                txtCity.Text = dr["City"].ToString();  // +' ' + dr["State"].ToString() + ' ' + dr["Zip"].ToString();
                txtState.Text = dr["State"].ToString();
                txtZip.Text = dr["Zip"].ToString();
                txtMainPhone.Text = dr["GeneralPhone"].ToString();
                txtMainFax.Text = dr["GeneralFax"].ToString();
                txtOrgNotes.Text = dr["OrgNotes"].ToString();
            }            
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (blnViewOnly)
                return;

            bool blnDataValid = true;
            if (chkLinkOrg.Checked == false)
            {
                //if (cmbOrganization.SelectedIndex == -1)
                if (cmbOrganization.SelectedRow == null)
                {
                    if (Action != "addlink")
                    {
                        MessageBox.Show("Please select an organization to link !!", "Data Entry Error", MessageBoxButtons.OK);
                        blnDataValid = false;
                    }
                }
                else
                {
                    blnDataValid = true;
                }
            }
            else
            {
                cmbOrganization.Value = 0;
                cmbDept.SelectedValue = 0;               
            }

            if (txtFname.Text == string.Empty)
            {
                MessageBox.Show("Please enter first name !!", "Data Entry Error", MessageBoxButtons.OK);
                blnDataValid = false;
            }
            else if (txtLname.Text == string.Empty)
            {
                MessageBox.Show("Please enter last name !!", "Data Entry Error", MessageBoxButtons.OK);
                blnDataValid = false;
            }

            if (blnDataValid == true)
            {
                bool blnExists = false;
                if (Action == "insert")
                {
                    add = txtStreet.Text.ToString();
                    city = txtCity.Text.ToString();
                    state = txtState.Text.ToString();
                    zip = txtZip.Text.ToString();
                    DataSet ds = null;
                    //if (cmbOrganization.SelectedIndex > -1)
                    if (cmbOrganization.SelectedRow !=null)
                        {
                        ds = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select * from Contact where (ContactFName = '" + txtFname.Text + "' and ContactLName = '" + txtLname.Text + "' and (OrgID = " + Convert.ToInt32(cmbOrganization.Value) + "))");
                        if (ds.Tables[0].Rows.Count > 0)
                        {
                            blnExists = true;
                        }
                        else
                        {
                            DataSet ds1 = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select * from Contact where (ContactFName = '" + txtFname.Text + "' and ContactLName = '" + txtLname.Text + "'and (OrgID is null))");
                            if (ds1.Tables[0].Rows.Count > 0)
                            {
                                int retval1 = SqlHelper.ExecuteNonQuery(GlobalSettings.ConnectionString, CommandType.Text, "delete from Contact where (ContactFName = '" + txtFname.Text + "' and ContactLName = '" + txtLname.Text + "' and (OrgID is null))");
                                blnExists = false;
                            }
                        }
                    }
                    else
                    {
                        ds = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select * from Contact where (ContactFName = '" + txtFname.Text + "' and ContactLName = '" + txtLname.Text + "'and (OrgID is null))");
                        blnExists = true;
                    }
                    if (blnExists == false)
                    {
                        int retVal = ContactData.InsertContact(txtFname.Text, txtLname.Text, txtJobTitle.Text, txtPhone.Text, txtExtension.Text, txtCell.Text,
                                                                txtEmail.Text, txtFax.Text, txtContactNotes.Text, (cmbOrganization.Value), OrgAddressID,
                                                                add, city, state, zip);
                        if (retVal == -1)
                        {
                            MessageBox.Show("Insert failed ", "Database Error",
                               MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                        else
                        {
                            MessageBox.Show("Data has been saved successfully !!");
                            if (formType == "project")
                            {
                                LinkContact lc = new LinkContact(Convert.ToInt32(cmbOrganization.Value), "project");
                                Form1 fm = (Form1)this.MdiParent;
                                fm.OpenForm(lc, "Link Contact");
                                this.Close();
                            }
                            this.Close();
                        }
                    }
                    else
                    {
                        MessageBox.Show("Contact already exists !! ", "Data Error",
                              MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    
                }
                else if (Action == "update")
                {

                    int retVal = ContactData.UpdateContact(txtFname.Text, txtLname.Text, txtJobTitle.Text, txtPhone.Text, txtExtension.Text, txtCell.Text,
                                                            txtEmail.Text, txtFax.Text, txtContactNotes.Text, (cmbOrganization.Value), OrgAddressID, ContactId);
                    if (retVal == -1)
                    {
                        MessageBox.Show("Update failed ", "Database Error",
                           MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    else
                    {
                        MessageBox.Show("Data has been updated successfully !!");
                        if (formType == "project")
                        {
                            //LinkContact lc = new LinkContact(Convert.ToInt32(cmbOrganization.SelectedValue), "project");
                            //lc.Show();
                            //this.Close();
                            OpenContact(GlobalSettings.projectId);
                        }
                        this.Close();
                    }


                }
                else if (Action == "addlink")
                {
                    DataSet ds = null;
                    if (cmbOrganization.SelectedRow.Index > -1)
                    {
                        ds = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select * from Contact where (ContactFName = '" + txtFname.Text + "' and ContactLName = '" + txtLname.Text + "' and (OrgID = " + Convert.ToInt32(cmbOrganization.Value) + "))");
                        if (ds.Tables[0].Rows.Count > 0)
                        {
                            blnExists = true;
                        }
                        else
                        {
                            DataSet ds1 = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select * from Contact where (ContactFName = '" + txtFname.Text + "' and ContactLName = '" + txtLname.Text + "'and (OrgID is null))");
                            if (ds1.Tables[0].Rows.Count > 0)
                            {
                                int retval1 = SqlHelper.ExecuteNonQuery(GlobalSettings.ConnectionString, CommandType.Text, "delete from Contact where (ContactFName = '" + txtFname.Text + "' and ContactLName = '" + txtLname.Text + "' and (OrgID is null))");
                                blnExists = false;
                            }
                        }
                    }
                    else
                    {
                        ds = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select * from Contact where (ContactFName = '" + txtFname.Text + "' and ContactLName = '" + txtLname.Text + "'and (OrgID is null))");
                        blnExists = true;
                    }
                    if (blnExists == false)
                    {
                        int retVal = ContactData.InsertContact(txtFname.Text, txtLname.Text, txtJobTitle.Text, txtPhone.Text, txtExtension.Text, txtCell.Text,
                                                                txtEmail.Text, txtFax.Text, txtContactNotes.Text, OrgId, OrgAddressID,
                                                                add, city, state, zip);
                        if (retVal == -1)
                        {
                            MessageBox.Show("Update failed ", "Database Error",
                               MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                        else
                        {
                            MessageBox.Show("Data has been added successfully !!");
                            if (formType == "project")
                            {
                                LinkContact lc = new LinkContact(Convert.ToInt32(cmbOrganization.Value), "project");
                                Form1 fm = (Form1)this.MdiParent;
                                fm.OpenForm(lc, "Link Contact");
                                this.Close();
                                //OpenContact(GlobalSettings.projectId);
                            }
                            this.Close();
                        }
                    }
                    else
                    {
                        MessageBox.Show("Contact already exists !! ", "Data Error",
                              MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            if (formType == "project")
            {
                OpenContact(GlobalSettings.projectId);
            }
            this.Close();
        }

        private void chkLinkOrg_CheckedChanged(object sender, EventArgs e)
        {
            if (chkLinkOrg.Checked == true)
            {
                cmbOrganization.Enabled = false;
                cmbDept.Enabled = false;
                
                txtState.ReadOnly = false;
                txtCity.ReadOnly = false;
                txtState.ReadOnly = false;
                txtZip.ReadOnly = false;
            }
            else if (chkLinkOrg.Checked == false)
            {
                cmbOrganization.Enabled = true;
                cmbDept.Enabled = true;
            }
        }

        private void chkLinkOrg_CheckedChanged_1(object sender, EventArgs e)
        {
            if (chkLinkOrg.Checked == true)
            {
                cmbOrganization.Enabled = false;
                cmbDept.Enabled = false;
               
                txtStreet.ReadOnly = false;
                txtCity.ReadOnly = false;
                txtState.ReadOnly = false;
                txtZip.ReadOnly = false;
                
            }
            else if (chkLinkOrg.Checked == false)
            {
                cmbOrganization.Enabled = true;
                cmbDept.Enabled = true;

                txtStreet.ReadOnly = true;
                txtCity.ReadOnly = true;
                txtState.ReadOnly = true;
                txtZip.ReadOnly = true;
            }
        }

        private void txtPhone_Leave(object sender, EventArgs e)
        {
            //if (txtPhone.Text != string.Empty)
            //{
            //    string pattern = "^\\(?(\\d{3})\\)?[- ]?(\\d{3})[- ]?(\\d{4})$";
            //    if (System.Text.RegularExpressions.Regex.IsMatch(txtPhone.Text, pattern) == false)
            //    {
            //        MessageBox.Show("Invalid Phone Number !!", "Data Entry Error", MessageBoxButtons.OK);
            //        txtPhone.Focus();
            //    }
            //}
        }

        private void txtCell_Leave(object sender, EventArgs e)
        {
            //if (txtCell.Text != string.Empty)
            //{
            //    string pattern = "^\\(?(\\d{3})\\)?[- ]?(\\d{3})[- ]?(\\d{4})$";
            //    if (System.Text.RegularExpressions.Regex.IsMatch(txtCell.Text, pattern) == false)
            //    {
            //        MessageBox.Show("Invalid Cell Number !!", "Data Entry Error", MessageBoxButtons.OK);
            //        txtCell.Focus();
            //    }
            //}
        }

        private void txtEmail_Leave(object sender, EventArgs e)
        {
            //if (txtEmail.Text != string.Empty)
            //{
            //    string pattern = @"^[-a-zA-Z0-9][-_.a-zA-Z0-9]*@[-.a-zA-Z0-9]+(\.[-.a-zA-Z0-9]+)*\.(com|edu|info|gov|int|mil|net|org|biz|name|museum|coop|aero|pro|tv|[a-zA-Z]{2})$";
            //    if (System.Text.RegularExpressions.Regex.IsMatch(txtEmail.Text, pattern) == false)
            //    {
            //        MessageBox.Show("Invalid Email Address !!", "Data Entry Error", MessageBoxButtons.OK);
            //        txtEmail.Focus();
            //    }
            //}
            
        }

        private void txtFax_Leave(object sender, EventArgs e)
        {
            //if (txtFax.Text != string.Empty)
            //{
            //    string pattern = "^\\(?(\\d{3})\\)?[- ]?(\\d{3})[- ]?(\\d{4})$";
            //    if (System.Text.RegularExpressions.Regex.IsMatch(txtFax.Text, pattern) == false)
            //    {
            //        MessageBox.Show("Invalid Fax Number !!", "Data Entry Error", MessageBoxButtons.OK);
            //        txtFax.Focus();
            //    }
            //}
        }

        private void txtExtension_Leave(object sender, EventArgs e)
        {
            //if (txtExtension.Text != string.Empty)
            //{
            //    string pattern =@"^\d*$";
            //    if (System.Text.RegularExpressions.Regex.IsMatch(txtExtension.Text, pattern) == false || txtExtension.Text.ToString().Length != 3)
            //    {
            //        MessageBox.Show("Invalid Phone Extension !!", "Data Entry Error", MessageBoxButtons.OK);
            //        txtExtension.Focus();
            //    }
            //}
        }

        //private void cmbOrganization_SelectedIndexChanged_1(object sender, EventArgs e)
        //{
        //    DbConnection dbConnection = DbConnection.GetDbConnection();
        //    string connectionString = dbConnection.DbConnectionString;
        //    DataSet ds = null;
        //    if ((cmbOrganization.SelectedIndex >= 0) && (cmbOrganization.Text != string.Empty))
        //    {
        //        try
        //        {
        //            ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select * from OrgAddress where OrgID = " + Convert.ToInt32(cmbOrganization.SelectedValue));
        //        }
        //        catch (Exception ex)
        //        {
        //            return;
        //        }
        //        if (ds.Tables[0].Rows.Count > 0)
        //        {
        //            DataRow dr = ds.Tables[0].Rows[0];
        //            DataSet ds1 = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select OrgAddressID, isnull(DepartmentOffice,' ') + '- ' + isnull(Address,' ') + '  ' + isnull(City,' ') + '  ' + isnull(State,' ') as DepartmentOffice from OrgAddress where OrgID = " + Convert.ToInt32(cmbOrganization.SelectedValue));
        //            cmbDept.DataSource = ds1.Tables[0];
        //            cmbDept.DisplayMember = "DepartmentOffice";
        //            cmbDept.ValueMember = "OrgAddressID";

        //            OrgAddressID = Convert.ToInt32(dr["OrgAddressID"]);
        //            DataSet ds2 = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select * from OrgAddress where OrgAddressID = " + OrgAddressID);
        //            DataRow dr2 = ds2.Tables[0].Rows[0];
        //            txtStreet.Text = dr2["Address"].ToString();
        //            txtCity.Text = dr2["City"].ToString();
        //            txtState.Text = dr2["State"].ToString();
        //            txtZip.Text = dr2["Zip"].ToString();
        //            txtMainPhone.Text = dr2["GeneralPhone"].ToString();
        //            txtMainFax.Text = dr2["GeneralFax"].ToString();
        //            txtOrgNotes.Text = dr2["OrgNotes"].ToString();
        //            // txtPhone.Text = dr2["GeneralPhone"].ToString();
        //            //txtFax.Text = dr2["GeneralFax"].ToString();
        //        }
        //        else
        //        {
        //            cmbDept.DataSource = null;
        //            txtStreet.Text = "";
        //            txtCity.Text = "";
        //            txtState.Text = "";
        //            txtZip.Text = "";
        //            txtMainPhone.Text = "";
        //            txtMainFax.Text = "";
        //            txtOrgNotes.Text = "";
        //        }
        //    }
        //}

        private void cmbDept_SelectedIndexChanged(object sender, EventArgs e)
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            DataSet ds2 = null;
            if (cmbDept.SelectedIndex >= 0)
            {
                try
                {
                   ds2 = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select * from OrgAddress where OrgAddressID = " + Convert.ToInt32(cmbDept.SelectedValue));
                }
                catch (Exception ex)
                {
                    return;
                }
                DataRow dr2 = ds2.Tables[0].Rows[0];
                txtStreet.Text = dr2["Address"].ToString();
                txtCity.Text = dr2["City"].ToString();
                txtState.Text = dr2["State"].ToString();
                txtZip.Text = dr2["Zip"].ToString();
                txtMainPhone.Text = dr2["GeneralPhone"].ToString();
                txtMainFax.Text = dr2["GeneralFax"].ToString();
                txtOrgNotes.Text = dr2["OrgNotes"].ToString();
                OrgAddressID = Convert.ToInt32(cmbDept.SelectedValue);
                //txtPhone.Text = dr2["GeneralPhone"].ToString();
                //txtFax.Text = dr2["GeneralFax"].ToString();
            }

        }

        private void txtZip_Leave(object sender, EventArgs e)
        {
            if (txtZip.Text != string.Empty)
            {
                string pattern = "^[0-9]{5}([- /]?[0-9]{4})?$";
                if (System.Text.RegularExpressions.Regex.IsMatch(txtZip.Text, pattern) == false)
                {
                    MessageBox.Show("Invalid Zip Code !!", "Data Entry Error", MessageBoxButtons.OK);
                    txtCell.Focus();
                }
            }
        }

        public void OpenContact(int projectId)
        {
            Form1 mainForm = (Form1)this.MdiParent;
            mainForm.OpenProject(GlobalSettings.projectId, ProjectData.GetProjectName(projectId));

            CCPM.Project.ProjectForm projectForm = null;
            mainForm.GetCurrentProject(out projectForm);
            projectForm.RefreshContacts();
            projectForm.SetTabIndex(1);

        }

        private void txtPhone_Leave_1(object sender, EventArgs e)
        {
            //if (txtPhone.Text != string.Empty)
            //{
            //    string pattern = "^\\(?(\\d{3})\\)?[- ]?(\\d{3})[- ]?(\\d{4})$";
            //    if (System.Text.RegularExpressions.Regex.IsMatch(txtPhone.Text, pattern) == false)
            //    {
            //        MessageBox.Show("Invalid Phone Number !!", "Data Entry Error", MessageBoxButtons.OK);
            //        txtPhone.Focus();
            //    }
            //}
        }

        private void cmbOrganization_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {

            // OrgID
            e.Layout.Bands[0].Columns[0].Hidden = true;

            // Organization
            e.Layout.Bands[0].Columns[1].Width = 240;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Organziation";
            
            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;

        }

        private void cmbOrganization_ValueChanged(object sender, EventArgs e)
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            DataSet ds = null;
            //if ((cmbOrganization.SelectedIndex >= 0) && (cmbOrganization.Text != string.Empty))
            if ((cmbOrganization.SelectedRow!=null) && (cmbOrganization.Text != string.Empty))
            {
                try
                {
                    ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select * from OrgAddress where OrgID = " + Convert.ToInt32(cmbOrganization.Value));
                }
                catch (Exception ex)
                {
                    return;
                }
                if (ds.Tables[0].Rows.Count > 0)
                {
                    DataRow dr = ds.Tables[0].Rows[0];
                    DataSet ds1 = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select OrgAddressID, isnull(DepartmentOffice,' ') + '- ' + isnull(Address,' ') + '  ' + isnull(City,' ') + '  ' + isnull(State,' ') as DepartmentOffice from OrgAddress where OrgID = " + Convert.ToInt32(cmbOrganization.Value));
                    cmbDept.DataSource = ds1.Tables[0];
                    cmbDept.DisplayMember = "DepartmentOffice";
                    cmbDept.ValueMember = "OrgAddressID";

                    OrgAddressID = Convert.ToInt32(dr["OrgAddressID"]);
                    DataSet ds2 = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select * from OrgAddress where OrgAddressID = " + OrgAddressID);
                    DataRow dr2 = ds2.Tables[0].Rows[0];
                    txtStreet.Text = dr2["Address"].ToString();
                    txtCity.Text = dr2["City"].ToString();
                    txtState.Text = dr2["State"].ToString();
                    txtZip.Text = dr2["Zip"].ToString();
                    txtMainPhone.Text = dr2["GeneralPhone"].ToString();
                    txtMainFax.Text = dr2["GeneralFax"].ToString();
                    txtOrgNotes.Text = dr2["OrgNotes"].ToString();
                    // txtPhone.Text = dr2["GeneralPhone"].ToString();
                    //txtFax.Text = dr2["GeneralFax"].ToString();
                }
                else
                {
                    cmbDept.DataSource = null;
                    txtStreet.Text = "";
                    txtCity.Text = "";
                    txtState.Text = "";
                    txtZip.Text = "";
                    txtMainPhone.Text = "";
                    txtMainFax.Text = "";
                    txtOrgNotes.Text = "";
                }
            }

        }

        private void btnAddAddress_Click(object sender, EventArgs e)
        {
            Form1 fm = (Form1)((this).MdiParent);
            LinkOrg lo = new LinkOrg(Convert.ToInt32(cmbOrganization.Value));
            lo.callingForm = this;
            fm.OpenForm(lo, "Link Organization");
        }

        public void btnRefresh_Click(object sender, EventArgs e)
        {
            retrieveData();
            cmbOrganization_ValueChanged(sender, e);
        }

        private void retrieveData()
        {
            loadOrgCombo();
            //cmbOrganization.SelectedIndex = -1;
            txtPhone.Text = "";
            if (ContactId != 0)
            {
                //this.txtFname.ReadOnly = true;
                //this.txtLname.ReadOnly = true;
                txtStreet.ReadOnly = true;
                txtCity.ReadOnly = true;
                txtMainFax.ReadOnly = true;
                txtMainPhone.ReadOnly = true;
                loadData();
            }
            else
            {
                txtFname.Text = "";
                txtLname.Text = "";
                txtJobTitle.Text = "";
                txtPhone.Text = "";
            }
            if (OrgId != 0)
            {
                DataSet ds1 = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select Organization from Organization where OrgID = " + OrgId);
                DataRow dr = ds1.Tables[0].Rows[0];
                cmbOrganization.Text = dr["Organization"].ToString();
            }
            //txtPhone.Text = "";
            SetSecurity();
        }

    }
}
