﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CCPM.Data;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Contact
{
    public partial class LinkContact : Form
    {
        int OrgID = 0;
        string formType = "";
        public Boolean isProjectView = false;
        public LinkContact(int OrgId, string type)
        {
            InitializeComponent();
            OrgID = OrgId;
            formType = type;
            if (formType == "admin")
            {
                label4.Visible = false;
                label5.Visible = false;
                label10.Text = "Contact List";
                btnRemove.Text = "Link to Org";
            }
            else
            {
                label4.Visible = false;
                label5.Visible = false;
                label10.Text = "Organization Contact List";
                btnRemove.Text = "Link to Project";

            }
            loadContactGrid();
        }

        private void loadContactGrid()
        {
            DataSet dsContact = null;
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            if (formType == "admin")
            {
                dsContact = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select Contact.ContactID, 'link' as button, ContactLName + ', ' + ContactFName, ContactJobTitle, Organization, OrganizationType, 0 as DirtyFlag from Contact LEFT OUTER JOIN Organization org ON Contact.OrgID = org.OrgID LEFT OUTER JOIN OrganizationType ot ON org.OrganizationTypeId = ot.OrganizationTypeId where Organization is null order by ContactLName");
                
            }
            else
            {
                dsContact = ContactData.GetContactList(OrgID);
            }
            uwgContact.DataSource = dsContact.Tables[0];
            uwgContact.DataBind();

            //if (formType == "admin")
            //{
            //    uwgContact.DisplayLayout.Bands[0].Columns[4].Hidden = false;
            //}
            //else
            //{
            //    uwgContact.DisplayLayout.Bands[0].Columns[4].Hidden = true;
            //}
            if (uwgContact.Rows.Count > 0)
            {
                uwgContact.Rows[0].Selected = true;
                uwgContact.Rows[0].Activate();
                btnRemove.Enabled = true;
            }
            else
            {
                btnRemove.Enabled = false;
            }
        }

        private void uwgContact_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //ContactId
            e.Layout.Bands[0].Columns[0].Hidden = true;

            e.Layout.Bands[0].Columns[1].Width = 80;
            e.Layout.Bands[0].Columns[1].Hidden = true;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Link To Organization";
            e.Layout.Bands[0].Columns[1].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns[1].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            e.Layout.Bands[0].Columns[2].Width = 200;
            e.Layout.Bands[0].Columns[2].Header.Caption = "CONTACT NAME";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[3].Width = 250;
            e.Layout.Bands[0].Columns[3].Header.Caption = "JOB TITLE";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            //Organization
            e.Layout.Bands[0].Columns[4].Width = 250;
            e.Layout.Bands[0].Columns[4].Hidden = true;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Organization";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            //OrganizationTypeId
            e.Layout.Bands[0].Columns[5].Hidden = true;
            //DirtyFlag
            e.Layout.Bands[0].Columns[6].Hidden = true;

            //DSD 12/23/2012 - phase 2 - task 76 - filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = Infragistics.Win.UltraWinGrid.FilterClearButtonLocation.RowAndCell;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = Infragistics.Win.UltraWinGrid.FilterOperatorDefaultValue.Contains;

            //DSD 12/23/2012 - phase 2 - task 77 - column sorting
            e.Layout.Override.HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction.SortMulti;
        }

        private void btnNewContact_Click(object sender, EventArgs e)
        {
            int contactId = 0;
            //DialogResult diarslt = MessageBox.Show("This will add a new contact to the master contact list-have you confirmed that it\ndoes not already exist ?",
            //                                        "New Contact Warning", MessageBoxButtons.YesNoCancel);
            //if (diarslt == DialogResult.Yes)
            //{
                CreateContact cc = null;
                if (formType == "admin")
                {
                    cc = new CreateContact(contactId, "addlink", OrgID, "admin");
                }
                else
                {
                    cc = new CreateContact(contactId, "addlink", OrgID, "project");
                }
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenForm(cc, "New Contact");
                this.Close();
            //}
            //else if (diarslt == DialogResult.No)
            //{
            //    Form1 fm = (Form1)((this.ParentForm).MdiParent);
            //    CCPM.Project.Contacts lc = new CCPM.Project.Contacts();
            //    //LinkContact lc = new LinkContact(OrgID, "admin");
            //    lc.MdiParent = this.MdiParent;
            //    lc.Show();
            //}
            //loadContactGrid();
        }

        private void uwgContact_ClickCellButton(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            int retVal1 = SqlHelper.ExecuteNonQuery(GlobalSettings.ConnectionString, CommandType.Text, "UPDATE Contact SET OrgID = " + OrgID + " where ContactID = " + Convert.ToInt32(uwgContact.ActiveRow.Cells[0].Value));
            this.Close();
        }

        public void OpenContact(int projectId)
        {
            Form1 mainForm = (Form1)this.MdiParent;
            mainForm.OpenProject(GlobalSettings.projectId, ProjectData.GetProjectName(GlobalSettings.projectId));

            CCPM.Project.ProjectForm projectForm = null;
            mainForm.GetCurrentProject(out projectForm);
            projectForm.RefreshContacts();
            projectForm.SetTabIndex(1);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            if (formType == "project")
            {
                OpenContact(GlobalSettings.projectId);
            }
            this.Close();
        }

        private void btnRemove_Click(object sender, EventArgs e)
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            for (int i = 0; i < uwgContact.Rows.Count; i++)
            {
                if (uwgContact.Rows[i].Selected == true || uwgContact.Rows[i].Activated == true)
                {
                    if (formType == "project")
                    {
                        DataSet ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select * from Contact_Project where (ProjectId = " + GlobalSettings.projectId + " and ContactId = " + Convert.ToInt32(uwgContact.Rows[i].Cells[0].Value) + ")");
                        if (ds.Tables[0].Rows.Count == 0)
                        {
                            int retVal1 = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "INSERT INTO Contact_Project(ProjectId,ContactId) values(" + GlobalSettings.projectId + "," + Convert.ToInt32(uwgContact.Rows[i].Cells[0].Value) + ")");
                        }
                    }
                    else
                    {
                        int retVal1 = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "UPDATE Contact SET OrgID = " + OrgID + " where ContactID = " + Convert.ToInt32(uwgContact.Rows[i].Cells[0].Value));
                    }
                }
            }
            if (formType == "project")
            {
                OpenContact(GlobalSettings.projectId);
            }
            this.Close();
        }

        private void uwgContact_AfterRowActivate(object sender, EventArgs e)
        {
            //if (uwgContact.DisplayLayout.Bands[0].Columns[4].Hidden == false)
            //{
            //    if (uwgContact.ActiveRow.Cells[4].Value.ToString() != string.Empty)
            //    {
            //        btnRemove.Enabled = false;
            //    }
            //    else
            //    {
            //        btnRemove.Enabled = true;
            //    }
            //}
        }

      

    }
}
