﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CCPM.Data;
using Microsoft.ApplicationBlocks.Data;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace CCPM.Contact
{
    public partial class LinkOrg : Form
    {
        public Form callingForm;
        public MasterContacts myParentForm;
        int OrganizationId;
        public LinkOrg(int OrgId)
        {
            InitializeComponent();
            OrganizationId = OrgId;
            loadOrgGrid();
            LoadOrgAddress();
            if (GlobalSettings.projectId != 0)
            {
                DataSet ds = ContractData.GetProjectNumber(GlobalSettings.projectId);
                DataRow dr = ds.Tables[0].Rows[0];
                label10.Text = "Master Organization List (" + dr["ProjectName"].ToString() + ")";
            }
        }

        private void loadOrgGrid()
        {
            DataSet dsOrg = ContactData.GetOrganization();
            uwgOrg.DataSource = dsOrg.Tables[0];
            uwgOrg.DataBind();
       

            if (uwgOrg.Rows.Count > 0)
            {
                //uwgOrg.Rows[0].Selected = true;
                if (OrganizationId != 0)
                {
                    for (int i = 0; i < uwgOrg.Rows.Count; i++)
                    {
                        if (Convert.ToInt32(uwgOrg.Rows[i].Cells[0].Value) == OrganizationId)
                        {
                            uwgOrg.Rows[i].Selected = true;
                            uwgOrg.Rows[i].Activated = true;
                        }
                    }
                }
                else
                {
                    uwgOrg.Rows[0].Selected = true;
                }
            }
        }

        private void LoadOrgAddress()
        {
            if (uwgOrg.ActiveRow.Cells[0].Value == System.DBNull.Value) return;

            DataSet ds = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select OrgAddressID, DepartmentOffice, Address, City, State, Zip, GeneralPhone, GeneralFax, OrgNotes from OrgAddress where OrgID = " + Convert.ToInt32(uwgOrg.ActiveRow.Cells[0].Value));
            uwgOrgAddress.DataSource = ds.Tables[0];
            uwgOrgAddress.DataBind();
        }

        private void uwgOrg_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //no multiselect
            e.Layout.Override.SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType.Single;
            e.Layout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect; 

            //Org Id
            e.Layout.Bands[0].Columns[0].Hidden = true;

            e.Layout.Bands[0].Columns[1].Width = 80;
            e.Layout.Bands[0].Columns[1].Hidden = true;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Link To Project";
            e.Layout.Bands[0].Columns[1].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns[1].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            e.Layout.Bands[0].Columns[2].Width = 320;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Organization";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[3].Width = 150;
            e.Layout.Bands[0].Columns[3].Hidden = true;
            e.Layout.Bands[0].Columns[3].Header.Caption = "Dept/Office";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[4].Width = 180;
            e.Layout.Bands[0].Columns[4].Hidden = true;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Street";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            
            e.Layout.Bands[0].Columns[5].Width = 100;
            e.Layout.Bands[0].Columns[5].Hidden = true;
            e.Layout.Bands[0].Columns[5].Header.Caption = "City";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            //OrganizationTypeId
            e.Layout.Bands[0].Columns[6].Hidden = true;
            //ContactId
            e.Layout.Bands[0].Columns[7].Hidden = true;
            // Dirty Flag
            e.Layout.Bands[0].Columns[8].Hidden = true;

            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;
        }

        private void uwgOrg_ClickCellButton(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[0].Value == System.DBNull.Value) return;
            int contactId = 0;
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            
            {
                DataSet ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select * from Org_ProjectRole where (ProjectId = " + GlobalSettings.projectId + " and OrgId = " + Convert.ToInt32(uwgOrg.ActiveRow.Cells[0].Value) + ")");
                //DataSet ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select * from Org_ProjectRole op INNER JOIN OrgAddress oa ON op.OrgId = oa.OrgID where (ProjectId = " + GlobalSettings.projectId + " and op.OrgId = " + Convert.ToInt32(uwgOrg.ActiveRow.Cells[0].Value) + " and oa.OrgAddressID = " + Convert.ToInt32(uwgOrg.ActiveRow.Cells[7].Value) + ")");
                if (ds.Tables[0].Rows.Count == 0)
                {
                    int retVal = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "INSERT INTO Org_ProjectRole(ProjectId,OrgId,ProjectRoleId) values(" + GlobalSettings.projectId + "," + Convert.ToInt32(uwgOrg.ActiveRow.Cells[0].Value) + "," + Convert.ToInt32(uwgOrg.ActiveRow.Cells[6].Value) + ")");
                }
                OpenContact(GlobalSettings.projectId);
                //DialogResult = DialogResult.OK;
                this.Close();
            }       
            
        }

        public void OpenContact(int projectId)
        {
            Form1 mainForm = (Form1)this.MdiParent;
            mainForm.OpenProject(GlobalSettings.projectId, ProjectData.GetProjectName(projectId));

            CCPM.Project.ProjectForm projectForm = null;
            mainForm.GetCurrentProject(out projectForm);
            projectForm.RefreshContacts();
            projectForm.SetTabIndex(1);
           
        }

        private void btnNewOrg_Click(object sender, EventArgs e)
        {
            int orgID = 0;
            DialogResult diarslt = MessageBox.Show("This will add a new organization to the master organization list-have you confirmed that it\ndoes not already exist ?",
                                                    "New Organization Warning", MessageBoxButtons.YesNo);
            if (diarslt == DialogResult.Yes)
            {
                NewOrganization no = new NewOrganization(orgID, "insert", "project");
                Form1 fm = (Form1)this.MdiParent;
                this.Close();
                fm.OpenForm(no, "New Organization");
            }
        }

        private void btnNewAddress_Click(object sender, EventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[0].Value == System.DBNull.Value) return;

            NewOrganization no = new NewOrganization("address","project",0,Convert.ToInt32(uwgOrg.ActiveRow.Cells[0].Value));
            if(callingForm !=null) no.callingForm = callingForm;
            Form1 fm = (Form1)this.MdiParent;
            this.Close();
            fm.OpenForm(no, "New Address");
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnLink_Click(object sender, EventArgs e)
        {
            //int contactId = 0;
            string roles = "";

            for (int i = 0; i < uwgOrg.Rows.Count; i++)
            {
                if(uwgOrg.Rows[i].Selected == true || uwgOrg.Rows[i].Activated == true)
                {
                    int orgid = (int)uwgOrg.Rows[i].Cells[0].Value;
                    if (ProjectData.OrgHasProjectRole(orgid, GlobalSettings.projectId) == false)
                    {
                        roles = ProjectRoles(uwgOrg.Rows[i].Cells[2].Text);
                        if (roles == string.Empty)
                            return;
                        ProjectData.OrgProjectRoleInsert(orgid, GlobalSettings.projectId, roles);
                    }
                    
                    for (int j = 0; j < uwgOrgAddress.Rows.Count; j++)
                    {
                        if (uwgOrgAddress.Rows[j].Selected == true)
                        {
                            DataSet ds1 = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select * from Org_Project_Address where (ProjectId = " + GlobalSettings.projectId + " and OrgId = " + Convert.ToInt32(uwgOrg.Rows[i].Cells[0].Value) + " and OrgAddressId = " + Convert.ToInt32(uwgOrgAddress.Rows[j].Cells[0].Value) + ")");
                            if (ds1.Tables[0].Rows.Count == 0)
                            {
                                int retVal = SqlHelper.ExecuteNonQuery(GlobalSettings.ConnectionString, CommandType.Text, "INSERT INTO Org_Project_Address(ProjectId,OrgId,OrgAddressId) values(" + GlobalSettings.projectId + "," + Convert.ToInt32(uwgOrg.Rows[i].Cells[0].Value) + "," + Convert.ToInt32(uwgOrgAddress.Rows[j].Cells[0].Value) + ")");
                            }
                        }
                    }
                }      
                            
            }
            
            OpenContact(GlobalSettings.projectId);
            this.Close();
            
        }

        private string ProjectRoles(string orgname)
        {
            string retVal = "";
            DialogResult dr;
            GridSelect gs = new GridSelect();
            gs.lblTitle.Text = "Select One or More Project Roles";
            gs.Text = "Linking Organization:  " + orgname;
            gs.DataSet(ProjectData.GetProjectRoles());
            gs.ColumnHide(0);
            gs.ColumnWidth(1, 300);
            gs.ColumnName(1, "Project Role");
            dr = gs.ShowDialog();
            if (dr == DialogResult.OK)
                retVal = gs.SelectedKeys(0, false);
            return retVal;
        }

        private void uwgOrgAddress_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //OrgAddress Id
            e.Layout.Bands[0].Columns[0].Hidden = true;

            e.Layout.Bands[0].Columns[1].Width = 150;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Dept/Office";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[2].Width = 180;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Street";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[3].Width = 90;
            e.Layout.Bands[0].Columns[3].Header.Caption = "City";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[4].Width = 40;
            e.Layout.Bands[0].Columns[4].Header.Caption = "State";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[5].Width = 60;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Zip";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[6].Width = 80;
            e.Layout.Bands[0].Columns[6].Header.Caption = "GeneralPhone";
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[7].Width = 80;
            e.Layout.Bands[0].Columns[7].Header.Caption = "GeneralFax";
            e.Layout.Bands[0].Columns[7].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[8].Width = 200;
            e.Layout.Bands[0].Columns[8].Header.Caption = "Notes";
            e.Layout.Bands[0].Columns[8].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

        }

        private void uwgOrg_AfterRowActivate(object sender, EventArgs e)
        {
            LoadOrgAddress();
        }

       
    }
}
