﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CCPM.Data;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Contact
{
    public partial class MasterContacts : System.Windows.Forms.UserControl
    {
        private bool isProjectView = false;
        bool blnDataDirty = false;
        private int projectId;
        private System.Windows.Forms.ContextMenu contextMenu1;
        bool blnRoleChange = false;
        int roleOrgId = 0;

        public bool IsProjectView
        {
            get { return isProjectView; }
            set { isProjectView = value; }
        }

        public int ProjectId
        {
            get { return projectId; }
            set { projectId = value; }
        }


        public MasterContacts()
        {
            InitializeComponent();
            uwgOrg.DisplayLayout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            uwgProjectRole.DisplayLayout.Override.WrapHeaderText = DefaultableBoolean.True;
            uwgContacts.DisplayLayout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            uwgOrgAddress.DisplayLayout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            uwgContacts.ContextMenu = contextMenu1;
            uwgOrg.ContextMenu = contextMenu1;
            LoadOrg();
            LoadContacts();
            LoadOrgAddress();
            
            LoadProjectRole();
            
            this.Focus();
            uwgOrg.Focus();
            //SetContextMenu();
        }

        public void LoadOrg()
        {
            DataSet cds = ContactData.GetOrganizationByProject(GlobalSettings.projectId);
            uwgOrg.DataSource = cds;
            uwgOrg.DataBind();            

            if (uwgOrg.Rows.Count < 1)
            {
                btnEditOrg.Enabled = false;
                btnRemove.Enabled = false;
                btnLinkContact.Enabled = false;
                btnContactAdd.Enabled = false;
                btnAddAddress.Enabled = false;
                btnSaveRole.Enabled = false;
                btnLinkOrgAddress.Enabled = false;
                //btnAddRole.Enabled = false;
            }
            else
            {
                uwgOrg.Rows[0].Selected = true;
                btnEditOrg.Enabled = true;
                btnRemove.Enabled = true;
                btnLinkContact.Enabled = true;
                btnContactAdd.Enabled = true;
                btnAddAddress.Enabled = true;
                btnSaveRole.Enabled = true;
                btnLinkOrgAddress.Enabled = true;
                //btnAddRole.Enabled = true;
            }

        }

        public void LoadContacts()
        {
            int orgId = 0;
            if (uwgOrg.Rows.Count < 1)
            {
                orgId = 0;
            }
            else
            {
                if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;
                orgId = Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value);
            }
            DataSet cds = ContactData.GetContactByOrganization(orgId);
            uwgContacts.DataSource = cds;
            uwgContacts.DataBind();
            

            if (uwgContacts.Rows.Count < 1)
            {
                btnEditContact.Enabled = false;
                btnContactRemove.Enabled = false;
            }
            else
            {
                uwgContacts.Rows[0].Selected = true;
                btnEditContact.Enabled = true;
                btnContactRemove.Enabled = true;
            }
        }

        public void LoadOrgAddress()
        {
            int orgId = 0;
            if (uwgOrg.Rows.Count < 1)
            {
                orgId = 0;
            }
            else
            {
                if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;
                orgId = Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value);
            }
            DataSet cds = ContactData.GetAddressByOrganization(orgId);
            uwgOrgAddress.DataSource = cds;
            uwgOrgAddress.DataBind();
            

            if (uwgOrgAddress.Rows.Count < 1)
            {
                btnAddressRemove.Enabled = false;
                btnEditOrgAddress.Enabled = false;
            }
            else
            {
                uwgOrgAddress.Rows[0].Selected = true;
                btnAddressRemove.Enabled = true;
                btnEditOrgAddress.Enabled = true;
            }
        }

        public void LoadProjectRole()
        {
            roleOrgId = 0;
            if (uwgOrg.Rows.Count < 1)
            {
                uwgProjectRole.DataSource = null;
                uwgProjectRole.DataBind();
            }
            else
            {
                if (uwgOrg.ActiveRow.Cells["OrgId"].Value == System.DBNull.Value) return;
                roleOrgId = Convert.ToInt32(uwgOrg.ActiveRow.Cells["OrgId"].Value);
                //DataSet ds = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select 0 as Include, ProjectRole, pr.ProjectRoleId from ProjectRole pr order by ProjectRole ");
                DataSet ds = ProjectData.GetOrgProjectRoles(roleOrgId, GlobalSettings.projectId);
                uwgProjectRole.DataSource = ds;
                uwgProjectRole.DataBind();


                //for (int i = 0; i < uwgProjectRole.Rows.Count; i++)
                //{
                //    DataSet ds1 = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select * from Org_ProjectRole where (ProjectId = " + GlobalSettings.projectId + " and OrgId = " + Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value) + " and ProjectRoleId = " + Convert.ToInt32(uwgProjectRole.Rows[i].Cells[2].Value) + ")");
                //    if (ds1.Tables[0].Rows.Count > 0)
                //    {
                //        uwgProjectRole.Rows[i].Cells[0].Value = true;
                //        uwgProjectRole.Rows[i].Cells[0].CancelUpdate();
                //    }
                //}
            }
            blnRoleChange = false;
        }

        private void uwgOrg_InitializeLayout_1(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Width = 80;
            e.Layout.Bands[0].Columns[0].Hidden = true;
            e.Layout.Bands[0].Columns[0].Header.Caption = "Remove Organization";
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns[0].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            e.Layout.Bands[0].Columns[1].Width = 220;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Organization";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[2].Width = 150;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Organization Type";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            // OrgID
            e.Layout.Bands[0].Columns[3].Hidden = true;
            //RecordId
            //e.Layout.Bands[0].Columns[4].Hidden = true;
            //TaxID
            e.Layout.Bands[0].Columns[4].Width = 80;
            e.Layout.Bands[0].Columns[4].Header.Caption = "TaxID Number";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            //SBE
            e.Layout.Bands[0].Columns[5].Width = 60;
            e.Layout.Bands[0].Columns[5].Header.Caption = "SBE";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[5].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;
            //DVBE
            e.Layout.Bands[0].Columns[6].Width = 60;
            e.Layout.Bands[0].Columns[6].Header.Caption = "DVBE";
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[6].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;
            //Certification#
            e.Layout.Bands[0].Columns[7].Width = 80;
            e.Layout.Bands[0].Columns[7].Header.Caption = "Certification #";
            e.Layout.Bands[0].Columns[7].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;  

        }

        private void uwgContacts_InitializeLayout_1(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Header.Caption = "Remove Contact";
            e.Layout.Bands[0].Columns[0].Hidden = true;
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns[0].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            e.Layout.Bands[0].Columns[1].Width = 110;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Full Name";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[2].Width = 150;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Job Title";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[3].Width = 150;
            e.Layout.Bands[0].Columns[3].Header.Caption = "Address";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[4].Width = 100;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Contact Phone";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[5].Width = 70;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Extension";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[6].Width = 100;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Contact Cell Phone";
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[7].Width = 100;
            e.Layout.Bands[0].Columns[7].Header.Caption = "Contact Fax";
            e.Layout.Bands[0].Columns[7].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[8].Width = 150;
            e.Layout.Bands[0].Columns[8].Header.Caption = "Contact Email";
            e.Layout.Bands[0].Columns[8].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            //ContactId
            e.Layout.Bands[0].Columns[9].Hidden = true;

            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;  

        }

        private void uwgOrg_AfterRowActivate_1(object sender, EventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;
            if (blnRoleChange == true)
            {
                if (DialogResult.Yes == MessageBox.Show("Save role changes?", "Role Changes", MessageBoxButtons.YesNo))
                    SaveProjectRole();
            }

            LoadContacts();
            LoadOrgAddress();
            LoadProjectRole();

            DataSet ds = ContactData.GetOrganizationData(Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value));
            if (ds.Tables[0].Rows.Count > 0)
            {
                DataRow dr = ds.Tables[0].Rows[0];
            }
        }

        private void btnLinkOrg_Click(object sender, EventArgs e)
        {
            Form1 fm = (Form1)((this.ParentForm).MdiParent);
            //2.40
            //LinkOrg lo = new LinkOrg(0);
            CCPM.Project.Organizations lo = new CCPM.Project.Organizations("project", null);
            lo.MdiParent = fm;
            fm.OpenForm(lo, "Link Organization");
                     
            //LoadOrg();
        }

        private void btnLinkContact_Click(object sender, EventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;
            LinkContact lc = new LinkContact(Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value),"project");
            Form1 fm = (Form1)((this.ParentForm).MdiParent);
            fm.OpenForm(lc, "Link Contact");
        }

        private void btnEditContact_Click(object sender, EventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value || uwgContacts.ActiveRow.Cells["ContactId"].Value ==System.DBNull.Value) return;

            DialogResult intRslt = MessageBox.Show("BE CAREFUL about making changes! Any changes to this contact will affect all other project linked to it.",
                            "Edit Contact Warning", MessageBoxButtons.OKCancel);
            if (intRslt == DialogResult.OK)
            {
                string fullname = "";

                if (uwgContacts.ActiveRow.Cells["FullName"].Value != null)
                {
                    fullname = uwgContacts.ActiveRow.Cells["FullName"].Value.ToString();
                }

                CreateContact cc = new CreateContact(Convert.ToInt32(uwgContacts.ActiveRow.Cells["ContactId"].Value), "update", Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value),"project");
                Form1 fm = (Form1)((this.ParentForm).MdiParent);
                fm.OpenForm(cc, "Edit Contact: " + fullname);
            }
        }

        private void btnEditOrg_Click(object sender, EventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;

            DialogResult intRslt = MessageBox.Show("BE CAREFUL about making changes! Any changes to this organization will affect all other project linked to it.\nIf you want to designate a new address for this organization, cancel and select the\nLink Organization to this Project button and follow the instructions. ",
                            "Edit Organization Warning", MessageBoxButtons.OKCancel);
            if (intRslt == DialogResult.OK)
            {
                string orgname = "";

                if (uwgOrg.ActiveRow.Cells[3].Value != null)
                {
                    orgname = uwgOrg.ActiveRow.Cells[1].Value.ToString();
                }

                NewOrganization no = new NewOrganization(Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value), "update","project");
                Form1 fm = (Form1)((this.ParentForm).MdiParent);
                fm.OpenForm(no, "Edit Organization:" + orgname);
            }
        }

        public void SetContextMenu()
        {
              contextMenu1 = new System.Windows.Forms.ContextMenu();

                MenuItem miAddExisting = new System.Windows.Forms.MenuItem();
                miAddExisting.Index = 0;
                miAddExisting.Text = "Add Existing Organization";

                MenuItem miAddNew = new MenuItem();
                miAddNew.Visible = false;
                miAddNew.Text = "Add New Organization";
                miAddNew.Index = 1;

                MenuItem miClone = new MenuItem();
                miClone.Visible = false;
                miClone.Text = "Clone Contact";
                miClone.Index = 2;

                MenuItem miSpacer1 = new MenuItem();
                miSpacer1.Text = "-";
                miSpacer1.Index = 3;

                MenuItem miEdit = new MenuItem();
                miEdit.Text = "Edit Organization";
                miEdit.Index = 4;

                MenuItem miSpacer2 = new MenuItem();
                miSpacer2.Text = "-";
                miSpacer2.Index = 5;

                MenuItem miRemove = new MenuItem();
                miRemove.Visible = false;
                miRemove.Text = "Remove Contact";
                miRemove.Index = 6;

                MenuItem miRemove1 = new MenuItem();
                miRemove1.Text = "Remove Organization";
                miRemove1.Index = 7;

                MenuItem miSpacer3 = new MenuItem();
                miSpacer3.Text = "-";
                miSpacer3.Index = 8;

                MenuItem miRefresh = new MenuItem();
                miRefresh.Text = "Refresh";
                miRefresh.Index = 9;

                contextMenu1.MenuItems.AddRange(new MenuItem[] { miAddExisting, miAddNew, miClone, miSpacer1, miEdit, miSpacer2, miRemove, miRemove1, miSpacer3, miRefresh });

                uwgOrg.ContextMenu = contextMenu1;

                miAddExisting.Click += new EventHandler(miAddExisting_Click);
                miAddNew.Click += new EventHandler(miAddNew_Click);
                // miClone.Click += new EventHandler(miClone_Click);
                miEdit.Click += new EventHandler(miEdit_Click);
                //miRemove.Click += new EventHandler(miRemove_Click);
                miRemove1.Click += new EventHandler(miRemove1_Click);
                miRefresh.Click += new EventHandler(miRefresh_Click);
            
        }

        public void miRemove1_Click(object sender, EventArgs e)
        {
            RemoveOrg();
        }

        public void RemoveOrg()
        {
            int recordId;
            if (uwgOrg.Rows.Count < 1) return;
            recordId = Convert.ToInt32(uwgOrg.ActiveRow.Cells["OrgId"].Value);

            if (OrganizationData.OrgHasProjectContract(recordId, GlobalSettings.projectId))
            {
                MessageBox.Show("This organization is under contract and can't be unlinked from this project.",
                "Unlink Organization Failure",
                MessageBoxButtons.OKCancel,
                MessageBoxIcon.Exclamation);
                return;
            }

            if (OrganizationData.OrgHasProjectMatching(recordId, GlobalSettings.projectId))
            {
                MessageBox.Show("Organization has matching funds in this project and can't be unlinked.",
                "Unlink Organization Failure",
                MessageBoxButtons.OKCancel,
                MessageBoxIcon.Exclamation);
                return;
            }

            DialogResult dr = MessageBox.Show(
                "You are about to unlink the selected organization and any associated contact information from this project!\n This will not affect the master organization or contact lists nor any other projects linked to this organization?",
                "Unlink Organization Confirmation",
                MessageBoxButtons.OKCancel,
                MessageBoxIcon.Exclamation);
            if (dr == DialogResult.OK)
            {
                ContactData.OrgContactRemove(GlobalSettings.projectId, recordId);
                LoadContacts();
                LoadOrg();
                LoadOrgAddress();
                LoadProjectRole();
            }
        }

        public void miRefresh_Click(object sender, EventArgs e)
        {
            LoadOrg();
            LoadContacts();
            LoadOrgAddress();
            LoadProjectRole();
        }

        public void miAddExisting_Click(object sender, EventArgs e)
        {
            Form1 fm = (Form1)((this.ParentForm).MdiParent);
            LinkOrg lo = new LinkOrg(0);
            lo.MdiParent = fm;
            fm.OpenForm(lo, "Link Organization");
        }

        public void miAddNew_Click(object sender, EventArgs e)
        {
            CCPM.Project.ProjectForm projectForm = (CCPM.Project.ProjectForm)this.ParentForm;
            CCPM.Contact.ContactCreateOrUpdate contactCreateOrUpdate = new CCPM.Contact.ContactCreateOrUpdate();
            contactCreateOrUpdate.Location = new Point(0, 0);
            contactCreateOrUpdate.ProjectId = projectForm.ProjectId;
            contactCreateOrUpdate.ProjectName = projectForm.ProjectName;

            DialogResult dr = contactCreateOrUpdate.ShowDialog();
            if (dr == DialogResult.OK)
            {
                projectForm.GetMasterDetailControl.ContactId = contactCreateOrUpdate.ContactId;
                projectForm.RefreshContacts();
            }
        }

        public void miEdit_Click(object sender, EventArgs e)
		{
			//If there are no contacts listed then return.
			if(uwgContacts.Rows.Count < 1) return;
            if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;

            DialogResult intRslt = MessageBox.Show("BE CAREFUL about making changes! Any changes to this organization will affect all other project linked to it.\nIf you want to designate a new branch address for this organization, cancel and select the\nLink Organization to this Project button and follow the instructions. ",
                            "Edit Organization Warning", MessageBoxButtons.OKCancel);
            if (intRslt == DialogResult.OK)
            {
                NewOrganization no = new NewOrganization(Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value), "update","project");
                Form1 fm = (Form1)((this.ParentForm).MdiParent);
                fm.OpenForm(no, "Edit Organization");
            }
		}

        private void uwgOrg_ClickCellButton(object sender, CellEventArgs e)
        {
            RemoveOrg();
            LoadOrg();
            LoadContacts();
            LoadOrgAddress();
            LoadProjectRole();
        }

        private void uwgOrg_MouseDown(object sender, MouseEventArgs e)
        {
            //if (e.Button == MouseButtons.Right)
            //{
            //    Point mousePoint = new Point(e.X, e.Y);
            //    UIElement element = ((UltraGrid)sender).DisplayLayout.UIElement.ElementFromPoint(mousePoint);

            //    contextMenu1.Show(uwgOrg, mousePoint);
            //}
        }

        private void uwgContacts_ClickCellButton(object sender, CellEventArgs e)
        {
            DialogResult dr = MessageBox.Show(
                    "You are about to remove a contact linked with the selected organization !\n The organization information will remain. ?",
                    "Remove Contact Confirmation",
                    MessageBoxButtons.OKCancel,
                    MessageBoxIcon.Exclamation);
            if (dr == DialogResult.OK)
            {
                ContactData.ContactRemove(this.ProjectId, Convert.ToInt32(uwgContacts.ActiveRow.Cells[8].Value));
                LoadContacts();

            }
        }

        private void uwgOrgAddress_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Width = 100;
            e.Layout.Bands[0].Columns[0].Header.Caption = "Remove Org Address";
            e.Layout.Bands[0].Columns[0].Hidden = true;
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns[0].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            e.Layout.Bands[0].Columns[1].Width = 190;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Department/Office";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[2].Width = 160;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Street";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[3].Width = 80;
            e.Layout.Bands[0].Columns[3].Header.Caption = "City";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[4].Width = 80;
            e.Layout.Bands[0].Columns[4].Header.Caption = "State";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[5].Width = 80;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Zip";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            //e.Layout.Bands[0].Columns[5].MaskInput = "nnnnn";

            e.Layout.Bands[0].Columns[6].Width = 100;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Phone";
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            //e.Layout.Bands[0].Columns[6].MaskInput = "nnnnnnnnnn";
            
            e.Layout.Bands[0].Columns[7].Width = 100;
            e.Layout.Bands[0].Columns[7].Header.Caption = "Fax";
            e.Layout.Bands[0].Columns[7].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;            
            //e.Layout.Bands[0].Columns[7].MaskInput = "nnnnnnnnnn";

            //OrgAddressId
            e.Layout.Bands[0].Columns[8].Hidden = true;
            //DirtyFlag
            e.Layout.Bands[0].Columns[9].Hidden = true;

            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;  

        }

        private void uwgOrgAddress_ClickCellButton(object sender, CellEventArgs e)
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            DialogResult dr = MessageBox.Show(
               "You are about to remove the selected organization address ? ", "Remove Organization Address Warning", MessageBoxButtons.OKCancel);
            if (dr == DialogResult.OK)
            {
                int retVal = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "delete from OrgAddress where OrgAddressID = " + Convert.ToInt32(uwgOrgAddress.ActiveRow.Cells[8].Value));
            }
            LoadOrgAddress();
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            LoadOrg();
            LoadContacts();
            LoadOrgAddress();
            LoadProjectRole();
        }

        private void btnAddAddress_Click(object sender, EventArgs e)
        {
            Form1 fm = (Form1)((this.ParentForm).MdiParent);

            if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;

            DialogResult diarslt = MessageBox.Show("This will add a new organization address-have you confirmed that it\ndoes not already exist ?",
                                                    "New Org Address Warning", MessageBoxButtons.YesNoCancel);
            if (diarslt == DialogResult.Yes)
            {
                NewOrganization no = new NewOrganization("address","project",0,Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value));
                fm.OpenForm(no, "Add Organization Address");
            }
            else if (diarslt == DialogResult.No)
            {
                LinkOrg lo = new LinkOrg(Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value));
                fm.OpenForm(lo, "Link Organization");
            }
            LoadOrgAddress();
            LoadContacts();
        }

        private void btnAddressRemove_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < uwgOrgAddress.Rows.Count; i++)
            {
                if (uwgOrgAddress.Rows[i].Selected == true)
                {
                    DbConnection dbConnection = DbConnection.GetDbConnection();
                    string connectionString = dbConnection.DbConnectionString;
                    int retVal = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "delete from Org_Project_Address where (OrgAddressId = " + Convert.ToInt32(uwgOrgAddress.Rows[i].Cells[8].Value) + " and ProjectId = " + GlobalSettings.projectId + ")");
                }
            }
            LoadOrgAddress();
            LoadContacts();
        }

        private void btnRemove_Click(object sender, EventArgs e)
        {
            RemoveOrg();
            LoadOrg();
            LoadContacts();
            LoadOrgAddress();
            LoadProjectRole();
        }

        private void btnAdd_Click(object sender, EventArgs e)
        {
            //DialogResult diarslt = MessageBox.Show("This will add a new organization to the Master Organization List-have you confirmed that it\ndoes not already exist ?",
            //                                        "New Organization Warning", MessageBoxButtons.YesNoCancel);
            //if (diarslt == DialogResult.Yes)
            //{
            //    NewOrganization no = new NewOrganization(0, "insert","project");
            //    no.MdiParent = (Form1)((this.ParentForm).MdiParent);
            //    no.Show();
            //}
            //else if (diarslt == DialogResult.No)
            //{
                Form1 fm = (Form1)((this.ParentForm).MdiParent);
                LinkOrg lo = new LinkOrg(0);
                lo.MdiParent = fm;
                fm.OpenForm(lo, "Add Organization");
            //}
            LoadOrg();
        }

        private void btnContactAdd_Click(object sender, EventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;

            int contactId = 0;
            int orgID = Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value);

            CreateContact cc = new CreateContact(contactId, "addlink", orgID, "project");
            Form1 fm = (Form1)((this.ParentForm).MdiParent);
            fm.OpenForm(cc, "Add Contact");

            //Form1 fm = (Form1)((this.ParentForm).MdiParent);
            //LinkContact lc = new LinkContact(orgID, "project");
            //lc.MdiParent = fm;
            //lc.Show();

            LoadContacts();
        }

        private void btnContactRemove_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < uwgContacts.Rows.Count; i++)
            {
                if (uwgContacts.Rows[i].Selected == true)
                {
                    DbConnection dbConnection = DbConnection.GetDbConnection();
                    string connectionString = dbConnection.DbConnectionString;
                    int retVal = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "DELETE Contact_Project where (ContactID = " + Convert.ToInt32(uwgContacts.Rows[i].Cells["ContactId"].Value) + " and ProjectId = " + GlobalSettings.projectId + ")");
                }
            }
            LoadContacts();
        }

        private void uwgOrgAddress_AfterCellUpdate(object sender, CellEventArgs e)
        {
            string pattern1 = "^\\((\\d{3})\\)[- ]?(\\d{3})[- ]?(\\d{4})$";
            string pattern2 = "^\\(?(\\d{3})\\)?[- ](\\d{3})[- ](\\d{4})$";
            string zipPattern = @"^(\d{5}-\d{4}|\d{5}|\d{9})$";

            if (uwgOrgAddress.ActiveRow.Cells[5].Value.ToString() != string.Empty)
            {
                if (System.Text.RegularExpressions.Regex.IsMatch(uwgOrgAddress.ActiveRow.Cells[5].Value.ToString(), zipPattern) == false)
                {
                    MessageBox.Show("Invalid Zip Code !!", "Data Entry Error", MessageBoxButtons.OK);
                    uwgOrgAddress.ActiveRow.Cells[5].Value = "";
                }
            }

            if (uwgOrgAddress.ActiveRow.Cells[6].Value.ToString() != string.Empty)
            {
                if (System.Text.RegularExpressions.Regex.IsMatch(uwgOrgAddress.ActiveRow.Cells[6].Value.ToString(), pattern1) == false && System.Text.RegularExpressions.Regex.IsMatch(uwgOrgAddress.ActiveRow.Cells[6].Value.ToString(), pattern2) == false)
                {
                    string pattern = "^\\(?(\\d{3})\\)?[- ]?(\\d{3})[- ]?(\\d{4})$";
                    if (System.Text.RegularExpressions.Regex.IsMatch(uwgOrgAddress.ActiveRow.Cells[6].Value.ToString(), pattern) == false)
                    {
                        MessageBox.Show("Invalid Phone Number !!", "Data Entry Error", MessageBoxButtons.OK);
                        uwgOrgAddress.ActiveRow.Cells[6].Value = "";
                    }
                    else
                    {
                        uwgOrgAddress.ActiveRow.Cells[6].Value = "(" + uwgOrgAddress.ActiveRow.Cells[6].Value.ToString().Substring(0, 3) + ") " + uwgOrgAddress.ActiveRow.Cells[6].Value.ToString().Substring(3, 3) + " " + uwgOrgAddress.ActiveRow.Cells[6].Value.ToString().Substring(6, 4);

                    }
                }
            }


            if (uwgOrgAddress.ActiveRow.Cells[7].Value.ToString() != string.Empty)
            {
                if (System.Text.RegularExpressions.Regex.IsMatch(uwgOrgAddress.ActiveRow.Cells[7].Value.ToString(), pattern1) == false && System.Text.RegularExpressions.Regex.IsMatch(uwgOrgAddress.ActiveRow.Cells[7].Value.ToString(), pattern2) == false)
                {
                    string pattern = "^\\(?(\\d{3})\\)?[- ]?(\\d{3})[- ]?(\\d{4})$";
                    if (System.Text.RegularExpressions.Regex.IsMatch(uwgOrgAddress.ActiveRow.Cells[7].Value.ToString(), pattern) == false)
                    {
                        MessageBox.Show("Invalid Fax Number !!", "Data Entry Error", MessageBoxButtons.OK);
                        uwgOrgAddress.ActiveRow.Cells[7].Value = "";
                    }
                    else
                    {
                        uwgOrgAddress.ActiveRow.Cells[7].Value = "(" + uwgOrgAddress.ActiveRow.Cells[7].Value.ToString().Substring(0, 3) + ") " + uwgOrgAddress.ActiveRow.Cells[7].Value.ToString().Substring(3, 3) + " " + uwgOrgAddress.ActiveRow.Cells[7].Value.ToString().Substring(6, 4);

                    }
                }
            }

                if (uwgOrgAddress.ActiveRow.Cells[9].Value.ToString() == "0")
                    uwgOrgAddress.ActiveRow.Cells[9].Value = "1";

        }

        private void saveOrgAddressGrid()
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            for (int i = 0; i < uwgOrgAddress.Rows.Count; i++)
            {
                if (uwgOrgAddress.Rows[i].Cells[9].Value.ToString() == "1")
                {
                   
                    int retVal = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "UPDATE OrgAddress SET DepartmentOffice = '" + uwgOrgAddress.Rows[i].Cells[1].Value.ToString() +
                                                                                                "',Address = '" + uwgOrgAddress.Rows[i].Cells[2].Value.ToString() +
                                                                                                "',City = '" + uwgOrgAddress.Rows[i].Cells[3].Value.ToString() +
                                                                                                "',State = '" + uwgOrgAddress.Rows[i].Cells[4].Value.ToString() +
                                                                                                "',Zip = '" + uwgOrgAddress.Rows[i].Cells[5].Value.ToString() +
                                                                                                "',GeneralPhone = '" + uwgOrgAddress.Rows[i].Cells[6].Value.ToString() +
                                                                                                "',GeneralFax = '" + uwgOrgAddress.Rows[i].Cells[7].Value.ToString() +
                                                                                                "' where OrgAddressID = " + Convert.ToInt32(uwgOrgAddress.Rows[i].Cells[8].Value));
                }
            }
            blnDataDirty = false;
            LoadOrgAddress();
            LoadContacts();
        }

        private void MasterContacts_Leave(object sender, EventArgs e)
        {
            if (blnRoleChange == true)
            {
                if (DialogResult.Yes == MessageBox.Show("Save role changes?", "Role Changes", MessageBoxButtons.YesNo))
                    SaveProjectRole();
            }

            for (int i = 0; i < uwgOrgAddress.Rows.Count; i++)
            {
                if (uwgOrgAddress.Rows[i].Cells[9].Value.ToString() == "1")
                {
                    blnDataDirty = true;
                }
            }
            if (blnDataDirty == true)
            {
                DialogResult diaRslt = MessageBox.Show("Data has been changed in Organization Address Grid. Do You want to save changes ?", "Data Change Warning", MessageBoxButtons.YesNo);
                if (diaRslt == DialogResult.Yes)
                {
                    saveOrgAddressGrid();
                    blnDataDirty = false;
                }
                else
                {
                    blnDataDirty = false;
                    LoadOrgAddress();
                }
            }
        }

        private void btnEditAddress_Click(object sender, EventArgs e)
        {
            saveOrgAddressGrid();
           
        }

        private void uwgProjectRole_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Width = 70;
            e.Layout.Bands[0].Columns[0].Header.Caption = "Include";
            e.Layout.Bands[0].Columns[0].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;
            
            e.Layout.Bands[0].Columns[1].Width = 150;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Organization Project Role";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            
            //ProjectRoleID
            e.Layout.Bands[0].Columns[2].Hidden = true;
        }

        private void btnRemoveRole_Click(object sender, EventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;

            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            if (uwgProjectRole.Rows.Count > 1)
            {
               int retval = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "delete from Org_ProjectRole where (ProjectId = " + GlobalSettings.projectId + " and OrgId = " + Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value) + " and ProjectRoleId = " + Convert.ToInt32(uwgProjectRole.ActiveRow.Cells[2].Value) + ")");
            }
            else
            {
                int retval = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "Update Org_ProjectRole SET ProjectRoleId = NULL where (ProjectId = " + GlobalSettings.projectId + " and OrgId = " + Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value) + " and ProjectRoleId = " + Convert.ToInt32(uwgProjectRole.ActiveRow.Cells[2].Value) + ")");
            }
            LoadProjectRole();
        }

        private void btnAddRole_Click(object sender, EventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;

            ProjectRole pr = new ProjectRole(Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value));
            pr.ShowDialog();
            LoadProjectRole();
        }

        private void uwgOrgAddress_CellChange(object sender, CellEventArgs e)
        {
            
        }

        private void MasterContacts_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Shift)
            {
                LoadOrg();
                LoadContacts();
                LoadOrgAddress();
                LoadProjectRole();
            }
        }

        private void uwgOrgAddress_AfterCellActivate(object sender, EventArgs e)
        {
            //if (uwgOrgAddress.ActiveRow.Cells[6].IsActiveCell == true)
            //{
            //    MessageBox.Show("please enter Phone Number in following format: \n (nnn) nnn nnnn OR nnn-nnn-nnnn", "Data Entry Warning", MessageBoxButtons.OK);
            //}
        }

        private void SaveProjectRole()
        {
            if (blnRoleChange == false || roleOrgId == 0)
                return;

            string roles = "";

            for (int i = 0; i < uwgProjectRole.Rows.Count; i++)
            {
                if (uwgProjectRole.Rows[i].Cells[0].Value.ToString() == "1")
                    roles += (roles == string.Empty ? "" : ",") + uwgProjectRole.Rows[i].Cells[2].Value.ToString();
            }
            ProjectData.OrgProjectRoleSave(roleOrgId, GlobalSettings.projectId, roles);

            CCPM.Project.ProjectForm pf = (CCPM.Project.ProjectForm)this.ParentForm;
            pf.RefreshProjectPage();
            blnRoleChange = false;
        }
        
        private void btnSaveRole_Click(object sender, EventArgs e)
        {
            SaveProjectRole();
        }

        private void btnLinkOrgAddress_Click(object sender, EventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;

            Form1 fm = (Form1)((this.ParentForm).MdiParent);
            int? OrgId = null;

            if (uwgOrg.ActiveRow != null &&
                uwgOrg.ActiveRow.Cells[3].Value != null)
            {
                OrgId = Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value);
            }

            //2.40
            //LinkOrg lo = new LinkOrg(OrgId);
            CCPM.Project.Organizations lo = new CCPM.Project.Organizations("project", OrgId);
            
            lo.MdiParent = fm;
            fm.OpenForm(lo, "Link Organization Address");
        }

        private void btnEditOrgAddress_Click(object sender, EventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[3].Value == System.DBNull.Value) return;

             DialogResult intRslt = MessageBox.Show("BE CAREFUL about making changes! Any changes to this org address will affect all other project linked to it.",
                            "Edit Org Address Warning", MessageBoxButtons.OKCancel);
             if (intRslt == DialogResult.OK)
             {
                 Form1 fm = (Form1)((this.ParentForm).MdiParent);
                 int OrgAddressId = Convert.ToInt32(uwgOrgAddress.ActiveRow.Cells[8].Value);
                 int OrgId = Convert.ToInt32(uwgOrg.ActiveRow.Cells[3].Value);
                 NewOrganization no = new NewOrganization("update", "project", OrgAddressId, OrgId);
                 no.MdiParent = fm;
                 fm.OpenForm(no, "Edit Organization Address");
             }
        }

        private void uwgProjectRole_AfterCellUpdate(object sender, CellEventArgs e)
        {
            blnRoleChange = true;
        }

        private void btnAllContacts_Click(object sender, EventArgs e)
        {
            GridSelect gs = new GridSelect();
            gs.lblTitle.Text = "All Contacts for Project";
            gs.DataSet(ProjectData.ProjectContacts(GlobalSettings.projectId));
            gs.Width = 950;
            gs.btnSelectAll.Visible = false;
            gs.ColumnHide(0);
            gs.ColumnWidth(1, 160);
            gs.ColumnWidth(3, 200);
            gs.ColumnWidth(4, 200);
            gs.ShowDialog();



        }

    }
}
