using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using CCPM.Data;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace CCPM.Contact
{
	/// <summary>
	/// Summary description for MasterDetailControl.
	/// </summary>
	public class MasterDetailControl : System.Windows.Forms.UserControl
	{
		#region Class Fields
		private System.Windows.Forms.DataGrid dgContacts;
		private System.Windows.Forms.DataGridTableStyle Master_Detail;
		private System.Windows.Forms.DataGridTextBoxColumn LastName;
		private System.Windows.Forms.DataGridTextBoxColumn FirstName;
		private System.Windows.Forms.DataGridTextBoxColumn OrganizationType;
		private System.Windows.Forms.DataGridTextBoxColumn Title;
		private System.Windows.Forms.DataGridTextBoxColumn Department;
		private System.Windows.Forms.DataGridTextBoxColumn OrganizationName;
		private int contactId = 0;
		private DataSet cds;
		private bool isProjectView = false;
		private System.Windows.Forms.Splitter splitter2;
        private System.Windows.Forms.Panel panel1;
		private int projectId;
		private System.Windows.Forms.DataGridTableStyle ProjectContacts;
		private System.Windows.Forms.DataGridTextBoxColumn ContactType;
		private System.Windows.Forms.DataGridTextBoxColumn _LastName;
		private System.Windows.Forms.DataGridTextBoxColumn _FirstName;
		private System.Windows.Forms.DataGridTextBoxColumn _Title;
		private System.Windows.Forms.DataGridTextBoxColumn D_Department;
		private System.Windows.Forms.DataGridTextBoxColumn _Organization;
		private System.Windows.Forms.DataGridTextBoxColumn _OrganizationType;
		private string tableName = "ContactList";//default to full list
		private System.Windows.Forms.ContextMenu contextMenu1;
        private bool isAddExistingMode = false;
		private System.Windows.Forms.DataGridTextBoxColumn Phone;
		private System.Windows.Forms.DataGridTextBoxColumn Extension;
		private System.Windows.Forms.DataGridTextBoxColumn Fax;
		private System.Windows.Forms.DataGridTextBoxColumn CellPhone;
		private System.Windows.Forms.DataGridTextBoxColumn Email;
		private bool isAddFundingPartnerMode = false;
        private GroupBox groupBox2;
        private Label lblMainFax;
        private Label lblExtension;
        private Label lblMainPhone;
        private Label lblCityState;
        private Label lblStreet;
        private Label label24;
        private Label lblDept;
        private Label label26;
        private Label lblOrganization;
        private Label label28;
        private Label label31;
        private Label label32;
        private Label label33;
        private Label label35;
        private Label label37;
        private Label label40;
        private Label label42;
        private Label lblTaxNumber;
        private CheckBox chkDVBE;
        private CheckBox chkSBE;
        private Button btnLinkOrg;
        private Button btnEditContact;
        private Button btnLinkContact;
        private Button btnEditOrg;
        private Label label3;
		//private string windowTitle = string.Empty;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		#endregion
		public int ContactId
		{
			get{return contactId;}
			set{contactId = value;}
		}

		public int ProjectId
		{
			get{return projectId;}
			set{projectId = value;}
		}
		public bool IsProjectView
		{
			get{return isProjectView;}
			set{isProjectView = value;}
		}

		public int SelectedContact
		{
			get
			{
				int contactId;
				BindingManagerBase manager = this.BindingContext[cds, tableName];
				DataRowView drv = (DataRowView)manager.Current;
                if (drv["CID"].ToString() != string.Empty)
                {
                    contactId = (int)drv["CID"];//["OrgID"];
                }
                else
                {
                    contactId = 0;
                }
				return contactId;
			}
		}

        public int SelectedOrg
        {
            get
            {
                int contactId;
                BindingManagerBase manager = this.BindingContext[cds, tableName];
                DataRowView drv = (DataRowView)manager.Current;
                contactId = (int)drv["OrganizationId"];//["OrgID"];
                return contactId;
            }
        }

		public string ContactOrganizationName
		{
			get
			{
				string organization;
				BindingManagerBase manager = this.BindingContext[cds, tableName];
				DataRowView drv = (DataRowView)manager.Current;
				organization = drv["ContactOrg"].ToString();
				return organization;
			}
		}
		public bool IsAddExistingMode
		{
			get{return isAddExistingMode;}
			set{isAddExistingMode = value;}
		}

		public bool IsAddFundingPartnerMode
		{
			get{return isAddFundingPartnerMode;}
			set{isAddFundingPartnerMode = value;}
		}
        int OrgID,projectContactId;
        private UltraGrid uwgOrganization;
        private UltraGrid uwgContacts;
        private Button button1;
        private UltraGrid uwgOrg;
    
		public MasterDetailControl()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
            dgContacts.ReadOnly = true;
			this.Load += new System.EventHandler(MasterDetail_Load);
			this.BindingContext = new BindingContext();
            uwgOrg.DisplayLayout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            
            //MessageBox.Show(uwgOrg.Rows.IsReadOnly.ToString());
            
		}

		public void SetGridCaption(string caption)
		{
			this.dgContacts.CaptionText = caption;
		}

        public virtual void LoadOrgContacts()
        {
            if (!IsProjectView)
            {
                if (cds == null)
                {
                    cds = ContactData.ContactList();
                    uwgOrg.DataSource = cds;
                    uwgOrg.DataMember = tableName;
                    uwgOrg.DataBind();
                }
                else
                {
                    //Reload the data without breaking DataBinding
                    BindingManagerBase manager = this.BindingContext[cds, tableName];
                    manager.SuspendBinding();
                    cds.Clear();
                    cds.Merge(ContactData.ContactList());
                    manager.ResumeBinding();
                }
            }
            else//Load project related contacts
            {
                cds = null;
                if (cds == null)
                {
                    cds = ContactData.ContactsByProject(ProjectId);
                    uwgOrg.DataSource = cds;
                    uwgOrg.DataMember = tableName;
                    uwgOrg.DataBind();
                }
                else
                {
                    BindingManagerBase manager = this.BindingContext[cds, tableName];
                    manager.SuspendBinding();
                    cds.Clear();
                    cds.Merge(ContactData.ContactsByProject(ProjectId));
                    manager.ResumeBinding();
                }
                if (cds.Tables[tableName].Rows.Count > 0)
                {
                    SetContactTypes(this, EventArgs.Empty);
                }
            }
        }

		public virtual void LoadContacts()
		{
			//Load all contacts
			if( ! IsProjectView)
			{
				if(cds == null)
				{
					cds = ContactData.ContactList();
					dgContacts.DataSource = cds;
					dgContacts.DataMember = tableName;
				}
				else
				{
					//Reload the data without breaking DataBinding
					BindingManagerBase manager = this.BindingContext[cds, tableName];
					manager.SuspendBinding();
					cds.Clear();
					cds.Merge(ContactData.ContactList());
					manager.ResumeBinding();
				}
			}
			else//Load project related contacts
			{
                cds = null;
				if(cds == null)
				{
					cds = ContactData.ContactsByProject(ProjectId);
					dgContacts.DataSource = cds;
					dgContacts.DataMember = tableName;
				}
				else
				{
					BindingManagerBase manager = this.BindingContext[cds, tableName];
					manager.SuspendBinding();
					cds.Clear();
					cds.Merge(ContactData.ContactsByProject(ProjectId));
					manager.ResumeBinding();
				}
				if(cds.Tables[tableName].Rows.Count > 0)
				{
					SetContactTypes(this, EventArgs.Empty);
				}
			}
		}

		public virtual void SetDetailView()
		{
            lblOrganization.DataBindings.Clear();
            lblDept.DataBindings.Clear();
            lblStreet.DataBindings.Clear();
            lblCityState.DataBindings.Clear();
            lblMainPhone.DataBindings.Clear();
            lblMainFax.DataBindings.Clear();
            lblTaxNumber.DataBindings.Clear();
            lblExtension.DataBindings.Clear();
            chkSBE.DataBindings.Clear();
            chkDVBE.DataBindings.Clear();

            
            lblOrganization.DataBindings.Add(new Binding("Text", cds, string.Concat(tableName, ".ContactOrg")));
            lblDept.DataBindings.Add(new Binding("Text", cds, string.Concat(tableName, ".DepartmentOffice")));
            lblStreet.DataBindings.Add(new Binding("Text", cds, string.Concat(tableName, ".Address")));
            lblCityState.DataBindings.Add(new Binding("Text", cds, string.Concat(tableName, ".City")));
            lblMainPhone.DataBindings.Add(new Binding("Text", cds, string.Concat(tableName, ".GeneralPhone")));
            lblMainFax.DataBindings.Add(new Binding("Text", cds, string.Concat(tableName, ".GeneralFax")));
            lblTaxNumber.DataBindings.Add(new Binding("Text", cds, string.Concat(tableName, ".TaxID")));
            lblExtension.DataBindings.Add(new Binding("Text", cds, string.Concat(tableName, ".ContactExtension")));
            chkSBE.DataBindings.Add(new Binding("Checked", cds, string.Concat(tableName, ".SBE")));
            chkDVBE.DataBindings.Add(new Binding("Checked", cds, string.Concat(tableName, ".DVBE")));
		}

		public void SetSelected()
		{
            int conId = 0;
			//if(ContactId == 0) return;
            if (cds.Tables[tableName].Rows.Count > 0)
            {
                for (int i = 0; i < cds.Tables[tableName].Rows.Count; i++)
                {
                    if (isProjectView)
                    {
                        if (Convert.ToString(cds.Tables[tableName].Rows[i]["ContactID"]) == string.Empty)
                        {
                            btnEditContact.Enabled = false;
                            contextMenu1.MenuItems[6].Enabled = false;
                            conId = 0;
                            OrgID = Convert.ToInt32(cds.Tables[tableName].Rows[i]["OrganizationId"]);
                        }
                        else
                        {
                            btnEditContact.Enabled = true;
                            contextMenu1.MenuItems[6].Enabled = true;
                            conId = Convert.ToInt32(cds.Tables[tableName].Rows[i]["CID"]);
                            projectContactId = Convert.ToInt32(cds.Tables[tableName].Rows[i]["ContactID"]);
                            OrgID = Convert.ToInt32(cds.Tables[tableName].Rows[i]["OrganizationId"]);
                        }
                    }
                 
                    if(conId == this.SelectedContact && OrgID == this.SelectedOrg)
                    {
                        // CurrencyManager manager = this.BindingContext[cds, tableName] as CurrencyManager;
                        BindingManagerBase manager = this.BindingContext[cds, tableName];
                        manager.Position = i;                       
                        //dgContacts.Select(i); 
                        //uwgOrg.Rows[i].Selected = true;
                        OrgID = Convert.ToInt32(cds.Tables[tableName].Rows[i]["OrganizationId"]);
                        break;
                    }
                    
                }
            }
            SetDetailView();
		}

		public void SetContextMenu()
		{
			if(IsAddExistingMode)//Used when a contact is being associated with a project.
			{
//				dsContactType = ContactData.ContactTypeList();
//				int itemCount= dsContactType.Tables[0].Rows.Count;
//				DataTable dt = dsContactType.Tables[0];
//				MenuItem[] miArray = new MenuItem[itemCount];
//				for(int i = 0; i < itemCount; i++)
//				{
//					MenuItem mi = new MenuItem();
//					mi.Text = dt.Rows[i]["ContactType"].ToString();
//					mi.Index = i;
//					miArray[i] = mi;
//					mi.Click += new EventHandler(miContactType_Click);
//				}
//		
//				this.contextMenu1 = new System.Windows.Forms.ContextMenu();
//				MenuItem miAddContactAs = new System.Windows.Forms.MenuItem();
//				miAddContactAs.Text = "Add Contact As";
//				miAddContactAs.Index = 0;
//
//				MenuItem miSpacer = new MenuItem();
//				miSpacer.Text = "-";
//				miSpacer.Index = 1;
//				
//				MenuItem miClose = new MenuItem();
//				miClose.Text = "Close";
//				miClose.Index = 2;
//				miClose.Click += new EventHandler(miClose_Click);
//				
//				MenuItem[] mainItems = new MenuItem[]{miAddContactAs, miSpacer, miClose};
//				this.contextMenu1.MenuItems.AddRange(mainItems);
//																					
//				miAddContactAs.MenuItems.AddRange(miArray);
//																							 
//				this.ContextMenu = contextMenu1;	
			}
			else if(IsProjectView)//Used when viewing contacts associated with a project
			{
				this.contextMenu1 = new System.Windows.Forms.ContextMenu();

				MenuItem miAddExisting = new System.Windows.Forms.MenuItem();
				miAddExisting.Index = 0;
				miAddExisting.Text = "Add Existing Organization";

                MenuItem miAddNew = new MenuItem();
                miAddNew.Visible = false;
                miAddNew.Text = "Add New Organization";
                miAddNew.Index = 1;

                MenuItem miClone = new MenuItem();
                miClone.Visible = false;
                miClone.Text = "Clone Contact";
                miClone.Index = 2;

				MenuItem miSpacer1 = new MenuItem();
				miSpacer1.Text = "-";
				miSpacer1.Index = 3;

				MenuItem miEdit = new MenuItem();
				miEdit.Text = "Edit Organization";
				miEdit.Index = 4;

				MenuItem miSpacer2 = new MenuItem();
				miSpacer2.Text = "-";
				miSpacer2.Index = 5;

				MenuItem miRemove = new MenuItem();
                //miRemove.Visible = false;
				miRemove.Text = "Remove Contact";
				miRemove.Index = 6;

                MenuItem miRemove1 = new MenuItem();
                miRemove1.Text = "Remove Organization";
                miRemove1.Index = 7;

				MenuItem miSpacer3 = new MenuItem();
				miSpacer3.Text = "-";
				miSpacer3.Index = 8;

				MenuItem miRefresh = new MenuItem();
				miRefresh.Text = "Refresh";
				miRefresh.Index = 9;

				this.contextMenu1.MenuItems.AddRange(new MenuItem[]{miAddExisting, miAddNew, miClone, miSpacer1, miEdit, miSpacer2, miRemove, miRemove1, miSpacer3, miRefresh});

				this.ContextMenu = contextMenu1;

				miAddExisting.Click += new EventHandler(miAddExisting_Click);
				miAddNew.Click += new EventHandler(miAddNew_Click);
				miClone.Click += new EventHandler(miClone_Click);
				miEdit.Click += new EventHandler(miEdit_Click);
				miRemove.Click +=new EventHandler(miRemove_Click);
                miRemove1.Click += new EventHandler(miRemove1_Click);
				miRefresh.Click += new EventHandler(miRefresh_Click);
			}
			else if(IsAddFundingPartnerMode)
			{

			}
			else//Used when viewing the Master Contact list
			{
				this.contextMenu1 = new System.Windows.Forms.ContextMenu();
				
				MenuItem miAddNew = new MenuItem();
				miAddNew.Text = "Add New Contact";
				miAddNew.Index = 0;

				MenuItem miSpacer1 = new MenuItem();
				miSpacer1.Text = "-";
				miSpacer1.Index = 1;

				MenuItem miEdit = new MenuItem();
				miEdit.Text = "Edit Contact";
				miEdit.Index = 2;

				MenuItem miClone = new MenuItem();
				miClone.Text = "Clone Contact";
				miClone.Index = 3;

				MenuItem miSpacer2 = new MenuItem();
				miSpacer2.Text = "-";
				miSpacer2.Index = 4;

				MenuItem miDelete = new MenuItem();
				miDelete.Text = "Delete Contact";
				miDelete.Index = 5;

				MenuItem miSpacer3 = new MenuItem();
				miSpacer3.Text = "-";
				miSpacer3.Index = 6;

				MenuItem miRefresh = new MenuItem();
				miRefresh.Text = "Refresh";
				miRefresh.Index = 7;

				MenuItem miSpacer4 = new MenuItem();
				miSpacer4.Text = "-";
				miSpacer4.Index = 8;
				
				MenuItem miClose = new MenuItem();
				miClose.Text = "Close";
				miClose.Index = 9;
				miClose.Click += new EventHandler(miClose_Click);

				this.contextMenu1.MenuItems.AddRange(new MenuItem[]{miAddNew, miSpacer1, miEdit, miClone, miSpacer2, miDelete, miSpacer3, miRefresh, miSpacer4, miClose });

				this.ContextMenu = contextMenu1;

				miAddNew.Click += new EventHandler(miMasterAddNew_Click);
				miEdit.Click += new EventHandler(miMasterEdit_Click);
				miClone.Click += new EventHandler(miClone_Click);
				miDelete.Click += new EventHandler(miDelete_Click);
				miRefresh.Click += new EventHandler(miRefresh_Click);
			}
		}

		
		/// <summary> 
			/// Clean up any resources being used.
			/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void SetRemoveButtonColumn()
		{
			DataGridButton.DataGridButtonColumn buttonColStyle = null;
			buttonColStyle = new DataGridButton.DataGridButtonColumn(3); //pass the column#
			buttonColStyle.HeaderText =  string.Empty;
			//Must match a data table column name
			buttonColStyle.MappingName =  "RemoveContact";
			buttonColStyle.Width = 80;

            //Added by Gatika 11/11/07
            DataGridButton.DataGridButtonColumn buttonColStyle1 = null;
            buttonColStyle1 = new DataGridButton.DataGridButtonColumn(0); //pass the column#
            buttonColStyle1.HeaderText = string.Empty;
            //Must match a data table column name
            buttonColStyle1.MappingName = "RemoveOrg";
            buttonColStyle1.Width = 80;

			//hookup cellbutton handler...
			buttonColStyle.CellButtonClicked += 
				new DataGridButton.DataGridCellButtonClickEventHandler(HandleRemoveButtonClick);

            buttonColStyle1.CellButtonClicked +=
                new DataGridButton.DataGridCellButtonClickEventHandler(HandleRemoveOrgButtonClick);

			DataGridColumnStyle[] dgColumns = new DataGridColumnStyle[] {
                                                                            buttonColStyle1,
                                                                            this._Organization,
																			this._OrganizationType,
																			buttonColStyle,
																			this._FirstName,
																			this._Title,
																			this.Phone,
                                                                            this.CellPhone,
																			this.Fax,
																			this.Email};

			this.ProjectContacts.GridColumnStyles.Clear();
			this.ProjectContacts.GridColumnStyles.AddRange(dgColumns);

			//hook the mouse handlers
            dgContacts.MouseDown += new MouseEventHandler(buttonColStyle.HandleMouseDown);
            dgContacts.MouseUp += new MouseEventHandler(buttonColStyle.HandleMouseUp);

            dgContacts.MouseDown += new MouseEventHandler(buttonColStyle1.HandleMouseDown);
            dgContacts.MouseUp += new MouseEventHandler(buttonColStyle1.HandleMouseUp);

		}

		private void SetAddButtonColumn()
		{
			DataGridButton.DataGridButtonColumn buttonColStyle = null;
			buttonColStyle = new DataGridButton.DataGridButtonColumn(0);

            DataGridButton.DataGridButtonColumn buttonColStyle1 = null;
            buttonColStyle1 = new DataGridButton.DataGridButtonColumn(3); //pass the column#
			if(!IsAddFundingPartnerMode)
			{
				buttonColStyle.HeaderText =  string.Empty;
				buttonColStyle.MappingName = "AddContact";
				buttonColStyle.Width = 110;
			}
			else //Funding Partner Mode
			{
				buttonColStyle.HeaderText =  string.Empty;
				buttonColStyle.MappingName = "AddFundingPartner";
				buttonColStyle.Width = 80;
			}

			//hookup cellbutton handler...
			buttonColStyle.CellButtonClicked += 
				new DataGridButton.DataGridCellButtonClickEventHandler(HandleAddButtonClick);

			DataGridColumnStyle[] dgColumns = new DataGridColumnStyle[] {
																			buttonColStyle1,
                                                                            this._Organization,
																			this._OrganizationType,
																			buttonColStyle,
																			this._FirstName,
																			this._Title,
																			this.Phone,
                                                                            this.CellPhone,
																			this.Fax,
																			this.Email};

			this.Master_Detail.GridColumnStyles.Clear();
			this.Master_Detail.GridColumnStyles.AddRange(dgColumns);

			//hook the mouse handlers
			dgContacts.MouseDown += new MouseEventHandler(buttonColStyle.HandleMouseDown);
			dgContacts.MouseUp += new MouseEventHandler(buttonColStyle.HandleMouseUp);

		}


		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            Infragistics.Win.Appearance appearance25 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance26 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance27 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance28 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance29 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance30 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance31 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance32 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance33 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance34 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance35 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance36 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance13 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance14 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance15 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance16 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance17 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance18 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance19 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance20 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance21 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance22 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance23 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance24 = new Infragistics.Win.Appearance();
            this.dgContacts = new System.Windows.Forms.DataGrid();
            this.Master_Detail = new System.Windows.Forms.DataGridTableStyle();
            this.FirstName = new System.Windows.Forms.DataGridTextBoxColumn();
            this.LastName = new System.Windows.Forms.DataGridTextBoxColumn();
            this.Title = new System.Windows.Forms.DataGridTextBoxColumn();
            this.Department = new System.Windows.Forms.DataGridTextBoxColumn();
            this.OrganizationName = new System.Windows.Forms.DataGridTextBoxColumn();
            this.OrganizationType = new System.Windows.Forms.DataGridTextBoxColumn();
            this.ProjectContacts = new System.Windows.Forms.DataGridTableStyle();
            this._FirstName = new System.Windows.Forms.DataGridTextBoxColumn();
            this._LastName = new System.Windows.Forms.DataGridTextBoxColumn();
            this.ContactType = new System.Windows.Forms.DataGridTextBoxColumn();
            this._Title = new System.Windows.Forms.DataGridTextBoxColumn();
            this.D_Department = new System.Windows.Forms.DataGridTextBoxColumn();
            this._Organization = new System.Windows.Forms.DataGridTextBoxColumn();
            this._OrganizationType = new System.Windows.Forms.DataGridTextBoxColumn();
            this.Phone = new System.Windows.Forms.DataGridTextBoxColumn();
            this.Extension = new System.Windows.Forms.DataGridTextBoxColumn();
            this.Fax = new System.Windows.Forms.DataGridTextBoxColumn();
            this.CellPhone = new System.Windows.Forms.DataGridTextBoxColumn();
            this.Email = new System.Windows.Forms.DataGridTextBoxColumn();
            this.splitter2 = new System.Windows.Forms.Splitter();
            this.panel1 = new System.Windows.Forms.Panel();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.label3 = new System.Windows.Forms.Label();
            this.btnEditContact = new System.Windows.Forms.Button();
            this.btnLinkContact = new System.Windows.Forms.Button();
            this.btnEditOrg = new System.Windows.Forms.Button();
            this.btnLinkOrg = new System.Windows.Forms.Button();
            this.chkDVBE = new System.Windows.Forms.CheckBox();
            this.chkSBE = new System.Windows.Forms.CheckBox();
            this.lblMainFax = new System.Windows.Forms.Label();
            this.lblExtension = new System.Windows.Forms.Label();
            this.lblMainPhone = new System.Windows.Forms.Label();
            this.lblCityState = new System.Windows.Forms.Label();
            this.lblStreet = new System.Windows.Forms.Label();
            this.label24 = new System.Windows.Forms.Label();
            this.lblDept = new System.Windows.Forms.Label();
            this.label26 = new System.Windows.Forms.Label();
            this.lblOrganization = new System.Windows.Forms.Label();
            this.label28 = new System.Windows.Forms.Label();
            this.label31 = new System.Windows.Forms.Label();
            this.label32 = new System.Windows.Forms.Label();
            this.label33 = new System.Windows.Forms.Label();
            this.label35 = new System.Windows.Forms.Label();
            this.label37 = new System.Windows.Forms.Label();
            this.label40 = new System.Windows.Forms.Label();
            this.label42 = new System.Windows.Forms.Label();
            this.lblTaxNumber = new System.Windows.Forms.Label();
            this.uwgOrg = new Infragistics.Win.UltraWinGrid.UltraGrid();
            this.uwgOrganization = new Infragistics.Win.UltraWinGrid.UltraGrid();
            this.uwgContacts = new Infragistics.Win.UltraWinGrid.UltraGrid();
            this.button1 = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.dgContacts)).BeginInit();
            this.panel1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.uwgOrg)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.uwgOrganization)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.uwgContacts)).BeginInit();
            this.SuspendLayout();
            // 
            // dgContacts
            // 
            this.dgContacts.AllowNavigation = false;
            this.dgContacts.AlternatingBackColor = System.Drawing.Color.Gainsboro;
            this.dgContacts.CausesValidation = false;
            this.dgContacts.DataMember = "";
            this.dgContacts.Dock = System.Windows.Forms.DockStyle.Top;
            this.dgContacts.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.dgContacts.Location = new System.Drawing.Point(0, 0);
            this.dgContacts.Name = "dgContacts";
            this.dgContacts.ReadOnly = true;
            this.dgContacts.Size = new System.Drawing.Size(1280, 390);
            this.dgContacts.TabIndex = 1;
            this.dgContacts.TableStyles.AddRange(new System.Windows.Forms.DataGridTableStyle[] {
            this.Master_Detail,
            this.ProjectContacts});
            this.dgContacts.TabStop = false;
            this.dgContacts.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.dgContacts_KeyPress);
            this.dgContacts.Click += new System.EventHandler(this.dgContacts_Click);
            // 
            // Master_Detail
            // 
            this.Master_Detail.AlternatingBackColor = System.Drawing.Color.Gainsboro;
            this.Master_Detail.DataGrid = this.dgContacts;
            this.Master_Detail.GridColumnStyles.AddRange(new System.Windows.Forms.DataGridColumnStyle[] {
            this.FirstName,
            this.LastName,
            this.Title,
            this.Department,
            this.OrganizationName,
            this.OrganizationType});
            this.Master_Detail.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.Master_Detail.MappingName = "ContactList";
            this.Master_Detail.ReadOnly = true;
            // 
            // FirstName
            // 
            this.FirstName.Format = "";
            this.FirstName.FormatInfo = null;
            this.FirstName.HeaderText = "First Name";
            this.FirstName.MappingName = "ContactFName";
            this.FirstName.ReadOnly = true;
            this.FirstName.Width = 150;
            // 
            // LastName
            // 
            this.LastName.Format = "";
            this.LastName.FormatInfo = null;
            this.LastName.HeaderText = "Last Name";
            this.LastName.MappingName = "ContactLName";
            this.LastName.Width = 75;
            // 
            // Title
            // 
            this.Title.Format = "";
            this.Title.FormatInfo = null;
            this.Title.HeaderText = "Title";
            this.Title.MappingName = "ContactJobTitle";
            this.Title.Width = 200;
            // 
            // Department
            // 
            this.Department.Format = "";
            this.Department.FormatInfo = null;
            this.Department.HeaderText = "Department";
            this.Department.MappingName = "ContactDept";
            this.Department.Width = 150;
            // 
            // OrganizationName
            // 
            this.OrganizationName.Format = "";
            this.OrganizationName.FormatInfo = null;
            this.OrganizationName.HeaderText = "Organization Name";
            this.OrganizationName.MappingName = "ContactOrg";
            this.OrganizationName.Width = 150;
            // 
            // OrganizationType
            // 
            this.OrganizationType.Format = "";
            this.OrganizationType.FormatInfo = null;
            this.OrganizationType.HeaderText = "Organization Type";
            this.OrganizationType.MappingName = "OrganizationType";
            this.OrganizationType.Width = 130;
            // 
            // ProjectContacts
            // 
            this.ProjectContacts.AlternatingBackColor = System.Drawing.Color.Gainsboro;
            this.ProjectContacts.DataGrid = this.dgContacts;
            this.ProjectContacts.GridColumnStyles.AddRange(new System.Windows.Forms.DataGridColumnStyle[] {
            this._FirstName,
            this._LastName,
            this.ContactType,
            this._Title,
            this.D_Department,
            this._Organization,
            this._OrganizationType,
            this.Phone,
            this.Extension,
            this.Fax,
            this.CellPhone,
            this.Email});
            this.ProjectContacts.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.ProjectContacts.MappingName = "ProjectContacts";
            // 
            // _FirstName
            // 
            this._FirstName.Format = "";
            this._FirstName.FormatInfo = null;
            this._FirstName.HeaderText = "Contact Name";
            this._FirstName.MappingName = "FullName";
            this._FirstName.Width = 150;
            // 
            // _LastName
            // 
            this._LastName.Format = "";
            this._LastName.FormatInfo = null;
            this._LastName.HeaderText = "Last Name";
            this._LastName.MappingName = "ContactLName";
            this._LastName.Width = 75;
            // 
            // ContactType
            // 
            this.ContactType.Format = "";
            this.ContactType.FormatInfo = null;
            this.ContactType.HeaderText = "Contact Type";
            this.ContactType.MappingName = "ContactType";
            this.ContactType.Width = 75;
            // 
            // _Title
            // 
            this._Title.Format = "";
            this._Title.FormatInfo = null;
            this._Title.HeaderText = "Title";
            this._Title.MappingName = "ContactJobTitle";
            this._Title.Width = 90;
            // 
            // D_Department
            // 
            this.D_Department.Format = "";
            this.D_Department.FormatInfo = null;
            this.D_Department.HeaderText = "Department";
            this.D_Department.MappingName = "ContactDept";
            this.D_Department.Width = 150;
            // 
            // _Organization
            // 
            this._Organization.Format = "";
            this._Organization.FormatInfo = null;
            this._Organization.HeaderText = "Organization Name";
            this._Organization.MappingName = "ContactOrg";
            this._Organization.Width = 250;
            // 
            // _OrganizationType
            // 
            this._OrganizationType.Format = "";
            this._OrganizationType.FormatInfo = null;
            this._OrganizationType.HeaderText = "Organization Type";
            this._OrganizationType.MappingName = "OrganizationType";
            this._OrganizationType.Width = 125;
            // 
            // Phone
            // 
            this.Phone.Format = "";
            this.Phone.FormatInfo = null;
            this.Phone.HeaderText = "Contact Phone/Extension";
            this.Phone.MappingName = "ContactPhone";
            this.Phone.Width = 95;
            // 
            // Extension
            // 
            this.Extension.Format = "";
            this.Extension.FormatInfo = null;
            this.Extension.HeaderText = "Ext.";
            this.Extension.MappingName = "ContactExtension";
            this.Extension.Width = 75;
            // 
            // Fax
            // 
            this.Fax.Format = "";
            this.Fax.FormatInfo = null;
            this.Fax.HeaderText = "Fax";
            this.Fax.MappingName = "ContactFax";
            this.Fax.Width = 95;
            // 
            // CellPhone
            // 
            this.CellPhone.Format = "";
            this.CellPhone.FormatInfo = null;
            this.CellPhone.HeaderText = "Cell Phone";
            this.CellPhone.MappingName = "ContactCellPhone";
            this.CellPhone.Width = 95;
            // 
            // Email
            // 
            this.Email.Format = "";
            this.Email.FormatInfo = null;
            this.Email.HeaderText = "Email";
            this.Email.MappingName = "ContactEmail";
            this.Email.Width = 150;
            // 
            // splitter2
            // 
            this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter2.Location = new System.Drawing.Point(0, 390);
            this.splitter2.Name = "splitter2";
            this.splitter2.Size = new System.Drawing.Size(1280, 3);
            this.splitter2.TabIndex = 4;
            this.splitter2.TabStop = false;
            // 
            // panel1
            // 
            this.panel1.AutoScroll = true;
            this.panel1.Controls.Add(this.button1);
            this.panel1.Controls.Add(this.groupBox2);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel1.Location = new System.Drawing.Point(0, 393);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(1280, 321);
            this.panel1.TabIndex = 5;
            // 
            // groupBox2
            // 
            this.groupBox2.BackColor = System.Drawing.SystemColors.Control;
            this.groupBox2.Controls.Add(this.label3);
            this.groupBox2.Controls.Add(this.btnEditContact);
            this.groupBox2.Controls.Add(this.btnLinkContact);
            this.groupBox2.Controls.Add(this.btnEditOrg);
            this.groupBox2.Controls.Add(this.btnLinkOrg);
            this.groupBox2.Controls.Add(this.chkDVBE);
            this.groupBox2.Controls.Add(this.chkSBE);
            this.groupBox2.Controls.Add(this.lblMainFax);
            this.groupBox2.Controls.Add(this.lblExtension);
            this.groupBox2.Controls.Add(this.lblMainPhone);
            this.groupBox2.Controls.Add(this.lblCityState);
            this.groupBox2.Controls.Add(this.lblStreet);
            this.groupBox2.Controls.Add(this.label24);
            this.groupBox2.Controls.Add(this.lblDept);
            this.groupBox2.Controls.Add(this.label26);
            this.groupBox2.Controls.Add(this.lblOrganization);
            this.groupBox2.Controls.Add(this.label28);
            this.groupBox2.Controls.Add(this.label31);
            this.groupBox2.Controls.Add(this.label32);
            this.groupBox2.Controls.Add(this.label33);
            this.groupBox2.Controls.Add(this.label35);
            this.groupBox2.Controls.Add(this.label37);
            this.groupBox2.Controls.Add(this.label40);
            this.groupBox2.Controls.Add(this.label42);
            this.groupBox2.Controls.Add(this.lblTaxNumber);
            this.groupBox2.Location = new System.Drawing.Point(3, 6);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(745, 285);
            this.groupBox2.TabIndex = 1;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Organization Information";
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(19, 229);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(428, 13);
            this.label3.TabIndex = 80;
            this.label3.Text = "Before clicking the buttons below, first select an organization or contact in the" +
                " grid above.";
            // 
            // btnEditContact
            // 
            this.btnEditContact.Location = new System.Drawing.Point(531, 247);
            this.btnEditContact.Name = "btnEditContact";
            this.btnEditContact.Size = new System.Drawing.Size(131, 23);
            this.btnEditContact.TabIndex = 79;
            this.btnEditContact.Text = "EDIT CONTACT";
            this.btnEditContact.UseVisualStyleBackColor = true;
            this.btnEditContact.Click += new System.EventHandler(this.btnEditContact_Click);
            // 
            // btnLinkContact
            // 
            this.btnLinkContact.Location = new System.Drawing.Point(531, 196);
            this.btnLinkContact.Name = "btnLinkContact";
            this.btnLinkContact.Size = new System.Drawing.Size(131, 23);
            this.btnLinkContact.TabIndex = 78;
            this.btnLinkContact.Text = "LINK CONTACT";
            this.btnLinkContact.UseVisualStyleBackColor = true;
            this.btnLinkContact.Click += new System.EventHandler(this.btnLinkContact_Click);
            // 
            // btnEditOrg
            // 
            this.btnEditOrg.Location = new System.Drawing.Point(19, 247);
            this.btnEditOrg.Name = "btnEditOrg";
            this.btnEditOrg.Size = new System.Drawing.Size(153, 23);
            this.btnEditOrg.TabIndex = 77;
            this.btnEditOrg.Text = "EDIT ORGANIZATION";
            this.btnEditOrg.UseVisualStyleBackColor = true;
            this.btnEditOrg.Click += new System.EventHandler(this.btnEditOrg_Click);
            // 
            // btnLinkOrg
            // 
            this.btnLinkOrg.Location = new System.Drawing.Point(19, 196);
            this.btnLinkOrg.Name = "btnLinkOrg";
            this.btnLinkOrg.Size = new System.Drawing.Size(281, 23);
            this.btnLinkOrg.TabIndex = 76;
            this.btnLinkOrg.Text = "LINK AN ORGANIZATION TO THIS PROJECT";
            this.btnLinkOrg.UseVisualStyleBackColor = true;
            this.btnLinkOrg.Click += new System.EventHandler(this.btnLinkOrg_Click);
            // 
            // chkDVBE
            // 
            this.chkDVBE.AutoSize = true;
            this.chkDVBE.Enabled = false;
            this.chkDVBE.Location = new System.Drawing.Point(408, 154);
            this.chkDVBE.Name = "chkDVBE";
            this.chkDVBE.Size = new System.Drawing.Size(152, 17);
            this.chkDVBE.TabIndex = 75;
            this.chkDVBE.Text = "Disabled Veteran Business";
            this.chkDVBE.UseVisualStyleBackColor = true;
            // 
            // chkSBE
            // 
            this.chkSBE.AutoSize = true;
            this.chkSBE.Enabled = false;
            this.chkSBE.Location = new System.Drawing.Point(408, 126);
            this.chkSBE.Name = "chkSBE";
            this.chkSBE.Size = new System.Drawing.Size(96, 17);
            this.chkSBE.TabIndex = 74;
            this.chkSBE.Text = "Small Business";
            this.chkSBE.UseVisualStyleBackColor = true;
            // 
            // lblMainFax
            // 
            this.lblMainFax.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.lblMainFax.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.lblMainFax.Location = new System.Drawing.Point(148, 154);
            this.lblMainFax.Name = "lblMainFax";
            this.lblMainFax.Size = new System.Drawing.Size(152, 24);
            this.lblMainFax.TabIndex = 69;
            this.lblMainFax.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblExtension
            // 
            this.lblExtension.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.lblExtension.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.lblExtension.Location = new System.Drawing.Point(311, 131);
            this.lblExtension.Name = "lblExtension";
            this.lblExtension.Size = new System.Drawing.Size(63, 24);
            this.lblExtension.TabIndex = 68;
            this.lblExtension.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblMainPhone
            // 
            this.lblMainPhone.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.lblMainPhone.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.lblMainPhone.Location = new System.Drawing.Point(148, 131);
            this.lblMainPhone.Name = "lblMainPhone";
            this.lblMainPhone.Size = new System.Drawing.Size(128, 24);
            this.lblMainPhone.TabIndex = 67;
            this.lblMainPhone.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblCityState
            // 
            this.lblCityState.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.lblCityState.Location = new System.Drawing.Point(148, 108);
            this.lblCityState.Name = "lblCityState";
            this.lblCityState.Size = new System.Drawing.Size(226, 24);
            this.lblCityState.TabIndex = 64;
            this.lblCityState.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblStreet
            // 
            this.lblStreet.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.lblStreet.Location = new System.Drawing.Point(148, 85);
            this.lblStreet.Name = "lblStreet";
            this.lblStreet.Size = new System.Drawing.Size(226, 24);
            this.lblStreet.TabIndex = 63;
            this.lblStreet.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label24
            // 
            this.label24.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.label24.AutoSize = true;
            this.label24.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.label24.Location = new System.Drawing.Point(148, 87);
            this.label24.Name = "label24";
            this.label24.Size = new System.Drawing.Size(2, 15);
            this.label24.TabIndex = 60;
            this.label24.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblDept
            // 
            this.lblDept.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.lblDept.Location = new System.Drawing.Point(148, 62);
            this.lblDept.Name = "lblDept";
            this.lblDept.Size = new System.Drawing.Size(226, 24);
            this.lblDept.TabIndex = 59;
            this.lblDept.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label26
            // 
            this.label26.AutoSize = true;
            this.label26.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.label26.Location = new System.Drawing.Point(148, 112);
            this.label26.Name = "label26";
            this.label26.Size = new System.Drawing.Size(2, 15);
            this.label26.TabIndex = 57;
            this.label26.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblOrganization
            // 
            this.lblOrganization.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.lblOrganization.Location = new System.Drawing.Point(148, 39);
            this.lblOrganization.Name = "lblOrganization";
            this.lblOrganization.Size = new System.Drawing.Size(325, 24);
            this.lblOrganization.TabIndex = 56;
            this.lblOrganization.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label28
            // 
            this.label28.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.label28.Location = new System.Drawing.Point(400, 82);
            this.label28.Name = "label28";
            this.label28.Size = new System.Drawing.Size(88, 23);
            this.label28.TabIndex = 49;
            this.label28.Text = "Tax ID Number";
            this.label28.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label31
            // 
            this.label31.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.label31.Location = new System.Drawing.Point(16, 132);
            this.label31.Name = "label31";
            this.label31.Size = new System.Drawing.Size(80, 23);
            this.label31.TabIndex = 52;
            this.label31.Text = "Main Phone";
            this.label31.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label32
            // 
            this.label32.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.label32.AutoSize = true;
            this.label32.Location = new System.Drawing.Point(281, 137);
            this.label32.Name = "label32";
            this.label32.Size = new System.Drawing.Size(25, 13);
            this.label32.TabIndex = 53;
            this.label32.Text = "Ext.";
            this.label32.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // label33
            // 
            this.label33.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.label33.Location = new System.Drawing.Point(16, 154);
            this.label33.Name = "label33";
            this.label33.Size = new System.Drawing.Size(80, 23);
            this.label33.TabIndex = 54;
            this.label33.Text = "Main Fax";
            this.label33.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label35
            // 
            this.label35.Location = new System.Drawing.Point(16, 88);
            this.label35.Name = "label35";
            this.label35.Size = new System.Drawing.Size(64, 23);
            this.label35.TabIndex = 45;
            this.label35.Text = "Street";
            this.label35.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label37
            // 
            this.label37.Location = new System.Drawing.Point(16, 110);
            this.label37.Name = "label37";
            this.label37.Size = new System.Drawing.Size(86, 23);
            this.label37.TabIndex = 47;
            this.label37.Text = "City/State/Zip";
            this.label37.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label40
            // 
            this.label40.Location = new System.Drawing.Point(16, 38);
            this.label40.Name = "label40";
            this.label40.Size = new System.Drawing.Size(78, 23);
            this.label40.TabIndex = 40;
            this.label40.Text = "Organization";
            this.label40.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label42
            // 
            this.label42.Location = new System.Drawing.Point(16, 63);
            this.label42.Name = "label42";
            this.label42.Size = new System.Drawing.Size(99, 23);
            this.label42.TabIndex = 44;
            this.label42.Text = "Dept/Office";
            this.label42.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblTaxNumber
            // 
            this.lblTaxNumber.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.lblTaxNumber.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.lblTaxNumber.Location = new System.Drawing.Point(494, 81);
            this.lblTaxNumber.Name = "lblTaxNumber";
            this.lblTaxNumber.Size = new System.Drawing.Size(152, 24);
            this.lblTaxNumber.TabIndex = 70;
            this.lblTaxNumber.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // uwgOrg
            // 
            this.uwgOrg.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.uwgOrg.Cursor = System.Windows.Forms.Cursors.Hand;
            this.uwgOrg.Font = new System.Drawing.Font("Arial", 8F);
            this.uwgOrg.Location = new System.Drawing.Point(11, 844);
            this.uwgOrg.Name = "uwgOrg";
            this.uwgOrg.RowUpdateCancelAction = Infragistics.Win.UltraWinGrid.RowUpdateCancelAction.RetainDataAndActivation;
            this.uwgOrg.Size = new System.Drawing.Size(1258, 116);
            this.uwgOrg.TabIndex = 13;
            this.uwgOrg.ClickCellButton += new Infragistics.Win.UltraWinGrid.CellEventHandler(this.uwgOrg_ClickCellButton_1);
            this.uwgOrg.MouseDown += new System.Windows.Forms.MouseEventHandler(this.uwgOrg_MouseDown_1);
            this.uwgOrg.Click += new System.EventHandler(this.uwgOrg_Click);
            this.uwgOrg.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(this.uwgOrg_InitializeLayout_1);
            // 
            // uwgOrganization
            // 
            appearance25.BackColor = System.Drawing.SystemColors.Window;
            appearance25.BorderColor = System.Drawing.SystemColors.InactiveCaption;
            this.uwgOrganization.DisplayLayout.Appearance = appearance25;
            this.uwgOrganization.DisplayLayout.BorderStyle = Infragistics.Win.UIElementBorderStyle.Solid;
            this.uwgOrganization.DisplayLayout.CaptionVisible = Infragistics.Win.DefaultableBoolean.False;
            appearance26.BackColor = System.Drawing.SystemColors.ActiveBorder;
            appearance26.BackColor2 = System.Drawing.SystemColors.ControlDark;
            appearance26.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical;
            appearance26.BorderColor = System.Drawing.SystemColors.Window;
            this.uwgOrganization.DisplayLayout.GroupByBox.Appearance = appearance26;
            appearance27.ForeColor = System.Drawing.SystemColors.GrayText;
            this.uwgOrganization.DisplayLayout.GroupByBox.BandLabelAppearance = appearance27;
            this.uwgOrganization.DisplayLayout.GroupByBox.BorderStyle = Infragistics.Win.UIElementBorderStyle.Solid;
            appearance28.BackColor = System.Drawing.SystemColors.ControlLightLight;
            appearance28.BackColor2 = System.Drawing.SystemColors.Control;
            appearance28.BackGradientStyle = Infragistics.Win.GradientStyle.Horizontal;
            appearance28.ForeColor = System.Drawing.SystemColors.GrayText;
            this.uwgOrganization.DisplayLayout.GroupByBox.PromptAppearance = appearance28;
            this.uwgOrganization.DisplayLayout.MaxColScrollRegions = 1;
            this.uwgOrganization.DisplayLayout.MaxRowScrollRegions = 1;
            appearance29.BackColor = System.Drawing.SystemColors.Window;
            appearance29.ForeColor = System.Drawing.SystemColors.ControlText;
            this.uwgOrganization.DisplayLayout.Override.ActiveCellAppearance = appearance29;
            appearance30.BackColor = System.Drawing.SystemColors.Highlight;
            appearance30.ForeColor = System.Drawing.SystemColors.HighlightText;
            this.uwgOrganization.DisplayLayout.Override.ActiveRowAppearance = appearance30;
            this.uwgOrganization.DisplayLayout.Override.BorderStyleCell = Infragistics.Win.UIElementBorderStyle.Dotted;
            this.uwgOrganization.DisplayLayout.Override.BorderStyleRow = Infragistics.Win.UIElementBorderStyle.Dotted;
            appearance31.BackColor = System.Drawing.SystemColors.Window;
            this.uwgOrganization.DisplayLayout.Override.CardAreaAppearance = appearance31;
            appearance32.BorderColor = System.Drawing.Color.Silver;
            appearance32.TextTrimming = Infragistics.Win.TextTrimming.EllipsisCharacter;
            this.uwgOrganization.DisplayLayout.Override.CellAppearance = appearance32;
            this.uwgOrganization.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.EditAndSelectText;
            this.uwgOrganization.DisplayLayout.Override.CellPadding = 0;
            appearance33.BackColor = System.Drawing.SystemColors.Control;
            appearance33.BackColor2 = System.Drawing.SystemColors.ControlDark;
            appearance33.BackGradientAlignment = Infragistics.Win.GradientAlignment.Element;
            appearance33.BackGradientStyle = Infragistics.Win.GradientStyle.Horizontal;
            appearance33.BorderColor = System.Drawing.SystemColors.Window;
            this.uwgOrganization.DisplayLayout.Override.GroupByRowAppearance = appearance33;
            appearance34.TextHAlignAsString = "Left";
            this.uwgOrganization.DisplayLayout.Override.HeaderAppearance = appearance34;
            this.uwgOrganization.DisplayLayout.Override.HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction.SortMulti;
            this.uwgOrganization.DisplayLayout.Override.HeaderStyle = Infragistics.Win.HeaderStyle.WindowsXPCommand;
            appearance35.BackColor = System.Drawing.SystemColors.Window;
            appearance35.BorderColor = System.Drawing.Color.Silver;
            this.uwgOrganization.DisplayLayout.Override.RowAppearance = appearance35;
            this.uwgOrganization.DisplayLayout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.False;
            appearance36.BackColor = System.Drawing.SystemColors.ControlLight;
            this.uwgOrganization.DisplayLayout.Override.TemplateAddRowAppearance = appearance36;
            this.uwgOrganization.DisplayLayout.ScrollBounds = Infragistics.Win.UltraWinGrid.ScrollBounds.ScrollToFill;
            this.uwgOrganization.DisplayLayout.ScrollStyle = Infragistics.Win.UltraWinGrid.ScrollStyle.Immediate;
            this.uwgOrganization.DisplayLayout.ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand.OutlookGroupBy;
            this.uwgOrganization.Location = new System.Drawing.Point(3, 720);
            this.uwgOrganization.Name = "uwgOrganization";
            this.uwgOrganization.Size = new System.Drawing.Size(550, 118);
            this.uwgOrganization.TabIndex = 14;
            this.uwgOrganization.Text = "ultraGrid1";
            this.uwgOrganization.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(this.uwgOrganization_InitializeLayout);
            // 
            // uwgContacts
            // 
            appearance13.BackColor = System.Drawing.SystemColors.Window;
            appearance13.BorderColor = System.Drawing.SystemColors.InactiveCaption;
            this.uwgContacts.DisplayLayout.Appearance = appearance13;
            this.uwgContacts.DisplayLayout.BorderStyle = Infragistics.Win.UIElementBorderStyle.Solid;
            this.uwgContacts.DisplayLayout.CaptionVisible = Infragistics.Win.DefaultableBoolean.False;
            appearance14.BackColor = System.Drawing.SystemColors.ActiveBorder;
            appearance14.BackColor2 = System.Drawing.SystemColors.ControlDark;
            appearance14.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical;
            appearance14.BorderColor = System.Drawing.SystemColors.Window;
            this.uwgContacts.DisplayLayout.GroupByBox.Appearance = appearance14;
            appearance15.ForeColor = System.Drawing.SystemColors.GrayText;
            this.uwgContacts.DisplayLayout.GroupByBox.BandLabelAppearance = appearance15;
            this.uwgContacts.DisplayLayout.GroupByBox.BorderStyle = Infragistics.Win.UIElementBorderStyle.Solid;
            appearance16.BackColor = System.Drawing.SystemColors.ControlLightLight;
            appearance16.BackColor2 = System.Drawing.SystemColors.Control;
            appearance16.BackGradientStyle = Infragistics.Win.GradientStyle.Horizontal;
            appearance16.ForeColor = System.Drawing.SystemColors.GrayText;
            this.uwgContacts.DisplayLayout.GroupByBox.PromptAppearance = appearance16;
            this.uwgContacts.DisplayLayout.MaxColScrollRegions = 1;
            this.uwgContacts.DisplayLayout.MaxRowScrollRegions = 1;
            appearance17.BackColor = System.Drawing.SystemColors.Window;
            appearance17.ForeColor = System.Drawing.SystemColors.ControlText;
            this.uwgContacts.DisplayLayout.Override.ActiveCellAppearance = appearance17;
            appearance18.BackColor = System.Drawing.SystemColors.Highlight;
            appearance18.ForeColor = System.Drawing.SystemColors.HighlightText;
            this.uwgContacts.DisplayLayout.Override.ActiveRowAppearance = appearance18;
            this.uwgContacts.DisplayLayout.Override.BorderStyleCell = Infragistics.Win.UIElementBorderStyle.Dotted;
            this.uwgContacts.DisplayLayout.Override.BorderStyleRow = Infragistics.Win.UIElementBorderStyle.Dotted;
            appearance19.BackColor = System.Drawing.SystemColors.Window;
            this.uwgContacts.DisplayLayout.Override.CardAreaAppearance = appearance19;
            appearance20.BorderColor = System.Drawing.Color.Silver;
            appearance20.TextTrimming = Infragistics.Win.TextTrimming.EllipsisCharacter;
            this.uwgContacts.DisplayLayout.Override.CellAppearance = appearance20;
            this.uwgContacts.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.EditAndSelectText;
            this.uwgContacts.DisplayLayout.Override.CellPadding = 0;
            appearance21.BackColor = System.Drawing.SystemColors.Control;
            appearance21.BackColor2 = System.Drawing.SystemColors.ControlDark;
            appearance21.BackGradientAlignment = Infragistics.Win.GradientAlignment.Element;
            appearance21.BackGradientStyle = Infragistics.Win.GradientStyle.Horizontal;
            appearance21.BorderColor = System.Drawing.SystemColors.Window;
            this.uwgContacts.DisplayLayout.Override.GroupByRowAppearance = appearance21;
            appearance22.TextHAlignAsString = "Left";
            this.uwgContacts.DisplayLayout.Override.HeaderAppearance = appearance22;
            this.uwgContacts.DisplayLayout.Override.HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction.SortMulti;
            this.uwgContacts.DisplayLayout.Override.HeaderStyle = Infragistics.Win.HeaderStyle.WindowsXPCommand;
            appearance23.BackColor = System.Drawing.SystemColors.Window;
            appearance23.BorderColor = System.Drawing.Color.Silver;
            this.uwgContacts.DisplayLayout.Override.RowAppearance = appearance23;
            this.uwgContacts.DisplayLayout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.False;
            appearance24.BackColor = System.Drawing.SystemColors.ControlLight;
            this.uwgContacts.DisplayLayout.Override.TemplateAddRowAppearance = appearance24;
            this.uwgContacts.DisplayLayout.ScrollBounds = Infragistics.Win.UltraWinGrid.ScrollBounds.ScrollToFill;
            this.uwgContacts.DisplayLayout.ScrollStyle = Infragistics.Win.UltraWinGrid.ScrollStyle.Immediate;
            this.uwgContacts.DisplayLayout.ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand.OutlookGroupBy;
            this.uwgContacts.Location = new System.Drawing.Point(610, 720);
            this.uwgContacts.Name = "uwgContacts";
            this.uwgContacts.Size = new System.Drawing.Size(550, 118);
            this.uwgContacts.TabIndex = 15;
            this.uwgContacts.Text = "ultraGrid1";
            this.uwgContacts.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(this.uwgContacts_InitializeLayout);
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(860, 89);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 23);
            this.button1.TabIndex = 2;
            this.button1.Text = "button1";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // MasterDetailControl
            // 
            this.Controls.Add(this.uwgContacts);
            this.Controls.Add(this.uwgOrganization);
            this.Controls.Add(this.uwgOrg);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.splitter2);
            this.Controls.Add(this.dgContacts);
            this.Name = "MasterDetailControl";
            this.Size = new System.Drawing.Size(1280, 1024);
            this.Enter += new System.EventHandler(this.MasterDetailControl_Enter);
            ((System.ComponentModel.ISupportInitialize)(this.dgContacts)).EndInit();
            this.panel1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.uwgOrg)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.uwgOrganization)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.uwgContacts)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		protected void MasterDetail_Load(object sender, System.EventArgs e)
		{
			//Sets the table name used to map to the ProjectContacts DataGrid TableStyle
			//Default is "ContactList" set in the class fields;
			if(IsProjectView) 
			{
				this.tableName = "ProjectContacts";
				this.dgContacts.Height = 200;
				//Sets "Remove" button in first column
				SetRemoveButtonColumn();
				
			}
			else if(IsAddExistingMode || IsAddFundingPartnerMode)
			{
				SetAddButtonColumn();
			}
		
			dgContacts.CaptionText = "Click left border to select contact. Right mouse click for options";
			SetContextMenu();
			LoadContacts();
            LoadOrgContacts();
			SetDetailView();
			SetSelected();
			if(IsProjectView)
			{
				BindingManagerBase manager = this.BindingContext[cds, "ProjectContacts"];
				manager.PositionChanged += new EventHandler(SetContactTypes);
			}
		}
		
		//Handle the "Remove" button displayed in ProjectView of the contact grid.
		private void HandleRemoveButtonClick(object sender, DataGridButton.DataGridCellButtonClickEventArgs e)
		{
			miRemove_Click(sender, EventArgs.Empty);
		}

        //Added by Gatika
        //Handle the "Remove" button for organization displayed in ProjectView of the contact grid.
        private void HandleRemoveOrgButtonClick(object sender, DataGridButton.DataGridCellButtonClickEventArgs e)
        {
            //miRemove_Click(sender, EventArgs.Empty);
            RemoveOrg();
        }

		private void HandleAddButtonClick(object sender, DataGridButton.DataGridCellButtonClickEventArgs e)
		{
			if(IsAddFundingPartnerMode)
			{
				this.ParentForm.DialogResult = DialogResult.OK;
				this.ParentForm.Close();
			}
			else
			{
				if(ContactData.ContactIsAssociated(this.SelectedContact, this.ProjectId))
				{
					MessageBox.Show("The contact you selected is already associated with this project!");
					return;
				}

				CCPM.Contact.AssociateContact associate = new AssociateContact(this.SelectedContact, this.ProjectId);
				DialogResult dialogResult = associate.ShowDialog(this);
				if(dialogResult == DialogResult.Abort)
				{
					this.ParentForm.Close();
				}
			}
		}

		
		#region Context Menu Events

		#region Project Specific Context Menu Events
		//Launches Master Contact List.
		public void miAddExisting_Click(object sender, EventArgs e)
		{
            Form1 fm = (Form1)((this.ParentForm).MdiParent);
            LinkOrg lo = new LinkOrg(0);
            lo.MdiParent = fm;
            //this.Dispose();

            fm.OpenForm(lo, "Link Organization");

            //CCPM.Contact.MasterDetail md = new CCPM.Contact.MasterDetail();
            //md.Text = "Add Existing Contact to Project";

            //MasterDetailControl mdc = md._MasterDetailControl;
            //mdc.IsAddExistingMode = true;
            //mdc.ProjectId = this.ProjectId;
            //md.ShowDialog(this);
            ////Refresh the project contact view to include any new contacts
            //this.LoadContacts();
            //this.ContactId = mdc.SelectedContact;
            //this.SetSelected();
		}

		//Create a new contact and associate it with the current project
		public void miAddNew_Click(object sender, EventArgs e)
		{
			CCPM.Project.ProjectForm projectForm = (CCPM.Project.ProjectForm)this.ParentForm;
			CCPM.Contact.ContactCreateOrUpdate contactCreateOrUpdate = new CCPM.Contact.ContactCreateOrUpdate();
			contactCreateOrUpdate.Location = new Point(0,0);
			contactCreateOrUpdate.ProjectId = projectForm.ProjectId;
			contactCreateOrUpdate.ProjectName = projectForm.ProjectName;

			DialogResult dr = contactCreateOrUpdate.ShowDialog();
			if(dr == DialogResult.OK)
			{
				projectForm.GetMasterDetailControl.ContactId = contactCreateOrUpdate.ContactId;
				projectForm.RefreshContacts();
			}
		}

		public void miEdit_Click(object sender, EventArgs e)
		{
			//If there are no contacts listed then return.
			if(this.dgContacts.CurrentRowIndex == -1) return;

            DialogResult intRslt = MessageBox.Show("BE CAREFUL about making changes! Any changes to this organization will affect all other project linked to it.\nIf you want to designate a new branch address for this organization, cancel and select the\nLink Organization to this Project button and follow the instructions. ",
                            "Edit Organization Warning", MessageBoxButtons.OKCancel);
            if (intRslt == DialogResult.OK)
            {
                NewOrganization no = new NewOrganization(OrgID, "update","project");
                Form1 fm = (Form1)((this.ParentForm).MdiParent);
                fm.OpenForm(no, "Edit Organization");

            }

            //// MAR 2005-08-19 - added confirmation message on Edit
            //DialogResult intDiagResult = MessageBox.Show("BE CAREFUL about making changes!  Any changes made to this contact will affect every other project linked to this contact. If you want to enter a new contact from the same organization, use the Clone Contact command. Do you wish to Edit now?","Edit Contact", 
            //    MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
            //if(intDiagResult == DialogResult.Yes) 
            //{

            //    ContactCreateOrUpdate updateForm = new ContactCreateOrUpdate();
            //    updateForm.ProjectId = this.ProjectId;
            //    updateForm.ContactId = this.SelectedContact;
            //    updateForm.ProjectName = ((CCPM.Project.ProjectForm)this.ParentForm).ProjectName;
            //    updateForm.IsUpdateMode = true;
            //    updateForm.Text = "Update Contact";
            //    DialogResult dialogResult = updateForm.ShowDialog(this);
            //    if(dialogResult == DialogResult.OK)
            //    {
            //        this.LoadContacts();
            //        this.ContactId = updateForm.ContactId;
            //        this.SetSelected();
            //    }
            //}

		}

		public void miRemove_Click(object sender, EventArgs e)
		{
            
            int recordId = 0;
            //cds = null;
            if (this.dgContacts.CurrentRowIndex == -1) return;
            BindingManagerBase manager = this.BindingContext[cds, tableName];
            DataRowView drv = (DataRowView)manager.Current;
            if (drv["CID"].ToString() != string.Empty)
            {
                recordId = (int)drv["CID"];

                //return contactId;

                DialogResult dr = MessageBox.Show(
                    "You are about to remove a contact from this project!\n The organization information will remain. This will not affect the \n master contact list nor any other projects linked to this contact?",
                    "Remove Contact Confirmation",
                    MessageBoxButtons.OKCancel,
                    MessageBoxIcon.Exclamation);
                if (dr == DialogResult.OK)
                {
                    ContactData.ContactRemove(this.ProjectId, recordId);
                    LoadContacts();

                }
            }
		}

        public void miRemove1_Click(object sender, EventArgs e)
        {

            RemoveOrg();
        }

        public void RemoveOrg()
        {
            //MessageBox.Show(sender.ToString());
            int recordId;
            //cds = null;
            if (this.dgContacts.CurrentRowIndex == -1) return;

            BindingManagerBase manager = this.BindingContext[cds, tableName];
            DataRowView drv = (DataRowView)manager.Current;
            recordId = (int)drv["RecordId"];
            DialogResult dr = MessageBox.Show(
                "You are about to remove the selected organization and any associated contact information from this project!\n This will not affect the master organization or contact lists nor any other projects linked to this organization?",
                "Remove Contact Confirmation",
                MessageBoxButtons.OKCancel,
                MessageBoxIcon.Exclamation);
            if (dr == DialogResult.OK)
            {
                ContactData.OrgContactRemove(this.ProjectId,recordId);
                LoadContacts();
            }
        }

		#endregion	
		
		#region Master Contact List Specific Events
		public void miMasterAddNew_Click(object sender, EventArgs e)
		{
			CCPM.Contact.ContactCreateOrUpdate contactCreateOrUpdate = new CCPM.Contact.ContactCreateOrUpdate();
			contactCreateOrUpdate.Location = new Point(0,0);
			contactCreateOrUpdate.Text = "Create New Contact on Mast List";

			DialogResult dr = contactCreateOrUpdate.ShowDialog();
			if(dr == DialogResult.OK)
			{
				this.ContactId = contactCreateOrUpdate.ContactId;
				this.LoadContacts();
				this.SetSelected();
			}
		}

		public void miMasterEdit_Click(object sender, EventArgs e)
		{
			// MAR 2005-07-26 - added confirmation message on Edit
			DialogResult intDiagResult = MessageBox.Show("BE CAREFUL about making changes!  Any changes made to this contact will affect every other project linked to this contact. If you want to enter a new contact from the same organization, use the Clone Contact command. Do you wish to Edit now?","Edit Contact", 
				MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
			if(intDiagResult == DialogResult.Yes) 
			{
				CCPM.Contact.ContactCreateOrUpdate ccou = new CCPM.Contact.ContactCreateOrUpdate();
				ccou.ContactId = this.SelectedContact;
				ccou.IsUpdateMode = true;
				ccou.Text = "Edit Contact";
				DialogResult dialogResult = ccou.ShowDialog(this);
				if(dialogResult == DialogResult.OK)
				{
					LoadContacts();
					this.ContactId = ccou.ContactId;
					SetSelected();
				}
			}
		}
		
		public void miDelete_Click(object sender, EventArgs e)
		{
			DataSet dsProjects = ContactData.ContactCanDelete(this.SelectedContact);
			if(dsProjects.Tables[0].Rows.Count < 1)
			{
				DialogResult dr = MessageBox.Show(
					"You are about to delete a contact!\nAre you sure you want to do this?",
					"Delete Contact Confirmation", 
					MessageBoxButtons.OKCancel,
					MessageBoxIcon.Stop);
				if(dr == DialogResult.OK)
				{
					ContactData.ContactDelete(this.SelectedContact);
					this.LoadContacts();
				}
			}
			else
			{
				System.Text.StringBuilder sb = new System.Text.StringBuilder();
				sb.Append("The following projects have a reference to this contact:\n\n");
				foreach(DataRow dr in dsProjects.Tables[0].Rows)
				{
					sb.Append((char)0xB0);//bullet
					sb.Append(" ");//space
					sb.Append(dr["ProjectName"].ToString());
					sb.Append("\n");
				}
				sb.Append("\n");
				sb.Append("Only contacts that are not associated with a project may be deleted.");

				MessageBox.Show(
					sb.ToString(),
					"Contact may not be deleted",
					MessageBoxButtons.OK,
					MessageBoxIcon.Information
					);
			}
		}
		
		#endregion
		//Populate the contact creation form with all the details form 
		//another contact minus the first and last names and email and notes.
		public void miClone_Click(object sender, EventArgs e)
		{
			CCPM.Contact.ContactCreateOrUpdate ccou = new CCPM.Contact.ContactCreateOrUpdate();
			ccou.ContactId = this.SelectedContact;
			ccou.IsCloneMode = true;
			ccou.Text = "Clone Contact";
			//If we are in project view then supply the project Id to the clone form.
			CCPM.Project.ProjectForm projectForm = this.ParentForm as CCPM.Project.ProjectForm;
			if(projectForm != null)
			{
				ccou.ProjectId = projectForm.ProjectId;
				ccou.ProjectName = projectForm.ProjectName;
			}
			DialogResult dialogResult = ccou.ShowDialog(this);
			if(dialogResult == DialogResult.OK)
			{
				LoadContacts();
				this.ContactId = ccou.ContactId;
				SetSelected();
			}
		}

		public void miClose_Click(object sender, EventArgs e)
		{
			this.ParentForm.Close();
		}

		public void miRefresh_Click(object sender, EventArgs e)
		{
			this.LoadContacts();
		}
		#endregion

		private void dgContacts_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
            BindingManagerBase manager = dgContacts.BindingContext[dgContacts.DataSource, dgContacts.DataMember];
            CurrencyManager cm = (CurrencyManager)manager;
            for (int i = 0; i < cm.List.Count; i++)
            {
                if (((DataRowView)cm.List[i])["ContactLName"].ToString().ToLower().StartsWith(e.KeyChar.ToString().ToLower()))
                {
                    manager.Position = i;
                    dgContacts.Select(i);
                    e.Handled = true;
                    break;
                }
            }
		}

		private void SetContactTypes(object sender, EventArgs e)
		{
            //lblContactType.Visible = true;
            //lblContactTypeText.Visible = true;
            //this.lblContactTypeText.Text = string.Empty;
            //string types = string.Empty;
            //BindingManagerBase manager = this.BindingContext[cds, "ProjectContacts"];
            //DataRowView drv = (DataRowView)manager.Current;
            //DataRow[] dr = drv.Row.GetChildRows("ContactsToContactTypes");
            //foreach(DataRow row in dr)
            //{
            //    types += ", ";
            //    types += (string)row["ContactType"];
            //}
            //if(types.Length > 2)
            //{
            //    lblContactTypeText.Text = types.Remove(0, 2);
            //}
		}

        private void btnLinkOrg_Click(object sender, EventArgs e)
        {
            Form1 fm = (Form1)((this.ParentForm).MdiParent);
            LinkOrg lo = new LinkOrg(0);
            lo.MdiParent = fm;
            fm.OpenForm(lo, "Link Organization");
        }

        private void btnEditOrg_Click(object sender, EventArgs e)
        {
            
            DialogResult intRslt = MessageBox.Show("BE CAREFUL about making changes! Any changes to this organization will affect all other project linked to it.\nIf you want to designate a new branch address for this organization, cancel and select the\nLink Organization to this Project button and follow the instructions. ",
                            "Edit Organization Warning", MessageBoxButtons.OKCancel);
            if (intRslt == DialogResult.OK)
            {
                NewOrganization no = new NewOrganization(OrgID,"update","project");
                Form1 fm = (Form1)((this.ParentForm).MdiParent);
                fm.OpenForm(no, "Edit Organization");

            }
        }

        private void btnLinkContact_Click(object sender, EventArgs e)
        {
            LinkContact lc = new LinkContact(OrgID,"project");
            Form1 fm = (Form1)((this.ParentForm).MdiParent);
            fm.OpenForm(lc, "Link Contact");
        }

        private void btnEditContact_Click(object sender, EventArgs e)
        {
            int contactId;
            contactId = projectContactId;
            DialogResult intRslt = MessageBox.Show("BE CAREFUL about making changes! Any changes to this contact will affect all other project linked to it.\nIf you want to replace this contact with another, cancel out this dialog, \n remove the contact and then add a new contact via the Link Contact button. ",
                            "Edit Contact Warning", MessageBoxButtons.OKCancel);
            if (intRslt == DialogResult.OK)
            {
                CreateContact cc = new CreateContact(contactId,"update", 0,"project");
                cc.Text = "Edit Contact";
                Form1 fm = (Form1)((this.ParentForm).MdiParent);
                fm.OpenForm(cc, "Edit Contact");

            }
        }

        private void MasterDetailControl_Enter(object sender, EventArgs e)
        {
            this.LoadContacts();
        }

        private void dgContacts_Click(object sender, EventArgs e)
        {
            SetSelected();
            //return;
        }

        private void uwgOrg_InitializeLayout_1(object sender, InitializeLayoutEventArgs e)
        {

            e.Layout.Bands[0].Columns[0].Hidden = true;
            e.Layout.Bands[0].Columns[1].Hidden = true;
            e.Layout.Bands[0].Columns[2].Hidden = true;
            e.Layout.Bands[0].Columns[3].Hidden = true;
            e.Layout.Bands[0].Columns[4].Hidden = true;
            e.Layout.Bands[0].Columns[5].Hidden = true;
            e.Layout.Bands[0].Columns[6].Hidden = true;
            e.Layout.Bands[0].Columns[7].Hidden = true;
            e.Layout.Bands[0].Columns[8].Hidden = true;
            e.Layout.Bands[0].Columns[9].Hidden = true;
            e.Layout.Bands[0].Columns[10].Hidden = true;
            e.Layout.Bands[0].Columns[11].Hidden = true;
            e.Layout.Bands[0].Columns[12].Hidden = true;
            e.Layout.Bands[0].Columns[13].Hidden = true;
            e.Layout.Bands[0].Columns[14].Hidden = true;
            e.Layout.Bands[0].Columns[15].Hidden = true;
            e.Layout.Bands[0].Columns[16].Hidden = true;
            e.Layout.Bands[0].Columns[17].Hidden = true;
            e.Layout.Bands[0].Columns[18].Hidden = true;
            e.Layout.Bands[0].Columns[19].Hidden = true;
            e.Layout.Bands[0].Columns[20].Hidden = true;
            e.Layout.Bands[0].Columns[21].Hidden = true;
            e.Layout.Bands[0].Columns[22].Hidden = true;
            e.Layout.Bands[0].Columns[23].Hidden = true;
            e.Layout.Bands[0].Columns[24].Hidden = true;
            e.Layout.Bands[0].Columns[25].Hidden = true;
            e.Layout.Bands[0].Columns[26].Hidden = true;
            e.Layout.Bands[0].Columns[27].Hidden = true;

            e.Layout.Bands[0].Columns[28].Width = 80;
            e.Layout.Bands[0].Columns[28].Header.Caption = "Remove Organization";
            e.Layout.Bands[0].Columns[28].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns[28].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            e.Layout.Bands[0].Columns[29].Width = 200;
            e.Layout.Bands[0].Columns[29].Header.Caption = "Organization";
            e.Layout.Bands[0].Columns[29].CellActivation = Infragistics.Win.UltraWinGrid.Activation.ActivateOnly;

            e.Layout.Bands[0].Columns[30].Width = 150;
            e.Layout.Bands[0].Columns[30].Header.Caption = "Organization Type";
            e.Layout.Bands[0].Columns[30].CellActivation = Infragistics.Win.UltraWinGrid.Activation.ActivateOnly;

            e.Layout.Bands[0].Columns[31].Width = 80;
            e.Layout.Bands[0].Columns[31].Header.Caption = "Remove Contact";
            e.Layout.Bands[0].Columns[31].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns[31].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            e.Layout.Bands[0].Columns[32].Width = 150;
            e.Layout.Bands[0].Columns[32].Header.Caption = "Full Name";
            e.Layout.Bands[0].Columns[32].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[33].Width = 130;
            e.Layout.Bands[0].Columns[33].Header.Caption = "Job Title";
            e.Layout.Bands[0].Columns[33].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[34].Width = 80;
            e.Layout.Bands[0].Columns[34].Header.Caption = "Contact Phone";
            e.Layout.Bands[0].Columns[34].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[35].Width = 80;
            e.Layout.Bands[0].Columns[35].Header.Caption = "Contact Cell Phone";
            e.Layout.Bands[0].Columns[35].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[36].Width = 80;
            e.Layout.Bands[0].Columns[36].Header.Caption = "Contact Fax";
            e.Layout.Bands[0].Columns[36].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[37].Width = 100;
            e.Layout.Bands[0].Columns[37].Header.Caption = "Contact Email";
            e.Layout.Bands[0].Columns[37].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[38].Hidden = true;
            //e.Layout.Bands[0].Columns[39].Hidden = true;

        }

        private void uwgOrg_ClickCellButton_1(object sender, CellEventArgs e)
        {
            if (uwgOrg.ActiveRow.Cells[28].HasSelectedAppearance == true)
            {
                MessageBox.Show("hello");
            }
        }

        private void uwgOrg_MouseDown_1(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                Point mousePoint = new Point(e.X, e.Y);
                UIElement element = ((UltraGrid)sender).DisplayLayout.UIElement.ElementFromPoint(mousePoint);

                contextMenu1.Show(uwgOrg, mousePoint);
            }
        }

        private void uwgOrg_Click(object sender, EventArgs e)
        {
            
        }

        private void uwgOrganization_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Width = 80;
            e.Layout.Bands[0].Columns[0].Header.Caption = "Remove Organization";
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns[0].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            e.Layout.Bands[0].Columns[1].Width = 200;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Organization";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.ActivateOnly;

            e.Layout.Bands[0].Columns[2].Width = 150;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Organization Type";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.ActivateOnly;

            // OrgID
            e.Layout.Bands[0].Columns[3].Hidden = true;

        }

        private void uwgContacts_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Header.Caption = "Remove Contact";
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns[0].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            e.Layout.Bands[0].Columns[1].Width = 150;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Full Name";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[2].Width = 130;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Job Title";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[3].Width = 80;
            e.Layout.Bands[0].Columns[3].Header.Caption = "Contact Phone";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[4].Width = 80;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Contact Cell Phone";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[5].Width = 80;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Contact Fax";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[6].Width = 100;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Contact Email";
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            //ContactId
            e.Layout.Bands[0].Columns[7].Hidden = true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            MasterContacts mc = new MasterContacts();
            mc.Show();
        }
      

       
	}

}
