﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CCPM.Data;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Contact
{
    public partial class NewOrganization : Form
    {
        //private System.Windows.Forms.ContextMenu contextMenu1;
        public Form callingForm;
        bool blnDataDirty = false;
        int OrgID = 0; string Action = ""; string Type = ""; int OrgAddressID = 0;
        private bool isProjectView = false;
        public bool IsProjectView
        {
            get { return isProjectView; }
            set { isProjectView = value; }
        }
        public NewOrganization(int OrgId, string action, string type)
        {
            InitializeComponent();
            Action = action;
            OrgID = OrgId;
            Type = type;
            loadOrgType();
            cmbOrgType.SelectedIndex = -1;
            if (OrgId != 0)
            {
                this.Text = "Create New Address for Existing Organization";
                loadData();
                //txtOrganization.ReadOnly = true;
                //txtDept.ReadOnly = true;
                //txtStreet.ReadOnly = true;
                //txtCity.ReadOnly = true;
                //txtState.ReadOnly = true;
                //txtZip.ReadOnly = true;
                //txtPhone.ReadOnly = true;
                //txtFax.ReadOnly = true;
                if (Action == "address")
                {
                    txtOrganization.ReadOnly = true;
                    txtDept.Text = "";
                    txtStreet.Text = "";
                    txtCity.Text = "";
                    txtState.Text = "";
                    txtZip.Text = "";
                    txtPhone.Text = "";
                    txtFax.Text = "";
                    txtNotes.Text = "";


                }
                else if (Action == "update")
                {
                    showOrgAddressesAndContacts();
                    setControlsOrgAddressAndContacts();
                }
            }
            else
            {
                txtOrganization.ReadOnly = false;
            }     
     
        }

        public NewOrganization(string action, string type, int OrgAddressId, int OrgId)
        {
            InitializeComponent();
            Action = action;
            OrgID = OrgId;
            OrgAddressID = OrgAddressId;
            Type = type;
            loadOrgType();
            cmbOrgType.SelectedIndex = -1;
            //if (OrgAddressId != 0)
            //{
            if (Action == "update")
            {
                this.Text = "Edit OrgAddress for Existing Organization";
                loadAddressData();
            }
            else
            {
                this.Text = "Add New OrgAddress for Existing Organization";
                loadData();

            }
                
                //loadAddressData();
                txtOrganization.ReadOnly = true;
                if (Action == "address")
                {
                    txtDept.Text = "";
                    txtStreet.Text = "";
                    txtCity.Text = "";
                    txtState.Text = "";
                    txtZip.Text = "";
                    txtPhone.Text = "";
                    txtFax.Text = "";
                    txtNotes.Text = "";
                }
            //}
            //else
            //{
            //    txtOrganization.ReadOnly = false;
            //}          
        }

        private void showOrgAddressesAndContacts()
        {
            panel1.Visible = true;
            panel2.Visible = true;
            groupBox1.Height = 740;
            btnSave.Top = groupBox1.Height - 50;
            btnCancel.Top = btnSave.Top;
            this.FindForm().Height = 760;
            this.FindForm().AutoScroll = true;
        }

        private void setControlsOrgAddressAndContacts()
        {
            uwgContacts.DisplayLayout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            uwgOrgAddress.DisplayLayout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            LoadContacts();
            LoadOrgAddress();

        }

        private void loadOrgType()
        {
            DataSet dsOrgType = ContactData.GetOrganizationType();
            cmbOrgType.DataSource = null;
            cmbOrgType.DataSource = dsOrgType.Tables[0];
            cmbOrgType.DisplayMember = "OrganizationType";
            cmbOrgType.ValueMember = "OrganizationTypeId";
            
        }

        public void loadData()
        {
            if (Type == "project")
            {
                DataSet ds = ContactData.GetOrganizationData(OrgID);
                if (ds.Tables[0].Rows.Count == 0)
                {
                    ds = ContactData.GetOrganizationAdminData(OrgID);
                }
                if (ds.Tables[0].Rows.Count > 0)
                {
                    DataRow dr = ds.Tables[0].Rows[0];
                    txtOrganization.Text = dr["Organization"].ToString();
                    txtDept.Text = dr["DepartmentOffice"].ToString();
                    txtStreet.Text = dr["Address"].ToString();
                    txtCity.Text = dr["City"].ToString();
                    txtState.Text = dr["State"].ToString();
                    txtZip.Text = dr["Zip"].ToString();
                    txtPhone.Text = dr["GeneralPhone"].ToString();
                    txtFax.Text = dr["GeneralFax"].ToString();
                    txtNotes.Text = dr["OrgNotes"].ToString();
                    cmbOrgType.Text = dr["OrganizationType"].ToString();
                    txtTaxIdNumber.Text = dr["TaxID"].ToString();
                    chkSmallBus.Checked = Convert.ToBoolean(dr["SBE"]);
                    chkDisableBus.Checked = Convert.ToBoolean(dr["DVBE"]);
                    txtCertNumber.Text = dr["CertificationNumber"].ToString();
                    OrgAddressID = Convert.ToInt32(dr["OrgAddressID"]);
                }
            }
            else if (Type == "admin")
            {
                DataSet ds = ContactData.GetOrganizationAdminData(OrgID);
                if (ds.Tables[0].Rows.Count > 0)
                {
                    DataRow dr = ds.Tables[0].Rows[0];
                    txtOrganization.Text = dr["Organization"].ToString();
                    txtDept.Text = dr["DepartmentOffice"].ToString();
                    txtStreet.Text = dr["Address"].ToString();
                    txtCity.Text = dr["City"].ToString();
                    txtState.Text = dr["State"].ToString();
                    txtZip.Text = dr["Zip"].ToString();
                    txtPhone.Text = dr["GeneralPhone"].ToString();
                    txtFax.Text = dr["GeneralFax"].ToString();
                    txtNotes.Text = dr["OrgNotes"].ToString();
                    cmbOrgType.Text = dr["OrganizationType"].ToString();
                    txtTaxIdNumber.Text = dr["TaxID"].ToString();
                    chkSmallBus.Checked = Convert.ToBoolean(dr["SBE"]);
                    chkDisableBus.Checked = Convert.ToBoolean(dr["DVBE"]);
                    txtCertNumber.Text = dr["CertificationNumber"].ToString();
                    OrgAddressID = Convert.ToInt32(dr["OrgAddressID"]);
                }
            }
        }

        public void loadAddressData()
        {
            DataSet ds = ContactData.GetOrganizationAddress(OrgAddressID);
            if (ds.Tables[0].Rows.Count > 0)
            {
                DataRow dr = ds.Tables[0].Rows[0];
                txtOrganization.Text = dr["Organization"].ToString();
                txtDept.Text = dr["DepartmentOffice"].ToString();
                txtStreet.Text = dr["Address"].ToString();
                txtCity.Text = dr["City"].ToString();
                txtState.Text = dr["State"].ToString();
                txtZip.Text = dr["Zip"].ToString();
                txtPhone.Text = dr["GeneralPhone"].ToString();
                txtFax.Text = dr["GeneralFax"].ToString();
                txtNotes.Text = dr["OrgNotes"].ToString();
                cmbOrgType.Text = dr["OrganizationType"].ToString();
                txtTaxIdNumber.Text = dr["TaxID"].ToString();
                chkSmallBus.Checked = Convert.ToBoolean(dr["SBE"]);
                chkDisableBus.Checked = Convert.ToBoolean(dr["DVBE"]);
                txtCertNumber.Text = dr["CertificationNumber"].ToString();
            }
        }

        public void LoadContacts()
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;

            btnEditContact.Enabled = true;
            DataSet cds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "Select 'Remove Contact' as Button, ContactLName + ',  ' + ContactFName as FullName, ContactJobTitle, ContactPhone, ContactExtension, ContactCellPhone, ContactFax, ContactEmail, ContactID, oa.Address + ' ' + oa.City + ' ' + oa.State + ' ' + oa.Zip from Contact LEFT OUTER JOIN OrgAddress oa ON Contact.OrgAddressID = oa.OrgAddressID Where Contact.OrgID = " + OrgID + " order by ContactLName, ContactFName");
            uwgContacts.DataSource = cds;
            uwgContacts.DataBind();

            if (uwgContacts.Rows.Count < 1)
            {
                btnEditContact.Enabled = false;
                btnContactRemove.Enabled = false;
            }
            else
            {
                uwgContacts.Rows[0].Selected = true;
                btnEditContact.Enabled = true;
                btnContactRemove.Enabled = true;
            }        
        }

        public void LoadOrgAddress()
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;

            DataSet cds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "Select 'Remove Org Address' as Button, DepartmentOffice, Address, City, State, Zip, GeneralPhone, GeneralFax, OrgAddressID, 0 AS DirtyFlag from OrgAddress Where OrgID = " + OrgID);
            uwgOrgAddress.DataSource = cds;
            uwgOrgAddress.DataBind();

            if (uwgOrgAddress.Rows.Count < 1)
            {
                btnAddressRemove.Enabled = false;
                btnEditOrgAddress.Enabled = false;
            }
            else
            {
                uwgOrgAddress.Rows[0].Selected = true;
                btnAddressRemove.Enabled = true;
                btnEditOrgAddress.Enabled = true;
            }
        }


        private string ProjectRoles(string orgname)
        {
            string retVal = "";
            DialogResult dr;
            GridSelect gs = new GridSelect();
            gs.lblTitle.Text = "Select One or More Project Roles";
            gs.Text = "Linking Organization:  " + orgname;
            gs.DataSet(ProjectData.GetProjectRoles());
            gs.ColumnHide(0);
            gs.ColumnWidth(1, 300);
            gs.ColumnName(1, "Project Role");
            dr = gs.ShowDialog();
            if (dr == DialogResult.OK)
                retVal = gs.SelectedKeys(0, false);
            return retVal;
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (txtOrganization.Text == string.Empty)
            {
                MessageBox.Show("Please enter organization name !!", "Data Entry Error", MessageBoxButtons.OK);
                blnDataDirty = true;
            }
            else if (cmbOrgType.Text == string.Empty)
            {
                MessageBox.Show("Please select organization type !!", "Data Entry Error", MessageBoxButtons.OK);
                blnDataDirty = true;
            }

            if (txtTaxIdNumber.Text != string.Empty)
            {
                string patern = @"^(\d{2}-\d{7})";
                if (System.Text.RegularExpressions.Regex.IsMatch(txtTaxIdNumber.Text, patern) == false)
                {
                    MessageBox.Show("Invalid Tax ID Number.  ID must be in 00-0000000 format.", "Data Entry Error", MessageBoxButtons.OK);
                    txtTaxIdNumber.Focus();
                    blnDataDirty = true;
                }
            }

            if (blnDataDirty == false)
            {
                if (Action == "insert")
                {
                    DataSet ds1 = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select Organization from Organization where Organization = '" + txtOrganization.Text.Replace("'","''") + "'");
                    if (ds1.Tables[0].Rows.Count < 1)
                    {

                        string roles = "";

                        if (GlobalSettings.projectId != 0)
                        {
                            roles = ProjectRoles(txtOrganization.Text);
                            if (roles == string.Empty)
                                return;
                        }

                        // Insert new organization
                        int retVal = ContactData.InsertOrganization(txtOrganization.Text, txtDept.Text, txtStreet.Text, txtCity.Text,
                                                        txtState.Text, txtZip.Text, txtPhone.Text, txtFax.Text, txtNotes.Text, Convert.ToInt32(cmbOrgType.SelectedValue),
                                                        txtTaxIdNumber.Text, Convert.ToString(chkSmallBus.Checked), Convert.ToString(chkDisableBus.Checked), txtCertNumber.Text);

                        if (GlobalSettings.projectId != 0)
                        {
                            int orgid = (int)SqlHelper.ExecuteScalar(GlobalSettings.ConnectionString, CommandType.Text, "select max(OrgID) as OrgId from Organization");
                            //DataSet ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select OrgID, OrganizationTypeId from Organization where OrgID = (select max(OrgID) from Organization)");
                            //DataRow dr = ds.Tables[0].Rows[0];
                            //int retVal1 = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "insert into Org_ProjectRole values(" + GlobalSettings.projectId + "," + Convert.ToInt32(dr["OrgID"]) + ", NULL)");
                            ProjectData.OrgProjectRoleInsert(orgid, GlobalSettings.projectId, roles);
                        }

                        if (retVal == -1)
                        {
                            MessageBox.Show("Insert failed ", "Database Error",
                               MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                        else
                        {
                            MessageBox.Show("Data has been saved successfully !!");
                            if (Type == "project")
                            {
                                OpenContact(GlobalSettings.projectId);
                            }
                            else if (Type == "projectfunding")
                            {
                                DataSet ds = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "select OrgID, OrganizationTypeId from Organization where OrgID = (select max(OrgID) from Organization)");
                                DataRow dr = ds.Tables[0].Rows[0];
                                int retVal1 = SqlHelper.ExecuteNonQuery(GlobalSettings.ConnectionString, CommandType.Text, "insert into Org_ProjectRole values(" + GlobalSettings.projectId + "," + Convert.ToInt32(dr["OrgID"]) + ", 2)");
                                retVal = ProjectFundingData.MatchingFundInsert(GlobalSettings.projectId,
                                            Convert.ToInt32(dr["OrgID"]),
                                            0, null, 0);

                                OpenFunding(GlobalSettings.projectId);
                            }

                            refreshCallingForm(sender,e);
                            this.Close();
                        }
                    }
                    else
                    {
                        MessageBox.Show("Organization already exists !! ", "Data Error",
                               MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
                else if(Action == "update")
                {
                    //Update existing organization
                    int retVal = ContactData.UpdateOrganization(OrgID,txtOrganization.Text, txtDept.Text, txtStreet.Text, txtCity.Text,
                                                    txtState.Text, txtZip.Text, txtPhone.Text, txtFax.Text, txtNotes.Text, Convert.ToInt32(cmbOrgType.SelectedValue),
                                                    txtTaxIdNumber.Text, Convert.ToString(chkSmallBus.Checked), Convert.ToString(chkDisableBus.Checked),txtCertNumber.Text,OrgAddressID);
                    if (retVal == -1)
                    {
                        MessageBox.Show("Update failed ", "Database Error",
                           MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    else
                    {
                        MessageBox.Show("Data has been updated successfully !!");
                        if (Type == "project")
                        {
                            OpenContact(GlobalSettings.projectId);
                        }

                        refreshCallingForm(sender,e);
                        this.Close();
                    }
                }
                else if (Action == "address")
                {
                     int retVal = ContactData.InsertOrganizationAddress(OrgID,txtDept.Text, txtStreet.Text, txtCity.Text,
                                                    txtState.Text, txtZip.Text, txtPhone.Text, txtFax.Text, txtNotes.Text);
                     if (retVal == -1)
                     {
                         MessageBox.Show("Insert failed ", "Database Error",
                            MessageBoxButtons.OK, MessageBoxIcon.Error);
                     }
                     else
                     {

                         MessageBox.Show("New Address has been added successfully !!");
                         if (Type == "project")
                         {
                             LinkOrg lo = new LinkOrg(OrgID);
                             Form1 fm = (Form1)this.MdiParent;
                             fm.OpenForm(lo, "Link Organization");
                             this.Close();
                             //OpenContact(GlobalSettings.projectId);
                         }
                         refreshCallingForm(sender,e);

                         this.Close();
                     }
                }
                
            }
            blnDataDirty = false;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            if (Type == "project")
            {
                OpenContact(GlobalSettings.projectId);
            }
            this.Close();
        }

        private void txtPhone_Leave(object sender, EventArgs e)
        {
            if (txtPhone.Text != string.Empty)
            {
                string pattern = "^\\(?(\\d{3})\\)?[- ]?(\\d{3})[- ]?(\\d{4})$"; 
                if (System.Text.RegularExpressions.Regex.IsMatch(txtPhone.Text, pattern) == false)
                {
                    MessageBox.Show("Invalid Phone Number !!", "Data Entry Error", MessageBoxButtons.OK);
                    txtPhone.Focus();
                }
            }
        }

        private void txtDept_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    txtOrganization.Focus();
                }
            }
        }

        private void txtStreet_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    txtDept.Focus();
                }
            }
        }

        private void txtCity_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    txtStreet.Focus();
                }
            }
        }

        private void txtState_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    txtCity.Focus();
                }
            }
        }

        private void txtZip_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    txtState.Focus();
                }
            }
        }

        private void txtPhone_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    txtZip.Focus();
                }
            }
        }

        private void txtFax_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    txtPhone.Focus();
                }
            }
        }

        private void txtNotes_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    txtFax.Focus();
                }
            }
        }

        private void cmbOrgType_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    txtNotes.Focus();
                }
            }
        }

        private void txtTaxIdNumber_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    cmbOrgType.Focus();
                }
            }
        }

        private void chkSmallBus_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    txtTaxIdNumber.Focus();
                }
            }
        }

        private void chkDisableBus_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    chkSmallBus.Focus();
                }
            }
        }

        private void btnSave_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Shift)
            {
                if (e.KeyData == Keys.Tab)
                {
                    chkDisableBus.Focus();
                }
            }
        }

        private void txtFax_Leave(object sender, EventArgs e)
        {
            if (txtFax.Text != string.Empty)
            {
                string pattern = "^\\(?(\\d{3})\\)?[- ]?(\\d{3})[- ]?(\\d{4})$"; 
                if (System.Text.RegularExpressions.Regex.IsMatch(txtFax.Text, pattern) == false)
                {
                    MessageBox.Show("Invalid Fax Number !!", "Data Entry Error", MessageBoxButtons.OK);
                    txtFax.Focus();
                }
            }
        }

        private void txtZip_Leave(object sender, EventArgs e)
        {
            if (txtZip.Text != string.Empty)
            {
                string pattern = @"^(\d{5}-\d{4}|\d{5}|\d{9})$";
                if (System.Text.RegularExpressions.Regex.IsMatch(txtZip.Text, pattern) == false)
                {
                    MessageBox.Show("Invalid Zip Code !!", "Data Entry Error", MessageBoxButtons.OK);
                    txtZip.Focus();
                }
            }
        }

        public void OpenContact(int projectId)
        {
            Form1 mainForm = (Form1)this.MdiParent;
            mainForm.OpenProject(GlobalSettings.projectId, ProjectData.GetProjectName(projectId));

            CCPM.Project.ProjectForm projectForm = null;
            mainForm.GetCurrentProject(out projectForm);
            projectForm.RefreshContacts();
            projectForm.SetTabIndex(1);

        }

        public void OpenFunding(int projectId)
        {
            Form1 mainForm = (Form1)this.MdiParent;
            mainForm.OpenProject(GlobalSettings.projectId, ProjectData.GetProjectName(projectId));

            CCPM.Project.ProjectForm projectForm = null;
            mainForm.GetCurrentProject(out projectForm);
            projectForm.RefreshContacts();
            projectForm.RefreshFundingDisplay();
            projectForm.SetTabIndex(3);

        }

        private void NewOrganization_Load(object sender, EventArgs e)
        {

        }

        private void btnAddAddress_Click(object sender, EventArgs e)
        {
            GlobalSettings.projectId = 0;
            NewOrganization no = new NewOrganization(Convert.ToInt32(OrgID), "address", "admin");
            Form1 fm = (Form1)this.MdiParent;
            fm.OpenForm(no, "Add Address");
            LoadOrgAddress();
            LoadContacts();
        }


        private void saveOrgAddressGrid()
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            for (int i = 0; i < uwgOrgAddress.Rows.Count; i++)
            {
                if (uwgOrgAddress.Rows[i].Cells[9].Value.ToString() == "1")
                {

                    int retVal = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "UPDATE OrgAddress SET DepartmentOffice = '" + uwgOrgAddress.Rows[i].Cells[1].Value.ToString() +
                                                                                                "',Address = '" + uwgOrgAddress.Rows[i].Cells[2].Value.ToString() +
                                                                                              "',GeneralFax = '" + uwgOrgAddress.Rows[i].Cells[7].Value.ToString() +
                                                                                                "' where OrgAddressID = " + Convert.ToInt32(uwgOrgAddress.Rows[i].Cells[8].Value));
                }
            }
            blnDataDirty = false;
            LoadOrgAddress();
            LoadContacts();
        }

        private void btnEditOrgAddress_Click(object sender, EventArgs e)
        {
            DialogResult intRslt = MessageBox.Show("BE CAREFUL about making changes! Any changes to this org address will affect all other project linked to it.",
                            "Edit Org Address Warning", MessageBoxButtons.OKCancel);
            if (intRslt == DialogResult.OK)
            {
                int OrgAddressId = Convert.ToInt32(uwgOrgAddress.ActiveRow.Cells[8].Value);
                NewOrganization no = new NewOrganization("update", "admin", OrgAddressId, OrgID);
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenForm(no, "Edit Organization Address");
            }

        }

        private void uwgOrgAddress_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Width = 100;
            e.Layout.Bands[0].Columns[0].Header.Caption = "Remove Org Address";
            e.Layout.Bands[0].Columns[0].Hidden = true;
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns[0].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            e.Layout.Bands[0].Columns[1].Width = 190;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Department/Office";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[2].Width = 160;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Street";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[3].Width = 80;
            e.Layout.Bands[0].Columns[3].Header.Caption = "City";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[4].Width = 80;
            e.Layout.Bands[0].Columns[4].Header.Caption = "State";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[5].Width = 80;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Zip";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            //e.Layout.Bands[0].Columns[5].MaskInput = "nnnnn";

            e.Layout.Bands[0].Columns[6].Width = 100;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Phone";
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            //e.Layout.Bands[0].Columns[6].MaskInput = "nnnnnnnnnn";

            e.Layout.Bands[0].Columns[7].Width = 100;
            e.Layout.Bands[0].Columns[7].Header.Caption = "Fax";
            e.Layout.Bands[0].Columns[7].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            //e.Layout.Bands[0].Columns[7].MaskInput = "nnnnnnnnnn";

            //OrgAddressId
            e.Layout.Bands[0].Columns[8].Hidden = true;
            //DirtyFlag
            e.Layout.Bands[0].Columns[9].Hidden = true;
        }

        private void uwgContacts_ClickCellButton(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {

            DialogResult dr = MessageBox.Show(
                    "You are about to remove a contact linked with the selected organization !\n The organization information will remain. ?",
                    "Remove Contact Confirmation",
                    MessageBoxButtons.OKCancel,
                    MessageBoxIcon.Exclamation);
            if (dr == DialogResult.OK)
            {
                DbConnection dbConnection = DbConnection.GetDbConnection();
                string connectionString = dbConnection.DbConnectionString;
                int retVal = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "UPDATE Contact SET OrgID = NULL where ContactID = " + Convert.ToInt32(uwgContacts.ActiveRow.Cells[7].Value));
                LoadContacts();

            }

        }

        private void uwgContacts_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Header.Caption = "Remove Contact";
            e.Layout.Bands[0].Columns[0].Hidden = true;
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns[0].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            e.Layout.Bands[0].Columns[1].Width = 110;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Full Name";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[2].Width = 140;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Job Title";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[3].Width = 100;
            e.Layout.Bands[0].Columns[3].Header.Caption = "Contact Phone";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[4].Width = 60;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Extension";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[5].Width = 100;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Cell Phone";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[6].Width = 100;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Contact Fax";
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[7].Width = 140;
            e.Layout.Bands[0].Columns[7].Header.Caption = "Contact Email";
            e.Layout.Bands[0].Columns[7].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            //ContactId
            e.Layout.Bands[0].Columns[8].Hidden = true;

            e.Layout.Bands[0].Columns[9].Width = 150;
            e.Layout.Bands[0].Columns[9].Header.Caption = "Address";
            e.Layout.Bands[0].Columns[9].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
  
        }

        private void btnEditContact_Click(object sender, EventArgs e)
        {
            DialogResult intRslt = MessageBox.Show("BE CAREFUL about making changes! Any changes to this contact will affect all other project linked to it.",
                            "Edit Contact Warning", MessageBoxButtons.OKCancel);
            if (intRslt == DialogResult.OK)
            {
                CreateContact cc = new CreateContact(Convert.ToInt32(uwgContacts.ActiveRow.Cells["ContactId"].Value), "update", 0, "admin");
                Form1 fm = (Form1)(this.MdiParent);
                fm.OpenForm(cc, "Edit Contact");
            }
        }

        private void btnLinkContact_Click(object sender, EventArgs e)
        {
            LinkContact lc = new LinkContact(Convert.ToInt32(OrgID), "admin");
            Form1 fm = (Form1)(this.MdiParent);
            fm.OpenForm(lc, "Link Contact");
        }

        private void uwgOrgAddress_AfterCellUpdate(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            if (uwgOrgAddress.ActiveRow.Cells[9].Value.ToString() == "0")
                uwgOrgAddress.ActiveRow.Cells[9].Value = "1";

            blnDataDirty = true;

        }

        private void btnAdd_Click(object sender, EventArgs e)
        {
            Form1 fm = (Form1)this.MdiParent;
            int contactId = 0;
            int orgID = Convert.ToInt32(OrgID);
            DialogResult diarslt = MessageBox.Show("This will add a new contact to the Master Contact List-have you confirmed that it\ndoes not already exist ?",
                                                    "New Contact Warning", MessageBoxButtons.YesNoCancel);
            if (diarslt == DialogResult.Yes)
            {
                CreateContact cc = new CreateContact(contactId, "addlink", orgID, "admin");
                fm.OpenForm(cc, "Add Contact");
            }
            else if (diarslt == DialogResult.No)
            {
                CCPM.Project.Contacts lc = new CCPM.Project.Contacts();
                fm.OpenForm(lc, "Project Contacts");
            }
            LoadContacts();
        }

        private void btnContactRemove_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < uwgContacts.Rows.Count; i++)
            {
                if (uwgContacts.Rows[i].Selected == true)
                {
                    DataSet ds = ProjectData.ContactProjects(Convert.ToInt32(uwgContacts.Rows[i].Cells["ContactId"].Value));
                    if (ds.Tables[0].Rows.Count > 0)
                    {
                        string msg = "Contact " + uwgContacts.Rows[i].Cells["FullName"].Value.ToString() + " can't be removed because it is linked to the following project(s): \n\n ";
                        foreach (DataRow dr in ds.Tables[0].Rows)
                        {
                            msg += dr["FileNumber"] + "\n";
                        }
                        MessageBox.Show(msg, "Remove Contact Warning", MessageBoxButtons.OK);
                        return;
                    }
                }
            }

            for (int i = 0; i < uwgContacts.Rows.Count; i++)
            {
                if (uwgContacts.Rows[i].Selected == true)
                {
                    try
                    {
                        ContactData.OrgContactUnlink(Convert.ToInt32(uwgContacts.Rows[i].Cells["ContactId"].Value));
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message, "Unlink Contact Failure!", MessageBoxButtons.OK);
                    }
                }
            }
            LoadContacts();
        }

        private void btnAddressRemove_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < uwgOrgAddress.Rows.Count; i++)
            {
                if (uwgOrgAddress.Rows[i].Selected == true)
                {
                    DbConnection dbConnection = DbConnection.GetDbConnection();
                    string connectionString = dbConnection.DbConnectionString;
                    int retVal = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "delete from OrgAddress where OrgAddressID = " + Convert.ToInt32(uwgOrgAddress.Rows[i].Cells[8].Value));
                }
            }
            LoadOrgAddress();
            LoadContacts();

        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            LoadContacts();
            LoadOrgAddress();

        }

        private void uwgOrgAddress_ClickCellButton(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            DialogResult dr = MessageBox.Show(
               "You are about to remove the selected organization address ? ", "Remove Organization Address Warning", MessageBoxButtons.OKCancel);
            if (dr == DialogResult.OK)
            {
                int retVal = SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, "delete from OrgAddress where OrgAddressID = " + Convert.ToInt32(uwgOrgAddress.ActiveRow.Cells[8].Value));
            }
            LoadOrgAddress();
        }

        private void NewOrganization_Activated(object sender, EventArgs e)
        {
            LoadContacts();
            LoadOrgAddress();

        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void refreshCallingForm(object sender, EventArgs e)
        {
            if (callingForm != null)
            {
                if (callingForm.GetType() == typeof(CCPM.Contact.CreateContact) && (!callingForm.IsDisposed))
                {
                    CreateContact fm = (CreateContact)(callingForm);
                    fm.btnRefresh_Click(sender,e);
                }
            }
        }


 
    
    }
}
