﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.ApplicationBlocks.Data;
using CCPM.Data;

namespace CCPM.Contact
{
    public partial class ProjectList : Form 
    {
        int OrgId = 0;
        public ProjectList(int OrgID)
        {
            InitializeComponent();
            OrgId = OrgID;
            LoadProjects();
        }

        private void LoadProjects()
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            DataSet ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select 0 as checkbox, FileNumber,ProjectName, ProjectId from Project order by ProjectName");
            uwgOrg.DataSource = ds.Tables[0];
            uwgOrg.DataBind();
        }

        private void uwgOrg_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Header.Caption = "";
            e.Layout.Bands[0].Columns[0].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;
            
            e.Layout.Bands[0].Columns[1].Width = 130;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Project Number";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            e.Layout.Bands[0].Columns[2].Width = 300;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Project Name";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

            // ProjectID
            e.Layout.Bands[0].Columns[3].Hidden = true;
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < uwgOrg.Rows.Count; i++)
            {
                if (uwgOrg.Rows[i].Cells[0].Value.ToString() == "1")
                {
                    string roles = "";
                    roles = ProjectRoles(uwgOrg.Rows[i].Cells[2].Text);
                    if (roles == string.Empty)
                        continue;
                    int pid = (int)uwgOrg.Rows[i].Cells[3].Value;
                    ProjectData.OrgProjectRoleInsert(OrgId, pid, roles);
                }
            }
            this.Close();
        }

        private string ProjectRoles(string orgname)
        {
            string retVal = "";
            DialogResult dr;
            GridSelect gs = new GridSelect();
            gs.lblTitle.Text = "Select One or More Project Roles";
            gs.Text = "Linking Organization:  " + orgname;
            gs.DataSet(ProjectData.GetProjectRoles());
            gs.ColumnHide(0);
            gs.ColumnWidth(1, 300);
            gs.ColumnName(1, "Project Role");
            dr = gs.ShowDialog();
            if (dr == DialogResult.OK)
                retVal = gs.SelectedKeys(0, false);
            return retVal;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
