﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CCPM.Data;
using System.Net.Mail;
using System.Net.Mime;
using System.ComponentModel;
using Microsoft.ApplicationBlocks.Data;
using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace CCPM.Contract
{
    
    public partial class ActiveContractLog : Form
    {
        bool blnDataChange = false;
        bool blnGridDirty = false;
        bool blnViewOnly = true;

        private ContractDetail cd;

        public ActiveContractLog()
        {
            DataSet dsContractStatus = null;
            DataSet dsProjectManagerName = null;
            InitializeComponent();

            this.Location = new Point(0, 0);
            uwgActiveContract.DisplayLayout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            uwgActiveContract.DisplayLayout.Override.HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction.SortSingle;
            dsContractStatus = ContractData.GetContractStatus();
            uwgActiveContract.DisplayLayout.ValueLists.Add("StatusCode");
            for (int i = 0; i < dsContractStatus.Tables[0].Rows.Count; i++)
            {
                Infragistics.Win.ValueListItem listItem = new Infragistics.Win.ValueListItem();
                listItem.DataValue = dsContractStatus.Tables[0].Rows[i].ItemArray.GetValue(0);
                listItem.DisplayText = (string)dsContractStatus.Tables[0].Rows[i].ItemArray.GetValue(1);
                uwgActiveContract.DisplayLayout.ValueLists["StatusCode"].ValueListItems.Add(listItem);
            }

            //Load and bind project manager name data source
            dsProjectManagerName = ProjectData.ProjectStaffList();
            uwgActiveContract.DisplayLayout.ValueLists.Add("Name");
            for (int i = 0; i < dsProjectManagerName.Tables[0].Rows.Count; i++)
            {
                Infragistics.Win.ValueListItem listItem = new Infragistics.Win.ValueListItem();
                listItem.DataValue = dsProjectManagerName.Tables[0].Rows[i].ItemArray.GetValue(0);
                listItem.DisplayText = (string)dsProjectManagerName.Tables[0].Rows[i].ItemArray.GetValue(1);
                uwgActiveContract.DisplayLayout.ValueLists["Name"].ValueListItems.Add(listItem);
            }
            LoadGridAll();
            SetSecurity();
        }

        private void SetSecurity()
        {
            UltraGridBand band = uwgActiveContract.DisplayLayout.Bands[0];

            //Conditions Met by Contracts Manager, Contracts Staff
            if (!(GlobalSettings.IsContractsManager || GlobalSettings.IsContractsStaff))
            {
                band.Columns["AreContractsConditionMet"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            }
            
            //edit & delete only:  Contracts Manager, Contracts Staff, and Accounting Manager
            if (GlobalSettings.IsContractsManager || GlobalSettings.IsContractsStaff || GlobalSettings.IsAccountingManager)
            {
                blnViewOnly = false;
            }
            else if (GlobalSettings.IsProjectManager)
            {
                btnSave.Enabled = false;
                band.Columns["ContractStatusId"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["AreContractsConditionMet"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["isFlagged"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["FlagNote"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            }
            else
            {
                btnSave.Enabled = false;
            }
        }

        private void LoadGrid()
        {
            if (uwgActiveContract.DataSource != null)
            {
                LoadData();
            }
            if (uwgActiveContract.Rows.Count < 1)
            {
                btnViewContract.Enabled = false;
                btnViewRepay.Enabled = false;
                btnViewInvoice.Enabled = false;
            }
            else
            {
                btnViewContract.Enabled = true;
                btnViewInvoice.Enabled = true;
            }
            blnDataChange = false;
            btnSave.Enabled = false;
        }

        private void LoadGridAll()
        {
            lblFilter.Text = "";
            lblFilterOn.Text = "";
            uwgActiveContract.DisplayLayout.Bands[0].ColumnFilters.ClearAllFilters();

            LoadData();
            if (uwgActiveContract.Rows.Count < 1)
            {
                btnViewContract.Enabled = false;
                btnViewRepay.Enabled = false;
                btnViewInvoice.Enabled = false;
            }
            else
            {
                btnViewContract.Enabled = true;
                btnViewInvoice.Enabled = true;
            }
            blnDataChange = false;
            btnSave.Enabled = false;
        }

        private void LoadData()
        {
            this.Cursor = Cursors.WaitCursor;
            DataSet dsActiveContract = ContractData.GetActiveContract();
            this.Cursor = Cursors.Default;
            uwgActiveContract.DataSource = dsActiveContract;
            uwgActiveContract.DataBind();        
        }
        private void uwgActiveContract_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //0 = ContractNumber
            //1 = AmendmentNumber
            //2 = Organization
            //3 = TypeCode
            //4 = ContractedAmount
            //5 = Amount
            //6 = ExecutedDate
            //7 = CompletedDate
            //8 = TerminationDate
            //9 = ExpirationAlert
            //10 = LiquidationAlert
            //11 = RepaymentAlert 
            //12 = ContractStatusId
            //13 = AreContractsConditionMet
            //14 = isFlagged
            //15 = ProjectName
            //16 = [Name]
            //17 = Region
            //18 = FlagNote
            //19 = DirtyFlag
            //20 = ContractId 
            e.Layout.Bands[0].Columns["ContractNumber"].Width = 120;
            e.Layout.Bands[0].Columns["ContractNumber"].Header.Caption = "Contract Number";
            e.Layout.Bands[0].Columns["ContractNumber"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["ContractNumber"].TabStop = false;
            e.Layout.Bands[0].Columns["ContractNumber"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ContractNumber"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ContractNumber"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["AmendmentNumber"].Width = 60;
            e.Layout.Bands[0].Columns["AmendmentNumber"].Header.Caption = "Last Amend #";
            e.Layout.Bands[0].Columns["AmendmentNumber"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["AmendmentNumber"].TabStop = false;
            e.Layout.Bands[0].Columns["AmendmentNumber"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["AmendmentNumber"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["AmendmentNumber"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["Organization"].Width = 170;
            e.Layout.Bands[0].Columns["Organization"].Header.Caption = "Grantee/Contractor";
            e.Layout.Bands[0].Columns["Organization"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["Organization"].TabStop = false;
            e.Layout.Bands[0].Columns["Organization"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["Organization"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["Organization"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["TypeCode"].Width = 100;
            e.Layout.Bands[0].Columns["TypeCode"].Header.Caption = "Contract Type";
            e.Layout.Bands[0].Columns["TypeCode"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["TypeCode"].TabStop = false;
            e.Layout.Bands[0].Columns["TypeCode"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["TypeCode"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["TypeCode"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["ContractedAmount"].Width = 80;
            e.Layout.Bands[0].Columns["ContractedAmount"].Header.Caption = "Contract Total";
            e.Layout.Bands[0].Columns["ContractedAmount"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["ContractedAmount"].TabStop = false;
            e.Layout.Bands[0].Columns["ContractedAmount"].Format = "$###,###,##0.00";
            e.Layout.Bands[0].Columns["ContractedAmount"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ContractedAmount"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ContractedAmount"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns["ContractedAmount"].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right;

            e.Layout.Bands[0].Columns["Balance"].Width = 80;
            e.Layout.Bands[0].Columns["Balance"].Header.Caption = "Balance";
            e.Layout.Bands[0].Columns["Balance"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["Balance"].TabStop = false;
            e.Layout.Bands[0].Columns["Balance"].Format = "$###,###,##0.00";
            e.Layout.Bands[0].Columns["Balance"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["Balance"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["Balance"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns["Balance"].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right;

            e.Layout.Bands[0].Columns["ExecutedDate"].Width = 70;
            e.Layout.Bands[0].Columns["ExecutedDate"].Header.Caption = "Date Exec";
            e.Layout.Bands[0].Columns["ExecutedDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["ExecutedDate"].TabStop = false;
            e.Layout.Bands[0].Columns["ExecutedDate"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ExecutedDate"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ExecutedDate"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["CompletedDate"].Width = 70;
            e.Layout.Bands[0].Columns["CompletedDate"].Header.Caption = "Compl Date";
            e.Layout.Bands[0].Columns["CompletedDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["CompletedDate"].TabStop = false;
            e.Layout.Bands[0].Columns["CompletedDate"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["CompletedDate"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["CompletedDate"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["RegisteredDate"].Width = 80;
            e.Layout.Bands[0].Columns["RegisteredDate"].Header.Caption = "Date Registered(SCPRS)";
            e.Layout.Bands[0].Columns["RegisteredDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["RegisteredDate"].TabStop = false;
            e.Layout.Bands[0].Columns["RegisteredDate"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["RegisteredDate"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["RegisteredDate"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["TerminationDate"].Width = 70;
            e.Layout.Bands[0].Columns["TerminationDate"].Header.Caption = "Term Date";
            e.Layout.Bands[0].Columns["TerminationDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["TerminationDate"].TabStop = false;
            e.Layout.Bands[0].Columns["TerminationDate"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["TerminationDate"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["TerminationDate"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["ExpirationAlert"].Width = 100;
            e.Layout.Bands[0].Columns["ExpirationAlert"].Header.Caption = "Expir Alert";
            e.Layout.Bands[0].Columns["ExpirationAlert"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["ExpirationAlert"].TabStop = false;
            e.Layout.Bands[0].Columns["ExpirationAlert"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ExpirationAlert"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ExpirationAlert"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["LiquidationAlert"].Width = 100;
            e.Layout.Bands[0].Columns["LiquidationAlert"].Header.Caption = "Liquid Alert";
            e.Layout.Bands[0].Columns["LiquidationAlert"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["LiquidationAlert"].TabStop = false;
            e.Layout.Bands[0].Columns["LiquidationAlert"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["LiquidationAlert"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["LiquidationAlert"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["RepaymentAlert"].Width = 100;
            e.Layout.Bands[0].Columns["RepaymentAlert"].Header.Caption = "Repayment Alert";
            e.Layout.Bands[0].Columns["RepaymentAlert"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["RepaymentAlert"].TabStop = false;
            e.Layout.Bands[0].Columns["RepaymentAlert"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["RepaymentAlert"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["RepaymentAlert"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["ContractStatusId"].Width = 70;
            e.Layout.Bands[0].Columns["ContractStatusId"].Header.Caption = "Contract Status";
            e.Layout.Bands[0].Columns["ContractStatusId"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns["ContractStatusId"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            e.Layout.Bands[0].Columns["ContractStatusId"].ValueList = uwgActiveContract.DisplayLayout.ValueLists["StatusCode"];
            e.Layout.ValueLists["StatusCode"].DisplayStyle = Infragistics.Win.ValueListDisplayStyle.DisplayText;

            e.Layout.Bands[0].Columns["AreContractsConditionMet"].Width = 80;
            e.Layout.Bands[0].Columns["AreContractsConditionMet"].Header.Caption = "Conditions Met?";
            e.Layout.Bands[0].Columns["AreContractsConditionMet"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns["AreContractsConditionMet"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;
            
            e.Layout.Bands[0].Columns["isFlagged"].Width = 50;
            e.Layout.Bands[0].Columns["isFlagged"].Header.Caption = "Flag";
            e.Layout.Bands[0].Columns["isFlagged"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
           
            e.Layout.Bands[0].Columns["ProjectName"].Width = 200;
            e.Layout.Bands[0].Columns["ProjectName"].Header.Caption = "Project Name";
            e.Layout.Bands[0].Columns["ProjectName"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["ProjectName"].TabStop = false;
            e.Layout.Bands[0].Columns["ProjectName"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ProjectName"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ProjectName"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            
            e.Layout.Bands[0].Columns["Name"].Width = 100;
            e.Layout.Bands[0].Columns["Name"].Header.Caption = "Project Contract Manager";
            e.Layout.Bands[0].Columns["Name"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns["Name"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            e.Layout.Bands[0].Columns["Name"].ValueList = uwgActiveContract.DisplayLayout.ValueLists["Name"];
            e.Layout.ValueLists["Name"].DisplayStyle = Infragistics.Win.ValueListDisplayStyle.DisplayText;

            e.Layout.Bands[0].Columns["Region"].Width = 70;
            e.Layout.Bands[0].Columns["Region"].Header.Caption = "Region";
            e.Layout.Bands[0].Columns["Region"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["Region"].TabStop = false;
            e.Layout.Bands[0].Columns["Region"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["Region"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["Region"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["FlagNote"].Width = 100;
            e.Layout.Bands[0].Columns["FlagNote"].Header.Caption = "Notes";
            e.Layout.Bands[0].Columns["FlagNote"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            //Dirty Flag
            e.Layout.Bands[0].Columns["DirtyFlag"].Hidden = true;
            //ContractId
            e.Layout.Bands[0].Columns["ContractId"].Hidden = true;

            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;
        }

        private void btnViewInvoice_Click(object sender, EventArgs e)
        {
            if (uwgActiveContract.ActiveRow.Cells["ContractId"].Value == System.DBNull.Value ) return;

            FundSourceSelection fss = new FundSourceSelection(Convert.ToInt32(uwgActiveContract.ActiveRow.Cells["ContractId"].Value));
            fss.MyParentForm = this;
            if (fss.ShowDialog() == DialogResult.OK)
            {
                int fundSource = fss.FundingSource;
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenInvoiceDrawdown(Convert.ToInt32(uwgActiveContract.ActiveRow.Cells["ContractId"].Value), fundSource);
            }
       }

        private void btnViewRepay_Click(object sender, EventArgs e)
        {
            Form1 fm = (Form1)this.MdiParent;
            fm.OpenRepayment(Convert.ToInt32(uwgActiveContract.ActiveRow.Cells["ContractId"].Value));
        }

        private void btnViewContract_Click(object sender, EventArgs e)
        {
            OpenContractDetail();
        }

        private void OpenContractDetail()
        {
            if (uwgActiveContract.ActiveRow.Cells[0].Value == System.DBNull.Value || uwgActiveContract.ActiveRow.Cells[0].Value ==null) return;

            Form1 mainForm = (Form1)this.MdiParent;
            mainForm.OpenContract(uwgActiveContract.ActiveRow.Cells[0].Value.ToString());
          
        }            

        private void uwgActiveContract_DoubleClickRow(object sender, Infragistics.Win.UltraWinGrid.DoubleClickRowEventArgs e)
        {
            OpenContractDetail();
        }

        private void uwgActiveContract_AfterRowActivate(object sender, EventArgs e)
        {
            if(uwgActiveContract.ActiveRow.Cells["TypeCode"].Value == System.DBNull.Value) return;
            if (uwgActiveContract.ActiveRow.Cells["TypeCode"].Value.ToString() == "Repayable Grant")
            {
                btnViewRepay.Enabled = true;
            }
            else
            {
                btnViewRepay.Enabled = false;
            }
        }

        private void ActiveContractLog_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (blnViewOnly)
                return;

            if (blnDataChange == true)
            {
                DialogResult intResult = MessageBox.Show("Do You want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (intResult == DialogResult.Yes)
                    SaveActiveContractLog();
            }
        }

        private void btnFilter_Click(object sender, EventArgs e)
        {
            GridFilter gf = new GridFilter(uwgActiveContract, lblFilter, lblFilterOn, this.Text);
            gf.ShowDialog();
            if (lblFilter.Text != string.Empty)
            {
                label4.Visible = true;
            }
            else
            {
                label4.Visible = false;
            }
        }

        private void SaveActiveContractLog()
        {
            if (blnViewOnly)
                return;

            int k = 0;
            for (int i = 0; i < uwgActiveContract.Rows.Count; i++)
            {
                if (uwgActiveContract.Rows[i].Cells["DirtyFlag"].Value.ToString() == "1")
                {
                    //string s = uwgActiveContract.Rows[i].Cells["StatusCode"].Text.ToString();
                    string s1 = uwgActiveContract.Rows[i].Cells["Name"].Text.ToString();
                    int statusOld = (int)uwgActiveContract.Rows[i].Cells["ContractStatusId"].OriginalValue;
                    int statusNew = (int)uwgActiveContract.Rows[i].Cells["ContractStatusId"].Value;
                    int retVal = ContractData.ActiveContractUpdate(
                            uwgActiveContract.Rows[i].Cells["ContractId"].Value
                            //, uwgActiveContract.Rows[i].Cells["StatusCode"].ValueListResolved.GetValue(s, ref k)
                            , statusNew
                            , uwgActiveContract.Rows[i].Cells["AreContractsConditionMet"].Value
                            , uwgActiveContract.Rows[i].Cells["isFlagged"].Value
                            , uwgActiveContract.Rows[i].Cells["Name"].ValueListResolved.GetValue(s1, ref k)
                            , uwgActiveContract.Rows[i].Cells["FlagNote"].Value
                            );
                    if (retVal == -1)
                    {
                        MessageBox.Show("Update failed ", "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    ContractData.ProjectProjectManagerInsert(Convert.ToInt32( uwgActiveContract.Rows[i].Cells["ContractId"].Value));
                    if (statusOld != 4 && statusNew == 4)       //Status to Closed
                    {
                        if (DialogResult.Yes == MessageBox.Show("Do you want to complete the closing comments now for Contract Number (" + Convert.ToString(uwgActiveContract.Rows[i].Cells["ContractNumber"].Value) + ") ?", "Warning", MessageBoxButtons.YesNo))
                        {
                            Form1 fm = (Form1)this.MdiParent;
                            fm.OpenContract((int)uwgActiveContract.Rows[i].Cells["ContractId"].Value);
                        }
                    }
                }
            }
            LoadGrid();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            SaveActiveContractLog();
        }

        private void uwgActiveContract_AfterCellUpdate(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            if (blnViewOnly)
                return;

            blnDataChange = true;
            btnSave.Enabled = true;
            //check for not 1 is not compatible with grid filtering, changed to check for 0.
            //if (uwgActiveContract.ActiveRow.Cells["DirtyFlag"].Value.ToString() != "1")
            if (uwgActiveContract.ActiveRow.Cells["DirtyFlag"].Value.ToString() == "0")
                uwgActiveContract.ActiveRow.Cells["DirtyFlag"].Value = "1";

            blnGridDirty = true;
        }

        private void ActiveContractLog_Activated(object sender, EventArgs e)
        {
            //LoadGrid();
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            if (blnGridDirty == true)
            {
                DialogResult diaRslt = MessageBox.Show("Do you want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (diaRslt == DialogResult.Yes)
                {
                    SaveActiveContractLog();
                }
            }
            label4.Visible = false;
            LoadGrid();
        }

        private void btnExport_Click(object sender, EventArgs e)
        {
            string excelFile = GlobalCode.ExcelFileName("c:\\Temp", "ccpm_export.xls", false);
            if (excelFile != string.Empty)
            {
                GlobalCode.ExportGridToExcel(uwgActiveContract, excelFile);
                GlobalCode.OpenAssociatedFile(excelFile);
            }
        }

        private void uwgActiveContract_Enter(object sender, EventArgs e)
        {
            if (uwgActiveContract.Rows.Count > 0)
                uwgActiveContract.Rows[0].Cells[0].Activate();
        }

        private void uwgActiveContract_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == Convert.ToChar(Keys.Tab))
            {
                uwgActiveContract.ActiveCell.Selected = true;
            } 
            
        }

        private void btnSeeAll_Click(object sender, EventArgs e)
        {
            if (blnGridDirty == true)
            {
                DialogResult diaRslt = MessageBox.Show("Do you want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (diaRslt == DialogResult.Yes)
                {
                    SaveActiveContractLog();
                }
            }
            label4.Visible = false;
            LoadGridAll();

        }
    }
}
