﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using Infragistics.Shared;
using Infragistics.Win; 
using Infragistics.Win.UltraWinGrid; 
using System.Windows.Forms;
using CCPM.Data;
using Microsoft.ApplicationBlocks.Data;
using System.Data.SqlTypes;

namespace CCPM.Contract
{
    public partial class AmendmentsLog : Form
    {
        DataSet dsContract = null;
        DataSet dsProjectStaff = null;
        bool blnGridDirty = false;
        bool blnViewOnly = true;

        public AmendmentsLog()
        {
            InitializeComponent();


            this.Location = new Point(0, 0);
            uwgContract.DisplayLayout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            uwgContract.DisplayLayout.Override.HeaderClickAction = HeaderClickAction.SortSingle;
            uwgContract.DisplayLayout.TabNavigation = TabNavigation.NextCell;

            System.Data.DataSet ds = CCPM.Data.ProjectData.GetProjectListRange("0,2"); //(3);
            cmbProjectNumber.DataSource = null;
            cmbProjectNumber.DataSource = ds.Tables[1];
            cmbProjectNumber.DisplayLayout.Bands[0].Columns[0].Hidden = true;
            cmbProjectNumber.DisplayMember = "FileNumber";
            cmbProjectNumber.ValueMember = "ProjectId";
            
            ds = null;
            ds = ContractData.GetContractList();
            cmbContractNumber.DataSource = ds.Tables[0];
            cmbContractNumber.DisplayLayout.Bands[0].Columns[0].Hidden = true;
            cmbContractNumber.DisplayMember = "ContractNumber";
            cmbContractNumber.ValueMember = "ContractId";
          
            //Create and bind Project Staff database
            dsProjectStaff = ProjectData.ProjectStaffList();
            uwgContract.DisplayLayout.ValueLists.Add("Name");
            for (int i = 0; i < dsProjectStaff.Tables[0].Rows.Count; i++)
            {
                Infragistics.Win.ValueListItem listItem1 = new Infragistics.Win.ValueListItem();
                listItem1.DataValue = dsProjectStaff.Tables[0].Rows[i].ItemArray.GetValue(0);
                listItem1.DisplayText = (string)dsProjectStaff.Tables[0].Rows[i].ItemArray.GetValue(1);
                uwgContract.DisplayLayout.ValueLists["Name"].ValueListItems.Add(listItem1);
            }

            LoadGridAll();
            SetSecurity();
        }

        private void SetSecurity()
        {
            //edit & delete only:  Contracts Manager, Contracts Staff, and Accounting Manager
            if (GlobalSettings.IsContractsManager || GlobalSettings.IsContractsStaff || GlobalSettings.IsAccountingManager)
            {
                blnViewOnly = false;
            }
            else if(GlobalSettings.IsProjectManager)
            {
                btnSave.Enabled = false;
                btnDelete.Enabled = false;
                btnNewContract.Enabled = false;
                btnNewAmendment.Enabled = false;

                UltraGridBand band = uwgContract.DisplayLayout.Bands[0];
                band.Columns["LegalDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["ProofreaderDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["GranteeDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["ReturnedDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["ExecutedDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["DGSDateTo"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["DGSDateFrom"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["ControllerDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["FinalDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["RegisteredDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["RemoveRow"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["Flag"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns["Notes"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            }
            else 
            {
                btnSave.Enabled = false;
                btnDelete.Enabled = false;
                btnNewContract.Enabled = false;
                btnNewAmendment.Enabled = false;

            }
        }

        private void LoadGrid()
        {
            if (uwgContract.DataSource != null)
            {
                LoadData();            
            }
            btnDelete.Enabled = (uwgContract.Rows.Count > 0);
            blnGridDirty = false;
            btnSave.Enabled = false;
        }

        private void LoadGridAll()
        {
             lblFilter.Text = "";
            lblFilterOn.Text = "";
            uwgContract.DisplayLayout.Bands[0].ColumnFilters.ClearAllFilters();

            LoadData();
            btnDelete.Enabled = (uwgContract.Rows.Count > 0);
            blnGridDirty = false;
            btnSave.Enabled = false;

        }
        private void LoadData()
        {
            this.Cursor = Cursors.WaitCursor;
            dsContract = ContractData.GetAmendmentLog();
            this.Cursor = Cursors.Default;
            uwgContract.DataSource = dsContract.Tables[0];
            uwgContract.DataBind();
        }

        private void uwgContract_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["ContractNumber"].Width = 120;
            e.Layout.Bands[0].Columns["ContractNumber"].Header.Caption = "Contract Number";
            e.Layout.Bands[0].Columns["ContractNumber"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["ContractNumber"].TabStop = false;
            e.Layout.Bands[0].Columns["ContractNumber"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ContractNumber"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ContractNumber"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["AmendmentNumber"].Width = 50;
            e.Layout.Bands[0].Columns["AmendmentNumber"].Header.Caption = "Amend No.";
            e.Layout.Bands[0].Columns["AmendmentNumber"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["AmendmentNumber"].TabStop = false;
            e.Layout.Bands[0].Columns["AmendmentNumber"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["AmendmentNumber"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["AmendmentNumber"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["TypeCode"].Width = 80;
            e.Layout.Bands[0].Columns["TypeCode"].Header.Caption = "Contract Type";
            e.Layout.Bands[0].Columns["TypeCode"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["TypeCode"].TabStop = false;
            e.Layout.Bands[0].Columns["TypeCode"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["TypeCode"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["TypeCode"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["Organization"].Width = 70;
            e.Layout.Bands[0].Columns["Organization"].Header.Caption = "Grantee/Contractor";
            e.Layout.Bands[0].Columns["Organization"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["Organization"].TabStop = false;
            e.Layout.Bands[0].Columns["Organization"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["Organization"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["Organization"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["ProjectName"].Width = 100;
            e.Layout.Bands[0].Columns["ProjectName"].Header.Caption = "Project Name";
            e.Layout.Bands[0].Columns["ProjectName"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["ProjectName"].TabStop = false;
            e.Layout.Bands[0].Columns["ProjectName"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ProjectName"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["ProjectName"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["StatusCode"].Width = 80;
            e.Layout.Bands[0].Columns["StatusCode"].Header.Caption = "Contract Status";
            e.Layout.Bands[0].Columns["StatusCode"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["StatusCode"].TabStop = false;
            e.Layout.Bands[0].Columns["StatusCode"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["StatusCode"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["StatusCode"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["ProjectManagerId"].Width = 80;
            e.Layout.Bands[0].Columns["ProjectManagerId"].Header.Caption = "Project Contract Manager";
            e.Layout.Bands[0].Columns["ProjectManagerId"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            e.Layout.Bands[0].Columns["ProjectManagerId"].ValueList = uwgContract.DisplayLayout.ValueLists["Name"];
            e.Layout.ValueLists["Name"].DisplayStyle = Infragistics.Win.ValueListDisplayStyle.DisplayText;

            e.Layout.Bands[0].Columns["LegalDate"].Width = 80;
            e.Layout.Bands[0].Columns["LegalDate"].Header.Caption = "Date to Legal";
            e.Layout.Bands[0].Columns["LegalDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns["ProofreaderDate"].Width = 80;
            e.Layout.Bands[0].Columns["ProofreaderDate"].Header.Caption = "Date to Proofreader";
            e.Layout.Bands[0].Columns["ProofreaderDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns["GranteeDate"].Width = 80;
            e.Layout.Bands[0].Columns["GranteeDate"].Header.Caption = "Date to Grantee/Contractor";
            e.Layout.Bands[0].Columns["GranteeDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns["ReturnedDate"].Width = 80;
            e.Layout.Bands[0].Columns["ReturnedDate"].Header.Caption = "Date Returned";
            e.Layout.Bands[0].Columns["ReturnedDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns["ExecutedDate"].Width = 80;
            e.Layout.Bands[0].Columns["ExecutedDate"].Header.Caption = "Date Executed";
            e.Layout.Bands[0].Columns["ExecutedDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns["DGSDateTo"].Width = 80;
            e.Layout.Bands[0].Columns["DGSDateTo"].Header.Caption = "Date to DGS";
            e.Layout.Bands[0].Columns["DGSDateTo"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns["DGSDateFrom"].Width = 80;
            e.Layout.Bands[0].Columns["DGSDateFrom"].Header.Caption = "Date from DGS";
            e.Layout.Bands[0].Columns["DGSDateFrom"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns["ControllerDate"].Width = 80;
            e.Layout.Bands[0].Columns["ControllerDate"].Header.Caption = "Date to Controller";
            e.Layout.Bands[0].Columns["ControllerDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns["FinalDate"].Width = 100;
            e.Layout.Bands[0].Columns["FinalDate"].Header.Caption = "Date Final to Grantee/Contractor";
            e.Layout.Bands[0].Columns["FinalDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns["RegisteredDate"].Width = 80;
            e.Layout.Bands[0].Columns["RegisteredDate"].Header.Caption = "Date Registered(SCPRS)";
            e.Layout.Bands[0].Columns["RegisteredDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns["RemoveRow"].Width = 50;
            e.Layout.Bands[0].Columns["RemoveRow"].Hidden = false;
            e.Layout.Bands[0].Columns["RemoveRow"].Header.Caption = "Remove Row?";
            e.Layout.Bands[0].Columns["RemoveRow"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns["RemoveRow"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;

            e.Layout.Bands[0].Columns["Flag"].Width = 50;
            e.Layout.Bands[0].Columns["Flag"].Header.Caption = "Flag";
            e.Layout.Bands[0].Columns["Flag"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns["Flag"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;

            e.Layout.Bands[0].Columns["Notes"].Width = 100;
            e.Layout.Bands[0].Columns["Notes"].Header.Caption = "Notes";
            e.Layout.Bands[0].Columns["Notes"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            
            e.Layout.Bands[0].Columns["AmendmentId"].Hidden = true;
            e.Layout.Bands[0].Columns["ContractId"].Hidden = true;
            e.Layout.Bands[0].Columns["DirtyFlag"].Hidden = true;

            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;
        }

        private void btnNewContract_Click(object sender, EventArgs e)
        {
            DataSet ds = ContractData.GetProject(cmbProjectNumber.Text.ToString());
            if (ds.Tables[0].Rows.Count > 0)
            {
                DataRow dr = ds.Tables[0].Rows[0];
                int projectId = Convert.ToInt32(dr[0]);
                Form1 fm = (Form1)this.MdiParent;
                ContractDetail cd = new ContractDetail(projectId);
                this.Close();
                fm.OpenForm(cd, "Contract Detail: " + ProjectData.GetProjectName(projectId));
            }
            else
            {
                MessageBox.Show("The Project Number doesn't exist !!", "Error", MessageBoxButtons.OK);
            }
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (blnViewOnly)
                return;
            bool blnRemoveRow = false;

            for (int i = 0; i < uwgContract.Rows.Count; i++)
            {
                if (uwgContract.Rows[i].Selected == true)
                {
                    uwgContract.Rows[i].Cells["RemoveRow"].Value = "True";
                    uwgContract.Rows[i].Cells["DirtyFlag"].Value = 1;
                    blnGridDirty = true;
                }
            }

            for (int i = 0; i < uwgContract.Rows.Count; i++)
            {
                if (uwgContract.Rows[i].Cells["RemoveRow"].Value.ToString() == "True" && uwgContract.Rows[i].Hidden == false)
                {
                    blnRemoveRow = true;
                }
            }

            if (blnRemoveRow == true)
            {
                DialogResult intDiagResult = MessageBox.Show("Do you want to remove the selected row(s) from the New Contracts & Amendments Log? This will not delete the Contract Details.", "Delete Row",
                        MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (intDiagResult == DialogResult.Yes)
                {
                    SaveAmendmentGrid();
                    GridManager.FirstButtonHandler(uwgContract);
                    blnGridDirty = false;
                    blnRemoveRow = false;
                }

            }
            else
            {
                UltraGridRow row = this.uwgContract.ActiveRow;

                if (null != row)
                {
                    DialogResult intDiagResult = MessageBox.Show("Do you want to remove the selected row(s) from the New Contracts & Amendments Log? This will not delete the Contract Details.", "Delete Row",
                        MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                    if (intDiagResult == DialogResult.Yes)
                    {
                        // if the row is a database row then mark it for deletion and hide it in the grid
                        if (row.Cells["DirtyFlag"].Value.ToString() == "0")
                        {
                            row.Hidden = true;
                            //row.Cells["DirtyFlag"].Value = "2";
                            row.Cells["RemoveRow"].Value = "True";
                            blnGridDirty = true;
                        }
                        // else it was added by the user and not saved to the database - delete it from the grid
                        else
                        {
                            row.Delete(false);
                        }
                        // set the active row to first (non-hidden) row
                        if (row.Cells["AmendmentId"].Value != DBNull.Value)
                        {
                            SaveAmendmentGrid();
                            GridManager.FirstButtonHandler(uwgContract);
                            blnGridDirty = false;
                        }
                    }
                }
                else
                {
                    //If there is no active row, then prompt the user to select one. 
                    MessageBox.Show("Please select a single row to delete.");
                }
            }
        }

        private void btnNewAmendment_Click(object sender, EventArgs e)
        {
            DataSet ds = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "SELECT ContractId FROM ContractDetails WHERE ContractNumber = '" + cmbContractNumber.Text.ToString() + "'");
            if (ds.Tables[0].Rows.Count > 0)
            {
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenContract(cmbContractNumber.Text.ToString());
            }
            else
            {
                MessageBox.Show("The Contract Number doesn't exist !!", "Error", MessageBoxButtons.OK);
            }
        }

        private void btnAdd_Click(object sender, EventArgs e)
        {
            UltraGridRow addRow = uwgContract.DisplayLayout.Bands[0].AddNew();
            addRow.Cells["DirtyFlag"].Value = "3";
        }

        private void uwgContract_AfterCellUpdate(object sender, CellEventArgs e)
        {
            if (blnViewOnly)
                return;

            if (uwgContract.ActiveRow.Cells["DirtyFlag"].Value.ToString() == "0")
            {
                uwgContract.ActiveRow.Cells["DirtyFlag"].Value = "1";
                btnSave.Enabled = true;
            }
            if (uwgContract.ActiveRow.Cells["ExecutedDate"].IsActiveCell)
            {
                string s = uwgContract.ActiveRow.Cells["ExecutedDate"].Value.ToString();
                if (s != string.Empty && uwgContract.ActiveRow.Cells["ReturnedDate"].Value.ToString() == string.Empty)
                    uwgContract.ActiveRow.Cells["ReturnedDate"].Value = uwgContract.ActiveRow.Cells["ExecutedDate"].Value;
            }

            blnGridDirty = true;
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            SaveAmendmentGrid();
        }

        private void SaveAmendmentGrid()
        {
            if (blnViewOnly)
                return;

            string retMsg;

             for (int i = 0; i < uwgContract.Rows.Count; i++)
             {
                 switch (uwgContract.Rows[i].Cells["DirtyFlag"].Value.ToString())
                 {
                     case "1":
                         {
                             retMsg = ContractData.AmendmentLogUpdate(Convert.ToInt32(uwgContract.Rows[i].Cells["ContractId"].Value),
                                                                      uwgContract.Rows[i].Cells["AmendmentId"].Value,
                                                                      uwgContract.Rows[i].Cells["LegalDate"].Value,
                                                                      uwgContract.Rows[i].Cells["ProofreaderDate"].Value,
                                                                      uwgContract.Rows[i].Cells["GranteeDate"].Value,
                                                                      uwgContract.Rows[i].Cells["ReturnedDate"].Value,
                                                                      uwgContract.Rows[i].Cells["ExecutedDate"].Value,
                                                                      uwgContract.Rows[i].Cells["DGSDateTo"].Value,
                                                                      uwgContract.Rows[i].Cells["DGSDateFrom"].Value,
                                                                      uwgContract.Rows[i].Cells["ControllerDate"].Value,
                                                                      uwgContract.Rows[i].Cells["FinalDate"].Value,
                                                                      uwgContract.Rows[i].Cells["RegisteredDate"].Value,
                                                                      Convert.ToString(uwgContract.Rows[i].Cells["RemoveRow"].Value),
                                                                      Convert.ToString(uwgContract.Rows[i].Cells["Flag"].Value),
                                                                      Convert.ToString(uwgContract.Rows[i].Cells["Notes"].Value),
                                                                      uwgContract.Rows[i].Cells["ProjectManagerId"].Value);

                             if (retMsg != "success")
                             {
                                 MessageBox.Show("Update failed ", "Database Error",
                                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                             }
                             break;
                         }
                     case "2":
                         {
                             retMsg = ContractData.AmendmentDelete(Convert.ToInt32(uwgContract.ActiveRow.Cells[19].Value));
                             if (retMsg != "success")
                                 MessageBox.Show("Delete failed", "Database Error",
                                 MessageBoxButtons.OK, MessageBoxIcon.Error);
                             break;
                         }
                     case "3":
                         {
                             break;
                         }
                 }
             }
             LoadGrid();
        }

        private void uwgContract_DoubleClickRow(object sender, DoubleClickRowEventArgs e)
        {
            if (uwgContract.Rows.Count > 0)
            {
                int cid = Convert.ToInt32(uwgContract.ActiveRow.Cells["ContractId"].Value);
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenContract(cid);
            }
        }

        private void AmendmentsLog_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (blnViewOnly)
                return;

            if (blnGridDirty == true)
            {
                DialogResult diaRslt = MessageBox.Show("Do you want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (diaRslt == DialogResult.Yes)
                {
                    SaveAmendmentGrid();
                }
            }
        }

        private void AmendmentsLog_Activated(object sender, EventArgs e)
        {
            LoadGrid();
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            if (blnGridDirty == true)
            {
                DialogResult diaRslt = MessageBox.Show("Do you want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (diaRslt == DialogResult.Yes)
                {
                    SaveAmendmentGrid();
                }
            }
            label5.Visible = false;
            LoadGrid();
        }

        private void btnExport_Click(object sender, EventArgs e)
        {
            string excelFile = GlobalCode.ExcelFileName("c:\\Temp", "ccpm_export.xls", false);
            if (excelFile != string.Empty)
            {
                GlobalCode.ExportGridToExcel(uwgContract, excelFile);
                GlobalCode.OpenAssociatedFile(excelFile);
            }
        }

        private void btnFilter_Click(object sender, EventArgs e)
        {
            GridFilter gf = new GridFilter(uwgContract, lblFilter, lblFilterOn, this.Text);
            gf.ShowDialog();
            if (lblFilter.Text != string.Empty)
            {
                label5.Visible = true;
            }
            else
            {
                label5.Visible = false;
            }

        }

        private void uwgContract_Enter(object sender, EventArgs e)
        {
            if (uwgContract.Rows.Count > 0)
                uwgContract.Rows[1].Cells[0].Activate();
        }

        private void uwgContract_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == Convert.ToChar(Keys.Tab))
            {
                uwgContract.ActiveCell.Selected = true;
            }   
        }

        private void uwgContract_DoubleClickRow_1(object sender, DoubleClickRowEventArgs e)
        {
            Form1 fm = (Form1)(this.MdiParent);
            fm.OpenContract(Convert.ToString(uwgContract.ActiveRow.Cells[0].Value));

        }

        private void btnSeeAll_Click(object sender, EventArgs e)
        {
            if (blnGridDirty == true)
            {
                DialogResult diaRslt = MessageBox.Show("Do you want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (diaRslt == DialogResult.Yes)
                {
                    SaveAmendmentGrid();
                }
            }
            label5.Visible = false;

            LoadGridAll();
        }

        private void AmendmentsLog_Load(object sender, EventArgs e)
        {

        }
        
        public void UpdateForm()
        {
            LoadGrid();
        }
    }
}
