﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using CCPM.Data;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Contract
{
    public partial class ClosedContractLog : Form
    {
        DataSet dsClosedContractLog = null;
        bool blnGridDirty = false;
        bool blnDataDirty = false;
        bool blnViewOnly = true;

        public ClosedContractLog()
        {
            InitializeComponent();
            this.Location = new Point(0, 0);
            uwgClosedContractLog.DisplayLayout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            uwgClosedContractLog.DisplayLayout.Override.HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction.SortSingle;
            LoadClosedContractLogAll();
            SetSecurity();

        }

        private void SetSecurity()
        {
            //edit & delete only:  Contracts Manager, Contracts Staff, and Accounting Manager
            if (GlobalSettings.IsContractsManager || GlobalSettings.IsContractsStaff || GlobalSettings.IsAccountingManager)
            {
                blnViewOnly = false;
            }
            else
            {
                btnSave.Enabled = false;
                UltraGridBand band = uwgClosedContractLog.DisplayLayout.Bands[0];
                band.Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            }
        }

        private void LoadClosedContractLog()
        {

            if (uwgClosedContractLog.DataSource != null)
            {
                LoadData();
            }
            if (uwgClosedContractLog.Rows.Count < 1)
            {
                btnViewContract.Enabled = false;
            }
        }

        private void LoadClosedContractLogAll()
        {
            lblFilter.Text = "";
            lblFilterOn.Text = "";
            uwgClosedContractLog.DisplayLayout.Bands[0].ColumnFilters.ClearAllFilters();

            LoadData();
            if (uwgClosedContractLog.Rows.Count < 1)
            {
                btnViewContract.Enabled = false;
            }
        }
        private void LoadData()
        {
            this.Cursor = Cursors.WaitCursor;
            dsClosedContractLog = ContractData.GetClosedContractLog();
            this.Cursor = Cursors.Default;
            uwgClosedContractLog.DataSource = dsClosedContractLog.Tables[0];
            uwgClosedContractLog.DataBind();
        }

        private void uwgClosedContractLog_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Width = 120;
            e.Layout.Bands[0].Columns[0].Header.Caption = "Contract Number";
            e.Layout.Bands[0].Columns[0].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[0].TabStop = false;
            e.Layout.Bands[0].Columns[0].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[0].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[0].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[1].Width = 150;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Grantee/Contractor";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[1].TabStop = false;
            e.Layout.Bands[0].Columns[1].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[1].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[1].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[2].Width = 120;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Project Name";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[2].TabStop = false;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[3].Width = 80;
            e.Layout.Bands[0].Columns[3].Header.Caption = "Date Contract Closed";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[3].CellAppearance.BackColor = Color.White;

            e.Layout.Bands[0].Columns[4].Width = 80;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Box No in Basement";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[4].CellAppearance.BackColor = Color.White;
           
            e.Layout.Bands[0].Columns[5].Width = 100;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Contract Closing Remarks";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[5].CellAppearance.BackColor = Color.White;

            e.Layout.Bands[0].Columns[6].Width = 70;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Taxpayer ID";
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[6].TabStop = false;
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[7].Width = 70;
            e.Layout.Bands[0].Columns[7].Header.Caption = "Date of Execution";
            e.Layout.Bands[0].Columns[7].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[7].TabStop = false;
            e.Layout.Bands[0].Columns[7].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[7].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[7].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[8].Width = 70;
            e.Layout.Bands[0].Columns[8].Header.Caption = "Term Date";
            e.Layout.Bands[0].Columns[8].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[8].TabStop = false;
            e.Layout.Bands[0].Columns[8].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[8].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[8].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[9].Width = 80;
            e.Layout.Bands[0].Columns[9].Header.Caption = "Project Number";
            e.Layout.Bands[0].Columns[9].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[9].TabStop = false;
            e.Layout.Bands[0].Columns[9].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[9].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[9].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[10].Width = 70;
            e.Layout.Bands[0].Columns[10].Header.Caption = "Purpose of Contract";
            e.Layout.Bands[0].Columns[10].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[10].TabStop = false;
            e.Layout.Bands[0].Columns[10].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[10].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[10].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[11].Width = 80;
            e.Layout.Bands[0].Columns[11].Header.Caption = "Contract Amount";
            e.Layout.Bands[0].Columns[11].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[11].Format = "$###,###,##0.00";
            e.Layout.Bands[0].Columns[11].CellAppearance.TextHAlign = HAlign.Right;
            e.Layout.Bands[0].Columns[11].TabStop = false;
            e.Layout.Bands[0].Columns[11].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[11].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[11].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[12].Width = 80;
            e.Layout.Bands[0].Columns[12].Header.Caption = "Total Amount Paid";
            e.Layout.Bands[0].Columns[12].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[12].Format = "$###,###,##0.00";
            e.Layout.Bands[0].Columns[12].CellAppearance.TextHAlign = HAlign.Right;
            e.Layout.Bands[0].Columns[12].TabStop = false;
            e.Layout.Bands[0].Columns[12].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[12].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[12].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[13].Width = 100;
            e.Layout.Bands[0].Columns[13].Hidden = true;
            e.Layout.Bands[0].Columns[13].Header.Caption = "Date of Last Claim Schedule";
            e.Layout.Bands[0].Columns[13].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[13].TabStop = false;
            e.Layout.Bands[0].Columns[13].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[13].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[13].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
           
            e.Layout.Bands[0].Columns[14].Width = 80;
            e.Layout.Bands[0].Columns[14].Header.Caption = "Region";
            e.Layout.Bands[0].Columns[14].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[14].TabStop = false;
            e.Layout.Bands[0].Columns[14].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[14].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[14].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[15].Width = 80;
            e.Layout.Bands[0].Columns[15].Header.Caption = "County";
            e.Layout.Bands[0].Columns[15].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[15].TabStop = false;
            e.Layout.Bands[0].Columns[15].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[15].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[15].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[16].Width = 80;
            e.Layout.Bands[0].Columns[16].Header.Caption = "Project Contract Manager";
            e.Layout.Bands[0].Columns[16].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[16].TabStop = false;
            e.Layout.Bands[0].Columns[16].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[16].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[16].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            //ContractId
            e.Layout.Bands[0].Columns[17].Hidden = true;
            //Dirty Flag
            e.Layout.Bands[0].Columns[18].Hidden = true;

            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;
        }

        private void OpenContractDetail()
        {
            if (uwgClosedContractLog.ActiveRow != null)
            {
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenContract(Convert.ToString(uwgClosedContractLog.ActiveRow.Cells[0].Value));
                //ContractDetail cd = new ContractDetail(Convert.ToString(uwgClosedContractLog.ActiveRow.Cells[0].Value));
                //cd.MdiParent = fm;
                //cd.Show();
            }
        }

        private void btnViewContract_Click(object sender, EventArgs e)
        {
            OpenContractDetail();
        }

        private void ClosedContractLog_Load(object sender, EventArgs e)
        {

        }

        private void ClosedContractLog_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (blnGridDirty)
            {
                DialogResult intResult = MessageBox.Show("Do You want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (intResult == DialogResult.Yes)
                {
                    SaveClosedContractLog();
                }
            }
        }

        private void btnFilter_Click(object sender, EventArgs e)
        {
            GridFilter gf = new GridFilter(uwgClosedContractLog, lblFilter, lblFilterOn, this.Text);
            gf.ShowDialog();
            if (lblFilter.Text != string.Empty)
            {
                label4.Visible = true;
            }
            else
            {
                label4.Visible = false;
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            SaveClosedContractLog();
        }

        private void SaveClosedContractLog()
        {
            if (blnViewOnly)
                return;

            for (int i = 0; i < uwgClosedContractLog.Rows.Count; i++)
            {
                string sql = "UPDATE ContractDetails "
                    + "SET ClosedDate = '" + Convert.ToDateTime(uwgClosedContractLog.Rows[i].Cells[3].Value) + "'"
                    + ", BoxNumber = '" + Convert.ToString(uwgClosedContractLog.Rows[i].Cells[4].Value) + "'"
                    + ", ClosingRemarks = '" + Convert.ToString(uwgClosedContractLog.Rows[i].Cells[5].Value) + "'"
                    + " where ContractId = " + Convert.ToInt32(uwgClosedContractLog.Rows[i].Cells["ContractId"].Value);
                int retVal = SqlHelper.ExecuteNonQuery(DbConnection.GetDbConnection().DbConnectionString, CommandType.Text, sql);
                if (retVal == -1)
                {
                    MessageBox.Show("Update failed ", "Database Error",
                  MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            LoadClosedContractLog();
        }

        private void ClosedContractLog_Activated(object sender, EventArgs e)
        {
            LoadClosedContractLog();
        }

        private void uwgClosedContractLog_DoubleClickRow(object sender, DoubleClickRowEventArgs e)
        {
            OpenContractDetail();
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            if (blnGridDirty == true)
            {
                DialogResult diaRslt = MessageBox.Show("Do you want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (diaRslt == DialogResult.Yes)
                {
                    
                    SaveClosedContractLog();
                }
            }
            label4.Visible = false;
            LoadClosedContractLog();
        }

        private void btnExport_Click(object sender, EventArgs e)
        {
            string excelFile = GlobalCode.ExcelFileName("c:\\Temp", "ccpm_export.xls", false);
            if (excelFile != string.Empty)
            {
                GlobalCode.ExportGridToExcel(uwgClosedContractLog, excelFile);
                GlobalCode.OpenAssociatedFile(excelFile);
            }
        }

        private void uwgClosedContractLog_AfterCellUpdate(object sender, CellEventArgs e)
        {
            if (uwgClosedContractLog.ActiveRow.Cells["DirtyFlag"].Value.ToString() == "0")
                uwgClosedContractLog.ActiveRow.Cells["DirtyFlag"].Value = "1";
            blnDataDirty = true;
        }

        private void uwgClosedContractLog_Enter(object sender, EventArgs e)
        {
            if (uwgClosedContractLog.Rows.Count > 0)
                uwgClosedContractLog.Rows[0].Cells[0].Activate();
        }

        private void uwgClosedContractLog_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == Convert.ToChar(Keys.Tab))
            {
                uwgClosedContractLog.ActiveCell.Selected = true;
            }   
        }

        private void btnSeeAll_Click(object sender, EventArgs e)
        {

            if (blnGridDirty == true)
            {
                DialogResult diaRslt = MessageBox.Show("Do you want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (diaRslt == DialogResult.Yes)
                {

                    SaveClosedContractLog();
                }
            }
            label4.Visible = false;
            LoadClosedContractLogAll();
        }

    }
}
