﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using CCPM.Data;
using Microsoft.ApplicationBlocks.Data;
using System.Data.SqlClient;


namespace CCPM.Contract
{
    public partial class CompleteContractLog : Form
    {
        DataSet dsStatus = null;
        DataSet dsProjectManagerName = null;
        bool blnDataChange = false;
        bool blnGridDirty = false;
        bool blnViewOnly = true;

        public CompleteContractLog()
        {
            InitializeComponent();
            this.Location = new Point(0, 0);
            uwgCompleteContractLog.DisplayLayout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            uwgCompleteContractLog.DisplayLayout.Override.HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction.SortSingle;

            //// Create and Bind Contract Status dataset
            dsStatus = ContractData.GetContractStatus();
            uwgCompleteContractLog.DisplayLayout.ValueLists.Add("Status");
            for (int i = 0; i < dsStatus.Tables[0].Rows.Count; i++)
            {
                Infragistics.Win.ValueListItem listItem = new Infragistics.Win.ValueListItem();
                listItem.DataValue = dsStatus.Tables[0].Rows[i].ItemArray.GetValue(0);
                listItem.DisplayText = (string)dsStatus.Tables[0].Rows[i].ItemArray.GetValue(1);
                uwgCompleteContractLog.DisplayLayout.ValueLists["Status"].ValueListItems.Add(listItem);
            }

            dsProjectManagerName = ProjectData.ProjectStaffList();
            uwgCompleteContractLog.DisplayLayout.ValueLists.Add("Name");
            for (int i = 0; i < dsProjectManagerName.Tables[0].Rows.Count; i++)
            {
                Infragistics.Win.ValueListItem listItem = new Infragistics.Win.ValueListItem();
                listItem.DataValue = dsProjectManagerName.Tables[0].Rows[i].ItemArray.GetValue(0);
                listItem.DisplayText = (string)dsProjectManagerName.Tables[0].Rows[i].ItemArray.GetValue(1);
                uwgCompleteContractLog.DisplayLayout.ValueLists["Name"].ValueListItems.Add(listItem);
            }

            LoadCompleteContractGridAll();
            SetSecurity();
        }

        private void SetSecurity()
        {
            //edit & delete only:  Contracts Manager, Contracts Staff, and Accounting Manager
            if (GlobalSettings.IsContractsManager || GlobalSettings.IsContractsStaff || GlobalSettings.IsAccountingManager)
            {
                blnViewOnly = false;
            }
            else if (GlobalSettings.IsProjectManager)
            {
                btnSave.Enabled = false;

                UltraGridBand band = uwgCompleteContractLog.DisplayLayout.Bands[0];
                band.Columns[7].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns[12].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns[13].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            }
            else
            {
                btnSave.Enabled = false;
            }
        }

        private void LoadCompleteContractGrid()
        {
            if (uwgCompleteContractLog.DataSource != null)
            {
                LoadData();
            }
            if (uwgCompleteContractLog.Rows.Count < 1)
            {
                btnViewContract.Enabled = false;
                btnViewMonitoringDetails.Enabled = false;
            }
            blnDataChange = false;
            btnSave.Enabled = false;
        }

        private void uwgCompleteContractLog_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {            
            //Contract ID
            e.Layout.Bands[0].Columns[0].Hidden = true;

            e.Layout.Bands[0].Columns[1].Width = 120;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Contract Number";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[1].TabStop = false;
            e.Layout.Bands[0].Columns[1].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[1].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[1].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[2].Width = 150;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Grantee/Contractor";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[2].TabStop = false;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[3].Width = 80;
            e.Layout.Bands[0].Columns[3].Header.Caption = "Project Name";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[3].TabStop = false;
            e.Layout.Bands[0].Columns[3].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[3].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[3].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[4].Width = 70;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Term Date";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[4].TabStop = false;
            e.Layout.Bands[0].Columns[4].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[4].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[4].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[5].Width = 100;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Monitoring Alert";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[5].TabStop = false;
            e.Layout.Bands[0].Columns[5].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[5].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[5].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[6].Width = 80;
            e.Layout.Bands[0].Columns[6].Hidden = true;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Last Claim Sched Date";
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[6].TabStop = false;
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            
            e.Layout.Bands[0].Columns[7].Width = 100;
            e.Layout.Bands[0].Columns[7].Header.Caption = "Contract Status";
            e.Layout.Bands[0].Columns[7].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[7].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            e.Layout.Bands[0].Columns[7].ValueList = uwgCompleteContractLog.DisplayLayout.ValueLists["Status"];
            e.Layout.ValueLists["Status"].DisplayStyle = Infragistics.Win.ValueListDisplayStyle.DisplayText;

            e.Layout.Bands[0].Columns[8].Width = 100;
            e.Layout.Bands[0].Columns[8].Header.Caption = "Project Type";
            e.Layout.Bands[0].Columns[8].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[8].TabStop = false;
            e.Layout.Bands[0].Columns[8].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[8].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[8].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[9].Width = 150;
            e.Layout.Bands[0].Columns[9].Header.Caption = "Region";
            e.Layout.Bands[0].Columns[9].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[9].TabStop = false;
            e.Layout.Bands[0].Columns[9].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[9].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[9].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[10].Width = 150;
            e.Layout.Bands[0].Columns[10].Header.Caption = "County";
            e.Layout.Bands[0].Columns[10].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[10].TabStop = false;
            e.Layout.Bands[0].Columns[10].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[10].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[10].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[11].Width = 100;
            e.Layout.Bands[0].Columns[11].Header.Caption = "Project Contract Manager";
            e.Layout.Bands[0].Columns[11].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[11].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            e.Layout.Bands[0].Columns[11].ValueList = uwgCompleteContractLog.DisplayLayout.ValueLists["Name"];
            e.Layout.ValueLists["Name"].DisplayStyle = Infragistics.Win.ValueListDisplayStyle.DisplayText;

            e.Layout.Bands[0].Columns[12].Width = 100;
            e.Layout.Bands[0].Columns[12].Header.Caption = "Flag";
            e.Layout.Bands[0].Columns[12].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[12].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;
            
            e.Layout.Bands[0].Columns[13].Width = 100;
            e.Layout.Bands[0].Columns[13].Header.Caption = "Notes";
            e.Layout.Bands[0].Columns[13].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            
            //Dirty Flag
            e.Layout.Bands[0].Columns[14].Hidden = true;

            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;
        }

        private void btnViewContract_Click(object sender, EventArgs e)
        {
            OpenContractDetail();
        }

        private void btnViewMonitoringDetails_Click(object sender, EventArgs e)
        {
            UltraGridRow row = uwgCompleteContractLog.ActiveRow;
            if (null != row)
            {
                int cid = Convert.ToInt32(uwgCompleteContractLog.ActiveRow.Cells[0].Value);
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenMonitoring(cid);
                //MonitoringDetails md = new MonitoringDetails(cid);
                ////this.Close();
                //md.MdiParent = fm;
                //md.Show();
            }
            else
            {
                MessageBox.Show("Please select a single row !!");
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            SaveCompletedContract();
        }

        private void SaveCompletedContract()
        {
            if (blnViewOnly)
                return;

            int k = 0;
            for (int i = 0; i < uwgCompleteContractLog.Rows.Count; i++)
            {
                if (uwgCompleteContractLog.Rows[i].Cells["DirtyFlag"].Value.ToString() == "1")
                {
                    string s = uwgCompleteContractLog.Rows[i].Cells["StatusCode"].Text.ToString();
                    string s1 = uwgCompleteContractLog.Rows[i].Cells["ProjectManagerId"].Text.ToString();
                    int retVal = ContractData.CompleteContractUpdate(
                            uwgCompleteContractLog.Rows[i].Cells[0].Value
                            , uwgCompleteContractLog.Rows[i].Cells["StatusCode"].ValueListResolved.GetValue(s, ref k)
                            , uwgCompleteContractLog.Rows[i].Cells["ProjectManagerId"].ValueListResolved.GetValue(s1, ref k)
                            , uwgCompleteContractLog.Rows[i].Cells["isFlagged"].Value
                            , uwgCompleteContractLog.Rows[i].Cells["FlagNote"].Value
                            );
                    if (retVal == -1)
                    {
                        MessageBox.Show("Update failed ", "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }

                    ContractData.ProjectProjectManagerInsert(Convert.ToInt32(uwgCompleteContractLog.Rows[i].Cells[0].Value));

                    if (uwgCompleteContractLog.Rows[i].Cells["StatusCode"].Text == "Closed")
                    {
                        DialogResult res = MessageBox.Show("Do you want to complete the closing comments now for Contract Number (" + Convert.ToString(uwgCompleteContractLog.Rows[i].Cells["ContractNumber"].Value) + ") ?", "Warning", MessageBoxButtons.YesNo);
                        if (res == DialogResult.Yes)
                        {
                            Form1 fm = (Form1)this.MdiParent;
                            fm.OpenContract(Convert.ToString(uwgCompleteContractLog.Rows[i].Cells["ContractNumber"].Value));
                        }
                    }
                }
            }

            LoadCompleteContractGrid();
        }

        private void CompleteContractLog_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (blnViewOnly)
                return;

            if (blnDataChange == true)
            {
                DialogResult intResult = MessageBox.Show("Do You want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (intResult == DialogResult.Yes)
                {
                    SaveCompletedContract();
                }
            }
        }

        private void uwgCompleteContractLog_DoubleClickRow(object sender, DoubleClickRowEventArgs e)
        {
            OpenContractDetail();
        }

        private void OpenContractDetail()
        {
            if (uwgCompleteContractLog.ActiveRow != null)
            {
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenContract(uwgCompleteContractLog.ActiveRow.Cells["ContractNumber"].Value.ToString());
                //ContractDetail cd = new ContractDetail(uwgCompleteContractLog.ActiveRow.Cells[1].Value.ToString());
                //cd.MdiParent = fm;
                //cd.Show();
            }
        }

        private void uwgCompleteContractLog_AfterCellUpdate(object sender, CellEventArgs e)
        {
            if (blnViewOnly)
                return;

            blnDataChange = true;
            btnSave.Enabled = true;

            //check for not 1 is not compatible with grid filtering, changed to check for 0.
            //if (uwgCompleteContractLog.ActiveRow.Cells["DirtyFlag"].Value.ToString() != "1")
            if (uwgCompleteContractLog.ActiveRow.Cells["DirtyFlag"].Value.ToString() == "0")
                uwgCompleteContractLog.ActiveRow.Cells["DirtyFlag"].Value = "1";
        }

        private void CompleteContractLog_Activated(object sender, EventArgs e)
        {
            LoadCompleteContractGrid();
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {

        }

        private void btnExport_Click(object sender, EventArgs e)
        {
            string excelFile = GlobalCode.ExcelFileName("c:\\Temp", "ccpm_export.xls", false);
            if (excelFile != string.Empty)
            {
                GlobalCode.ExportGridToExcel(uwgCompleteContractLog, excelFile);
                GlobalCode.OpenAssociatedFile(excelFile);
            }
        }

        private void btnFilter_Click(object sender, EventArgs e)
        {
            GridFilter gf = new GridFilter(uwgCompleteContractLog, lblFilter, lblFilterOn, this.Text);
            gf.ShowDialog();
            if (lblFilter.Text != string.Empty)
            {
                label4.Visible = true;
            }
            else
            {
                label4.Visible = false;
            }
        }

        private void uwgCompleteContractLog_Enter(object sender, EventArgs e)
        {
            if (uwgCompleteContractLog.Rows.Count > 0)
                uwgCompleteContractLog.Rows[0].Cells[1].Activate();
        }

        private void btnRefresh_Click_1(object sender, EventArgs e)
        {
            label4.Visible = false;
            LoadCompleteContractGrid();
        }

        private void uwgCompleteContractLog_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == Convert.ToChar(Keys.Tab))
            {
                uwgCompleteContractLog.ActiveCell.Selected = true;
            }   
        }

        private void btnSeeAll_Click(object sender, EventArgs e)
        {
            label4.Visible = false;
            LoadCompleteContractGridAll();
        }
        private void LoadCompleteContractGridAll()
        {
            lblFilter.Text = "";
            lblFilterOn.Text = "";
            uwgCompleteContractLog.DisplayLayout.Bands[0].ColumnFilters.ClearAllFilters();

            LoadData();
            if (uwgCompleteContractLog.Rows.Count < 1)
            {
                btnViewContract.Enabled = false;
                btnViewMonitoringDetails.Enabled = false;
            }
            blnDataChange = false;
            btnSave.Enabled = false;
        }

        private void LoadData()
        {
            this.Cursor = Cursors.WaitCursor;
            DataSet dsCompleteContractLog = ContractData.GetCompleteContractLog();
            this.Cursor = Cursors.Default;
            uwgCompleteContractLog.DataSource = dsCompleteContractLog.Tables[0];
            uwgCompleteContractLog.DataBind();
        }

    }

}
