﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CCPM.Data;

namespace CCPM.Contract
{
    public partial class ContractAmedment : Form
    {
        public ContractDetail MyParentForm;
        public string FundingSource
        {
            get { return cmbFundingSource.Text; }
        }
        public decimal Amount
        {
            get { return Convert.ToDecimal(txtAmount.Text); }
        }
        public ContractAmedment(int ContractId)
        {
            InitializeComponent();
            DataSet ds = ContractData.GetContractFundingSource(ContractId);
            cmbFundingSource.DataSource = ds.Tables[0];
            cmbFundingSource.DisplayMember = "FundingItem";
            cmbFundingSource.ValueMember = "FundID";
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if (txtAmount.Text != string.Empty && cmbFundingSource.Text != string.Empty)
            {
                DialogResult = DialogResult.OK;
                this.Close();
            }
            else
            {
                MessageBox.Show("Please select the funding source and enter the Amount", "Data Entry Error", MessageBoxButtons.OK);
            }
        }

        private void txtAmount_TextChanged(object sender, EventArgs e)
        {
            string patern = @"[^0-9\.]*";
            txtAmount.Text = System.Text.RegularExpressions.Regex.Replace(txtAmount.Text, patern, string.Empty);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
