﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using CCPM.Data;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Contract
{
    public partial class ContractByFundingSourceLog : Form
    {
        DataSet dsContractByFundSource = null;
        public ContractByFundingSourceLog()
        {
            InitializeComponent();

            this.Location = new Point(0, 0);
            uwgContractByFundingSourceLog.DisplayLayout.Override.WrapHeaderText = DefaultableBoolean.True;
            uwgContractByFundingSourceLog.DisplayLayout.Override.HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction.SortSingle;
            LoadContractByFundingSourceLogAll();

           
        }

        private void ContractByFundingSourceLog_Shown(object sender, EventArgs e)
        {
            MessageBox.Show("Note that this log is geared toward fund source information. Because \n" +
                            "some contracts have more than one fund source, there may be more than \n" +
                            "one listing per contract. \n \n" +
                            "If you want a complete picture of a particular contract, either sort or \n" +
                            "filter based on Contract Number OR select an entry and go to Contract Details. \n \n" +
                            "If you want to view all information on a project that might have multiple \n" +
                            "contracts, either sort or filter based on Project Name OR select an entry \n" +
                            "and go to Project Details.");
        }

        private void LoadContractByFundingSourceLog()
        {
            if (uwgContractByFundingSourceLog.DataSource != null)
            {
                // Load the data in the grid
                LoadData();
            }
            if (uwgContractByFundingSourceLog.Rows.Count < 1)
            {
                btnGoToContract.Enabled = false;
                btnGoToInvoice.Enabled = false;
                btnGoToProject.Enabled = false;
                btnGoToRepayment.Enabled = false;
            }
            else
            {
                btnGoToContract.Enabled = true;
                btnGoToInvoice.Enabled = true;
                btnGoToProject.Enabled = true;
                btnGoToRepayment.Enabled = true;
            }
        }
        private void LoadData()
        {
            this.Cursor = Cursors.WaitCursor;
            DataSet dsContractByFundSource = ContractData.GetContractByFundSourceLog();
            this.Cursor = Cursors.Default;
            uwgContractByFundingSourceLog.DataSource = dsContractByFundSource.Tables[0];
            uwgContractByFundingSourceLog.DataBind();
        }

        private void LoadContractByFundingSourceLogAll()
        {
            lblFilter.Text = "";
            lblFilterOn.Text = "";
            this.uwgContractByFundingSourceLog.DisplayLayout.Bands[0].ColumnFilters.ClearAllFilters();

            // Load the data in the grid
            LoadData();
            if (uwgContractByFundingSourceLog.Rows.Count < 1)
            {
                btnGoToContract.Enabled = false;
                btnGoToInvoice.Enabled = false;
                btnGoToProject.Enabled = false;
                btnGoToRepayment.Enabled = false;
            }
            else
            {
                btnGoToContract.Enabled = true;
                btnGoToInvoice.Enabled = true;
                btnGoToProject.Enabled = true;
                btnGoToRepayment.Enabled = true;
            }
        }

        private void uwgContractByFundingSourceLog_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //Contract Id
            e.Layout.Bands[0].Columns[0].Hidden = true;

            e.Layout.Bands[0].Columns[1].Width = 180;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Fund Source";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[1].TabStop = false;
            e.Layout.Bands[0].Columns[1].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[1].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[1].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[2].Width = 120;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Fund Name";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[2].TabStop = false;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[3].Width = 80;
            e.Layout.Bands[0].Columns[3].Header.Caption = "Fiscal Year";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[3].TabStop = false;
            e.Layout.Bands[0].Columns[3].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[3].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[3].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[4].Width = 120;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Contract Number";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[4].TabStop = false;
            e.Layout.Bands[0].Columns[4].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[4].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[4].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[5].Width = 120;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Project Name";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[5].TabStop = false;
            e.Layout.Bands[0].Columns[5].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[5].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[5].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[6].Width = 70;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Liquidation Date";
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[6].TabStop = false;
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[7].Width = 100;
            e.Layout.Bands[0].Columns[7].Header.Caption = "Liquidation Alert";
            e.Layout.Bands[0].Columns[7].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[7].TabStop = false;
            e.Layout.Bands[0].Columns[7].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[7].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[7].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[8].Width = 80;
            e.Layout.Bands[0].Columns[8].Header.Caption = "Completion Date";
            e.Layout.Bands[0].Columns[8].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[8].TabStop = false;
            e.Layout.Bands[0].Columns[8].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[8].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[8].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[9].Width = 80;
            e.Layout.Bands[0].Columns[9].Header.Caption = "Termination Date";
            e.Layout.Bands[0].Columns[9].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[9].TabStop = false;
            e.Layout.Bands[0].Columns[9].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[9].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[9].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[10].Width = 110;
            e.Layout.Bands[0].Columns[10].Header.Caption = "Amount Under Contract from the Fund Source";
            e.Layout.Bands[0].Columns[10].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[10].TabStop = false;
            e.Layout.Bands[0].Columns[10].Format = "$###,###,##0.00";
            e.Layout.Bands[0].Columns[10].CellAppearance.TextHAlign = HAlign.Right;
            e.Layout.Bands[0].Columns[10].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[10].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[10].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[11].Width = 70;
            e.Layout.Bands[0].Columns[11].Header.Caption = "Balance To-Date";
            e.Layout.Bands[0].Columns[11].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[11].TabStop = false;
            e.Layout.Bands[0].Columns[11].Format = "$###,###,##0.00";
            e.Layout.Bands[0].Columns[11].CellAppearance.TextHAlign = HAlign.Right;
            e.Layout.Bands[0].Columns[11].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[11].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[11].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[12].Width = 80;
            e.Layout.Bands[0].Columns[12].Header.Caption = "Region";
            e.Layout.Bands[0].Columns[12].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[12].TabStop = false;
            e.Layout.Bands[0].Columns[12].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[12].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[12].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[13].Width = 150;
            e.Layout.Bands[0].Columns[13].Header.Caption = "Grantee/Contractor";
            e.Layout.Bands[0].Columns[13].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[13].TabStop = false;
            e.Layout.Bands[0].Columns[13].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[13].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[13].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[14].Width = 100;
            e.Layout.Bands[0].Columns[14].Header.Caption = "Project Contract Manager";
            e.Layout.Bands[0].Columns[14].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[14].TabStop = false;
            e.Layout.Bands[0].Columns[14].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[14].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[14].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            //DirtyFlag
            e.Layout.Bands[0].Columns[15].Hidden = true;
            //ProjectId
            e.Layout.Bands[0].Columns[16].Hidden = true;
            //FundId
            e.Layout.Bands[0].Columns[17].Hidden = true;

            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;
        }

        private void OpenContractDetail()
        {
            if (uwgContractByFundingSourceLog.ActiveRow != null) 
            {
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenContract(Convert.ToString(uwgContractByFundingSourceLog.ActiveRow.Cells[4].Value));
            }
        }

        private void btnGoToContract_Click(object sender, EventArgs e)
        {
            OpenContractDetail();
        }

        private void btnGoToRepayment_Click(object sender, EventArgs e)
        {
            Form1 fm = (Form1)this.MdiParent;
            fm.OpenRepayment(Convert.ToInt32(uwgContractByFundingSourceLog.ActiveRow.Cells[0].Value));
        }

        private void btnGoToInvoice_Click(object sender, EventArgs e)
        {
            Form1 fm = (Form1)this.MdiParent;
            fm.OpenInvoiceDrawdown(Convert.ToInt32(uwgContractByFundingSourceLog.ActiveRow.Cells[0].Value), Convert.ToInt32(uwgContractByFundingSourceLog.ActiveRow.Cells[17].Value));
        }

        private void btnGoToProject_Click(object sender, EventArgs e)
        {
            Form1 mainForm = (Form1)this.MdiParent;
            mainForm.OpenProject(Convert.ToInt32(uwgContractByFundingSourceLog.ActiveRow.Cells[16].Value), ProjectData.GetProjectName(Convert.ToInt32(uwgContractByFundingSourceLog.ActiveRow.Cells[16].Value)));
            CCPM.Project.ProjectForm projectForm = null;
            mainForm.GetCurrentProject(out projectForm);
            projectForm.SetTabIndex(0); 
        }

        private void ContractByFundingSourceLog_Activated(object sender, EventArgs e)
        {
            LoadContractByFundingSourceLog();
        }

        private void uwgContractByFundingSourceLog_DoubleClickRow(object sender, DoubleClickRowEventArgs e)
        {
            OpenContractDetail();
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            label4.Visible = false;
            LoadContractByFundingSourceLog();
        }

        private void btnExport_Click(object sender, EventArgs e)
        {
            string excelFile = GlobalCode.ExcelFileName("c:\\Temp", "ccpm_export.xls", false);
            if (excelFile != string.Empty)
            {
                GlobalCode.ExportGridToExcel(uwgContractByFundingSourceLog, excelFile);
                GlobalCode.OpenAssociatedFile(excelFile);
            }
        }

        private void btnFilter_Click(object sender, EventArgs e)
        {
            GridFilter gf = new GridFilter(uwgContractByFundingSourceLog, lblFilter, lblFilterOn, this.Text);
            gf.ShowDialog();
            if (lblFilter.Text != string.Empty)
            {
                label4.Visible = true;
            }
            else
            {
                label4.Visible = false;
            }
        }

        private void uwgContractByFundingSourceLog_Enter(object sender, EventArgs e)
        {
            if (uwgContractByFundingSourceLog.Rows.Count > 0)
                uwgContractByFundingSourceLog.Rows[0].Cells[1].Activate();
        }

        private void uwgContractByFundingSourceLog_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == Convert.ToChar(Keys.Tab))
            {
                uwgContractByFundingSourceLog.ActiveCell.Selected = true;
            }   
        }

        private void btnSeeAll_Click(object sender, EventArgs e)
        {
            label4.Visible = false;
            LoadContractByFundingSourceLogAll();

        }

    }
}
