﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinEditors;
using CCPM.Data;
using Microsoft.ApplicationBlocks.Data;
using System.Data.SqlTypes;

namespace CCPM.Contract
{
    public partial class ContractDetail : Form
    {
        private string projectId;
        private string contractNumber;
        public decimal TotalFundingSourceAmount;
        DataSet dsAmendment;
        public DataSet dsFundingSource;
        DataTable dtOrganization;
        DataTable dtContact;
        DataTable dtAddress;
        int cid = 0;
        int pid = 0;
        int orgid = 0;
        int orgaddressid = 0;
        int contactid = 0;
        int contractstatusid = 0;
        int projectmanagerid = 0;
        int primaryprojectmanagerid = 0;
        int contracttypeid = 0;
        int newStatusId = 0;
        string projecttitle = "";
        string t = ""; bool sbe; bool dvbe; bool condition; bool repay; bool monitoring;
        string ph = ""; string tax = ""; string pname = ""; string purpose = ""; string boxnumber = "";
        string fax = ""; string email = "";
        string closingremarks = "";
        private bool blnDataChanged = false;    //for form
        private bool blnDataDirty = false;      //for grids
        private bool blnDataValid = true;
        private bool blnReduceAmount = false;
        private bool blnDataLoaded = false;
        bool blnDisplay1 = false;
        bool blnSkip = false;


        bool blnDisplay = false;
        object dtCompletionDate;

        public int ContractId
        {
            get { return cid; }
        }

        public string cnumber
        {
            get { return contractNumber; }
        }

        public string ProjectId
        {
            get { return projectId; }
            set { projectId = value; }
        }



        public ContractDetail(string number)
        {
            InitializeComponent();
            this.Location = new Point(0, 0);
            contractNumber = number;
            LoadContractDetailsPage();
            //cmbStatus.SelectedIndex = 0;
            SetSecurity();
            blnDisplay1 = false;
        }

        public ContractDetail(int ContractId)
        {
            InitializeComponent();
            this.Location = new Point(0, 0);
            cid = ContractId;
            LoadContractDetailsPage();
            //cmbStatus.SelectedIndex = 0;
            SetSecurity();
            blnDisplay1 = false;
        }

        public void RefreshContract()
        {
            LoadContractDetailsPage();
            this.Refresh();
        }

        private void SetSecurity()
        {
            //contract number by contracts manager or staff when blank
            if (GlobalSettings.IsContractsManager)
            {
                txtContractNumber.ReadOnly = false;
                txtContractNumber.ReadOnly = false;
                txtContractNumber.ReadOnly = false;
            }
            else if (txtContractNumber.Text == String.Empty && (GlobalSettings.IsContractsManager || GlobalSettings.IsContractsStaff))
            {
                txtContractNumber.ReadOnly = false;
            }

            //delete contract by Contracts Manager only
            if (GlobalSettings.IsContractsManager)
            {
                btnDelete.Enabled = true;
            }
            else
            {
                btnDelete.Enabled = false;
            }

            //Conditions Met by Contracts Manager & Contrats Staff 
            if (GlobalSettings.IsContractsManager || GlobalSettings.IsContractsStaff)
            {
                chkCondition.Enabled = true;
            }
            else
            {
                chkCondition.Enabled = false;
            }

            if (GlobalSettings.IsContractsManager || GlobalSettings.IsAccountingManager || GlobalSettings.IsContractsStaff)
            {
                //can edit the rest
            }
            else
            {
                //all other roles can only edit the following items
                //•	Grantee/Contractor
                //•	Tax ID Number
                //•	Contact Person
                //•	Address
                //•	Phone
                //•	SBE
                //•	DVBE
                //•	Certification Number
                //•	Contract Type
                //•	Project Manager
                //•	Contract Conditions Met
                //•	Repayment Required
                //•	Monitoring Required
                //•	Notes

                chkRepayment.Enabled = false;
                cmbGrantee.Enabled = false;
                cmbContactPerson.Enabled = false;
                cmbAddress.Enabled = false;
                txtTaxId.Enabled = false;
                chkSBE.Enabled = false;
                chkDVBE.Enabled = false;
                txtCertNumber.Enabled = false;
                cmbContractType.Enabled = false;

                cmbStatus.Enabled = false;
                uwdtClosedDate.Enabled = false;
                uwdtCompletionDate.Enabled = false;
                uwdtTerminationDate.Enabled = false;
                uwdtDateExecuted.Enabled = false;
                txtBoxNumber.Enabled = false;

                btnAddAmendment.Enabled = false;
                btnDeleteAmendment.Enabled = false;
                btnSaveAmendment.Enabled = false;
                btnAddFund.Enabled = false;
                btnDeleteFund.Enabled = false;
                btnSaveFund.Enabled = false;

                //project mgr can edit purpose
                if (!GlobalSettings.IsProjectManager)
                    txtPurpose.Enabled = false;

                //txtClosingRemark.Enabled = false;

                UltraGridBand band = uwgAmendment.DisplayLayout.Bands[0];
                band.Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;

                band = uwgContractFund.DisplayLayout.Bands[0];
                band.Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
                band.Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            }
        }

        private void LoadContractDetailsPage()
        {
            blnDataLoaded = false;
            LoadContractDetail();
            LoadComboData();

            LoadGridFS();

            // Create and Bind Funding Source dataset
            dsFundingSource = ContractData.GetProjectFundingSource(Convert.ToInt32(pid));
            uwgContractFund.DisplayLayout.ValueLists.Clear();
            uwgContractFund.DisplayLayout.ValueLists.Add("FundingItem");

            for (int i = 0; i < dsFundingSource.Tables[0].Rows.Count; i++)
            {
                Infragistics.Win.ValueListItem listItem = new Infragistics.Win.ValueListItem();
                listItem.DataValue = dsFundingSource.Tables[0].Rows[i].ItemArray.GetValue(0);
                listItem.DisplayText = (string)dsFundingSource.Tables[0].Rows[i].ItemArray.GetValue(1) + " " + (string)dsFundingSource.Tables[0].Rows[i].ItemArray.GetValue(2);
                uwgContractFund.DisplayLayout.ValueLists["FundingItem"].ValueListItems.Add(listItem);
            }

            LoadAmendmentGrid(cid);
            LoadFundSourceGrid(cid);
            LoadFundSourceGridTotal();
            LoadContractNote();


            blnDataDirty = false;
            blnDataChanged = false;
            blnDataLoaded = true;
        }


        private void LoadAddresses()
        {
            if (orgid > 0)
            {
                DataSet ds1 = null;
                ds1 = ContactData.OrganizationAddresses(pid, orgid);
                dtAddress = ds1.Tables[0];
                cmbAddress.DataSource = null;
                cmbAddress.DataSource = dtAddress;
                cmbAddress.ValueMember = "OrgAddressId";
                cmbAddress.DisplayMember = "FullAddress";
                if (orgaddressid > 0)
                    GlobalCode.ComboSetValue(cmbAddress, orgaddressid);
                else
                    cmbAddress.SelectedIndex = -1;
            }
        }

        private void LoadOrganizations()
        {
            DataSet ds1 = null;
            ds1 = ProjectData.ProjectOrganizations(pid, 1);
            dtOrganization = ds1.Tables[0];
            cmbGrantee.DataSource = null;
            cmbGrantee.DataSource = dtOrganization;
            cmbGrantee.ValueMember = "OrgId";
            cmbGrantee.DisplayMember = "Organization";
            if (orgid > 0)
                GlobalCode.ComboSetValue(cmbGrantee, orgid);
            else
                cmbGrantee.SelectedIndex = -1;
        }

        private void LoadContacts()
        {
            if (orgid > 0)
            {
                DataSet ds1 = null;
                ds1 = ContactData.OrganizationContacts(pid, orgid);
                dtContact = ds1.Tables[0];
                cmbContactPerson.DataSource = null;
                cmbContactPerson.DataSource = dtContact;
                cmbContactPerson.ValueMember = "ContactId";
                cmbContactPerson.DisplayMember = "ContactName";
                if (contactid > 0)
                    GlobalCode.ComboSetValue(cmbContactPerson, contactid);
                else
                    cmbContactPerson.SelectedIndex = -1;
            }
        }

        private void LoadComboData()
        {
            LoadOrganizations();
            LoadAddresses();
            LoadContacts();

            DataSet ds1 = null;
            ds1 = ProjectData.ProjectStaffList();
            cmbProjectManager.DataSource = ds1.Tables[0];
            cmbProjectManager.DisplayMember = "Name";
            cmbProjectManager.ValueMember = "ProjectManagerId";
            if (projectmanagerid > 0)
                GlobalCode.ComboSetValue(cmbProjectManager, projectmanagerid);


            blnSkip = true;
            ds1 = null;
            ds1 = ContractData.GetContractStatus();
            cmbStatus.DataSource = null;
            cmbStatus.DataSource = ds1.Tables[0];
            cmbStatus.DisplayMember = "StatusCode";
            cmbStatus.ValueMember = "ContractStatusId";
            if (contractstatusid > 0)
                GlobalCode.ComboSetValue(cmbStatus, contractstatusid);
            blnSkip = false;

            ds1 = null;
            ds1 = ContractData.GetContractType();
            cmbContractType.DataSource = null;
            cmbContractType.DataSource = ds1.Tables[0];
            cmbContractType.DisplayMember = "TypeCode";
            cmbContractType.ValueMember = "ContractTypeId";
            if (contracttypeid > 0)
                GlobalCode.ComboSetValue(cmbContractType, contracttypeid);
            else
                cmbContractType.SelectedIndex = -1;
        }

        private void LoadContractDetail()
        {
            DataSet ds = null;
            DataRow dr = null;

            if (cid == 0 && contractNumber != string.Empty)
            {
                ds = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "SELECT ContractId FROM ContractDetails WHERE ContractNumber = '" + contractNumber + "'");
                if (ds.Tables[0].Rows.Count > 0)
                    cid = (int)ds.Tables[0].Rows[0]["ContractId"];
            }

            ds = ContractData.GetContractDetail(cid);
            if (ds.Tables[0].Rows.Count > 0)
            {
                dr = ds.Tables[0].Rows[0];
                txtContractNumber.Text = (string)dr["ContractNumber"];
                orgid = GlobalCode.ToInt32(dr["GranteeId"]);
                orgaddressid = GlobalCode.ToInt32(dr["OrgAddressId"]);
                contactid = GlobalCode.ToInt32(dr["ContactPersonId"]);
                //txtPhone.Text = Convert.ToString(dr["GeneralPhone"]);
                ph = txtPhone.Text = System.Convert.ToString(dr["GeneralPhone"]);
                fax = txtFax.Text = System.Convert.ToString(dr["Fax"]);
                email = txtEmail.Text = System.Convert.ToString(dr["Email"]);
                contractstatusid = GlobalCode.ToInt32(dr["ContractStatusId"]);
                projectmanagerid = GlobalCode.ToInt32(dr["ProjectManagerId"]);
                primaryprojectmanagerid = GlobalCode.ToInt32(dr["CurrentPM"]);
                contracttypeid = GlobalCode.ToInt32(dr["ContractTypeId"]);
                //s = cmbStatus.Text = System.Convert.ToString(dr["StatusCode"]);
                //t = cmbContractType.Text = System.Convert.ToString(dr["TypeCode"]);
                txtContractTotal.Text = decimal.Parse(dr["ContractedAmount"].ToString()).ToString(GlobalSettings.MoneyFormat);
                txtBalance.Text = decimal.Parse(dr["Balance"].ToString()).ToString(GlobalSettings.MoneyFormat);
                txtDisencumbered.Text = decimal.Parse(dr["Disencumbered"].ToString()).ToString(GlobalSettings.MoneyFormat);

                txtProjectNumber.Text = System.Convert.ToString(dr["FileNumber"]);
                pid = Convert.ToInt32(dr["ProjectId"]);
                tax = txtTaxId.Text = System.Convert.ToString(dr["TaxId"]);
                cid = System.Convert.ToInt32(dr["ContractId"]);
                uwdtDateExecuted.Value = Convert.ToString(dr["ExecutedDate"]);
                uwdtCompletionDate.Value = Convert.ToString(dr["CompletedDate"]);
                uwdtTerminationDate.Value = Convert.ToString(dr["TerminationDate"]);
                uwdtClosedDate.Value = Convert.ToString(dr["ClosedDate"]);
                chkSBE.Checked = Convert.ToBoolean(dr["SBE"]);
                sbe = chkSBE.Checked = Convert.ToBoolean(dr["SBE"]);
                chkDVBE.Checked = Convert.ToBoolean(dr["DVBE"]);
                dvbe = chkDVBE.Checked = Convert.ToBoolean(dr["DVBE"]);
                txtCertNumber.Text = dr["CertificationNumber"].ToString();
                chkRepayment.Checked = Convert.ToBoolean(dr["IsRepaymentRequired"]);
                repay = chkRepayment.Checked = Convert.ToBoolean(dr["IsRepaymentRequired"]);
                chkMonitoring.Checked = Convert.ToBoolean(dr["IsMonitoringRequired"]);
                monitoring = chkMonitoring.Checked = Convert.ToBoolean(dr["IsMonitoringRequired"]);
                txtRegionalManager.Text = Convert.ToString(dr["RName"]);
                txtAttorney.Text = Convert.ToString(dr["ProjectAttorneyNames"]);
                pname = cmbProjectManager.Text = Convert.ToString(dr["PName"]);
                txtPurpose.Text = Convert.ToString(dr["Purpose"]);
                purpose = txtPurpose.Text = Convert.ToString(dr["Purpose"]);
                txtPaid.Text = decimal.Parse(dr["PaidToDate"].ToString()).ToString(GlobalSettings.MoneyFormat);
                txtWithheld.Text = decimal.Parse(dr["WithheldToDate"].ToString()).ToString(GlobalSettings.MoneyFormat);
                chkCondition.Checked = Convert.ToBoolean(dr["AreContractsConditionMet"]);
                condition = chkCondition.Checked = Convert.ToBoolean(dr["AreContractsConditionMet"]);
                txtBoxNumber.Text = Convert.ToString(dr["BoxNumber"]);
                boxnumber = txtBoxNumber.Text = Convert.ToString(dr["BoxNumber"]);
                txtClosingRemark.Text = Convert.ToString(dr["ClosingRemarks"]);
                closingremarks = txtClosingRemark.Text = Convert.ToString(dr["ClosingRemarks"]);
                chkFlag.Checked = Convert.ToBoolean(dr["isFlagged"]);
                txtFlagNote.Text = Convert.ToString(dr["FlagNote"]);
                label13.Text = "Contract Details    (" + Convert.ToString(dr["ProjectName"]) + ")";
                projecttitle = Convert.ToString(dr["ProjectName"]);
                LoadContractNote();
            }
            else
            {
                DataSet dsProjectNumber = null;
                if (pid > 0)
                {
                    dsProjectNumber = ContractData.GetProjectNumber(pid);
                }
                else
                {
                    pid = GlobalCode.ToInt32(contractNumber);
                    dsProjectNumber = ContractData.GetProjectNumber(pid);
                }
                DataRow dr1 = dsProjectNumber.Tables[0].Rows[0];
                txtProjectNumber.Text = Convert.ToString(dr1["FileNumber"]);
                label13.Text = "Contract Details    (" + Convert.ToString(dr1["ProjectName"]) + ")";

                string contractInfo = "(" + txtContractNumber.Text + ")";
                if (txtContractNumber.Text.Trim() == "") contractInfo = " - New (" + Convert.ToString(dr1["ProjectName"]) + ")";
                this.Text = "Contract Details " + contractInfo;

                projectmanagerid = GlobalCode.ToInt32(ContractData.GetValue("select CurrentPM from Project where ProjectId = " + pid.ToString()));
                primaryprojectmanagerid = projectmanagerid;

            }
            // Fill Total to Repay textbox

            ds = null; dr = null;
            ds = ContractData.GetTotalReimbAmount(cid);
            dr = ds.Tables[0].Rows[0];
            if (dr[0].ToString() == string.Empty)
            {
                txtTotalToRepay.Text = "$.00";
            }
            else
            {
                txtTotalToRepay.Text = decimal.Parse(dr[0].ToString()).ToString(GlobalSettings.MoneyFormat);
            }

            // Fill Repayment Balance testbox
            ds = null; dr = null;
            ds = ContractData.GetTotalRepaidAmount(cid);
            if (ds.Tables[0].Rows.Count > 0)
            {
                dr = ds.Tables[0].Rows[0];
                txtRepaymentBalance.Text = (GlobalCode.ToDecimal(txtTotalToRepay.Text) - GlobalCode.ToDecimal(dr["RepaidAmount"])).ToString(GlobalSettings.MoneyFormat);
            }
            else
            {
                txtRepaymentBalance.Text = "$.00";
            }
            //grant default
            if (contracttypeid == 0)
                contracttypeid = 1;
        }

        private void LoadContractNote()
        {
            txtNotes.Text = ContractData.GetContractNote(cid);
        }

        private void LoadAmendmentGrid(int cId1)
        {
            dsAmendment = ContractData.GetContractAmendment(cId1);
            uwgAmendment.DataSource = dsAmendment.Tables[0];
            uwgAmendment.DataBind();
        }

        private void LoadFundSourceGrid(int cId1)
        {
            DataSet dsContractFund = ContractData.GetContractFund(cId1);
            uwgContractFund.DataSource = dsContractFund.Tables[0];
            uwgContractFund.DataBind();
        }
        private void LoadGridFS()
        {
            //Create the funding source dataset and bind to the (dropdown list) grid
            dsFundingSource = ContractData.GetProjectFundingSource(Convert.ToInt32(pid));
            dsFundingSource.Tables[0].Columns.Add("FundingItemActive", typeof(string), "FundingItem + ' ' + IsActive");
            ugFundingSourceDropdown.DataSource = dsFundingSource.Tables[0];
            ugFundingSourceDropdown.DataBind();
        }

        private void RefreshAmendmentLog()
        {
            Form[] fMdiChildren = this.ParentForm.MdiChildren;
            for (int iForms = 0; iForms <= fMdiChildren.Length - 1; iForms++)
            {
                if (fMdiChildren[iForms].Name == "AmendmentsLog")
                {
                    AmendmentsLog amdLog = (AmendmentsLog)fMdiChildren[iForms];
                    amdLog.UpdateForm();
                    break;
                }
            }
        }
        private void btnSave_Click(object sender, EventArgs e)
        {
            if (!SaveContractDetail())
                return;
            SaveAmendmentGrid();
            SaveFundSourceGrid();
            contractNumber = txtContractNumber.Text;
            LoadContractDetailsPage();
            Point p = new Point(0, 0);
            this.AutoScrollPosition = p;

            bool found = false;
            for (int i = 0; i < this.MdiParent.MdiChildren.Length; i++)
            {
                if (this.MdiParent.MdiChildren[i] as CCPM.Project.ProjectForm != null)
                {
                    if (((CCPM.Project.ProjectForm)this.MdiParent.MdiChildren[i]).ProjectId == pid)
                    {
                        found = true;
                        ((CCPM.Project.ProjectForm)this.MdiParent.MdiChildren[i]).RefreshContracts();
                        break;
                    }
                }
            }

        }

        private bool SaveContractDetail()
        {
            if (txtContractNumber.Text == string.Empty)
            {
                MessageBox.Show("Missing contract number.");
                txtContractNumber.Focus();
                return false;
            }


            if (ContractData.IsContractNumberDuplicate(txtContractNumber.Text, cid))
            {
                MessageBox.Show("Contract number is already being used.", "Duplicate contract number.");
                txtContractNumber.Focus();
                return false;
            }

            if (cmbGrantee.SelectedIndex == -1)
            {
                MessageBox.Show("Grantee required.");
                cmbGrantee.Focus();
                return false;
            }

            if (uwgAmendment.Rows.Count > 0)
            {
                if ((uwdtDateExecuted.Value == null && uwgAmendment.Rows[0].Cells["ExecutedDate"].Text != String.Empty) ||
                     (uwdtDateExecuted.Value != null && uwgAmendment.Rows[0].Cells["ExecutedDate"].Text == String.Empty))
                {
                    MessageBox.Show("Please check if the Date Executed on Contract and Date Executed of Amendment 0 are correct.");
                    uwdtDateExecuted.Focus();
                    return false;
                }
            }

            int retVal;
            string retMsg;

            blnDataValid = true;

            if (blnDataValid == true)
            {
                this.Cursor = Cursors.WaitCursor;
                DataSet ds1 = null;
                if (cid == 0)
                    ds1 = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text
                        , "SELECT * FROM ContractDetails WHERE ContractNumber = '" + txtContractNumber.Text.ToString() + "'");
                else
                    ds1 = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text
                        , "SELECT * FROM ContractDetails WHERE ContractId = " + cid.ToString());
                if (ds1.Tables[0].Rows.Count > 0)
                {
                    //update contract details
                    DataRow dr1 = ds1.Tables[0].Rows[0];
                    cid = Convert.ToInt32(dr1[0]);
                    retMsg = ContractData.ContractDetailUpdate(
                            cid,
                            txtContractNumber.Text.ToString(),
                            Convert.ToInt32(pid),
                            Convert.ToInt32(cmbGrantee.SelectedValue),
                            cmbAddress.SelectedValue,
                            Convert.ToString(txtTaxId.Text),
                            Convert.ToInt32(cmbContactPerson.SelectedValue),
                            Convert.ToInt32(cmbStatus.SelectedValue),
                            Convert.ToInt32(cmbContractType.SelectedValue),
                            GlobalCode.ToDecimal(txtContractTotal.Text),
                            uwdtDateExecuted.Value,
                            uwdtCompletionDate.Value,
                            uwdtTerminationDate.Value,
                            uwdtClosedDate.Value,
                            Convert.ToString(chkSBE.Checked),
                            Convert.ToString(chkDVBE.Checked),
                            txtCertNumber.Text,
                            Convert.ToString(chkRepayment.Checked),
                            Convert.ToString(chkMonitoring.Checked),
                            Convert.ToInt32(cmbProjectManager.SelectedValue),
                            Convert.ToString(txtPurpose.Text),
                            Convert.ToString(chkCondition.Checked),
                            Convert.ToString(txtBoxNumber.Text),
                            Convert.ToString(txtClosingRemark.Text),
                            Convert.ToString(chkFlag.Checked),
                            Convert.ToString(txtFlagNote.Text)
                            );
                    if (retMsg != "success")
                    {
                        MessageBox.Show("Update failed in row ", "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return false;
                    }
                }
                else
                {
                    //insert contract details
                    retVal = ContractData.ContractDetailInsert(
                            txtContractNumber.Text.ToString(),
                            Convert.ToInt32(pid),
                            Convert.ToInt32(cmbGrantee.SelectedValue),
                            cmbAddress.SelectedValue,
                            Convert.ToString(txtTaxId.Text),
                            Convert.ToInt32(cmbContactPerson.SelectedValue),
                            Convert.ToInt32(cmbStatus.SelectedValue),
                            Convert.ToInt32(cmbContractType.SelectedValue),
                            GlobalCode.ToDecimal(txtContractTotal.Text),
                            uwdtDateExecuted.Value,
                            uwdtCompletionDate.Value,
                            uwdtTerminationDate.Value,
                            uwdtClosedDate.Value,
                            Convert.ToString(chkSBE.Checked),
                            Convert.ToString(chkDVBE.Checked),
                            txtCertNumber.Text,
                            Convert.ToString(chkRepayment.Checked),
                            Convert.ToString(chkMonitoring.Checked),
                            Convert.ToInt32(cmbProjectManager.SelectedValue),
                            Convert.ToString(txtPurpose.Text),
                            Convert.ToString(chkCondition.Checked),
                            Convert.ToString(txtBoxNumber.Text),
                            Convert.ToString(txtClosingRemark.Text),
                            Convert.ToString(chkFlag.Checked),
                            Convert.ToString(txtFlagNote.Text)
                            );
                    if (retVal == -1)
                    {
                        MessageBox.Show("Insert failed ", "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return false;
                    }
                    else
                    {
                        cid = retVal;
                    }
                }
                this.Cursor = Cursors.Default;
            }

            ContractData.ContractNoteInsert(cid, GlobalSettings.UserId, txtNotes.Text.ToString());

            blnDataChanged = false;
            Point p = new Point(0, 0);
            this.AutoScrollPosition = p;
            return true;
        }

        private void btnNewContract_Click(object sender, EventArgs e)
        {
            //string partA = DateTime.Now.Year.ToString().Substring(2, 2);
            //int nextKey = ContractData.GetNextContractNumber();

            //txtContractNumber.Text = string.Format("{0}-{1:d3}", partA, nextKey);
        }

        private void btnAddAmendment_Click(object sender, EventArgs e)
        {
            UltraGridRow addrow = uwgAmendment.DisplayLayout.Bands[0].AddNew();
            addrow.Cells[5].Value = "3";
            btnDeleteAmendment.Enabled = false;
        }

        private void uwgAmendment_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            //AmendmentId
            e.Layout.Bands[0].Columns[0].Hidden = true;

            e.Layout.Bands[0].Columns[1].Width = 40;
            e.Layout.Bands[0].Columns[1].Header.Caption = "No.";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns[2].Width = 200;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Reason for Amendment";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            e.Layout.Bands[0].Columns[3].Width = 120;
            e.Layout.Bands[0].Columns[3].Header.Caption = "Augmentation Amount";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[3].Format = GlobalSettings.MoneyFormat;
            e.Layout.Bands[0].Columns[3].MaskInput = "-nnnnnnnnnnn.nn";
            e.Layout.Bands[0].Columns[3].CellAppearance.TextHAlign = HAlign.Right;

            e.Layout.Bands[0].Columns[4].Width = 80;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Date Executed";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;

            // Dirty Flag
            e.Layout.Bands[0].Columns[5].Hidden = true;
        }

        private void btnSaveAmendment_Click(object sender, EventArgs e)
        {
            if (!SaveContractDetail())
                return;
            SaveAmendmentGrid();
            SaveFundSourceGrid();
            LoadContractDetailsPage();
            Point p = new Point(0, 0);
            this.AutoScrollPosition = p;
            btnDeleteAmendment.Enabled = true;
        }

        private void SaveAmendmentGrid()
        {
            int retVal1;
            string retMsg;
            int row;
            for (int i = 0; i < uwgAmendment.Rows.Count; i++)
            {
                row = i + 1;
                //first row must have 0 amendment number
                if ((i == 0) && (uwgAmendment.Rows[i].Cells[1].Value.ToString() != "0"))
                    uwgAmendment.Rows[i].Cells[1].Value = "0";
                //amendment number required
                if (uwgAmendment.Rows[i].Cells[1].Value.ToString() == string.Empty)
                {
                    MessageBox.Show("Please enter a amendment number in row " + row.ToString(),
                        "Data Entry Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                //other rows can't use 0 as amendment number
                if ((i > 0) && (uwgAmendment.Rows[i].Cells[1].Value.ToString() == "0"))
                {
                    MessageBox.Show("Amendment Number can't be 0 in row " + row.ToString(),
                        "Data Entry Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                //amendment number must be unique
                for (int j = i + 1; j < uwgAmendment.Rows.Count; j++)
                {
                    if (uwgAmendment.Rows[j].Cells[1].Value.ToString() == uwgAmendment.Rows[i].Cells[1].Value.ToString())
                    {
                        MessageBox.Show("Amendment number must be unique.  Please enter a different number in row " + row.ToString() + " or " + (j + 1).ToString(),
                            "Data Entry Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                }
            }

            for (int i = 0; i < uwgAmendment.Rows.Count; i++)
            {
                switch (uwgAmendment.Rows[i].Cells["DirtyFlag"].Value.ToString())
                {
                    case "1":
                        {
                            retMsg = ContractData.AmendmentUpdate(cid, Convert.ToInt32(uwgAmendment.Rows[i].Cells[0].Value),
                                                                 Convert.ToString(uwgAmendment.Rows[i].Cells[1].Value),
                                                                 Convert.ToString(uwgAmendment.Rows[i].Cells[2].Value),
                                                                 GlobalCode.ToDecimal(uwgAmendment.Rows[i].Cells[3].Value),
                                                                 Convert.ToInt32(cmbContractType.SelectedValue),
                                                                 uwgAmendment.Rows[i].Cells[4].Value);
                            if (retMsg != "success")
                            {
                                MessageBox.Show("Update failed ", "Database Error",
                                   MessageBoxButtons.OK, MessageBoxIcon.Error);
                            }
                            break;
                        }
                    case "2":
                        {
                            retMsg = ContractData.AmendmentDelete(Convert.ToInt32(uwgAmendment.ActiveRow.Cells[0].Value));
                            if (retMsg != "success")
                                MessageBox.Show("Delete failed", "Database Error",
                                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                            break;
                        }
                    case "3":
                        {
                            retVal1 = ContractData.AmendmentInsert(cid,
                                                                    uwgAmendment.Rows[i].Cells[1].Value.ToString(),
                                                                    Convert.ToString(uwgAmendment.Rows[i].Cells[2].Value),
                                                                    GlobalCode.ToDecimal(uwgAmendment.Rows[i].Cells[3].Value),
                                                                    Convert.ToInt32(cmbContractType.SelectedValue),
                                                                    uwgAmendment.Rows[i].Cells[4].Value);

                            if (retVal1 == -1)
                            {
                                MessageBox.Show("Insert failed ", "Database Error",
                                   MessageBoxButtons.OK, MessageBoxIcon.Error);
                            }
                            break;
                        }
                }
            }
            LoadAmendmentGrid(cid);
            RefreshAmendmentLog();
        }

        private void uwgAmendment_AfterCellUpdate(object sender, CellEventArgs e)
        {
            if (blnSkip)
            {
                blnSkip = false;
                return;
            }

            if (uwgAmendment.ActiveCell != null)
            {
                if (uwgAmendment.ActiveCell.Column.Key == "Amount")
                    MessageBox.Show("You must also update the appropriate Contract Funds with the augmentation amount so that the totals are correct.");

                if (uwgAmendment.ActiveCell.Column.Key == "ExecutedDate")
                {
                    MessageBox.Show("Please check if the Date Executed on Contract and Date Executed of Amendment 0 are correct.");

                    //status from draft to active 
                    if (uwdtDateExecuted.Value != null)
                    {
                        if (cmbStatus.SelectedIndex == 0)
                        {
                            cmbStatus.SelectedIndex = 1;
                        }
                    }

                    if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value == null)
                    {
                        newStatusId = 1;
                        cmbStatus.SelectedValue = 2;

                    }
                    else if (uwdtClosedDate.Value == null && uwdtDateExecuted.Value == null)
                    {
                        newStatusId = 0;
                        cmbStatus.SelectedValue = 1;

                    }
                    else if (uwdtDateExecuted.Value == null && uwdtClosedDate.Value != null)
                    {
                        newStatusId = 3;
                        cmbStatus.SelectedValue = 4;

                    }
                    else if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value != null)
                    {
                        newStatusId = 3;
                        cmbStatus.SelectedValue = 4;

                    }
                }

            }

            if (this.uwgAmendment.ActiveRow.Cells[5].Value.ToString() == "0")
            {
                blnSkip = true;
                this.uwgAmendment.ActiveRow.Cells[5].Value = "1";
            }

            blnDataDirty = true;

        }

        private void uwgAmendment_CellListSelect(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            if (this.uwgAmendment.ActiveRow.Cells[5].Value.ToString() == "0")
                this.uwgAmendment.ActiveRow.Cells[5].Value = "1";
        }

        private void btnCancelAmendment_Click(object sender, EventArgs e)
        {
            this.LoadAmendmentGrid(cid);
        }

        private void btnDeleteAmendment_Click(object sender, EventArgs e)
        {
            UltraGridRow row = this.uwgAmendment.ActiveRow;
            if (row.Index == 0)
            {
                MessageBox.Show("The original contract row can't be deleted.");
                return;
            }

            if (null != row)
            {
                DialogResult intDiagResult = MessageBox.Show("Do you want to delete this Amendment, and save all other pending changes?", "Delete Row",
                    MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (intDiagResult == DialogResult.Yes)
                {
                    // if the row is a database row then mark it for deletion and hide it in the grid
                    row.Hidden = true;
                    row.Cells["DirtyFlag"].Value = "2";
                    blnDataDirty = true;

                    // set the active row to first (non-hidden) row
                    SaveAmendmentGrid();
                    GridManager.FirstButtonHandler(uwgAmendment);

                }
            }
            else
            {
                // If there is no active row, then prompt the user to select one. 
                MessageBox.Show("Please select a single row to delete.");
            }
        }

        private void btnViewInvoice_Click(object sender, EventArgs e)
        {
        }

        private void btnViewApproval_Click(object sender, EventArgs e)
        {
            ApprovalProgress ap = new ApprovalProgress();
            Form1 fm = (Form1)this.MdiParent;
            fm.OpenForm(ap, "View Approval");
            this.Close();
        }

        private void btnViewAllContract_Click(object sender, EventArgs e)
        {
            Form1 mainForm = (Form1)this.MdiParent;
            mainForm.OpenProject(pid, projecttitle);

            CCPM.Project.ProjectForm projectForm = null;
            mainForm.GetCurrentProject(out projectForm);
            projectForm.SetTabIndex(4);
        }

        private void btnViewRepayment_Click(object sender, EventArgs e)
        {
            if (cid == 0)
            {
                MessageBox.Show("Please save the Contract", "Data Entry Error", MessageBoxButtons.OK);
            }
            else
            {
                GlobalSettings.mainFormHandle.OpenRepayment(cid);
            }
        }

        private void btnViewMonitoring_Click(object sender, EventArgs e)
        {
            if (cid == 0)
            {
                MessageBox.Show("Please save the Contract", "Data Entry Error", MessageBoxButtons.OK);
            }
            else
            {
                GlobalSettings.mainFormHandle.OpenMonitoring(cid);
                //Form1 fm = (Form1)this.MdiParent;
                //MonitoringDetails md = new MonitoringDetails(cid);
                ////this.Close();
                //md.MdiParent = fm;
                //md.Show();
            }
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            DbConnection dbConnection = DbConnection.GetDbConnection();
            string connectionString = dbConnection.DbConnectionString;
            string retMsg = "success"; int retVal;
            DialogResult intDiagResult = MessageBox.Show("Do you want to delete this Contract?", "Delete Contract Detail",
                    MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (intDiagResult == DialogResult.Yes)
            {
                retMsg = ContractData.ContractDetailDelete(Convert.ToString(txtContractNumber.Text));
                if (retMsg != "success")
                    MessageBox.Show("Delete failed", "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                blnDataChanged = false;
                blnDataDirty = false;
                this.Close();
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {

        }

        private void uwgContractFund_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            //0=ContractFundId, 1=FundId, 2=ContractedAmount, 3=BalanceToDate, 4=LiquidationDate, 5=DisencumberAmount
            //6=ContractId, 7=DirtyFlag, 8=hasInvoice
            e.Layout.Bands[0].Columns["ContractFundId"].Hidden = true;

            e.Layout.Bands[0].Columns["FundId"].Width = 240;//190;
            e.Layout.Bands[0].Columns["FundId"].Header.Caption = "Funding Source";
            e.Layout.Bands[0].Columns["FundId"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns["FundId"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;

            e.Layout.Bands[0].Columns["FundId"].ValueList = uwgContractFund.DisplayLayout.ValueLists["FundingItem"];
            e.Layout.Bands[0].Columns["FundId"].EditorComponent = uteFund;

            e.Layout.Bands[0].Columns["ContractedAmount"].Width = 110;
            e.Layout.Bands[0].Columns["ContractedAmount"].Header.Caption = "Contracted Amount";
            e.Layout.Bands[0].Columns["ContractedAmount"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns["ContractedAmount"].Format = GlobalSettings.MoneyFormat;
            e.Layout.Bands[0].Columns["ContractedAmount"].MaskInput = "-nnnnnnnnnnn.nn";
            e.Layout.Bands[0].Columns["ContractedAmount"].CellAppearance.TextHAlign = HAlign.Right;

            e.Layout.Bands[0].Columns["BalanceToDate"].Width = 100;
            e.Layout.Bands[0].Columns["BalanceToDate"].Header.Caption = "Balance To-Date";
            e.Layout.Bands[0].Columns["BalanceToDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["BalanceToDate"].CellAppearance.BackColor = Color.Yellow;
            e.Layout.Bands[0].Columns["BalanceToDate"].Format = GlobalSettings.MoneyFormat;
            e.Layout.Bands[0].Columns["BalanceToDate"].MaskInput = "-nnnnnnnnnnn.nn";
            e.Layout.Bands[0].Columns["BalanceToDate"].CellAppearance.TextHAlign = HAlign.Right;

            e.Layout.Bands[0].Columns["LiquidationDate"].Width = 100;
            e.Layout.Bands[0].Columns["LiquidationDate"].Header.Caption = "Liquidation Date";
            e.Layout.Bands[0].Columns["LiquidationDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns["LiquidationDate"].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["LiquidationDate"].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns["LiquidationDate"].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns["DisencumberAmount"].Hidden = true;
            //e.Layout.Bands[0].Columns["DisencumberAmount"].Width = 115;
            //e.Layout.Bands[0].Columns["DisencumberAmount"].Header.Caption = "Disencumb Amount";
            //e.Layout.Bands[0].Columns["DisencumberAmount"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            //e.Layout.Bands[0].Columns["DisencumberAmount"].Format = "-" + GlobalSettings.MoneyFormat;
            //e.Layout.Bands[0].Columns["DisencumberAmount"].MaskInput = "-nnnnnnnnnnn.nn";
            //e.Layout.Bands[0].Columns["DisencumberAmount"].CellAppearance.TextHAlign = HAlign.Right;

            e.Layout.Bands[0].Columns["WithholdingToDate"].Width = 110;
            e.Layout.Bands[0].Columns["WithholdingToDate"].Header.Caption = "Withholding To Date";
            e.Layout.Bands[0].Columns["WithholdingToDate"].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns["WithholdingToDate"].Format = GlobalSettings.MoneyFormat;
            e.Layout.Bands[0].Columns["WithholdingToDate"].MaskInput = "-nnnnnnnnnnn.nn";
            e.Layout.Bands[0].Columns["WithholdingToDate"].CellAppearance.TextHAlign = HAlign.Right;

            e.Layout.Bands[0].Columns["ContractId"].Hidden = true;
            e.Layout.Bands[0].Columns["DirtyFlag"].Hidden = true;
            e.Layout.Bands[0].Columns["hasInvoice"].Hidden = true;


        }

        private void btnAddFund_Click(object sender, EventArgs e)
        {
            UltraGridRow addRow = uwgContractFund.DisplayLayout.Bands[0].AddNew();
            addRow.Cells["DirtyFlag"].Value = "3";
            btnDeleteFund.Enabled = false;
        }

        private void uwgContractFund_AfterCellListCloseUp(object sender, CellEventArgs e)
        {
            if (e.Cell.DataChanged)
            {
                DataSet ds = null;
                DataRow dr = null;
                int FundID = 0;
                string FundingSource = "";
                decimal totalContractedAmount = 0;

                //do not allow to select funds that are no longer active
                if (this.uwgContractFund.ActiveRow.Cells["FundID"].Text.Contains("InActive"))
                {
                    MessageBox.Show("Funding Source is no longer Active.", "Change Funding Source ", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    //revert selection
                    e.Cell.CancelUpdate();
                    return;
                }

                //do not allow to select funds that are already part of contract funds
                FundingSource = this.uwgContractFund.ActiveRow.Cells["FundID"].Text;

                bool shouldRevert = false;

                foreach (UltraGridRow fundingRow in uwgContractFund.Rows)
                {
                    if (fundingRow.Cells["FundId"].Text == FundingSource &&
                        fundingRow.Index != this.uwgContractFund.ActiveRow.Index)
                    {
                        shouldRevert = true;
                        break;
                    }
                }

                if (shouldRevert)
                {
                    MessageBox.Show("Funding sources must be unique.  Please select a different funding source for row " + (this.uwgContractFund.ActiveRow.Index + 1).ToString() + ".", "Data Entry Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    //revert selection
                    e.Cell.CancelUpdate();
                    return;
                }

                //if (uwgContractFund.ActiveRow.Cells["FundId"].Value.ToString() != string.Empty)

                //    FundID = Convert.ToInt32(this.uwgContractFund.ActiveRow.Cells["FundID"].Value);

                if (uwgContractFund.Rows.Count > 0)
                {
                    if (uwgContractFund.ActiveRow.Cells["FundId"].IsInEditMode == true)
                    {
                        uwgContractFund.ActiveRow.Cells[2].Activate();

                        //check if there are existing invoices that first need to be reassigned to a different fund
                        if (uwgContractFund.ActiveRow.Cells["FundId"].Value.ToString() != uwgContractFund.ActiveRow.Cells["FundId"].OriginalValue.ToString())
                        {
                            if (GlobalCode.ToBoolean(uwgContractFund.ActiveRow.Cells["hasInvoice"].Value) == true)
                            {
                                DialogResult intDiagResult = MessageBox.Show("There are invoices and/or payments against this Contract Fund already. \n\r\n\r Before you change this funding source, first go to the Invoice Drawdown Sheet for this fund and reassign the invoices.",
                                             "Change Funding Source", MessageBoxButtons.OK, MessageBoxIcon.Question);

                                //revert selection
                                e.Cell.CancelUpdate();
                                return;

                                /*
                                if (intDiagResult == DialogResult.No)
                                {
                                    //revert selection
                                    e.Cell.CancelUpdate();
                                    uwgContractFund.ActiveRow.Cells["FundId"].Value = FundID;
                                    return;
                                }
                                else
                                {
                                    //proceed with reassigning invoices
                                    ContractData.ContractFundInvoicesReassigned(cid, Convert.ToInt32(uwgContractFund.ActiveRow.Cells["FundId"].OriginalValue), Convert.ToInt32(uwgContractFund.ActiveRow.Cells["FundId"].Value));
                                    SaveFundSourceGrid();
                                    SaveContractDetail();
                                }
                                */
                            }

                        }

                        if (uwgContractFund.ActiveRow.Cells["FundId"].Value.ToString() != uwgContractFund.ActiveRow.Cells["FundId"].OriginalValue.ToString())
                        {
                            if (uwgContractFund.ActiveRow.Cells["FundId"].Value.ToString() != string.Empty)
                            {
                                uteFund.Value = ugFundingSourceDropdown.ActiveRow.Cells["FundId"].Value;

                                // Gets total reserved amount for the funding source
                                ds = ContractData.GetFundsourceAmount(Convert.ToInt32(uwgContractFund.ActiveRow.Cells["FundId"].Value), Convert.ToInt32(pid));
                                if (ds.Tables[0].Rows.Count > 0)
                                {
                                    dr = ds.Tables[0].Rows[0];
                                    TotalFundingSourceAmount = GlobalCode.ToDecimal(dr[0]);
                                }
                                else
                                {
                                    TotalFundingSourceAmount = 0;
                                }

                                // Gets the total contracted amount for the funding source for that particular project
                                DataSet ds1 = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "SELECT isnull(sum(cf.ContractedAmount),0) FROM ContractFunds cf INNER JOIN ContractDetails cd ON cf.ContractId = cd.ContractId WHERE (FundId = " + Convert.ToInt32(uwgContractFund.ActiveRow.Cells["FundId"].Value) + " and ProjectId = " + Convert.ToInt32(pid) + ")");
                                if (ds1.Tables[0].Rows.Count > 0)
                                {
                                    DataRow dr1 = ds1.Tables[0].Rows[0];
                                    totalContractedAmount = GlobalCode.ToDecimal(dr1[0]);
                                }
                                else
                                {
                                    totalContractedAmount = 0;
                                }

                                // Load funding source amount in the Contracted Amount column
                                uwgContractFund.ActiveRow.Cells["ContractedAmount"].Value = TotalFundingSourceAmount - totalContractedAmount;    //dr[0].ToString();

                                ds = null;
                                dr = null;

                                ds = ContractData.GetFundsourceLiquidDate(Convert.ToInt32(uwgContractFund.ActiveRow.Cells["FundId"].Value), Convert.ToInt32(pid));
                                if (ds.Tables[0].Rows.Count > 0)
                                {
                                    dr = ds.Tables[0].Rows[0];
                                    //Load fund source liquidation date
                                    if (dr[0].ToString() != String.Empty)
                                        uwgContractFund.ActiveRow.Cells["LiquidationDate"].Value = dr[0].ToString();
                                }
                                LoadFundSourceGridTotal();
                            }
                        }
                    }

                    if (uwgContractFund.ActiveRow.Cells["DirtyFlag"].Value.ToString() == "0")
                        uwgContractFund.ActiveRow.Cells["DirtyFlag"].Value = "1";
                }

                blnDataDirty = true;
            }
        }

        private void LoadFundSourceGridTotal()
        {
            decimal sum = 0;
            decimal sum1 = 0;
            decimal sum2 = 0;
            for (int i = 0; i < uwgContractFund.Rows.Count; i++)
            {
                sum += Convert.ToDecimal(uwgContractFund.Rows[i].Cells[2].Value);
                if (uwgContractFund.Rows[i].Cells[3].Value.ToString() == string.Empty)
                {
                    uwgContractFund.Rows[i].Cells[3].Value = "0";
                    sum1 += Convert.ToDecimal(uwgContractFund.Rows[i].Cells[3].Value);
                }
                else
                {
                    sum1 += Convert.ToDecimal(uwgContractFund.Rows[i].Cells[3].Value);
                }

                if (uwgContractFund.Rows[i].Cells[5].Value.ToString() == string.Empty)
                {
                    uwgContractFund.Rows[i].Cells[5].Value = "0";
                    sum2 += Convert.ToDecimal(uwgContractFund.Rows[i].Cells[5].Value);
                }
                else
                {
                    sum2 += Convert.ToDecimal(uwgContractFund.Rows[i].Cells[5].Value);
                }
            }
            txtFundContractedTotal.Text = sum.ToString(GlobalSettings.MoneyFormat);
            txtFundBalanceToDateTotal.Text = sum1.ToString(GlobalSettings.MoneyFormat);
            txtFundDisencumberedTotal.Text = sum2.ToString("-" + GlobalSettings.MoneyFormat);
        }

        private void btnSaveFund_Click(object sender, EventArgs e)
        {
            if (cid == 0)
            {
                if (!SaveContractDetail())
                    return;
            }
            SaveFundSourceGrid();
            if (!SaveContractDetail())
                return;
            Point p = new Point(0, 0);
            this.AutoScrollPosition = p;
            btnDeleteFund.Enabled = true;
            //refresh summary fields
            btnRefresh_Click(sender, e);
        }

        private void SaveFundSourceGrid()
        {
            //0=ContractFundId, 1=FundId, 2=ContractedAmount
            //"3=BalanceToDate, 4=LiquidationDate, 5=DisencumberAmount, 6=ContractId, 7=DirtyFlag, 8=hasInvoice

            int retVal1;
            string retMsg;
            //funding sources must be unique
            for (int i = 0; i < uwgContractFund.Rows.Count; i++)
            {
                for (int j = i + 1; j < uwgContractFund.Rows.Count; j++)
                {
                    if (uwgContractFund.Rows[j].Cells["FundId"].Value.ToString() == uwgContractFund.Rows[i].Cells["FundId"].Value.ToString())
                    {
                        MessageBox.Show("Funding sources must be unique.  Please select a different funding source for row " + (j + 1).ToString() + ".",
                            "Data Entry Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                }
            }

            for (int i = 0; i < uwgContractFund.Rows.Count; i++)
            {
                switch (uwgContractFund.Rows[i].Cells["DirtyFlag"].Value.ToString())
                {
                    case "1":
                        {
                            uwgContractFund.Rows[i].Cells["BalanceToDate"].Value = Convert.ToDecimal(uwgContractFund.Rows[i].Cells["ContractedAmount"].Value);
                            retMsg = ContractData.ContractFundUpdate(Convert.ToInt32(uwgContractFund.Rows[i].Cells["ContractFundId"].Value),
                                                                 Convert.ToString(uwgContractFund.Rows[i].Cells["FundId"].Value),
                                                                 Convert.ToDecimal(uwgContractFund.Rows[i].Cells["ContractedAmount"].Value),
                                                                 Convert.ToDecimal(uwgContractFund.Rows[i].Cells["BalanceToDate"].Value),
                                                                 uwgContractFund.Rows[i].Cells["LiquidationDate"].Value,
                                                                 GlobalCode.ToDecimal(uwgContractFund.Rows[i].Cells["DisencumberAmount"].Value),
                                                                 blnReduceAmount);
                            if (retMsg != "success")
                            {
                                MessageBox.Show("Update failed ", "Database Error",
                                   MessageBoxButtons.OK, MessageBoxIcon.Error);
                            }
                            break;
                        }
                    case "2":
                        {
                            retMsg = ContractData.ContractFundDelete(Convert.ToInt32(uwgContractFund.ActiveRow.Cells["ContractFundId"].Value));
                            if (retMsg != "success")
                                MessageBox.Show("Delete failed", "Database Error",
                                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                            break;
                        }
                    case "3":
                        {
                            if (uwgContractFund.Rows[i].Cells["FundId"].Value.ToString() == string.Empty)
                            {
                                MessageBox.Show("Missing Funding Source.");
                                return;
                            }
                            if (uwgContractFund.Rows[i].Cells["ContractedAmount"].Value.ToString() == string.Empty)
                            {
                                MessageBox.Show("Missing Contracted Amount");
                                return;
                            }

                            uwgContractFund.Rows[i].Cells["BalanceToDate"].Value = Convert.ToDecimal(uwgContractFund.Rows[i].Cells["ContractedAmount"].Value);
                            retVal1 = ContractData.ContractFundInsert(Convert.ToString(uwgContractFund.Rows[i].Cells["FundId"].Value),
                                                                 Convert.ToDecimal(uwgContractFund.Rows[i].Cells["ContractedAmount"].Value),
                                                                 Convert.ToDecimal(uwgContractFund.Rows[i].Cells["BalanceToDate"].Value),
                                                                 uwgContractFund.Rows[i].Cells["LiquidationDate"].Value,
                                                                 GlobalCode.ToDecimal(uwgContractFund.Rows[i].Cells["DisencumberAmount"].Value),
                                                                 cid, blnReduceAmount);

                            if (retVal1 == -1)
                            {
                                MessageBox.Show("Insert failed ", "Database Error",
                                   MessageBoxButtons.OK, MessageBoxIcon.Error);
                            }
                            this.Refresh();
                            break;
                        }
                }
            }
            LoadFundSourceGrid(cid);
            LoadFundSourceGridTotal();
            blnDataDirty = false;
            blnDataChanged = false;
        }

        private void uwgContractFund_AfterCellUpdate(object sender, CellEventArgs e)
        {
            if (blnSkip)
                return;

            DataSet ds = null;
            DataRow dr = null;
            TotalFundingSourceAmount = 0;
            decimal totalContractedAmount = 0;
            blnSkip = true;


            if (uwgContractFund.ActiveRow.Cells["ContractedAmount"].IsInEditMode == true)
            {
                ds = ContractData.GetFundsourceAmount(GlobalCode.ToInt32(uwgContractFund.ActiveRow.Cells["FundId"].Value), Convert.ToInt32(pid));
                dr = ds.Tables[0].Rows[0];
                TotalFundingSourceAmount = GlobalCode.ToDecimal(dr[0]);

                // Gets the total contracted amount for the funding source for that particular project
                DataSet ds1 = SqlHelper.ExecuteDataset(GlobalSettings.ConnectionString, CommandType.Text, "SELECT isnull(sum(cf.ContractedAmount),0) FROM ContractFunds cf INNER JOIN ContractDetails cd ON cf.ContractId = cd.ContractId WHERE (FundId = " + Convert.ToInt32(uwgContractFund.ActiveRow.Cells["FundId"].Value) + " and ProjectId = " + Convert.ToInt32(pid) + ")");
                if (ds1.Tables[0].Rows.Count > 0)
                {
                    DataRow dr1 = ds1.Tables[0].Rows[0];
                    totalContractedAmount = GlobalCode.ToDecimal(dr1[0]);
                }
                else
                {
                    totalContractedAmount = 0;
                }

                if (GlobalCode.ToDecimal(uwgContractFund.ActiveRow.Cells["ContractedAmount"].OriginalValue) == (TotalFundingSourceAmount - totalContractedAmount))
                {
                    totalContractedAmount = totalContractedAmount + GlobalCode.ToDecimal(uwgContractFund.ActiveRow.Cells["ContractedAmount"].Value);
                }
                else if (GlobalCode.ToDecimal(uwgContractFund.ActiveRow.Cells["ContractedAmount"].Value) > (TotalFundingSourceAmount - totalContractedAmount))
                {
                    totalContractedAmount = totalContractedAmount - GlobalCode.ToDecimal(uwgContractFund.ActiveRow.Cells["ContractedAmount"].OriginalValue) + GlobalCode.ToDecimal(uwgContractFund.ActiveRow.Cells["ContractedAmount"].Value);
                }

                if (totalContractedAmount > (TotalFundingSourceAmount))
                {
                    MessageBox.Show("The amount you entered is greater than the amount reserved (" + TotalFundingSourceAmount.ToString(GlobalSettings.MoneyFormat) + ") for this funding source.\n " +
                        "If a larger reservation amount has been approved, first make the change on the Funding tab for the project prior to completing the contract details.", "Data entry error");
                    uwgContractFund.ActiveRow.Cells["ContractedAmount"].Value = GlobalCode.ToDecimal(uwgContractFund.ActiveRow.Cells["ContractedAmount"].OriginalValue);
                    uwgContractFund.ActiveRow.Cells["ContractedAmount"].CancelUpdate();
                    blnSkip = false;
                    return;
                }
            }

            if (uwgContractFund.ActiveRow.Cells["DirtyFlag"].Value.ToString() == "0")
                uwgContractFund.ActiveRow.Cells["DirtyFlag"].Value = "1";
            blnSkip = false;
            blnDataDirty = true;
        }

        private void btnCancelFund_Click(object sender, EventArgs e)
        {
            if (blnDataDirty == true)
            {
                DialogResult intRes = MessageBox.Show("Data has changed - Do you want to cancel changes?", "Cancel Changes",
                    MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (intRes == DialogResult.Yes)
                {
                    blnDataDirty = false;
                    this.LoadFundSourceGrid(cid);
                    this.LoadFundSourceGridTotal();
                }
            }
            btnDeleteFund.Enabled = true;
        }

        private void btnDeleteFund_Click(object sender, EventArgs e)
        {
            UltraGridRow row = this.uwgContractFund.ActiveRow;

            if (null != row)
            {
                if (GlobalCode.ToBoolean(row.Cells["hasInvoice"].Value))
                {
                    MessageBox.Show("Contract Fund has invoice(s) and can't be deleted.", "Delete Row Failure",
                                        MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation);
                    return;
                }

                DialogResult intDiagResult = MessageBox.Show("Do you want to delete this Contract Fund Source, and save all other pending changes?", "Delete Row",
                    MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (intDiagResult == DialogResult.Yes)
                {
                    // if the row is a database row then mark it for deletion and hide it in the grid
                    row.Hidden = true;
                    row.Cells["DirtyFlag"].Value = "2";
                    blnDataDirty = true;

                    // set the active row to first (non-hidden) row
                    SaveFundSourceGrid();
                    GridManager.FirstButtonHandler(uwgContractFund);
                }
                btnRefresh_Click(sender, e);
            }
            else
            {
                // If there is no active row, then prompt the user to select one. 
                MessageBox.Show("Please select a single row to delete.");
            }
        }

        private void btnGoToInvoice_Click(object sender, EventArgs e)
        {
            if (uwgContractFund.Rows.Count > 0)
            {
                if (GlobalCode.ToInt32(uwgContractFund.ActiveRow.Cells["ContractFundId"].Value) == 0)
                {
                    MessageBox.Show("Save fund source first.", "", MessageBoxButtons.OK);
                    return;
                }
                int ContractID = GlobalCode.ToInt32(uwgContractFund.ActiveRow.Cells[6].Value);
                int FundingSource = GlobalCode.ToInt32(uwgContractFund.ActiveRow.Cells[1].Value);

                if (!SaveContractDetail())
                    return;
                SaveFundSourceGrid();
                LoadContractDetailsPage();
                GlobalSettings.mainFormHandle.OpenInvoiceDrawdown(ContractID, FundingSource);

            }
            else
            {
                MessageBox.Show("No fund source exists !!", "Data Entry Error", MessageBoxButtons.OK);
            }
        }

        private void uwgAmendment_MouseDown_1(object sender, MouseEventArgs e)
        {
            if (cid == 0)
                return;
            //if (uwgAmendment.Rows.Count > 0)
            //{
            //    if (uwgAmendment.ActiveRow.Cells[3].IsInEditMode == true)
            //    {
            //        ContractAmedment ca = new ContractAmedment(Convert.ToInt32(cid));
            //        ca.MyParentForm = this;
            //        if (ca.ShowDialog() == DialogResult.OK)
            //        {
            //            uwgAmendment.ActiveRow.Cells[3].Value = ca.Amount;
            //            string fundSource = ca.FundingSource;
            //            for (int i = 0; i < uwgContractFund.Rows.Count; i++)
            //            {
            //                if (uwgContractFund.Rows[i].Cells[1].Text.ToString() == fundSource)
            //                {
            //                    DataSet ds = ContractData.GetFundsourceAmount(Convert.ToInt32(uwgContractFund.Rows[i].Cells[1].Value), Convert.ToInt32(pid));
            //                    DataRow dr = ds.Tables[0].Rows[0];
            //                    TotalFundingSourceAmount = Convert.ToDecimal(dr[0]);
            //                    // Add the augmentation amount to the fund source contracted amount
            //                    uwgContractFund.Rows[i].Cells[2].Value = Convert.ToDecimal(uwgContractFund.Rows[i].Cells[2].Value) + ca.Amount;
            //                    uwgContractFund.Rows[i].Cells[8].Value = "1";
            //                }
            //            }
            //        }
            //    }
            //}
        }

        private void uwgContractFund_MouseDown(object sender, MouseEventArgs e)
        {
            if (uwgContractFund.Rows.Count > 0)
            {
                if (uwgContractFund.ActiveRow.Cells["DisencumberAmount"].IsInEditMode == true)
                {
                    DataSet ds = ContractData.GetFundsourceAmount(Convert.ToInt32(uwgContractFund.ActiveRow.Cells["FundId"].Value), Convert.ToInt32(pid));
                    DataRow dr = ds.Tables[0].Rows[0];
                    TotalFundingSourceAmount = GlobalCode.ToDecimal(dr[0]);

                    ContractFundDialogBox cfd = new ContractFundDialogBox();
                    cfd.MyParentForm = this;
                    if (blnDisplay == true)
                    {
                        blnDisplay = false;
                        if (cfd.ShowDialog() == DialogResult.OK)
                        {
                            if (cfd.Reduce == true)
                            {
                                blnReduceAmount = true;
                            }
                            else if (cfd.DoNotReduce == true)
                            {
                                blnReduceAmount = false;
                            }
                        }
                    }
                }
            }
        }

        private void chkRepayment_Click(object sender, EventArgs e)
        {
            if (cid == 0)
            {
                MessageBox.Show("Please save the Contract", "Data Entry Error", MessageBoxButtons.OK);
            }
            else
            {
                if (chkRepayment.Checked == true)
                {
                    DialogResult diaRes = MessageBox.Show("Do you want to enter the repayment details now ?", "Warning", MessageBoxButtons.YesNo);
                    if (diaRes == DialogResult.Yes)
                    {
                        if (!SaveContractDetail())
                            return;
                        Form1 fm = (Form1)this.MdiParent;
                        RepaymentDetails rd = new RepaymentDetails(cid);
                        fm.OpenForm(rd, "Repayment Details: " + cid);
                    }
                }
            }
        }

        private void chkMonitoring_Click(object sender, EventArgs e)
        {
            if (cid == 0)
            {
                MessageBox.Show("Please save the Contract", "Data Entry Error", MessageBoxButtons.OK);
            }
            else
            {
                if (chkMonitoring.Checked == true)
                {
                    DialogResult diaRes = MessageBox.Show("Do you want to enter the Monitoring details now ?", "Warning", MessageBoxButtons.YesNo);
                    if (diaRes == DialogResult.Yes)
                    {
                        if (!SaveContractDetail())
                            return;
                        Form1 fm = (Form1)this.MdiParent;
                        MonitoringDetails md = new MonitoringDetails(cid);
                        fm.OpenForm(md, "Monitoring Details: " + cid);
                    }
                }
            }
        }

        private void ContractDetail_Load(object sender, EventArgs e)
        {
            blnDataChanged = false;
        }

        private void ContractDetail_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (blnDataChanged == true || blnDataDirty == true)
            {
                DialogResult intResult = MessageBox.Show("Do you want to save changes ?", "Save Data", MessageBoxButtons.YesNo);
                if (intResult == DialogResult.Yes)
                {
                    if (!SaveContractDetail())
                        return;
                    SaveAmendmentGrid();
                    SaveFundSourceGrid();
                }
            }
        }

        private void cmbGrantee_SelectedValueChanged(object sender, EventArgs e)
        {
            if (!blnDataLoaded)
                return;

            try
            {
                orgid = (int)cmbGrantee.SelectedValue;
                foreach (DataRow dr in dtOrganization.Rows)
                {
                    if (orgid == (int)dr["OrgId"])
                    {
                        txtTaxId.Text = dr["TaxId"].ToString();
                        chkSBE.Checked = (bool)dr["SBE"];
                        chkDVBE.Checked = (bool)dr["DVBE"];
                        txtCertNumber.Text = dr["CertificationNumber"].ToString();
                        break;
                    }
                }
                LoadAddresses();
                LoadContacts();
                blnDataChanged = true;
            }
            catch (Exception) { }
        }

        private void cmbStatus_SelectedValueChanged(object sender, EventArgs e)
        {
            if (blnSkip)
                return;

            int newid = GlobalCode.ToInt32(cmbStatus.SelectedValue);
            if (newid > 0 && contractstatusid != newid)
            {
                blnDataChanged = true;
                if (contractstatusid != 4 && newid == 4)       //to Closed
                {
                    if (blnDisplay1 == false)
                    {
                        blnDisplay1 = true;
                        if (DialogResult.Yes == MessageBox.Show("Do you want to complete the closing comments now?", "Warning", MessageBoxButtons.YesNo))
                        {
                            txtClosingRemark.Focus();
                        }
                    }
                }
            }
        }

        private void cmbContractType_SelectedValueChanged(object sender, EventArgs e)
        {
            if (t != cmbContractType.Text)
            {
                blnDataChanged = true;
            }
        }

        private void txtPhone_TextChanged(object sender, EventArgs e)
        {
            if (ph != txtPhone.Text)
            {
                blnDataChanged = true;
            }
        }

        private void cmbProjectManager_SelectedValueChanged(object sender, EventArgs e)
        {

            if (pname != cmbProjectManager.Text)
            {
                blnDataChanged = true;

                int newid = GlobalCode.ToInt32(cmbProjectManager.SelectedValue);
                if (newid > 0 && newid != primaryprojectmanagerid)
                {
                    if (cmbProjectManager.SelectedIndex == 0) return;
                    if (DialogResult.No == MessageBox.Show(cmbProjectManager.Text + " is not the Primary Project Manager for this project. Would you like to proceed with your change?", "Confirm change", MessageBoxButtons.YesNo))
                    {
                        cmbProjectManager.SelectedValue = projectmanagerid;
                    }
                    else
                    {
                        if (DialogResult.Yes == MessageBox.Show(cmbProjectManager.Text + " is not the Primary Project Manager for this project. Would you like to make " + cmbProjectManager.Text + " the Primary Project Manager? Note, this will automatically save your changes to the database.", "Confirm change", MessageBoxButtons.YesNo))
                        {
                            primaryprojectmanagerid = newid;
                            SaveContractDetail();
                            ProjectData.UpdateProjectPrimaryPM(newid, pid);
                        }
                    }
                }
            }
        }
        private void cmbProjectManager_SelectedIndexChanged(object sender, EventArgs e)
        {


        }

        private void cmbContactPerson_DropDownClosed(object sender, EventArgs e)
        {
            //DbConnection dbConnection = DbConnection.GetDbConnection();
            //string connectionString = dbConnection.DbConnectionString;
            //string sql = "SELECT Address, City, State, Zip, GeneralPhone " +
            //    "FROM Contact JOIN OrgAddress on OrgAddress.OrgAddressId = Contact.OrgAddressId " +
            //    "WHERE ContactId = " + Convert.ToInt32(cmbContactPerson.SelectedValue);
            //DataSet ds1 = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            //if (ds1.Tables[0].Rows.Count > 0)
            //{
            //    DataRow dr = ds1.Tables[0].Rows[0];
            //    txtAddress.Text = Convert.ToString(dr["Address"]) + "\r\n" + Convert.ToString(dr["City"]) + "  " + Convert.ToString(dr["State"]) + "  " + Convert.ToString(dr["Zip"]); 
            //    txtPhone.Text = Convert.ToString(dr["GeneralPhone"]);
            //}
        }

        private void txtPurpose_TextChanged(object sender, EventArgs e)
        {
            if (purpose != txtPurpose.Text)
            {
                blnDataChanged = true;
            }
        }

        private void chkDVBE_CheckStateChanged(object sender, EventArgs e)
        {
            if (chkDVBE.Checked != dvbe)
            {
                blnDataChanged = true;
            }
        }

        private void chkSBE_CheckStateChanged(object sender, EventArgs e)
        {
            if (chkSBE.Checked != sbe)
            {
                blnDataChanged = true;
            }
        }

        private void chkCondition_CheckStateChanged(object sender, EventArgs e)
        {
            if (chkCondition.Checked != condition)
            {
                blnDataChanged = true;
            }
        }

        private void txtBoxNumber_TextChanged(object sender, EventArgs e)
        {
            if (boxnumber != txtBoxNumber.Text)
            {
                blnDataChanged = true;
            }
        }

        private void txtClosingRemark_TextChanged(object sender, EventArgs e)
        {
            if (closingremarks != txtClosingRemark.Text)
            {
                blnDataChanged = true;
            }
        }

        private void LoadContactPerson()
        {
            if (contactid == 0)
                return;

            foreach (DataRow dr in dtContact.Rows)
            {
                int aid;
                if (contactid == (int)dr["ContactId"])
                {
                    txtPhone.Text = Convert.ToString(dr["GeneralPhone"]);
                    txtFax.Text = Convert.ToString(dr["Fax"]);
                    txtEmail.Text = Convert.ToString(dr["Email"]);
                    aid = GlobalCode.ToInt32(dr["OrgAddressId"]);
                    if (aid > 0)
                        GlobalCode.ComboSetValue(cmbAddress, aid);
                    break;
                }
            }


            //DataSet ds = null;
            //ds = ContactData.GetContactPerson(contactid);
            //DataRow dr = ds.Tables[0].Rows[0];
            ////txtAddress.Text = Convert.ToString(dr["Address"]) + "\r\n" + Convert.ToString(dr["City"]) + "  " + Convert.ToString(dr["State"]) + "  " + Convert.ToString(dr["Zip"]);
            //txtPhone.Text = Convert.ToString(dr["GeneralPhone"]);
        }

        private void cmbContactPerson_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!blnDataLoaded)
                return;
            try
            {
                contactid = Convert.ToInt32(cmbContactPerson.SelectedValue);
            }
            catch (Exception)
            {
                return;
            }
            LoadContactPerson();
            blnDataChanged = true;
        }

        private void txtProjectNumber_DoubleClick(object sender, EventArgs e)
        {
            Form1 mainForm = (Form1)this.MdiParent;
            mainForm.OpenProject(pid, projecttitle);

            CCPM.Project.ProjectForm projectForm = null;
            mainForm.GetCurrentProject(out projectForm);
            projectForm.SetTabIndex(0);
        }

        //private void btnGoToProjectFundingTab_Click(object sender, EventArgs e)
        //{
        //    Form1 mainForm = (Form1)this.MdiParent;
        //    mainForm.OpenProject(pid);

        //    CCPM.Project.ProjectForm projectForm = null;
        //    mainForm.GetCurrentProject(out projectForm);
        //    projectForm.SetTabIndex(3);
        //}

        private void ContractDetail_Activated(object sender, EventArgs e)
        {
            RestoreWindowState();
        }
        private void RestoreWindowState()
        {
            // Looking for given form among all opened forms 
            Form instance = null;
            foreach (Form form in Application.OpenForms)
                if (form is ContractDetail && form.Text.Trim() == this.Text)
                {
                    instance = form;

                    if (instance.WindowState == FormWindowState.Minimized)
                        instance.WindowState = FormWindowState.Normal;

                    instance.BringToFront();
                    if (instance.CanFocus)
                        instance.Focus();

                    break;
                }
        }

        private void chkRepayment_CheckStateChanged(object sender, EventArgs e)
        {
            if (chkRepayment.Checked != repay)
            {
                blnDataChanged = true;
            }
            else
            {
                blnDataChanged = false;
            }
        }

        private void chkMonitoring_CheckStateChanged(object sender, EventArgs e)
        {
            if (chkMonitoring.Checked != monitoring)
            {
                blnDataChanged = true;
            }
        }

        private void txtNotes_TextChanged(object sender, EventArgs e)
        {
            blnDataChanged = true;
        }

        private void uwdtDateExecuted_ValueChanged(object sender, EventArgs e)
        {
        }

        private void uwdtCompletionDate_ValueChanged(object sender, EventArgs e)
        {
        }

        private void uwdtTerminationDate_ValueChanged(object sender, EventArgs e)
        {
        }

        private void uwdtClosedDate_ValueChanged(object sender, EventArgs e)
        {
        }

        private void btnGoToFundingTab_Click(object sender, EventArgs e)
        {
            Form1 mainForm = (Form1)this.MdiParent;
            mainForm.OpenProject(pid, projecttitle);

            CCPM.Project.ProjectForm projectForm = null;
            mainForm.GetCurrentProject(out projectForm);
            projectForm.SetTabIndex(3);
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            if (blnDataDirty == true || blnDataChanged == true)
            {
                DialogResult diaRslt = MessageBox.Show("Do you want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (diaRslt == DialogResult.Yes)
                {
                    if (!SaveContractDetail())
                        return;
                    SaveAmendmentGrid();
                    SaveFundSourceGrid();
                }
            }
            LoadContractDetailsPage();
            if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value == null)
            {
                newStatusId = 1;
                cmbStatus.SelectedValue = 2;

            }
            else if (uwdtClosedDate.Value == null && uwdtDateExecuted.Value == null)
            {
                newStatusId = 0;
                cmbStatus.SelectedValue = 1;

            }
            else if (uwdtDateExecuted.Value == null && uwdtClosedDate.Value != null)
            {
                newStatusId = 3;
                cmbStatus.SelectedValue = 4;

            }
            else if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value != null)
            {
                newStatusId = 3;
                cmbStatus.SelectedValue = 4;

            }
        }

        private void txtContractNumber_TextChanged(object sender, EventArgs e)
        {
            blnDataChanged = true;
        }

        private void txtTaxId_TextChanged(object sender, EventArgs e)
        {
            blnDataChanged = true;
        }

        private void uwdtCompletionDate_Leave(object sender, EventArgs e)
        {
            blnDataChanged = true;

            if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value == null)
            {
                newStatusId = 1;
                cmbStatus.SelectedValue = 2;

            }
            else if (uwdtClosedDate.Value == null && uwdtDateExecuted.Value == null)
            {
                newStatusId = 0;
                cmbStatus.SelectedValue = 1;

            }
            else if (uwdtDateExecuted.Value == null && uwdtClosedDate.Value != null)
            {
                newStatusId = 3;
                cmbStatus.SelectedValue = 4;

            }
            else if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value != null)
            {
                newStatusId = 3;
                cmbStatus.SelectedValue = 4;

            }

            if (uwdtTerminationDate.Value == null && uwdtCompletionDate.Value != null)
            {
                uwdtTerminationDate.Value = uwdtCompletionDate.DateTime.AddMonths(3);
            }
            else
            {
                if (uwdtCompletionDate.DateTime.Date > uwdtTerminationDate.DateTime.Date)
                {
                    MessageBox.Show("The Completion Date can not be later than the Termination Date !!", "Data Entry Error", MessageBoxButtons.OK);
                    uwdtCompletionDate.Value = dtCompletionDate;
                    //uwdtCompletionDate.Focus();
                }
            }
        }

        private void uwdtDateExecuted_Enter(object sender, EventArgs e)
        {
            uwdtDateExecuted.SelectAll();
        }

        private void uwdtCompletionDate_Enter(object sender, EventArgs e)
        {
            uwdtCompletionDate.SelectAll();
        }

        private void uwdtTerminationDate_Enter(object sender, EventArgs e)
        {
            uwdtTerminationDate.SelectAll();
        }

        private void uwdtClosedDate_Enter(object sender, EventArgs e)
        {
            uwdtClosedDate.SelectAll();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (cid == 0 || blnDataChanged == true)
            {
                MessageBox.Show("Save contract details first.");
                return;
            }
            if (txtContractNumber.Text == "")
            {
                MessageBox.Show("Contract number required.  Enter contract number and save contract details first.");
                return;
            }

            CCPM.Report.ContractExpirationReport fm = new CCPM.Report.ContractExpirationReport(txtContractNumber.Text, chkShowDocumentMap.Checked);
            Form1 fm1 = (Form1)this.MdiParent;
            fm1.OpenForm(fm, "Contract Expiration Report: " + txtContractNumber.Text);
        }

        private void uwgContractFund_AfterEnterEditMode(object sender, EventArgs e)
        {
            blnDisplay = true;
        }

        private void uwdtCompletionDate_Click(object sender, EventArgs e)
        {
            dtCompletionDate = uwdtCompletionDate.Value;
        }

        private void cmbStatus_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cmbStatus.SelectedIndex.ToString() == "2")
            {
                if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value == null)
                {
                    blnDisplay1 = false;
                    cmbStatus.SelectedIndex = 2;
                }
                else
                {
                    cmbStatus.SelectedIndex = newStatusId;
                }
            }

            else if (cmbStatus.SelectedIndex.ToString() == "1")
            {
                if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value == null)
                {
                    blnDisplay1 = false;
                    cmbStatus.SelectedIndex = 1;
                }
                else
                {
                    cmbStatus.SelectedIndex = newStatusId;
                }
            }
            else if (cmbStatus.SelectedIndex.ToString() == "3")
            {
                if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value != null)
                {
                    cmbStatus.SelectedIndex = 3;
                    //if (DialogResult.Yes == MessageBox.Show("Do you want to complete the closing comments now?", "Warning", MessageBoxButtons.YesNo))
                    //{
                    //    txtClosingRemark.Focus();
                    //}
                }
                else
                {
                    cmbStatus.SelectedIndex = newStatusId;
                }
            }
            else
            {
                blnDisplay1 = false;
                cmbStatus.SelectedIndex = newStatusId;
            }
        }

        private void uwgAmendment_KeyDown(object sender, KeyEventArgs e)
        {
            if (cid == 0)
                return;
            //if (uwgAmendment.Rows.Count > 0)
            //{
            //    if (uwgAmendment.ActiveRow.Cells[3].IsInEditMode == true || uwgAmendment.ActiveRow.Cells[3].Activated == true)
            //    {
            //        ContractAmedment ca = new ContractAmedment(Convert.ToInt32(cid));
            //        ca.MyParentForm = this;
            //        if (ca.ShowDialog() == DialogResult.OK)
            //        {
            //            uwgAmendment.ActiveRow.Cells[3].Value = ca.Amount;
            //            string fundSource = ca.FundingSource;
            //            for (int i = 0; i < uwgContractFund.Rows.Count; i++)
            //            {
            //                if (uwgContractFund.Rows[i].Cells[1].Text.ToString() == fundSource)
            //                {
            //                    DataSet ds = ContractData.GetFundsourceAmount(Convert.ToInt32(uwgContractFund.Rows[i].Cells[1].Value), Convert.ToInt32(pid));
            //                    DataRow dr = ds.Tables[0].Rows[0];
            //                    TotalFundingSourceAmount = Convert.ToDecimal(dr[0]);
            //                    // Add the augmentation amount to the fund source contracted amount
            //                    uwgContractFund.Rows[i].Cells[2].Value = Convert.ToDecimal(uwgContractFund.Rows[i].Cells[2].Value) + ca.Amount;
            //                    uwgContractFund.Rows[i].Cells[8].Value = "1";
            //                }
            //            }
            //        }
            //    }
            //}
        }

        private void uwdtTerminationDate_Leave(object sender, EventArgs e)
        {
            blnDataChanged = true;

            if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value == null)
            {
                newStatusId = 1;
                cmbStatus.SelectedValue = 2;

            }
            else if (uwdtClosedDate.Value == null && uwdtDateExecuted.Value == null)
            {
                newStatusId = 0;
                cmbStatus.SelectedValue = 1;

            }
            else if (uwdtDateExecuted.Value == null && uwdtClosedDate.Value != null)
            {
                newStatusId = 3;
                cmbStatus.SelectedValue = 4;

            }
            else if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value != null)
            {
                newStatusId = 3;
                cmbStatus.SelectedValue = 4;

            }

            if (uwdtTerminationDate.Value != null && uwdtCompletionDate.Value != null)
            {
                if (uwdtCompletionDate.DateTime.Date > uwdtTerminationDate.DateTime.Date)
                {
                    MessageBox.Show("The Termination Date must be greater than the Completion Date !!", "Data Entry Error", MessageBoxButtons.OK);
                }
            }
        }

        private void uwdtClosedDate_Leave(object sender, EventArgs e)
        {
            blnDataChanged = true;

            if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value == null)
            {
                newStatusId = 1;
                cmbStatus.SelectedValue = 2;

            }
            else if (uwdtClosedDate.Value == null && uwdtDateExecuted.Value == null)
            {
                newStatusId = 0;
                cmbStatus.SelectedValue = 1;

            }
            else if (uwdtDateExecuted.Value == null && uwdtClosedDate.Value != null)
            {
                newStatusId = 3;
                cmbStatus.SelectedValue = 4;

            }
            else if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value != null)
            {
                newStatusId = 3;
                cmbStatus.SelectedValue = 4;

            }

        }

        private void uwdtDateExecuted_Leave(object sender, EventArgs e)
        {
            blnDataChanged = true;
            //status from draft to active
            if (uwdtDateExecuted.Value != null)
            {
                if (cmbStatus.SelectedIndex == 0)
                {
                    cmbStatus.SelectedIndex = 1;
                }

                if (uwgAmendment.Rows.Count > 0)
                {
                    uwgAmendment.Rows[0].Cells["ExecutedDate"].Value = uwdtDateExecuted.Value;
                }
            }

            if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value == null)
            {
                newStatusId = 1;
                cmbStatus.SelectedValue = 2;

            }
            else if (uwdtClosedDate.Value == null && uwdtDateExecuted.Value == null)
            {
                newStatusId = 0;
                cmbStatus.SelectedValue = 1;

            }
            else if (uwdtDateExecuted.Value == null && uwdtClosedDate.Value != null)
            {
                newStatusId = 3;
                cmbStatus.SelectedValue = 4;

            }
            else if (uwdtDateExecuted.Value != null && uwdtClosedDate.Value != null)
            {
                newStatusId = 3;
                cmbStatus.SelectedValue = 4;

            }

        }

        private void txtTaxId_Leave(object sender, EventArgs e)
        {
            if (txtTaxId.Text != string.Empty)
            {
                string patern = @"^(\d{2}-\d{7})";
                if (System.Text.RegularExpressions.Regex.IsMatch(txtTaxId.Text, patern) == false)
                {
                    MessageBox.Show("Invalid Tax ID Number.  ID must be in 00-0000000 format.", "Data Entry Error", MessageBoxButtons.OK);
                    txtTaxId.Focus();
                }
            }
        }

        private void txtContractNumber_Leave(object sender, EventArgs e)
        {
        }

        private void txtFax_TextChanged(object sender, EventArgs e)
        {
            if (fax != txtFax.Text)
            {
                blnDataChanged = true;
            }

        }

        private void txtEmail_TextChanged(object sender, EventArgs e)
        {
            if (email != txtEmail.Text)
            {
                blnDataChanged = true;
            }

        }

        private void btnSubstitute_Click(object sender, EventArgs e)
        {
            UltraGridRow row = this.uwgContractFund.ActiveRow;
            if (null != row)
            {
                if (cid == 0)
                {
                    MessageBox.Show("Please save the Contract", "Data Entry Error", MessageBoxButtons.OK);
                }
                else
                {
                    GlobalSettings.mainFormHandle.OpenFundSubstitute(cid);
                }

            }
            else
            {
                // If there is no active row, then prompt the user to select one. 
                MessageBox.Show("Please select a single row to delete.");
            }
        }

        private void ugFundingSourceDropdown_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            ugFundingSourceDropdown.Width = 360;
            ugFundingSourceDropdown.Height = 120;

            e.Layout.Bands[0].Columns[0].Hidden = true;

            e.Layout.Bands[0].Columns[1].Width = 300;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Funding Item";


            //Is Active
            e.Layout.Bands[0].Columns[2].Width = 60;
            e.Layout.Bands[0].Columns[2].Header.Caption = "IsActive";
            e.Layout.Bands[0].Columns[2].Hidden = true;

            //Extra InActive Column
            e.Layout.Bands[0].Columns[3].Hidden = true;

            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;

        }

        private void ugFundingSourceDropdown_DoubleClick(object sender, EventArgs e)
        {
            uteFund.CloseEditorButtonDropDowns();
        }

        private void ugFundingSourceDropdown_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                uteFund.CloseEditorButtonDropDowns();
            }
        }

        private void uteFund_AfterEditorButtonCloseUp(object sender, Infragistics.Win.UltraWinEditors.EditorButtonEventArgs e)
        {
            if (ugFundingSourceDropdown.ActiveRow != null)
            {
                uteFund.Value = ugFundingSourceDropdown.ActiveRow.Cells[1].Value;
                uwgContractFund.ActiveRow.Cells["FundID"].Value = ugFundingSourceDropdown.ActiveRow.Cells["FundID"].Value.ToString();
                
            }
        }

        private void uteFund_BeforeEditorButtonDropDown(object sender, Infragistics.Win.UltraWinEditors.BeforeEditorButtonDropDownEventArgs e)
        {
            if (uwgContractFund.ActiveRow.Cells[1].IsActiveCell)
            {
                string item = uwgContractFund.ActiveRow.Cells["FundID"].Value.ToString();
                if (item != string.Empty)


                    for (int i = 0; i < ugFundingSourceDropdown.Rows.Count; i++)
                    {
                        if (item.ToString() == ugFundingSourceDropdown.Rows[i].Cells["FundID"].Value.ToString())
                        {

                            ugFundingSourceDropdown.Rows[i].Selected = true;
                            ugFundingSourceDropdown.Rows[i].Activated = true;
                            break;
                        }
                    }
                blnDataDirty = false;
            }
        }

        private void uwgContractFund_BeforeCellListDropDown(object sender, CancelableCellEventArgs e)
        {

            if (uwgContractFund.ActiveRow.Cells[2].IsActiveCell)
            {
                string item = uwgContractFund.ActiveCell.Value.ToString();
                if (item != string.Empty)
                {
                    for (int i = 0; i < ugFundingSourceDropdown.Rows.Count; i++)
                    {
                        if (item == ugFundingSourceDropdown.Rows[i].Cells["FundingItem"].Value.ToString())
                        {

                            ugFundingSourceDropdown.Rows[i].Selected = true;
                            ugFundingSourceDropdown.Rows[i].Activated = true;
                            break;
                        }
                    }
                }
            }
            blnDataDirty = false;
        }
    }

}
