﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CCPM.Data;

namespace CCPM.Contract
{
    public partial class ContractPicker : Form
    {
        public ContractPicker()
        {
            InitializeComponent();
            this.Location = new Point(0, 0);
            DataSet ds = null;
            ds = ContractData.GetContractList();
            cmbContractNumber.DataSource = ds.Tables[0];
            cmbContractNumber.DisplayLayout.Bands[0].Columns[0].Hidden = true;
            cmbContractNumber.DisplayMember = "ContractNumber";
            cmbContractNumber.ValueMember = "ContractId";
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            string ContractNumber = cmbContractNumber.Text.ToString();
            if (ContractNumber == string.Empty)
            {
                MessageBox.Show("Please select the Contract Number from the list", "Data Entry Error", MessageBoxButtons.OK);
            }
            else if (ContractData.IsContractNumber(ContractNumber))
            {
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenContract(ContractNumber);
                this.Close();
            }
            else
            {
                MessageBox.Show("Please select a valid Contract Number from the list", "Contract Number Doesn't Exist", MessageBoxButtons.OK);
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void cmbContractNumber_ValueChanged(object sender, EventArgs e)
        {
            //cmbContractNumber.Textbox.Select(0, 0);
        }

        private void cmbContractNumber_KeyDown(object sender, KeyEventArgs e)
        {
            if (this.cmbContractNumber.Textbox.SelectionLength == 0)
            {
                this.cmbContractNumber.Select();
            }
        }

        private void ContractPicker_Load(object sender, EventArgs e)
        {
        }       
    }
}
