﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CCPM.Contract
{
    public partial class MasterContractLog : Form
    {
        bool blnViewOnly = true;

        public MasterContractLog()
        {
            InitializeComponent();
            SetSecurity();
        }

        private void SetSecurity()
        {
            //edit & delete only:  Contracts Manager, Contracts Staff, and Accounting Manager
            if (GlobalSettings.IsContractsManager || GlobalSettings.IsContractsStaff || GlobalSettings.IsAccountingManager)
            {
                blnViewOnly = false;
            }
            else
            {
                //btnSave.Enabled = false;
            }
            //if (blnViewOnly)
            //    return;

        }

        private void uwgMasterContractLog_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //Contract Id
            e.Layout.Bands[0].Columns[0].Hidden = true;

            e.Layout.Bands[0].Columns[1].Width = 120;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Contract Number";
            e.Layout.Bands[0].Columns[1].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[1].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[1].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[1].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[2].Width = 150;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Grantee/Contractor";
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[3].Width = 50;
            e.Layout.Bands[0].Columns[3].Header.Caption = "Contract Type";
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[3].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[3].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[3].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[4].Width = 50;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Contract Status";
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[4].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[4].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[4].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[5].Width = 70;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Liquidation Alert";
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[5].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[5].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[5].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[6].Width = 50;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Date Executed";
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[7].Width = 50;
            e.Layout.Bands[0].Columns[7].Header.Caption = "Completion Date";
            e.Layout.Bands[0].Columns[7].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[7].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[7].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[7].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[8].Width = 50;
            e.Layout.Bands[0].Columns[8].Header.Caption = "Termination Date";
            e.Layout.Bands[0].Columns[8].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[8].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[8].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[8].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[9].Width = 50;
            e.Layout.Bands[0].Columns[9].Header.Caption = "Contract Expiration Alert";
            e.Layout.Bands[0].Columns[9].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[9].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[9].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[9].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[10].Width = 50;
            e.Layout.Bands[0].Columns[10].Header.Caption = "Contracted Amount";
            e.Layout.Bands[0].Columns[10].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[10].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[10].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[10].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[11].Width = 50;
            e.Layout.Bands[0].Columns[11].Header.Caption = "Paid To-Date";
            e.Layout.Bands[0].Columns[11].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;
            e.Layout.Bands[0].Columns[11].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[11].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[11].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[12].Width = 150;
            e.Layout.Bands[0].Columns[12].Header.Caption = "Balance To-Date";
            e.Layout.Bands[0].Columns[12].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[12].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[12].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[12].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[13].Width = 100;
            e.Layout.Bands[0].Columns[13].Header.Caption = "Disencumbered Amount";
            e.Layout.Bands[0].Columns[13].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[13].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[13].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[13].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[14].Width = 50;
            e.Layout.Bands[0].Columns[14].Header.Caption = "Reimbursable Amount";
            e.Layout.Bands[0].Columns[14].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[14].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[14].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[14].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[15].Width = 50;
            e.Layout.Bands[0].Columns[15].Header.Caption = "Repay Amount";
            e.Layout.Bands[0].Columns[15].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[15].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[15].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[15].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[16].Width = 50;
            e.Layout.Bands[0].Columns[16].Header.Caption = "Repaid To-Date";
            e.Layout.Bands[0].Columns[16].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[16].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[16].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[16].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[17].Width = 50;
            e.Layout.Bands[0].Columns[17].Header.Caption = "Balance To Repay";
            e.Layout.Bands[0].Columns[17].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[17].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[17].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[17].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[18].Width = 80;
            e.Layout.Bands[0].Columns[18].Header.Caption = "Repay Alert";
            e.Layout.Bands[0].Columns[18].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[18].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[18].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[18].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[19].Width = 80;
            e.Layout.Bands[0].Columns[19].Header.Caption = "Monitoring Alert";
            e.Layout.Bands[0].Columns[19].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[19].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[19].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[19].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[20].Width = 80;
            e.Layout.Bands[0].Columns[20].Header.Caption = "Project Contract Manager";
            e.Layout.Bands[0].Columns[20].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[20].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[20].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[20].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[21].Width = 80;
            e.Layout.Bands[0].Columns[21].Header.Caption = "Region";
            e.Layout.Bands[0].Columns[21].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[21].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[21].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[21].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[22].Width = 80;
            e.Layout.Bands[0].Columns[22].Header.Caption = "County";
            e.Layout.Bands[0].Columns[22].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;
            e.Layout.Bands[0].Columns[22].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[22].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[22].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            //DirtyFlag
            e.Layout.Bands[0].Columns[23].Hidden = true;
        }

        private void uwgMasterContractLog_Enter(object sender, EventArgs e)
        {
            uwgMasterContractLog.Rows[1].Cells[1].Activate();
        }
    }
}
