﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using CCPM.Data;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Contract
{
    public partial class MonitoringLog : Form
    {
        DataSet dsProjectStaff = null;
        bool blnGridDirty = false;
        public MonitoringLog()
        {
            InitializeComponent();
            this.Location = new Point(0, 0);

            uwgMonitoringLog.DisplayLayout.Override.WrapHeaderText = Infragistics.Win.DefaultableBoolean.True;
            uwgMonitoringLog.DisplayLayout.Override.HeaderClickAction = HeaderClickAction.SortSingle;

            //Create and bind Project Staff database
            dsProjectStaff = ProjectData.ProjectStaffList();
            uwgMonitoringLog.DisplayLayout.ValueLists.Add("Name");
            for (int i = 0; i < dsProjectStaff.Tables[0].Rows.Count; i++)
            {
                Infragistics.Win.ValueListItem listItem1 = new Infragistics.Win.ValueListItem();
                listItem1.DataValue = dsProjectStaff.Tables[0].Rows[i].ItemArray.GetValue(0);
                listItem1.DisplayText = (string)dsProjectStaff.Tables[0].Rows[i].ItemArray.GetValue(1);
                uwgMonitoringLog.DisplayLayout.ValueLists["Name"].ValueListItems.Add(listItem1);
            }

            LoadMonitoringLogAll();
        }
        private void LoadData()
        {
            this.Cursor = Cursors.WaitCursor;
            DataSet dsMonitoringGrid = ContractData.GetContractMonitoringLog();
            this.Cursor = Cursors.Default;
            uwgMonitoringLog.DataSource = dsMonitoringGrid.Tables[0];
            uwgMonitoringLog.DataBind();
        }

        private void LoadMonitoringLog()
        {
            if (uwgMonitoringLog.DataSource != null)
            {
                LoadData();
            }
            btnSave.Enabled = false;
            blnGridDirty = false;
        }

        private void LoadMonitoringLogAll()
        {
            lblFilter.Text = "";
            lblFilterOn.Text = "";
            this.uwgMonitoringLog.DisplayLayout.Bands[0].ColumnFilters.ClearAllFilters();

            LoadData();
            btnSave.Enabled = false;
            blnGridDirty = false;
        }

        private void uwgMonitoringLog_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {

            //Monitoring Detail ID
            e.Layout.Bands[0].Columns[0].Hidden=true;

            e.Layout.Bands[0].Columns[1].Width = 120;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Contract Number";
            e.Layout.Bands[0].Columns[1].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[1].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[1].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns[1].CellActivation = Activation.NoEdit;
            e.Layout.Bands[0].Columns[1].TabStop = false;

            e.Layout.Bands[0].Columns[2].Width = 100;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Project Name";
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns[2].CellActivation = Activation.NoEdit;
            e.Layout.Bands[0].Columns[2].TabStop = false;

            e.Layout.Bands[0].Columns[3].Width = 150;
            e.Layout.Bands[0].Columns[3].Header.Caption = "Grantee/Contractor";
            e.Layout.Bands[0].Columns[3].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[3].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[3].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns[3].CellActivation = Activation.NoEdit;
            e.Layout.Bands[0].Columns[3].TabStop = false;

            e.Layout.Bands[0].Columns[4].Width = 80;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Due Date";
            e.Layout.Bands[0].Columns[4].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[4].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[4].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns[4].CellActivation = Activation.NoEdit;
            e.Layout.Bands[0].Columns[4].TabStop = false;

            e.Layout.Bands[0].Columns[5].Width = 100;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Monitoring Alert";
            e.Layout.Bands[0].Columns[5].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[5].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[5].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns[5].CellActivation = Activation.NoEdit;
            e.Layout.Bands[0].Columns[5].TabStop = false;

            e.Layout.Bands[0].Columns[6].Width = 80;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Date Last Monitored";
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns[6].CellActivation = Activation.NoEdit;
            e.Layout.Bands[0].Columns[6].TabStop = false;

            e.Layout.Bands[0].Columns[7].Width = 100;
            e.Layout.Bands[0].Columns[7].Header.Caption = "Outcome from Last Monitoring";
            e.Layout.Bands[0].Columns[7].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[7].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[7].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns[7].CellActivation = Activation.NoEdit;
            e.Layout.Bands[0].Columns[7].TabStop = false;

            e.Layout.Bands[0].Columns[8].Width = 100;
            e.Layout.Bands[0].Columns[8].Header.Caption = "Remarks from Last Monitoring";
            e.Layout.Bands[0].Columns[8].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[8].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[8].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns[8].CellActivation = Activation.NoEdit;
            e.Layout.Bands[0].Columns[8].TabStop = false;

            e.Layout.Bands[0].Columns[9].Width = 80;
            e.Layout.Bands[0].Columns[9].Header.Caption = "Project Contract Manager";
            e.Layout.Bands[0].Columns[9].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            e.Layout.Bands[0].Columns[9].ValueList = uwgMonitoringLog.DisplayLayout.ValueLists["Name"];
            e.Layout.ValueLists["Name"].DisplayStyle = Infragistics.Win.ValueListDisplayStyle.DisplayText;

            e.Layout.Bands[0].Columns[10].Width = 90;
            e.Layout.Bands[0].Columns[10].Header.Caption = "Region";
            e.Layout.Bands[0].Columns[10].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[10].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[10].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns[10].CellActivation = Activation.NoEdit;
            e.Layout.Bands[0].Columns[10].TabStop = false;

            e.Layout.Bands[0].Columns[11].Width = 90;
            e.Layout.Bands[0].Columns[11].Header.Caption = "County";
            e.Layout.Bands[0].Columns[11].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[11].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[11].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            e.Layout.Bands[0].Columns[11].CellActivation = Activation.NoEdit;
            e.Layout.Bands[0].Columns[11].TabStop = false;

            //ContractID
            e.Layout.Bands[0].Columns[12].Hidden = true;
           //Dirty Flag
            e.Layout.Bands[0].Columns[13].Hidden=true;


            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;
        }

        private void GoMonitoringDetails()
        {
            Form1 fm = (Form1)this.MdiParent;
            fm.OpenMonitoring(Convert.ToInt32(uwgMonitoringLog.ActiveRow.Cells["ContractId"].Value));
        }

        private void btnViewMonitoring_Click(object sender, EventArgs e)
        {
            GoMonitoringDetails();
        }

        private void uwgMonitoringLog_DoubleClick(object sender, EventArgs e)
        {
            GoMonitoringDetails();
        }

        private void SaveMonitoringLog()
        {
            foreach (UltraGridRow ugr in uwgMonitoringLog.Rows)
            {
                if (ugr.Cells["DirtyFlag"].Value.ToString() == "1")
                {
                    string sql = "UPDATE ContractDetails"
                        + " SET ProjectManagerId = " + Convert.ToInt32(ugr.Cells["ProjectManagerId"].Value)
                        + " where ContractId = " + ugr.Cells["ContractId"].Value.ToString();
                    int retVal = SqlHelper.ExecuteNonQuery(DbConnection.GetDbConnection().DbConnectionString, CommandType.Text, sql);
                    ContractData.ProjectProjectManagerInsert(Convert.ToInt32(ugr.Cells["ContractId"].Value));
                    if (retVal == -1)
                    {
                        MessageBox.Show("Update failed ", "Database Error",
                      MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
            }
            LoadMonitoringLog();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            SaveMonitoringLog();
        }

        private void uwgMonitoringLog_CellChange(object sender, CellEventArgs e)
        {
            if (uwgMonitoringLog.ActiveRow.Cells["DirtyFlag"].Value.ToString() == "0")
            {
                uwgMonitoringLog.ActiveRow.Cells["DirtyFlag"].Value = 1;

            }
            blnGridDirty = true;
            btnSave.Enabled = true;
        }

        private void MonitoringLog_Activated(object sender, EventArgs e)
        {
            LoadMonitoringLog();
            
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            if (blnGridDirty == true)
            {
                DialogResult diaRslt = MessageBox.Show("Do you want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (diaRslt == DialogResult.Yes)
                {
                    SaveMonitoringLog();
                }
            }
            label4.Visible = false;
            LoadMonitoringLog();
        }

        private void btnFilter_Click(object sender, EventArgs e)
        {
            GridFilter gf = new GridFilter(uwgMonitoringLog, lblFilter, lblFilterOn, this.Text);
            gf.ShowDialog();
            if (lblFilter.Text != string.Empty)
            {
                label4.Visible = true;
            }
            else
            {
                label4.Visible = false;
            }
        }

        private void btnExport_Click(object sender, EventArgs e)
        {
            string excelFile = GlobalCode.ExcelFileName("c:\\Temp", "ccpm_export.xls", false);
            if (excelFile != string.Empty)
            {
                GlobalCode.ExportGridToExcel(uwgMonitoringLog, excelFile);
                GlobalCode.OpenAssociatedFile(excelFile);
            }
        }

        private void MonitoringLog_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (blnGridDirty)
            {
                DialogResult dr = MessageBox.Show("Do You want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (dr == DialogResult.Yes)
                    SaveMonitoringLog();
            }
        }

        private void uwgMonitoringLog_DoubleClickRow(object sender, DoubleClickRowEventArgs e)
        {
            GoMonitoringDetails(); 
        }

        private void uwgMonitoringLog_Enter(object sender, EventArgs e)
        {
            if (uwgMonitoringLog.Rows.Count > 0)
                uwgMonitoringLog.Rows[0].Cells[1].Activate();
        }

        private void uwgMonitoringLog_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == Convert.ToChar(Keys.Tab))
            {
                uwgMonitoringLog.ActiveCell.Selected = true;
            }   
        }

        private void btnSeeAll_Click(object sender, EventArgs e)
        {
            if (blnGridDirty == true)
            {
                DialogResult diaRslt = MessageBox.Show("Do you want to save changes ?", "Warning", MessageBoxButtons.YesNo);
                if (diaRslt == DialogResult.Yes)
                {
                    SaveMonitoringLog();
                }
            }
            label4.Visible = false;
            LoadMonitoringLogAll();

        }
        
    }
}
