﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CCPM.Data;

namespace CCPM.Contract
{
    public partial class OpenInvoice : Form
    {
        public OpenInvoice()
        {
            InitializeComponent();
            this.Location = new Point(0, 0);
            DataSet ds = null;
            ds = ContractData.GetContractList();
            cmbContractNumber.DataSource = ds.Tables[0];
            cmbContractNumber.DisplayLayout.Bands[0].Columns[0].Hidden = true;
            cmbContractNumber.DisplayMember = "ContractNumber";
            cmbContractNumber.ValueMember = "ContractId";           
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if (cmbContractNumber.Text == string.Empty || cmbFundingSource.Text == string.Empty)
            {
                MessageBox.Show("Please select Contract Number and Funding Source !!", "Data Entry Error", MessageBoxButtons.OK);
            }
            else
            {
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenInvoiceDrawdown(Convert.ToInt32(cmbContractNumber.SelectedRow.Cells[0].Value), Convert.ToInt32(cmbFundingSource.SelectedValue));
                this.Close();
            }
        }

        private void cmbContractNumber_ValueChanged(object sender, EventArgs e)
        {
            //cmbContractNumber.Textbox.Select(0, 0);
        }

        private void cmbContractNumber_TextChanged(object sender, EventArgs e)
        {
            DataSet ds1 = ContractData.GetContractFundingSource(Convert.ToInt32(cmbContractNumber.SelectedRow.Cells[0].Value));
            cmbFundingSource.DataSource = ds1.Tables[0];
            cmbFundingSource.DisplayMember = "FundingItem";
            cmbFundingSource.ValueMember = "FundID";
            cmbFundingSource.SelectedIndex = -1;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
