using System;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Data
{
	/// <summary>
	/// Summary description for ContactData.
	/// </summary>
	public class ContactData
	{

        private static string connectionString
        {
            get { return GlobalSettings.ConnectionString; }
        }

		static ContactData()
		{
			//DbConnection dbConnection = DbConnection.GetDbConnection();
			//connectionString = dbConnection.DbConnectionString;
		}

        //todo:  fix ContactAddress ...
		public static int InsertContact(
			string ContactFName,
			string ContactLName ,
			string ContactJobTitle ,
            string ContactPhone,
            string ContactExtension,
            string ContactCellPhone,
            string ContactEmail,
            string ContactFax,
            string ContactNotes,
			object OrgID ,
			object OrgAddressID,
            string ContactAddress,
            string ContactCity,
            string ContactState,
            string ContactZip)
		{
			int retVal = SqlHelper.ExecuteNonQuery(
				connectionString,
				"ContactInsert",
				ContactFName,
				ContactLName ,
				ContactJobTitle ,
                ContactPhone,
                ContactExtension,
                ContactCellPhone,
                ContactEmail,
                ContactFax ,
				ContactNotes,
				OrgID ,
				OrgAddressID,
                ContactAddress,
                ContactCity,
                ContactState,
                ContactZip);
            return retVal;
        }

		public static int PersistContact(ContactDataSet cds)
		{
			SqlConnection conn = new SqlConnection(connectionString);
			conn.Open();
//			SqlCommand insertCommand = SqlHelper.CreateCommand(
//				conn,
//				"ContactInsert",
//				"ContactFName",
//				"ContactLName",
//				"ContactJobTitle",
//				"ContactOrg",
//				"ContactDept",
//				"ContactOrgTypeId",
//				"ContactAddress",
//				"ContactCity",
//				"ContactState",
//				"ContactZip" ,
//				"ContactPhone" ,
//				"ContactExtension" ,
//				"ContactFax" ,
//				"ContactCellPhone", 
//				"ContactEmail",
//				"ContactNotes");

			SqlCommand updateCommand = SqlHelper.CreateCommand(
				conn,
				"ContactUpdate",
				"ContactFName",
				"ContactLName",
				"ContactJobTitle",
				"OrgID",
				"ContactDept",
				"ContactAddress",
				"ContactCity",
				"ContactState",
				"ContactZip" ,
				"ContactPhone" ,
				"ContactExtension" ,
				"ContactFax" ,
				"ContactCellPhone", 
				"ContactEmail",
				"ContactNotes",
				"ContactID");
			
//			SqlCommand deleteCommand = SqlHelper.CreateCommand(
//				connectionString,
//				"contactDelete"

			//SqlHelper.UpdateDataset(insertCommand, null, null, cds, tableName);
			SqlDataAdapter da = new SqlDataAdapter();
			da.UpdateCommand = updateCommand;
			int returnval = da.Update(cds, "ContactList");
			conn.Close();

			return returnval;
		}

		public static int UpdateContact(
				string ContactFName,
			    string ContactLName ,
			    string ContactJobTitle ,
                string ContactPhone,
                string ContactExtension,
                string ContactCellPhone,
                string ContactEmail,
                string ContactFax,
                string ContactNotes,
			    object OrgID ,
			    object OrgAddressID,
				int contactId)
			{
				int result = SqlHelper.ExecuteNonQuery(
					connectionString,
					"ContactUpdate",
					ContactFName,
				    ContactLName ,
				    ContactJobTitle ,
                    ContactPhone,
                    ContactExtension,
                    ContactCellPhone,
                    ContactEmail,
                    ContactFax ,
				    ContactNotes,
				    OrgID ,
				    OrgAddressID,
					contactId);
				return result;

			}

        public static int InsertOrganization(
                string Organization,
                string Dept,
                string Street,
                string City,
                string State,
                string Zip,
                string Phone,
                string Fax,
                string OrgNotes,
                int OrgTypeId,
                string TaxIdNumber,
                string SBE,
                string DVBE,
                string CertificationNumber)
        {
            int result = SqlHelper.ExecuteNonQuery(
                connectionString,
                "ContactOrganizationInsert",
                Organization,
                Dept,
                Street,
                City,
                State,
                Zip,
                Phone,
                Fax,
                OrgNotes,
                //ContactZipPlus ,
                OrgTypeId,
                TaxIdNumber,
                SBE,
                DVBE,
                CertificationNumber);
            return result;

        }

        public static int UpdateOrganization(
                int OrgId,
                string Organization,
                string Dept,
                string Street,
                string City,
                string State,
                string Zip,
                string Phone,
                string Fax,
                string OrgNotes,
                int OrgTypeId,
                string TaxIdNumber,
                string SBE,
                string DVBE,
                string CertificationNumber,
                int OrgAddressId)
        {
            int result = SqlHelper.ExecuteNonQuery(
                connectionString,
                "ContactOrganizationUpdate",
                OrgId,
                Organization,
                Dept,
                Street,
                City,
                State,
                Zip,
                Phone,
                Fax,
                OrgNotes,
                //ContactZipPlus ,
                OrgTypeId,
                TaxIdNumber,
                SBE,
                DVBE,
                CertificationNumber,
                OrgAddressId);
            return result;

        }

        public static int InsertOrganizationAddress(
                int OrgId,
                string Dept,
                string Street,
                string City,
                string State,
                string Zip,
                string Phone,
                string Fax,
                string OrgNotes)
        {
            int result = SqlHelper.ExecuteNonQuery(
                connectionString,
                "InsertOrgAddress",
                OrgId,
                Dept,
                Street,
                City,
                State,
                Zip,
                Phone,
                Fax,
                OrgNotes);
            return result;

        }

		public static DataSet OrganizationList(int includeInactive)
		{
			return SqlHelper.ExecuteDataset(connectionString, "ContactOrganizationList", includeInactive);
		}

        public static DataSet GetOrganization()
        {
            //string sql = "SELECT org.OrgID, 'Link' as Button, Organization, ContactDept, ContactAddress, ContactCity, 0 as DirtyFlag from Organization org INNER JOIN Contact c ON org.OrgID = c.OrgID";
            string sql = "SELECT distinct org.OrgID, 'Link' as Button, Organization, '' as DepartmentOffice, '' as Address, '' as City, OrganizationTypeId, 0 as OrgAddressID ,0 as DirtyFlag from Organization org Order by Organization, City, Address";
            //string sql = "SELECT distinct org.OrgID, 'Link' as Button, Organization, DepartmentOffice, Address, City, OrganizationTypeId, oa.OrgAddressID ,0 as DirtyFlag, 0 as Grantee, 0 as Partner, 0 as Owner, 0 as Neighbour, 0 as Other from Organization org INNER JOIN OrgAddress oa ON org.OrgID = oa.OrgID Order by Organization, City, Address";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetOrganizationList()
        {
            //string sql = "SELECT org.OrgID, 'Link' as Button, Organization, ContactDept, ContactAddress, ContactCity, 0 as DirtyFlag from Organization org INNER JOIN Contact c ON org.OrgID = c.OrgID";
            string sql = "SELECT distinct OrgID, Organization from Organization Order by Organization";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetOrganizationByProject(int ProjectId)
        {
            string sql = "Select 'Remove Org' as Button, Organization, OrganizationType, op.OrgId, TaxID, SBE, DVBE, CertificationNumber " +
                " from Org_ProjectRole op INNER JOIN Organization org ON op.OrgId = org.OrgID LEFT OUTER JOIN OrganizationType ot ON org.OrganizationTypeId = ot.OrganizationTypeId " +
                " where op.ProjectId = " + ProjectId + 
                " group by  Organization, OrganizationType, op.OrgId, TaxID, SBE, DVBE, CertificationNumber" +
                " order by Organization";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContactByOrganization(int OrgId)
        {
            //string sql = "SELECT org.OrgID, 'Link' as Button, Organization, ContactDept, ContactAddress, ContactCity, 0 as DirtyFlag from Organization org INNER JOIN Contact c ON org.OrgID = c.OrgID";
            string sql = "Select 'Remove Contact' as Button, ContactLName + ',  ' + ContactFName as FullName, ContactJobTitle, oa.Address + ' ' + oa.City + ' ' + oa.State + ' ' + oa.Zip, ContactPhone, ContactExtension, ContactCellPhone, ContactFax, ContactEmail, c.ContactID from Contact c INNER JOIN Contact_Project cp ON c.ContactId = cp.ContactId INNER JOIN Org_ProjectRole op ON op.ProjectId = cp.ProjectId LEFT OUTER JOIN OrgAddress oa ON c.OrgAddressID = oa.OrgAddressID Where (c.OrgID = " + OrgId + " and cp.ProjectId = " + GlobalSettings.projectId + ") group by ContactFName, ContactLName, ContactJobTitle, ContactPhone, ContactExtension, ContactCellPhone, ContactFax, ContactEmail, c.ContactID, oa.Address,oa.City,oa.State,oa.Zip"; 
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContacts()
        {
            //string sql = "SELECT org.OrgID, 'Link' as Button, Organization, ContactDept, ContactAddress, ContactCity, 0 as DirtyFlag from Organization org INNER JOIN Contact c ON org.OrgID = c.OrgID";
            string sql = "Select 'Remove Contact' as Button, ContactLName + ', ' + ContactFName as FullName, ContactJobTitle, ContactPhone, ContactCellPhone, ContactFax, ContactEmail, Organization, ContactID from Contact LEFT OUTER JOIN Organization org ON Contact.OrgID = org.OrgID order by ContactLName";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetAddressByOrganization(int OrgId)
        {
            //string sql = "SELECT org.OrgID, 'Link' as Button, Organization, ContactDept, ContactAddress, ContactCity, 0 as DirtyFlag from Organization org INNER JOIN Contact c ON org.OrgID = c.OrgID";
            string sql = "Select 'Remove Org Address' as Button, DepartmentOffice, Address, City, State, Zip, GeneralPhone, GeneralFax, oa.OrgAddressID, 0 AS DirtyFlag from OrgAddress oa INNER JOIN Org_Project_Address opa ON oa.OrgAddressID = opa.OrgAddressId Where (opa.OrgID = " + OrgId + " and opa.ProjectId = " + GlobalSettings.projectId + ")";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }


        public static DataSet GetContactList(int OrgId)
        {
            //string sql = "SELECT org.OrgID, 'Link' as Button, Organization, ContactDept, ContactAddress, ContactCity, 0 as DirtyFlag from Organization org INNER JOIN Contact c ON org.OrgID = c.OrgID";
            //string sql = "SELECT ContactID, 'Link to Org' as Button, ContactLName + ' ' + ContactFName as FullName, ContactJobTitle, Contact.OrgID, OrganizationTypeId, 0 as DirtyFlag from Contact LEFT OUTER JOIN Organization org ON org.OrgID = Contact.OrgID where (Contact.OrgID is null) order by ContactLName";
            string sql = "SELECT Contact.ContactID, 'Link to Org' as Button, ContactLName + ', ' + ContactFName as FullName, ContactJobTitle, Organization, OrganizationTypeId, 0 as DirtyFlag from Contact INNER JOIN Organization org ON org.OrgID = Contact.OrgID where Contact.OrgID = " + OrgId + "order by ContactLName";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetOrganizationData(int OrgId)
        {
            //string sql = "SELECT Organization, DepartmentOffice, Address, City, State, Zip, GeneralPhone, GeneralFax, OrgNotes, OrganizationType, TaxID, SBE, DVBE, CertificationNumber from Organization org LEFT OUTER JOIN Org_Project_Address opa ON org.OrgID = opa.OrgId LEFT OUTER JOIN OrgAddress oa ON opa.OrgId = oa.OrgID LEFT OUTER JOIN  OrganizationType ot ON org.OrganizationTypeId = ot.OrganizationTypeId where org.OrgID = " + OrgId;
            string sql = "SELECT Organization, DepartmentOffice, Address, City, State, Zip, GeneralPhone, GeneralFax, OrgNotes, OrganizationType, TaxID, SBE, DVBE, CertificationNumber, isnull(oa.OrgAddressID,0) as OrgAddressID " +
                "from Organization org " +
                "LEFT OUTER JOIN Org_Project_Address opa ON org.OrgID = opa.OrgId and opa.ProjectId = " + GlobalSettings.projectId + " " +
                "LEFT OUTER JOIN OrgAddress oa ON opa.OrgAddressId = oa.OrgAddressID " +
                "LEFT OUTER JOIN  OrganizationType ot ON org.OrganizationTypeId = ot.OrganizationTypeId " +
                "where org.OrgID in (select OrgId from Org_ProjectRole where OrgId = " + OrgId + " and ProjectId = " + GlobalSettings.projectId + ") ";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetOrganizationAdminData(int OrgId)
        {
            //string sql = "SELECT Organization, DepartmentOffice, Address, City, State, Zip, GeneralPhone, GeneralFax, OrgNotes, OrganizationType, TaxID, SBE, DVBE, CertificationNumber, isnull(oa.OrgAddressID,0) as OrgAddressID " +
            //  "from Organization org LEFT OUTER JOIN Org_Project_Address opa ON org.OrgID = opa.OrgId LEFT OUTER JOIN OrgAddress oa ON opa.OrgAddressId = oa.OrgAddressID LEFT OUTER JOIN  OrganizationType ot ON org.OrganizationTypeId = ot.OrganizationTypeId where org.OrgID = " + OrgId;
            string sql = "SELECT Organization, DepartmentOffice, Address, City, State, Zip, GeneralPhone, GeneralFax, OrgNotes, OrganizationType, TaxID, SBE, DVBE, CertificationNumber, isnull(oa.OrgAddressID,0) as OrgAddressID " +
                "from Organization org " +
                "LEFT OUTER JOIN OrgAddress oa ON org.OrgID = oa.OrgID " +
                "LEFT OUTER JOIN  OrganizationType ot ON org.OrganizationTypeId = ot.OrganizationTypeId " +
                "where org.OrgID = " + OrgId; 
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetOrganizationAddress(int OrgAddressId)
        {
            string sql = "SELECT Organization, DepartmentOffice, Address, City, State, Zip, GeneralPhone, GeneralFax, OrgNotes, OrganizationType, TaxID, SBE, DVBE, CertificationNumber from Organization org LEFT OUTER JOIN OrgAddress oa ON org.OrgID = oa.OrgID LEFT OUTER JOIN  OrganizationType ot ON org.OrganizationTypeId = ot.OrganizationTypeId where oa.OrgAddressID = " + OrgAddressId;
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetOrganizationType()
        {
            //string sql = "SELECT org.OrgID, 'Link' as Button, Organization, ContactDept, ContactAddress, ContactCity, 0 as DirtyFlag from Organization org INNER JOIN Contact c ON org.OrgID = c.OrgID";
            string sql = "SELECT OrganizationType, OrganizationTypeId FROM OrganizationType";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContactPerson(int ContactId)
        {
            string sql = "SELECT Address, City, State, Zip, GeneralPhone " +
                    "FROM Contact left outer join OrgAddress on OrgAddress.OrgAddressId = Contact.OrgAddressId " +
                    "WHERE ContactId = " + ContactId.ToString();
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;

        }

        public static DataSet OrganizationContacts(int ProjectId, int OrgId)
        {
            string sql = "SELECT Contact.ContactID" +
                    ", Contact.ContactFName, Contact.ContactLName" +
                    ", Contact.ContactLName + ', ' + Contact.ContactFName as ContactName" +
                    ", Contact.OrgAddressId" +
                    ", OrgAddress.Address, OrgAddress.City, OrgAddress.State, OrgAddress.Zip" +
                    ", (case when OrgAddress.Address is null then '' else OrgAddress.Address + ' ' end)" +
                    "  + (case when OrgAddress.City is null then '' else OrgAddress.City + ' ' end)" +
                    "  + (case when OrgAddress.State is null then '' else OrgAddress.State + ' ' end)" +
                    "  + (case when OrgAddress.Zip is null then '' else OrgAddress.Zip + ' ' end) as FullAddress " +
                    ", IsNull(NullIf(Contact.ContactPhone,''), OrgAddress.GeneralPhone) AS GeneralPhone " +
                    ", IsNull(NullIf(Contact.ContactFax,''),OrgAddress.GeneralFax) AS Fax, Contact.ContactEmail AS Email " +
                    "FROM Contact_Project " +
                    "left join Contact on Contact_Project.ContactId = Contact.ContactId " +
                    "left outer join OrgAddress on OrgAddress.OrgAddressId = Contact.OrgAddressId " +
                    "where Contact.OrgId = " + OrgId.ToString() + " " +
                    "and Contact_Project.ProjectId = " + ProjectId + " " +
                    "ORDER BY Contact.ContactFName, Contact.ContactLName";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet OrganizationContacts(int OrgId)
        {
            //                    ", OrgAddress.GeneralPhone " +
            string sql = "SELECT Contact.ContactID" +
                    ", Contact.ContactFName, Contact.ContactLName" +
                    ", Contact.ContactLName + ', ' + Contact.ContactFName as ContactName" +
                    ", Contact.OrgAddressId" +
                    ", OrgAddress.Address, OrgAddress.City, OrgAddress.State, OrgAddress.Zip" +
                    ", (case when OrgAddress.Address is null then '' else OrgAddress.Address + ' ' end)" +
                    "  + (case when OrgAddress.City is null then '' else OrgAddress.City + ' ' end)" +
                    "  + (case when OrgAddress.State is null then '' else OrgAddress.State + ' ' end)" +
                    "  + (case when OrgAddress.Zip is null then '' else OrgAddress.Zip + ' ' end) as FullAddress " +
                    ", IsNull(NullIf(Contact.ContactPhone,''), OrgAddress.GeneralPhone) AS GeneralPhone" +
                    ", IsNull(NullIf(Contact.ContactFax,''),OrgAddress.GeneralFax) AS Fax, Contact.ContactEmail AS Email " +
                    "FROM Contact left outer join OrgAddress on OrgAddress.OrgAddressId = Contact.OrgAddressId " +
                    "where Contact.OrgId = " + OrgId.ToString() + " " +
                    "ORDER BY Contact.ContactFName, Contact.ContactLName";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }
        
        public static void OrgContactUnlink(int ContactId)
        {
            string sql = "UPDATE Contact SET OrgID = NULL where ContactID = " + ContactId;
            try
            {
                SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public static void OrgContactDelete(int ContactId)
        {
            string sql = "delete Contact where ContactID = " + ContactId;
            try
            {
                SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public static DataSet OrganizationAddresses(int ProjectId, int OrgId)
        {
            string sql = "SELECT OrgAddress.OrgAddressID" +
                   ", Address, City, State, Zip" +
                   ", (case when Address is null then '' else Address + ', ' end)" +
                   "  + (case when City is null then '' else City + ', ' end)" +
                   "  + (case when State is null then '' else State + '  ' end)" +
                   "  + (case when Zip is null then '' else Zip + ' ' end) as FullAddress " +
                   "FROM Org_Project_Address " +
                   "left join OrgAddress on Org_Project_Address.OrgAddressId = OrgAddress.OrgAddressId " +
                   "where OrgAddress.OrgId = " + OrgId.ToString() + " " +
                   "and Org_Project_Address.ProjectId = " + ProjectId + " " +
                   "ORDER BY Address, City, State, Zip";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet ProjectOrganizations(int ProjectId)
        {
            string sql = "SELECT distinct Organization.OrgID" +
                    ", Organization.Organization " +
                    ", TaxID, isnull(SBE, 0) as SBE, isnull(DVBE, 0) as DVBE, CertificationNumber " +
                    "FROM Organization " +
                    "join Org_ProjectRole on Org_ProjectRole.OrgId = Organization.OrgId " +
                    "where ProjectId = " + ProjectId.ToString() + " " +
                    "ORDER BY Organization.Organization";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static void OrganizationDelete(int OrgId)
        {
            string sql = "delete from Organization where OrgID = " + OrgId;
            try
            {
                SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

       	public static DataSet OrganizationSelectionList()
		{
			string sql = "SELECT * FROM vwOrgSelectionList";
			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}
		public static DataSet OrganizationListManage()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ContactOrganizationList", 1);
		}

		public static void ContactOrganizationInsert(string organizationType)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ContactOrganizationTypeInsert", organizationType);
		}
		public static void ContactOrganizationUpdate(string organizationType, bool isValid, int organizationTypeId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ContactOrganizationTypeUpdate", organizationType, isValid, organizationTypeId);
		}
		public static DataSet ContactList()
		{
			DataSet cds = new DataSet();
			SqlHelper.FillDataset(connectionString, CommandType.StoredProcedure, "ContactList", cds, new string[]{"ContactList"});
			return cds;
		}

		public static DataSet ContactsByProject(int projectId)
		{
            DataSet cds = new DataSet();
            SqlHelper.FillDataset(connectionString, "ContactByProject", cds, new string[]{"ProjectContacts", "ContactTypes"}, projectId);
            return cds;
		}

		public static DataSet ContactTypeList(int isActive)
		{
			return SqlHelper.ExecuteDataset(connectionString, "ContactTypeList", isActive);
		}

		public static DataSet ContactTypeListManage()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ContactTypeList", 1);
		}

		public static void ContactTypeUpdate(string contactType, bool isActive, int contactTypeId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ContactTypeUpdate", contactType, isActive, contactTypeId);
		}
		public static void ContactTypeInsert(string contactType)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ContactTypeInsert", contactType);
		}
		public static int ContactAssociate(int projectId, int contactId)
		{
			return SqlHelper.ExecuteNonQuery(connectionString, "ContactAssociate", projectId, contactId);
		}
		public static void ContactAssociateUpdate(int projectId, int contactId, int contactTypeId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ContactAssociateUpdate", projectId, contactId, contactTypeId);
		}

		public static void ContactRemove(int projectId, int contactId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ContactRemove", contactId, projectId);
			ContactTypeDelete(projectId, contactId);
		}

        public static void OrgContactRemove(int projectId, int recordId)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "OrgContactRemove", recordId, projectId);
        }

		public static ContactDataSet GetProjectContactForEdit(int contactId, int projectId)
		{
			ContactDataSet cds = new ContactDataSet();
			SqlHelper.FillDataset(connectionString, "ContactGetForEditByProject", cds, new string[]{"ContactList", "ContactType"}, contactId, projectId);
			DataColumn col1 = cds.Tables["ContactList"].Columns["ContactId"];
			DataColumn col2 = cds.Tables["ContactType"].Columns["ContactId"];
			cds.Relations.Add("ContactsToContactTypes", col1, col2, false);
			return cds;
		}
		public static ContactDataSet GetContactForEdit(int contactId)
		{
			ContactDataSet cds = new ContactDataSet();
			SqlHelper.FillDataset(connectionString, "ContactGetForEdit", cds, new string[]{"ContactList"}, contactId);
			return cds;
		}
		
		public static DataSet ContactCanDelete(int contactId)
		{
			return SqlHelper.ExecuteDataset(connectionString, "ContactCanDelete", contactId);
		}
		public static void ContactDelete(int contactId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ContactDelete", contactId);
		}

		public static bool IsContactPreexisting(string lastName, int orgid)
		{
			return (bool)SqlHelper.ExecuteScalar(connectionString, "ContactIsPreexisting", lastName, orgid);
		}
		public static void Contact_ContactTypeInsert(int projectId, int contactId, int contactTypeId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "Contact_ContactTypeInsert", projectId, contactId, contactTypeId);
		}
		public static bool ContactIsAssociated(int contactId, int projectId)
		{
			return (bool)SqlHelper.ExecuteScalar(connectionString, "ContactIsAssociated", contactId, projectId);
		}
		public static void ContactTypeDelete(int projectId, int contactId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ContactTypeDelete", projectId, contactId);
		}
		public static DataSet GetProjectPartners(int projectId)
		{
			return SqlHelper.ExecuteDataset(connectionString, "ContactProjectParter", projectId);
		}
	}
}
