﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using System.Data;
using Microsoft.ApplicationBlocks.Data;
using System.Configuration;

namespace CCPM.Data
{
    public class ContractData
    {
		static string userid = GlobalSettings.userid;

        private static string connectionString
        {
            get { return GlobalSettings.ConnectionString; }
        }

		static ContractData()
		{
			//DbConnection dbConnection = DbConnection.GetDbConnection();
			//connectionString = dbConnection.DbConnectionString;
		}

        public static string SendEmailAlerts(object AsOfDate, string Alert)
        {
            string sql = "exec SendEmailAlerts @AsOfDate = " + GlobalCode.SqlString(AsOfDate) +
                ", @Alert = '" + Alert + "'";            
            object result = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);
            if (result == DBNull.Value)
                result = "";
            return result.ToString();
        }


        public static string GetValue(string sql)
        {
            object result = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);
            if (result == DBNull.Value)
                result = "";
            return result.ToString();
        }

        public static int GetNextContractNumber()
        {
            int contractNumber = 0;
            object result = SqlHelper.ExecuteScalar(connectionString, "GetNextContractNumber");
            
            if (result == DBNull.Value)
                contractNumber = 001;                    
            else
                contractNumber = (int)result;

            return contractNumber;
        }

        public static bool IsContractNumber(string ContractNumber)
        {
            object retVal = false;
            string sql = "select 1 from ContractDetails where ContractNumber = '" + ContractNumber + "'";
            try
            {
                retVal = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            if (retVal == null)
                return false;
            else
                return true;

        }

        public static bool IsContractNumberDuplicate(string ContractNumber, int ContractId)
        {
            object retVal = false;
            string sql = "select 1 from ContractDetails where ContractNumber = '" + ContractNumber + "' and ContractId <> " + ContractId;
            try
            {
                retVal = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            if (retVal == null)
                return false;
            else
                return true;

        }

        public static DataSet GetContractDetail(int ContractId)
        {
            // Format SQL string
            string sql = "SELECT cd.ContractNumber, cd.GranteeId, o.Organization, cd.OrgAddressId" +
                ", oa1.Address, oa1.City, oa1.State, oa1.Zip, IsNull(NullIf(co.ContactPhone,''), oa1.GeneralPhone) AS GeneralPhone" + 
                ", IsNull(NullIf(co.ContactFax,''),oa1.GeneralFax) AS Fax, co.ContactEmail AS Email" +
                ", StatusCode, TypeCode" +
                ", dbo.usfContractTotals(cd.ContractId , 'C') AS ContractedAmount" +
                ", FileNumber, o.TaxId, ContractId" +
                ", ExecutedDate, CompletedDate, TerminationDate, ClosedDate" +
                ", isnull(o.SBE,0) as SBE, isnull(o.DVBE,0) as DVBE, o.CertificationNumber" +
                ", IsRepaymentRequired, IsMonitoringRequired" +
                ", dbo.usfProjectRegionManagerNames(cd.projectId) AS RName" +
                ", p.ProjectId, cd.ContactPersonId " +
                ", co.ContactFName + ' ' + co.ContactLName AS ContactName " +
                ", ps1.[Name] AS PName, cd.Purpose " +
                ", dbo.usfContractTotals(cd.ContractId , 'IB') AS Balance" +
                ", dbo.usfContractTotals(cd.ContractId , 'D') AS Disencumbered" +
                ", dbo.usfContractTotals(cd.ContractId , 'IP') AS PaidToDate" +
                ", dbo.usfContractTotals(cd.ContractId , 'IW') AS WithheldToDate" +
                //", isnull((select sum(NetPaymentAmount) from Invoice inv INNER JOIN ContractDetails c ON c.ContractId = inv.ContractId where c.ContractID = '" + ContractId.ToString() + "'),0) AS PaidToDate" +
                //", isnull((select sum(WithholdingAmount) from Invoice inv INNER JOIN ContractDetails c ON c.ContractId = inv.ContractId where c.ContractID = '" + ContractId.ToString() + "'),0) AS WithheldToDate" +
                ", isnull(AreContractsConditionMet, 0) as AreContractsConditionMet, BoxNumber, ClosingRemarks" +
                ", isnull(cd.isFlagged, 0) as isFlagged, cd.FlagNote" +
                ", ProjectName  " +
                ", cd.ContractStatusId, cd.ProjectManagerId, cd.ContractTypeId " +
                ", replace(dbo.usfProjectAttorneyNames(cd.ProjectId), char(10), ', ') as ProjectAttorneyNames, p.CurrentPM " +
                "FROM ContractDetails cd  " +
                "LEFT OUTER JOIN OrgAddress oa1 on oa1.OrgAddressId = cd.OrgAddressId " +
                "LEFT OUTER JOIN Contact co ON cd.ContactPersonId = co.ContactID " +
                "LEFT OUTER JOIN Organization o ON cd.GranteeId = o.OrgId " +
                "INNER JOIN Project p ON cd.ProjectId = p.ProjectId " +
                "INNER JOIN ContractStatus cs ON cd.ContractStatusId = cs.ContractStatusId " +
                "INNER JOIN ContractType ct ON cd.ContractTypeId = ct.ContractTypeId " +
                "LEFT OUTER JOIN ProjectStaff ps1 ON ps1.ProjectManagerId = cd.ProjectManagerId " +
                "WHERE cd.ContractId = '" + ContractId.ToString() + "'";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetProjectNumber(int ProjectId)
        {
            // Format SQL string
            string sql = "SELECT FileNumber, ProjectName FROM Project WHERE ProjectId = " + ProjectId;

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContractAmendment(int contractId)
        {
            // Format SQL string
            string sql = "SELECT AmendmentId, AmendmentNumber,  ReasonForAmendment, Amount, ExecutedDate, 0 AS DirtyFlag " +
                "FROM Amendments " +
                "WHERE ContractId = " + contractId +
                " order by AmendmentId";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContractList()
        {
            // Format SQL string
            string sql = "SELECT ContractId, ContractNumber FROM ContractDetails order by ContractNumber";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContractor()
        {
            // Format SQL string
            string sql = "SELECT ProjectManagerId AS ContactId, Name AS ContactFName FROM ProjectStaff ORDER BY Name ASC";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContactPerson()
        {
            // Format SQL string
            string sql = "SELECT ContactId, ContactFName + '   ' + ContactLName AS ContactFName FROM Contact where ContactFName is not null and datalength(ContactFName) > 0 ORDER BY ContactFName ASC";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }
        public static DataSet GetContractStatus()
        {
            // Format SQL string
            string sql = "SELECT * FROM ContractStatus";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }
        public static DataSet GetContractType()
        {
            // Format SQL string
            string sql = "SELECT * FROM ContractType where IsActive = 1";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContractFund(int ContractId)
        {
            // Format SQL string 
            string sql = @"SELECT
	                            ContractFundId,
	                            ContractFunds.FundId,
	                            ContractedAmount,
	                            dbo.usfContractFundTotals(ContractId , ContractFunds.FundId, 'B') as BalanceToDate,
	                            FundingSource.LiquidDate as LiquidationDate,
	                            DisencumberAmount,
	                            ContractId,
	                            0 AS DirtyFlag,
	                            (select top 1 1
	                             from Invoice
	                             where ContractId = ContractFunds.ContractId and 
		                               FundId = ContractFunds.FundId) as hasInvoice,
	                            dbo.usfContractFundTotals(ContractFunds.ContractID , ContractFunds.FundID, 'W') AS WithholdingToDate 
                            FROM
	                            ContractFunds left join 
	                            FundingSource on FundingSource.FundId = ContractFunds.FundId 
                            WHERE ContractId = " + ContractId;

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContractFunds(int ContractId)
        {
            // Format SQL string 
            string sql = "SELECT ContractFundId, ContractFunds.FundId ,  dbo.usfFundingItem2(FundingSource.FundID) as FundingItem " +
                         ", dbo.usfContractFundTotals(ContractId , ContractFunds.FundId, 'B') AS BalanceToDate" +
                         ", 0.00 AS DisencumberAmount, ContractFunds.FundId AS NewFundId " +
                         ", FundingSource.LiquidDate as LiquidationDate " +
                         ", ContractId, 0 AS DirtyFlag, ContractedAmount " +
                         "FROM ContractFunds " +
                         "left join FundingSource on FundingSource.FundId = ContractFunds.FundId " +
                         "WHERE ContractId = " + ContractId;

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContractFundOther(int ContractId, int FundId)
        {
            // Format SQL string
            string sql = "select null as FundId, '' as FundingItem " +
                "union " +
                "select FundId as FundId, dbo.usfFundingItem2(FundId) as FundingItem " +
                "from ContractFunds " +
                "where ContractId = " + ContractId +
                " and FundId <> " + FundId;

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContractFundAmount(int ContractId, int FundId)
        {
            // Format SQL string
            string sql = "SELECT SUM(ContractedAmount) FROM ContractFunds WHERE (ContractId = " + ContractId + " and FundId = " + FundId + ")";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetProjectFundingSource(int projectId)
        {
            // Format SQL string
            string sql = "SELECT FundingSource.FundID, dbo.usfFundingItem1(FundingSource.FundID) as FundingItem " +
                 ", (case when FundingSource.IsActive = 0 then 'InActive' else '' end) as IsActive " +			
                "FROM FundingSource " +
                "INNER JOIN vwProjectFundingSource pfs ON pfs.FundID = FundingSource.FundID " +
                "WHERE pfs.ProjectId = " + projectId.ToString() +
                " ORDER BY dbo.usfFundingItem2(FundingSource.FundID) ";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContractFundingSource(int contractId)
        {
            string sql = "SELECT FundingSource.FundID, dbo.usfFundingItem2(FundingSource.FundID) as FundingItem " +
                "FROM FundingSource " +
                "INNER JOIN ContractFunds cf ON cf.FundId = FundingSource.FundID " +
                "WHERE cf.ContractId = " + contractId.ToString() +
                " ORDER BY dbo.usfFundingItem2(FundingSource.FundID) ";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetFundsourceAmount(int FundId, int ProjectId)
        {
            // Format SQL string
            string sql = "SELECT SUM(Amount) FROM vwProjectFundingSource WHERE (FundID = " + FundId + " and ProjectId = " + ProjectId + ")";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static void RepaymentLogUpdate(int RepaymentId, object flag)
        {
            string sql = "update Repayments set isFlagged = " + GlobalCode.SqlBoolean(flag) + " where RepaymentId = " + RepaymentId.ToString();
            SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }

        public static DataSet GetTotalRepaidAmount(int ContractId)
        {
            string sql = "select dbo.usfContractRepaidTotal(" + ContractId.ToString() + ") as RepaidAmount";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetTotalReimbAmount(int ContractId)
        {
            string sql = "select dbo.usfContractTotals(" + ContractId + " , 'R') as RepaymentAmount";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetFundsourceLiquidDate(int FundId, int ProjectId)
        {
            // Format SQL string
            string sql = "SELECT LiquidDate FROM FundingSource fs INNER JOIN vwProjectFundingSource pfs ON fs.FundID = pfs.FundID where (fs.FundID = " + FundId + " and ProjectId = " + ProjectId + ")";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetAmendmentLog()
        {
            // Format SQL string
            string sql = "SELECT ContractNumber" +
                ", isnull(AmendmentNumber, '0') as AmendmentNumber" +
                ", TypeCode" +
                ", Organization" +
                ", ProjectName" +
                ", ContractStatus.StatusCode" +
                ", c.ProjectManagerId" +
                ", LegalDate" +
                ", ProofreaderDate" +
                ", GranteeDate" +
                ", ReturnedDate" +
                ", a.ExecutedDate as ExecutedDate" +
                ", DGSDateTo" +
                ", DGSDateFrom" +
                ", ControllerDate" +
                ", FinalDate" +
                ", RegisteredDate" +
                ", isnull(RemoveRow,0) as RemoveRow" +
                ", isnull(a.Flag,0) as Flag" +
                ", a.Notes" +
                ", a.AmendmentId" +
                ", c.ContractId" + 
                ", 0 AS DirtyFlag " +
                "FROM ContractDetails c " +
                "LEFT JOIN Project p ON c.ProjectId = p.ProjectId " +
                "LEFT JOIN Amendments a ON c.ContractId = a.ContractId " +
                "LEFT OUTER JOIN ContractType ct ON c.ContractTypeId = ct.ContractTypeId " +
                "LEFT OUTER JOIN Organization o ON c.GranteeId = o.OrgId " +
                "LEFT OUTER JOIN ContractStatus ON c.ContractStatusId = ContractStatus.ContractStatusId " +
                "WHERE 0 = (case /*when (a.ExecutedDate is not null and c.ContractStatusId = 2) then 1*/ " +
                "   when RemoveRow is null then 0 else RemoveRow end) " +
                "ORDER BY ContractNumber, AmendmentNumber";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetAllContractLog(int ProjectId)
        {
            // Format SQL string
            string sql = "SELECT ContractDetails.ContractNumber, Organization.Organization, ContractStatus.StatusCode" +
                ", dbo.usfContractTotals(ContractDetails.ContractId, 'C') as ContractedAmount" +
                ", dbo.usfContractTotals(ContractDetails.ContractId, 'IB') as ContractBalance" +
                ", ContractDetails.AreContractsConditionMet, ContractDetails.ExecutedDate, ContractDetails.CompletedDate, ContractDetails.TerminationDate" +
                //", dbo.usfContractExpirationAlert(ContractDetails.ContractId) as ExpirationAlert" +
                //", dbo.usfContractLiquidationAlert(ContractDetails.ContractId, null) as LiquidationAlert" +
                //if status is complete or close - blank these 2 fields
                ", (CASE WHEN ContractStatus.ContractStatusid in ('4','3') THEN null ELSE dbo.usfContractExpirationAlert(ContractDetails.ContractId) END ) as ExpirationAlert" +
                ", (CASE WHEN ContractStatus.ContractStatusid in ('4','3') THEN null ELSE dbo.usfContractLiquidationAlert(ContractDetails.ContractId, null) END ) as LiquidationAlert" +
                ", dbo.usfContractRepaymentAlert(ContractDetails.ContractId, null) as RepaymentAlert" +
                ", ContractDetails.IsMonitoringRequired" +
                ", dbo.usfContractMonitoringAlert(ContractDetails.ContractId, null) as MonitoringAlert" +
                //Monitoring OutcomeCode, last value entered
                ", (select top 1 MonitorOutcome.OutcomeCode" +
                "       from ContractMonitor cm " +
                "       join ContractMonitorDetail cmd ON cm.MonitorId = cmd.MonitorId" +
                "       join MonitorOutcome ON cmd.OutcomeId = MonitorOutcome.OutcomeId" +
                "       where cmd.OutcomeId is not null and cmd.MonitoredDate is not null and cm.ContractId = ContractDetails.ContractId" +
                "       order by cmd.MonitoredDate DESC)" +
                "       as OutcomeCode " +
                ", ContractType.TypeCode, ContractDetails.ContractId, 0 AS DirtyFlag " +
                "FROM ContractDetails " +
                "LEFT OUTER JOIN ContractType ON ContractDetails.ContractTypeId = ContractType.ContractTypeId " +
                "LEFT OUTER JOIN ContractStatus ON ContractDetails.ContractStatusId = ContractStatus.ContractStatusId " +
                "LEFT OUTER JOIN Organization ON ContractDetails.GranteeId = Organization.OrgId " +
                "WHERE ContractDetails.ProjectId = " + ProjectId +
                "order by ContractDetails.ContractNumber";
             
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static string GetFundName(int fundId)
        {
            return (string)SqlHelper.ExecuteScalar(connectionString, "ContractGetFundName", fundId);
        }

        public static int ActiveContractUpdate(
              object ContractId
            , object ContractStatusId
            , object AreContractsConditionMet
            , object IsFlagged
            , object ProjectManagerId
            , object FlagNote
            )
        {
            string sql = "UPDATE ContractDetails "
                + "SET ContractStatusId = " + Convert.ToInt32(ContractStatusId)
                + ", AreContractsConditionMet = " + SqlBoolean(AreContractsConditionMet)
                + ", isFlagged = " + SqlBoolean(IsFlagged)
                + ", ProjectManagerId = " + Convert.ToInt32(ProjectManagerId)
                + ", FlagNote = " + SqlString(FlagNote)
                + " where ContractId = " + Convert.ToString(Convert.ToInt32(ContractId));
            return SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }

        public static int ProjectProjectManagerInsert(int ContractId)
        {
            string sql = "insert Project_ProjectManager (ProjectId, ProjectManagerId)" +
                " select ProjectId, ProjectManagerId from ContractDetails where ContractId = " + ContractId.ToString() +
                "   and ProjectManagerId not in (select ProjectManagerId from Project_ProjectManager where ProjectId = ContractDetails.ProjectId)";
            return SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }

        public static DataSet GetActiveContract()
        {
            //string sql = "SELECT ContractDetails.ContractNumber"
            //    + ", isnull(Amendments.AmendmentNumber, '0') as AmendmentNumber"
            //    + ", Organization.Organization"
            //    + ", ContractType.TypeCode"
            //    + ", dbo.usfContractTotals(ContractDetails.ContractId , 'C') AS ContractedAmount" 
            //    + ", dbo.usfContractTotals(ContractDetails.ContractId , 'IB') AS Balance"
            //    + ", ContractDetails.ExecutedDate"
            //    + ", ContractDetails.CompletedDate"
            //    + ", ContractDetails.TerminationDate"
            //    + ", Amendments.RegisteredDate"
            //    + ", dbo.usfContractExpirationAlert(ContractDetails.ContractId) as ExpirationAlert"
            //    + ", dbo.usfContractLiquidationAlert(ContractDetails.ContractId, null) as LiquidationAlert"
            //    + ", dbo.usfContractRepaymentAlert(ContractDetails.ContractId, null) as RepaymentAlert" 
            //    + ", ContractDetails.ContractStatusId"
            //    + ", isnull(ContractDetails.AreContractsConditionMet,0) as AreContractsConditionMet"
            //    + ", isnull(ContractDetails.isFlagged, 0) as isFlagged"
            //    + ", Project.ProjectName"
            //    + ", ProjectStaff.[Name]"
            //    + ", dbo.usfProjectRegionNames(ContractDetails.ProjectId) as Region"
            //    + ", ContractDetails.FlagNote"
            //    + ", 0 AS DirtyFlag"
            //    + ", ContractDetails.ContractId "
            //    + "FROM ContractDetails "
            //    + "LEFT OUTER JOIN Amendments ON ContractDetails.ContractId = Amendments.ContractId "
            //    + "    and Amendments.AmendmentId = (select Max(AmendmentId) from Amendments re WHERE re.ContractId = ContractDetails.ContractId) "
            //    + "LEFT OUTER JOIN ContractType ON ContractDetails.ContractTypeId = ContractType.ContractTypeId "
            //    + "LEFT OUTER JOIN Project ON ContractDetails.ProjectId = Project.ProjectId "
            //    + "LEFT OUTER JOIN Organization ON ContractDetails.GranteeId = Organization.OrgId "
            //    + "LEFT OUTER JOIN ProjectStaff ON ContractDetails.ProjectManagerId = ProjectStaff.ProjectManagerId "
            //    + "WHERE (ContractDetails.ContractStatusId = 2) " 
            //    + "ORDER BY ContractDetails.ContractNumber ";
           
            string sql = "SELECT ContractDetails.ContractNumber"
                + ", isnull(Amendments.AmendmentNumber, '0') as AmendmentNumber"
                + ", Organization.Organization"
                + ", ContractType.TypeCode"
                + ", dbo.usfContractTotals(ContractDetails.ContractId , 'C') AS ContractedAmount" 
                + ", dbo.usfContractTotals(ContractDetails.ContractId , 'IB') AS Balance"
                + ", ContractDetails.ExecutedDate"
                + ", ContractDetails.CompletedDate"
                + ", ContractDetails.TerminationDate"
                + ", Amendments.RegisteredDate"
                + ", dbo.usfContractExpirationAlert(ContractDetails.ContractId) as ExpirationAlert"
                + ", dbo.usfContractLiquidationAlert(ContractDetails.ContractId, null) as LiquidationAlert"
                + ", dbo.usfContractRepaymentAlert(ContractDetails.ContractId, null) as RepaymentAlert" 
                + ", ContractDetails.ContractStatusId"
                + ", isnull(ContractDetails.AreContractsConditionMet,0) as AreContractsConditionMet"
                + ", isnull(ContractDetails.isFlagged, 0) as isFlagged"
                + ", Project.ProjectName"
                + ", ProjectStaff.[Name]"
                + ", dbo.usfProjectRegionNames(ContractDetails.ProjectId) as Region"
                + ", ContractDetails.FlagNote"
                + ", 0 AS DirtyFlag"
                + ", ContractDetails.ContractId "
                + "FROM ContractDetails "
                + "LEFT OUTER JOIN Amendments ON ContractDetails.ContractId = Amendments.ContractId "
                + "    and Amendments.AmendmentId = (select Max(AmendmentId) from Amendments re WHERE re.ContractId = ContractDetails.ContractId) "
                + "LEFT OUTER JOIN ContractType ON ContractDetails.ContractTypeId = ContractType.ContractTypeId "
                + "LEFT OUTER JOIN Project ON ContractDetails.ProjectId = Project.ProjectId "
                + "LEFT OUTER JOIN Organization ON ContractDetails.GranteeId = Organization.OrgId "
                + "LEFT OUTER JOIN ProjectStaff ON ContractDetails.ProjectManagerId = ProjectStaff.ProjectManagerId "
                + "WHERE (ContractDetails.ContractStatusId = 2) " 
                + "AND ( " 
                + "      ( (dbo.usfContractLiquidationAlert(ContractDetails.ContractId, null) LIKE 'Past Liquid Date!' ) "
                + "         AND (dbo.usfContractTotals(ContractDetails.ContractId , 'IB') > 0 ) "
                + "       ) "
                + "       OR (dbo.usfContractLiquidationAlert(ContractDetails.ContractId, null) not LIKE '%Past Liquid Date!%' ) "
                + "       OR (dbo.usfContractLiquidationAlert(ContractDetails.ContractId, null) is null) "
                + "  ) "
                + "ORDER BY ContractDetails.ContractNumber ";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex) 
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContractInvoice(int ContractID, int FundingSource)
        {
            // Format SQL string
            string sql = "SELECT ContractNumber, Organization" +
                ", dbo.usfFundingItem1(cf.FundId) as FundingItem" +
                ", convert(varchar(10),ExecutedDate,101) as ExecutedDate" +
                ", convert(varchar(10),CompletedDate,101) as CompletedDate" +
                ", convert(varchar(10),TerminationDate,101) as TerminationDate" +
                ", ps.Name AS PName, ps1.Name AS RName" +
                ", cf.ContractedAmount, AreContractsConditionMet, ProjectName " +
                ", dbo.usfContractFundTotals(cf.ContractId , cf.FundId, 'B') as Balance " +
                ", dbo.usfContractFundTotals(cf.ContractId , cf.FundId, 'P') as PaidToDate " +
                ", dbo.usfContractFundTotals(cf.ContractId , cf.FundId, 'W') as WithholdingToDate " +
                ", cd.ProjectId " +
                ", cf.InitialAmount " +
                ", convert(varchar(10), FundingSource.LiquidDate, 101) as LiquidationDate " +
                "FROM ContractDetails cd " +
                "LEFT OUTER JOIN ContractFunds cf ON cd.ContractId = cf.ContractId " +
                "LEFT OUTER JOIN FundingSource on FundingSource.FundId = cf.FundId " +
                "LEFT OUTER JOIN  vwFundingSourceSelectionList ON cf.FundId = vwFundingSourceSelectionList.FundID " +
                "LEFT OUTER JOIN Organization ON GranteeId = OrgID " +
                "LEFt OUTER JOIN Project ON cd.ProjectId = Project.ProjectId " +
                "LEFT OUTER JOIN ProjectStaff ps ON cd.ProjectManagerId = ps.ProjectManagerId " +
                "LEFT OUTER JOIN Project_ProjectRegion ppr ON cd.ProjectId = ppr.ProjectId " +
                "LEFT OUTER JOIN ProjectRegion pr ON ppr.ProjectRegionId = pr.RegionId " +
                "LEFT OUTER JOIN ProjectStaff ps1 ON ps1.ProjectManagerId = pr.RegionalManagerId " +
                "WHERE (cd.ContractId = " + ContractID + " and cf.FundId = " + FundingSource + ")";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetInvoiceDrawDownSheet(int ContractID, int FundingSource)
        {
            // Format SQL string
            string sql = "SELECT InvoiceId, ReceivedDate, InvoiceNumber, Invoicedate, BillingPeriodStart, IsFinal, GrossInvoiceAmount" +
                ", GrossAmountApproved, NetPaymentAmount, convert(money, 0) AS AccumulatedPayment, WithholdingPercent" +
                ", WithholdingAmount, convert(money, 0) AS WithholdingTotal" +
                ", DisencumberAugment " +
                ", Balance, IsDisputed, Reason, ClaimScheduleNumber, ClaimScheduleDate" +
                ", ToProjectManagerDate, ToAccountingDate, FromAccountingDate, DisputeDateFromPM" +
                ", DisputeDateMailedOut, 0 AS DirtyFlag" +
                ", (select ContractStatusId from ContractDetails where ContractId = Invoice.ContractId) as ContractStatusId " +
                " FROM Invoice WHERE (ContractId = " + ContractID + " and FundId = " + FundingSource + ") " +
                " ORDER by ReceivedDate";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetInvoiceLog()
        {
            // Format SQL string
            string sql = "SELECT InvoiceId, cd.ContractNumber, cd.GranteeId, ReceivedDate, i.InvoiceNumber, InvoiceDate, " +
                "BillingPeriodStart, IsFinal, GrossInvoiceAmount, GrossAmountApproved, NetPaymentAmount, IsDisputed,  (select statuscode from contractstatus where ContractStatusId = cd.ContractStatusId) AS Status , Reason, " +
                "ClaimScheduleNumber, ClaimScheduleDate, ToProjectManagerDate, ToAccountingDate, DisputeDateFromPM, " +
                "DisputeDateMailedOut, 0 AS DirtyFlag, i.FundId, i.ContractId, " +
                "cd.ProjectManagerId, FromAccountingDate, i.Balance, i.WithholdingPercent, i.WithholdingAmount, " +
                "i.DisencumberAugment " +
                "FROM Invoice i " +
                "INNER JOIN ContractDetails cd ON i.ContractId = cd.ContractId " +
                "LEFT OUTER JOIN Project p ON cd.ProjectId = p.ProjectId " +
                "WHERE i.DisencumberAugment is null OR i.DisencumberAugment = 0 " +
                "ORDER BY ReceivedDate DESC, cd.ContractNumber";
            //2.5: took status restriction out to display other invoices. 
            // this will allow to take actions on invoices that are not assigned to funding source
            // "WHERE cd.ContractStatusId = 2 " +
            //2.33 those that only have an augmenation or disencumberment, should not appear in the log
            // added "WHERE i.DisencumberAugment is null OR i.DisencumberAugment = 0 " +
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }


        public static DataSet GetRepaymentGrid(int ContractId)
        {
            // Format SQL string
            string sql = "exec RepaymentSelect @ContractId = " + ContractId.ToString();
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetRepaymentLog()
        {
            // Format SQL string
            //TODO :  what is Flag used for ?
            string sql = "exec RepaymentLogSelect";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static int CompleteContractUpdate(
              object ContractId
            , object ContractStatusId
            , object ProjectManagerId
            , object IsFlagged
            , object FlagNote
            )
        {
            string sql = "UPDATE ContractDetails "
                + "SET ContractStatusId = " + Convert.ToInt32(ContractStatusId)
                + ", ProjectManagerId = " + Convert.ToInt32(ProjectManagerId)
                + ", isFlagged = " + SqlBoolean(IsFlagged)
                + ", FlagNote = " + SqlString(FlagNote)
                + " where ContractId = " + Convert.ToString(Convert.ToInt32(ContractId));
            return SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }

        public static DataSet GetCompleteContractLog()
        {
            // Format SQL string
            string sql = "SELECT ContractDetails.ContractId"
                        + ", ContractDetails.ContractNumber"
                        + ", Organization.Organization"
                        + ", Project.ProjectName"
                        + ", ContractDetails.TerminationDate"
                        + ", dbo.usfContractMonitoringAlert(ContractDetails.ContractId, null) as MonitoringAlert "
                        + ", dbo.usfInvoiceClaimDate(ContractDetails.ContractId)  AS ClaimDate"
                        + ", ContractStatus.StatusCode"
                        + ", dbo.usfProjectTypeName(ContractDetails.ProjectId) as ProjectType"
                        + ", dbo.usfProjectRegionNames(ContractDetails.ProjectId) as Region"
                        + ", dbo.usfProjectCountyNames(ContractDetails.ProjectId) as CountyName"
                        + ", ContractDetails.ProjectManagerId"
                        + ", isnull(ContractDetails.isFlagged, 0) as isFlagged"
                        + ", ContractDetails.FlagNote"
                        + ", 0 AS DirtyFlag "
                        + "FROM ContractDetails "
                        + "LEFT OUTER JOIN Organization ON ContractDetails.GranteeId = Organization.OrgID "
                        + "LEFT OUTER JOIN Project ON ContractDetails.ProjectId = Project.ProjectId "
                        + "LEFT OUTER JOIN ContractStatus ON ContractDetails.ContractStatusId = ContractStatus.ContractStatusId "
                        + "WHERE ContractDetails.ContractStatusId = 3 "
                        + "ORDER BY ContractDetails.TerminationDate ASC, ContractDetails.ContractNumber";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetClosedContractLog()
        {
            string sql = "SELECT ContractNumber, Organization, ProjectName, ClosedDate, BoxNumber, ClosingRemarks, " +
                        "o.TaxId, ExecutedDate, " +
                        "TerminationDate, FileNumber, Purpose, " +
                         "dbo.usfContractTotals(cd.ContractId, 'C') AS ContractedAmount, " +
                        "isnull((select max(RepaidToDate) from Repayments where cd.ContractId = Repayments.ContractId), 0) AS RepaidToDate, " +
                        "dbo.usfInvoiceClaimDate(cd.ContractId) as DateLastClaimSchedule, " +
                        "dbo.usfProjectRegionNames(cd.ProjectId) as Region, " +
                        "dbo.usfProjectCountyNames(cd.ProjectId) as County, " +
                        "[Name] AS PName, " +
                        "cd.ContractId, " +
                        "0 AS DirtyFlag " +
                        "FROM ContractDetails cd " +
                        "LEFT OUTER JOIN ContractStatus cs ON cd.ContractStatusId = cs.ContractStatusId " +
                        "LEFT OUTER JOIN Organization o ON cd.GranteeId = o.OrgID " +
                        "LEFT OUTER JOIN Project p ON cd.ProjectId = p.ProjectId " +
                        "LEFT OUTER JOIN ProjectStaff ps ON cd.ProjectManagerId=ps.ProjectManagerId " +
                        "WHERE StatusCode = 'Closed' " +
                        "ORDER BY ContractNumber";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetContractByFundSourceLog()
        {
            // Format SQL string
            string sql = "SELECT cd.ContractId, dbo.usfFundingItem2(cf.FundId) as FundingItem, fs.Source, FiscalYear.Years, cd.ContractNumber, p.ProjectName" +
                         ", fs.LiquidDate as LiquidationDate" +
                         ", dbo.usfContractLiquidationAlert(cf.ContractId, cf.FundId) as LiquidationAlert" + 
                         ", cd.CompletedDate, cd.TerminationDate" +
                         ", cf.ContractedAmount" +
                         ", cf.BalanceToDate" +
                         ", dbo.usfProjectRegionNames(cd.ProjectId) as Region" +
                         ", o.Organization, ps.[Name], 0 AS DirtyFlag, cd.ProjectId, cf.FundId " +
                         "FROM ContractDetails cd " +
                         "INNER JOIN ContractFunds cf ON cd.ContractId = cf.ContractId " +
                         "INNER JOIN FundingSource fs ON cf.FundId = fs.FundID " +
                         "INNER JOIN FiscalYear ON fs.FiscalYearID = FiscalYear.FiscalYearID " + 
                         "LEFT OUTER JOIN ContractStatus cs ON cd.ContractStatusId = cs.ContractStatusId " +
                         "LEFT OUTER JOIN Organization o ON cd.GranteeId = o.OrgID " +
                         "LEFT OUTER JOIN Project p ON cd.ProjectId = p.ProjectId " +
                         "LEFT OUTER JOIN ProjectStaff ps ON cd.ProjectManagerId=ps.ProjectManagerId " +
                         "WHERE (StatusCode = 'Draft' or StatusCode = 'Active') " +
                         "ORDER BY fs.OrgCode, fs.RefCode, fs.FundNumber, fs.ScheduleNum, fs.SubScheduleNum, fs.ReimbCode";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetMonitoringSummary(int ContractId)
        {
            // Format SQL string
            string sql = "SELECT ContractNumber, Organization, GeneralPhone, Region, c.[Name]" +
                         ", ProjectType, CompletedDate, TerminationDate, cd.ProjectId, OrgAddress.Address " +
                         "FROM ContractDetails cd LEFT OUTER JOIN Organization o ON cd.GranteeId = o.OrgID " +
                         "LEFT OUTER JOIN Project p ON cd.ProjectId = p.ProjectId " +
                         "LEFT OUTER JOIN Contact c ON cd.ContactPersonId = c.ContactId " +
                         "LEFT OUTER JOIN OrgAddress on OrgAddress.OrgAddressId = c.OrgAddressId " +
                         "LEFT OUTER JOIN Project_ProjectType ppt ON p.ProjectId = ppt.ProjectId " +
                         "LEFT OUTER JOIN ProjectType pt ON ppt.ProjectTypeId = pt.ProjectTypeId " +
                         "LEFT OUTER JOIN Project_ProjectRegion ppr ON p.ProjectId = ppr.ProjectId " +
                         "LEFT OUTER JOIN ProjectRegion pr ON ppr.ProjectRegionId = pr.RegionId " +
                         "LEFT OUTER JOIN Project_ProjectManager ppm ON cd.ProjectId = ppm.ProjectId " +
                         "LEFT OUTER JOIN ProjectStaff ps ON ppm.ProjectManagerId=ps.ProjectManagerId WHERE cd.ContractId = " + ContractId;

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static string GetContractMonitorNote(int MonitorId)
        {
            object retVal = null;
            string sql = "SELECT MonitorNote "
                + "FROM ContractMonitorNote "
                + "WHERE MonitorId = " + MonitorId;

            try
            {
                retVal = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            if (retVal == null)
                retVal = "";
            return retVal.ToString();
        }

        public static DataSet GetContractMonitoringDetail(int MonitorId)
        {
            // Format SQL string
            string sql = "SELECT ContractMonitorDetail.MonitorDetailId " +
                ",	ContractMonitorDetail.MonitorId " +
                ",	ContractMonitorDetail.ScheduledDate " +
                ", dbo.usfContractMonitoringAlert(null, ContractMonitorDetail.MonitorDetailId) as MonitoringAlert " +
                ",	ContractMonitorDetail.MonitoredDate " +
                ",	ProjectStaff.[Name] " +
                ",	MonitorOutcome.OutcomeCode " +
                ",	ContractMonitorDetail.IsDocumentLinked " +
                ",	ContractMonitorDetail.Remarks " +
                ",	0 AS DirtyFlag " +
                "FROM ContractMonitorDetail " +
                "LEFT OUTER JOIN MonitorOutcome ON ContractMonitorDetail.OutcomeId = MonitorOutcome.OutcomeId " +
                "LEFT OUTER JOIN ProjectStaff ON ContractMonitorDetail.VerifiedById = ProjectStaff.ProjectManagerId " +
                "WHERE ContractMonitorDetail.MonitorId = " + MonitorId +
                " ORDER BY ContractMonitorDetail.ScheduledDate";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }
        public static DataSet GetContractMonitor(int ContractId)
        {
            // Format SQL string
            string sql = "exec ContractMonitorSelect @ContractID = " + ContractId;
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }
        public static DataSet GetContractMonitoringLog()
        {
            // Format SQL string
            string sql = "exec ContractMonitorLogSelect";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetRepaymentSummary(int ContractId)
        {
            // Format SQL string
            string sql = "SELECT cd.ContractNumber, o.Organization, OrgAddress.GeneralPhone" +
                         ", dbo.usfProjectRegionNames(cd.ProjectId) as Region" +
                         ", ps.[Name], pt.ProjectType, cd.CompletedDate, cd.TerminationDate, cd.ProjectId" +
                         ", OrgAddress.Address" +
                         ", (select top 1 Terms from Repayments where cd.ContractId = ContractId order by RepaymentId) as Terms" +
                         ", crn.RepaymentNote" +
                         ", ProjectName, OrgAddress.City, OrgAddress.State, OrgAddress.Zip " +
                         "FROM ContractDetails cd " +
                         "LEFT OUTER JOIN ContractRepaymentNote crn ON cd.ContractId = crn.ContractId " +
                         "LEFT OUTER JOIN Organization o ON cd.GranteeId = o.OrgID " +
                         "LEFT OUTER JOIN Project p ON cd.ProjectId = p.ProjectId " +
                         "LEFT OUTER JOIN Contact c ON cd.ContactPersonId = c.ContactId " +
                         "LEFT OUTER JOIN OrgAddress on OrgAddress.OrgID = o.OrgID " +
                         "LEFT OUTER JOIN Project_ProjectType ppt ON p.ProjectId = ppt.ProjectId " +
                         "LEFT OUTER JOIN ProjectType pt ON ppt.ProjectTypeId = pt.ProjectTypeId " +
                         "LEFT OUTER JOIN ProjectStaff ps ON cd.ProjectManagerId=ps.ProjectManagerId " +
                         "WHERE cd.ContractId = " + ContractId;

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static string GetRepaymentNote(int ContractId)
        {
            object retVal = null;
            string sql = "SELECT RepaymentNote " +
                "FROM ContractRepaymentNote " +
                "WHERE ContractId = " + ContractId;
            try
            {
                retVal = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            if (retVal == null)
                retVal = "";
            return retVal.ToString();
        }

        public static string GetInvoiceNote(int ContractId, int FundId)
        {
            object retVal = null;
            string sql = "SELECT top 1 InvoiceNote " +
                "FROM ContractInvoiceNote " +
                "WHERE (ContractId = " + ContractId + " and FundId = " + FundId + ") " +
                "ORDER BY InvoiceNoteId ";
            try
            {
                retVal = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            if (retVal == null)
                retVal = "";
            return retVal.ToString();
        }

        public static DataSet GetMonitoringOutcome()
        {
            // Format SQL string
            string sql = "SELECT * FROM MonitorOutcome";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static void ContractMonitorAddDates(int MonitorId, DateTime dt, int years)
        {
            string sql = "";
            for (int i = 1; i <= years; i++)
            {
                sql += "insert ContractMonitorDetail (MonitorId, ScheduledDate, IsDocumentLinked) " +
                    "values (" + MonitorId.ToString() + ", '" + dt.AddYears(i -1).ToShortDateString() + "', 0); ";
            }
            SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }

        public static string ContractMonitorUpdate(
                          int MonitorId
                        , string MonitoringNote
                        , string MonitoringRequirement
                        , string MonitoringProcedure
                        , string MonitoringGauging
                        , string MonitoringDocumentation
                        , int UserId
                        )
        {
            // Update ContractMonitor record
            int retVal = 0;
            string msg = "success";
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "ContractMonitorUpdate"
                     , MonitorId
                     , MonitoringNote
                     , MonitoringRequirement
                     , MonitoringProcedure
                     , MonitoringGauging
                     , MonitoringDocumentation
                     , UserId
                     );
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the Contract Monitoring record.";
            }
            return msg;
        }

        public static int ContractMonitorDetailInsert(
            int MonitorId
            , object ScheduledDate
            , object MonitoredDate
            , int VerifiedById
            , int OutcomeId
            , string IsDocumentLinked
            , string Remarks
            )
        {
            // Insert MonitoringDetail record
            int retVal = 0;
            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, "ContractMonitorDetailInsert",
                     MonitorId
                     , ScheduledDate
                     , MonitoredDate
                     , VerifiedById
                     , OutcomeId
                     , IsDocumentLinked
                     , Remarks);

                retVal = int.Parse(id.ToString());
            }
            catch
            {
                //throw ex;
                retVal = -1;
            }
            return retVal;
        }

        public static string ContractMonitorDetailUpdate(
                          int MonitorDetialId
                        , int MonitorId
                        , object ScheduledDate
                        , object MonitoredDate
                        , int VerifiedById
                        , int OutcomeId
                        , string IsDocumentLinked
                        , string Remarks
                        )
        {
            // Update Monitoring Detail record

            int retVal = 0;
            string msg = "success";
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "ContractMonitorDetailUpdate"
                     , MonitorDetialId
                     , MonitorId
                     , ScheduledDate
                     , MonitoredDate
                     , VerifiedById
                     , OutcomeId
                     , IsDocumentLinked
                     , Remarks
                     );
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the Contract Monitoring Detail record.";
            }
            return msg;
        }

        public static string ContractMonitorDetailDelete(int MonitoringDetailId)
        {
            // Delete Monitoring Detail record
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "ContractMonitorDetailDelete", MonitoringDetailId);
            }
            catch
            {
                msg = "There was a problem deleting the Monitoring Schedule record.";
            }
            return msg;
        }

        public static DataSet GetProject(string fileNumber)
        {
            string sql = "SELECT ProjectId FROM Project WHERE FileNumber = '" + fileNumber.ToString() + "'";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        //todo:  fix ContractAddress, ContractPhone
        public static int ContractDetailInsert(
            string ContractNumber
            , int ProjectId
            , int GranteeId
            , object OrgAddressId
            , string TaxIdNumber
            , int ContactPersonId
            , int ContractStatusId
            , int ContractTypeId
            , decimal ContractedAmount
            , object ExecutionDate
            , object CompletionDate
            , object TerminationDate
            , object ClosedDate
            , string SBE
            , string DVBE
            , string CertificationNumber
            , string IsRepaymentRequired
            , string IsMonitoringRequired
            , int ProjectManagerId
            , string Purpose
            , string AreContractsConditionMet
            , string BoxNumber
            , string ClosingRemarks
            , string IsFlagged
            , string FlagNote
            )
        { 
            // Insert ContractDetail record
            int retVal = 0;
            //try
            //{
                object id = SqlHelper.ExecuteScalar(connectionString, "ContractDetailInsert"
                    , ContractNumber                   
                    , ProjectId
                    , GranteeId
                    , SqlNumber(OrgAddressId)
                    , TaxIdNumber
                    , ContactPersonId
                    , ContractStatusId
                    , ContractTypeId
                    , ContractedAmount
                    , SqlNull(ExecutionDate)
                    , SqlNull(CompletionDate)
                    , SqlNull(TerminationDate)
                    , SqlNull(ClosedDate)
                    , SBE
                    , DVBE
                    , CertificationNumber
                    , IsRepaymentRequired
                    , IsMonitoringRequired
                    , ProjectManagerId
                    , Purpose
                    , AreContractsConditionMet
                    , BoxNumber
                    , ClosingRemarks
                    , IsFlagged
                    , FlagNote
                    );

                retVal = int.Parse(id.ToString());
            //}
            //catch
            //{
            //    //throw ex;
            //    retVal = -1;
            //}
            return retVal;
        }

        public static string ContractDetailUpdate(
            int ContractId
            , string ContractNumber
            , int ProjectId
            , int GranteeId
            , object OrgAddressId
            , string TaxId
            , int ContactPersonId
            , int ContractStatusId
            , int ContractTypeId
            , decimal ContractedAmount
            , object ExecutionDate
            , object CompletionDate
            , object TerminationDate
            , object ClosedDate
            , string SBE
            , string DVBE
            , string CertificationNumber
            , string IsRepaymentRequired
            , string IsMonitoringRequired
            , int ProjectManagerId
            , string Purpose
            , string AreContractsConditionMet
            , string BoxNumber
            , string ClosingRemarks
            , string isFlagged
            , string FlagNote
            )
           {
            // Update ContractDetail record
            int retVal = 0;
            string msg = "success";
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "ContractDetailUpdate"
                    , ContractId
                    , ContractNumber
                    , ProjectId
                    , GranteeId
                    , SqlNumber(OrgAddressId)
                    , TaxId
                    , ContactPersonId
                    , ContractStatusId
                    , ContractTypeId
                    , ContractedAmount
                    , SqlNull(ExecutionDate)
                    , SqlNull(CompletionDate)
                    , SqlNull(TerminationDate)
                    , SqlNull(ClosedDate)
                    , SBE
                    , DVBE
                    , CertificationNumber
                    , IsRepaymentRequired
                    , IsMonitoringRequired
                    , ProjectManagerId
                    , Purpose
                    , AreContractsConditionMet
                    , BoxNumber
                    , ClosingRemarks
                    , isFlagged
                    , FlagNote
                    );
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the ContractDetail record.";
            }
            return msg;
        }

        public static string ContractDetailDelete(string ContractNumber)
        {
            // Delete ContractFund record
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "ContractDetailDelete", ContractNumber);
            }
            catch
            {
                msg = "There was a problem deleting the Contract record.";
            }
            return msg;
        }

        public static void ContractNoteInsert( int ContractId, int UserId, string ContractNote)
        {
            object id = SqlHelper.ExecuteNonQuery(connectionString, "ContractNoteInsert"
                 , ContractId
                 , DateTime.Now
                 , UserId
                 , ContractNote);
        }

        public static string GetContractNote(int ContractId)
        {
            object retVal = null;
            string sql = "SELECT top 1 ContractNote "
                + "FROM ContractNote "
                + "WHERE ContractId = " + ContractId
                + " ORDER by ContractNoteId ";

            retVal = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);
            if (retVal == null)
                retVal = string.Empty;

            return retVal.ToString();
        }

        // ADS 28-July-2008
        public static int AmendmentInsert(
            int ContractId
            , string AmendmentNumber
            , string ReasonForAmendment
            , decimal Amount
            , int ContractTypeId
            , object ExecutedDate
            )
        {
            // Insert ContractAmendment record
            int retVal = 0;
            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, "AmendmentInsert",
                     ContractId
                     , AmendmentNumber
                     , ReasonForAmendment
                     , Amount
                     , ContractTypeId
                     , ExecutedDate);

                retVal = int.Parse(id.ToString());
            }
            catch
            {
                //throw ex;
                retVal = -1;
            }
            return retVal;
        }

        public static string AmendmentDelete(int ContractId)
        {
            // Delete ContractAmendment record
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "AmendmentDelete", ContractId);
            }
            catch
            {
                msg = "There was a problem deleting the Contract Amendment record.";
            }
            return msg;
        }

        public static int ContractProjectManagerUpdate(int ContractId, int ProjectManagerId)
        {
            string sql = "UPDATE ContractDetails SET ProjectManagerId = " + ProjectManagerId + " WHERE ContractId = " + ContractId + " AND (ProjectManagerId is null or ProjectManagerId <> " + ProjectManagerId + ")";
            return SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }

        public static int ContractGranteeUpdate(int ContractId, int GranteeId)
        {
            string sql = "UPDATE ContractDetails SET GranteeId = " + GranteeId + " WHERE ContractId = " + ContractId + " AND (GranteeId is null or GranteeId <> " + GranteeId + ")";
            return SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }

        public static string AmendmentUpdate(
            int ContractId
            , int AmendmentId
            , string AmendmentNumber
            , string ReasonForAmendment
            , decimal Amount
            , int ContractTypeId
            , object ExecutedDate
            )
        {
            // Update ContractAmendment record
            int retVal = 0;
            string msg = "success";
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "AmendmentUpdate",
                     ContractId
                     , AmendmentId
                     , AmendmentNumber
                     , ReasonForAmendment
                     , Amount
                     , ContractTypeId
                     , ExecutedDate);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the Contract Amendment record.";
            }
            return msg;
        }

        public static string AmendmentLogUpdate(
              int ContractId
            , object AmendmentId
            , object LegalDate
            , object ProofreaderDate
            , object GranteeDate
            , object ReturnedDate
            , object ExecutedDate
            , object DGSDateTo
            , object DGSDateFrom
            , object ControllerDate
            , object FinalDate
            , object RegisteredDate
            , string RemoveRow
            , string Flag
            , string Notes
            , object ProjectManagerId
            )
        {
            // Update ContractAmendment record
            int retVal = 0;
            string msg = "success";
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "AmendmentLogUpdate"
                     , ContractId
                     , AmendmentId
                     , LegalDate
                     , ProofreaderDate
                     , GranteeDate
                     , ReturnedDate
                     , ExecutedDate
                     , DGSDateTo
                     , DGSDateFrom
                     , ControllerDate
                     , FinalDate
                     , RegisteredDate
                     , RemoveRow
                     , Flag
                     , Notes
                     , ProjectManagerId);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the Contract Amendment record.";
            }
            return msg;
        }


        public static string ContractFundInsert(
            SqlTransaction transaction
            , string FundingSource
            , decimal ContractedAmount
            , decimal BalanceToDate
            , object LiquidationDate
            , decimal DisencumberedAmount
            , int ContractId
            , bool ReduceAmount
            )
        {
            // Insert ContractFund record
            string retVal = "success";
            try
            {
                object id = SqlHelper.ExecuteScalar(transaction, "ContractFundInsert",
                     FundingSource
                     , ContractedAmount
                     , BalanceToDate
                     , LiquidationDate
                     , DisencumberedAmount
                     , ContractId
                     , ReduceAmount);

            }
            catch (Exception ex)
            {
                //throw ex;
                retVal = "ContractFundInsert: Error happened inserting Contract Fund";
            }
            return retVal;
        }

        public static int ContractFundInsert(
            string FundingSource
            , decimal ContractedAmount
            , decimal BalanceToDate
            , object LiquidationDate
            , decimal DisencumberedAmount
            , int ContractId
            , bool ReduceAmount
            )
        {
            // Insert ContractFund record
            int retVal = 0;
            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, "ContractFundInsert",
                     FundingSource
                     , ContractedAmount
                     , BalanceToDate
                     , LiquidationDate
                     , DisencumberedAmount
                     , ContractId
                     , ReduceAmount);

                retVal = int.Parse(id.ToString());
            }
            catch
            {
                //throw ex;
                retVal = -1;
            }
            return retVal;
        }

        public static decimal GetContractFundTotal(int ContractId, int FundId, string option)
        {
            string sql = "select dbo.usfContractFundTotals(" + ContractId + ", " + FundId + ", '" + option + "')";
            return GlobalCode.ToDecimal( SqlHelper.ExecuteScalar(connectionString,CommandType.Text, sql));
        }

        public static string ContractFundUpdate(
            int ContractFundId
            , string FundingSource
            , decimal ContractedAmount
            , decimal BalanceToDate
            , object LiquidationDate
            , decimal DisencumberedAmount
            , bool ReduceAmount
            )
        {
            // Update ContractFund record
            int retVal = 0;
            string msg = "success";
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "ContractFundUpdate",
                     ContractFundId
                     , FundingSource
                     , ContractedAmount
                     , BalanceToDate
                     , LiquidationDate
                     , DisencumberedAmount
                     , ReduceAmount);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the Contract Funding Source record.";
            }
            return msg;
        }

        public static string ContractFundUpdate(
            SqlTransaction dbTransaction
            , int ContractFundId
            , string FundingSource
            , decimal ContractedAmount
            , decimal BalanceToDate
            , object LiquidationDate
            , decimal DisencumberedAmount
            , bool ReduceAmount
            )
        {
            // Update ContractFund record
            int retVal = 0;
            string msg = "success";
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(dbTransaction, "ContractFundUpdate",
                     ContractFundId
                     , FundingSource
                     , ContractedAmount
                     , BalanceToDate
                     , LiquidationDate
                     , DisencumberedAmount
                     , ReduceAmount);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the Contract Funding Source record.";
            }
            return msg;
        }


        public static string ContractFundDelete(int ContractFundId)
        {
            // Delete ContractFund record
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "ContractFundDelete", ContractFundId);
            }
            catch
            {
                msg = "There was a problem deleting the Contract Funding Source record.";
            }
            return msg;
        }

        public static int RepaymentInsert(
            int ContractId
            , object ScheduleDate
            , object Remarks
            , object AmountOwed
            , object DatePaid
            , object AmountPaid
            , object RepaidToDate
            , object Terms
            )
        {
            // Insert Repayment Detail record
            int retVal = 0; 
            try
            {
                if (ScheduleDate.ToString() == "")
                {
                    if ((decimal)RepaidToDate == 0) RepaidToDate = null;
                    if ((decimal)AmountPaid == 0) AmountPaid = null;
                }
                
                object id = SqlHelper.ExecuteScalar(connectionString, "RepaymentInsert",
                     ContractId
                     , ScheduleDate
                     , Remarks
                     , AmountOwed
                     , DatePaid 
                     , AmountPaid
                     , RepaidToDate
                     , Terms);

                retVal = int.Parse(id.ToString());
            }
            catch
            {
                //throw ex;
                retVal = -1;
            }
            return retVal;
        }

        public static int RepaymentNoteSave(int ContractId, string RepaymentNote)
        {
            int retVal = 0;
            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, "RepaymentNoteInsert",
                     ContractId
                     , DateTime.Today
                     , GlobalSettings.UserId
                     , RepaymentNote);

                retVal = int.Parse(id.ToString());
            }
            catch
            {
                //throw ex;
                retVal = -1;
            }
            return retVal;
        }



        public static int InvoiceNoteSave(
            int ContractId
            , int UserId
            , string InvoiceNote
            , int FundId
            )
        {
            int retVal = 0;
            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, "InvoiceNoteInsert",
                     ContractId
                     , DateTime.Now
                     , UserId
                     , InvoiceNote
                     , FundId);

                retVal = int.Parse(id.ToString());
            }
            catch
            {
                //throw ex;
                retVal = -1;
            }
            return retVal;
        }

        public static string RepaymentUpdate(
            int RepaymentId
            , object ScheduleDate
            , object Remarks
            , object AmountOwed
            , object DatePaid
            , object AmountPaid
            , object RepaidToDate
            , object Terms
            )
        {
            // Update Repayment Detail record
            int retVal = 0;
            string msg = "success";

            try
            {
                if (ScheduleDate.ToString() == "")
                {
                    if ((decimal)RepaidToDate == 0) RepaidToDate = null;
                    if ((decimal)AmountPaid == 0) AmountPaid = null;
                }
                
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "RepaymentUpdate"
                     , RepaymentId
                     , ScheduleDate
                     , Remarks
                     , AmountOwed
                     , DatePaid
                     , AmountPaid
                     , RepaidToDate
                     , Terms);
            }
            catch
            {
                msg = "There was a problem updating the Contract Repayment Detail record.";
            }
            return msg;
        }

        public static string RepaymentDelete(int RepaymentId)
        {
            // Delete Repayment Detail record
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "RepaymentDelete", RepaymentId);
            }
            catch
            {
                msg = "There was a problem deleting the Repayment Schedule record.";
            }
            return msg;
        }

        public static int MonitoringDetailInsert(
            int ContractId
            , DateTime ScheduledDate
            , DateTime MonitoredDate
            , int VerifiedById
            , int OutcomeId
            , string IsDocumentLinked
            , string Remarks
            )
        {
            // Insert MonitoringDetail record
            int retVal = 0;
            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, "MonitoringDetailInsert",
                     ContractId
                     , ScheduledDate
                     , MonitoredDate
                     , VerifiedById
                     , OutcomeId
                     , IsDocumentLinked
                     , Remarks);

                retVal = int.Parse(id.ToString());
            }
            catch
            {
                //throw ex;
                retVal = -1;
            }
            return retVal;
        }

        public static string MonitoringDetailUpdate(
            int MonitorId
            , DateTime ScheduledDate
            , DateTime MonitoredDate
            , int VerifiedById
            , int OutcomeId
            , string IsDocumentLinked
            , string Remarks
            )
        {
            // Update Monitoring Detail record
            int retVal = 0;
            string msg = "success";
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "MonitoringDetailUpdate",
                     MonitorId
                     , ScheduledDate
                     , MonitoredDate
                     , VerifiedById
                     , OutcomeId
                     , IsDocumentLinked
                     , Remarks);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the Contract Monitoring Detail record.";
            }
            return msg;
        }

        public static string MonitoringDetailDelete(int MonitoringId)
        {
            // Delete Monitoring Detail record
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "MonitoringDetailDelete", MonitoringId);
            }
            catch
            {
                msg = "There was a problem deleting the Monitoring Schedule record.";
            }
            return msg;
        }

        public static int FundingSubstitute
                  (int ContractId
                  ,int ContractFundId
                  , object ReceivedDate
                  , object WithholdingPercent
                  , decimal Balance
                  , string Reason
                  , int FundId
                  , string InvoiceNumber
                  , decimal DisencumberAugment
                  , int NewFundID        
                  , int AuthorizationId     
            )
        {
            // Reflect Funding Substitute through: Invoice, ContractFund, Reservencumb tables
            int retVal = 0;
            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, "FundingSubstitute",
                     ContractId
                     , ContractFundId
                     , ReceivedDate
                     //, BillingPeriodStart
                     //, InvoiceDate
                     //, GrossAmountApproved
                     //, NetAmountApproved
                     , WithholdingPercent
                     //, WithholdingAmount
                     , Balance
                     , Reason
                     , FundId
                     , InvoiceNumber
                     , DisencumberAugment
                     , NewFundID              
                     , AuthorizationId     
                     , userid                     
                     
                     );

                retVal = int.Parse(id.ToString());
            }
            catch
            {
                //throw ex;
                retVal = -1;
            }
            return retVal;
        }

        public static string ContractFundInvoicesReassigned(int ContractId, int OriginalFundId, int NewFundId)
        {
            string retVal = "success";

            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, "ContractFundInvoicesReassigned",
                     ContractId
                     , OriginalFundId
                     , NewFundId);
            }
            catch (Exception ex)
            {
                //throw ex;
                retVal = "ContractFundInvoicesReassigned: Error happened during invoices reassignment";
            }

            return retVal;
        }

        public static string InvoiceDetailInsert
            ( SqlTransaction transaction
            , int ContractId
            , object ReceivedDate
            , decimal GrossInvoiceAmount
            , string IsFinal
            , object BillingPeriodStart
            , object InvoiceDate
            , decimal GrossAmountApproved
            , decimal NetAmountApproved
            , object WithholdingPercent
            , decimal WithholdingAmount
            , decimal Balance
            , object DateToProjManager
            , object ToAccountingDate
            , object FromAccountingDate
            , string ClaimScheduleNumber
            , object ClaimSchedDate
            , object DisputeDateFromPM
            , string Reason
            , object DisputeDateMailedOut
            , string IsDisputed
            , int FundId
            , string InvoiceNumber
            , decimal DisencumberAugment
            )
        {
            // Insert InvoiceDetail record
            string retVal = "success";
            try
            {
                object id = SqlHelper.ExecuteScalar(transaction, "InvoiceDetailInsert",
                     ContractId
                     , ReceivedDate
                     , GrossInvoiceAmount
                     , IsFinal
                     , BillingPeriodStart
                     , InvoiceDate
                     , GrossAmountApproved
                     , NetAmountApproved
                     , WithholdingPercent
                     , WithholdingAmount
                     , Balance
                     , DateToProjManager
                     , ToAccountingDate
                     , FromAccountingDate
                     , ClaimScheduleNumber
                     , ClaimSchedDate
                     , DisputeDateFromPM
                     , Reason
                     , DisputeDateMailedOut
                     , IsDisputed
                     , FundId
                     , InvoiceNumber
                     , DisencumberAugment);

               
            }
            catch(Exception ex)
            {
                //throw ex;
                retVal = "InvoiceDetailInsert: Error happened during insert invoice";
            }
            return retVal;
        }


        public static int InvoiceDetailInsert
            ( int ContractId
            , object ReceivedDate
            , decimal GrossInvoiceAmount
            , string IsFinal
            , object BillingPeriodStart
            , object InvoiceDate
            , decimal GrossAmountApproved
            , decimal NetAmountApproved
            , object WithholdingPercent
            , decimal WithholdingAmount
            , decimal Balance
            , object DateToProjManager
            , object ToAccountingDate
            , object FromAccountingDate
            , string ClaimScheduleNumber
            , object ClaimSchedDate
            , object DisputeDateFromPM
            , string Reason
            , object DisputeDateMailedOut
            , string IsDisputed
            , int FundId
            , string InvoiceNumber
            , decimal DisencumberAugment
            )
        {
            // Insert InvoiceDetail record
            int retVal = 0;
            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, "InvoiceDetailInsert",
                     ContractId
                     , ReceivedDate
                     , GrossInvoiceAmount
                     , IsFinal
                     , BillingPeriodStart
                     , InvoiceDate
                     , GrossAmountApproved
                     , NetAmountApproved
                     , WithholdingPercent
                     , WithholdingAmount
                     , Balance
                     , DateToProjManager
                     , ToAccountingDate
                     , FromAccountingDate
                     , ClaimScheduleNumber
                     , ClaimSchedDate
                     , DisputeDateFromPM
                     , Reason
                     , DisputeDateMailedOut
                     , IsDisputed
                     , FundId
                     , InvoiceNumber
                     , DisencumberAugment);

                retVal = int.Parse(id.ToString());
            }
            catch
            {
                //throw ex;
                retVal = -1;
            }
            return retVal;
        }

        public static string InvoiceDetailUpdate(
            int InvoiceId
            , object ReceivedDate
            , decimal GrossInvoiceAmount
            , string IsFinal
            , string BillingPeriodStart
            , object InvoiceDate
            , decimal GrossAmountApproved
            , decimal NetPaymentAmount
            , object WithholdingPercent
            , decimal WithholdingAmount
            , decimal Balance
            , object DateToProjManager
            , object ToAccountingDate
            , object FromAccountingDate
            , string ClaimScheduleNumber
            , object ClaimSchedDate
            , object DisputeDateFromPM
            , string Reason
            , object DisputeDateMailedOut
            , string IsDisputed
            , int FundId
            , string InvoiceNumber
            , decimal DisencumberAugment
            )
        {
            // Update Monitoring Detail record
            int retVal = 0;
            string msg = "success";
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "InvoiceDetailUpdate",
                     InvoiceId
                     , ReceivedDate
                     , GrossInvoiceAmount
                     , IsFinal
                     , BillingPeriodStart
                     , InvoiceDate
                     , GrossAmountApproved
                     , NetPaymentAmount
                     , WithholdingPercent
                     , WithholdingAmount
                     , Balance
                     , DateToProjManager
                     , ToAccountingDate
                     , FromAccountingDate
                     , ClaimScheduleNumber
                     , ClaimSchedDate
                     , DisputeDateFromPM
                     , Reason
                     , DisputeDateMailedOut
                     , IsDisputed
                     , FundId
                     , InvoiceNumber
                     , DisencumberAugment);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the Contract Invoice Detail record.";
            }
            return msg;
        }

        public static string InvoiceDetailDelete(int InvoiceId)
        {
            // Delete Invoice Detail record
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "InvoiceDetailDelete", InvoiceId);
            }
            catch
            {
                msg = "There was a problem deleting the Monitoring Schedule record.";
            }
            return msg;
        }

        private static object SqlNull(object value)
        {
            if (value == DBNull.Value || value == null)
                return DBNull.Value;
            string s = value.ToString();
            if (s == string.Empty)
                return DBNull.Value;
            return value;
        }

        private static string SqlString(object value)
        {
            if (value == DBNull.Value || value == null)
                return "null";
            string s = value.ToString();
            if (s == string.Empty)
                return "null";
            return "'" + s.Replace("'", "''") + "'";
        }

        private static string SqlBoolean(object value)
        {
            if (value == DBNull.Value || value == null)
                return "0";
            string s = value.ToString().ToLower();
            if (s == string.Empty)
                return "0";
            s = s.Substring(0, 1);
            //1, true, on, yes
            if (s == "1" || s == "t" || s == "o" || s == "y")
                return "1";
            return "0";
        }

        private static object SqlNumber(object value)
        {
            if (value == DBNull.Value || value == null)
                return DBNull.Value;
            string s = value.ToString();
            if (s == string.Empty)
                return DBNull.Value;
            try
            {
               s = decimal.Parse(s).ToString();
                return s;
            }
            catch (Exception)
            {
                return DBNull.Value;
            }
        }
    
    }
}
