using System;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Data
{
	/// <summary>
	/// MAR 2005-03-28
	/// Contains methods for managing data for FiscalYear table
	/// </summary>
	public class FiscalYearData
	{
		static string userid = GlobalSettings.userid;
        
        private static string connectionString
        {
            get { return GlobalSettings.ConnectionString; }
        }

        static FiscalYearData()
		{

        }
		
        public static DataSet GetFiscalYears()
		{
			// Get list of all FiscalYears (for FiscalYear admin page grid)
			// Format SQL string
			string sql = 
			  "SELECT FiscalYearID, Years, StartDate, EndDate, Chapter, ChapterFy, 0 AS DirtyFlag " + 
			    "FROM FiscalYear ORDER BY Years";

			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}

		public static string FiscalYearUpdate(
			 int FiscalYearID
			,DateTime StartDate
			,DateTime EndDate
			,String Chapter
			,String Years
			,String ChapterFY
			)
		{	
			// Update FiscalYear record
			string msg="success";
			int retVal = 0;
			try
			{
				retVal = SqlHelper.ExecuteNonQuery(connectionString,"FiscalYearUpdate",
					  FiscalYearID 
					 ,StartDate
			         ,EndDate
			         ,Chapter
			         ,Years
			         ,ChapterFY
					 ,userid);					 
			}
			catch
			{
				//throw ex;
				msg="There was a problem updating the FiscalYear record.";
			}
			return msg;
		}
		public static int FiscalYearInsert(
			 DateTime StartDate
			,DateTime EndDate
			,string Chapter
			,String Years
			,String ChapterFY
			)
		{	
			// Insert objective record
			int retVal = 0;
			try
			{
				object id = SqlHelper.ExecuteScalar(connectionString,"FiscalYearInsert",
					  StartDate
			         ,EndDate
			         ,Chapter
			         ,Years
			         ,ChapterFY
					 ,userid);

				retVal = int.Parse(id.ToString());
			}
			catch 
			{
				retVal=-1;
			}
			return retVal;
		}
		public static string FiscalYearDelete(int FiscalYearID)
		{	
			// Delete FiscalYear record
			string msg="success";
			int retVal = 0;
			try
			{
				retVal = SqlHelper.ExecuteNonQuery(connectionString,"FiscalYearDelete",FiscalYearID);	
			}
			catch
			{
				//throw ex;
				msg="There was a problem deleting the FiscalYear record.";
			}
			return msg;
		}

	
	}
}
