using System;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using Microsoft.ApplicationBlocks.Data;
using System.Collections.Generic;

namespace CCPM.Data
{
	/// <summary>
	/// Summary description for ProjectData.
	/// </summary>
	public class ProjectData
	{
		static string userid = GlobalSettings.userid;

        private static string connectionString
        {
            get { return GlobalSettings.ConnectionString; }
        }

        static ProjectData()
		{
		}

        public static bool OrgHasProjectRole(int OrgId, int ProjectId)
        {
            string sql = "select top 1 1 from Org_ProjectRole where OrgId = " + OrgId + " and ProjectId = " + ProjectId + " and ProjectRoleId is not null ";
            return GlobalCode.ToBoolean(SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql));
        }

        public static int OrgProjectRoleInsert(int OrgId, int ProjectId, string Roles)
        {
            string sql = "insert Org_ProjectRole (OrgId, ProjectId, ProjectRoleId) " +
                " select " + OrgId + ", " + ProjectId + ", ProjectRoleId " +
                " from ProjectRole where ProjectRoleId in (" + Roles + ") " +
                " and ProjectRoleId not in (select ProjectRoleId from Org_ProjectRole where OrgId = " + OrgId + " and ProjectId = " + ProjectId + ") ";
            return SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }

        public static int OrgProjectRoleSave(int OrgId, int ProjectId, string Roles)
        {
            string sql = "delete Org_ProjectRole where OrgId = " + OrgId + " and ProjectId = " + ProjectId +"; ";
            if (Roles == string.Empty)
            {
                sql += "insert Org_ProjectRole (OrgId, ProjectId, ProjectRoleId) " +
                    " values (" + OrgId + ", " + ProjectId + ", null); ";
            }
            else
            {
                sql += "insert Org_ProjectRole (OrgId, ProjectId, ProjectRoleId) " +
                " select " + OrgId + ", " + ProjectId + ", ProjectRoleId " +
                " from ProjectRole where ProjectRoleId in (" + Roles + ") ";
            }
            return SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }

        public static DataSet GetOrgProjectRoles(int OrgId, int ProjectId)
        {
            string sql = "select (case when Org_ProjectRole.ProjectRoleId is null then 0 else 1 end) as Include" +
                ", ProjectRole.ProjectRole , ProjectRole.ProjectRoleId " +
                " from ProjectRole " +
                " left outer join Org_ProjectRole on Org_ProjectRole.ProjectRoleId = ProjectRole.ProjectRoleId " +
                "     and Org_ProjectRole.ProjectId = " + ProjectId + " and Org_ProjectRole.OrgId = " + OrgId +
                " order by ProjectRole.ProjectRole";
            return SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
        }
        
        public static DataSet GetProjectRoles()
        {
            string sql = "select ProjectRoleId, ProjectRole from ProjectRole where IsActive = 1 order by ProjectRole";
            return SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
        }

        public static DataSet GetAllStaff()
        {
            string sql = "select ProjectManagerId, [Name], Initials, Email, IsActive from ProjectStaff order by [Name]";
            return SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
        }

        public static DataSet GetStaffRoles(int id)
        {
            string sql = "";
            if (id > 0)
            {
                sql = "select StaffRole.StaffRoleId " +
                    ", StaffRole.StaffRoleName " +
                    ", convert(bit, (case when (ProjectStaff_StaffRole.StaffRoleId) is null then 0 else 1 end)) as inRole " +
                    "from StaffRole " +
                    "left outer join ProjectStaff_StaffRole on ProjectStaff_StaffRole.StaffRoleId = StaffRole.StaffRoleId " +
                    "    and ProjectStaff_StaffRole.ProjectManagerId = " + id.ToString() + " " +
                    "order by StaffRole.StaffRoleName";
            }
            else
            {
                sql = "select StaffRoleId, StaffRoleName, convert(bit, 0) as inRole from StaffRole order by StaffRoleName";
            }
            return SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
        }

        public static int StaffRoleSave(int Id, string roles)
        {
            string sql = "delete ProjectStaff_StaffRole where ProjectManagerId = " + Id.ToString() + ";\n";
            if (roles.Length > 0)
            {
                sql += "insert ProjectStaff_StaffRole (ProjectManagerId, StaffRoleId) \n" +
                "    select " + Id.ToString() + ", StaffRoleId from StaffRole \n" +
                "    where StaffRoleId in (" + roles + ");";
            }
            return SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);

        }

        public static int ProjectStaffSave(int ProjectManagerId, string Name, string Initials, string Email, bool IsActive)
        {
            return (int)SqlHelper.ExecuteScalar(connectionString, "ProjectStaffSave", ProjectManagerId, Name, Initials, Email, IsActive);
        }

        public static int ProjectStaffDelete(int projectManagerId)
        {
            return (int)SqlHelper.ExecuteNonQuery(connectionString, "ProjectStaffDelete", projectManagerId);
        }

        public static int InsertProject(string fileNumber, string projectName, string description)
		{
			return InsertProject( fileNumber, projectName, "", description,
				0, 0, 0, 0, 0, 0, 0, 0, "", "", 0, 0, 0,
				new CCPM.Data.IntegerList(), new CCPM.Data.IntegerList(), new CCPM.Data.IntegerList(), new CCPM.Data.IntegerList(),
				new CCPM.Data.IntegerList(), new CCPM.Data.IntegerList(), new CCPM.Data.IntegerList(), new CCPM.Data.IntegerList(),
				new CCPM.Data.IntegerList(), new CCPM.Data.IntegerList(), new CCPM.Data.IntegerList(), null,null,"0",null,null,new List<string>());
		}
		
		public static int InsertProject(
			string			fileNumber,
			string			projectName,
			string			summary,
			string			description,
			decimal			latitude,
			decimal			longitude,
			decimal			acreage,
			decimal			squareMiles,
			decimal			trailMiles,
			decimal			trailLinearFeet,
			decimal			streamMiles,
			decimal			streamLinearFeet,
			string			projectNotes,
			string			parcelNumber,
			decimal			coastalTrailMiles,
            decimal         coastalLinearFeet,
			int				currentPM,
			IntegerList		projectAttornies,
			IntegerList		projectCounties,
			IntegerList		projectCities,
			IntegerList		projectManagers,
			IntegerList		projectProgramTypes,
			IntegerList		projectRegions,
			IntegerList     projectWatersheds,
			IntegerList		projectTypes,
			IntegerList		assemblyList,
			IntegerList		senateList,
			IntegerList		congressionalList,
            string          LocationDescription,
            object          completionDate,
            string          isWebSite,
            string          dynamicDD1,
            string dynamicDD2,
            List<string> dynamicMultiSelect1
			)
		{
			int projectId;
			SqlConnection conn = new SqlConnection(connectionString);
			conn.Open();
			SqlTransaction trans = conn.BeginTransaction(System.Data.IsolationLevel.RepeatableRead, "ProjectInsert");
			try
			{
				object id = SqlHelper.ExecuteScalar(
					trans,
					"ProjectInsert",
					fileNumber,
					projectName,
					summary,
					description,
					latitude,
					longitude,
					acreage,
					squareMiles,
					trailMiles,
					trailLinearFeet,
					streamMiles,
					streamLinearFeet,
					parcelNumber,
					coastalTrailMiles,
                    coastalLinearFeet,
					currentPM,
					projectNotes,
                    LocationDescription,
                    completionDate,
                    isWebSite,                   
                    dynamicDD1,
                    dynamicDD2
                    );

				projectId = int.Parse(id.ToString());

				InsertProjectRelated(
					trans,
					projectAttornies,
					projectCounties,
					projectCities,
					projectManagers,
					projectProgramTypes,
					projectRegions,
					projectWatersheds,
					projectTypes,
					assemblyList,
					senateList,
					congressionalList,
                    dynamicMultiSelect1,
					projectId);

				trans.Commit();
			}
			catch(Exception ex)
			{
				trans.Rollback("ProjectInsert");
				throw ex;
			}
			finally
			{
				trans.Dispose();
			}
		
			return projectId;
		}

		public static bool UpdateProject(
			string			fileNumber,
			string			projectName,
			int				StatusId,
			DateTime		statusDate,
			string			summary,
			string			description,
			decimal			latitude,
			decimal			longitude,
			decimal			acreage,
			decimal			squareMiles,
			decimal			trailMiles,
			decimal			trailLinearFeet,
			decimal			streamMiles,
			decimal			streamLinearFeet,
			string			projectNotes,
			IntegerList		projectAttornies,
			IntegerList		projectCounties,
			IntegerList		projectCities,
			IntegerList		projectManagers,
			IntegerList		projectProgramTypes,
			IntegerList		projectRegions,
			IntegerList     projectWatersheds,
			IntegerList		projectTypes,
			IntegerList		assemblyDistricts,
			IntegerList		senateDistricts,
			IntegerList		congressionalDistricts,
			string			parcelNumber,
			decimal			coastalTrailMiles,
            decimal         coastalTrailLinearFeet,
			int				currentPM,
			int				projectId,
			DateTime		lastModified,
            string          LocationDescription,
            object          completionDate,
            string          isWebSite,
            string          dynamicDD1,
            string          dynamicDD2,
            List<string>    dynamicMultiSelect1
            )
		{
			bool success;
			SqlConnection conn = new SqlConnection(connectionString);
			conn.Open();
			SqlTransaction trans = conn.BeginTransaction(
				System.Data.IsolationLevel.RepeatableRead,
				"UpdateProject");
			try
			{
				int returnVal = SqlHelper.ExecuteNonQuery(
					trans,
					"ProjectUpdate",
					fileNumber,
					projectName,
					StatusId,
					statusDate,
					summary,
					description,
					latitude,
					longitude,
					acreage,
					squareMiles,
					trailMiles,
					trailLinearFeet,
					streamMiles,
					streamLinearFeet,
					projectNotes,
					parcelNumber,
					coastalTrailMiles,
                    coastalTrailLinearFeet,
					currentPM,
					projectId,
					lastModified,
                    LocationDescription,
                    completionDate,
                    isWebSite,               
                    dynamicDD1,
                    dynamicDD2
                );

				success = returnVal == 0 ? false : true;

				if(success)//record was updated
				{
					SqlHelper.ExecuteNonQuery(trans, "Project_DeleteRelated", projectId);
					InsertProjectRelated(
						trans,
						projectAttornies,
						projectCounties,
						projectCities,
						projectManagers,
						projectProgramTypes,
						projectRegions,
						projectWatersheds,
						projectTypes,
						assemblyDistricts,
						senateDistricts,
						congressionalDistricts,
                        dynamicMultiSelect1,
						projectId);
				}

				trans.Commit();
			}
			catch
			{
				trans.Rollback();
				throw;
			}
			finally
			{
				trans.Dispose();
			}
			
			return success;
		}

        public static bool UpdateProjectPrimaryPM(
                    int currentPM,
                    int projectId
                    )
        {
            bool success;
            SqlConnection conn = new SqlConnection(connectionString);
            conn.Open();
            SqlTransaction trans = conn.BeginTransaction(
                System.Data.IsolationLevel.RepeatableRead,
                "UpdateProject");
            try
            {
                int returnVal = SqlHelper.ExecuteNonQuery(
                    trans,
                    "ProjectPrimaryPMUpdate",
                    currentPM,
                    projectId
                );

                success = returnVal == 0 ? false : true;

                trans.Commit();
            }
            catch
            {
                trans.Rollback();
                throw;
            }
            finally
            {
                trans.Dispose();
            }

            return success;
        }

		private static void InsertProjectRelated(
			SqlTransaction trans,
			IntegerList		projectAttornies,
			IntegerList		projectCounties,
			IntegerList		projectCities,
			IntegerList		projectManagers,
			IntegerList		projectProgramTypes,
			IntegerList		projectRegions, 
			IntegerList     projectWatersheds,
			IntegerList		projectTypes,
			IntegerList		assemblyList,
			IntegerList		senateList,
			IntegerList		congressionalList,
            List<string>    dynamicMultiSelect1,
			int projectId)
		{

			//string someuser;
			//GlobalSettings gs = new GlobalSettings();
			string someuser = GlobalSettings.userid;
                                    
			foreach(object attorneyId in projectAttornies)
			{ 
				SqlHelper.ExecuteNonQuery(
					trans,
					"Project_ProjectAttorneyInsert", 
					projectId,
					(int)attorneyId);
			}

			foreach(object countyId in projectCounties)
			{
				SqlHelper.ExecuteNonQuery(
					trans,
					"Project_ProjectCountyInsert",
					projectId,
					(int)countyId);
			}

			foreach(object cityId in projectCities)
			{
				SqlHelper.ExecuteNonQuery(
					trans,
					"Project_ProjectCityInsert",
					projectId,
					(int)cityId);
			}

			foreach(object managerId in projectManagers)
			{
				SqlHelper.ExecuteNonQuery(
					trans,
					"Project_ProjectManagerInsert",
					projectId,
					(int)managerId);
			}

			foreach(object programTypeId in projectProgramTypes)
			{
				SqlHelper.ExecuteNonQuery(
					trans,
					"Project_ProjectProgramTypeInsert",
					projectId,
					(int)programTypeId);
			}

			foreach(object regionId in projectRegions)
			{
				SqlHelper.ExecuteNonQuery(
					trans,
					"Project_ProjectRegionInsert",
					projectId,
					(int)regionId);
			}

			// 2005-02-18 - added
			foreach(object WatershedID in projectWatersheds)
			{
				SqlHelper.ExecuteNonQuery(
					trans,
					"Project_ProjectWatershedInsert",
					projectId,
					(int)WatershedID, userid);
			}

			foreach(object projectTypeId in projectTypes)
			{
				SqlHelper.ExecuteNonQuery(
					trans,
					"Project_ProjectTypeInsert",
					projectId,
					(int)projectTypeId);
			}

			foreach(object assemblyDistrict in assemblyList)
			{
				SqlHelper.ExecuteNonQuery(
					trans,
					"Project_AssemblyDistrictInsert",
					projectId,
					(int)assemblyDistrict);
			}

			foreach(object senateDistrict in senateList)
			{
				SqlHelper.ExecuteNonQuery(
					trans,
					"Project_SenateDistrictInsert",
					projectId,
					(int)senateDistrict);
			}

			foreach(object congressionalDistrict in congressionalList)
			{
				SqlHelper.ExecuteNonQuery(
					trans,
					"Project_CongressionalDistrictInsert",
					projectId,
					(int)congressionalDistrict);
			}

            foreach (string selectedId in dynamicMultiSelect1)
            {
                //had to do this with text commandtype because the damn thing wouldn't treat the nvarchar value properly. Kept converting it to an integer.
                SqlHelper.ExecuteNonQuery(
                    trans,
                    CommandType.Text,
                    "EXEC Project_ProjectDynamicMultiSelect1Insert " + projectId + "," + "'" + selectedId + "'");
            }
		}

		public static DataSet GetProject(int projectId)
		{
			DataSet project = null;
			SqlConnection conn = new SqlConnection(connectionString);
			conn.Open();
			SqlTransaction trans = conn.BeginTransaction(
				System.Data.IsolationLevel.RepeatableRead,
				"GetProject");
			try
			{
				project = SqlHelper.ExecuteDataset(
					trans,
					"ProjectGet",
					projectId);

				project.Tables[0].TableName = "Project";
				project.Tables[1].TableName = "ProjectAttorney";
				project.Tables[2].TableName = "ProjectCounty";
				project.Tables[3].TableName = "ProjectCity";
				project.Tables[4].TableName = "ProjectManager";
				project.Tables[5].TableName = "ProjectProgramType";
				project.Tables[6].TableName = "ProjectRegion";
				project.Tables[7].TableName = "ProjectType";
				project.Tables[8].TableName = "ProjectAssemblyDistrict";
				project.Tables[9].TableName = "ProjectSenateDistrict";
				project.Tables[10].TableName = "ProjectCongressionalDistrict";
				project.Tables[11].TableName = "ProjectFunds";
				// MAR 2005-02-18 - added
                project.Tables[12].TableName = "ProjectWatershed";
				project.Tables[13].TableName = "ProjectObjective";

                project.Tables[14].TableName = "ContractManager";

                project.Tables[15].TableName = "DynamicMultiSelect1";

				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectAttorney"].Columns["ProjectId"]);
				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectCounty"].Columns["ProjectId"]);
				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectCity"].Columns["ProjectId"]);
				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectManager"].Columns["ProjectId"]);
				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectProgramType"].Columns["ProjectId"]);
				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectRegion"].Columns["ProjectId"]);
				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectType"].Columns["ProjectId"]);
				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectAssemblyDistrict"].Columns["ProjectId"]);
				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectSenateDistrict"].Columns["ProjectId"]);
				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectCongressionalDistrict"].Columns["ProjectId"]);
				// MAR 2005-02-18 - added
				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectWatershed"].Columns["ProjectId"]);
				project.Relations.Add(project.Tables["Project"].Columns["ProjectId"], project.Tables["ProjectObjective"].Columns["ProjectId"]);
			}
			catch
			{
				trans.Rollback("GetProject");
			}
			finally
			{
				trans.Dispose();
			}
			return project;
		}

		public static int GetProjectId(string projectName)
		{
			return (int)SqlHelper.ExecuteScalar(connectionString, "ProjectGetId", projectName);
		}

        public static string GetProjectName(int projectId)
        {
            return (string)SqlHelper.ExecuteScalar(connectionString, "ProjectGetName", projectId);
        }

        public static DataSet GetProjectGrantees(int ProjectId)
        {
            // build parameters
            SqlParameter[] sParams = new SqlParameter[1];
            sParams[0] = new SqlParameter("@ProjectId", SqlDbType.Int);
            sParams[0].Value = ProjectId;

            DataSet ds = SqlHelper.ExecuteDataset(connectionString, CommandType.StoredProcedure, "ProjectGrantees", sParams);
            return ds;
        }

		public static DataSet GetContactTypeByProject(int ProjectId, int ContactTypeId)
		{
			// build parameters
			SqlParameter[] sParams = new SqlParameter[2];
			sParams[0] = new SqlParameter("@ProjectId", SqlDbType.Int);
			sParams[1] = new SqlParameter("@ContactTypeId", SqlDbType.Int);
			sParams[0].Value = ProjectId;
			sParams[1].Value = ContactTypeId;

			// get data
			DataSet ds = SqlHelper.ExecuteDataset(connectionString, CommandType.StoredProcedure, "ContactTypeByProject", sParams);
			return ds;
		}

		public static DataSet GetProjectRelated()
		{
			DataSet ds = SqlHelper.ExecuteDataset(connectionString, CommandType.StoredProcedure, "ProjectGetRelated");
			ds.Tables[0].TableName = "ProjectManager";
			ds.Tables[1].TableName = "ProjectAttorney";
			ds.Tables[2].TableName = "ProjectCounty";
			ds.Tables[3].TableName = "ProjectCity";
			ds.Tables[4].TableName = "ProjectProgramType";
			ds.Tables[5].TableName = "ProjectRegion";
			ds.Tables[6].TableName = "ProjectType";
			ds.Tables[7].TableName = "ProjectAssemblyDistrict";
			ds.Tables[8].TableName = "ProjectCongressionalDistrict";
			ds.Tables[9].TableName = "ProjectStateSenateDistrict";
			// MAR 2005-02-09 - added
            ds.Tables[10].TableName = "Watershed";
            ds.Tables[11].TableName = "Objective";
			return ds;
		}

        public static DataSet GetProjectRelated(int ProjectId)
        {
            DataSet ds = SqlHelper.ExecuteDataset(connectionString, "ProjectGetRelated", ProjectId);
            ds.Tables[0].TableName = "ProjectManager";
            ds.Tables[1].TableName = "ProjectAttorney";
            ds.Tables[2].TableName = "ProjectCounty";
            ds.Tables[3].TableName = "ProjectCity";
            ds.Tables[4].TableName = "ProjectProgramType";
            ds.Tables[5].TableName = "ProjectRegion";
            ds.Tables[6].TableName = "ProjectType";
            ds.Tables[7].TableName = "ProjectAssemblyDistrict";
            ds.Tables[8].TableName = "ProjectCongressionalDistrict";
            ds.Tables[9].TableName = "ProjectStateSenateDistrict";
            // MAR 2005-02-09 - added
            ds.Tables[10].TableName = "Watershed";
            ds.Tables[11].TableName = "Objective";
            return ds;
        }

        public static DataSet GetProjectRelatedInactive()
		{
			DataSet ds = SqlHelper.ExecuteDataset(connectionString, CommandType.StoredProcedure, "ProjectGetRelatedInactive");
			ds.Tables[0].TableName = "ProjectManager";
			ds.Tables[1].TableName = "ProjectAttorney";
			ds.Tables[2].TableName = "ProjectCounty";
			ds.Tables[3].TableName = "ProjectCity";
			ds.Tables[4].TableName = "ProjectProgramType";
			ds.Tables[5].TableName = "ProjectRegion";
			ds.Tables[6].TableName = "ProjectType";
			ds.Tables[7].TableName = "ProjectAssemblyDistrict";
			ds.Tables[8].TableName = "ProjectCongressionalDistrict";
			ds.Tables[9].TableName = "ProjectStateSenateDistrict";
			// MAR 2005-02-09 - added
			ds.Tables[10].TableName = "Watershed";
			ds.Tables[11].TableName = "Objective";
			return ds;
		}

        public static DataSet GetProjectRelatedInactive(int ProjectId)
        {
            DataSet ds = SqlHelper.ExecuteDataset(connectionString, "ProjectGetRelatedInactive", ProjectId);
            ds.Tables[0].TableName = "ProjectManager";
            ds.Tables[1].TableName = "ProjectAttorney";
            ds.Tables[2].TableName = "ProjectCounty";
            ds.Tables[3].TableName = "ProjectCity";
            ds.Tables[4].TableName = "ProjectProgramType";
            ds.Tables[5].TableName = "ProjectRegion";
            ds.Tables[6].TableName = "ProjectType";
            ds.Tables[7].TableName = "ProjectAssemblyDistrict";
            ds.Tables[8].TableName = "ProjectCongressionalDistrict";
            ds.Tables[9].TableName = "ProjectStateSenateDistrict";
            // MAR 2005-02-09 - added
            ds.Tables[10].TableName = "Watershed";
            ds.Tables[11].TableName = "Objective";
            return ds;
        }

        public static DataSet GetProjectList(int status)
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectList", status);
		}
        public static DataSet GetProjectListRange(string status)
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectListRange", status);
		}
        

		public static DataSet GetProjectListEx(int status)
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectListEx", status);
		}

        // Added -- 18-July-2008 --- 2.11.1
        
        public static DataSet GetProjectStatus()
        {
            // Format SQL string
            string sql = "SELECT * FROM ProjectStatus"; 
                
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }


        public static DataSet GetFiscalYears()
        {
            string sql = "select FiscalYearId, Years from FiscalYear order by Years";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetFundItem()
        {
            string sql = "SELECT FundID, dbo.usfFundingItem1(FundingSource.FundID) AS FundingItem "
                + "FROM FundingSource INNER JOIN FiscalYear ON FundingSource.FiscalYearID = FiscalYear.FiscalYearID "
                + "ORDER BY Years DESC, FundNumber, RefCode, ScheduleNum, SubScheduleNum";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetFundSource()
        {
            // Format SQL string
            //string sql = "SELECT '' AS FundingItem, 0 AS FundID "
            //    + ", 0 as SortKey, '' as Years, '' as FundNumber, '' as RefCode, '' as ScheduleNum, '' as SubScheduleNum "
            //    + "UNION ALL "
            //    + "SELECT dbo.usfFundingItem2(FundingSource.FundID) AS FundingItem "
            //    + ", FundID, 1 as SortKey, Years, FundNumber, RefCode, ScheduleNum, SubScheduleNum  "
            //    + "FROM FundingSource INNER JOIN FiscalYear ON FundingSource.FiscalYearID = FiscalYear.FiscalYearID "
            //    + "ORDER BY SortKey, Years DESC, FundNumber, RefCode, ScheduleNum, SubScheduleNum";

            string sql = "SELECT FundID, dbo.usfFundingItem2(FundingSource.FundID) AS FundingItem "
                + "FROM FundingSource INNER JOIN FiscalYear ON FundingSource.FiscalYearID = FiscalYear.FiscalYearID "
                + "ORDER BY FundNumber, RefCode, ScheduleNum, SubScheduleNum";
            //    + "ORDER BY SortKey, Years DESC, FundNumber, RefCode, ScheduleNum, SubScheduleNum";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetFundNumber()
        {
            // Format SQL string
            //string sql = "SELECT DISTINCT FundNumber + ' (' + COALESCE(FundingSource.Source,'') + ')' AS FundDesc, FundNumber, Source "
            //     + "FROM FundingSource "
            //     + "WHERE FundNumber is not null "
            //     + "ORDER BY FundNumber ASC, Source ASC";

            string sql = "SELECT DISTINCT FundNumber "
                 + "FROM FundingSource "
                 + "WHERE FundNumber is not null "
                 + "ORDER BY FundNumber ";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetFundTitle()
        {
            // Format SQL string
            string sql = "SELECT DISTINCT Source FROM FundingSource ORDER BY Source";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetOrganizations()
        {
            // Get list of grantee organizations (project search page)
            string sql =
                "SELECT OrgID, Organization "
                + "FROM Organization "
                //+ "WHERE OrganizationTypeId = 10 "
                + "ORDER BY Organization ";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetMatchingFundOrganizations()
        {
            // Get list of matching fund organizations 
            string sql =
                "SELECT OrgID, Organization "
                + "FROM Organization "
               + "WHERE OrgId in (select OrgId from MatchingFund) "
                + "ORDER BY Organization ";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

		#region Project Related Fields
        //Reimbursement Types
        public static DataSet ReimbTypeSelect()
        {
            return SqlHelper.ExecuteDataset(connectionString, "ReimbTypeSelect");
        }

        public static void ReimbTypeInsert(string ReimbType)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "ReimbTypeInsert", ReimbType);
        }

        public static void ReimbTypeUpdate(string ReimbType, bool IsActive, int ReimbTypeId)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "ReimbTypeUpdate", ReimbTypeId, ReimbType);
        }


        //Authorization Types
        public static DataSet AuthorizationTypeSelect()
        {
            return SqlHelper.ExecuteDataset(connectionString, "AuthorizationTypeSelect", 1);
        }

        public static void AuthorizationTypeInsert(string AuthorizationType)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "AuthorizationTypeInsert", AuthorizationType);
        }

        public static void AuthorizationTypeUpdate(string AuthorizationType, bool IsActive, int AuthorizationTypeId)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "AuthorizationTypeUpdate", AuthorizationTypeId, AuthorizationType,IsActive);
        }


        //Rel Types
        public static DataSet RelTypeSelect()
        {
            return SqlHelper.ExecuteDataset(connectionString, "RelTypeSelect", 1, null);
        }

        public static void RelTypeInsert(string RelType)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "RelTypeInsert", RelType);
        }

        public static void RelTypeUpdate(string RelType, bool IsActive, int RelTypeId)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "RelTypeUpdate", RelTypeId, RelType, IsActive);
        }


        
        //Contract Types
        public static DataSet ContractTypeSelect()
        {
            return SqlHelper.ExecuteDataset(connectionString, "ContractTypeSelect",1);
        }

        public static void ContractTypeInsert(string TypeCode)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "ContractTypeInsert", TypeCode);
        }

        public static void ContractTypeUpdate(string TypeCode, bool IsActive, int ContractTypeId)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "ContractTypeUpdate", ContractTypeId, TypeCode, IsActive);
        }


        //MonitorOutcomes
        public static DataSet MonitorOutcomeSelect()
        {
            return SqlHelper.ExecuteDataset(connectionString, "MonitorOutcomeSelect",1);
        }

        public static void MonitorOutcomeInsert(string OutcomeCode)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "MonitorOutcomeInsert", OutcomeCode);
        }

        public static void MonitorOutcomeUpdate(string OutcomeCode, bool IsActive, int OutcomeId)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "MonitorOutcomeUpdate", OutcomeId, OutcomeCode,IsActive);
        }




        //Project Attorney
		public static DataSet ProjectAttorneyList()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectAttorneyList", 1, null);
		}

		public static void ProjectAttorneyInsert(string name)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectAttorneyInsert", name);
		}

		public static void ProjectAttorneyUpdate(string name, bool isValid, int id)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectAttorneyUpdate", name, isValid, id);
		}
		//Project Staff
		public static DataSet ProjectStaffList()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectStaffList", 1, null);
		}

		public static void ProjectStaffInsert(string name)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectStaffInsert", name);
		}

		public static void ProjectStaffUpdate(string name, bool isActive, int id)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectStaffUpdate", name, isActive, id);
		}
		//Project Type
		public static DataSet ProjectTypeList()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectTypeList", 1);
		}

		public static void ProjectTypeInsert(string projectType)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "projectTypeInsert", projectType);
		}

		public static void ProjectTypeUpdate(string projectType, bool isActive, int projectTypeId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectTypeUpdate", projectType, isActive, projectTypeId);
		}
        public static void ProjectTypeDelete( int projectTypeId)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "ProjectTypeDelete", projectTypeId);
        }
        //Program Type
		public static DataSet ProjectProgramTypeList()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectProgramTypeList", 1);
		}

		public static void ProjectProgramTypeInsert(string programType)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectProgramTypeInsert", programType);
		}

		public static void ProjectProgramTypeUpdate(string programType, bool isActive, int programTypeId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectProgramTypeUpdate", programType, isActive, programTypeId);
		}

		//Assembly Districts
		public static DataSet ProjectAssemblyDistrictList()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectAssemblyDistrictList", 1);
		}
		public static void ProjectAssemblyDistrictInsert(string districtNumber)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "projectAssemblyDistrictInsert", districtNumber);
		}
		public static void ProjectAssemblyDistrictUpdate(string unused, bool isActive, int assemblyDistrictId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "projectAssemblyDistrictUpdate", isActive, assemblyDistrictId);
            //SqlHelper.ExecuteNonQuery(connectionString, "projectAssemblyUpdate", isActive, assemblyId);
		}
		//State Senate Districts
		public static DataSet ProjectStateSenateDistrictList()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectStateSenateDistrictList", 1);
		}
		public static void ProjectStateSenateDistrictInsert(string districtNumber)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "projectStateSenateDistrictInsert", districtNumber);
		}
		public static void ProjectStateSenateDistrictUpdate(string unused, bool isActive, int stateSenateId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "projectStateSenateDistrictUpdate", isActive, stateSenateId);
		}
		//Congressional Districts
		public static DataSet ProjectCongressionalDistrictList()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectCongressionalDistrictList", 1);
		}
		public static void ProjectCongressionalDistrictInsert(string districtNumber)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "projectCongressionalDistrictInsert", districtNumber);
		}
		public static void ProjectCongressionalDistrictUpdate(string unused, bool isActive, int congressionalId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "projectCongressionalDistrictUpdate", isActive, congressionalId);
		}
		//County
        public static DataSet ProjectCounties()
        {
            return SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select CountyId, CountyName from ProjectCounty order by CountyName");
        }
        public static DataSet ProjectCountyList()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectCountyList", 1);
		}
		public static void ProjectCountyInsert(string countyName)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectCountyInsert", countyName);
		}
		public static void ProjectCountyUpdate(string countyName, bool isActive, int countyId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectCountyUpdate", countyName, isActive, countyId);
		}
		public static bool ProjectCountyDupCheck( int countyID, string countyName )
		{
			bool duplicate = false;
			object id = SqlHelper.ExecuteScalar( connectionString, "ProjectCountyDupCheck", countyID, countyName );

			if( ( id != null ) && ( int.Parse( id.ToString() ) > 0 ) )
				duplicate = true;

			return duplicate;
		}
		public static void ProjectCountyDelete( int cityID )
		{
			SqlHelper.ExecuteNonQuery( connectionString, "ProjectCountyDelete", cityID );
		}
		
		//City
        public static DataSet ProjectCities()
        {
            return SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select CityId, CityName from ProjectCity order by CityName");
        }
        public static DataSet ProjectCityList()
		{
			//return SqlHelper.ExecuteDataset(connectionString, "ProjectCityList", 1);
            return SqlHelper.ExecuteDataset(connectionString, CommandType.Text, "select CityId, CountyId, CityName from ProjectCity order by CityName");
		}
		public static void ProjectCityInsert( string cityName )
		{
			SqlHelper.ExecuteNonQuery( connectionString, "ProjectCityInsert", cityName );
		}
		public static void ProjectCityUpdate(string cityName, bool isActive, int cityId )
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectCityUpdate", cityName, isActive, cityId );
		}
		public static void ProjectCityInsertEx( string cityName, int countyID )
		{
			SqlHelper.ExecuteNonQuery( connectionString, "ProjectCityInsertEx", cityName, countyID );
		}
		public static void ProjectCityUpdateEx(string cityName, bool isActive, int cityId, int countyID )
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectCityUpdateEx", cityName, isActive, cityId, countyID );
		}
		public static void ProjectCityDelete( int cityID )
		{
			SqlHelper.ExecuteNonQuery( connectionString, "ProjectCityDelete", cityID );
		}
		public static bool ProjectCityDupCheck( int cityID, string cityName )
		{
			bool duplicate = false;
			object id = SqlHelper.ExecuteScalar( connectionString, "ProjectCityDupCheck", cityID, cityName );

			if( ( id != null ) && ( int.Parse( id.ToString() ) > 0 ) )
				duplicate = true;

			return duplicate;
		}
		
		//Region
		public static DataSet ProjectRegionList()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectRegionList", 1);
		}

        public static DataSet ProjectRegionSelect()
        {
            string sql = "select RegionId, Region, IsActive, RegionalManagerId, convert(bit, 0) as DirtyFlag from ProjectRegion order by Region";
            return SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
        }
       
        public static void ProjectRegionInsert(string region)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectRegionInsert", region);
		}

		public static void ProjectRegionUpdate(string region, bool isActive, int regionId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectRegionUpdate", region, isActive, regionId);
		}

        public static void ProjectRegionSave(int RegionId, string Region, bool IsActive, int RegionalManagerId)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "ProjectRegionSave", RegionId, Region, IsActive, RegionalManagerId);
        }

        //Project Contract Managers
        public static DataSet ProjectContractsManagerSelect(int projectId)
        {
            DataSet ds = null; 
            try
            {
                return ds = SqlHelper.ExecuteDataset(connectionString, "ProjectContractsManagerSelect", projectId);
            }
            catch (Exception ex)
            {
                throw ex;
            }            
        }

        public static void ProjectContractsManagerUpdate( int proejctManagerId, string contractList)
        {
            try
            {
                SqlHelper.ExecuteNonQuery(connectionString, "ProjectContractsManagerUpdate", proejctManagerId, contractList);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        //Project Status
        public static void ProjectStatusUpdate(string status, bool isActive, int StatusId)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "ProjectStatusUpdate", status, StatusId);
        }

        public static void ProjectStatusInsert(string status)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "ProjectStatusInsert", status);
        }

        
        public static bool ProjectRegionDupCheck(int regionID, string regionName)
		{
			bool duplicate = false;
			object id = SqlHelper.ExecuteScalar( connectionString, "ProjectRegionDupCheck", regionID, regionName );

			if( ( id != null ) && ( int.Parse( id.ToString() ) > 0 ) )
				duplicate = true;

			return duplicate;
		}
		public static void ProjectRegionDelete( int RegionId )
		{
            SqlHelper.ExecuteNonQuery(connectionString, "ProjectRegionDelete", RegionId);
		}

		//Watershed - MAR - 2005-02-18 - added
		public static DataSet ProjectWatershedList()
		{
			return SqlHelper.ExecuteDataset(connectionString, "ProjectWatershedList", 1);
		}
		public static void ProjectWatershedInsert(string watershed)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectWatershedInsert", watershed, userid);
		}
		public static void ProjectWatershedUpdate(string watershed, bool isActive, int watershedId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectWatershedUpdate", watershed, isActive, watershedId, userid);
		}
        public static void ProjectWatershedDelete(int watershedId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectWatershedDelete", watershedId);
		}

		#endregion

		//Search
		public static DataSet ProjectSearch(string sql)
		{
			return SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
		}


		//Locks project if it is not currently locked
		public static bool ProjectIsLocked(int projectId)
		{
			return (bool)SqlHelper.ExecuteScalar(connectionString, "ProjectLock", projectId);
		}

		public static void UnlockProject(int projectId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectUnlock", projectId);
		}
		public static bool ProjectFileNumberIsUnuique(string fileNumber, int projectId)
		{
			return (bool)SqlHelper.ExecuteScalar(connectionString, "ProjectFileNumberIsUnique", fileNumber, projectId);
		}

		// ADS 4-Dec-2007 - 2.10 - New query method
		public static int GetProjectIDByFileNumber( string fileNumber )
		{
			int projectID = 0;
			object result = SqlHelper.ExecuteScalar(connectionString, "ProjectByFileNumber", fileNumber );

			if( result != null )
				projectID = (int)result;

			return projectID;
		}

		// ADS 10-Dec-2007 - 2.3.1 - New query for project number
		public static int GetNextProjectNumber()
		{
			int projectNumber = 0;
			object result = SqlHelper.ExecuteScalar(connectionString, "GetNextProjectNumber" );

			if( result != null )
				projectNumber = (int)result;

			return projectNumber;
		}

		// MAR 2005-02-04
		public static string GetDistrictText(int projectId, string districtType)
		{
			// this method is used on the 'One Page Report' module to fetch concatenated, comma-delimited list
			// of districts
			string retVal = "";
			string sql = "";
			int num = 0;
			if (districtType == "AssemblyDistrict")
            {
                sql = "select AssemblyDistrictNumber as AssemblyDistrict " +
                  "from Project_AssemblyDistrict " +
                  "left join ProjectAssemblyDistrict on ProjectAssemblyDistrict.AssemblyDistrictId = Project_AssemblyDistrict.AssemblyDistrictId " +
                  "where ProjectID = " + projectId.ToString() + 
                  " order by AssemblyDistrictNumber";
            }
			else if(districtType == "StateSenateDistrict") 
			{
                sql = "select StateSenateDistrictNumber " +
                    "from Project_SenateDistrict " +
                    "left join ProjectStateSenateDistrict on Project_SenateDistrict.SenateDistrictId = ProjectStateSenateDistrict.StateSenateDistrictId " +
                    "where ProjectID ="  + projectId.ToString() +
                    " order by StateSenateDistrictNumber";
            }
			else if(districtType == "CongressionalDistrict") 
			{
                sql = "select CongressionalDistrictNumber " +
                    "from Project_CongressionalDistrict " +
                    "left join ProjectCongressionalDistrict on ProjectCongressionalDistrict.CongressionalDistrictId = Project_CongressionalDistrict.CongressionalDistrictId " +
                    "where ProjectID = " + projectId.ToString() +
                    " order by CongressionalDistrictNumber";
            }
			try 
			{
				SqlDataReader dr = SqlHelper.ExecuteReader(connectionString, CommandType.Text, sql);
				if (dr.HasRows)
				{
					while (dr.Read())
					{
						if(retVal.Length>0)
						{
							retVal = retVal + ", ";
						}
						num = dr.GetInt32(0);
                        retVal = retVal + num.ToString();
					}
				}
			}
			catch
			{
                retVal = " ";
				//retVal = "Error fetching districts";
			}
			return retVal;
		}

        public static bool ProjectHasContracts(int ProjectId)
        {
            bool retVal = false;
            string sql = "select top 1 1 from ContractDetails where ProjectId = " + ProjectId;
            retVal = GlobalCode.ToBoolean(SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql));
            return retVal;
        }

        public static bool ProjectIsValid(int ProjectId)
        {
            bool retVal = false;
            string sql = "select 1 from Project where ProjectId = " + ProjectId;
            retVal = GlobalCode.ToBoolean(SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql));
            return retVal;
        }

		public static void ProjectDelete(int projectId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ProjectDelete", projectId);
		}

		public static string ProjectUnlockAll()
		{
			string msg="success";
			int retVal = 0;
			try
			{
				retVal = SqlHelper.ExecuteNonQuery(connectionString,"ProjectUnlockAll");	
			}
			catch
			{
				//throw ex;
				msg="There was a problem unlocking all projects.";
			}
			return msg;
		}

        public static DataSet ProjectContacts(int ProjectId)
        {
            string sql = "select Contact.ContactID, ContactLName + ',  ' + ContactFName as Full_Name" +
                    ", ContactJobTitle as Job_Title, Organization.Organization" +
                    ", oa.Address + ' ' + oa.City + ' ' + oa.State + ' ' + oa.Zip as Address" +
                    ", ContactPhone as Phone, ContactExtension as Extension, ContactCellPhone as Cell_Phone, ContactFax as Fax, ContactEmail as Email " +
                    "from Contact_Project " +
                    "left join Contact ON Contact.ContactId = Contact_Project.ContactId " +
                    "left join Organization ON Contact.OrgId = Organization.OrgId " +
                    "left outer join OrgAddress oa ON Contact.OrgAddressId = oa.OrgAddressId " +
                    "where Contact_Project.ProjectId = " + ProjectId + " " +
                    "order by ContactLName, ContactFName "; 
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }


        public static DataSet ProjectOrganizations(int ProjectId, int projectRoleId)
        {
            string sql = "SELECT Organization.OrgID" +
                    ", Organization.Organization " +
                    ", TaxID, isnull(SBE, 0) as SBE, isnull(DVBE, 0) as DVBE, CertificationNumber " +
                    "FROM Organization " +
                    "join Org_ProjectRole on Org_ProjectRole.OrgId = Organization.OrgId " +
                    "where (ProjectId = " + ProjectId.ToString() + " and Org_ProjectRole.ProjectRoleId = " + projectRoleId + ") " +
                    "ORDER BY Organization.Organization";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet OrganizationProjects(int OrgId)
        {
            string sql = "SELECT ProjectId, FileNumber, Description " +
                    "FROM Project " +
                    "where ProjectId in (select ProjectId from Org_ProjectRole where OrgId = " + OrgId + ") " +
                    "    or ProjectId in (select ProjectId from MatchingFund where OrgId = " + OrgId + ") " +
                    "ORDER BY FileNumber";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }



        public static DataSet ContactProjects(int ContactId)
        {
            string sql = "SELECT ProjectId, FileNumber, Description " +
                    "FROM Project " +
                    "where ProjectId in (select ProjectId from Contact_Project where ContactId = " + ContactId + ") " +
                    "ORDER BY FileNumber";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetDynamicDropDown(string ctlName)
        {
            string sql = " SELECT M.LabelName, D.Id, D.Code,D.DisplayName"
                 + " FROM DynamicDropdownMaster M, DynamicDropdownDetail D "
                 + " WHERE M.DropdownId=D.Id AND M.ProjectTableColumnName='" + ctlName + "'"
                 + " ORDER BY D.DisplayName ASC";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataTable GetDynamicMultiSelect(string tableName)
        {
            string sql = " SELECT M.LabelName, D.Id, D.Code,D.DisplayName"
                 + " FROM DynamicMultiSelectMaster M, DynamicMultiSelectDetail D "
                 + " WHERE M.MultiSelectId=D.Id AND M.TableName='" + tableName + "'"
                 + " ORDER BY D.DisplayName ASC";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds.Tables[0];
        }

        public static DataSet GetDDLMaster()
        {
            string sql = " SELECT M.DropdownId, 0 AS DirtyFlag, M.ProjectTableColumnName, M.Location, M.LabelName "
                 + " FROM DynamicDropdownMaster M "
                 + " ORDER BY M.LabelName ASC";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetDMSMaster()
        {
            string sql = " SELECT M.MultiSelectId, 0 AS DirtyFlag, M.TableName, M.Location, M.LabelName "
                 + " FROM DynamicMultiSelectMaster M "
                 + " ORDER BY M.LabelName ASC";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetDDLDetail(int ctlDDLId)
        {
            string sql =   " SELECT D.Id, 0 AS DirtyFlag, D.Code,D.DisplayName,"
                         + " (SELECT count(*) FROM project P1 WHERE P1.DynamicDD1 IS NOT NULL AND P1.DynamicDD1 <> '' AND D.Code = P1.DynamicDD1) AS IsDynamicDD1, "
                         + " (SELECT count(*) FROM project P2 WHERE P2.DynamicDD2 IS NOT NULL AND P2.DynamicDD2 <> '' AND D.Code = P2.DynamicDD2) AS IsDynamicDD2 "
                 + " FROM DynamicDropdownDetail D "
                 + " WHERE D.ID = " + ctlDDLId + ""
                 + " ORDER BY D.Code ASC";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static DataSet GetDMSDetail(int ctlDMSId)
        {
            string sql = " SELECT D.Id, 0 AS DirtyFlag, D.Code,D.DisplayName"
                 + " FROM DynamicMultiSelectDetail D "
                 + " WHERE D.ID = " + ctlDMSId + ""
                 + " ORDER BY D.Code ASC";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static string MasterDDLUpdate(
             int DropdownId
            , string LabelName)
        {
            // Update Master Dropdown record
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "MasterDropdownUpdate",
                     DropdownId
                     , LabelName);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the Dropdown record.";
            }
            return msg;
        }

        public static string MasterDMSUpdate(
             int MultiSelectId
            , string LabelName)
        {
            // Update Master MultiSelect record
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "MasterMultiSelectUpdate",
                     MultiSelectId
                     , LabelName);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the MultiSelect record.";
            }
            return msg;
        }

        public static int DetailDDLInsert(
             int ID
            , string Code
            , string DisplayName
            )
        {
            // Insert DDL Detail record
            int retVal = 0;
            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, "DetailDDLInsert",
                     ID
                    , Code
                    , DisplayName
                    );

                retVal = (id.ToString() == string.Empty) ? 0 : int.Parse(id.ToString());
            }
            catch
            {
                //throw ex;
                retVal = -1;
            }
            return retVal;
        }

        public static int DetailDMSInsert(
             int ID
            , string Code
            , string DisplayName
            )
        {
            // Insert DMS Detail record
            int retVal = 0;
            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, "DetailDMSInsert",
                     ID
                    , Code
                    , DisplayName
                    );

                retVal = (id.ToString() == string.Empty) ? 0 : int.Parse(id.ToString());
            }
            catch
            {
                //throw ex;
                retVal = -1;
            }
            return retVal;
        }

        public static string DetailDDLUpdate(
                 int DropdownId
                , string Code
                , string DisplayName)
        {
            // Update Detail Dropdown entry
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "DetailDDLUpdate",
                       DropdownId
                     , Code
                     , DisplayName);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the Dropdown entry.";
            }
            return msg;
        }

        public static string DetailDMSUpdate(
                 int MultiSelectId
                , string Code
                , string DisplayName)
        {
            // Update Detail MultiSelect entry
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "DetailDMSUpdate",
                       MultiSelectId
                     , Code
                     , DisplayName);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the MultiSelect entry.";
            }
            return msg;
        }

        public static string MasterDDLDelete( int DropdownId, string ControlName)
        {
            // Delete Detail Dropdown entry
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "MasterDDLDelete", DropdownId, ControlName);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem deleting the Dropdown entry.";
            }
            return msg;
        }

        public static string MasterDMSDelete(int MultiSelectId, string ControlName)
        {
            // Delete Detail MultiSelect entry
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "MasterDMSDelete", MultiSelectId, ControlName);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem deleting the MultiSelect entry.";
            }
            return msg;
        }

        public static string DetailDDLDelete(
                 int DropdownId
                , string Code
                , string ControlName)
        {
            // Delete Detail Dropdown entry
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "DetailDDLDelete",
                       DropdownId
                     , Code
                     , ControlName);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem deleting the Dropdown entry.";
            }
            return msg;
        }

        public static string DetailDMSDelete(
                 int MultiSelectId
                , string Code
                , string ControlName)
        {
            // Delete Detail MultiSelect entry
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "DetailDMSDelete",
                       MultiSelectId
                     , Code
                     , ControlName);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem deleting the MultiSelect entry.";
            }
            return msg;
        }

        public static DataSet GetAllAgency()
        {
            DataSet ds = new DataSet();
            ds = SqlHelper.ExecuteDataset(connectionString, CommandType.StoredProcedure, "AgencyGetALL");
            ds.Tables[0].TableName = "Agency";
            return ds;        
        }
		public static int AgencyDelete(int AgencyId)
		{
			return (int)SqlHelper.ExecuteNonQuery(connectionString, "AgencyDelete", AgencyId);		
        }

        public static int AgencySave(int agencyId, string agencyname, string address, string city, string state, string zip, string phone, string fax, string webaddress, bool isactive )
        {
            return (int)SqlHelper.ExecuteScalar(connectionString, "AgencyUpdate", agencyname, address, city, state, zip, phone, fax, webaddress,isactive,agencyId);
        }
    
        public static DataSet GetAllAlertEmails()
        {
            DataSet ds = new DataSet();
            ds = SqlHelper.ExecuteDataset(connectionString, CommandType.StoredProcedure, "AlertEmailGetALL");
            ds.Tables[0].TableName = "AlertEmails";
            return ds;        
        }
		public static int AlertEmailDelete(int AlertEmailId)
		{
			return (int)SqlHelper.ExecuteNonQuery(connectionString, "AlertEmailDelete", AlertEmailId);		
        }

        public static int AlertEmailSave(int alertId, string alerttype, string profilename, string recipients, string emailsubject, string emailtext, bool isactive)
        {
            return (int)SqlHelper.ExecuteScalar(connectionString, "AlertEmailUpdate", alerttype, profilename, recipients, emailsubject, emailtext, isactive,alertId);
        }

        public static DataSet OrgRolesSelect()
        {
            return SqlHelper.ExecuteDataset(connectionString, "OrgRolesSelect");

            string sql = "select ProjectRoleId, ProjectRole, IsActive from ProjectRole order by ProjectRole";
            return SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
        }

        public static void OrgRolesInsert(string ProjectRole)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "OrgRolesInsert", ProjectRole);
        }

        public static void OrgRolesUpdate(string ProjectRole, bool IsActive, int ProjectRoleId)
        {
            SqlHelper.ExecuteNonQuery(connectionString, "OrgRolesUpdate", ProjectRole, IsActive, ProjectRoleId);
        }

    }


	public class IntegerList : System.Collections.CollectionBase
	{
		public object this[int index]
		{
			get{return List[index];}
			set{List[index] = value;}
		}

		public IntegerList(params int[] list)
		{
			foreach(int i in list)
			{
				this.Add(i);
			}
		}

		public void Add(int _int)
		{
			List.Add(_int);
		}
	}
}
