using System;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Data
{
	/// <summary>
	/// Summary description for ProjectFundingData.
	/// </summary>
	public class ProjectFundingData
	{
		static string userid = GlobalSettings.userid;

        private static string connectionString
        {
            get { return GlobalSettings.ConnectionString; }
        }

        static ProjectFundingData()
		{
		}

        public static string GetFundingItem(int FundId)
        {
            if (FundId == 0)
                return string.Empty;
            string sql = "SELECT dbo.usfFundingItem2(" + FundId + ") AS Funding_Item";
            return GlobalCode.ToString(SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql));
        }

        public static DataSet GetProjectAuthorizations(int projectId)
		{
            string sql =
             "SELECT ad.AuthorizationId, t.AuthorizationTypeId, ad.AuthorizationDate, " +
                    "ad.AmountAuthorized, ad.CreatedBy, 0 AS DirtyFlag, ad.Notes " +
              "FROM   AuthorizationDetail ad " +
                " LEFT OUTER JOIN AuthorizationType t ON ad.AuthorizationTypeId = t.AuthorizationTypeId " +
                " LEFT OUTER JOIN ReservEncumb re ON ad.AuthorizationId = re.AuthorizationId " +
                " WHERE ProjectId = " + projectId.ToString() +
             " GROUP BY ad.AuthorizationId, t.AuthorizationTypeId, ad.AuthorizationDate, ad.AmountAuthorized, ad.CreatedBy, ad.notes " +
             " ORDER BY ad.AuthorizationDate";

			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}

        public static DataTable GetFundingSourceAuthorizations(int projectId, int fundId)
        {
            string sql =
                    " SELECT ad.AuthorizationId, t.AuthorizationTypeId, t.AuthorizationType, ad.AuthorizationDate " +
                    ", re.Amount,  0.00 AS SubstitutedAmount,ad.CreatedBy, 0 AS DirtyFlag " +
                    ", re.ReservEncumbID, re.ReserveDate, IsNull(re.GrantAmount,'0') as GrantAmount, IsNull(re.ReimbTypeId,'0') As ReimbTypeId, IsNull(re.GrantSource,'0') As GrantSource " + 
                    " FROM   AuthorizationDetail ad " + 
                    " LEFT OUTER JOIN AuthorizationType t ON ad.AuthorizationTypeId = t.AuthorizationTypeId " + 
                    " LEFT OUTER JOIN ReservEncumb re ON ad.AuthorizationId = re.AuthorizationId " +
                    " WHERE re.FundId =  " + fundId.ToString()  +
                    " AND ad.projectid = " + projectId.ToString() +
                    " ORDER BY ad.AuthorizationDate";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }

            DataTable returnTable = ds.Tables[0];
            returnTable.TableName = projectId.ToString() + fundId.ToString();
            ds.Tables.Remove(returnTable);
            return returnTable;
        }

        public static decimal GetAuthReservationTotal(int AuthorizationId)
        {
            decimal retVal = 0;
            string sql = "select sum(Amount) from ReservEncumb where AuthorizationId = " + AuthorizationId;
            try
            {
                object amt = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);
                retVal = GlobalCode.ToDecimal(amt);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return retVal;

        }

        public static DataSet GetAuthReservations(int AuthorizationId, int pid)
		{
			// Format SQL string
			string sql = 
                "SELECT ReservEncumbID"+
				    " , ReservEncumb.AuthorizationID"+  
                  	" , dbo.usfFundingItem2(FundingSource.FundID) AS FundingItem" + 
				    " , FundingSource.Source" + 
				    " , FiscalYear.Years" +
                    " , ReservEncumb.ReserveDate" +
                    " , FundingSource.EncumbExpDate" +
                    " , FundingSource.LiquidDate" +
                    " , ReservEncumb.Amount" +
                    " , (case when ReservEncumb.ReimbTypeId = 0 then null else ReservEncumb.ReimbTypeId end) as ReimbTypeId" +			    
                    " , ReservEncumb.GrantSource" +
                    " , IsNull(ReservEncumb.GrantAmount,'0') as GrantAmount" +
				    " , FundingSource.FundID" + 
				    " , 0 AS DirtyFlag " +
                    " , (select count(*) from ContractFunds cf left join contractdetails cd on cd.contractid = cf.contractid  where FundingSource.FundId = cf.FundId and cd.projectid = " + pid + ") as ContractCount " +                  
                "FROM  FundingSource " +
                 "INNER JOIN FiscalYear ON FundingSource.FiscalYearID = FiscalYear.FiscalYearID  " +
                 "INNER JOIN ReservEncumb ON FundingSource.FundID = ReservEncumb.FundID " +
                "WHERE ReservEncumb.AuthorizationId = " + AuthorizationId + " " +
                "ORDER BY ReservEncumbID";


			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}

        public static decimal GetProjectFundAmount(int ProjectId, int FundID, int AuthorizationId)
        {
            //other reserved amounts for project, same fund, other authorization
            string sql = "select sum(Amount) " + 
                "from ReservEncumb " +
                "left join AuthorizationDetail on AuthorizationDetail.AuthorizationId = ReservEncumb.AuthorizationId " +
                "where AuthorizationDetail.ProjectId = " + ProjectId + " " +
                "and AuthorizationDetail.AuthorizationId <> " + AuthorizationId + " " +
                "and ReservEncumb.FundID = " + FundID;
            return GlobalCode.ToDecimal(SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql));
        }

        public static decimal GetProjectContractFundAmount(int ProjectId, int Fundid)
        {
            string sql = "select sum(ContractedAmount) FROM ContractFunds " +
                "WHERE ContractId in (select ContractId from ContractDetails where ProjectId = " + ProjectId + ") " +
                "AND FundId = " + Fundid;
            return GlobalCode.ToDecimal( SqlHelper.ExecuteScalar(connectionString,CommandType.Text, sql));
        }

        public static decimal GetReserveEncumbAmount(int ReservEncumbId)
        {
            string sql = "select Amount from ReservEncumb where ReservEncumbId = " + ReservEncumbId;
            return GlobalCode.ToDecimal(SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql));
        }

        public static void ReserveEncumbGrantAmountUpdate(int ReservEncumbId, decimal GrantAmount)
        {
            string sql = "update ReservEncumb set GrantAmount = " + GrantAmount + " where ReservEncumbId = " + ReservEncumbId;
            SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }
        
        public static DataSet GetReservations(int ProjectId)
        {
            //formated for grid display
            //string sql =
            //    "SELECT dbo.usfFundingItem2(FundingSource.FundID) AS [Funding Item]" +
            //        " , FundingSource.Source as [Source/Nickname]" +
            //        " , FiscalYear.Years as [FY]" +
            //        " , ReservEncumb.ReserveDate as [Reserve Date]" +
            //        " , FundingSource.EncumbExpDate as [Encumber By]" +
            //        " , FundingSource.LiquidDate as [Spend By]" +
            //        " , ReservEncumb.Amount as [Reserved Amount]" +
            //        " , (select ReimbType from ReimbType where ReimbTypeId = ReservEncumb.ReimbTypeId) as [Reimb/Repayment]" +
            //        " , ReservEncumb.GrantAmount as [Total Amt to be Reimb/Repaid]" +
            //    " FROM  FundingSource " +
            //     "INNER JOIN FiscalYear ON FundingSource.FiscalYearID = FiscalYear.FiscalYearID  " +
            //     "INNER JOIN ReservEncumb ON FundingSource.FundID = ReservEncumb.FundID " +
            //    "WHERE ReservEncumb.AuthorizationId in (select AuthorizationId from AuthorizationDetail where ProjectId = " + ProjectId + ") " +
            //    "ORDER BY ReservEncumbID";

            string sql =
                "SELECT dbo.usfFundingItem2(FundingSource.FundID) AS [Funding Item]" +
                    " , FundingSource.Source as [Source/Nickname]" +
                    " , FiscalYear.Years as [FY]" +
                    " , ReservEncumb.ReserveDate as [Reserve Date]" +
                    " , AuthorizationDetail.AuthorizationDate as [Authorize Date]" +
                    " , FundingSource.EncumbExpDate as [Encumber By]" +
                    " , FundingSource.LiquidDate as [Spend By]" +
                    " , ReservEncumb.Amount as [Reserved Amount]" +
                    " , (select ReimbType from ReimbType where ReimbTypeId = ReservEncumb.ReimbTypeId) as [Reimb/Repayment]" +
                    " , IsNull(ReservEncumb.GrantAmount,'0') as [Total Amt to be Reimb/Repaid]" +
                " FROM  FundingSource " +
                 "INNER JOIN FiscalYear ON FundingSource.FiscalYearID = FiscalYear.FiscalYearID  " +
                 "INNER JOIN ReservEncumb ON FundingSource.FundID = ReservEncumb.FundID " +
                 "INNER JOIN AuthorizationDetail ON ReservEncumb.AuthorizationId = AuthorizationDetail.AuthorizationId " +
                "WHERE AuthorizationDetail.ProjectId = " + ProjectId + " " +
                "ORDER BY ReservEncumbID";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static bool HasContractFund(int ProjectId, int FundId)
        {
            object retVal = null;
            string sql = "select top 1 1 from ContractFunds " +
                "left join ContractDetails on ContractFunds.ContractId = ContractDetails.ContractId " +
                "where ContractFunds.FundId = " + FundId +
                " and ContractDetails.ProjectId = " + ProjectId;
            retVal = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);
            return GlobalCode.ToBoolean(retVal);
        }

        public static DataSet GetAuthGrants(int authorizationID)
		{
			// Format SQL string
			string sql = 
				"SELECT ReservEncumbID"+
				" , AuthorizationID"+                    				    
				" , ReservEncumb.GrantReimburse" +
                " , IsNull(ReservEncumb.GrantAmount,'0') as GrantAmount" +
				" , ReservEncumb.GrantSource" + 
				" ,0 AS DirtyFlag " +
				"FROM  FundingSource " +
				"INNER JOIN FiscalYear ON FundingSource.FiscalYearID = FiscalYear.FiscalYearID  "+
				"INNER JOIN ReservEncumb ON FundingSource.FundID = ReservEncumb.FundID "+
				"WHERE AuthorizationId = " + authorizationID.ToString();

			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}

		public static DataSet GetOrgSelectionList()
		{
			string sql = "SELECT * FROM vwOrgSelectionList";
			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}

        public static DataSet GetOrgList()
        {
            string sql = "SELECT * FROM vwOrgSelectionList Order By Organization ASC";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }


		public static DataSet GetAuthTypeSelectionList()
		{
			// Get list of Strategic Objectives for a project
			string sql = "SELECT * FROM AuthorizationType where IsActive = 1 ";
			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}
		public static bool IsFundingSourceActive(int FundId)
		{
			// Check if Funding Source is Active
			string sql = "SELECT top 1 1 FROM FundingSource where FundId = " + FundId + 
                         " AND IsActive = 1 ";
			object retVal;
            retVal = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);
            return GlobalCode.ToBoolean(retVal);
 		}
        
        public static DataSet GetReimbTypeSelectionList()
        {
            // Get list of Strategic Objectives for a project
            string sql = "SELECT ReimbTypeId, ReimbType FROM ReimbType";
            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }
	
		public static DataSet GetFundSelectionList(bool displayActiveSourceOnly )
		{
			// Get list of Funding Sources for Funding Item dropdown list
            string sql =
             "SELECT FundingSource.FundID " +
                   ", Years=COALESCE(FiscalYear.Years,'')" +
                   ", FundingItem=dbo.usfFundingItem2(dbo.FundingSource.FundID)" +
                   ", FundSource=COALESCE(FundingSource.Source,'')" +
                   ", Description=COALESCE(FundingSource.Description,'')" +
                   ", SubScheduleName=COALESCE(FundingSource.SubScheduleName,'')" +
                   ", EncumbExpDate=COALESCE(FundingSource.EncumbExpDate,'1/1/1901')" +
                   ", LiquidDate=COALESCE(FundingSource.LiquidDate,'1/1/1901')" +
                   ", Source=COALESCE(FundingSource.Source,'')" +
                   ", (case when FundingSource.IsActive = 0 then 'No' else 'Yes' end) as IsActive" +
               " FROM FundingSource INNER JOIN " +
                     "FiscalYear ON FundingSource.FiscalYearID = FiscalYear.FiscalYearID ";

              if (displayActiveSourceOnly)
                   sql += " WHERE FundingSource.IsActive = 1 ";

               sql +=
				     "ORDER BY Years DESC, FundNumber ASC, RefCode ASC, ScheduleNum ASC";

			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}

        public static DataSet GetProjectMatchingFunds(int projectId)
        {
            // Format SQL string
            string sql =
                "SELECT vmf.MatchingFundId, vmf.OrgID, vmf.OrganizationType, vmf.DollarAmount, vmf.ReimbTypeId, vmf.OrgID, " +
                "0 AS DirtyFlag, vmf.ReimbId " +
                "FROM vwMatchingFunds vmf INNER JOIN ReservEncumb re ON vmf.ReimbId = re.ReservEncumbID " +
                "WHERE ProjectID=" + projectId.ToString() +
                " union all " +
                "SELECT vmf.MatchingFundId, vmf.OrgID, vmf.OrganizationType, vmf.DollarAmount, vmf.ReimbTypeId, vmf.OrgID, " +
                "0 AS DirtyFlag, vmf.ReimbId " +
                "FROM vwMatchingFunds vmf LEFT OUTER JOIN ReservEncumb re ON vmf.ReimbId = re.ReservEncumbID " +
                "WHERE (vmf.ReimbId is null or vmf.ReimbId = 0) " +
                "and ProjectId = " + projectId.ToString() +
                " ORDER BY ReimbId";

            DataSet ds = null;
            try
            {
                ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return ds;
        }

        public static string MatchingFundUpdate(
			 int MatchingFundId
			,int ProjectId
			,int OrgID
			,decimal DollarAmount
            ,object ReimbTypeId
            ,int ReimbId)
		{	
			// Update MatchingFund record
			string msg="success";
			int retVal = 0;
			try
			{
				retVal = SqlHelper.ExecuteNonQuery(connectionString,"MatchingFundUpdate",
					MatchingFundId
					,ProjectId
					,OrgID
					,DollarAmount
					,userid
                    ,ReimbTypeId
                    ,ReimbId);					 
			}
			catch
			{
				//throw ex;
				msg="There was a problem updating the MatchingFund record.";
			}
			return msg;
		}

		public static int MatchingFundInsert(
			 int ProjectId
			,int OrgID
			,decimal DollarAmount
            ,object ReimbTypeId
            ,int ReimbId            
           )
		{	
			// Insert MatchingFund record
			int retVal = 0;
			try
			{
				object id = SqlHelper.ExecuteScalar(connectionString,"MatchingFundInsert",
					 ProjectId
					,OrgID
					,DollarAmount
					,userid
                    ,ReimbTypeId                    
                    ,ReimbId
                    );				
	 
				retVal = int.Parse(id.ToString());
			}
			catch 
			{
				//throw ex;
				retVal = -1;
			}
			return retVal;
		}

		public static string MatchingFundDelete(int MatchingFundId)			
		{	
			// Delete MatchingFund record
			string msg="success";
			int retVal = 0;
			try
			{
				retVal = SqlHelper.ExecuteNonQuery(connectionString,"MatchingFundDelete",MatchingFundId);					 
			}
			catch
			{
				//throw ex;
				msg="There was a problem deleting the MatchingFund record.";
			}
			return msg;
		}

        public static string MatchingFundDeleteByReimbId(int ReimbId)
        {
            // Delete MatchingFund record
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "MatchingFundDeleteByReimbId", ReimbId);
            }
            catch
            {
                //throw ex;
                msg = "There was a problem deleting the MatchingFund record by ReimbId.";
            }
            return msg;
        }
		public static string AuthorizationUpdate(
			 int AuthorizationId
			,int ProjectId
			,int AuthorizationTypeId
			,DateTime AuthorizationDate
            ,string Notes
            ,decimal AmountAuthorized) 
		{	
			// Update AuthorizationDetail record
			string msg="success";
			int retVal = 0;
			try
			{
                retVal = SqlHelper.ExecuteNonQuery(connectionString, "AuthorizationDetailUpdate",
                     AuthorizationId
                    , ProjectId
                    , AuthorizationTypeId
                    , AuthorizationDate
                    , AmountAuthorized
                    , Notes
					, userid);					 
			}
			catch
			{
				//throw ex;
				msg="There was a problem updating the Authorization record.";
			}
			return msg;
		}

		public static int AuthorizationInsert(
			 int ProjectId
			,int AuthorizationTypeId
			,DateTime AuthorizationDate
            ,decimal AmountAuthorized
            ,string Notes)
		{	
			// Insert AuthorizationDetail record
			int retVal = 0;
			try
			{
                object id = SqlHelper.ExecuteScalar(connectionString, "AuthorizationDetailInsert",
                     ProjectId
                    , AuthorizationTypeId
                    , AuthorizationDate
                    , AmountAuthorized
                    , Notes
					, userid);				
	 
				retVal = int.Parse(id.ToString());
			}
			catch 
			{
				//throw ex;
				retVal = -1;
			}
			return retVal;
		}

		public static string AuthorizationDelete(int AuthorizationId)			
		{	
			// Delete AuthorizationDetail record
			string msg="success";
			int retVal = 0;
			try
			{
				retVal = SqlHelper.ExecuteNonQuery(connectionString,"AuthorizationDetailDelete",AuthorizationId);					 
			}
			catch
			{
				msg="There was a problem deleting the Authorization record.";
			}
			return msg;
		}

		public static int ReservEncumbInsert(
			 int FundID
			,int AuthorizationId
			,DateTime ReserveDate
			,decimal Amount
            ,decimal GrantAmount
            ,object ReimbTypeId 
            ,string GrantSource
            )
		{	
			// Insert ReservEncumb record
			int retVal = 0;
			try
			{
				object id = SqlHelper.ExecuteScalar(connectionString,"ReservEncumbInsert",
					 FundID
					,AuthorizationId
					,ReserveDate
					,Amount
                    ,userid
                    ,GrantAmount
                    ,ReimbTypeId
                    ,GrantSource
					);				
	 
				retVal = int.Parse(id.ToString());
			}
			catch 
			{
				//throw ex;
				retVal = -1;
			}
			return retVal;
		}

        public static string ReservEncumbInsert(
             SqlTransaction transaction
            , int FundID
            , int AuthorizationId
            , DateTime ReserveDate
            , decimal Amount
            , decimal GrantAmount
            , object ReimbTypeId
            , string GrantSource
            )
        {
            // Insert ReservEncumb record
            string retVal = "success";
            try
            {
                object id = SqlHelper.ExecuteScalar(transaction, "ReservEncumbInsert",
                     FundID
                    , AuthorizationId
                    , ReserveDate
                    , Amount
                    , userid
                    , GrantAmount
                    , ReimbTypeId
                    , GrantSource
                    );

             
            }
            catch (Exception ex)
            {
                //throw ex;
                retVal = "ReservEncumbInsert: Error Inserting into Reserve Encumb";
            }
            return retVal;
        }

		public static string ReservEncumbUpdate(
		     int ReservEncumbID
			,int FundID
			,int AuthorizationId
			,DateTime ReserveDate
			,decimal Amount
            ,decimal GrantAmount
            ,object ReimbTypeId
            ,string GrantSource
           ) 
		{	
			// Update ReservEncumb record
			string msg="success";
			int retVal = 0;
			try
			{
				retVal = SqlHelper.ExecuteNonQuery(connectionString,"ReservEncumbUpdate",
					 ReservEncumbID
					,FundID 
					,AuthorizationId
					,ReserveDate
					,Amount
                    ,userid
                    ,GrantAmount
                    ,ReimbTypeId
                    ,GrantSource
					);					 
			}
			catch
			{
				//throw ex;
				msg="There was a problem updating the ReserveEncumb record.";
			}
			return msg;
		}

        public static string ReservEncumbUpdate(
              SqlTransaction transaction
            , int ReservEncumbID
            , int FundID
            , int AuthorizationId
            , DateTime ReserveDate
            , decimal Amount
            , decimal GrantAmount
            , object ReimbTypeId
            , string GrantSource
           )
        {
            // Update ReservEncumb record
            string msg = "success";
            int retVal = 0;
            try
            {
                retVal = SqlHelper.ExecuteNonQuery(transaction, "ReservEncumbUpdate",
                     ReservEncumbID
                    , FundID
                    , AuthorizationId
                    , ReserveDate
                    , Amount
                    , userid
                    , GrantAmount
                    , ReimbTypeId
                    , GrantSource
                    );
            }
            catch
            {
                //throw ex;
                msg = "There was a problem updating the ReserveEncumb record.";
            }
            return msg;
        }

		public static string ReservEncumbDelete(int ReservEncumbID)			
		{	
			// Delete ReservEncumb record
			string msg="success";
			int retVal = 0;
			try
			{
				retVal = SqlHelper.ExecuteNonQuery(connectionString,"ReservEncumbDelete",ReservEncumbID);					 
			}
			catch
			{
				msg="There was a problem deleting the ReservEncumb record.";
			}
			return msg;
		}

        public static decimal GetProjectTotal(int ProjectId, string Option)
        {
            // fundType: A - Authorized,  M - MatchingFunds, P - ProjectTotal
            decimal retVal = 0;
            string sql = "select dbo.usfProjectTotals(" + ProjectId + ", '" + Option + "')";
            try
            {
                object id = SqlHelper.ExecuteScalar(connectionString, CommandType.Text, sql);

                retVal = decimal.Parse(id.ToString());
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return retVal;
        }

        public static decimal GetFundTotal(int ProjectId, string fundType)
		{	
			// fundType: A - Authorized,  M - MatchingFunds, P - ProjectTotal
			decimal retVal = 0;
            string sql = "select dbo.usfProjectTotals(" + ProjectId + ", '" + fundType + "')";
			try
			{
				object id = SqlHelper.ExecuteScalar(connectionString,CommandType.Text, sql);				
	 
				retVal = decimal.Parse(id.ToString());
			}
			catch (Exception ex)
			{
				throw ex;
			}
			return retVal;
		}
		public static decimal GetAuthorizationTotal(int AuthorizationId)
		{	
			decimal retVal = 0;
			try
			{
				object id = SqlHelper.ExecuteScalar(connectionString,"GetAuthorizationTotal",AuthorizationId);				
	 
				retVal = decimal.Parse(id.ToString());
			}
			catch (Exception ex)
			{
				throw ex;
			}
			return retVal;
		}

	}
}
