using System;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Data
{
	/// <summary>
	/// Summary description for ProjectObjectiveData.
	/// </summary>
	public class ProjectObjectiveData
	{
		static string userid = GlobalSettings.userid;

        private static string connectionString
        {
            get { return GlobalSettings.ConnectionString; }
        }

        static ProjectObjectiveData()
		{
		}

        public static DataSet GetProjectObjectives(int projectId)
		{
			// Format SQL string
			string sql = 
				"SELECT ppo.RecordID, po.Objective,  ppo.NumberOfUnits, po.UnitOfMeasurement, " +
                    "0 AS DirtyFlag, ppo.ObjectiveID " + 
				"FROM Project_ProjectObjective ppo " +
                "INNER JOIN vwProjectObjectiveSelectionList po " +
					"ON ppo.ObjectiveID = po.ObjectiveID " +
				"WHERE ProjectID = " + projectId.ToString() + " " +
				"ORDER BY po.SortOrder";

            //change to text and not id
            //string sql =
            //    "SELECT ppo.RecordID, ppo.ObjectiveID,  ppo.NumberOfUnits, po.UnitOfMeasurement, " +
            //        "0 AS DirtyFlag " +
            //    "FROM dbo.Project_ProjectObjective ppo INNER JOIN dbo.ProjectObjective po " +
            //        "ON ppo.ObjectiveID = po.ObjectiveID " +
            //    "WHERE ProjectID=" + projectId.ToString() + " " +
            //    "ORDER BY po.SortOrder";
            
            //        string sql = "SELECT ObjectiveID, Objective, UnitOfMeasurement, SortOrder " +
        //"FROM vwProjectObjectiveSelectionList " +
        //(IsActive ? " where IsActive = 1 " : "") +
        //" order by SortOrder";
//SELECT     TOP (100) PERCENT ObjectiveID, CAST(ObjectiveNumber + ': ' + ObjectiveShortName AS varchar(80)) AS Objective, UnitOfMeasurement, SortOrder, IsActive, 
//            PlanYear
//FROM         dbo.ProjectObjective



			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}
		public static DataSet GetListProjectObjective(int projectId)
		{
			// Get list of Strategic Objectives for a project
			string sql = "SELECT * FROM vwProject_ProjectObjective WHERE ProjectID=" + projectId.ToString(); 
			DataSet ds = null;
            try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
            }
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}
		public static DataSet GetProjectObjectiveDetail(int RecordID)
		{
			// Get list of Strategic Objectives for a project
			string sql = "SELECT * FROM Project_ProjectObjective WHERE RecordID = " + RecordID.ToString();
			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}

		public static DataSet GetObjectiveSelectionList(bool IsActive)
		{
			// Get list of Strategic Objectives for a project
            string sql = "SELECT ObjectiveID, Objective, UnitOfMeasurement, SortOrder " +
                "FROM vwProjectObjectiveSelectionList " +
                (IsActive ? " where IsActive = 1 " : "") +
                " order by SortOrder";
			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}
		public static DataSet GetObjectiveSearchSelectionList()
		{
			// Get list of Strategic Objectives for a project
			string sql = "SELECT ObjectiveID, CAST(ObjectiveNumber + ': ' + ObjectiveShortName + '  (' + UnitOfMeasurement + ') ' AS varchar(80)) AS Objective "+
                 "FROM ProjectObjective ORDER BY SortOrder";
			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}

		public static DataSet GetObjectives()
		{
			// Get all the objectives
			string sql = 
				"SELECT ObjectiveID, ObjectiveLongName, ObjectiveShortName, ObjectiveNumber, " + 
					"UnitOfMeasurement, Target, SortOrder, PlanYear, IsActive, 0 AS DirtyFlag " +
				"FROM ProjectObjective " +
				"ORDER BY SortOrder";
			DataSet ds = null;
			try
			{
				ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text , sql);
			}
			catch(Exception ex)
			{
				throw ex;
			}
			return ds;
		}
		public static string ObjectiveUpdate(
			int ObjectiveID
			,string ObjectiveLongName
			,string ObjectiveShortName
			,string ObjectiveNumber
			,string UnitOfMeasurement
			,int Target
			,int SortOrder
			,int IsActive
            ,string PlanYear)
		{	
			// Update Objective record
			string msg="success";
			int retVal = 0;
			try
			{
				retVal = SqlHelper.ExecuteNonQuery(connectionString,"ProjectObjectiveUpdate",
					ObjectiveID
					,ObjectiveLongName
					,ObjectiveShortName
					,ObjectiveNumber
					,UnitOfMeasurement
					,Target
					,SortOrder
					,IsActive
					,userid
                    ,PlanYear);					 
			}
			catch
			{
				//throw ex;
				msg="There was a problem updating the Objective record.";
			}
			return msg;
		}
		public static int ObjectiveInsert(
			string ObjectiveLongName
			,string ObjectiveShortName
			,string ObjectiveNumber
			,string UnitOfMeasurement
			,int Target
			,int SortOrder
			,int IsActive
            ,string PlanYear)
		{	
			// Insert objective record
			int retVal = 0;
			try
			{
				object id = SqlHelper.ExecuteScalar(connectionString,"ProjectObjectiveInsert",
					ObjectiveLongName
					,ObjectiveShortName
					,ObjectiveNumber
					,UnitOfMeasurement
					,Target
					,SortOrder
					,IsActive
					,userid
                    ,PlanYear);					 
				retVal = int.Parse(id.ToString());
			}
			catch (Exception ex)
			{
				throw ex;
			}
			return retVal;
		}
		public static string ObjectiveDelete(int ObjectiveID
			)
		{	
			// Delete objective record
			string msg="success";
			int retVal = 0;
			try
			{
				retVal = SqlHelper.ExecuteNonQuery(connectionString,"ProjectObjectiveDelete",ObjectiveID);					 
			}
			catch
			{
				//throw ex;
				msg="There was a problem deleting the Objective record.";
			}
			return msg;
		}
		public static string GetObjectiveDescription(int ObjectiveID)
		{
			// Get list of Strategic Objectives for a project
			string sql = "SELECT ObjectiveNumber + ': ' + ObjectiveShortName FROM ProjectObjective WHERE ObjectiveID=" + ObjectiveID.ToString();
			string retVal = string.Empty;
			try
			{
				object ObjectiveDescr = SqlHelper.ExecuteScalar(connectionString, CommandType.Text , sql);
				retVal = ObjectiveDescr.ToString();
			}
			catch(Exception ex)
			{
				throw ex;
			}
		    
            return retVal;
		}

		public static string ProjectObjectiveUpdate(
			int RecordID
		   ,int ProjectId
		   ,int ObjectiveID
           ,decimal NumberOfUnits)
		{	
			// Update Project_ProjectObjective record
			int retVal = 0;
			string msg="success";
			try
			{
                 retVal = SqlHelper.ExecuteNonQuery(connectionString,"Project_ProjectObjectiveUpdate",
					 RecordID
				    ,ProjectId
				    ,ObjectiveID
				    ,NumberOfUnits
				    ,userid);					 
			}
			catch
			{
				//throw ex;
				msg="There was a problem updating the Strategic Objective record.";
			}
			return msg;
		}
		public static int ProjectObjectiveInsert(
			 int ProjectId
			,int ObjectiveID
			,decimal NumberOfUnits)
		{	
			// Update Project_ProjectObjective record
			int retVal = 0;
			try
			{
				object id = SqlHelper.ExecuteScalar(connectionString,"Project_ProjectObjectiveInsert",
					ProjectId
					,ObjectiveID
					,NumberOfUnits
					,userid);					 

				retVal = int.Parse(id.ToString());

			}
			catch
			{
				//throw ex;
				//msg="There was a problem adding the Strategic Objective record.";
				retVal = -1;
			}
			return retVal;
		}
		public static string ProjectObjectiveDelete(int RecordID
			)
		{	
			// Update Project_ProjectObjective record
			int retVal = 0;
			string msg="success";
			try
			{
				retVal = SqlHelper.ExecuteNonQuery(connectionString,"Project_ProjectObjectiveDelete",RecordID);					 
			}
			catch
			{
				//throw ex;
				msg="There was a problem deleting the Strategic Objective record.";
			}
			return msg;
		}
		public static string ProjectObjectiveValidate(string mode, string strRecordID, int ProjectID, 
			                                          string strObjectiveID, string strNumberOfUnits)
		{	
			int retVal = 0;
			bool isValid = true;
			string msg="valid";

			// validate number of units
			if (strNumberOfUnits.Trim()=="")
				strNumberOfUnits="0";

			if (!IsDecimal(strNumberOfUnits))
			{
				isValid = false;
				msg = "Number of Units must be a numeric entry.";
			}

			if (!IsDecimal(strObjectiveID))
			{
				isValid = false;
				msg = "You must select an objective.";
			}

			if (isValid)
			{
				// get record ID to check for duplicates
				int RecordID=0;
				if (mode=="EDIT")
					RecordID = Convert.ToInt32(strRecordID);
						
				try
				{
					object id = SqlHelper.ExecuteScalar(connectionString,"Project_ProjectObjectiveDupCheck",
                     RecordID, ProjectID, Convert.ToInt32(strObjectiveID));
					retVal = int.Parse(id.ToString());

					if(retVal!=0)
						msg="The selected objective already exists for the project.";                      					
				}
				catch
				{
					//throw ex;
					msg="An error occurred when checking for duplicate records.";
				}
			}
			return msg;
		}

		public static bool IsDecimal(string theValue)
		{
			try
			{
				Convert.ToDouble(theValue);
				return true;
			} 
			catch 
			{
				return false;
			}
		}

	}
}
