using System;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Data
{
	/// <summary>
	/// Data for images and links
	/// </summary>
	public class ResourceData
	{

        private static string connectionString
        {
            get { return GlobalSettings.ConnectionString; }
        }

        static ResourceData()
		{
    	}

		public static long ImageInsert(int projectId, string name, ref byte[] imageBuffer)
		{
			return (long)SqlHelper.ExecuteNonQuery(connectionString, "ImageInsert", projectId, name, imageBuffer);
		}

		public static DataSet ImageList(int projectId)
		{
			return SqlHelper.ExecuteDataset(connectionString, "ImageList", projectId);
		}
		public static DataSet ImageById(int imageId)
		{
			return SqlHelper.ExecuteDataset(connectionString, "ImageById", imageId);
		}
		public static void ImageCaptionUpdate(int imageId, string caption, string ImageCredit)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ImageCaptionUpdate", imageId, caption, ImageCredit);
		}
		public static void ImageRplace(int imageId, ref byte[] image)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ImageReplace", imageId, image);
		}
		public static void ImageDelte(int imageId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ImageDelete", imageId);
		}
		public static DataSet LinkList(int projectId)
		{
			return SqlHelper.ExecuteDataset(connectionString, "LinkList", projectId);
		}
		public static void LinkInsert(int projectId, string filePath, string description)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "LinkInsert", projectId, filePath, description);
		}
		public static void LinkUpdate(int linkId, string description)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "LinkDescriptionUpdate", linkId, description);
		}
		public static void LinkDelete(int linkId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "LinkDelete", linkId);
		}
		public static void ImageUpdateName(int imageId, string imageName)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "ImageUpdateName", imageId, imageName);
		}


	}
}
