using System;
using Microsoft.ApplicationBlocks.Data;
using System.Data;
using System.Configuration;

namespace CCPM.Data
{
	/// <summary>
	/// Summary description for UserData.
	/// </summary>
	public class UserData
	{
        private static string connectionString
        {
            get { return GlobalSettings.ConnectionString; }
        }

        static UserData()
		{
        }

		public static int InsertUser(string username, string password, int roleId)
		{
			return (int)SqlHelper.ExecuteScalar(connectionString, "UserCreate", username, password, roleId);
		}

        public static int UserSave(int UserId, string UserName, string Password, bool IsActive)
        {
            return (int)SqlHelper.ExecuteScalar(connectionString, "UserSave", UserId, UserName, Password, IsActive);
        }

        public static void UserDelete(int UserId)
        {
            string sql = "delete [user] where userid = " + UserId;
            SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }

        public static int UserRoleSave(int UserId, string roles)
        {
            string sql = "delete User_UserRole where UserId = " + UserId.ToString() + ";\n";
            if (roles.Length > 0)
            {
                sql += "insert User_UserRole (UserId, UserRoleId) \n" +
                "    select " + UserId.ToString() + ", UserRoleId from UserRole \n" +
                "    where UserRoleId in (" + roles + ");";
            }
                return SqlHelper.ExecuteNonQuery(connectionString, CommandType.Text, sql);

        }

		public static int UpdateUser(string username, string password, int roleId, int userId)
		{
			return (int)SqlHelper.ExecuteScalar(connectionString, "UserUpdate", username, password, roleId, userId);
		}

		public static void DeleteUser(int userId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "UserDelete", userId);
		}

		public static DataSet GetAllUsers()
		{
			DataSet ds = new DataSet();
			ds = SqlHelper.ExecuteDataset(connectionString, CommandType.StoredProcedure, "UserGetAll");
			ds.Tables[0].TableName = "User";
			return ds;
		}

        public static DataSet GetUserRoles(int uid)
        {
            string sql = "";
            if (uid > 0)
            {
                sql = "select UserRole.UserRoleId " +
                    ", UserRole.UserRoleName " +
                    ", convert(bit, (case when (User_UserRole.UserRoleId) is null then 0 else 1 end)) as inRole " +
                    "from UserRole " +
                    "left outer join User_UserRole on User_UserRole.UserRoleId = UserRole.UserRoleId " +
                    "    and User_UserRole.UserId = " + uid.ToString() + " " +
                    "order by UserRole.UserRoleName";
            }
            else
            {
                sql = "select UserRoleId, UserRoleName, convert(bit, 0) as inRole from UserRole order by UserRoleName";
            }
            return SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
        }

		public static DataSet GetUserByUsername(string username)
		{
			return SqlHelper.ExecuteDataset(connectionString, "UserGetByUsername", username);
		}

		public static DataSet GetUser(string username, string password)
		{
			return SqlHelper.ExecuteDataset(connectionString, "UserGet", username, password);
		}

		public static DataSet GetRecentProjects(string username)
		{
			return SqlHelper.ExecuteDataset(connectionString, "RecentProjectGet", username);
		}

		public static void InsertRecentProjects(string username, int projectId)
		{
			SqlHelper.ExecuteNonQuery(connectionString, "RecentProjectInsert", username, projectId);
		}

	}
}
