using System;

namespace CCPM
{
	/// <summary>
	/// Summary description for GlobalSettings.
	/// </summary>
	public class GlobalSettings
	{
        //old active directory first name
		public static string userid = string.Empty;
		public static int projectId = 0;
		//public static bool isAdmin = false;
		public static bool okayToClose = true;
		public static bool editInProgress = false;
		public static System.Drawing.Color nonEditableBackColor = System.Drawing.Color.Beige;
		public static System.Drawing.Color nonEditableForeColor = System.Drawing.Color.Black;
        public static System.Drawing.Color EditableBackColor = System.Drawing.Color.White;
        public static CCPM.Form1 mainFormHandle;
		public static CCPM.Project.ProjectSearch projectSearchHandle;
		public static CCPM.Project.OpenProject openProjectHandle;

		private static string _projectRegex = System.Configuration.ConfigurationSettings.AppSettings[ "ProjectNumberRegex" ];
		public static string ProjectRegex{get{return _projectRegex;}}

        private static string _connectionString = "";
        //static string _testConnectionString = "Data Source=DSD-VPC2; Initial Catalog=CCPMTEST; UID=ccadmin; pwd=ccadmin;";//"Data Source=COAST1;Initial Catalog=CCPM3; UID=ccadmin; pwd=ccadmin;";
        //static string _connectionStringCCPM3 = "Data Source=DSD-VPC2;Initial Catalog=CCPMTEST; UID=ccadmin; pwd=ccadmin;";
        //static string _devConnectionString = "Data Source=DSD-VPC2; Initial Catalog=CCPMTEST; UID=ccadmin; pwd=ccadmin;";
        static string _testConnectionString = "Data Source=COAST08DB; Initial Catalog=CCPMTEST; UID=ccadmin; pwd=ccadmin;";
        static string _connectionStringCCPM3 = "Data Source=COAST08DB;Initial Catalog=CCPM3; UID=ccadmin; pwd=ccadmin;";
        static string _devConnectionString = "Data Source=COAST08DB; Initial Catalog=CCPMTEST; UID=ccadmin; pwd=ccadmin;";

        private static int _userId = 0;
        private static string _userName = "";
        private static bool _isAdministrator = false;
        private static bool _isProjectManager = false;
        private static bool _isContractsManager = false;
        private static bool _isContractsStaff = false;
        private static bool _isAccountingManager = false;
        private static bool _isNCRegionalManager = false;
        private static bool _isBayRegionalManager = false;
        private static bool _isCCRegionalManager = false;
        private static bool _isSCRegionalManager = false;
        private static bool _isOPCRegionalManager = false;
        private static string _MoneyFormat = "$#,##0.00";

        private static bool _isTestDB = false;
        private static bool _isFirstOpen = true;

        public static bool IsFirstOpen
        {
            get { return _isFirstOpen; }
            set { _isFirstOpen = value; }
        }

        public static string MoneyFormat
        {
            get { return _MoneyFormat; }
        }

        public static string ConnectionString
        {
            get { return _connectionString; }
            set { _connectionString = value; }
        }

        public static string TestConnectionString
        {
            get { return _testConnectionString; }
            set { _testConnectionString = value; }
        }

        public static string ConnectionStringCCPM3
        {
            get { return _connectionStringCCPM3; }
            set { _connectionStringCCPM3 = value; }
        }

        public static string DevConnectionString
        {
            get { return _devConnectionString; }
            set { _devConnectionString = value; }
        }

        public static bool IsTestDB
        {
            get { return _isTestDB;}
            set { _isTestDB = value; }
        }


        public static int UserId
        {
            get { return _userId;}
            set { _userId = value;}
        }

        public static string UserName
        {
            get { return _userName; }
            set { _userName = value; }
        }

        public static bool IsAdministrator
        {
            get { return _isAdministrator; }
            set { _isAdministrator = value; }
        }

        public static bool IsProjectManager
        {
            get { return _isProjectManager; }
            set { _isProjectManager = value; }
        }

        public static bool IsContractsManager
        {
            get { return _isContractsManager; }
            set { _isContractsManager = value; }
        }

        public static bool IsContractsStaff
        {
            get { return _isContractsStaff; }
            set { _isContractsStaff = value; }
        }

        public static bool IsAccountingManager
        {
            get { return _isAccountingManager; }
            set { _isAccountingManager = value; }
        }

        public static bool IsNCRegionalManager
        {
            get { return _isNCRegionalManager; }
            set { _isNCRegionalManager = value; }
        }

        public static bool IsBayRegionalManager
        {
            get { return _isBayRegionalManager; }
            set { _isBayRegionalManager = value; }
        }

        public static bool IsCCRegionalManager
        {
            get { return _isCCRegionalManager; }
            set { _isCCRegionalManager = value; }
        }

        public static bool IsSCRegionalManager
        {
            get { return _isSCRegionalManager; }
            set { _isSCRegionalManager = value; }
        }

        public static bool IsOPCRegionalManager
        {
            get { return _isOPCRegionalManager; }
            set { _isOPCRegionalManager = value; }
        }

        public static void SetSecurity()
        {

            //1	Administrator
            //2	Project_Manager
            //3	Contracts Manager
            //4	Contracts Staff
            //5	Accounting Manager
            //6	North Coast Regional Manager
            //7	Bay Regional Manager
            //8	Central Coast Regional Manager
            //9	South Coast Regional Manager
            //10 OPC Regional Manager
            System.Data.DataSet ds = CCPM.Data.UserData.GetUserRoles(_userId);
            foreach (System.Data.DataRow dr in ds.Tables[0].Rows)
            {
                if (Convert.ToBoolean(dr["inRole"]))
                {
                    switch (dr["UserRoleId"].ToString())
                    {
                        case "1":
                            _isAdministrator = true;
                            break;
                        case "2":
                            _isProjectManager = true;
                            break;
                        case "3":
                            _isContractsManager = true;
                            break;
                        case "4":
                            _isContractsStaff = true;
                            break;
                        case "5":
                            _isAccountingManager = true;
                            break;
                        case "6":
                            _isNCRegionalManager = true;
                            break;
                        case "7":
                            _isBayRegionalManager = true;
                            break;
                        case "8":
                            _isCCRegionalManager = true;
                            break;
                        case "9":
                            _isSCRegionalManager = true;
                            break;
                        case "10":
                            _isOPCRegionalManager = true;
                            break;
                    };
                }
            }        
        }


		public GlobalSettings()
		{
			//
			// TODO: Add constructor logic here
			//
		}
		
		// A read-write instance property:
		//		public static MainForm MainFormHandle
		//		{
		//			get 
		//			{
		//				return MainFormHandle; 
		//			}
		//			set 
		//			{
		//				name = value; 
		//			}
		//		}

	}
}
