﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM
{
    public partial class GridSelect : Form
    {
        public UltraGridBand band;
        public GridSelect()
        {
            InitializeComponent();
            band = uwgSelect.DisplayLayout.Bands[0];
            uwgSelect.DisplayLayout.Override.HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction.SortSingle;
            
        }

        public void SqlStatement(string sql, string connectionString)
        {
            DataSet ds = null;
            ds = SqlHelper.ExecuteDataset(connectionString, CommandType.Text, sql);
            uwgSelect.DataSource = ds;
            uwgSelect.DataBind();
        }

        public void DataSet(DataSet ds)
        {
            uwgSelect.DataSource = ds;
            uwgSelect.DataBind();
        }

        public void ColumnHide(int index)
        {
            band.Columns[index].Hidden = true;
        }

        public void ColumnWidth(int index, int value)
        {
            band.Columns[index].Width = value;
        }

        public void ColumnName(int index, string value)
        {
            band.Columns[index].Header.Caption = value;
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if (uwgSelect.Selected.Rows.Count == 0)
                uwgSelect.ActiveRow.Selected = true;
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        private void uwgSelect_DoubleClickRow(object sender, DoubleClickRowEventArgs e)
        {
            if (uwgSelect.Selected.Rows.Count == 0)
                uwgSelect.ActiveRow.Selected = true;
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        public int SelectedRowsCount()
        {
            return uwgSelect.Selected.Rows.Count;
        }

        public string SelectedKeys(int index, bool isString)
        {
            string result = "";
            Infragistics.Win.UltraWinGrid.SelectedRowsCollection selectedRows;
            selectedRows = uwgSelect.Selected.Rows;
            if (selectedRows.Count > 0)
            {
                string s = "";
                UltraGridRow ugr;
                for ( int i = 0; i < selectedRows.Count; i++ )
                {
                    ugr = selectedRows[i];
                    s = ugr.Cells[index].Value.ToString();
                    if (isString)
                        result += GlobalCode.SqlString(s) + ",";
                    else
                        result += s + ",";
                }
                result = result.Substring(0, result.Length - 1);
            }
            else
            {
                if (isString)
                    result = GlobalCode.SqlString(uwgSelect.ActiveRow.Cells[index].Value.ToString());
                else
                    result = uwgSelect.ActiveRow.Cells[index].Value.ToString();
            }
            return result;

        }

        private void uwgSelect_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            for (int i = 0; i < band.Columns.Count; i++)
            {
                band.Columns[i].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            }
        }

        private void btnSelectAll_Click(object sender, EventArgs e)
        {
            foreach (UltraGridRow ugr in uwgSelect.Rows)
            {
                ugr.Selected = true;
            }
        }

        private void btnExport_Click(object sender, EventArgs e)
        {
            string excelFile = GlobalCode.ExcelFileName("c:\\Temp", "ccpm_export.xls", false);
            if (excelFile != string.Empty)
            {
                GlobalCode.ExportGridToExcel(uwgSelect, excelFile);
                GlobalCode.OpenAssociatedFile(excelFile);
            }
        }

    }
}
