﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CCPM
{
    public partial class InputBox : Form
    {
        private bool _IsInteger = false;
        private bool _IsDateRange = false;

        public bool IsDateRange
        {
            get { return _IsDateRange; }
            set
            {
                dtpValue2.Top = dtpValue.Top;
                dtpValue2.Visible = true;
                dtpValue.Top = txtValue.Top;
                dtpValue.Visible = true;
                txtValue.Visible = false;
            }
        }

        public bool IsInteger
        {
            get { return _IsInteger; }
            set { _IsInteger = value; }
        }

        public InputBox()
        {
            InitializeComponent();
            lblDate.Text = "";
            lblValue.Text = "";
        }

        public string TextValue
        {
            get { return txtValue.Text; }
            set { txtValue.Text = value; }
        }

        public string Title
        {
            set { this.Text = value; }
        }

        public string Caption
        {
            set { lblCaption.Text = value; }
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void txtValue_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (_IsInteger)
            {
                if (e.KeyChar == 8)
                    return;
                if (!Char.IsDigit(e.KeyChar))
                    e.Handled = true;
            }
        }

    }
}
