using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text;
using System.IO;
using CCPM.Data;
using System.Text.RegularExpressions;
using Genghis;

namespace CCPM.Links
{
	/// <summary>
	/// Summary description for AddLink.
	/// </summary>
	public class AddLink : System.Windows.Forms.Form
	{
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button btnSeelctFile;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txtWebLink;
		private System.Windows.Forms.Button btnAddWebLink;
		private int projectId;
        private bool boolFolder = false;
		private System.Windows.Forms.TextBox txtWebLinkDescription;
		private System.Windows.Forms.TextBox txtFile;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnSaveFile;
		private System.Windows.Forms.TextBox txtFileDescription;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.Button btnCancelTwo;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public int ProjectId
		{
			get{return projectId;}
			set{projectId = value;}
		}

		public AddLink(int projectId)
		{
			InitializeComponent();
			ProjectId = projectId;
		}

        public AddLink(int projectId, bool folder)
        {
            InitializeComponent();
            ProjectId = projectId;
            boolFolder = folder;
            if (boolFolder)
            {
                groupBox1.Text = "Network Folder";
                label1.Text = "Select a folder that is located on a network shared drive.";
                groupBox2.Visible = false;
                this.Height = 250;
            }

        }
        
        /// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.btnSeelctFile = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnSaveFile = new System.Windows.Forms.Button();
			this.txtFileDescription = new System.Windows.Forms.TextBox();
			this.txtFile = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.btnCancelTwo = new System.Windows.Forms.Button();
			this.txtWebLinkDescription = new System.Windows.Forms.TextBox();
			this.btnAddWebLink = new System.Windows.Forms.Button();
			this.txtWebLink = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnSeelctFile
			// 
			this.btnSeelctFile.Location = new System.Drawing.Point(288, 48);
			this.btnSeelctFile.Name = "btnSeelctFile";
			this.btnSeelctFile.Size = new System.Drawing.Size(56, 22);
			this.btnSeelctFile.TabIndex = 1;
			this.btnSeelctFile.Text = "Browse";
			this.btnSeelctFile.Click += new System.EventHandler(this.btnSeelctFile_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.btnCancel);
			this.groupBox1.Controls.Add(this.btnSaveFile);
			this.groupBox1.Controls.Add(this.txtFileDescription);
			this.groupBox1.Controls.Add(this.txtFile);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.btnSeelctFile);
			this.groupBox1.Location = new System.Drawing.Point(16, 16);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(368, 144);
			this.groupBox1.TabIndex = 1;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Local File";
			// 
			// btnCancel
			// 
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnCancel.Location = new System.Drawing.Point(269, 112);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 7;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// btnSaveFile
			// 
			this.btnSaveFile.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnSaveFile.Location = new System.Drawing.Point(168, 112);
			this.btnSaveFile.Name = "btnSaveFile";
			this.btnSaveFile.TabIndex = 6;
			this.btnSaveFile.Text = "Save Link";
			this.btnSaveFile.Click += new System.EventHandler(this.btnSaveFile_Click);
			// 
			// txtFileDescription
			// 
			this.txtFileDescription.Location = new System.Drawing.Point(16, 72);
			this.txtFileDescription.MaxLength = 250;
			this.txtFileDescription.Multiline = true;
			this.txtFileDescription.Name = "txtFileDescription";
			this.txtFileDescription.Size = new System.Drawing.Size(328, 32);
			this.txtFileDescription.TabIndex = 5;
			this.txtFileDescription.Text = "Enter description";
			this.txtFileDescription.Enter += new System.EventHandler(this.txtFileDescription_Enter);
			// 
			// txtFile
			// 
			this.txtFile.Location = new System.Drawing.Point(16, 48);
			this.txtFile.Name = "txtFile";
			this.txtFile.ReadOnly = true;
			this.txtFile.Size = new System.Drawing.Size(271, 20);
			this.txtFile.TabIndex = 2;
			this.txtFile.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(312, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Select a file that is located on your computer or a local share.";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.btnCancelTwo);
			this.groupBox2.Controls.Add(this.txtWebLinkDescription);
			this.groupBox2.Controls.Add(this.btnAddWebLink);
			this.groupBox2.Controls.Add(this.txtWebLink);
			this.groupBox2.Controls.Add(this.label2);
			this.groupBox2.Location = new System.Drawing.Point(16, 176);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(368, 160);
			this.groupBox2.TabIndex = 2;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Web link";
			// 
			// btnCancelTwo
			// 
			this.btnCancelTwo.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnCancelTwo.Location = new System.Drawing.Point(269, 128);
			this.btnCancelTwo.Name = "btnCancelTwo";
			this.btnCancelTwo.TabIndex = 5;
			this.btnCancelTwo.Text = "Cancel";
			this.btnCancelTwo.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// txtWebLinkDescription
			// 
			this.txtWebLinkDescription.Location = new System.Drawing.Point(16, 88);
			this.txtWebLinkDescription.MaxLength = 250;
			this.txtWebLinkDescription.Multiline = true;
			this.txtWebLinkDescription.Name = "txtWebLinkDescription";
			this.txtWebLinkDescription.Size = new System.Drawing.Size(328, 32);
			this.txtWebLinkDescription.TabIndex = 3;
			this.txtWebLinkDescription.Text = "Enter description";
			this.txtWebLinkDescription.Enter += new System.EventHandler(this.txtWebLinkDescription_Enter);
			// 
			// btnAddWebLink
			// 
			this.btnAddWebLink.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnAddWebLink.Location = new System.Drawing.Point(168, 128);
			this.btnAddWebLink.Name = "btnAddWebLink";
			this.btnAddWebLink.TabIndex = 4;
			this.btnAddWebLink.Text = "Save Link";
			this.btnAddWebLink.Click += new System.EventHandler(this.btnAddWebLink_Click);
			// 
			// txtWebLink
			// 
			this.txtWebLink.AllowDrop = true;
			this.txtWebLink.CausesValidation = false;
			this.txtWebLink.Location = new System.Drawing.Point(16, 64);
			this.txtWebLink.MaxLength = 255;
			this.txtWebLink.Name = "txtWebLink";
			this.txtWebLink.Size = new System.Drawing.Size(328, 20);
			this.txtWebLink.TabIndex = 2;
			this.txtWebLink.Text = "Enter Web link";
			this.txtWebLink.DragDrop += new System.Windows.Forms.DragEventHandler(this.txtWebLink_DragDrop);
			this.txtWebLink.DragEnter += new System.Windows.Forms.DragEventHandler(this.txtWebLink_DragEnter);
			this.txtWebLink.Enter += new System.EventHandler(this.txtWebLink_Enter);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(328, 32);
			this.label2.TabIndex = 0;
			this.label2.Text = "Drag and drop from the IE address bar or paste a Web site link to the text field " +
				"marked \'Enter Web link\' below.";
			// 
			// AddLink
			// 
			this.AllowDrop = true;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 358);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Name = "AddLink";
			this.Text = "Add Link";
			this.Load += new System.EventHandler(this.AddLink_Load);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void AddLink_Load(object sender, System.EventArgs e)
		{
		
		}

		/// <summary>
		/// Make sure the file is on a network share and provide a means to copy it
		/// to a share if not.
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnSeelctFile_Click(object sender, System.EventArgs e)
		{

            if (boolFolder)
            {
                System.Windows.Forms.FolderBrowserDialog fbd = new System.Windows.Forms.FolderBrowserDialog();
                fbd.Description = "Select a shared network folder.  Folders on your local computer can't be used.";
                if (fbd.ShowDialog() == DialogResult.OK)
                {
                    if (fbd.SelectedPath.Substring(0, 2) != @"\\")
                        MessageBox.Show("Folder must be a shared network folder!");
                    else
                        txtFile.Text = fbd.SelectedPath;
                }
            }
            else
            {
                if (openFileDialog1.ShowDialog(this) == DialogResult.OK)
                {
                    string filename = openFileDialog1.FileName;

                    if (filename.Substring(0, 2) != @"\\")
                    {
                        string msg = string.Concat("This file is located on your computer!\nDo you want to copy ", Path.GetFileName(filename), " to a network share now?\n*NOTE: Use \"My Network Places\" from the SaveAs dialog.");
                        if (DialogResult.OK == MessageBox.Show(msg,
                            "File Not Available to Other Users",
                            MessageBoxButtons.OKCancel,
                            MessageBoxIcon.Information))
                        {
                            this.saveFileDialog1.FileName = filename;
                            if (DialogResult.OK == this.saveFileDialog1.ShowDialog(this))
                            {
                                string newFileName = saveFileDialog1.FileName;

                                if (newFileName != string.Empty && newFileName.Substring(0, 2) == @"\\")
                                {
                                    try
                                    {
                                        File.Copy(filename, newFileName, true);
                                    }
                                    catch (Exception ex)
                                    {
                                        MessageBox.Show(ex.Message,
                                            "Error Saving File",
                                            MessageBoxButtons.OK,
                                            MessageBoxIcon.Stop);
                                        return;
                                    }

                                    txtFile.Text = newFileName;
                                }
                                else
                                {
                                    MessageBox.Show("Sorry, you did not choose a network share!",
                                        "File Not Available to Other Users",
                                        MessageBoxButtons.OK,
                                        MessageBoxIcon.Information);
                                }
                            }
                        }
                    }
                    else
                    {
                        txtFile.Text = filename;// file is on a share
                    }
                }
            }
			
		}

		private void txtWebLink_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			try 
			{  
				System.IO.Stream ioStream = (System.IO.Stream)e.Data.GetData("FileGroupDescriptor"); 
				byte[] contents = new Byte[512]; 
				ioStream.Read(contents,0,512); 
				ioStream.Close(); 
				StringBuilder sb = new StringBuilder(); 
				//The magic number 76 is the size of that part of the 
				//FILEGROUPDESCRIPTOR structure before the filename starts 
				for (int i=76; contents[i] != 0; i++) 
				{ 
					sb.Append((char)contents[i]); 
				} 
				if (!sb.ToString(sb.Length-4,4).Equals(".url")) 
				{ 
					throw new Exception("filename does not end in '.url'"); 
				} 
				string filename = sb.ToString(0,sb.Length-4);

				Stream urlStream = (Stream)e.Data.GetData("UniformResourceLocator");
				string url = new StreamReader(urlStream).ReadToEnd();
				urlStream.Close();
				
				txtWebLink.Text = url;
				if(txtWebLinkDescription.Text == "Enter description")
				{
					txtWebLinkDescription.Text = filename;
				}
			} 
			catch(Exception ex) 
			{ 
				MessageBox.Show(ex.ToString()); 
			} 
		}

		private void txtWebLink_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			// Determine if we are dragging something, if we are, set the effect
			if (e.Data.GetDataPresent(DataFormats.Text))
			{
				e.Effect = DragDropEffects.Copy;
			}
			else
			{
				e.Effect = DragDropEffects.None;
			}

		}

		private void txtWebLinkDescription_Enter(object sender, System.EventArgs e)
		{
			if(txtWebLinkDescription.Text == "Enter description")
			{
				txtWebLinkDescription.Text = string.Empty;
			}
		}

		private void txtWebLink_Enter(object sender, System.EventArgs e)
		{
			if(txtWebLink.Text == "Enter Web link")
			{
				txtWebLink.Text = string.Empty;
			}
		}

		private void btnAddWebLink_Click(object sender, System.EventArgs e)
		{
			//Matches URLS 
			string pattern = @"(http|https|ftp)\://([a-zA-Z0-9\.\-]+(\:[a-zA-Z0-9\.&%\$\-]+)*@)?((25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])|([a-zA-Z0-9\-]+\.)*[a-zA-Z0-9\-]+\.[a-zA-Z]{2,4})(\:[0-9]+)?(/[^/][a-zA-Z0-9\.\,\?\'\\/\+&%\$#\=~_\-]*)*";

			Regex regex = new Regex(pattern);
			
			if(regex.IsMatch(txtWebLink.Text))
			{
				string description = txtWebLinkDescription.Text == "Enter description" ? string.Empty : txtWebLinkDescription.Text;
				ResourceData.LinkInsert(ProjectId, txtWebLink.Text, description);
				this.DialogResult = DialogResult.OK;
				this.Close();
			}
			else
			{
				MessageBox.Show("Please make sure you have a valid url in the Web link field! \nIt is required to include the protocol (http://, https://, ftp://)",
					"Link Format Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void btnSaveFile_Click(object sender, System.EventArgs e)
		{
			if(txtFile.Text != string.Empty)
			{
				string description = txtFileDescription.Text == "Enter description" ? string.Empty : txtFileDescription.Text;
				ResourceData.LinkInsert(ProjectId, txtFile.Text, description);
				this.DialogResult = DialogResult.OK;
				this.Close();
			}
			else
			{
				MessageBox.Show("Please browse for a file before saving!");
			}
		}

		private void txtFileDescription_Enter(object sender, System.EventArgs e)
		{
			if(txtFileDescription.Text == "Enter description")
			{
				txtFileDescription.Text = string.Empty;
			}
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
