using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace CCPM.Links
{
	/// <summary>
	/// Summary description for EditLinkDescription.
	/// </summary>
	public class EditLinkDescription : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnUpdate;
		private string fileName;
		private string description;
		private int linkId;
		private System.Windows.Forms.Label lblFileName;
		private System.Windows.Forms.TextBox txtDescription;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		public string FileName
		{
			get{return fileName;}
			set{fileName = value;}
		}
		public string Description
		{
			get{return description;}
			set{description = value;}
		}
		public int LinkId
		{
			get{return linkId;}
			set{linkId = value;}
		}
		public EditLinkDescription(int linkId, string fileName, string description)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			FileName = fileName;
			Description = description;
			LinkId = linkId;
		}

		private void PopulateForm()
		{
			lblFileName.Text = FileName;
			txtDescription.Text = Description;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtDescription = new System.Windows.Forms.TextBox();
			this.lblFileName = new System.Windows.Forms.Label();
			this.btnUpdate = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// txtDescription
			// 
			this.txtDescription.Location = new System.Drawing.Point(16, 64);
			this.txtDescription.MaxLength = 250;
			this.txtDescription.Multiline = true;
			this.txtDescription.Name = "txtDescription";
			this.txtDescription.Size = new System.Drawing.Size(382, 32);
			this.txtDescription.TabIndex = 0;
			this.txtDescription.Text = "";
			// 
			// lblFileName
			// 
			this.lblFileName.Location = new System.Drawing.Point(16, 16);
			this.lblFileName.Name = "lblFileName";
			this.lblFileName.Size = new System.Drawing.Size(376, 32);
			this.lblFileName.TabIndex = 1;
			// 
			// btnUpdate
			// 
			this.btnUpdate.Location = new System.Drawing.Point(200, 120);
			this.btnUpdate.Name = "btnUpdate";
			this.btnUpdate.TabIndex = 2;
			this.btnUpdate.Text = "Update";
			this.btnUpdate.Click += new System.EventHandler(this.btnUpdate_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Location = new System.Drawing.Point(324, 120);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 3;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// EditLinkDescription
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(416, 174);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnUpdate);
			this.Controls.Add(this.lblFileName);
			this.Controls.Add(this.txtDescription);
			this.Name = "EditLinkDescription";
			this.Text = "Edit Link Description";
			this.Load += new System.EventHandler(this.EditLinkDescription_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btnUpdate_Click(object sender, System.EventArgs e)
		{
			CCPM.Data.ResourceData.LinkUpdate(LinkId, txtDescription.Text);
			this.DialogResult = DialogResult.OK;
			this.Close();
		}

		private void EditLinkDescription_Load(object sender, System.EventArgs e)
		{
			lblFileName.Text = string.Concat("Resource name: ", FileName);
			txtDescription.Text = Description;
		}

	}
}
