using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Security.Principal;
using CCPM.ProjectRelated;
using CCPM.Data;
using CCPM.User;
using CCPM.Contract;
using System.Runtime.InteropServices;
using System.Reflection;
using System.Diagnostics;
using System.Configuration;

namespace CCPM
{
    /// <summary>
    /// Main form for application. The database connection is stored in
    /// app.config (coastal conservancy Project manager.exe.config) for convenience
    /// but should probably be moved into a registry setting for greater security
    /// </summary>
    public class Form1 : System.Windows.Forms.Form
    {
        #region Class Fields
        public User.UpdateDeleteUser updateDeleteUser;
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem miUsers;
        private System.Windows.Forms.MenuItem miFile;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem miExit;
        private System.Windows.Forms.MenuItem miNew;
        private System.Windows.Forms.MenuItem miNewProject;
        private System.Windows.Forms.MenuItem menuItem2;
        private System.Windows.Forms.MenuItem miOpenProject;
        private System.Windows.Forms.MenuItem miManage;
        private System.Windows.Forms.MenuItem miAttorney;
        private System.Windows.Forms.MenuItem miUser;
        private System.Windows.Forms.MenuItem miWindow;
        private System.Windows.Forms.MenuItem miArrange;
        private System.Windows.Forms.MenuItem miCascade;
        private System.Windows.Forms.MenuItem miTileHoriz;
        private System.Windows.Forms.MenuItem miTileVertical;
        private System.Windows.Forms.MenuItem miStaff;
        private System.Windows.Forms.MenuItem miProjectType;
        private System.Windows.Forms.MenuItem miProgramType;
        private System.Windows.Forms.MenuItem miSearchProjects;
        private System.Windows.Forms.MenuItem miRegion;
        private System.Windows.Forms.MenuItem miAssemblyDistricts;
        private System.Windows.Forms.MenuItem miStateSenateDistricts;
        private System.Windows.Forms.MenuItem miCongressionalDistricts;
        private System.Windows.Forms.MenuItem miEdit;
        private int currentProjectFocus = 0;
        private System.Windows.Forms.MenuItem menuItem3;
        private System.Windows.Forms.MenuItem miCloseAll;
        private System.Windows.Forms.MenuItem menuItem4;
        private System.Windows.Forms.MenuItem menuItem5;
        private System.Windows.Forms.MenuItem miDeleteProject;
        private System.Windows.Forms.MenuItem menuItem8;
        private System.Windows.Forms.MenuItem menuItem9;
        private System.Windows.Forms.MenuItem miManageContacts;
        private System.Windows.Forms.MenuItem menuItem11;
        private System.Windows.Forms.MenuItem miAdminProject;
        private System.Windows.Forms.MenuItem miEditGeneral;
        private System.Windows.Forms.MenuItem miAddMatchingFund;
        private System.Windows.Forms.MenuItem miEditMatchingFund;
        private System.Windows.Forms.MenuItem menuItem25;
        private System.Windows.Forms.MenuItem miDeleteMatchingFund;
        private System.Windows.Forms.MenuItem menuItem29;
        private System.Windows.Forms.MenuItem menuItem30;
        private System.Windows.Forms.MenuItem miAddLink;
        private System.Windows.Forms.MenuItem miEditLink;
        private System.Windows.Forms.MenuItem menuItem31;
        private System.Windows.Forms.MenuItem miDeleteLink;
        private System.Windows.Forms.MenuItem menuItem32;
        private System.Windows.Forms.MenuItem menuItem33;
        private System.Windows.Forms.MenuItem miAddRelatedProject;
        private System.Windows.Forms.MenuItem miEditRelatedProject;
        private System.Windows.Forms.MenuItem menuItem34;
        private System.Windows.Forms.MenuItem miDeleteRelatedProject;
        #endregion

        private System.Windows.Forms.MenuItem miWatershed;
        private System.Windows.Forms.MenuItem miObjectives;
        private System.Windows.Forms.MenuItem miAdminOrganization;
        private System.Windows.Forms.MenuItem miAdminFundingSource;
        private System.Windows.Forms.MenuItem miAdminFiscalYears;
        private System.Windows.Forms.MenuItem miUnlockProjects;
        private System.Windows.Forms.MenuItem miProjectCities;
        private System.Windows.Forms.MenuItem miProjectCounties;
        private System.Windows.Forms.MenuItem miProjectRegions;
        private MenuItem miContract;
        private MenuItem miAddContract;
        private MenuItem miOpenContract;
        private MenuItem miOpenInvoice;
        private MenuItem miNewContract;
        private MenuItem miActiveContractLog;
        private MenuItem miInvoiceLog;
        private MenuItem miRepayLog;
        private MenuItem miCompleteLog;
        private MenuItem miClosedLog;
        private MenuItem menuItem6;
        private MenuItem menuItem13;
        private MenuItem menuItem16;
        private MenuItem miContractsFundingSource;
        private MenuItem menuItem17;
        private IContainer components;

        private ActiveContractLog ac;
        private AmendmentsLog al;
        private ClosedContractLog ccl;
        private CompleteContractLog cl;
        private ContractByFundingSourceLog cfsl;
        private InvoiceLog il;
        private MonitoringLog ml;
        private RepaymentLog rl;
        private DynamicDropdowns ddl;
        private Project.ProjectSearch ps;

        private ContractDetail cd;
        private MenuItem miReimbType;
        private MenuItem miProjectStatus;
        private MenuItem miAuthorizationTypes;
        private MenuItem miRelationTypes;
        private MenuItem miContractType;
        private MenuItem miMonitorOutcome;
        private MenuItem menuItem20;
        private MenuItem menuItem22;
        private MenuItem miSize;
        private MenuItem miSendAlerts;
        private MenuItem miSize1024;
        private MenuItem menuItem23;
        private MenuItem miQueryTool;
        private MenuItem menuItem12;
        private MenuItem menuItem7;
        private MenuItem miContacts;
        private Panel pnlYellow;
        private Infragistics.Win.UltraWinTabbedMdi.UltraTabbedMdiManager ultraTabbedMdiManager1;
        private MenuItem miDynamicDropdowns;
        private MenuItem miAgency;
        private MenuItem miAlertEmails;
        private MenuItem miOrganizationRole;
        private MenuItem menuItem19;
        private MenuItem miDynamicMultiSelect;
        private ContractPicker cp;

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            GlobalSettings.mainFormHandle = this;

        }

        private void OpenProjectForm()
        {
            if (GlobalSettings.openProjectHandle == null)
            {
                try
                {
                    CCPM.Project.OpenProject openProject = new CCPM.Project.OpenProject();
                    GlobalSettings.openProjectHandle = openProject;
                    openProject.MdiParent = this;
                    openProject.Location = new System.Drawing.Point(0, 0);
                    if (GlobalSettings.IsFirstOpen)
                    {
                        openProject.WindowState = FormWindowState.Maximized;
                        GlobalSettings.IsFirstOpen = false;
                    }
                    openProject.Show();
                    openProject.Focus();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Failure connecting to database!");
                    this.Close();
                    return;
                }
            }
            else
            {
                GlobalSettings.openProjectHandle.WindowState = FormWindowState.Maximized;
                GlobalSettings.openProjectHandle.Focus();
            }
        }

        public bool OpenForm(Form frmToOpen, string formTitle)
        {
            bool found = false;

            foreach (Form frm in MdiChildren)
            {
                if (frm.GetType() == frmToOpen.GetType() &&
                    frm.Text == formTitle)
                {
                    frm.Focus();
                    frmToOpen.Close();
                    found = true;
                    break;
                }
            }

            if (!found)
            {
                frmToOpen.WindowState = FormWindowState.Maximized;
                frmToOpen.MdiParent = this;
                frmToOpen.Text = formTitle;
                frmToOpen.Show();
            }

            return found;
        }

        private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {

            //check if you can close the form or if you need to do some clean up before exiting 
            //like prompting the user to save the current document 
            if (!GlobalSettings.okayToClose)
            {
                e.Cancel = true; //this causes the for not to be closed 
            }
        }
        /// <summary>
        /// Loads the form used for managing application users.
        /// </summary>
        /// <param name="userId"></param>
        //private void LoadManageUser(int userId)
        //{
        //    CCPM.User.ManageUserForm manageUserForm = new CCPM.User.ManageUserForm();
        //    manageUserForm.MdiParent = this;
        //    manageUserForm.Show();
        //}

        /// <summary>
        /// Open ProjectForm.cs as a child window and add project to current
        /// user's recent project list.
        /// </summary>
        /// <param name="projectId">Project Id number</param>
        public void OpenProject(int projectId, string projectName)
        {
            // NOTE: This method is also in OpenProject form 
            //If project is already open then give it focus
            CCPM.Project.ProjectForm projectForm = new CCPM.Project.ProjectForm(projectId);

            bool found = OpenForm(projectForm, "Project: " + projectName); 

            if (!found)
            {
                //Add project to recent project list since it wasn't already open
                CCPM.Data.UserData.InsertRecentProjects(GlobalSettings.userid, projectId);
            }
        }

        public void OpenContract(string ContractNumber)
        {
            ContractDetail cd1 = new ContractDetail(ContractNumber);
            bool found = OpenForm(cd1, "Contract Details ( " + ContractNumber + ")");
        }

        public void OpenContract(int ContractId)
        {
            ContractDetail cd1 = new ContractDetail(ContractId);
            bool found = OpenForm(cd1, "Contract Details ( " + cd1.txtContractNumber.Text + ")");
        }

        public void OpenFundSubstitute( int ContractId)
        {
            FundSubstitute rd = new FundSubstitute(ContractId);
            OpenForm(rd, "Fund Substitute for contract: " + ContractId);            
        }
        public void OpenRepayment(int ContractId)
        {
            RepaymentDetails rd = new RepaymentDetails(ContractId);
            OpenForm(rd, "Repayment for contract: " + ContractId);
        }

        public void OpenInvoiceDrawdown(int ContractId, int FundId)
        {
            InvoiceDrawdownSheet ids = new InvoiceDrawdownSheet(ContractId, FundId);
            OpenForm(ids, "Invoice Drawdown Sheet - Contract: " + ContractId + " / Fund: " + ContractData.GetFundName(FundId));            
        }

        public void OpenMonitoring(int ContractId)
        {
            MonitoringDetails md = new MonitoringDetails(ContractId);
            OpenForm(md, "Monitoring for contract: " + ContractId);
        }

        private void OpenProjectSearch()
        {
            Project.ProjectSearch md = new Project.ProjectSearch();
            OpenForm(md, "Project Search");
        }

        private void OpenManageUsers()
        {
            UserMain md = new UserMain();
            OpenForm(md, "Manager Users");
        }

        private void OpenDynamicDropdown()
        {
            DynamicDropdowns md = new DynamicDropdowns();
            OpenForm(md, "Manage Dynamic Dropdown Controls");
        }

        private void OpenDynamicMultiSelect()
        {
            DynamicMultiSelects md = new DynamicMultiSelects();
            OpenForm(md, "Manage Dynamic Multi-select Controls");
        }

        public int CurrentProjectFocus
        {
            get { return currentProjectFocus; }
            set { currentProjectFocus = value; }
        }

        private void SetPrincipal(string username, string role)
        {
            GenericIdentity genericIdentity;
            GenericPrincipal genericPrincipal;
            genericIdentity = new GenericIdentity(username);
            genericPrincipal = new GenericPrincipal(genericIdentity, new string[] { role });
            System.Threading.Thread.CurrentPrincipal = genericPrincipal;
        }


        private void SetRecentProjectMenu()
        {
            MenuItem miRecent = null;
            //Add "Recent Projects" to File menu
            int maxItems = miFile.MenuItems.Count;
            //MenuItem _miFile = mainMenu1.MenuItems[0]; //File menu
            //Only add the parent item once
            if (miFile.MenuItems[maxItems - 3].Text != "Recent Projects")
            {
                miRecent = new MenuItem("Recent Projects");
                miFile.MenuItems.Add((maxItems - 2), miRecent);
            }
            else //"Recent Project" menu item already exists
            {
                miRecent = miFile.MenuItems[maxItems - 3];
            }
            //Add recent projects
            miRecent.MenuItems.Clear();
            //DataSet ds = CCPM.Data.UserData.GetRecentProjects(System.Threading.Thread.CurrentPrincipal.Identity.Name);
            DataSet ds = CCPM.Data.UserData.GetRecentProjects(GlobalSettings.userid);
            if (ds.Tables[0].Rows.Count > 0)
            {
                foreach (DataRow dr in ds.Tables[0].Rows)
                {
                    MenuItem miNew = new MenuItem((string)dr["ProjectName"], new EventHandler(this.miRecentProject_Click));
                    miRecent.MenuItems.Add(miNew);
                }
            }
        }

        /// <summary>
        /// Check if this user is in the applicatio administrator role and 
        /// hide the administration menu if not.
        /// </summary>
        private void SetSecurity()
        {
            if (!GlobalSettings.IsAdministrator)
            {
                miUsers.Visible = false;
            }
            if (GlobalSettings.IsContractsManager || GlobalSettings.IsContractsStaff || GlobalSettings.IsAccountingManager)
            {
                miAddContract.Visible = true;
            }
            else
            {
                miAddContract.Visible = false;
            }
        }

        /// <summary>
        /// Return the current project of focus via an out parameter.
        /// </summary>
        /// <param name="projectForm">out param of type CCPM.Project.ProjectForm</param>
        public void GetCurrentProject(out CCPM.Project.ProjectForm projectForm)
        {
            projectForm = null;
            for (int i = 0; i < MdiChildren.Length; i++)
            {
                if (MdiChildren[i] as CCPM.Project.ProjectForm != null)
                {
                    if (((CCPM.Project.ProjectForm)MdiChildren[i]).ProjectId == this.CurrentProjectFocus)
                    {
                        projectForm = (CCPM.Project.ProjectForm)MdiChildren[i];
                        //projectForm.WindowState = FormWindowState.Normal;
                        break;
                    }
                }
            }
        }

        /// <summary>
        /// Returns the current instance of MasterDetail.cs if it exists. This is
        /// the stand alone contact view; not associated with a project.
        /// </summary>
        /// <returns></returns>
        private CCPM.Contact.MasterDetail GetMasterDetailForm()
        {
            CCPM.Contact.MasterDetail md = null;
            for (int i = 0; i < this.MdiChildren.Length; i++)
            {
                if (MdiChildren[i].GetType() == typeof(CCPM.Contact.MasterDetail))
                {
                    MdiChildren[i].Focus();
                    MdiChildren[i].WindowState = FormWindowState.Normal;
                    md = (CCPM.Contact.MasterDetail)MdiChildren[i];
                    break;
                }
            }
            return md;
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }


        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.miFile = new System.Windows.Forms.MenuItem();
            this.miNew = new System.Windows.Forms.MenuItem();
            this.miNewProject = new System.Windows.Forms.MenuItem();
            this.menuItem8 = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.miOpenProject = new System.Windows.Forms.MenuItem();
            this.miSearchProjects = new System.Windows.Forms.MenuItem();
            this.miContacts = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.miExit = new System.Windows.Forms.MenuItem();
            this.miUsers = new System.Windows.Forms.MenuItem();
            this.miManage = new System.Windows.Forms.MenuItem();
            this.miAgency = new System.Windows.Forms.MenuItem();
            this.miAlertEmails = new System.Windows.Forms.MenuItem();
            this.miUser = new System.Windows.Forms.MenuItem();
            this.menuItem9 = new System.Windows.Forms.MenuItem();
            this.miAdminProject = new System.Windows.Forms.MenuItem();
            this.miAssemblyDistricts = new System.Windows.Forms.MenuItem();
            this.miAttorney = new System.Windows.Forms.MenuItem();
            this.miAuthorizationTypes = new System.Windows.Forms.MenuItem();
            this.miCongressionalDistricts = new System.Windows.Forms.MenuItem();
            this.miContractType = new System.Windows.Forms.MenuItem();
            this.miMonitorOutcome = new System.Windows.Forms.MenuItem();
            this.miProgramType = new System.Windows.Forms.MenuItem();
            this.miProjectStatus = new System.Windows.Forms.MenuItem();
            this.miProjectType = new System.Windows.Forms.MenuItem();
            this.miRelationTypes = new System.Windows.Forms.MenuItem();
            this.miRegion = new System.Windows.Forms.MenuItem();
            this.miReimbType = new System.Windows.Forms.MenuItem();
            this.miStaff = new System.Windows.Forms.MenuItem();
            this.miStateSenateDistricts = new System.Windows.Forms.MenuItem();
            this.miObjectives = new System.Windows.Forms.MenuItem();
            this.miWatershed = new System.Windows.Forms.MenuItem();
            this.menuItem11 = new System.Windows.Forms.MenuItem();
            this.miManageContacts = new System.Windows.Forms.MenuItem();
            this.menuItem22 = new System.Windows.Forms.MenuItem();
            this.miAdminOrganization = new System.Windows.Forms.MenuItem();
            this.menuItem20 = new System.Windows.Forms.MenuItem();
            this.miOrganizationRole = new System.Windows.Forms.MenuItem();
            this.menuItem19 = new System.Windows.Forms.MenuItem();
            this.miProjectCities = new System.Windows.Forms.MenuItem();
            this.miProjectCounties = new System.Windows.Forms.MenuItem();
            this.miProjectRegions = new System.Windows.Forms.MenuItem();
            this.miAdminFundingSource = new System.Windows.Forms.MenuItem();
            this.miAdminFiscalYears = new System.Windows.Forms.MenuItem();
            this.miDynamicDropdowns = new System.Windows.Forms.MenuItem();
            this.miDynamicMultiSelect = new System.Windows.Forms.MenuItem();
            this.miUnlockProjects = new System.Windows.Forms.MenuItem();
            this.miSendAlerts = new System.Windows.Forms.MenuItem();
            this.mainMenu1 = new System.Windows.Forms.MainMenu(this.components);
            this.miEdit = new System.Windows.Forms.MenuItem();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.miEditGeneral = new System.Windows.Forms.MenuItem();
            this.menuItem5 = new System.Windows.Forms.MenuItem();
            this.miDeleteProject = new System.Windows.Forms.MenuItem();
            this.menuItem29 = new System.Windows.Forms.MenuItem();
            this.menuItem30 = new System.Windows.Forms.MenuItem();
            this.miAddLink = new System.Windows.Forms.MenuItem();
            this.miEditLink = new System.Windows.Forms.MenuItem();
            this.menuItem31 = new System.Windows.Forms.MenuItem();
            this.miDeleteLink = new System.Windows.Forms.MenuItem();
            this.menuItem32 = new System.Windows.Forms.MenuItem();
            this.menuItem33 = new System.Windows.Forms.MenuItem();
            this.miAddRelatedProject = new System.Windows.Forms.MenuItem();
            this.miEditRelatedProject = new System.Windows.Forms.MenuItem();
            this.menuItem34 = new System.Windows.Forms.MenuItem();
            this.miDeleteRelatedProject = new System.Windows.Forms.MenuItem();
            this.miContract = new System.Windows.Forms.MenuItem();
            this.miAddContract = new System.Windows.Forms.MenuItem();
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            this.miOpenContract = new System.Windows.Forms.MenuItem();
            this.miOpenInvoice = new System.Windows.Forms.MenuItem();
            this.menuItem13 = new System.Windows.Forms.MenuItem();
            this.miNewContract = new System.Windows.Forms.MenuItem();
            this.miActiveContractLog = new System.Windows.Forms.MenuItem();
            this.miInvoiceLog = new System.Windows.Forms.MenuItem();
            this.miRepayLog = new System.Windows.Forms.MenuItem();
            this.menuItem17 = new System.Windows.Forms.MenuItem();
            this.miCompleteLog = new System.Windows.Forms.MenuItem();
            this.miClosedLog = new System.Windows.Forms.MenuItem();
            this.menuItem16 = new System.Windows.Forms.MenuItem();
            this.miContractsFundingSource = new System.Windows.Forms.MenuItem();
            this.menuItem12 = new System.Windows.Forms.MenuItem();
            this.menuItem7 = new System.Windows.Forms.MenuItem();
            this.menuItem23 = new System.Windows.Forms.MenuItem();
            this.miQueryTool = new System.Windows.Forms.MenuItem();
            this.miWindow = new System.Windows.Forms.MenuItem();
            this.miArrange = new System.Windows.Forms.MenuItem();
            this.miCascade = new System.Windows.Forms.MenuItem();
            this.miTileVertical = new System.Windows.Forms.MenuItem();
            this.miTileHoriz = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.miCloseAll = new System.Windows.Forms.MenuItem();
            this.miSize = new System.Windows.Forms.MenuItem();
            this.miSize1024 = new System.Windows.Forms.MenuItem();
            this.miAddMatchingFund = new System.Windows.Forms.MenuItem();
            this.miEditMatchingFund = new System.Windows.Forms.MenuItem();
            this.menuItem25 = new System.Windows.Forms.MenuItem();
            this.miDeleteMatchingFund = new System.Windows.Forms.MenuItem();
            this.pnlYellow = new System.Windows.Forms.Panel();
            this.ultraTabbedMdiManager1 = new Infragistics.Win.UltraWinTabbedMdi.UltraTabbedMdiManager(this.components);
            ((System.ComponentModel.ISupportInitialize)(this.ultraTabbedMdiManager1)).BeginInit();
            this.SuspendLayout();
            // 
            // miFile
            // 
            this.miFile.Index = 0;
            this.miFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miNew,
            this.menuItem2,
            this.miOpenProject,
            this.miSearchProjects,
            this.miContacts,
            this.menuItem1,
            this.miExit});
            this.miFile.Text = "File";
            this.miFile.Select += new System.EventHandler(this.miFile_Select);
            // 
            // miNew
            // 
            this.miNew.Index = 0;
            this.miNew.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miNewProject,
            this.menuItem8});
            this.miNew.Text = "New";
            this.miNew.Click += new System.EventHandler(this.miExit_Click);
            // 
            // miNewProject
            // 
            this.miNewProject.Index = 0;
            this.miNewProject.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
            this.miNewProject.Text = "Project";
            this.miNewProject.Click += new System.EventHandler(this.miNewProject_Click);
            // 
            // menuItem8
            // 
            this.menuItem8.Index = 1;
            this.menuItem8.Text = "-";
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 1;
            this.menuItem2.Text = "-";
            // 
            // miOpenProject
            // 
            this.miOpenProject.Index = 2;
            this.miOpenProject.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
            this.miOpenProject.Text = "Open Project";
            this.miOpenProject.Click += new System.EventHandler(this.miOpenProject_Click);
            // 
            // miSearchProjects
            // 
            this.miSearchProjects.Index = 3;
            this.miSearchProjects.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
            this.miSearchProjects.Text = "Search Projects";
            this.miSearchProjects.Click += new System.EventHandler(this.miSearchProjects_Click);
            // 
            // miContacts
            // 
            this.miContacts.Index = 4;
            this.miContacts.Text = "Open Contacts";
            this.miContacts.Click += new System.EventHandler(this.miContacts_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 5;
            this.menuItem1.Text = "-";
            // 
            // miExit
            // 
            this.miExit.Index = 6;
            this.miExit.Text = "Exit";
            this.miExit.Click += new System.EventHandler(this.miExit_Click);
            // 
            // miUsers
            // 
            this.miUsers.Index = 2;
            this.miUsers.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miManage,
            this.miUnlockProjects,
            this.miSendAlerts});
            this.miUsers.Text = "Administration";
            // 
            // miManage
            // 
            this.miManage.Index = 0;
            this.miManage.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miAgency,
            this.miAlertEmails,
            this.miUser,
            this.menuItem9,
            this.miAdminProject,
            this.menuItem11,
            this.miManageContacts,
            this.miAdminOrganization,
            this.miProjectCities,
            this.miProjectCounties,
            this.miProjectRegions,
            this.miAdminFundingSource,
            this.miAdminFiscalYears,
            this.miDynamicDropdowns,
            this.miDynamicMultiSelect});
            this.miManage.Text = "Manage";
            // 
            // miAgency
            // 
            this.miAgency.Index = 0;
            this.miAgency.Text = "Agency";
            this.miAgency.Click += new System.EventHandler(this.miAgency_Click);
            // 
            // miAlertEmails
            // 
            this.miAlertEmails.Index = 1;
            this.miAlertEmails.Text = "Alert Emails";
            this.miAlertEmails.Click += new System.EventHandler(this.miAlertEmails_Click);
            // 
            // miUser
            // 
            this.miUser.Index = 2;
            this.miUser.Text = "Users";
            this.miUser.Click += new System.EventHandler(this.miUser_Click);
            // 
            // menuItem9
            // 
            this.menuItem9.Index = 3;
            this.menuItem9.Text = "-";
            // 
            // miAdminProject
            // 
            this.miAdminProject.Index = 4;
            this.miAdminProject.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miAssemblyDistricts,
            this.miAttorney,
            this.miAuthorizationTypes,
            this.miCongressionalDistricts,
            this.miContractType,
            this.miMonitorOutcome,
            this.miProgramType,
            this.miProjectStatus,
            this.miProjectType,
            this.miRelationTypes,
            this.miRegion,
            this.miReimbType,
            this.miStaff,
            this.miStateSenateDistricts,
            this.miObjectives,
            this.miWatershed});
            this.miAdminProject.Text = "Project";
            // 
            // miAssemblyDistricts
            // 
            this.miAssemblyDistricts.Index = 0;
            this.miAssemblyDistricts.Text = "Assembly Districts";
            this.miAssemblyDistricts.Click += new System.EventHandler(this.miAssemblyDistrict_Click);
            // 
            // miAttorney
            // 
            this.miAttorney.Index = 1;
            this.miAttorney.Text = "Attorneys";
            this.miAttorney.Click += new System.EventHandler(this.miAttorney_Click);
            // 
            // miAuthorizationTypes
            // 
            this.miAuthorizationTypes.Index = 2;
            this.miAuthorizationTypes.Text = "Authorization Types";
            this.miAuthorizationTypes.Click += new System.EventHandler(this.miAuthorizationTypes_Click);
            // 
            // miCongressionalDistricts
            // 
            this.miCongressionalDistricts.Index = 3;
            this.miCongressionalDistricts.Text = "Congressional Districts";
            this.miCongressionalDistricts.Click += new System.EventHandler(this.miCongressionalDistrict_Click);
            // 
            // miContractType
            // 
            this.miContractType.Index = 4;
            this.miContractType.Text = "Contract  Types";
            this.miContractType.Click += new System.EventHandler(this.miContractType_Click);
            // 
            // miMonitorOutcome
            // 
            this.miMonitorOutcome.Index = 5;
            this.miMonitorOutcome.Text = "Monitor Outcome";
            this.miMonitorOutcome.Click += new System.EventHandler(this.miMonitorOutcome_Click);
            // 
            // miProgramType
            // 
            this.miProgramType.Index = 6;
            this.miProgramType.Text = "Program Types";
            this.miProgramType.Click += new System.EventHandler(this.miProgramType_Click);
            // 
            // miProjectStatus
            // 
            this.miProjectStatus.Index = 7;
            this.miProjectStatus.Text = "Project Status";
            this.miProjectStatus.Visible = false;
            this.miProjectStatus.Click += new System.EventHandler(this.miProjectStatus_Click);
            // 
            // miProjectType
            // 
            this.miProjectType.Index = 8;
            this.miProjectType.Text = "Project Types";
            this.miProjectType.Click += new System.EventHandler(this.miProjectType_Click);
            // 
            // miRelationTypes
            // 
            this.miRelationTypes.Index = 9;
            this.miRelationTypes.Text = "Relation Types";
            this.miRelationTypes.Click += new System.EventHandler(this.miRelationTypes_Click);
            // 
            // miRegion
            // 
            this.miRegion.Index = 10;
            this.miRegion.Text = "Regions";
            this.miRegion.Click += new System.EventHandler(this.miRegion_Click);
            // 
            // miReimbType
            // 
            this.miReimbType.Index = 11;
            this.miReimbType.Text = "Reimbursement Types";
            this.miReimbType.Click += new System.EventHandler(this.miReimbType_Click);
            // 
            // miStaff
            // 
            this.miStaff.Index = 12;
            this.miStaff.Text = "Staff";
            this.miStaff.Click += new System.EventHandler(this.miStaff_Click);
            // 
            // miStateSenateDistricts
            // 
            this.miStateSenateDistricts.Index = 13;
            this.miStateSenateDistricts.Text = "State Senate Districts";
            this.miStateSenateDistricts.Click += new System.EventHandler(this.miStateSenateDistrict_Click);
            // 
            // miObjectives
            // 
            this.miObjectives.Index = 14;
            this.miObjectives.Text = "Strategic Objectives";
            this.miObjectives.Click += new System.EventHandler(this.miObjectives_Click);
            // 
            // miWatershed
            // 
            this.miWatershed.Index = 15;
            this.miWatershed.Text = "Watershed";
            this.miWatershed.Click += new System.EventHandler(this.miWatershed_Click);
            // 
            // menuItem11
            // 
            this.menuItem11.Index = 5;
            this.menuItem11.Text = "-";
            // 
            // miManageContacts
            // 
            this.miManageContacts.Index = 6;
            this.miManageContacts.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem22});
            this.miManageContacts.Text = "Contact";
            // 
            // menuItem22
            // 
            this.menuItem22.Index = 0;
            this.menuItem22.Text = "Contacts";
            this.menuItem22.Click += new System.EventHandler(this.menuItem22_Click);
            // 
            // miAdminOrganization
            // 
            this.miAdminOrganization.Index = 7;
            this.miAdminOrganization.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem20,
            this.miOrganizationRole,
            this.menuItem19});
            this.miAdminOrganization.Text = "Organizations";
            this.miAdminOrganization.Click += new System.EventHandler(this.miAdminOrganization_Click);
            // 
            // menuItem20
            // 
            this.menuItem20.Index = 0;
            this.menuItem20.Text = "Organization";
            this.menuItem20.Click += new System.EventHandler(this.menuItem20_Click);
            // 
            // miOrganizationRole
            // 
            this.miOrganizationRole.Index = 1;
            this.miOrganizationRole.Text = "Organization Role";
            this.miOrganizationRole.Click += new System.EventHandler(this.miOrganizationRole_Click);
            // 
            // menuItem19
            // 
            this.menuItem19.Index = 2;
            this.menuItem19.Text = "Organization Type";
            this.menuItem19.Click += new System.EventHandler(this.menuItem19_Click);
            // 
            // miProjectCities
            // 
            this.miProjectCities.Index = 8;
            this.miProjectCities.Text = "City";
            this.miProjectCities.Click += new System.EventHandler(this.miProjectCities_Click);
            // 
            // miProjectCounties
            // 
            this.miProjectCounties.Index = 9;
            this.miProjectCounties.Text = "County";
            this.miProjectCounties.Click += new System.EventHandler(this.miProjectCounties_Click);
            // 
            // miProjectRegions
            // 
            this.miProjectRegions.Index = 10;
            this.miProjectRegions.Text = "Region";
            this.miProjectRegions.Click += new System.EventHandler(this.miProjectRegions_Click);
            // 
            // miAdminFundingSource
            // 
            this.miAdminFundingSource.Index = 11;
            this.miAdminFundingSource.Text = "Funding Sources";
            this.miAdminFundingSource.Click += new System.EventHandler(this.miAdminFundingSource_Click);
            // 
            // miAdminFiscalYears
            // 
            this.miAdminFiscalYears.Index = 12;
            this.miAdminFiscalYears.Text = "Fiscal Years";
            this.miAdminFiscalYears.Click += new System.EventHandler(this.miAdminFiscalYears_Click);
            // 
            // miDynamicDropdowns
            // 
            this.miDynamicDropdowns.Index = 13;
            this.miDynamicDropdowns.Text = "Dynamic Dropdowns";
            this.miDynamicDropdowns.Click += new System.EventHandler(this.miDynamicDropdowns_Click);
            // 
            // miDynamicMultiSelect
            // 
            this.miDynamicMultiSelect.Index = 14;
            this.miDynamicMultiSelect.Text = "Dynamic Multi-select";
            this.miDynamicMultiSelect.Click += new System.EventHandler(this.miDynamicMultiSelect_Click);
            // 
            // miUnlockProjects
            // 
            this.miUnlockProjects.Index = 1;
            this.miUnlockProjects.Text = "Unlock All Projects";
            this.miUnlockProjects.Click += new System.EventHandler(this.miUnlockProjects_Click);
            // 
            // miSendAlerts
            // 
            this.miSendAlerts.Index = 2;
            this.miSendAlerts.Text = "Send Alerts";
            this.miSendAlerts.Click += new System.EventHandler(this.miSendAlerts_Click);
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miFile,
            this.miEdit,
            this.miUsers,
            this.miContract,
            this.menuItem23,
            this.miWindow});
            // 
            // miEdit
            // 
            this.miEdit.Index = 1;
            this.miEdit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem4,
            this.menuItem29,
            this.menuItem30,
            this.menuItem32,
            this.menuItem33});
            this.miEdit.Text = "Edit";
            // 
            // menuItem4
            // 
            this.menuItem4.Index = 0;
            this.menuItem4.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miEditGeneral,
            this.menuItem5,
            this.miDeleteProject});
            this.menuItem4.Text = "Project";
            // 
            // miEditGeneral
            // 
            this.miEditGeneral.Index = 0;
            this.miEditGeneral.Text = "Edit General Information";
            this.miEditGeneral.Click += new System.EventHandler(this.miEditGeneral_Click);
            // 
            // menuItem5
            // 
            this.menuItem5.Index = 1;
            this.menuItem5.Text = "-";
            // 
            // miDeleteProject
            // 
            this.miDeleteProject.Index = 2;
            this.miDeleteProject.Text = "Delete Project";
            this.miDeleteProject.Click += new System.EventHandler(this.miDeleteProject_Click);
            // 
            // menuItem29
            // 
            this.menuItem29.Index = 1;
            this.menuItem29.Text = "-";
            // 
            // menuItem30
            // 
            this.menuItem30.Index = 2;
            this.menuItem30.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miAddLink,
            this.miEditLink,
            this.menuItem31,
            this.miDeleteLink});
            this.menuItem30.Text = "Project Links";
            // 
            // miAddLink
            // 
            this.miAddLink.Index = 0;
            this.miAddLink.Text = "Add Link";
            this.miAddLink.Click += new System.EventHandler(this.miAddLink_Click);
            // 
            // miEditLink
            // 
            this.miEditLink.Index = 1;
            this.miEditLink.Text = "Edit Link Description";
            this.miEditLink.Click += new System.EventHandler(this.miEditLink_Click);
            // 
            // menuItem31
            // 
            this.menuItem31.Index = 2;
            this.menuItem31.Text = "-";
            // 
            // miDeleteLink
            // 
            this.miDeleteLink.Index = 3;
            this.miDeleteLink.Text = "Delete Link";
            this.miDeleteLink.Click += new System.EventHandler(this.miDeleteLink_Click);
            // 
            // menuItem32
            // 
            this.menuItem32.Index = 3;
            this.menuItem32.Text = "-";
            // 
            // menuItem33
            // 
            this.menuItem33.Index = 4;
            this.menuItem33.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miAddRelatedProject,
            this.miEditRelatedProject,
            this.menuItem34,
            this.miDeleteRelatedProject});
            this.menuItem33.Text = "Related Projects";
            // 
            // miAddRelatedProject
            // 
            this.miAddRelatedProject.Index = 0;
            this.miAddRelatedProject.Text = "Add Related Project";
            this.miAddRelatedProject.Click += new System.EventHandler(this.miAddRelatedProject_Click);
            // 
            // miEditRelatedProject
            // 
            this.miEditRelatedProject.Index = 1;
            this.miEditRelatedProject.Text = "Edit Related Project";
            this.miEditRelatedProject.Click += new System.EventHandler(this.miEditRelatedProject_Click);
            // 
            // menuItem34
            // 
            this.menuItem34.Index = 2;
            this.menuItem34.Text = "-";
            // 
            // miDeleteRelatedProject
            // 
            this.miDeleteRelatedProject.Index = 3;
            this.miDeleteRelatedProject.Text = "Delete Related Project";
            this.miDeleteRelatedProject.Click += new System.EventHandler(this.miDeleteRelatedProject_Click);
            // 
            // miContract
            // 
            this.miContract.Index = 3;
            this.miContract.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miAddContract,
            this.menuItem6,
            this.miOpenContract,
            this.miOpenInvoice,
            this.menuItem13,
            this.miNewContract,
            this.miActiveContractLog,
            this.miInvoiceLog,
            this.miRepayLog,
            this.menuItem17,
            this.miCompleteLog,
            this.miClosedLog,
            this.menuItem16,
            this.miContractsFundingSource,
            this.menuItem12,
            this.menuItem7});
            this.miContract.Text = "Contracts";
            // 
            // miAddContract
            // 
            this.miAddContract.Index = 0;
            this.miAddContract.Text = "Add new Contract";
            this.miAddContract.Click += new System.EventHandler(this.miAddContract_Click);
            // 
            // menuItem6
            // 
            this.menuItem6.Index = 1;
            this.menuItem6.Text = "-";
            // 
            // miOpenContract
            // 
            this.miOpenContract.Index = 2;
            this.miOpenContract.Text = "Open existing Contract details ";
            this.miOpenContract.Click += new System.EventHandler(this.miOpenContract_Click);
            // 
            // miOpenInvoice
            // 
            this.miOpenInvoice.Index = 3;
            this.miOpenInvoice.Text = "Open Contract Invoice Drawdown sheet";
            this.miOpenInvoice.Click += new System.EventHandler(this.miOpenInvoice_Click);
            // 
            // menuItem13
            // 
            this.menuItem13.Index = 4;
            this.menuItem13.Text = "-";
            // 
            // miNewContract
            // 
            this.miNewContract.Index = 5;
            this.miNewContract.Text = "New Contracts/Amendments log";
            this.miNewContract.Click += new System.EventHandler(this.miNewContract_Click);
            // 
            // miActiveContractLog
            // 
            this.miActiveContractLog.Index = 6;
            this.miActiveContractLog.Text = "Active Contracts log";
            this.miActiveContractLog.Click += new System.EventHandler(this.miActiveContractLog_Click);
            // 
            // miInvoiceLog
            // 
            this.miInvoiceLog.Index = 7;
            this.miInvoiceLog.Text = "Invoices log";
            this.miInvoiceLog.Click += new System.EventHandler(this.miInvoiceLog_Click);
            // 
            // miRepayLog
            // 
            this.miRepayLog.Index = 8;
            this.miRepayLog.Text = "Repayment log";
            this.miRepayLog.Click += new System.EventHandler(this.miRepayLog_Click);
            // 
            // menuItem17
            // 
            this.menuItem17.Index = 9;
            this.menuItem17.Text = "Monitoring log";
            this.menuItem17.Click += new System.EventHandler(this.menuItem17_Click);
            // 
            // miCompleteLog
            // 
            this.miCompleteLog.Index = 10;
            this.miCompleteLog.Text = "Complete (20 yr) Contracts log";
            this.miCompleteLog.Click += new System.EventHandler(this.miCompleteLog_Click);
            // 
            // miClosedLog
            // 
            this.miClosedLog.Index = 11;
            this.miClosedLog.Text = "Closed Contracts log";
            this.miClosedLog.Click += new System.EventHandler(this.miClosedLog_Click);
            // 
            // menuItem16
            // 
            this.menuItem16.Index = 12;
            this.menuItem16.Text = "-";
            // 
            // miContractsFundingSource
            // 
            this.miContractsFundingSource.Index = 13;
            this.miContractsFundingSource.Text = "Active Contracts by Fund Source log";
            this.miContractsFundingSource.Click += new System.EventHandler(this.miContractsFundingSource_Click);
            // 
            // menuItem12
            // 
            this.menuItem12.Index = 14;
            this.menuItem12.Text = "-";
            // 
            // menuItem7
            // 
            this.menuItem7.Index = 15;
            this.menuItem7.Text = "Agreement Expiration Alert and Modification Forms";
            this.menuItem7.Click += new System.EventHandler(this.menuItem7_Click);
            // 
            // menuItem23
            // 
            this.menuItem23.Index = 4;
            this.menuItem23.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miQueryTool});
            this.menuItem23.Text = "Query";
            // 
            // miQueryTool
            // 
            this.miQueryTool.Index = 0;
            this.miQueryTool.Text = "Query Tool";
            this.miQueryTool.Click += new System.EventHandler(this.miQueryTool_Click);
            // 
            // miWindow
            // 
            this.miWindow.Index = 5;
            this.miWindow.MdiList = true;
            this.miWindow.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miArrange,
            this.miCascade,
            this.miTileVertical,
            this.miTileHoriz,
            this.menuItem3,
            this.miCloseAll,
            this.miSize,
            this.miSize1024});
            this.miWindow.Text = "Window";
            // 
            // miArrange
            // 
            this.miArrange.Index = 0;
            this.miArrange.Text = "Arrange Icons";
            this.miArrange.Click += new System.EventHandler(this.miArrange_Click);
            // 
            // miCascade
            // 
            this.miCascade.Index = 1;
            this.miCascade.Text = "Cascade";
            this.miCascade.Click += new System.EventHandler(this.miCascade_Click);
            // 
            // miTileVertical
            // 
            this.miTileVertical.Index = 2;
            this.miTileVertical.Text = "Tile Vertically";
            this.miTileVertical.Click += new System.EventHandler(this.miTile_Click);
            // 
            // miTileHoriz
            // 
            this.miTileHoriz.Index = 3;
            this.miTileHoriz.Text = "Tile Horizontally";
            this.miTileHoriz.Click += new System.EventHandler(this.miTileHoriz_Click);
            // 
            // menuItem3
            // 
            this.menuItem3.Index = 4;
            this.menuItem3.Text = "-";
            // 
            // miCloseAll
            // 
            this.miCloseAll.Index = 5;
            this.miCloseAll.Text = "Close All";
            this.miCloseAll.Click += new System.EventHandler(this.miCloseAll_Click);
            // 
            // miSize
            // 
            this.miSize.Index = 6;
            this.miSize.Text = "Size 1280x1024";
            this.miSize.Click += new System.EventHandler(this.miSize_Click);
            // 
            // miSize1024
            // 
            this.miSize1024.Index = 7;
            this.miSize1024.Text = "Size 1024x768";
            this.miSize1024.Click += new System.EventHandler(this.miSize1024_Click);
            // 
            // miAddMatchingFund
            // 
            this.miAddMatchingFund.Index = -1;
            this.miAddMatchingFund.Text = "";
            // 
            // miEditMatchingFund
            // 
            this.miEditMatchingFund.Index = -1;
            this.miEditMatchingFund.Text = "";
            // 
            // menuItem25
            // 
            this.menuItem25.Index = -1;
            this.menuItem25.Text = "";
            // 
            // miDeleteMatchingFund
            // 
            this.miDeleteMatchingFund.Index = -1;
            this.miDeleteMatchingFund.Text = "";
            // 
            // pnlYellow
            // 
            this.pnlYellow.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.pnlYellow.BackColor = System.Drawing.Color.Yellow;
            this.pnlYellow.Location = new System.Drawing.Point(0, -20);
            this.pnlYellow.Margin = new System.Windows.Forms.Padding(0, 0, 3, 3);
            this.pnlYellow.Name = "pnlYellow";
            this.pnlYellow.Size = new System.Drawing.Size(1278, 25);
            this.pnlYellow.TabIndex = 1;
            this.pnlYellow.Visible = false;
            // 
            // ultraTabbedMdiManager1
            // 
            this.ultraTabbedMdiManager1.MdiParent = this;
            this.ultraTabbedMdiManager1.TabGroupSettings.CloseButtonLocation = Infragistics.Win.UltraWinTabs.TabCloseButtonLocation.Tab;
            this.ultraTabbedMdiManager1.TabSettings.CloseButtonAlignment = Infragistics.Win.UltraWinTabs.TabCloseButtonAlignment.AfterContent;
            this.ultraTabbedMdiManager1.TabSettings.CloseButtonVisibility = Infragistics.Win.UltraWinTabs.TabCloseButtonVisibility.Always;
            this.ultraTabbedMdiManager1.ViewStyle = Infragistics.Win.UltraWinTabbedMdi.ViewStyle.Office2007;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.SystemColors.Control;
            this.ClientSize = new System.Drawing.Size(1278, 725);
            this.Controls.Add(this.pnlYellow);
            this.IsMdiContainer = true;
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Coastal Conservancy Project Manager";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.Shown += new System.EventHandler(this.Form1_Shown);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.Form1_FormClosing);
            ((System.ComponentModel.ISupportInitialize)(this.ultraTabbedMdiManager1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application. Only one instance of the
        /// application is allowed to run.
        /// </summary>	
        [STAThread]
        public static void Main()
        {
            //Get the running instance.
            Process instance = RunningInstance();
            if (instance == null)
            {
                // ADS 21-March-2008 - Added unhandled exception processing
                CCPM.ExceptionHandler.AddHandler(true, true, true);

                //There isn't another instance, show our form.
                try
                {
                    //GlobalSettings.IsTestDB = true;
                    Application.Run(new Form1());
                }
                catch (Exception ex) { }
            }
            else
            {
                //There is another instance of this process.
                HandleRunningInstance(instance);
            }
        }

        public static Process RunningInstance()
        {
            Process current = Process.GetCurrentProcess();
            Process[] processes = Process.GetProcessesByName(current.ProcessName);

            foreach (Process process in processes)
            {
                //Ignore the current process
                if (process.Id != current.Id)
                {
                    //Make sure that the process is running from the exe file.
                    if (Assembly.GetExecutingAssembly().Location.Replace("/", "\\") ==
                        current.MainModule.FileName)
                    {
                        //Return the other process instance.
                        return process;
                    }
                }
            }

            //No other instance was found.
            return null;
        }

        public static void HandleRunningInstance(Process instance)
        {
            //Make sure the window is not minimized or maximized
            ShowWindowAsync(instance.MainWindowHandle, WS_SHOWNORMAL);

            //Set the real intance to foreground window
            SetForegroundWindow(instance.MainWindowHandle);
        }

        [DllImport("User32.dll")]
        private static extern bool ShowWindowAsync(
            IntPtr hWnd, int cmdShow);
        [DllImport("User32.dll")]
        private static extern bool
            SetForegroundWindow(IntPtr hWnd);
        private const int WS_SHOWNORMAL = 1;


        #region Event Handlers for the Window Menu
        private void miArrange_Click(object sender, System.EventArgs e)
        {
            this.LayoutMdi(MdiLayout.ArrangeIcons);
        }

        private void miCascade_Click(object sender, System.EventArgs e)
        {
            this.LayoutMdi(MdiLayout.Cascade);
        }

        private void miTile_Click(object sender, System.EventArgs e)
        {
            this.LayoutMdi(MdiLayout.TileVertical);
        }

        private void miTileHoriz_Click(object sender, System.EventArgs e)
        {
            this.LayoutMdi(MdiLayout.TileHorizontal);
        }
        #endregion

        /// <summary>
        /// Authenticate the user by matching their local Machine name to
        ///computers on file. If no match is found a user can enter a username and password
        ///for optional "roaming" (a user who is not at thier computer) access.
        ///Authorization is managed by altering the application main menu.
        ///A Generic Identity and Principal objects are created and assigned
        ///to the Thread.CurrentPrincipal property. A try catch is placed around 
        ///the login routine to try to limit a forced exception vulnerability.
        /// </summary>.
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, System.EventArgs e)
        {
            this.WindowState = FormWindowState.Maximized;

            try
            {
                WindowsIdentity wi = WindowsIdentity.GetCurrent();
                int slash = wi.Name.LastIndexOf(@"\");
                string logonUserName = wi.Name.Substring(slash + 1);
                GlobalSettings.userid = logonUserName;

                string hostName = System.Net.Dns.GetHostName();
                int roleId;
                this.setBanner();
                DataSet ds = CCPM.Data.UserData.GetUserByUsername(logonUserName);

                if (ds.Tables[0].Rows.Count > 0)     //User exists
                {
                    GlobalSettings.UserId = Convert.ToInt32(ds.Tables[0].Rows[0]["UserId"]);
                    GlobalSettings.UserName = Convert.ToString(ds.Tables[0].Rows[0]["Username"]);
                    GlobalSettings.SetSecurity();
                    //this.SetPrincipal(logonUserName, ((UserRole)roleId).ToString());
                }
                else    //User not on file so offer roaming user logon
                {
                    //Get roaming user
                    RoamingUserLogin rul = new RoamingUserLogin();
                    rul.ShowDialog(this);
                    if (rul.DialogResult != DialogResult.OK)
                    {
                        this.Close();
                    }
                }

                this.setBanner();
                this.SetSecurity();
                this.SetRecentProjectMenu();

                this.IsMdiContainer = true;

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "System Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                this.Close();
            }

            //load last screen settings
            int n = 0;
            n = GlobalCode.ToInt32(ConfigurationSettings.AppSettings["ScreenWidth"]);
            if (n > 0)
                this.Width = n;
            n = GlobalCode.ToInt32(ConfigurationSettings.AppSettings["ScreenHeight"]);
            if (n > 0)
                this.Height = n;
            n = GlobalCode.ToInt32(ConfigurationSettings.AppSettings["ScreenTop"]);
            if (n > 0)
                this.Top = n;
            n = GlobalCode.ToInt32(ConfigurationSettings.AppSettings["ScreenLeft"]);
            if (n > 0)
                this.Left = n;


            //if (Screen.PrimaryScreen.Bounds.Width < 1280)
            //    ClientSize = new System.Drawing.Size(1024, 720);

            if (GlobalSettings.IsTestDB)
            {
                ultraTabbedMdiManager1.Appearance.BackColor = Color.Yellow;
            }
        }

        private void setBanner()
        {
            // MAR 2005-02-08 - added
            string dbConnString = "";

            if (GlobalSettings.IsTestDB)
            {
                dbConnString = GlobalSettings.TestConnectionString;//ConfigurationSettings.AppSettings["TestConnectionString"];
                CCPM.Data.DbConnection.GetDbConnection().DbConnectionString = dbConnString;
            }
            else
            {
                dbConnString = GlobalSettings.ConnectionStringCCPM3;//ConfigurationSettings.AppSettings["connectionStringCCPM3"];
            }

            GlobalSettings.ConnectionString = dbConnString;

            string devServer = ConfigurationSettings.AppSettings["DevelopmentServer"];
            string testServer = ConfigurationSettings.AppSettings["TestServer"];

            if (dbConnString.IndexOf(devServer) > 0)
            {
                this.Text = "Coastal Conservancy Project Manager  (** DEV DATABASE **)  ";
                pnlYellow.Visible = true;
            }
            else if (GlobalSettings.IsTestDB)       //dbConnString.IndexOf(testServer) > 0
            {
                this.Text = "Coastal Conservancy Project Manager   (** TEST DATABASE **)  ";
                pnlYellow.Visible = true;               
            }
        }

        //Centralize allert messages
        private void ShowAlertMsg(AlertMessageType msgType)
        {
            switch (msgType)
            {
                case AlertMessageType.MasterListNotFound:
                    MessageBox.Show("Master Contact List is not open! Please open Master Contact list first.");
                    break;
                case AlertMessageType.ProjectNotFound:
                    MessageBox.Show("No project found to work with! Please open a project first.");
                    break;
                case AlertMessageType.ContactNotFound:
                    MessageBox.Show("No contact selection found! Please select a contact to work with.");
                    break;
            }
        }
        public void DisableMenusAll()
        {
            this.miFile.Enabled = false;
            this.miEdit.Enabled = false;
            if (this.miUsers.Visible == true)
            {
                this.miUsers.Enabled = false;
            }
            this.miWindow.Enabled = false;
        }
        public void EnableMenusAll()
        {
            this.miFile.Enabled = true;
            this.miEdit.Enabled = true;
            if (this.miUsers.Visible == true)
            {
                this.miUsers.Enabled = true;
            }
            this.miWindow.Enabled = true;
        }

        //#region User Management Event Handlers
        //private void miAddUser_Click(object sender, System.EventArgs e)
        //{
        //    CreateUser createUser = new CreateUser();
        //    createUser.ShowDialog(this);
        //    if(createUser.DialogResult == DialogResult.OK)
        //    {
        //        this.LoadManageUser(createUser.UserInsertResult);
        //    }
        //}


        //private void miUpdateUser_Click(object sender, System.EventArgs e)
        //{
        //    this.LoadManageUser(0);
        //}

        //#endregion

        public void miExit_Click(object sender, System.EventArgs e)
        {
            this.Close();
        }

        private void miCloseAll_Click(object sender, System.EventArgs e)
        {
            foreach (Form form in this.MdiChildren)
            {
                form.Close();
            }
        }

        /*The menu items that are concerned with project related commands
        call the event handlers for the context meu items on each of the
        User Controls that are loaded by CCPM.Project.ProjectForm.cs.*/
        #region Project Event Handlers
        private void miOpenProject_Click(object sender, System.EventArgs e)
        {
            OpenProjectForm();
        }

        private void miNewProject_Click(object sender, System.EventArgs e)
        {
            CCPM.Project.ProjectCreateOrUpdate newProject = new CCPM.Project.ProjectCreateOrUpdate();
            //newProject.Width = 730;
            //newProject.Height = 555;
            DialogResult dr = newProject.ShowDialog(this);
            if (dr == DialogResult.OK)
            {
                this.OpenProject(newProject.ProjectId, "New Project");
            }
        }


        private void miRecentProject_Click(object sender, System.EventArgs e)
        {
            string projectName = ((MenuItem)sender).Text;
            int projectId = CCPM.Data.ProjectData.GetProjectId(projectName);
            this.OpenProject(projectId, projectName);
        }

        //Populate recent project menu
        private void miFile_Select(object sender, System.EventArgs e)
        {
            this.SetRecentProjectMenu();
        }


        private void miSearchProjects_Click(object sender, System.EventArgs e)
        {
            OpenProjectSearch();
        }


        private void miDeleteProject_Click(object sender, System.EventArgs e)
        {
            bool found = false;
            for (int i = 0; i < MdiChildren.Length; i++)
            {
                if (MdiChildren[i] as CCPM.Project.ProjectForm != null)
                {
                    if (((CCPM.Project.ProjectForm)MdiChildren[i]).ProjectId == this.CurrentProjectFocus)
                    {
                        CCPM.Project.ProjectForm projectForm = (CCPM.Project.ProjectForm)MdiChildren[i];
                        DialogResult dialogResult = MessageBox.Show(
                            string.Concat("You are about to delete a project!\nAre you sure you want to do this?",
                            "\nProject Name: ",
                            projectForm.ProjectName,
                            "\nFile Number: ",
                            projectForm.FileNumber),
                            "Delete Record Confirmation",
                            MessageBoxButtons.OKCancel,
                            MessageBoxIcon.Stop);
                        if (dialogResult == DialogResult.OK)
                        {
                            if (ProjectData.ProjectHasContracts(this.CurrentProjectFocus))
                            {
                                MessageBox.Show("Can't delete a project with contracts.  Delete the contracts first.", "Project Contract(s)", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                return;
                            }
                            ProjectData.ProjectDelete(this.CurrentProjectFocus);
                            //Close the form for the record being deleted
                            projectForm.Close();
                        }

                        found = true;
                    }
                }
            }

            if (!found) MessageBox.Show("No project found to delete");
        }


        private void miEditGeneral_Click(object sender, System.EventArgs e)
        {
            CCPM.Project.ProjectForm projectForm = null;
            this.GetCurrentProject(out projectForm);
            if (projectForm != null)
            {
                projectForm.Focus();
                projectForm.EditProjectGeneralInfoHandler(sender, e);
            }
            else
            {
                MessageBox.Show("No project found to work with! Please open a project first.");
            }
        }

        #endregion

        #region Project Related-Table-Management Event Handlers
        private void miAttorney_Click(object sender, System.EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ProjectAttorneyList);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ProjectAttorneyInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ProjectAttorneyUpdate);

            ManageBase manageAttorney = new ManageBase(populateMethod, insertMethod, updateMethod, "Name", "AttorneyId", "Manage Project Attorneys");
            OpenForm(manageAttorney, "Manage Project Attorneys");
        }

        private void miStaff_Click(object sender, System.EventArgs e)
        {
            //ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ProjectStaffList);
            //ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ProjectStaffInsert);
            //ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ProjectStaffUpdate);

            //ManageBase manageStaff = new ManageBase(populateMethod, insertMethod, updateMethod, "Name", "ProjectManagerId", "Manage Project Staff");
            //manageStaff.MdiParent = this;
            //manageStaff.Show();
            StaffMain sm = new StaffMain();
            OpenForm(sm, "Manage Project Staff");
        }

        private void miProjectType_Click(object sender, System.EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(CCPM.Data.ProjectData.ProjectTypeList);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(CCPM.Data.ProjectData.ProjectTypeInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(CCPM.Data.ProjectData.ProjectTypeUpdate);
            ManageBase.DeleteMethod deleteMethod = new ManageBase.DeleteMethod(CCPM.Data.ProjectData.ProjectTypeDelete);

            ManageBase manageType = new ManageBase(populateMethod, insertMethod, updateMethod, deleteMethod, "ProjectType", "ProjectTypeId", true, true, "Manage Project Types");
            OpenForm(manageType, "Manage Project Types");
        }

        private void miProgramType_Click(object sender, System.EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ProjectProgramTypeList);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ProjectProgramTypeInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ProjectProgramTypeUpdate);

            ManageBase manageProgramType = new ManageBase(populateMethod, insertMethod, updateMethod, "ProgramType", "ProgramTypeId", "Manage Pgrogram Type");
            OpenForm(manageProgramType, "Manage Pgrogram Type");
        }
        private void miCounty_Click(object sender, System.EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ProjectCountyList);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ProjectCountyInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ProjectCountyUpdate);

            ManageBase manageCounty = new ManageBase(populateMethod, insertMethod, updateMethod, "CountyName", "CountyId", "Manage Countys");
            OpenForm(manageCounty, "Manage Counties");
        }

        private void miCities_Click(object sender, System.EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ProjectCityList);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ProjectCityInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ProjectCityUpdate);

            ManageBase manageCity = new ManageBase(populateMethod, insertMethod, updateMethod, "CityName", "CityId", "Manage Cities");
            OpenForm(manageCity, "Manage Cities");
        }

        private void miRegion_Click(object sender, System.EventArgs e)
        {
            //ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ProjectRegionList);
            //ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ProjectRegionInsert);
            //ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ProjectRegionUpdate);

            //ManageBase manageRegion = new ManageBase(populateMethod, insertMethod, updateMethod, "Region", "RegionId", "Manage Regions");
            //manageRegion.MdiParent = this;
            //manageRegion.Show();

            GridEdit ge = new GridEdit("ProjectRegion");
            OpenForm(ge, "Edit Project Regions");

        }
        private void miWatershed_Click(object sender, System.EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ProjectWatershedList);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ProjectWatershedInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ProjectWatershedUpdate);
            ManageBase.DeleteMethod deleteMethod = new ManageBase.DeleteMethod(CCPM.Data.ProjectData.ProjectWatershedDelete);

            ManageBase manageWatershed = new ManageBase(populateMethod, insertMethod, updateMethod, deleteMethod, "Watershed", "WatershedID", true, true, "Manage Watersheds");
            OpenForm(manageWatershed, "Manage Watersheds");
        }
        private void miAssemblyDistrict_Click(object sender, System.EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ProjectAssemblyDistrictList);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ProjectAssemblyDistrictInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ProjectAssemblyDistrictUpdate);

            ManageDistricts manageAssemblyDistrict = new ManageDistricts(populateMethod, insertMethod, updateMethod, "AssemblyDistrictNumber", "AssemblyDistrictId", "Manage Assembly Districts");
            OpenForm(manageAssemblyDistrict, "Manage Assembly Districts");
        }
        private void miStateSenateDistrict_Click(object sender, System.EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ProjectStateSenateDistrictList);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ProjectStateSenateDistrictInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ProjectStateSenateDistrictUpdate);

            ManageDistricts manageStateSenateDistrict = new ManageDistricts(populateMethod, insertMethod, updateMethod, "StateSenateDistrictNumber", "StateSenateDistrictId", "Manage State Senate Districts");
            OpenForm(manageStateSenateDistrict, "Manage State Senate Districts");
        }
        private void miCongressionalDistrict_Click(object sender, System.EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ProjectCongressionalDistrictList);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ProjectCongressionalDistrictInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ProjectCongressionalDistrictUpdate);

            ManageDistricts manageCongressionalDistrict = new ManageDistricts(populateMethod, insertMethod, updateMethod, "CongressionalDistrictNumber", "CongressionalDistrictId", "Manage Congressional Districts");
            OpenForm(manageCongressionalDistrict, "Manage Congressional Districts");
        }
        #endregion

        #region Contact Event Handlers

        #region Project Contact Event Handlers
        //Get an instance of MasterDetailControl from the current project of focus.
        private CCPM.Contact.MasterDetailControl GetMasterDetialControl()
        {
            CCPM.Project.ProjectForm projectForm = null;
            CCPM.Contact.MasterDetailControl mdc = null;
            GetCurrentProject(out projectForm);
            if (projectForm != null)
            {
                //Set the project tab control to the contacts tab.
                projectForm.SetTabIndex(1);
                mdc = projectForm.GetMasterDetailControl;
                if (mdc == null)
                {
                    ShowAlertMsg(AlertMessageType.ContactNotFound);
                }
            }
            else
            {
                this.ShowAlertMsg(AlertMessageType.ProjectNotFound);
            }

            return mdc;
        }
        //Associate an existing contact with a project
        private void miAddExistingContact_Click(object sender, System.EventArgs e)
        {
            CCPM.Contact.MasterDetailControl mdc = GetMasterDetialControl();
            if (mdc != null)
            {
                mdc.miAddExisting_Click(sender, e);
            }
        }
        //Associate a new contact with a project.
        private void miAssociateNewContact_Click(object sender, System.EventArgs e)
        {
            CCPM.Contact.MasterDetailControl mdc = GetMasterDetialControl();
            if (mdc != null)
            {
                mdc.miAddNew_Click(sender, e);
            }

        }

        private void miRemoveContact_Click(object sender, System.EventArgs e)
        {
            CCPM.Contact.MasterDetailControl mdc = GetMasterDetialControl();
            if (mdc != null)
            {
                mdc.miRemove_Click(sender, e);
            }
        }

        //Edit project contact
        private void miEditContact_Click(object sender, System.EventArgs e)
        {
            CCPM.Contact.MasterDetailControl mdc = GetMasterDetialControl();
            if (mdc != null)
            {
                mdc.miEdit_Click(sender, e);
            }
        }
        //Clone project contact.
        private void miCloneContact_Click(object sender, System.EventArgs e)
        {
            CCPM.Contact.MasterDetailControl mdc = GetMasterDetialControl();
            if (mdc != null)
            {
                mdc.miClone_Click(sender, e);
            }
        }

        #endregion

        #region Master Contact List Event Handlers
        private void miOpenContacts_Click(object sender, System.EventArgs e)
        {
            ////Ensure only one instance of Master Contact List
            //bool found = false;
            //for (int i = 0; i < this.MdiChildren.Length; i++)
            //{
            //    if (MdiChildren[i].GetType() == typeof(CCPM.Project.Contacts))
            //    {
            //        MdiChildren[i].Focus();
            //        found = true;
            //        break;
            //    }
            //}
            //if (!found)
            //{
            //    CCPM.Project.Contacts md = new CCPM.Project.Contacts();
            //    md.MdiParent = this;
            //    md.Location = new Point(0, 0);
            //    md.Show();
            //}
        }
        private void miCloneMaster_Click(object sender, System.EventArgs e)
        {
            CCPM.Contact.MasterDetail md = GetMasterDetailForm();
            if (md != null)
            {
                md._MasterDetailControl.miClone_Click(sender, e);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.MasterListNotFound);
            }

        }

        private void miEditContactMaster_Click(object sender, System.EventArgs e)
        {
            CCPM.Contact.MasterDetail md = GetMasterDetailForm();
            if (md != null)
            {
                md._MasterDetailControl.miMasterEdit_Click(sender, e);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.MasterListNotFound);
            }

        }

        private void miNewContact_Click(object sender, System.EventArgs e)
        {
            CCPM.Contact.MasterDetail md = GetMasterDetailForm();
            if (md != null)
            {
                md._MasterDetailControl.miMasterAddNew_Click(sender, e);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.MasterListNotFound);
            }

        }

        private void miDeleteContact_Click(object sender, System.EventArgs e)
        {
            CCPM.Contact.MasterDetail md = GetMasterDetailForm();
            if (md != null)
            {
                md._MasterDetailControl.miDelete_Click(sender, e);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.MasterListNotFound);
            }
        }

        private void miCloseContact_Click(object sender, System.EventArgs e)
        {
            CCPM.Contact.MasterDetail md = GetMasterDetailForm();
            if (md != null)
            {
                md._MasterDetailControl.miClose_Click(sender, e);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.MasterListNotFound);
            }
        }
        #endregion

        #endregion

        #region Contact Administration Events
        private void miContactType_Click(object sender, System.EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ContactData.ContactTypeListManage);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ContactData.ContactTypeInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ContactData.ContactTypeUpdate);

            ManageBase manageProgramType = new ManageBase(populateMethod, insertMethod, updateMethod, "ContactType", "ContactTypeId", "Manage Contact Type");
            OpenForm(manageProgramType, "Manage Contact Type");
        }

        private void miContactOrgaizationType_Click(object sender, System.EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ContactData.OrganizationListManage);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ContactData.ContactOrganizationInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ContactData.ContactOrganizationUpdate);

            ManageBase manageProgramType = new ManageBase(populateMethod, insertMethod, updateMethod, "OrganizationType", "OrganizationTypeId", "Manage Contact Organization Type");
            OpenForm(manageProgramType, "Manage Contact Organization Type");
        }
        #endregion

        #region Funding Events
        //		private void miAddAuthorization_Click(object sender, System.EventArgs e)
        //		{
        //			CCPM.Project.ProjectForm projectForm = null;
        //			GetCurrentProject(out projectForm);
        //			if(projectForm != null)
        //			{
        //				//Set the project tab control to the Funding Tab.
        //				projectForm.SetTabIndex(2);
        //				//Call the same method that the context menu does.
        //				projectForm.miAddAuthorization_Click(this, EventArgs.Empty);
        //			}
        //			else
        //			{
        //				ShowAlertMsg(AlertMessageType.ProjectNotFound);
        //			}
        //		}
        //
        //		private void miEditAuthorization_Click(object sender, System.EventArgs e)
        //		{
        //			CCPM.Project.ProjectForm projectForm = null;
        //			GetCurrentProject(out projectForm);
        //			if(projectForm != null)
        //			{
        //				//Set the project tab control to the Funding Tab.
        //				projectForm.SetTabIndex(2);
        //				//Call the same method that the context menu does.
        //				projectForm.miEditAuthorization_Click(this, EventArgs.Empty);
        //			}
        //			else
        //			{
        //				ShowAlertMsg(AlertMessageType.ProjectNotFound);
        //			}
        //		}
        //		
        //		private void miDeleteAuthorization_Click(object sender, System.EventArgs e)
        //		{
        //			CCPM.Project.ProjectForm projectForm = null;
        //			GetCurrentProject(out projectForm);
        //			if(projectForm != null)
        //			{
        //				//Set the project tab control to the Funding Tab.
        //				projectForm.SetTabIndex(2);
        //				//Call the same method that the context menu does.
        //				projectForm.miDeleteAuthorization_Click(this, EventArgs.Empty);
        //			}
        //			else
        //			{
        //				ShowAlertMsg(AlertMessageType.ProjectNotFound);
        //			}
        //		}
        //		
        //		private void miAddMatchingFund_Click(object sender, System.EventArgs e)
        //		{
        //			CCPM.Project.ProjectForm projectForm = null;
        //			GetCurrentProject(out projectForm);
        //			if(projectForm != null)
        //			{
        //				//Set the project tab control to the Funding Tab.
        //				projectForm.SetTabIndex(2);
        //				//Call the same method that the context menu does.
        //				projectForm.miAddMatchingFund_Click(this, EventArgs.Empty);
        //			}
        //			else
        //			{
        //				ShowAlertMsg(AlertMessageType.ProjectNotFound);
        //			}
        //		}
        //
        //		private void miEditMatchingFund_Click(object sender, System.EventArgs e)
        //		{
        //			CCPM.Project.ProjectForm projectForm = null;
        //			GetCurrentProject(out projectForm);
        //			if(projectForm != null)
        //			{
        //				//Set the project tab control to the Funding Tab.
        //				projectForm.SetTabIndex(2);
        //				//Call the same method that the context menu does.
        //				projectForm.miEditMatchingFund_Click(this, EventArgs.Empty);
        //			}
        //			else
        //			{
        //				ShowAlertMsg(AlertMessageType.ProjectNotFound);
        //			}
        //		}
        //
        //		private void miDeleteMatchingFund_Click(object sender, System.EventArgs e)
        //		{
        //			CCPM.Project.ProjectForm projectForm = null;
        //			GetCurrentProject(out projectForm);
        //			if(projectForm != null)
        //			{
        //				//Set the project tab control to the Funding Tab.
        //				projectForm.SetTabIndex(2);
        //				//Call the same method that the context menu does.
        //				projectForm.miDeleteMatchingFund_Click(this, EventArgs.Empty);
        //			}
        //			else
        //			{
        //				ShowAlertMsg(AlertMessageType.ProjectNotFound);
        //			}
        //		}
        #endregion

        #region Image Events
        private void miAddImage_Click(object sender, System.EventArgs e)
        {
            CCPM.Project.ProjectForm projectForm = null;
            GetCurrentProject(out projectForm);
            if (projectForm != null)
            {
                //Set the project tab control to Project Images.
                projectForm.SetTabIndex(5);
                //Call the same method that the context menu does.
                projectForm.ImagesControl.miAddImage_Click(this, EventArgs.Empty);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.ProjectNotFound);
            }
        }

        #endregion

        #region Link Events
        private void miAddLink_Click(object sender, System.EventArgs e)
        {
            CCPM.Project.ProjectForm projectForm = null;
            GetCurrentProject(out projectForm);
            if (projectForm != null)
            {
                //Set the project tab control to Project Links.
                projectForm.SetTabIndex(6);
                //Call the same method that the context menu does.
                projectForm.LinkListControl.miAddLink_Click(this, EventArgs.Empty);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.ProjectNotFound);
            }
        }

        private void miEditLink_Click(object sender, System.EventArgs e)
        {
            CCPM.Project.ProjectForm projectForm = null;
            GetCurrentProject(out projectForm);
            if (projectForm != null)
            {
                //Set the project tab control to Project Links.
                projectForm.SetTabIndex(6);
                //Call the same method that the context menu does.
                projectForm.LinkListControl.miEditDescription_Click(this, EventArgs.Empty);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.ProjectNotFound);
            }
        }

        private void miDeleteLink_Click(object sender, System.EventArgs e)
        {
            CCPM.Project.ProjectForm projectForm = null;
            GetCurrentProject(out projectForm);
            if (projectForm != null)
            {
                //Set the project tab control to Project Links.
                projectForm.SetTabIndex(6);
                //Call the same method that the context menu does.
                projectForm.LinkListControl.miDeleteLink_Click(this, EventArgs.Empty);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.ProjectNotFound);
            }
        }
        #endregion

        #region Related Project Events
        private void miAddRelatedProject_Click(object sender, System.EventArgs e)
        {
            CCPM.Project.ProjectForm projectForm = null;
            GetCurrentProject(out projectForm);
            if (projectForm != null)
            {
                // ADS 15-Nov-2007 - Changed tab to show the related projects list
                //Set the project tab control to Related Project List.
                projectForm.SetTabIndex(7);
                //Call the same method that the context menu does.
                projectForm.RelatedProjectListControl.miAddRelatedProject_Click(this, EventArgs.Empty);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.ProjectNotFound);
            }
        }

        private void miEditRelatedProject_Click(object sender, System.EventArgs e)
        {
            CCPM.Project.ProjectForm projectForm = null;
            GetCurrentProject(out projectForm);
            if (projectForm != null)
            {
                // ADS 15-Nov-2007 - Changed tab to show the related projects list
                //Set the project tab control to Related Project List.
                projectForm.SetTabIndex(7);
                //Call the same method that the context menu does.
                projectForm.RelatedProjectListControl.miUpdate_Click(this, EventArgs.Empty);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.ProjectNotFound);
            }
        }

        private void miDeleteRelatedProject_Click(object sender, System.EventArgs e)
        {
            CCPM.Project.ProjectForm projectForm = null;
            GetCurrentProject(out projectForm);
            if (projectForm != null)
            {
                // ADS 15-Nov-2007 - Changed tab to show the related projects list
                //Set the project tab control to Related Project List.
                projectForm.SetTabIndex(7);
                //Call the same method that the context menu does.
                projectForm.RelatedProjectListControl.miDelete_Click(this, EventArgs.Empty);
            }
            else
            {
                ShowAlertMsg(AlertMessageType.ProjectNotFound);
            }
        }
        #endregion

        private void miObjectives_Click(object sender, System.EventArgs e)
        {
            Project.ManageObjective manageObjectives = new Project.ManageObjective();
            OpenForm(manageObjectives, "Manage Objectives");
        }

        private void miAdminOrganization_Click(object sender, System.EventArgs e)
        {
            Project.Organizations frmOrgs = new Project.Organizations();
            OpenForm(frmOrgs, "Manage Organizations");
        }

        private void miProjectCities_Click(object sender, System.EventArgs e)
        {
            Project.CodeTableAdmin frmAdmin = new CCPM.Project.CodeTableAdmin(CCPM.Project.CodeTableAdmin.CodeTable.City);
            OpenForm(frmAdmin, "Manage Cities");
        }

        private void miProjectCounties_Click(object sender, System.EventArgs e)
        {
            Project.CodeTableAdmin frmAdmin = new CCPM.Project.CodeTableAdmin(CCPM.Project.CodeTableAdmin.CodeTable.County);
            OpenForm(frmAdmin, "Manage Counties");
        }

        private void miProjectRegions_Click(object sender, System.EventArgs e)
        {
            GridEdit ge = new GridEdit("ProjectRegion");
            OpenForm(ge, "Manage Project Regions");
        }

        private void miAdminFundingSource_Click(object sender, System.EventArgs e)
        {
            Project.FundingSources frmFS = new Project.FundingSources();
            OpenForm(frmFS, "Manage Funding Sources");
        }

        private void miAdminFiscalYears_Click(object sender, System.EventArgs e)
        {
            Project.FiscalYear frmFY = new Project.FiscalYear();
            OpenForm(frmFY, "Manage Fiscal Years");
        }

        private void miUnlockProjects_Click(object sender, System.EventArgs e)
        {
            DialogResult intDiagResult = MessageBox.Show("Do you want to unlock all projects?", "Confirm",
                MessageBoxButtons.YesNo);
            if (intDiagResult == DialogResult.Yes)
            {
                if (ProjectData.ProjectUnlockAll() != "success")
                {
                    MessageBox.Show("Sorry. The unlock failed.", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                else
                {
                    MessageBox.Show("All projects are now unlocked.", "", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
        }

        private void miNewContract_Click(object sender, EventArgs e)
        {
            AmendmentsLog al1 = new AmendmentsLog();
            OpenForm(al1, "New Amendments Log");
        }

        private void miAddContract_Click(object sender, EventArgs e)
        {
            ProjectPicker pp = new ProjectPicker();
            OpenForm(pp, "New Contract: Project Picker");
        }

        private void miActiveContractLog_Click(object sender, EventArgs e)
        {
            ActiveContractLog ac1 = new ActiveContractLog();
            OpenForm(ac1, "Active Contracts Log");
        }

        private void miInvoiceLog_Click(object sender, EventArgs e)
        {
            InvoiceLog il1 = new InvoiceLog();
            OpenForm(il1, "Invoice Log");
        }

        private void miRepayLog_Click(object sender, EventArgs e)
        {
            RepaymentLog rl1 = new RepaymentLog();
            OpenForm(rl1, "Repayments Log");
        }

        private void miCompleteLog_Click(object sender, EventArgs e)
        {
            CompleteContractLog cl1 = new CompleteContractLog();
            OpenForm(cl1, "Complete Contracts Log");
        }

        private void miClosedLog_Click(object sender, EventArgs e)
        {
            ClosedContractLog ccl1 = new ClosedContractLog();
            OpenForm(ccl1, "Closed Contract Log");
        }

        private void miOpenInvoice_Click(object sender, EventArgs e)
        {
            OpenInvoice oi = new OpenInvoice();
            OpenForm(oi, "Open Invoices");
        }

        private void miOpenContract_Click(object sender, EventArgs e)
        {
            cp = new ContractPicker();
            OpenForm(cp, "Open Contract Picker");
        }

        private void menuItem17_Click(object sender, EventArgs e)
        {
            MonitoringLog ml1 = new MonitoringLog();
            OpenForm(ml1, "Monitoring Log");
        }

        private void miContractsFundingSource_Click(object sender, EventArgs e)
        {
            ContractByFundingSourceLog cfsl1 = new ContractByFundingSourceLog();
            OpenForm(cfsl1, "Contract By Funding Source Log");
        }

        private void miUser_Click(object sender, EventArgs e)
        {
            //UserMain um = new UserMain();
            //um.MdiParent = this;
            //um.Show();
            OpenManageUsers();
        }

        private void miReimbType_Click(object sender, EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ReimbTypeSelect);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ReimbTypeInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ReimbTypeUpdate);
            ManageBase manageReimbType = new ManageBase(populateMethod, insertMethod, updateMethod, "ReimbType", "ReimbTypeId", "Manage Reimbursement Types");
            OpenForm(manageReimbType, "Manage Reimbursement Types");
        }

        private void miProjectStatus_Click(object sender, EventArgs e)
        {
            Project.CodeTableAdmin frmAdmin = new CCPM.Project.CodeTableAdmin(CCPM.Project.CodeTableAdmin.CodeTable.ProjectStatus);
            OpenForm(frmAdmin, "Manage Project Statuses");
        }

        private void miAuthorizationTypes_Click(object sender, EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.AuthorizationTypeSelect);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.AuthorizationTypeInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.AuthorizationTypeUpdate);
            ManageBase manageType = new ManageBase(populateMethod, insertMethod, updateMethod, "AuthorizationType", "AuthorizationTypeId", "Manage Authorization Types");
            OpenForm(manageType, "Manage Authorization Types");
        }

        private void miRelationTypes_Click(object sender, EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.RelTypeSelect);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.RelTypeInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.RelTypeUpdate);
            ManageBase manageType = new ManageBase(populateMethod, insertMethod, updateMethod, "RelType", "RelTypeId",  "Manage Rel Types");
            OpenForm(manageType, "Manage Relation Types");
        }

        private void miContractType_Click(object sender, EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.ContractTypeSelect);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.ContractTypeInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.ContractTypeUpdate);
            ManageBase manageType = new ManageBase(populateMethod, insertMethod, updateMethod, "TypeCode", "ContractTypeId",  "Manage Contract Types");
            OpenForm(manageType, "Manage Contract Types");
        }

        private void miMonitorOutcome_Click(object sender, EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.MonitorOutcomeSelect);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.MonitorOutcomeInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.MonitorOutcomeUpdate);
            ManageBase manageType = new ManageBase(populateMethod, insertMethod, updateMethod, "OutcomeCode", "OutcomeId",  "Manage Monitor Outcomes");
            OpenForm(manageType, "Manage Monitor Outcomes");
        }

        private void menuItem19_Click(object sender, EventArgs e)
        {
            ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ContactData.OrganizationListManage);
            ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ContactData.ContactOrganizationInsert);
            ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ContactData.ContactOrganizationUpdate);

            ManageBase manageProgramType = new ManageBase(populateMethod, insertMethod, updateMethod, "OrganizationType", "OrganizationTypeId", "Manage Contact Organization Type");
            OpenForm(manageProgramType, "Manage Contact Organization Type");
        }

        private void menuItem20_Click(object sender, EventArgs e)
        {
            Project.Organizations frmOrgs = new Project.Organizations();
            OpenForm(frmOrgs, "Manage Organizations");
        }

        private void menuItem22_Click(object sender, EventArgs e)
        {
            Project.Contacts frmContacts = new Project.Contacts();
            OpenForm(frmContacts, "Manage Contacts");
        }

        private void miSize_Click(object sender, EventArgs e)
        {
            this.Width = 1280;
            this.Height = 1024;
        }

        private void miSendAlerts_Click(object sender, EventArgs e)
        {
            InputBox f1 = new InputBox();
            f1.Title = "Send Email Alerts";
            f1.IsInteger = true;
            f1.TextValue = "";
            f1.txtValue.Visible = false;
            f1.dtpValue.Value = DateTime.Today;
            f1.Caption = "Send out Email Alerts";
            f1.lblDate.Text = "Enter as of date (30, 91 days from event).";
            f1.dtpValue.Visible = true;

            f1.lblValue.Text = "Select alert to send";
            f1.cmbValue.Top = f1.txtValue.Top;
            f1.cmbValue.Visible = true;
            f1.cmbValue.TabIndex = 1;
            f1.cmbValue.Items.Add("All");
            f1.cmbValue.Items.Add("AlertContractCompletion");
            f1.cmbValue.Items.Add("AlertContractLiquidation");
            f1.cmbValue.Items.Add("AlertContractMonitor");
            f1.cmbValue.Items.Add("AlertContractTermination");
            f1.cmbValue.Items.Add("AlertPaymentDue");
            f1.cmbValue.Items.Add("AlertPaymentOverDue");
            f1.cmbValue.SelectedIndex = 0;

            //f1.ControlBox = false;
            f1.MinimizeBox = false;
            f1.ShowDialog(this);		//modal
            if (f1.DialogResult == DialogResult.OK)
            {
                try
                {
                    string s = ContractData.SendEmailAlerts(f1.dtpValue.Value, f1.cmbValue.Text);
                    MessageBox.Show(s, "Results");
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Alert failure.");
                }
            }
        }

        private void miSize1024_Click(object sender, EventArgs e)
        {
            this.Width = 1024;
            this.Height = 768;
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            OpenProjectForm();
        }

        private void miQueryTool_Click(object sender, EventArgs e)
        {
            CCPM.Report.QueryGrid qg = new CCPM.Report.QueryGrid();
            OpenForm(qg, "Query Tool");
        }

        private void miExpirationAlert_Click(object sender, EventArgs e)
        {
            CCPM.Report.DateRange dr = new CCPM.Report.DateRange();
            if (dr.ShowDialog() == DialogResult.OK)
            {
                CCPM.Report.ContractExpirationReport fm = new CCPM.Report.ContractExpirationReport(dr.completionDate1, dr.completionDate2, dr.type);
                OpenForm(fm, "Contract Expiration Report: " + dr.type);
            }
        }

        private void menuItem7_Click(object sender, EventArgs e)
        {
            CCPM.Report.DateRange dr = new CCPM.Report.DateRange();
            if (dr.ShowDialog() == DialogResult.OK)
            {
                CCPM.Report.ContractExpirationReport fm = new CCPM.Report.ContractExpirationReport(dr.completionDate1, dr.completionDate2, dr.type/*, dr.showDocumentMap*/);
                OpenForm(fm, "Contract Expiration Report: " + dr.type);
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            //save screen settings
            System.Configuration.Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            try
            {
                config.AppSettings.Settings["ScreenWidth"].Value = this.Width.ToString();
            }
            catch (Exception)
            {
                config.AppSettings.Settings.Add("ScreenWidth", this.Width.ToString());
            }
            try
            {
                config.AppSettings.Settings["ScreenHeight"].Value = this.Height.ToString();
            }
            catch (Exception)
            {
                config.AppSettings.Settings.Add("ScreenHeight", this.Height.ToString());
            }
            try
            {
                config.AppSettings.Settings["ScreenTop"].Value = this.Top.ToString();
            }
            catch (Exception)
            {
                config.AppSettings.Settings.Add("ScreenTop", this.Top.ToString());
            }
            try
            {
                config.AppSettings.Settings["ScreenLeft"].Value = this.Left.ToString();
            }
            catch (Exception)
            {
                config.AppSettings.Settings.Add("ScreenLeft", this.Left.ToString());
            }
            config.Save(ConfigurationSaveMode.Modified);
        }

        private void miContacts_Click(object sender, EventArgs e)
        {
            Project.Contacts frmContacts = new Project.Contacts();
            OpenForm(frmContacts, "Project Contacts");
        }

        private void miDynamicDropdowns_Click(object sender, EventArgs e)
        {
            OpenDynamicDropdown();
        }

        private void miAlertEmails_Click(object sender, EventArgs e)
        {
            AlertEmail sm = new AlertEmail();
            OpenForm(sm, "Manage Alert Emails");
        }

        private void miAgency_Click(object sender, EventArgs e)
        {
            Agency sm = new Agency();
            OpenForm(sm, "Manage Agency");
        }

        private void miOrganizationRole_Click(object sender, EventArgs e)
        {
            {
                ManageBase.PopulateMethod populateMethod = new ManageBase.PopulateMethod(ProjectData.OrgRolesSelect);
                ManageBase.InsertMethod insertMethod = new ManageBase.InsertMethod(ProjectData.OrgRolesInsert);
                ManageBase.UpdateMethod updateMethod = new ManageBase.UpdateMethod(ProjectData.OrgRolesUpdate);

                ManageBase manageProgramType = new ManageBase(populateMethod, insertMethod, updateMethod, "ProjectRole", "ProjectRoleId", "Manage Project Organization Role");
                OpenForm(manageProgramType, "Manage Project Organization Role");
            }
        }

        private void miDynamicMultiSelect_Click(object sender, EventArgs e)
        {
            OpenDynamicMultiSelect();
        }


    }

    public enum AlertMessageType
    {
        MasterListNotFound,
        ProjectNotFound,
        ContactNotFound,
    }

}
