USE [CCPM]
GO
/************************************************************************************************/
/***** 				  						     	    *****/
/***** Issue 2.8         ROLLING BACK TO ORIGINAL CODE - reassigns all Invoices and Payments to the new Funding Source	    *****/
/***** 				  						     	    *****/
/***** Issue 2.46        new sp ProjectListRange in contract/amendment log 	            *****/
/***** 				  						     	    *****/
/***** Issue 2.17, 2.18     alerts: sp AlertContractLiquidation: 	 		    *****/
/*****			    should not apply for closed contracts; send alert 1 and 3 mos   *****/
/***** 											    *****/
/***** Issue 2.17, 2.18     alerts: sp AlertPaymentDue: 	 			    *****/
/*****			    should not apply for closed contracts			    *****/
/***** 											    *****/
/***** Issue 2.17, 2.18     alerts: sp AlertPaymentOverDue: 	 		    	    *****/
/*****			    should not apply for closed contracts			    *****/
/***** 											    *****/
/***** Issue 2.17, 2.18     alerts: sp AlertContractMonitor: 	 		    	    *****/
/*****			    should not apply for closed contracts			    *****/
/***** 											    *****/
/***** Issue 2.19	  Create new Procedure AlertReservedNotEncumberedFunds 		    *****/
/***** 											    *****/
/***** Issue 2.25         create new view to be used for search of Grantee/Contractor	    *****/
/***** 											    *****/
/***** 											    *****/
/***** Issue 2.14         update disencumber amount when invoice is deleted in Funding Sheets****/
/***** 											    *****/
/***** 											    *****/
/***** Issue 2.30         create view for report to display Authorizations and Reservations  ****/
/***** 											    *****/
/************************************************************************************************/


/************************************************************************************************/
/***** Issue 2.8         REVISED - ROLLBACK TO USE ORIGINAL CODE FROM DB PROD - THE INTENT HERE ORIGINALYL WAS TO reassign all Invoices and Payments to the new Funding Source	    *****/
/************************************************************************************************/
USE [CCPMTEST]
GO
/****** Object:  StoredProcedure [dbo].[ContractFundUpdate]    Script Date: 06/29/2012 01:07:24 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO



ALTER PROCEDURE [dbo].[ContractFundUpdate]
(
    @ContractFundId		int,
    @FundingSource		varchar(150),
	@ContractedAmount	money,
	@BalanceToDate		money,
	@LiquidationDate	datetime,
	@DisencumberedAmount	money,
	@ReduceAmount		varchar(10))
AS

BEGIN
    BEGIN TRAN
	--InitialAmount = ContractedAmount until there are invoices
	if exists (select 1 from ContractFunds 
			inner join Invoice on ContractFunds.ContractId = Invoice.ContractId 
			and ContractFunds.FundId = Invoice.FundId
			where ContractFunds.ContractFundId = @ContractFundId)
			begin
			UPDATE ContractFunds
			SET FundId = @FundingSource
			,	ContractedAmount = @ContractedAmount
			,	BalanceToDate = @BalanceToDate
			,	LiquidationDate = @LiquidationDate
			,	DisencumberAmount = @DisencumberedAmount
			WHERE ContractFundId = @ContractFundId
			end
	else
		begin
			UPDATE ContractFunds
			SET FundId = @FundingSource
			,	ContractedAmount = @ContractedAmount
			,	BalanceToDate = @BalanceToDate
			,	LiquidationDate = @LiquidationDate
			,	DisencumberAmount = @DisencumberedAmount
			,	InitialAmount = @ContractedAmount
			WHERE ContractFundId = @ContractFundId
		end

    COMMIT TRAN
        
    IF (@ReduceAmount = 'true')
    BEGIN
       BEGIN TRAN
        UPDATE ReservEncumb
           SET Amount = (Amount - @DisencumberedAmount)
        WHERE FundID = @FundingSource                
       COMMIT TRAN
    END
     
    IF (@@error!=0)
    BEGIN
        RAISERROR  20001 'ContractFundsUpdate: Update failed '
        ROLLBACK TRAN
        RETURN(1)
    
    END
    --COMMIT TRAN
    RETURN(0)
END



--this was code that would reassign invoices
--BEGIN
--    BEGIN TRAN
--	--InitialAmount = ContractedAmount until there are invoices
--	--if there are invoices on the contractfundid then reassign all invoices just in case
--	if exists (select 1 
--			   from
--					ContractFunds inner join 
--					Invoice on ContractFunds.ContractId = Invoice.ContractId and 
--							   ContractFunds.FundId = Invoice.FundId
--			   where ContractFunds.ContractFundId = @ContractFundId)
--
--			-- reassigns all Invoices and Payments to the new Funding Source
--			begin	
--
--			DECLARE @ContractId int
--			DECLARE @OriginalFundId int
--
--			SELECT @ContractID = ContractID, @OriginalFundId = FundId FROM ContractFunds WHERE ContractFundId = @ContractFundId
--
--			UPDATE Invoice
--				SET FundId = @FundingSource
--				WHERE ContractID = @ContractId AND
--					  FundID = @OriginalFundId
--     
--			DECLARE @augmentDisencumbered money
--			
--			--now we need to update the disencumbered amount to reflect the new invoice assignments
--			--set ContractFunds DisencumberAmount = ContractedAmount when invoice is disencumber
--			SET @augmentDisencumbered = 0
--
--			select @augmentDisencumbered = SUM(COALESCE(Invoice.DisencumberAugment, 0) ) from Invoice where	ContractId = @ContractId and FundId = @FundingSource and disencumberAugment < 0
--
--			IF (@augmentDisencumbered < 0)		
--			BEGIN		
--				UPDATE	ContractFunds 
--				SET		DisencumberAmount = @augmentDisencumbered
--				WHERE	ContractId = @ContractId and FundId = @FundingSource
--			END
--
--			IF (@@error!=0)
--			BEGIN
--				RAISERROR  20001 'ContractFundInvoicePaymentsUpdate: Update failed '
--				ROLLBACK TRAN
--				RETURN(1)
--		    
--			END
--
--			begin			
--			UPDATE ContractFunds
--			SET FundId = @FundingSource
--			,	ContractedAmount = @ContractedAmount
--			,	BalanceToDate = @BalanceToDate
--			,	LiquidationDate = @LiquidationDate
--			,	DisencumberAmount = @DisencumberedAmount
--			WHERE ContractFundId = @ContractFundId
--			end
--			end
--
--	else
--		begin
--			UPDATE ContractFunds
--			SET FundId = @FundingSource
--			,	ContractedAmount = @ContractedAmount
--			,	BalanceToDate = @BalanceToDate
--			,	LiquidationDate = @LiquidationDate
--			,	DisencumberAmount = @DisencumberedAmount
--			,	InitialAmount = @ContractedAmount
--			WHERE ContractFundId = @ContractFundId
--		end
--
--    COMMIT TRAN
--        
--    IF (@ReduceAmount = 'true')
--    BEGIN
--       BEGIN TRAN
--        UPDATE ReservEncumb
--           SET Amount = (Amount - @DisencumberedAmount)
--        WHERE FundID = @FundingSource                
--       COMMIT TRAN
--    END
--     
--    IF (@@error!=0)
--    BEGIN
--        RAISERROR  20001 'ContractFundsUpdate: Update failed '
--        ROLLBACK TRAN
--        RETURN(1)
--    
--    END
--    RETURN(0)
--END
--
--



GO
/************************************************************************************************/
/***** Issue 2.46        new sp ProjectListRange: display all projects except 		    *****/
/*****				 Closed and Inactive in contract/amendment log 	            *****/
/************************************************************************************************/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE   PROCEDURE [dbo].[ProjectListRange]
@Status nvarchar(30)
AS
begin


DECLARE @STR nvarchar (1000);

	SET @STR = 
	'  SELECT 0 AS ProjectId, '' Select a Project Name''  AS ProjectName, ''Missing Value'' AS FileNumber UNION ALL ' + 
	' SELECT ProjectId, ProjectName, CASE FileNumber WHEN '''' THEN ''Missing Value'' ELSE FileNumber END FileNumber ' + 
	' FROM Project ' +
	' WHERE StatusId IN ' + '( ' +  @Status + ' )' +
	' ORDER BY ProjectName '  +  

	' SELECT ProjectId, CASE FileNumber WHEN '''' THEN ''Missing Value'' ELSE FileNumber END FileNumber  ' +
	' FROM Project  ' +
	' WHERE StatusId IN ' + '( ' +  @Status + ' )'  +
	' ORDER BY FileNumber ';

	EXEC (@STR);

end

GO
/************************************************************************************************/
/***** Issue 2.17, 2.18     alerts: sp alertContractLiquidation: 	 		    *****/
/*****			    should not apply for closed contracts; send alert 1 and 3 mos   *****/
/************************************************************************************************/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER PROCEDURE [dbo].[AlertContractLiquidation]
(
	@AsOfDate datetime = null
)	
AS
/*
**	Desc:		email alert for contract funding liquidation date = today + 1 month and balance to date <> 0
**	By:			Bob Freeman, 10/17/2008
**	Test:		exec AlertContractLiquidation @AsOfDate = '3/11/2009'
**				exec AlertContractLiquidation
				select	ContractFunds.LiquidationDate, dateadd(d, -91, ContractFunds.LiquidationDate) as AsOfDate, count(*) as rows
				from	ContractDetails join	ContractFunds on ContractFunds.ContractId = ContractDetails.ContractId
				where	ContractFunds.BalanceToDate <> 0 
				and		ContractFunds.LiquidationDate >= '9/17/2008'
				group by ContractFunds.LiquidationDate, dateadd(d, -91, ContractFunds.LiquidationDate)

**  Changes:
**  05-12-2012	Should not apply for Closed Contracts 
**				send alert with liquidations = 1 mos and 3 mos instead of 3 mos and 6 mos
*/
begin

declare 	@msg varchar(max)
,	@count int
, 	@EmailBody varchar(5000)
,	@EmailSubject varchar(200)
,	@ToEmail varchar(1000)
,	@CCEmail varchar(1000)
,	@ContractManagerEmail varchar(1000)
,	@AccountingManagerEmail varchar(1000)

,	@ContractNumber varchar(10)
,	@LiquidDate datetime
,	@FundTitle varchar(120)
,	@ProjectName varchar(100)
,	@ProjectContractManagerEmail varchar(100)
,	@ProjectManagerEmail varchar(100)
,	@RegionalManagerEmail varchar(1000)
,	@AdminEmail varchar(100)

set		@msg = ''
set		@count = 0

set		@CCEmail = 'contracts@scc.ca.gov;'
set		@AdminEmail = ''
select	@AdminEmail = @AdminEmail + Email + ';' 
from	ProjectStaff 
where	ProjectManagerId in (select ProjectManagerId from ProjectStaff_StaffRole where StaffRoleId = 3)
and		Email > ''

select	@AsOfDate = dbo.usfDateOnly(getdate()) where @AsOfDate is null
set		@ContractManagerEmail = ''
set		@AccountingManagerEmail = ''

select	@ContractManagerEmail = @ContractManagerEmail + Email + ';' 
from	ProjectStaff 
where	ProjectManagerId in (select ProjectManagerId from ProjectStaff_StaffRole where StaffRoleId = 1)
and		Email > ''

select	@AccountingManagerEmail = @AccountingManagerEmail + Email + ';' 
from	ProjectStaff 
where	ProjectManagerId in (select ProjectManagerId from ProjectStaff_StaffRole where StaffRoleId = 2)
and		Email > ''




declare	cur cursor 
for  	

	select	distinct ContractDetails.ContractNumber
	,		FundingSource.LiquidDate

	,		FundingSource.FundTitle
	,		Project.ProjectName

	,		isnull(ps1.Email, '') as ProjectContractManagerEmail
	,		isnull(ps2.Email, '') as ProjectManagerEmail
	,		isnull(ps3.Email, '') as RegionalManagerEmail

	from	ContractDetails
	join	ContractFunds on ContractFunds.ContractId = ContractDetails.ContractId
	join	FundingSource on FundingSource.FundID = ContractFunds.FundId
	left join Project on Project.ProjectId = ContractDetails.ProjectId
	left outer join ProjectStaff ps1 on ps1.ProjectManagerId = ContractDetails.ProjectManagerId
	left outer join ProjectStaff ps2 on ps2.ProjectManagerId = Project.CurrentPM

	left outer join Project_ProjectRegion on Project_ProjectRegion.ProjectId = Project.ProjectId
	left outer join ProjectRegion on ProjectRegion.RegionId = Project_ProjectRegion.ProjectRegionId
	left outer join ProjectStaff ps3 on ps3.ProjectManagerId = ProjectRegion.RegionalManagerId
	left outer join (SELECT
						ContractID,
						FundID,
						isNULL(SUM(WithholdingAmount),0) AS TotalWithholdingAmount
					FROM
						Invoice
					GROUP BY
						ContractID,
						FundID) wh ON ContractFunds.ContractID = wh.ContractID AND
									  ContractFunds.FundID = wh.FundID
	where	(ContractFunds.BalanceToDate + wh.TotalWithholdingAmount) > 0
			and	ContractDetails.ContractStatusId <> 4 
			and ( (FundingSource.LiquidDate = dateadd(d, 91, @AsOfDate))
				or (FundingSource.LiquidDate = dateadd(d, 30, @AsOfDate)) )
				--or (FundingSource.LiquidDate = dateadd(d, 182, @AsOfDate)) )

open 	cur
	fetch next from cur into @ContractNumber, @LiquidDate, @FundTitle, @ProjectName
		, @ProjectContractManagerEmail, @ProjectManagerEmail, @RegionalManagerEmail

while	(@@FETCH_STATUS = 0)
	begin

	set @ToEmail = @RegionalManagerEmail
	if	(@ToEmail = '')
		set	@ToEmail = @AdminEmail

	set @CCEmail = (case when @AccountingManagerEmail = '' then '' else @AccountingManagerEmail + ';' end)
		+ (case when @ContractManagerEmail = '' then '' else @ContractManagerEmail + ';' end)
		+ (case when @ProjectContractManagerEmail = '' then '' else @ProjectContractManagerEmail + ';' end)
	if	((@ProjectContractManagerEmail = '') or (@ProjectManagerEmail <> @ProjectContractManagerEmail))
		set	@CCEmail = @CCEmail + @ProjectManagerEmail

	set @EmailSubject = 'ALERT: Liquidation Date for Contract # '
		+ @ContractNumber
		+ ' will expire on ' + convert(varchar(10), @LiquidDate, 101) 

	set @EmailBody = 'ALERT!<br /><br />'
		+ 'Please note that the Liquidation Date for the contract for ' + @FundTitle
		+ ' fund source for the ' + @ProjectName 
		+ ' (Contract # ' + @ContractNumber + ')'
		+ ' will expire on ' + convert(varchar(10), @LiquidDate, 101) + '.<br /><br />'
		+ 'There is still a remaining balance for this fund source.  Please address this as soon as possible.'

	EXEC msdb.dbo.sp_send_dbmail
		  @profile_name = 'CCPM3'
		, @recipients = @ToEmail
		, @copy_recipients = @CCEmail
		, @subject = @EmailSubject
		, @body = @EmailBody
		, @body_format = 'HTML'
		, @importance = 'High'

	set	@count = @count + 1

	fetch next from cur into @ContractNumber, @LiquidDate, @FundTitle, @ProjectName
		, @ProjectContractManagerEmail, @ProjectManagerEmail, @RegionalManagerEmail
	end

close	cur
deallocate cur

select	@msg = 'AlertContractLiquidation:  ' + char(9) + convert(varchar, @count) + char(13)
select	@msg as msg

end

GO
/***** Issue 2.17, 2.18     alerts: sp AlertPaymentDue: 	 			    *****/
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER  PROCEDURE [dbo].[AlertPaymentDue]
(
	@AsOfDate datetime = null
)	
AS
/*
**	Desc:		email alert for payments due 30 days and 91 days
**	By:			Bob Freeman, 10/14/2008
**	Test:		exec AlertPaymentDue @AsOfDate = '12/02/2010'
**				exec AlertPaymentDue
				select ScheduleDate, dateadd(d, -30, ScheduleDate) as AsOfDate, count(*) as rows 
				from Repayments where AmountPaid = 0 group by ScheduleDate, dateadd(d, -30, ScheduleDate)
**  Changes:
**  05-12-2012	Should not apply for Closed Contracts 

*/
begin

declare 	@msg varchar(max)
,	@count int
,	@EmailBody varchar(5000)
,	@EmailSubject varchar(200)
,	@AccountingManagerEmail varchar(1000)
,	@ToEmail varchar(1000)
,	@CCEmail varchar(1000)

,	@ScheduleDate datetime
,	@AmountOwed money
,	@RepaidToDate money
,	@ContractedAmount money
,	@ContractNumber varchar(10)
,	@ProjectName varchar(100)
,	@ProjectContractManagerEmail varchar(100)
,	@ProjectManagerEmail varchar(100)
,	@OrganizationName varchar(100)
,	@ContactPhone varchar(70)
,	@AdminEmail varchar(100)

set		@msg = ''
set		@count = 0
set		@CCEmail = 'contracts@scc.ca.gov;'
select	@AsOfDate = dbo.usfDateOnly(getdate()) where @AsOfDate is null

set		@AdminEmail = ''
select	@AdminEmail = @AdminEmail + Email + ';' 
from	ProjectStaff 
where	ProjectManagerId in (select ProjectManagerId from ProjectStaff_StaffRole where StaffRoleId = 3)
and		Email > ''

set		@AccountingManagerEmail = ''
/*
select	@AccountingManagerEmail = @AccountingManagerEmail + Email + ';' 
from	ProjectStaff 
where	ProjectManagerId in (select ProjectManagerId from ProjectStaff_StaffRole where StaffRoleId = 2)
and		Email > ''
*/

declare	cur cursor 
for  	

	select	Repayments.ScheduleDate
	,		Repayments.AmountOwed
	,		Repayments.RepaidToDate

	,		ContractDetails.ContractedAmount
	,		ContractDetails.ContractNumber

	,		Project.ProjectName
	,		isnull(ps1.Email, '') as ContractManagerEmail
	,		isnull(ps2.Email, '') as ProjectManagerEmail

	,		isnull(Organization.Organization, '') as OrganizationName
	,		isnull(Contact.ContactPhone, '') +
			(case when Contact.ContactExtension > '' then ' Ext ' + Contact.ContactExtension else ''  end)
			as ContactPhone

	from	Repayments
	left join ContractDetails on ContractDetails.ContractId = Repayments.ContractId
	left join Project on Project.ProjectId = ContractDetails.ProjectId
	left outer join ProjectStaff ps1 on ps1.ProjectManagerId = ContractDetails.ProjectManagerId
	left outer join ProjectStaff ps2 on ps2.ProjectManagerId = Project.CurrentPM
	left outer join  Organization on Organization.OrgID = ContractDetails.GranteeId
	left outer join	Contact on Contact.ContactID = ContractDetails.ContactPersonId
	where	Repayments.AmountPaid = 0
	and		ContractDetails.ContractStatusId <> 4 
	and		( (Repayments.ScheduleDate = dateadd(d, 30, @AsOfDate))
			or (Repayments.ScheduleDate = dateadd(d, 91, @AsOfDate)) )


open 	cur
	fetch next from cur into @ScheduleDate, @AmountOwed, @RepaidToDate, @ContractedAmount, @ContractNumber
		, @ProjectName, @ProjectContractManagerEmail, @ProjectManagerEmail, @OrganizationName, @ContactPhone

while	(@@FETCH_STATUS = 0)
	begin

	if	(@ProjectContractManagerEmail = @ProjectManagerEmail)
		set @ProjectManagerEmail = ''

	set	@ToEmail = @ProjectContractManagerEmail
	if	(@ToEmail = '')
		begin
		set @ToEmail = @ProjectManagerEmail
		set @ProjectManagerEmail = ''
		end
	if	(@ToEmail = '')
		set @ToEmail = @AdminEmail

	set	@CCEmail = @AccountingManagerEmail
	set @CCEmail = @CCEmail + @ProjectManagerEmail

	set @EmailSubject = 'ALERT: A scheduled repayment for Contract # '
		+ @ContractNumber
		+ ' is due on '
		+  convert(varchar(10), @ScheduleDate, 101)

	set @EmailBody = 'ALERT!<br /><br />'
		+ 'Please note that a scheduled repayment for the ' + @ProjectName 
		+ ' (Contract # ' + @ContractNumber + ')'
		+ ' is due on '	+  convert(varchar(10), @ScheduleDate, 101) + '.<br />'
		+ 'The amount due is $' + convert(varchar(12), @AmountOwed, 1) + '.<br />'
		+ 'Please alert ' + @OrganizationName
		+ ', ' + @ContactPhone
		+ ', to send payment to:<br /><br />'
		+ 'Accounting Department<br />'
		+ 'Coastal Conservancy<br />'
		+ '1330 Broadway, Ste. 1300<br />'
		+ 'Oakland, CA 94612<br />'
		+ '(510) 286-1015<br />'


	EXEC msdb.dbo.sp_send_dbmail
		  @profile_name = 'CCPM3'
		, @recipients = @ToEmail
		, @copy_recipients = @CCEmail
		, @subject = @EmailSubject
		, @body = @EmailBody
		, @body_format = 'HTML'
		, @importance = 'High'

	set	@count = @count + 1

	fetch next from cur into @ScheduleDate, @AmountOwed, @RepaidToDate, @ContractedAmount, @ContractNumber
		, @ProjectName, @ProjectContractManagerEmail, @ProjectManagerEmail, @OrganizationName, @ContactPhone
	end

close	cur
deallocate cur

select	@msg = 'AlertPaymentDue:  ' + char(9) + char(9) + convert(varchar, @count) + char(13)
select	@msg as msg


end

GO
/***** Issue 2.17, 2.18     alerts: sp AlertPaymentOverDue: 	 		    	    *****/

GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[AlertPaymentOverDue]
(
	@AsOfDate datetime = null
)	
AS
/*
**	Desc:		email alert for overdue payments, scheduled date = today, plus resend every 30 days 
**	By:			Bob Freeman, 10/17/2008
**	Test:		exec AlertPaymentOverDue @AsOfDate = '3/26/2009'
**				exec AlertPaymentOverDue
				select ScheduleDate, count(*) as rows from Repayments where AmountPaid = 0 group by ScheduleDate

**	ToDo:		get accounting manager email from db

**  Changes:
**  05-12-2012	Should not apply for Closed Contracts 

*/
begin

declare 	@msg varchar(max)
,	@count int
,	@EmailBody varchar(5000)
,	@EmailSubject varchar(200)
,	@AccountingManagerEmail varchar(1000)
,	@CCEmail varchar(1000)
,	@ToEmail varchar(1000)

,	@ScheduleDate datetime
,	@AmountOwed money
,	@RepaidToDate money
,	@ContractedAmount money
,	@ContractNumber varchar(10)
,	@FileNumber varchar(50)
,	@ProjectName varchar(100)
,	@ProjectContractManagerEmail varchar(100)
,	@ProjectManagerEmail varchar(100)
,	@OrganizationName varchar(100)
,	@ContactPhone varchar(70)
,	@AdminEmail varchar(1000)

set		@msg = ''
set		@count = 0
set		@CCEmail = ''
select	@AsOfDate = dbo.usfDateOnly(getdate()) where @AsOfDate is null


set		@AdminEmail = ''
select	@AdminEmail = @AdminEmail + Email + ';' 
from	ProjectStaff 
where	ProjectManagerId in (select ProjectManagerId from ProjectStaff_StaffRole where StaffRoleId = 3)
and		Email > ''


set		@AccountingManagerEmail = ''
/*
select	@AccountingManagerEmail = @AccountingManagerEmail + Email + ';' 
from	ProjectStaff 
where	ProjectManagerId in (select ProjectManagerId from ProjectStaff_StaffRole where StaffRoleId = 2)
and		Email > ''
*/

select	@AsOfDate = dbo.usfDateOnly(getdate()) where @AsOfDate is null



declare	cur cursor 
for  	

	select	Repayments.ScheduleDate
	,		Repayments.AmountOwed
	,		Repayments.RepaidToDate

	,		ContractDetails.ContractedAmount
	,		ContractDetails.ContractNumber

	,		Project.ProjectName
	,		isnull(ps1.Email, '') as ContractManagerEmail
	,		isnull(ps2.Email, '') as ProjectManagerEmail

	,		isnull(Organization.Organization, '') as OrganizationName
	,		isnull(Contact.ContactPhone, '') +
			(case when Contact.ContactExtension > '' then ' Ext ' + Contact.ContactExtension else ''  end)
			as ContactPhone

	from	Repayments
	left join ContractDetails on ContractDetails.ContractId = Repayments.ContractId
	left join Project on Project.ProjectId = ContractDetails.ProjectId
	left outer join ProjectStaff ps1 on ps1.ProjectManagerId = ContractDetails.ProjectManagerId
	left outer join ProjectStaff ps2 on ps2.ProjectManagerId = Project.CurrentPM
	left join  Organization on Organization.OrgID = ContractDetails.GranteeId
	left join	Contact on Contact.ContactID = ContractDetails.ContactPersonId
	where	Repayments.AmountPaid = 0
	and		ContractDetails.ContractStatusId <> 4 
	and		Repayments.ScheduleDate <= @AsOfDate
	and		(datediff(d, Repayments.ScheduleDate, @AsOfDate) % 30) = 0	--same day or every 30 days


open 	cur
	fetch next from cur into @ScheduleDate, @AmountOwed, @RepaidToDate, @ContractedAmount, @ContractNumber
		, @ProjectName, @ProjectContractManagerEmail, @ProjectManagerEmail, @OrganizationName, @ContactPhone

while	(@@FETCH_STATUS = 0)
	begin

	if	(@ProjectContractManagerEmail = @ProjectManagerEmail)
		set @ProjectManagerEmail = ''

	set	@ToEmail = @ProjectContractManagerEmail
	if	(@ToEmail = '')
		begin
		set @ToEmail = @ProjectManagerEmail
		set @ProjectManagerEmail = ''
		end
	if	(@ToEmail = '')
		set @ToEmail = @AdminEmail

	set	@CCEmail = @AccountingManagerEmail
	set @CCEmail = @CCEmail + @ProjectManagerEmail

	set @EmailSubject = 'ALERT: A scheduled repayment for Contract # '
		+ @ContractNumber
		+ ' is OVERDUE!'

	set @EmailBody = 'ALERT!<br /><br />'
		+ 'Please note that a scheduled repayment for the ' + @ProjectName 
		+ ' (Contract # ' + @ContractNumber + ')'
		+ ' was due on '	+  convert(varchar(10), @ScheduleDate, 101) + ' and is now PAST DUE.<br />'
		+ 'The amount due is $' + convert(varchar(12), @AmountOwed, 1) + '.<br />'
		+ 'Please alert ' + @OrganizationName
		+ ', ' + @ContactPhone
		+ ', to send payment immediately to:<br /><br />'
		+ 'Accounting Department<br />'
		+ 'Coastal Conservancy<br />'
		+ '1330 Broadway, Ste. 1300<br />'
		+ 'Oakland, CA 94612<br />'
		+ '(510) 286-1015<br />'


	EXEC msdb.dbo.sp_send_dbmail
		  @profile_name = 'CCPM3'
		, @recipients = @ToEmail
		, @copy_recipients = @CCEmail
		, @subject = @EmailSubject
		, @body = @EmailBody
		, @body_format = 'HTML'
		, @importance = 'High'

	set	@count = @count + 1

	fetch next from cur into @ScheduleDate, @AmountOwed, @RepaidToDate, @ContractedAmount, @ContractNumber
		, @ProjectName, @ProjectContractManagerEmail, @ProjectManagerEmail, @OrganizationName, @ContactPhone
	end
close	cur
deallocate cur

select	@msg = 'AlertPaymentOverDue:  ' + char(9) + convert(varchar, @count) + char(13)
select	@msg as msg

end
GO
/***** Issue 2.17, 2.18     alerts: sp AlertContractMonitor 	 		    	    *****/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[AlertContractMonitor]
(
	@AsOfDate datetime = null
)	
AS
/*
**	Desc:		email alert for contract monitoring, scheduled date = today + 30 days, monitored date = null
**				also send overdue notice when = today and each 30 days past due
**	By:			Bob Freeman, 10/23/2008
**	Test:		exec AlertContractMonitor @AsOfDate = '12/02/2009'
				exec AlertContractMonitor
				select ScheduledDate, dateadd(d, -30, ScheduledDate) as AsOfDate, count(*) as rows 
				from ContractMonitorDetail where MonitoredDate is null group by ScheduledDate, dateadd(d, -30, ScheduledDate)
**  Changes:
**  05-12-2012	Should not apply for Closed Contracts 
*/
begin


declare 	@msg varchar(max)
,	@count int
,	@EmailBody varchar(5000)
,	@EmailSubject varchar(200)
,	@ToEmail varchar(1000)
,	@CCEmail varchar(1000)

,	@ContractNumber varchar(10)
,	@ScheduledDate datetime
,	@ProjectName varchar(100)
,	@FileNumber varchar(50)
,	@ProjectContractManagerEmail varchar(100)
,	@ProjectManagerEmail varchar(100)
,	@AdminEmail varchar(100)

set		@msg = ''
set		@count = 0
set		@CCEmail = ''

set		@AdminEmail = ''
select	@AdminEmail = @AdminEmail + Email + ';' 
from	ProjectStaff 
where	ProjectManagerId in (select ProjectManagerId from ProjectStaff_StaffRole where StaffRoleId = 3)
and		Email > ''


select	@AsOfDate = dbo.usfDateOnly(getdate()) where @AsOfDate is null


declare	cur cursor 
for  	

	select	ContractDetails.ContractNumber
	,		ContractMonitorDetail.ScheduledDate
	,		Project.ProjectName
	,		Project.FileNumber
	,		isnull(ps1.Email, '') as ContractManagerEmail
	,		isnull(ps2.Email, '') as ProjectManagerEmail
	from	ContractDetails
	left join ContractMonitor on ContractMonitor.ContractId = ContractDetails.ContractId
	left join ContractMonitorDetail ON ContractMonitorDetail.MonitorId = ContractMonitor.MonitorId
	left join Project on Project.ProjectId = ContractDetails.ProjectId
	left outer join ProjectStaff ps1 on ps1.ProjectManagerId = ContractDetails.ProjectManagerId
	left outer join ProjectStaff ps2 on ps2.ProjectManagerId = Project.CurrentPM
	where	(ContractMonitorDetail.MonitoredDate is null)
	
	and	ContractDetails.ContractStatusId <> 4 
	and	( 
			(ContractMonitorDetail.ScheduledDate = dateadd(d, 30, @AsOfDate))
			--or (ContractMonitorDetail.ScheduledDate = dateadd(d, 91, @AsOfDate))
			or ( (ContractMonitorDetail.ScheduledDate <= @AsOfDate)
				and (datediff(d, ContractMonitorDetail.ScheduledDate, @AsOfDate) % 30) = 0)  --same day or every 30 past days
			)

open 	cur
	fetch next from cur into @ContractNumber, @ScheduledDate
		, @ProjectName, @FileNumber, @ProjectContractManagerEmail, @ProjectManagerEmail

while	(@@FETCH_STATUS = 0)
	begin

	if	(@ProjectContractManagerEmail = @ProjectManagerEmail)
		set @ProjectManagerEmail = ''

	set	@ToEmail = @ProjectContractManagerEmail
	if	(@ToEmail = '')
		begin
		set @ToEmail = @ProjectManagerEmail
		set @ProjectManagerEmail = ''
		end
	if	(@ToEmail = '')
		set @ToEmail = @AdminEmail

	set @CCEmail = @ProjectManagerEmail

	if	(@ScheduledDate > @AsOfDate)
		begin
		set @EmailSubject = 'ALERT: A scheduled monitoring report for Contract # '
			+ @ContractNumber
			+ ' is due on ' + convert(varchar(10), @ScheduledDate, 101)

		set @EmailBody = 'ALERT!<br /><br />'
			+ 'Note that a scheduled monitoring report for the ' + @ProjectName 
			+ ' (' + @FileNumber + ') '
			+ ' is due on ' + convert(varchar(10), @ScheduledDate, 101) + '.<br /><br />'
			+ 'Please make preparations to complete the report and update the Monitoring Details in the project database. '
		end
	else
		begin
		set @EmailSubject = 'ALERT: A scheduled monitoring report for Contract # '
			+ @ContractNumber
			+ ' is now OVERDUE.'

		set @EmailBody = 'ALERT!<br /><br />'
			+ 'Note that a scheduled monitoring report for the ' + @ProjectName 
			+ ' (' + @FileNumber + ') '
			+ ' was due on ' + convert(varchar(10), @ScheduledDate, 101) + '.<br /><br />'
			+ 'Please make preparations to complete the report and update the Monitoring Details in the project database as soon as possible. '
		end

	EXEC msdb.dbo.sp_send_dbmail
		  @profile_name = 'CCPM3'
		, @recipients = @ToEmail
		, @copy_recipients = @CCEmail
		, @subject = @EmailSubject
		, @body = @EmailBody
		, @body_format = 'HTML'
		, @importance = 'High'

	set	@count = @count + 1

	fetch next from cur into @ContractNumber, @ScheduledDate
		, @ProjectName, @FileNumber, @ProjectContractManagerEmail, @ProjectManagerEmail
	end

close	cur
deallocate cur

select	@msg = 'AlertContractMonitor:  ' + char(9) + convert(varchar, @count) + char(13)
select	@msg as msg

end

GO
/****** Create new Procedure AlertReservedNotEncumberedFunds ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[AlertReservedNotEncumberedFunds]
(
	@AsOfDate datetime = null
)	
AS
/*
**	Desc:		email alert for reserved but not encumbered funds 
**				(sum of reserved funds for funding sources for a project is greater than sum of ContractFunds.contractedAmount)
**				 for that funding source )
**				 and funding source encumb exp date = today + 1 month or today + 3 months
**	Date:		05/01/2012
**	Test:		exec AlertReservedNotEncumberedFunds @AsOfDate = '5/1/2012'
**				exec AlertReservedNotEncumberedFunds
				--select Authorizationdetail.projectid, FundingSource.fundid, COALESCE(ReservEncumb.Amount, 0) as ReservFundsAmount,
				--	(select IsNull(SUM(COALESCE(ContractFunds.contractedamount , 0)),0) 
				--	 from	ContractFunds LEFT JOIN ContractDetails on ContractDetails.ContractId = ContractFunds.ContractId
				--  	 where	ContractDetails.ProjectId = AuthorizationDetail.ProjectId 
				--	 and ContractFunds.fundid = FundingSource.fundid  ) as EncumberFundAmount, FundingSource.EncumbExpDate

				select FundingSource.EncumbExpDate, dateadd(d, -91, FundingSource.EncumbExpDate) as AsOfDate, count(*) as rows
				from ReservEncumb 
					join FundingSource ON FundingSource.FundID = ReservEncumb.FundID 
					join AuthorizationDetail ON ReservEncumb.AuthorizationID = AuthorizationDetail.AuthorizationID  	 
					left join Project on Project.ProjectId = AuthorizationDetail.ProjectId
				where FundingSource.EncumbExpDate >= '5/1/2012'
				--and AuthorizationDetail.ProjectId = 27
				group by FundingSource.EncumbExpDate, dateadd(d, -91, FundingSource.EncumbExpDate)
*/
begin

declare 	@msg varchar(max)
,	@count int
, 	@EmailBody varchar(5000)
,	@EmailSubject varchar(200)
,	@ToEmail varchar(1000)
,	@CCEmail varchar(1000)

,	@FundingItem varchar(100)
,	@EncumbExpDate datetime
,   @ReservFundsAmount money
,   @ContractedFundAmount money
,	@FundTitle varchar(120)
,	@ProjectName varchar(100)
,	@AuthorizedBy varchar(100)
,	@ProjectManagerEmail varchar(100)
,	@RegionalManagerEmail varchar(1000)
,	@AdminEmail varchar(100)

set		@msg = ''
set		@count = 0
set		@EmailBody = ''

set		@CCEmail = 'contracts@scc.ca.gov;'
set		@AdminEmail = ''
select	@AdminEmail = @AdminEmail + Email + ';' 
from	ProjectStaff 
where	ProjectManagerId in (select ProjectManagerId from ProjectStaff_StaffRole where StaffRoleId = 3)
and		Email > ''

select	@AsOfDate = dbo.usfDateOnly(getdate()) where @AsOfDate is null

declare	cur cursor 
for  	

	select distinct 
			dbo.usfFundingItem2(FundingSource.FundId) as FundingItem
	,		FundingSource.EncumbExpDate

	,		COALESCE(ReservEncumb.Amount, 0) as ReservFundsAmount
	,		(SELECT  IsNull(SUM(COALESCE(ContractFunds.contractedamount , 0)),0)
				FROM  ContractFunds 
					LEFT JOIN ContractDetails on ContractDetails.ContractId = ContractFunds.ContractId
				WHERE	ContractDetails.ProjectId = AuthorizationDetail.ProjectId 
					AND ContractFunds.fundid = FundingSource.fundid  
			) as EncumberFundAmount

	,		FundingSource.FundTitle
	,		Project.ProjectName
	,		AuthorizationDetail.CreatedBy as AuthorizedBy

	,		isnull(ps2.Email, '') as ProjectManagerEmail
	,		isnull(ps3.Email, '') as RegionalManagerEmail

	from ReservEncumb 
	join FundingSource ON FundingSource.FundID = ReservEncumb.FundID 
	join AuthorizationDetail ON ReservEncumb.AuthorizationID = AuthorizationDetail.AuthorizationID  	 
	left join Project on Project.ProjectId = AuthorizationDetail.ProjectId
	left outer join ProjectStaff ps2 on ps2.ProjectManagerId = Project.CurrentPM

	left outer join Project_ProjectRegion on Project_ProjectRegion.ProjectId = Project.ProjectId
	left outer join ProjectRegion on ProjectRegion.RegionId = Project_ProjectRegion.ProjectRegionId
	left outer join ProjectStaff ps3 on ps3.ProjectManagerId = ProjectRegion.RegionalManagerId

	where	
			( (FundingSource.EncumbExpDate = dateadd(d, 30, @AsOfDate))
				or (FundingSource.EncumbExpDate = dateadd(d, 91, @AsOfDate)) )


open 	cur
	fetch next from cur into @FundingItem, @EncumbExpDate, @ReservFundsAmount,  @ContractedFundAmount 
		, @FundTitle, @ProjectName, @AuthorizedBy, @ProjectManagerEmail, @RegionalManagerEmail

while	(@@FETCH_STATUS = 0)
	begin 
    if (@ReservFundsAmount > @ContractedFundAmount)
	Begin
	set @ToEmail = @ProjectManagerEmail 
	if	(@ToEmail = '')
		set	@ToEmail = @CCEmail + @AdminEmail


	set	@CCEmail =  @RegionalManagerEmail

	set @EmailSubject = 'ALERT: Encumber Expiration Date for Funding Source  '
		+ @FundingItem
		+ ' will expire on ' + convert(varchar(10), @EncumbExpDate, 101) 

	set @EmailBody = 'ALERT!<br /><br />'
		+ 'Please note that the Encumber Expiration Date for the funding source for ' + @FundTitle
		+ ' fund source for the ' + @ProjectName 
		+ ' authorized by ' + @AuthorizedBy
		+ ' will expire on ' + convert(varchar(10), @EncumbExpDate, 101) + '.<br /><br />'
		+ 'These funds have been reserved (' +  convert(varchar(20), @ReservFundsAmount) + ') but not encumbered (' + convert(varchar(20), @ContractedFundAmount) + '). There is still a remaining balance for this fund source.  Please address this as soon as possible.'

	EXEC msdb.dbo.sp_send_dbmail
		  @profile_name = 'CCPM3'
		, @recipients = @ToEmail
		, @copy_recipients = @CCEmail
		, @subject = @EmailSubject
		, @body = @EmailBody
		, @body_format = 'HTML'
		, @importance = 'High'

	set	@count = @count + 1
	end 

	fetch next from cur into @FundingItem, @EncumbExpDate, @ReservFundsAmount,  @ContractedFundAmount 
		, @FundTitle, @ProjectName, @AuthorizedBy, @ProjectManagerEmail, @RegionalManagerEmail
	end

close	cur
deallocate cur

select	@msg = 'AlertReservedNotEncumberedFunds:  ' + char(9) + convert(varchar, @count) + char(13)
select	@msg as msg

end


/************************************************************************************************/
/***** Issue 2.25         create new view to be used for search of Grantee/Contractor	    *****/
/************************************************************************************************/
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
/****** Object:  View [dbo].[vwGranteeForProject]    ******/
CREATE VIEW [dbo].[vwGranteeForProject]
AS
SELECT     dbo.Org_ProjectRole.ProjectId, Organization_2.OrgID, Organization_2.Organization
FROM         dbo.Org_ProjectRole INNER JOIN
                      dbo.Organization AS Organization_2 ON dbo.Org_ProjectRole.OrgId = Organization_2.OrgID AND dbo.Org_ProjectRole.ProjectRoleId = 1

/************************************************************************************************/
/***** Issue 2.14         update disencumber amount when invoice is deleted in Funding Sheets****/
/************************************************************************************************/
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


ALTER PROCEDURE [dbo].[InvoiceDetailDelete]
(
    @InvoiceId         int)
AS
BEGIN
    DECLARE @augmentDisencumbered money

    BEGIN TRAN
	declare	@ContractId int
	,		@FundId int

	select	@ContractId = ContractId
	,		@FundId = FundId
	from	Invoice
	where	InvoiceId = @InvoiceId

	--set ContractFunds DisencumberAmount = ContractedAmount when invoice is disencumber
	SET @augmentDisencumbered = 0
	IF exists (select * from Invoice where	ContractId = @ContractId and FundId = @FundId and disencumberAugment < 0)
	BEGIN
		SET @augmentDisencumbered = (select SUM(COALESCE(Invoice.DisencumberAugment, 0) ) from Invoice where	ContractId = @ContractId and FundId = @FundId and disencumberAugment < 0)
	END

	IF (@augmentDisencumbered < 0)		
	BEGIN		
		UPDATE	ContractFunds 
		SET		DisencumberAmount = 0
		WHERE	ContractId = @ContractId and FundId = @FundId
	END

    DELETE
    FROM Invoice
    WHERE InvoiceId = @InvoiceId
    
    IF (@@error!=0)
    BEGIN
        RAISERROR  20002 'InvoiceDetailDelete: Delete failed '
        ROLLBACK TRAN
        RETURN(1)
    END

	--set ContractFunds InitialAmount = ContractedAmount when there are no more invoices
	if not exists (select * from Invoice where	ContractId = @ContractId and FundId = @FundId)
		begin
		update	ContractFunds 
		set		InitialAmount = ContractedAmount
		where	ContractId = @ContractId and FundId = @FundId
		end

    COMMIT TRAN
    RETURN(0)
END

/************************************************************************************************/
/***** Issue 2.30         create view for report to display Authorizations and Reservations  ****/
/************************************************************************************************/
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[vwProjectAuthorizationsResevations]
AS

SELECT 
	  AuthorizationDetail.ProjectId
	, AuthorizationDetail.AuthorizationId
	,  dbo.usfFundingItem2(FundingSource.FundID) AS FundingItem
	, FundingSource.Source
    , ReservEncumb.ReserveDate As ReserveDate
	, t.AuthorizationType as AuthorizedBy
	, AuthorizationDetail.AuthorizationDate	 As AuthDate
	, AuthorizationDetail.AmountAuthorized as AuthAmount
	, AuthorizationDetail.Notes 
	, FundingSource.EncumbExpDate EncumberBy
	, FundingSource.LiquidDate As SpendBy
	, ReservEncumb.Amount As ReserveAmount
FROM  FundingSource 
INNER JOIN ReservEncumb ON FundingSource.FundID = ReservEncumb.FundID 
INNER JOIN AuthorizationDetail ON AuthorizationDetail.AuthorizationId = ReservEncumb.AuthorizationID
LEFT OUTER JOIN AuthorizationType t ON AuthorizationDetail.AuthorizationTypeId = t.AuthorizationTypeId 

/************************************************************************************************/
/************************************************************************************************/
