using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using System.Data;
using Infragistics.Shared; 
using Infragistics.Win; 
using Infragistics.Win.UltraWinGrid; 
using CCPM.Data;

namespace CCPM.Project
{
	/// <summary>
	/// Summary description for CodeTableAdmin.
	/// </summary>
	public class CodeTableAdmin : System.Windows.Forms.Form
	{
		#region Fields
		private System.Windows.Forms.Label lblInstructions;
		private System.Windows.Forms.PictureBox pbLast;
		private System.Windows.Forms.PictureBox pbPrevious;
		private System.Windows.Forms.PictureBox pbNext;
		private System.Windows.Forms.PictureBox pbFirst;
		private Infragistics.Win.UltraWinGrid.UltraGrid uwgList;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Button btnDelete;
		private System.Windows.Forms.Button btnAdd;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private bool blnGridDirty = false;
		private CodeTable enTable = CodeTable.City;
		#endregion

		#region Types & Constants
		public enum CodeTable
		{
			City, County, Region, ProjectStatus
		}

		public enum DirtyFlags
		{
			Clean = 0, Added, Updated, Deleted
		}

		private const string VALUE_LIST_COUNTIES = "Counties";
		private const string GRID_COLUMN_DIRTY_FLAG = "DirtyFlag";
		#endregion

		#region Constructors
		public CodeTableAdmin( CodeTable table )
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			enTable = table;

            this.Text = "Manage " + table;

			this.uwgList.AfterRowActivate += new EventHandler(uwgList_AfterRowActivate);
			this.uwgList.AfterCellUpdate += new Infragistics.Win.UltraWinGrid.CellEventHandler(uwgList_AfterCellUpdate);
			this.uwgList.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(uwgList_InitializeLayout);

			this.Closing += new CancelEventHandler(CodeTableAdmin_Closing);

			LoadGrid();
			SetButtons();
		}

		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(CodeTableAdmin));
            this.lblInstructions = new System.Windows.Forms.Label();
            this.pbLast = new System.Windows.Forms.PictureBox();
            this.pbPrevious = new System.Windows.Forms.PictureBox();
            this.pbNext = new System.Windows.Forms.PictureBox();
            this.pbFirst = new System.Windows.Forms.PictureBox();
            this.uwgList = new Infragistics.Win.UltraWinGrid.UltraGrid();
            this.btnCancel = new System.Windows.Forms.Button();
            this.btnSave = new System.Windows.Forms.Button();
            this.btnDelete = new System.Windows.Forms.Button();
            this.btnAdd = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.pbLast)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbPrevious)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbNext)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbFirst)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.uwgList)).BeginInit();
            this.SuspendLayout();
            // 
            // lblInstructions
            // 
            this.lblInstructions.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.lblInstructions.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblInstructions.ForeColor = System.Drawing.Color.Green;
            this.lblInstructions.Location = new System.Drawing.Point(200, 384);
            this.lblInstructions.Name = "lblInstructions";
            this.lblInstructions.Size = new System.Drawing.Size(320, 16);
            this.lblInstructions.TabIndex = 63;
            this.lblInstructions.Text = "Use Tab or Shift+Tab to navigate between cells within a row.";
            // 
            // pbLast
            // 
            this.pbLast.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.pbLast.Image = ((System.Drawing.Image)(resources.GetObject("pbLast.Image")));
            this.pbLast.Location = new System.Drawing.Point(618, 406);
            this.pbLast.Name = "pbLast";
            this.pbLast.Size = new System.Drawing.Size(32, 24);
            this.pbLast.TabIndex = 62;
            this.pbLast.TabStop = false;
            this.pbLast.Click += new System.EventHandler(this.pbLast_Click);
            // 
            // pbPrevious
            // 
            this.pbPrevious.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.pbPrevious.Image = ((System.Drawing.Image)(resources.GetObject("pbPrevious.Image")));
            this.pbPrevious.Location = new System.Drawing.Point(534, 406);
            this.pbPrevious.Name = "pbPrevious";
            this.pbPrevious.Size = new System.Drawing.Size(32, 24);
            this.pbPrevious.TabIndex = 61;
            this.pbPrevious.TabStop = false;
            this.pbPrevious.Click += new System.EventHandler(this.pbPrevious_Click);
            // 
            // pbNext
            // 
            this.pbNext.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.pbNext.Image = ((System.Drawing.Image)(resources.GetObject("pbNext.Image")));
            this.pbNext.Location = new System.Drawing.Point(576, 406);
            this.pbNext.Name = "pbNext";
            this.pbNext.Size = new System.Drawing.Size(32, 24);
            this.pbNext.TabIndex = 60;
            this.pbNext.TabStop = false;
            this.pbNext.Click += new System.EventHandler(this.pbNext_Click);
            // 
            // pbFirst
            // 
            this.pbFirst.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.pbFirst.Image = ((System.Drawing.Image)(resources.GetObject("pbFirst.Image")));
            this.pbFirst.Location = new System.Drawing.Point(492, 406);
            this.pbFirst.Name = "pbFirst";
            this.pbFirst.Size = new System.Drawing.Size(32, 24);
            this.pbFirst.TabIndex = 59;
            this.pbFirst.TabStop = false;
            this.pbFirst.Click += new System.EventHandler(this.pbFirst_Click);
            // 
            // uwgList
            // 
            this.uwgList.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.uwgList.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.uwgList.Location = new System.Drawing.Point(30, 14);
            this.uwgList.Name = "uwgList";
            this.uwgList.Size = new System.Drawing.Size(819, 362);
            this.uwgList.TabIndex = 58;
            // 
            // btnCancel
            // 
            this.btnCancel.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.btnCancel.Enabled = false;
            this.btnCancel.Location = new System.Drawing.Point(418, 406);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(64, 24);
            this.btnCancel.TabIndex = 57;
            this.btnCancel.Text = "Cancel";
            this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
            // 
            // btnSave
            // 
            this.btnSave.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.btnSave.Enabled = false;
            this.btnSave.Location = new System.Drawing.Point(344, 406);
            this.btnSave.Name = "btnSave";
            this.btnSave.Size = new System.Drawing.Size(64, 24);
            this.btnSave.TabIndex = 56;
            this.btnSave.Text = "Save";
            this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
            // 
            // btnDelete
            // 
            this.btnDelete.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.btnDelete.Enabled = false;
            this.btnDelete.Location = new System.Drawing.Point(270, 406);
            this.btnDelete.Name = "btnDelete";
            this.btnDelete.Size = new System.Drawing.Size(64, 24);
            this.btnDelete.TabIndex = 55;
            this.btnDelete.Text = "Delete";
            this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
            // 
            // btnAdd
            // 
            this.btnAdd.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.btnAdd.Location = new System.Drawing.Point(196, 406);
            this.btnAdd.Name = "btnAdd";
            this.btnAdd.Size = new System.Drawing.Size(64, 24);
            this.btnAdd.TabIndex = 54;
            this.btnAdd.Text = "Add";
            this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
            // 
            // CodeTableAdmin
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(882, 444);
            this.Controls.Add(this.lblInstructions);
            this.Controls.Add(this.pbLast);
            this.Controls.Add(this.pbPrevious);
            this.Controls.Add(this.pbNext);
            this.Controls.Add(this.pbFirst);
            this.Controls.Add(this.uwgList);
            this.Controls.Add(this.btnCancel);
            this.Controls.Add(this.btnSave);
            this.Controls.Add(this.btnDelete);
            this.Controls.Add(this.btnAdd);
            this.Name = "CodeTableAdmin";
            this.Text = "Code Table Admin";
            ((System.ComponentModel.ISupportInitialize)(this.pbLast)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbPrevious)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbNext)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbFirst)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.uwgList)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		#region Commands
		private void LoadGrid()
		{
			switch( enTable )
			{
				case CodeTable.City:
					LoadCountyValueList();
					LoadCityGrid();
					break;

				case CodeTable.County:
					LoadCountyGrid();
					break;

				case CodeTable.Region:
					LoadRegionGrid();
					break;
                case CodeTable.ProjectStatus:
                    LoadProjectStatusGrid();
                    break;

				default:
					throw new ArgumentOutOfRangeException( string.Format( "Code table {0} not recognized", enTable.ToString() ) );
			}
		}

		private void LoadCountyValueList()
		{
			int idx = uwgList.DisplayLayout.ValueLists.IndexOf( VALUE_LIST_COUNTIES );

			if( idx == -1 )
			{
				DataSet dsCounties = ProjectData.ProjectCountyList();
				uwgList.DisplayLayout.ValueLists.Add( VALUE_LIST_COUNTIES );

				uwgList.DisplayLayout.ValueLists[ VALUE_LIST_COUNTIES ].DisplayStyle = Infragistics.Win.ValueListDisplayStyle.DisplayText;

				foreach( DataRow record in dsCounties.Tables[0].Rows)
				{
					Infragistics.Win.ValueListItem listItem = new Infragistics.Win.ValueListItem();
					listItem.DataValue = record[ "CountyID" ];
					listItem.DisplayText = record[ "CountyName" ].ToString();
					uwgList.DisplayLayout.ValueLists[ VALUE_LIST_COUNTIES ].ValueListItems.Add( listItem );
				}
			}
		}

        private void LoadProjectStatusGrid()
        {
            DataSet ds = ProjectData.GetProjectStatus();
            SetDirtyFlag(ds.Tables[0]);
            uwgList.DataSource = ds.Tables[0];
            uwgList.DataBind();
        }

        private void LoadCityGrid()
		{
			DataSet dsCities = ProjectData.ProjectCityList();
			SetDirtyFlag( dsCities.Tables[0] );
			uwgList.DataSource = dsCities.Tables[0];
			uwgList.DataBind();
		}

		private void LoadCountyGrid()
		{
			DataSet dsCounties = ProjectData.ProjectCountyList();
			SetDirtyFlag( dsCounties.Tables[0] );
			uwgList.DataSource = dsCounties.Tables[0];
			uwgList.DataBind();
		}

		private void LoadRegionGrid()
		{
			DataSet dsRegions = ProjectData.ProjectRegionList();
			SetDirtyFlag( dsRegions.Tables[0] );
			uwgList.DataSource = dsRegions.Tables[0];
			uwgList.DataBind();
		}

		private void SetDirtyFlag( DataTable table )
		{
			DataColumn col = new DataColumn( GRID_COLUMN_DIRTY_FLAG, typeof( int ) );
			col.DefaultValue = DirtyFlags.Clean;
			table.Columns.Add( col );
		}

		private void SetButtons()
		{
			if (blnGridDirty == true)
			{
				this.btnSave.Enabled = true;
				this.btnCancel.Enabled = true;
			}
			else
			{
				this.btnSave.Enabled = false;
				this.btnCancel.Enabled = false;
			}

			if (this.uwgList.ActiveRow == null)
				this.btnDelete.Enabled = false;
			else
				this.btnDelete.Enabled = true;

            if (enTable == CodeTable.ProjectStatus)
                btnDelete.Enabled = false;

		}


		private void SaveGrid()
		{
			// Validate
			bool valid = true;
            int nameColumnIdx = uwgList.DisplayLayout.Bands[0].Columns.Count - 3;
            if (nameColumnIdx <= 0)
                nameColumnIdx = uwgList.DisplayLayout.Bands[0].Columns.Count - 2;
                

			foreach( Infragistics.Win.UltraWinGrid.UltraGridRow row in uwgList.Rows )
			{
				if( row.Cells[ nameColumnIdx ].Value.ToString() == "" )
				{
					MessageBox.Show( "Please enter a value for row " + row.Index.ToString(),
						"Data Entry Error", MessageBoxButtons.OK, MessageBoxIcon.Error );

					valid = false;
					break;
				}
			}

			// Process Updates
			if( valid )
			{
				foreach( UltraGridRow row in uwgList.Rows )
				{
					switch( (DirtyFlags)row.Cells[ GRID_COLUMN_DIRTY_FLAG ].Value )
					{
					case DirtyFlags.Clean:
						// Do nothing
						break;

					case DirtyFlags.Added:
						AddCodeTable( row );
						break;

					case DirtyFlags.Deleted:
						DeleteCodeTable( row );
						break;

					case DirtyFlags.Updated:
						UpdateCodeTable( row );
						break;

					default:
						throw new ArgumentOutOfRangeException( "Unhandled flag " + ((DirtyFlags)row.Cells[ GRID_COLUMN_DIRTY_FLAG ].Value).ToString() );
					}
				}

				// Reset state
				blnGridDirty = false;
				LoadGrid();
				SetButtons();
			}
		}

		private void AddCodeTable( UltraGridRow row )
		{
			switch( enTable )
			{
			case CodeTable.City:
				if( ProjectData.ProjectCityDupCheck( 0, row.Cells[ "CityName" ].Value.ToString() ) )
				{
					MessageBox.Show("Duplicate City found. Update failed in row " + row.Index.ToString(), "Database Error", 
						MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
				else
				{
					ProjectData.ProjectCityInsertEx( row.Cells[ "CityName" ].Value.ToString(), (int)row.Cells[ "CountyID" ].Value );
				}
				break;

			case CodeTable.County:
				if( ProjectData.ProjectCountyDupCheck( 0, row.Cells[ "CountyName" ].Value.ToString() ) )
				{
					MessageBox.Show("Duplicate County found. Update failed in row " + row.Index.ToString(), "Database Error", 
						MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
				else
				{
					ProjectData.ProjectCountyInsert( row.Cells[ "CountyName" ].Value.ToString() );
				}
				break;

			case CodeTable.Region:
				if( ProjectData.ProjectRegionDupCheck( 0, row.Cells[ "Region" ].Value.ToString() ) )
				{
					MessageBox.Show("Duplicate Region found. Update failed in row " + row.Index.ToString(), "Database Error", 
						MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
				else
				{
					ProjectData.ProjectRegionInsert( row.Cells[ "Region" ].Value.ToString() );
				}
				break;

                case CodeTable.ProjectStatus:
                    ProjectData.ProjectStatusInsert(row.Cells["Status"].Value.ToString());
                    break;

			default:
				throw new ArgumentOutOfRangeException( "Unhandled Code Table " + enTable.ToString() );
			}
		}

		private void UpdateCodeTable( UltraGridRow row )
		{
			switch( enTable )
			{
			case CodeTable.City:
				ProjectData.ProjectCityUpdateEx( row.Cells[ "CityName" ].Value.ToString(), true, (int)row.Cells[ "CityID" ].Value, (int)row.Cells[ "CountyID" ].Value );
				break;

			case CodeTable.County:
				ProjectData.ProjectCountyUpdate( row.Cells[ "CountyName" ].Value.ToString(), true, (int)row.Cells[ "CountyID" ].Value );
				break;

			case CodeTable.Region:
				ProjectData.ProjectRegionUpdate( row.Cells[ "Region" ].Value.ToString(), true, (int)row.Cells[ "RegionID" ].Value );
				break;

            case CodeTable.ProjectStatus:
                ProjectData.ProjectStatusUpdate(row.Cells["Status"].Value.ToString(), true, (int)row.Cells["StatusId"].Value);
                break;

			default:
				throw new ArgumentOutOfRangeException( "Unhandled Code Table " + enTable.ToString() );
			}
		}

		private void DeleteCodeTable( UltraGridRow row )
		{
			switch( enTable )
			{
			case CodeTable.City:
				ProjectData.ProjectCityDelete( (int)row.Cells[ "CityID" ].Value );
				break;

			case CodeTable.County:
				ProjectData.ProjectCountyDelete( (int)row.Cells[ "CountyID" ].Value );
				break;

			case CodeTable.Region:
				ProjectData.ProjectRegionDelete( (int)row.Cells[ "RegionID" ].Value );
				break;

			default:
				throw new ArgumentOutOfRangeException( "Unhandled Code Table " + enTable.ToString() );
			}
		}
		#endregion

		#region Events
		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			UltraGridRow addedRow = uwgList.DisplayLayout.Bands[0].AddNew( );
			addedRow.Cells[ GRID_COLUMN_DIRTY_FLAG ].Value = (int)DirtyFlags.Added;
			blnGridDirty = true;
			SetButtons();
		}

		private void btnDelete_Click(object sender, System.EventArgs e)
		{
			// Get the row to delete. In this case we will use the active row. 
			UltraGridRow row = this.uwgList.ActiveRow;

			if ( null != row ) 
			{ 
				DialogResult intDiagResult = MessageBox.Show("Do you want to delete this row and save all other pending changes?","Delete Row", 
					MessageBoxButtons.YesNo, MessageBoxIcon.Question);

				if (intDiagResult == DialogResult.Yes)
				{
					// if the row is a database row then mark it for deletion and hide it in the grid
					if( (int)row.Cells[ GRID_COLUMN_DIRTY_FLAG ].Value == (int)DirtyFlags.Clean )
					{
						row.Hidden = true;
						row.Cells[ GRID_COLUMN_DIRTY_FLAG ].Value = DirtyFlags.Deleted;
						blnGridDirty = true;
					}
						// else it was added by the user and not saved to the database - delete it from the grid
					else
					{
						row.Delete(false);
					}
					// set the active row to first (non-hidden) row
					GridManager.FirstButtonHandler(uwgList);
					
					SaveGrid();
				}
			} 
			else 
			{ 
				// If there is no active row, then prompt the user to select one. 
				MessageBox.Show( "Please select a single row to delete." ); 
			} 
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			SaveGrid();
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			if (blnGridDirty == true)
			{
				DialogResult intDiagResult = MessageBox.Show("Data has changed - Do you want to cancel changes?","Cancel Changes", 
					MessageBoxButtons.YesNo, MessageBoxIcon.Question);

				if (intDiagResult == DialogResult.Yes)
				{
					this.LoadGrid();
					blnGridDirty = false;
					SetButtons();
				}
			}
		}

		private void pbFirst_Click(object sender, System.EventArgs e)
		{
			GridManager.FirstButtonHandler(uwgList);
		}

		private void pbPrevious_Click(object sender, System.EventArgs e)
		{
			GridManager.PreviousButtonHandler(uwgList);
		}

		private void pbNext_Click(object sender, System.EventArgs e)
		{
			GridManager.NextButtonHandler(uwgList);
		}

		private void pbLast_Click(object sender, System.EventArgs e)
		{
			GridManager.LastButtonHandler(uwgList);
		}

		private void uwgList_AfterRowActivate(object sender, EventArgs e)
		{
			SetButtons();
		}

		private void uwgList_AfterCellUpdate(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
		{
			// If editing an existing row then set the dirty flag to edit mode for this row
			if( (int)this.uwgList.ActiveRow.Cells[ GRID_COLUMN_DIRTY_FLAG ].Value == (int)DirtyFlags.Clean )
			{
				this.uwgList.ActiveRow.Cells[ GRID_COLUMN_DIRTY_FLAG ].Value = DirtyFlags.Updated;
			}

			blnGridDirty = true;
			SetButtons();
		}

		private void uwgList_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
		{
			e.Layout.Bands[0].Columns[0].Hidden = true;

			if( enTable == CodeTable.City )
			{
				e.Layout.Bands[0].Columns[1].Header.Caption = "County";
				e.Layout.Bands[0].Columns[1].Width = 150;
				e.Layout.Bands[0].Columns[1].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
				e.Layout.Bands[0].Columns[1].ValueList = uwgList.DisplayLayout.ValueLists[ VALUE_LIST_COUNTIES ];
				//e.Layout.Bands[0].Columns[ "CountyID" ].ValueList = uwgList.DisplayLayout.ValueLists[ VALUE_LIST_COUNTIES ];

				e.Layout.Bands[0].Columns[2].Header.Caption = enTable.ToString() + " Name";
				e.Layout.Bands[0].Columns[2].Width = 430;
			}
			else
			{
				e.Layout.Bands[0].Columns[1].Header.Caption = enTable.ToString() + " Name";
				e.Layout.Bands[0].Columns[1].Width = 580;
			}

            if (enTable == CodeTable.ProjectStatus)
            {
                e.Layout.Bands[0].Columns[1].Header.Caption = enTable.ToString() + " Status";
            }
            else if (enTable == CodeTable.City)
            {
            }
            else
            {
                e.Layout.Bands[0].Columns[e.Layout.Bands[0].Columns.Count - 2].Hidden = true;	//	IsActive
            }
			e.Layout.Bands[0].Columns[ e.Layout.Bands[0].Columns.Count - 1 ].Hidden = true;	//	DirtyFlag
		}

		private void CodeTableAdmin_Closing(object sender, CancelEventArgs e)
		{
			if (blnGridDirty == true)
			{
				// If edits were made then display a dialog box to the user
				DialogResult intDiagResult = MessageBox.Show("Changes have been made on the " +
					"list.  Do you want to discard these changes?", "", 
					MessageBoxButtons.YesNo, MessageBoxIcon.Question);
				// If the user wants to save the changes cancel the close
				if (intDiagResult == DialogResult.No)
				{
					e.Cancel = true;
				}
			}
		}
		#endregion // Events
	}
}
