using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using Infragistics.Shared; 
using Infragistics.Win; 
using Infragistics.Win.UltraWinGrid; 
using CCPM.Data;

namespace CCPM.Project
{
	/// <summary>
	/// Funding Source admin page
	/// MAR 2005-04-19
	/// </summary>
	public class FundingSources : System.Windows.Forms.Form
	{
		private DataSet dsFundingSources;
		private DataSet dsDetail;
		private DataSet dsFiscalYears;

		private string _AddMode = "ADD";
		private string _ViewMode = "VIEW";
		private string _EditMode = "EDIT";
		private string _AddCloneMode = "ADDCLONE";
		private string _mode = "";  // current mode for form
		private DateTime nullDate = new DateTime(1901,1,1);

		private System.Windows.Forms.TabControl tabControlFS;
		private System.Windows.Forms.TabPage tabPageList;
		private Infragistics.Win.UltraWinGrid.UltraGrid uwgFundingSource;
		private System.Windows.Forms.Label lblFundID;
		private System.Windows.Forms.TextBox txtFundID;
		private System.Windows.Forms.Label lblFiscalYearID;
		private System.Windows.Forms.Label lblFundTitle;
        private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtFundNumber;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtDescription;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox txtSubScheduleName;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.TextBox txtRefCode;
		private System.Windows.Forms.TextBox txtScheduleNum;
		private System.Windows.Forms.TextBox txtSubScheduleNum;
		private System.Windows.Forms.TextBox txtProgram;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.TextBox txtElement;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.TextBox txtComponent;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.TextBox txtReimbCode;
		private System.Windows.Forms.Label label11;
		private Infragistics.Win.UltraWinEditors.UltraDateTimeEditor dtEncumbExpDate;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label13;
		private Infragistics.Win.UltraWinEditors.UltraDateTimeEditor dtLiquidDate;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.TextBox txtOrgCode;
		private System.Windows.Forms.TextBox txtFundTitle;
		private Infragistics.Win.UltraWinEditors.UltraCurrencyEditor txtAppropAmt;
		private System.Windows.Forms.ComboBox cbFiscalYearID;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnDelete;
		private System.Windows.Forms.Button btnEdit;
		private System.Windows.Forms.Button btnAdd2;
		private System.Windows.Forms.Button btnAddClone1;
		private System.Windows.Forms.Button btnAdd1;
		private System.Windows.Forms.Button btnView;
		private System.Windows.Forms.Button btnAddClone2;
		private System.Windows.Forms.PictureBox pbLast;
		private System.Windows.Forms.PictureBox pbPrevious;
		private System.Windows.Forms.PictureBox pbNext;
		private System.Windows.Forms.PictureBox pbFirst;
		private System.Windows.Forms.TabPage tabPagDetails;
		private System.Windows.Forms.TextBox txtCategory;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.TextBox txtSource;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.TextBox txtFYShort;
		private System.Windows.Forms.Label label17;
        private System.Windows.Forms.Label label18;
        private System.Windows.Forms.CheckBox chkIsActive;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FundingSources()
		{
			//
			// Required for Windows Form Designer support
			//
		
			InitializeComponent();

			// populate dataset for fiscal year dropdown list
			dsFiscalYears = FundingSourceData.GetFiscalYearSelectionList();
			cbFiscalYearID.DataSource = FundingSourceData.GetFiscalYearSelectionList();
			cbFiscalYearID.DisplayMember="Table.Years";
			cbFiscalYearID.ValueMember = "Table.FiscalYearID";

			// Initialize the grid with data
			LoadGrid();
            			
			_mode = _ViewMode;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		private void LoadGrid()
		{
			//Create the project objectives dataset and bind to the grid
			dsFundingSources = FundingSourceData.GetFundingSources();
			uwgFundingSource.DataSource = dsFundingSources.Tables[0];
			uwgFundingSource.DataBind();
			//uwgFundingSource.DisplayLayout.AutoFitColumns = true;
		}

		private void uwgFundingSource_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
		{
			e.Layout.Bands[0].Columns[0].Hidden = true;

			e.Layout.Bands[0].Columns[1].Width = 165;
			e.Layout.Bands[0].Columns[1].Header.Caption = "Funding Item";

			// ADS 4-Dec-2007 - 2.13 - Changing list column
			e.Layout.Bands[0].Columns[2].Width = 175;
			e.Layout.Bands[0].Columns[2].Header.Caption = "Source/Nickname";

			e.Layout.Bands[0].Columns[3].Width = 175;
			e.Layout.Bands[0].Columns[3].Header.Caption = "Program Name";

			e.Layout.Bands[0].Columns[4].Width = 85;
			e.Layout.Bands[0].Columns[4].Header.Caption = "SubAccount";

			e.Layout.Bands[0].Columns[5].Width = 65;
			e.Layout.Bands[0].Columns[5].Header.Caption = "FY";

            e.Layout.Bands[0].Columns[6].Width = 40;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Active";
            //e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.Disabled;

            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;
        }

		private void FundingSource_AfterRowActivate(object sender, System.EventArgs e) 
		{ 
			//SetButtons();
		}
		private void TabControlFS_SelectedIndexChanged(object sender, EventArgs e)
		{
			//bool okToChange = true;
			//int currentPage = tabControlFS.
			int selectedTabIndex = tabControlFS.SelectedIndex;
			if (_mode != _ViewMode)
			{
				if (selectedTabIndex==0)
				{
					tabControlFS.SelectedIndex = 1;
					this.SaveReminderMsg();
				}	
			}
			else
			{
				if (selectedTabIndex==1)
				{
					// Detail page
					if (_mode == _ViewMode)
						OpenDetailPage();
				}
			}
			
		}

		private void btnViewEdit_Click(object sender, System.EventArgs e)
		{
			OpenDetailPage();
		}
		private void OpenDetailPage()
		{
			UltraGridRow row = this.uwgFundingSource.ActiveRow;
            if (row.Index == -1) return;
			int FundID = (int)row.Cells["FundID"].Value;

			_mode = _ViewMode;
			SetAll(FundID);

			this.tabControlFS.SelectedTab = this.tabControlFS.TabPages[1];

		}
		private void SetAll(int FundID)
		{
			SetFields(FundID);
			SetButtons();
			SetControls();
		}
		private void SetFields(int FundID)
		{
			// populate detail page controls with data
			if (FundID>0)
			{
				this.dsDetail = FundingSourceData.GetFundingSourceDetail(FundID);
				//this.txtFundID = this.dsDetail.Tables[0].
				DataRow dr = dsDetail.Tables[0].Rows[0];
				if (_mode == _EditMode | _mode == _ViewMode) 
				{
					this.txtFundID.Text = dr["FundID"].ToString();
					this.cbFiscalYearID.SelectedValue = (int)dr["FiscalYearID"];
				}
				else
				{
					this.txtFundID.Text = "";
					this.cbFiscalYearID.SelectedValue = 0;
				}
				
				this.txtFundTitle.Text = (string)dr["FundTitle"];
				this.txtFYShort.Text = (string)dr["FYShort"];
                
				this.txtOrgCode.Text = (string)dr["OrgCode"];
				this.txtRefCode.Text = (string)dr["RefCode"];
				this.txtFundNumber.Text = (string)dr["FundNumber"];
				this.txtScheduleNum.Text = (string)dr["ScheduleNum"];
				
				this.txtDescription.Text = (string)dr["Description"];
				this.txtSource.Text = (string)dr["Source"];
				this.txtSubScheduleNum.Text = (string)dr["SubScheduleNum"];
				this.txtSubScheduleName.Text = (string)dr["SubScheduleName"];

				this.txtProgram.Text = (string)dr["Program"];
				this.txtElement.Text = (string)dr["Element"];
				this.txtComponent.Text = (string)dr["Component"];
				this.txtReimbCode.Text = (string)dr["ReimbCode"];
				if (_mode == _EditMode | _mode == _ViewMode) 
				{
					this.dtEncumbExpDate.Value = (DateTime)dr["EncumbExpDate"];
					this.dtLiquidDate.Value = (DateTime)dr["LiquidDate"];
					if (this.dtEncumbExpDate.DateTime==nullDate)
						this.dtEncumbExpDate.Value = null;	
					if (this.dtLiquidDate.DateTime==nullDate)
						this.dtLiquidDate.Value = null;	

				}
				else
				{
					this.dtEncumbExpDate.Value = null;
					this.dtLiquidDate.Value = null;
				}
				this.txtAppropAmt.Value = (decimal)dr["AppropAmt"];
				this.txtCategory.Text = (string)dr["Category"];
                this.chkIsActive.Checked = Convert.ToBoolean(dr["IsActive"]);

			}
			else
			{
				this.txtFundID.Text = "";
				this.cbFiscalYearID.SelectedValue = 0;
				this.txtFundTitle.Text = "";
				this.txtFYShort.Text = "";
                
				this.txtOrgCode.Text = "3760";
				this.txtRefCode.Text = "";
				this.txtFundNumber.Text = "";
				this.txtScheduleNum.Text = "";
				
				this.txtDescription.Text = "";
				this.txtSubScheduleNum.Text = "";
				this.txtSubScheduleName.Text = "";

				this.txtProgram.Text = "80";
				this.txtElement.Text = "";
				this.txtComponent.Text = "";
				this.txtReimbCode.Text = "";

				this.dtEncumbExpDate.Value = null;
				this.dtLiquidDate.Value = null;
				this.txtAppropAmt.Value = 0;
				this.txtCategory.Text = "";
                this.chkIsActive.Checked = true;
			}        
		}

		private void SetButtons()
		{
			// set detail page buttons to appropriate state
			if (_mode==_ViewMode)
			{
				this.btnEdit.Enabled = true;
				this.btnAdd2.Enabled = true;
				this.btnAddClone2.Enabled = true;
				this.btnDelete.Enabled = true;
				this.btnSave.Enabled = false;
				this.btnCancel.Enabled = false;
			}
			if (_mode == _EditMode | _mode==_AddCloneMode | _mode == _AddMode)
			{
				this.btnEdit.Enabled = false;
				this.btnAdd2.Enabled = false;
				this.btnAddClone2.Enabled = false;
				this.btnDelete.Enabled = false;
				this.btnSave.Enabled = true;
				this.btnCancel.Enabled = true;
			}
		}

		private void SetControls()
		{
			// set detail page data controls to appropriate enabled or disable state
			this.txtFundID.Enabled = false;  // key always disabled

			if (_mode == _ViewMode)
			{
				this.cbFiscalYearID.Enabled = false;
				this.txtFYShort.Enabled = false;
				this.txtFundTitle.Enabled = false;
				this.txtOrgCode.Enabled = false;
				this.txtRefCode.Enabled = false;
				this.txtFundNumber.Enabled = false;
				this.txtScheduleNum.Enabled = false;
				this.txtDescription.Enabled = false;
				this.txtSource.Enabled = false;
				this.txtSubScheduleNum.Enabled = false;
				this.txtSubScheduleName.Enabled = false;
				this.txtProgram.Enabled = false;
				this.txtElement.Enabled = false;
				this.txtComponent.Enabled = false;
				this.txtReimbCode.Enabled = false;
				this.dtEncumbExpDate.Enabled = false;
				this.dtLiquidDate.Enabled = false;
				this.txtAppropAmt.Enabled = false;
				this.txtCategory.Enabled = false;
                this.chkIsActive.Enabled = false;
            }
			else
			{
				this.cbFiscalYearID.Enabled = true;
				this.txtFYShort.Enabled = true;
				this.txtFundTitle.Enabled = true;
				this.txtOrgCode.Enabled = true;
				this.txtRefCode.Enabled = true;
				this.txtFundNumber.Enabled = true;
				this.txtScheduleNum.Enabled = true;
				this.txtDescription.Enabled = true;
				this.txtSource.Enabled = true;
				this.txtSubScheduleNum.Enabled = true;
				this.txtSubScheduleName.Enabled = true;
				this.txtProgram.Enabled = true;
				this.txtElement.Enabled = true;
				this.txtComponent.Enabled = true;
				this.txtReimbCode.Enabled = true;
				this.dtEncumbExpDate.Enabled = true;
				this.dtLiquidDate.Enabled = true;
				this.txtAppropAmt.Enabled = true;
				this.txtCategory.Enabled = true;
                this.chkIsActive.Enabled = true;
			}

		}
		private void btnEdit_Click(object sender, System.EventArgs e)
		{
			_mode = _EditMode;
			SetButtons();
			SetControls();
		}

		private void btnAdd1_Click(object sender, System.EventArgs e)
		{
			// add button on the list page
			_mode = _AddMode;
			SetAll(0);	
			this.tabControlFS.SelectedTab = this.tabControlFS.TabPages[1];
		}

		private void btnAdd2_Click(object sender, System.EventArgs e)
		{
			_mode = _AddMode;
			SetAll(0);
		}

		private void btnAddClone1_Click(object sender, System.EventArgs e)
		{
            if (uwgFundingSource.ActiveRow.Cells["FundID"].Value == System.DBNull.Value) return;
            _mode = _AddMode;
			UltraGridRow row = this.uwgFundingSource.ActiveRow;
			int FundID = (int)row.Cells["FundID"].Value;
			SetAll(FundID);	
			this.tabControlFS.SelectedTab = this.tabControlFS.TabPages[1];
		}

		private void btnAddClone2_Click(object sender, System.EventArgs e)
		{
			_mode = _AddMode;
			int FundID = Convert.ToInt32(this.txtFundID.Text);
			SetAll(FundID);
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
            int FundID = 0;
            if (uwgFundingSource.ActiveRow.Cells["FundID"].Value == System.DBNull.Value)
            {
                _mode = _ViewMode;
            	SetAll(FundID);
                return;
            }
			if (_mode==_AddMode)
			{
				// get the fund id from the selected list item
				UltraGridRow row = this.uwgFundingSource.ActiveRow;
				FundID = (int)row.Cells["FundID"].Value;
			}	
			else
			{
				FundID = Convert.ToInt32(this.txtFundID.Text);
			}

			// go back into View mode
			_mode = _ViewMode;
			SetAll(FundID);
		}

		private void pbFirst_Click(object sender, System.EventArgs e)
		{
			GridManager.FirstButtonHandler(uwgFundingSource);
		}

		private void pbPrevious_Click(object sender, System.EventArgs e)
		{
			GridManager.PreviousButtonHandler(uwgFundingSource);
		}

		private void pbNext_Click(object sender, System.EventArgs e)
		{
			GridManager.NextButtonHandler(uwgFundingSource);
		}

		private void pbLast_Click(object sender, System.EventArgs e)
		{
			GridManager.LastButtonHandler(uwgFundingSource);
		}

		public void SaveReminderMsg()
		{
			string msg = "Please save or cancel your changes.";
			DialogResult intDiagResult = MessageBox.Show(this,msg, "Data Changed", MessageBoxButtons.OK, MessageBoxIcon.Warning);
		}

		private void TabControlFS_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			// This event gets triggered when the user tries to close the form
			// If unsaved changes, return them to the detail page

			// Determine if edits were made on the various pages, if edits made
			if (_mode != _ViewMode)
			{
				// if we're in edit or add mode, prompt for save/cancel and don't allow tab change
				this.SaveReminderMsg();
				tabControlFS.SelectedIndex = 1;
				e.Cancel = true;
			}
		}
		private void btnDelete_Click(object sender, System.EventArgs e)
		{
			int FundID = Convert.ToInt32(this.txtFundID.Text);

			DialogResult intDiagResult = MessageBox.Show("Do you want to delete this Funding Source?","Delete Funding Source", 
				MessageBoxButtons.YesNo, MessageBoxIcon.Question);
			if (intDiagResult == DialogResult.Yes)
			{
				// delete the record
				string msg = FundingSourceData.FundingSourceDelete(FundID);
				if (msg!="success")
				{
					MessageBox.Show(msg,"Delete Error", 
						MessageBoxButtons.OK, MessageBoxIcon.Warning );
				}
				else
				{
					// refresh the list
					LoadGrid();

					// return to List page
					this.tabControlFS.SelectedIndex = 0;
				}
			}		
		}
		private void btnSave_Click(object sender, System.EventArgs e)
		{
			bool validData = true;
			bool noDups = true;
			if ((int)this.cbFiscalYearID.SelectedValue==0)
			{
				validData = false;
				MessageBox.Show("You must select a valid Fiscal Year.", "Data Entry Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			if (this.txtFundTitle.Text=="")
			{
				validData = false;
				MessageBox.Show("You must enter a Fund Title", "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Error);				
			}

			// check for dups
			if (validData)
			{
				if (_mode==_AddMode | _mode==_AddCloneMode)
				{
					if (FundingSourceData.FundingSourceDupCheck(
						0 
						,(int)this.cbFiscalYearID.SelectedValue
						,this.txtOrgCode.Text
						,this.txtRefCode.Text
						,this.txtFundNumber.Text
						,this.txtScheduleNum.Text 
						,this.txtSubScheduleNum.Text 
                        ,this.txtReimbCode.Text
						))
						noDups = false;
				}	
				else
				{
					if (FundingSourceData.FundingSourceDupCheck(
						Convert.ToInt32(this.txtFundID.Text) 
						,(int)this.cbFiscalYearID.SelectedValue
						,this.txtOrgCode.Text
						,this.txtRefCode.Text
						,this.txtFundNumber.Text
						,this.txtScheduleNum.Text 
						,this.txtSubScheduleNum.Text
                        , this.txtReimbCode.Text
                        ))
						noDups = false;
				}
			}
			if (!noDups)
				MessageBox.Show("Unable to Save. This Funding Source already exists.", "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
           

			// on add, newly added fund id is returned, on edit, the original fund id is returned
			if (validData & noDups)
			{
				// dates are null, convert them to dummy value (C# can't handle nulls yet)
				if (this.dtEncumbExpDate.Value == null)
					this.dtEncumbExpDate.Value = "1/1/1901";
	        
				if (this.dtLiquidDate.Value == null)
					this.dtLiquidDate.Value = "1/1/1901";


				int FundID = SaveRec();
				if (FundID>0)
				{
					// if we added a new record, need to refresh and reposition the grid
					// ADS 4-Dec-2007 = 2.13.2 - ALWAYS refresh
					this.LoadGrid();
					
					// Position the grid to the newly added row. 
					this.PositionGridRow(FundID);

					_mode = _ViewMode;
					SetAll(FundID);
				}
				else
				{
					if (_mode==_EditMode)
						MessageBox.Show("Edit failed.", "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
					else
					    MessageBox.Show("Add failed.", "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
			}
		}

		private int SaveRec()
		{
			int retVal = 0;
			string retMsg = "";
			if (_mode != _EditMode)
			{
				// Save on Add 
				retVal = FundingSourceData.FundingSourceInsert(
					 (int)this.cbFiscalYearID.SelectedValue
					,this.txtFYShort.Text
					,this.txtFundTitle.Text
					,this.txtOrgCode.Text
					,this.txtRefCode.Text
					,this.txtFundNumber.Text
					,this.txtScheduleNum.Text 
					,this.txtDescription.Text
					,this.txtSource.Text
					,this.txtSubScheduleNum.Text 
					,this.txtSubScheduleName.Text 
					,this.txtProgram.Text 
					,this.txtElement.Text 
					,this.txtComponent.Text 
					,this.txtReimbCode.Text 
					,Convert.ToDateTime(this.dtEncumbExpDate.Value) 
					,Convert.ToDateTime(this.dtLiquidDate.Value)                    
					,Convert.ToDecimal(this.txtAppropAmt.Value)
					,this.txtCategory.Text
                    ,this.chkIsActive.Checked);				

				if (retVal<=0)
				{
					retVal = -1;
				}
			}
			else
			{
				// Save on Edit
				retMsg = FundingSourceData.FundingSourceUpdate(
					 Convert.ToInt32(this.txtFundID.Text) 
					,(int)this.cbFiscalYearID.SelectedValue
					,this.txtFYShort.Text
					,this.txtFundTitle.Text
					,this.txtOrgCode.Text
					,this.txtRefCode.Text
					,this.txtFundNumber.Text
					,this.txtScheduleNum.Text 
					,this.txtDescription.Text
					,this.txtSource.Text
					,this.txtSubScheduleNum.Text 
					,this.txtSubScheduleName.Text 
					,this.txtProgram.Text 
					,this.txtElement.Text 
					,this.txtComponent.Text 
					,this.txtReimbCode.Text 
					,Convert.ToDateTime(this.dtEncumbExpDate.Value) 
					,Convert.ToDateTime(this.dtLiquidDate.Value)                    
					,Convert.ToDecimal(this.txtAppropAmt.Value)
					,this.txtCategory.Text
                    ,this.chkIsActive.Checked);		

				if (retMsg!="success")
				{
					retVal = -1;
				}

				retVal = Convert.ToInt32(this.txtFundID.Text);

			}
			return retVal;
		}

		private void PositionGridRow(int FundID)
		{
			int numRows = dsFiscalYears.Tables[0].Rows.Count; 
			for(int i = 0; i < numRows; i++)
			{
				if ((int)this.uwgFundingSource.Rows[i].Cells["FundID"].Value == FundID)
				{
					this.uwgFundingSource.ActiveRow = this.uwgFundingSource.Rows[i];
					break;
				}
			}

		}

		
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FundingSources));
            Infragistics.Win.Appearance appearance1 = new Infragistics.Win.Appearance();
            this.tabControlFS = new System.Windows.Forms.TabControl();
            this.tabPageList = new System.Windows.Forms.TabPage();
            this.pbLast = new System.Windows.Forms.PictureBox();
            this.pbPrevious = new System.Windows.Forms.PictureBox();
            this.pbNext = new System.Windows.Forms.PictureBox();
            this.pbFirst = new System.Windows.Forms.PictureBox();
            this.btnAddClone1 = new System.Windows.Forms.Button();
            this.btnAdd1 = new System.Windows.Forms.Button();
            this.btnView = new System.Windows.Forms.Button();
            this.uwgFundingSource = new Infragistics.Win.UltraWinGrid.UltraGrid();
            this.tabPagDetails = new System.Windows.Forms.TabPage();
            this.txtSource = new System.Windows.Forms.TextBox();
            this.label16 = new System.Windows.Forms.Label();
            this.txtCategory = new System.Windows.Forms.TextBox();
            this.label15 = new System.Windows.Forms.Label();
            this.btnAddClone2 = new System.Windows.Forms.Button();
            this.btnAdd2 = new System.Windows.Forms.Button();
            this.btnEdit = new System.Windows.Forms.Button();
            this.btnDelete = new System.Windows.Forms.Button();
            this.btnSave = new System.Windows.Forms.Button();
            this.btnCancel = new System.Windows.Forms.Button();
            this.label14 = new System.Windows.Forms.Label();
            this.statusBar1 = new System.Windows.Forms.StatusBar();
            this.txtAppropAmt = new Infragistics.Win.UltraWinEditors.UltraCurrencyEditor();
            this.label13 = new System.Windows.Forms.Label();
            this.dtLiquidDate = new Infragistics.Win.UltraWinEditors.UltraDateTimeEditor();
            this.label12 = new System.Windows.Forms.Label();
            this.dtEncumbExpDate = new Infragistics.Win.UltraWinEditors.UltraDateTimeEditor();
            this.txtReimbCode = new System.Windows.Forms.TextBox();
            this.label11 = new System.Windows.Forms.Label();
            this.txtComponent = new System.Windows.Forms.TextBox();
            this.label10 = new System.Windows.Forms.Label();
            this.txtElement = new System.Windows.Forms.TextBox();
            this.label9 = new System.Windows.Forms.Label();
            this.txtProgram = new System.Windows.Forms.TextBox();
            this.label8 = new System.Windows.Forms.Label();
            this.txtSubScheduleName = new System.Windows.Forms.TextBox();
            this.label7 = new System.Windows.Forms.Label();
            this.txtSubScheduleNum = new System.Windows.Forms.TextBox();
            this.label6 = new System.Windows.Forms.Label();
            this.txtDescription = new System.Windows.Forms.TextBox();
            this.label5 = new System.Windows.Forms.Label();
            this.txtFundNumber = new System.Windows.Forms.TextBox();
            this.label4 = new System.Windows.Forms.Label();
            this.txtScheduleNum = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.chkIsActive = new System.Windows.Forms.CheckBox();
            this.label18 = new System.Windows.Forms.Label();
            this.txtRefCode = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.txtOrgCode = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.txtFundTitle = new System.Windows.Forms.TextBox();
            this.lblFundTitle = new System.Windows.Forms.Label();
            this.cbFiscalYearID = new System.Windows.Forms.ComboBox();
            this.lblFiscalYearID = new System.Windows.Forms.Label();
            this.txtFundID = new System.Windows.Forms.TextBox();
            this.lblFundID = new System.Windows.Forms.Label();
            this.txtFYShort = new System.Windows.Forms.TextBox();
            this.label17 = new System.Windows.Forms.Label();
            this.tabControlFS.SuspendLayout();
            this.tabPageList.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pbLast)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbPrevious)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbNext)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbFirst)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.uwgFundingSource)).BeginInit();
            this.tabPagDetails.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.txtAppropAmt)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.dtLiquidDate)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.dtEncumbExpDate)).BeginInit();
            this.SuspendLayout();
            // 
            // tabControlFS
            // 
            this.tabControlFS.Controls.Add(this.tabPageList);
            this.tabControlFS.Controls.Add(this.tabPagDetails);
            this.tabControlFS.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.tabControlFS.Location = new System.Drawing.Point(0, 0);
            this.tabControlFS.Name = "tabControlFS";
            this.tabControlFS.SelectedIndex = 0;
            this.tabControlFS.Size = new System.Drawing.Size(760, 520);
            this.tabControlFS.TabIndex = 0;
            this.tabControlFS.Validating += new System.ComponentModel.CancelEventHandler(this.TabControlFS_Validating);
            this.tabControlFS.SelectedIndexChanged += new System.EventHandler(this.TabControlFS_SelectedIndexChanged);
            // 
            // tabPageList
            // 
            this.tabPageList.Controls.Add(this.pbLast);
            this.tabPageList.Controls.Add(this.pbPrevious);
            this.tabPageList.Controls.Add(this.pbNext);
            this.tabPageList.Controls.Add(this.pbFirst);
            this.tabPageList.Controls.Add(this.btnAddClone1);
            this.tabPageList.Controls.Add(this.btnAdd1);
            this.tabPageList.Controls.Add(this.btnView);
            this.tabPageList.Controls.Add(this.uwgFundingSource);
            this.tabPageList.Location = new System.Drawing.Point(4, 24);
            this.tabPageList.Name = "tabPageList";
            this.tabPageList.Size = new System.Drawing.Size(752, 492);
            this.tabPageList.TabIndex = 0;
            this.tabPageList.Text = "List";
            // 
            // pbLast
            // 
            this.pbLast.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.pbLast.Image = ((System.Drawing.Image)(resources.GetObject("pbLast.Image")));
            this.pbLast.Location = new System.Drawing.Point(421, 384);
            this.pbLast.Name = "pbLast";
            this.pbLast.Size = new System.Drawing.Size(32, 24);
            this.pbLast.TabIndex = 37;
            this.pbLast.TabStop = false;
            this.pbLast.Click += new System.EventHandler(this.pbLast_Click);
            // 
            // pbPrevious
            // 
            this.pbPrevious.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.pbPrevious.Image = ((System.Drawing.Image)(resources.GetObject("pbPrevious.Image")));
            this.pbPrevious.Location = new System.Drawing.Point(343, 384);
            this.pbPrevious.Name = "pbPrevious";
            this.pbPrevious.Size = new System.Drawing.Size(32, 24);
            this.pbPrevious.TabIndex = 36;
            this.pbPrevious.TabStop = false;
            this.pbPrevious.Click += new System.EventHandler(this.pbPrevious_Click);
            // 
            // pbNext
            // 
            this.pbNext.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.pbNext.Image = ((System.Drawing.Image)(resources.GetObject("pbNext.Image")));
            this.pbNext.Location = new System.Drawing.Point(382, 384);
            this.pbNext.Name = "pbNext";
            this.pbNext.Size = new System.Drawing.Size(32, 24);
            this.pbNext.TabIndex = 35;
            this.pbNext.TabStop = false;
            this.pbNext.Click += new System.EventHandler(this.pbNext_Click);
            // 
            // pbFirst
            // 
            this.pbFirst.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.pbFirst.Image = ((System.Drawing.Image)(resources.GetObject("pbFirst.Image")));
            this.pbFirst.Location = new System.Drawing.Point(304, 384);
            this.pbFirst.Name = "pbFirst";
            this.pbFirst.Size = new System.Drawing.Size(32, 24);
            this.pbFirst.TabIndex = 34;
            this.pbFirst.TabStop = false;
            this.pbFirst.Click += new System.EventHandler(this.pbFirst_Click);
            // 
            // btnAddClone1
            // 
            this.btnAddClone1.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnAddClone1.Location = new System.Drawing.Point(208, 384);
            this.btnAddClone1.Name = "btnAddClone1";
            this.btnAddClone1.Size = new System.Drawing.Size(80, 24);
            this.btnAddClone1.TabIndex = 3;
            this.btnAddClone1.Text = "Add / Clone";
            this.btnAddClone1.Click += new System.EventHandler(this.btnAddClone1_Click);
            // 
            // btnAdd1
            // 
            this.btnAdd1.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnAdd1.Location = new System.Drawing.Point(112, 384);
            this.btnAdd1.Name = "btnAdd1";
            this.btnAdd1.Size = new System.Drawing.Size(80, 24);
            this.btnAdd1.TabIndex = 2;
            this.btnAdd1.Text = "Add";
            this.btnAdd1.Click += new System.EventHandler(this.btnAdd1_Click);
            // 
            // btnView
            // 
            this.btnView.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnView.Location = new System.Drawing.Point(16, 384);
            this.btnView.Name = "btnView";
            this.btnView.Size = new System.Drawing.Size(80, 24);
            this.btnView.TabIndex = 1;
            this.btnView.Text = "View";
            this.btnView.Click += new System.EventHandler(this.btnViewEdit_Click);
            // 
            // uwgFundingSource
            // 
            appearance1.FontData.BoldAsString = "True";
            this.uwgFundingSource.DisplayLayout.Override.FixedHeaderAppearance = appearance1;
            this.uwgFundingSource.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.uwgFundingSource.Location = new System.Drawing.Point(8, 8);
            this.uwgFundingSource.Name = "uwgFundingSource";
            this.uwgFundingSource.Size = new System.Drawing.Size(744, 368);
            this.uwgFundingSource.TabIndex = 0;
            this.uwgFundingSource.AfterCellUpdate += new Infragistics.Win.UltraWinGrid.CellEventHandler(this.uwgFundingSource_AfterCellUpdate);
            this.uwgFundingSource.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(this.uwgFundingSource_InitializeLayout);
            // 
            // tabPagDetails
            // 
            this.tabPagDetails.Controls.Add(this.txtSource);
            this.tabPagDetails.Controls.Add(this.label16);
            this.tabPagDetails.Controls.Add(this.txtCategory);
            this.tabPagDetails.Controls.Add(this.label15);
            this.tabPagDetails.Controls.Add(this.btnAddClone2);
            this.tabPagDetails.Controls.Add(this.btnAdd2);
            this.tabPagDetails.Controls.Add(this.btnEdit);
            this.tabPagDetails.Controls.Add(this.btnDelete);
            this.tabPagDetails.Controls.Add(this.btnSave);
            this.tabPagDetails.Controls.Add(this.btnCancel);
            this.tabPagDetails.Controls.Add(this.label14);
            this.tabPagDetails.Controls.Add(this.statusBar1);
            this.tabPagDetails.Controls.Add(this.txtAppropAmt);
            this.tabPagDetails.Controls.Add(this.label13);
            this.tabPagDetails.Controls.Add(this.dtLiquidDate);
            this.tabPagDetails.Controls.Add(this.label12);
            this.tabPagDetails.Controls.Add(this.dtEncumbExpDate);
            this.tabPagDetails.Controls.Add(this.txtReimbCode);
            this.tabPagDetails.Controls.Add(this.label11);
            this.tabPagDetails.Controls.Add(this.txtComponent);
            this.tabPagDetails.Controls.Add(this.label10);
            this.tabPagDetails.Controls.Add(this.txtElement);
            this.tabPagDetails.Controls.Add(this.label9);
            this.tabPagDetails.Controls.Add(this.txtProgram);
            this.tabPagDetails.Controls.Add(this.label8);
            this.tabPagDetails.Controls.Add(this.txtSubScheduleName);
            this.tabPagDetails.Controls.Add(this.label7);
            this.tabPagDetails.Controls.Add(this.txtSubScheduleNum);
            this.tabPagDetails.Controls.Add(this.label6);
            this.tabPagDetails.Controls.Add(this.txtDescription);
            this.tabPagDetails.Controls.Add(this.label5);
            this.tabPagDetails.Controls.Add(this.txtFundNumber);
            this.tabPagDetails.Controls.Add(this.label4);
            this.tabPagDetails.Controls.Add(this.txtScheduleNum);
            this.tabPagDetails.Controls.Add(this.label3);
            this.tabPagDetails.Controls.Add(this.chkIsActive);
            this.tabPagDetails.Controls.Add(this.label18);
            this.tabPagDetails.Controls.Add(this.txtRefCode);
            this.tabPagDetails.Controls.Add(this.label2);
            this.tabPagDetails.Controls.Add(this.txtOrgCode);
            this.tabPagDetails.Controls.Add(this.label1);
            this.tabPagDetails.Controls.Add(this.txtFundTitle);
            this.tabPagDetails.Controls.Add(this.lblFundTitle);
            this.tabPagDetails.Controls.Add(this.cbFiscalYearID);
            this.tabPagDetails.Controls.Add(this.lblFiscalYearID);
            this.tabPagDetails.Controls.Add(this.txtFundID);
            this.tabPagDetails.Controls.Add(this.lblFundID);
            this.tabPagDetails.Controls.Add(this.txtFYShort);
            this.tabPagDetails.Controls.Add(this.label17);
            this.tabPagDetails.Location = new System.Drawing.Point(4, 24);
            this.tabPagDetails.Name = "tabPagDetails";
            this.tabPagDetails.Size = new System.Drawing.Size(752, 492);
            this.tabPagDetails.TabIndex = 1;
            this.tabPagDetails.Text = "Details";
            // 
            // txtSource
            // 
            this.txtSource.ForeColor = System.Drawing.Color.Black;
            this.txtSource.Location = new System.Drawing.Point(120, 117);
            this.txtSource.MaxLength = 80;
            this.txtSource.Name = "txtSource";
            this.txtSource.Size = new System.Drawing.Size(500, 22);
            this.txtSource.TabIndex = 17;
            // 
            // label16
            // 
            this.label16.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label16.Location = new System.Drawing.Point(29, 115);
            this.label16.Name = "label16";
            this.label16.Size = new System.Drawing.Size(88, 30);
            this.label16.TabIndex = 16;
            this.label16.Text = "Source/         Nickname";
            // 
            // txtCategory
            // 
            this.txtCategory.ForeColor = System.Drawing.Color.Black;
            this.txtCategory.Location = new System.Drawing.Point(120, 352);
            this.txtCategory.Name = "txtCategory";
            this.txtCategory.Size = new System.Drawing.Size(304, 22);
            this.txtCategory.TabIndex = 39;
            // 
            // label15
            // 
            this.label15.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label15.Location = new System.Drawing.Point(29, 356);
            this.label15.Name = "label15";
            this.label15.Size = new System.Drawing.Size(72, 16);
            this.label15.TabIndex = 38;
            this.label15.Text = "Category";
            // 
            // btnAddClone2
            // 
            this.btnAddClone2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.btnAddClone2.Location = new System.Drawing.Point(194, 384);
            this.btnAddClone2.Name = "btnAddClone2";
            this.btnAddClone2.Size = new System.Drawing.Size(88, 24);
            this.btnAddClone2.TabIndex = 42;
            this.btnAddClone2.Text = "Add / Clone";
            this.btnAddClone2.Click += new System.EventHandler(this.btnAddClone2_Click);
            // 
            // btnAdd2
            // 
            this.btnAdd2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.btnAdd2.Location = new System.Drawing.Point(105, 384);
            this.btnAdd2.Name = "btnAdd2";
            this.btnAdd2.Size = new System.Drawing.Size(88, 24);
            this.btnAdd2.TabIndex = 41;
            this.btnAdd2.Text = "Add";
            this.btnAdd2.Click += new System.EventHandler(this.btnAdd2_Click);
            // 
            // btnEdit
            // 
            this.btnEdit.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.btnEdit.Location = new System.Drawing.Point(16, 384);
            this.btnEdit.Name = "btnEdit";
            this.btnEdit.Size = new System.Drawing.Size(88, 24);
            this.btnEdit.TabIndex = 40;
            this.btnEdit.Text = "Edit";
            this.btnEdit.Click += new System.EventHandler(this.btnEdit_Click);
            // 
            // btnDelete
            // 
            this.btnDelete.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.btnDelete.Location = new System.Drawing.Point(283, 384);
            this.btnDelete.Name = "btnDelete";
            this.btnDelete.Size = new System.Drawing.Size(88, 24);
            this.btnDelete.TabIndex = 43;
            this.btnDelete.Text = "Delete";
            this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
            // 
            // btnSave
            // 
            this.btnSave.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.btnSave.Location = new System.Drawing.Point(372, 384);
            this.btnSave.Name = "btnSave";
            this.btnSave.Size = new System.Drawing.Size(88, 24);
            this.btnSave.TabIndex = 44;
            this.btnSave.Text = "Save";
            this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
            // 
            // btnCancel
            // 
            this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.btnCancel.Location = new System.Drawing.Point(461, 384);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(88, 24);
            this.btnCancel.TabIndex = 45;
            this.btnCancel.Text = "Cancel";
            this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
            // 
            // label14
            // 
            this.label14.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label14.Location = new System.Drawing.Point(28, 319);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(64, 16);
            this.label14.TabIndex = 36;
            this.label14.Text = "Amount";
            // 
            // statusBar1
            // 
            this.statusBar1.Location = new System.Drawing.Point(0, 470);
            this.statusBar1.Name = "statusBar1";
            this.statusBar1.Size = new System.Drawing.Size(752, 22);
            this.statusBar1.TabIndex = 33;
            this.statusBar1.Text = "statusBar1";
            // 
            // txtAppropAmt
            // 
            this.txtAppropAmt.Location = new System.Drawing.Point(120, 319);
            this.txtAppropAmt.Name = "txtAppropAmt";
            this.txtAppropAmt.Size = new System.Drawing.Size(100, 23);
            this.txtAppropAmt.TabIndex = 37;
            // 
            // label13
            // 
            this.label13.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label13.Location = new System.Drawing.Point(28, 287);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(88, 16);
            this.label13.TabIndex = 34;
            this.label13.Text = "Liquidate By";
            // 
            // dtLiquidDate
            // 
            this.dtLiquidDate.Location = new System.Drawing.Point(120, 287);
            this.dtLiquidDate.Name = "dtLiquidDate";
            this.dtLiquidDate.Size = new System.Drawing.Size(96, 23);
            this.dtLiquidDate.TabIndex = 35;
            // 
            // label12
            // 
            this.label12.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label12.Location = new System.Drawing.Point(28, 255);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(88, 16);
            this.label12.TabIndex = 32;
            this.label12.Text = "Encumber By";
            // 
            // dtEncumbExpDate
            // 
            this.dtEncumbExpDate.Location = new System.Drawing.Point(120, 255);
            this.dtEncumbExpDate.Name = "dtEncumbExpDate";
            this.dtEncumbExpDate.Size = new System.Drawing.Size(96, 23);
            this.dtEncumbExpDate.TabIndex = 33;
            // 
            // txtReimbCode
            // 
            this.txtReimbCode.ForeColor = System.Drawing.Color.Black;
            this.txtReimbCode.Location = new System.Drawing.Point(548, 214);
            this.txtReimbCode.Name = "txtReimbCode";
            this.txtReimbCode.Size = new System.Drawing.Size(72, 22);
            this.txtReimbCode.TabIndex = 31;
            // 
            // label11
            // 
            this.label11.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label11.Location = new System.Drawing.Point(469, 217);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(80, 16);
            this.label11.TabIndex = 30;
            this.label11.Text = "Reimb Code";
            // 
            // txtComponent
            // 
            this.txtComponent.ForeColor = System.Drawing.Color.Black;
            this.txtComponent.Location = new System.Drawing.Point(412, 214);
            this.txtComponent.Name = "txtComponent";
            this.txtComponent.Size = new System.Drawing.Size(56, 22);
            this.txtComponent.TabIndex = 29;
            // 
            // label10
            // 
            this.label10.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label10.Location = new System.Drawing.Point(315, 217);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(91, 19);
            this.label10.TabIndex = 28;
            this.label10.Text = "Component";
            // 
            // txtElement
            // 
            this.txtElement.ForeColor = System.Drawing.Color.Black;
            this.txtElement.Location = new System.Drawing.Point(253, 214);
            this.txtElement.Name = "txtElement";
            this.txtElement.Size = new System.Drawing.Size(56, 22);
            this.txtElement.TabIndex = 27;
            // 
            // label9
            // 
            this.label9.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label9.Location = new System.Drawing.Point(181, 217);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(63, 16);
            this.label9.TabIndex = 26;
            this.label9.Text = "Element";
            // 
            // txtProgram
            // 
            this.txtProgram.ForeColor = System.Drawing.Color.Black;
            this.txtProgram.Location = new System.Drawing.Point(120, 217);
            this.txtProgram.Name = "txtProgram";
            this.txtProgram.Size = new System.Drawing.Size(56, 22);
            this.txtProgram.TabIndex = 25;
            // 
            // label8
            // 
            this.label8.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label8.Location = new System.Drawing.Point(28, 220);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(80, 16);
            this.label8.TabIndex = 24;
            this.label8.Text = "Program";
            // 
            // txtSubScheduleName
            // 
            this.txtSubScheduleName.ForeColor = System.Drawing.Color.Black;
            this.txtSubScheduleName.Location = new System.Drawing.Point(374, 180);
            this.txtSubScheduleName.Name = "txtSubScheduleName";
            this.txtSubScheduleName.Size = new System.Drawing.Size(189, 22);
            this.txtSubScheduleName.TabIndex = 23;
            // 
            // label7
            // 
            this.label7.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label7.Location = new System.Drawing.Point(181, 186);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(128, 16);
            this.label7.TabIndex = 22;
            this.label7.Text = "Subschedule Name";
            // 
            // txtSubScheduleNum
            // 
            this.txtSubScheduleNum.ForeColor = System.Drawing.Color.Black;
            this.txtSubScheduleNum.Location = new System.Drawing.Point(120, 183);
            this.txtSubScheduleNum.Name = "txtSubScheduleNum";
            this.txtSubScheduleNum.Size = new System.Drawing.Size(56, 22);
            this.txtSubScheduleNum.TabIndex = 21;
            // 
            // label6
            // 
            this.label6.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label6.Location = new System.Drawing.Point(28, 186);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(96, 16);
            this.label6.TabIndex = 20;
            this.label6.Text = "Subschedule #";
            // 
            // txtDescription
            // 
            this.txtDescription.ForeColor = System.Drawing.Color.Black;
            this.txtDescription.Location = new System.Drawing.Point(120, 150);
            this.txtDescription.Name = "txtDescription";
            this.txtDescription.Size = new System.Drawing.Size(500, 22);
            this.txtDescription.TabIndex = 19;
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(28, 156);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(88, 16);
            this.label5.TabIndex = 18;
            this.label5.Text = "Description";
            // 
            // txtFundNumber
            // 
            this.txtFundNumber.ForeColor = System.Drawing.Color.Black;
            this.txtFundNumber.Location = new System.Drawing.Point(419, 80);
            this.txtFundNumber.Name = "txtFundNumber";
            this.txtFundNumber.Size = new System.Drawing.Size(56, 22);
            this.txtFundNumber.TabIndex = 13;
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(365, 86);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(48, 16);
            this.label4.TabIndex = 12;
            this.label4.Text = "Fund #";
            // 
            // txtScheduleNum
            // 
            this.txtScheduleNum.ForeColor = System.Drawing.Color.Black;
            this.txtScheduleNum.Location = new System.Drawing.Point(564, 83);
            this.txtScheduleNum.Name = "txtScheduleNum";
            this.txtScheduleNum.Size = new System.Drawing.Size(56, 22);
            this.txtScheduleNum.TabIndex = 15;
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(483, 86);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(80, 16);
            this.label3.TabIndex = 14;
            this.label3.Text = "Schedule #";
            // 
            // chkIsActive
            // 
            this.chkIsActive.AutoSize = true;
            this.chkIsActive.Location = new System.Drawing.Point(605, 17);
            this.chkIsActive.Name = "chkIsActive";
            this.chkIsActive.Size = new System.Drawing.Size(15, 14);
            this.chkIsActive.TabIndex = 6;
            this.chkIsActive.UseVisualStyleBackColor = true;
            this.chkIsActive.CheckedChanged += new System.EventHandler(this.chkIsActive_CheckedChanged);
            // 
            // label18
            // 
            this.label18.AutoSize = true;
            this.label18.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold);
            this.label18.Location = new System.Drawing.Point(552, 16);
            this.label18.Name = "label18";
            this.label18.Size = new System.Drawing.Size(47, 16);
            this.label18.TabIndex = 7;
            this.label18.Text = "Active";
            // 
            // txtRefCode
            // 
            this.txtRefCode.ForeColor = System.Drawing.Color.Black;
            this.txtRefCode.Location = new System.Drawing.Point(250, 83);
            this.txtRefCode.Name = "txtRefCode";
            this.txtRefCode.Size = new System.Drawing.Size(56, 22);
            this.txtRefCode.TabIndex = 11;
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(182, 86);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(66, 16);
            this.label2.TabIndex = 10;
            this.label2.Text = "Ref Code";
            // 
            // txtOrgCode
            // 
            this.txtOrgCode.ForeColor = System.Drawing.Color.Black;
            this.txtOrgCode.Location = new System.Drawing.Point(120, 83);
            this.txtOrgCode.Name = "txtOrgCode";
            this.txtOrgCode.Size = new System.Drawing.Size(56, 22);
            this.txtOrgCode.TabIndex = 9;
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(28, 86);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(80, 16);
            this.label1.TabIndex = 8;
            this.label1.Text = "Org Code";
            // 
            // txtFundTitle
            // 
            this.txtFundTitle.ForeColor = System.Drawing.Color.Black;
            this.txtFundTitle.Location = new System.Drawing.Point(120, 47);
            this.txtFundTitle.Name = "txtFundTitle";
            this.txtFundTitle.Size = new System.Drawing.Size(500, 22);
            this.txtFundTitle.TabIndex = 7;
            // 
            // lblFundTitle
            // 
            this.lblFundTitle.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblFundTitle.Location = new System.Drawing.Point(28, 49);
            this.lblFundTitle.Name = "lblFundTitle";
            this.lblFundTitle.Size = new System.Drawing.Size(72, 16);
            this.lblFundTitle.TabIndex = 6;
            this.lblFundTitle.Text = "Fund Title";
            // 
            // cbFiscalYearID
            // 
            this.cbFiscalYearID.ForeColor = System.Drawing.Color.Black;
            this.cbFiscalYearID.Location = new System.Drawing.Point(250, 11);
            this.cbFiscalYearID.Name = "cbFiscalYearID";
            this.cbFiscalYearID.Size = new System.Drawing.Size(121, 23);
            this.cbFiscalYearID.TabIndex = 3;
            this.cbFiscalYearID.SelectedIndexChanged += new System.EventHandler(this.cbFiscalYearID_SelectedIndexChanged);
            // 
            // lblFiscalYearID
            // 
            this.lblFiscalYearID.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblFiscalYearID.Location = new System.Drawing.Point(182, 16);
            this.lblFiscalYearID.Name = "lblFiscalYearID";
            this.lblFiscalYearID.Size = new System.Drawing.Size(62, 16);
            this.lblFiscalYearID.TabIndex = 2;
            this.lblFiscalYearID.Text = "Fiscal Year";
            // 
            // txtFundID
            // 
            this.txtFundID.Enabled = false;
            this.txtFundID.ForeColor = System.Drawing.Color.Black;
            this.txtFundID.Location = new System.Drawing.Point(120, 13);
            this.txtFundID.Name = "txtFundID";
            this.txtFundID.Size = new System.Drawing.Size(56, 22);
            this.txtFundID.TabIndex = 1;
            // 
            // lblFundID
            // 
            this.lblFundID.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblFundID.Location = new System.Drawing.Point(28, 15);
            this.lblFundID.Name = "lblFundID";
            this.lblFundID.Size = new System.Drawing.Size(56, 16);
            this.lblFundID.TabIndex = 0;
            this.lblFundID.Text = "Fund ID";
            // 
            // txtFYShort
            // 
            this.txtFYShort.Enabled = false;
            this.txtFYShort.ForeColor = System.Drawing.Color.Black;
            this.txtFYShort.Location = new System.Drawing.Point(457, 13);
            this.txtFYShort.MaxLength = 10;
            this.txtFYShort.Name = "txtFYShort";
            this.txtFYShort.Size = new System.Drawing.Size(80, 22);
            this.txtFYShort.TabIndex = 5;
            // 
            // label17
            // 
            this.label17.Font = new System.Drawing.Font("Arial", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label17.Location = new System.Drawing.Point(395, 14);
            this.label17.Name = "label17";
            this.label17.Size = new System.Drawing.Size(56, 16);
            this.label17.TabIndex = 4;
            this.label17.Text = "FYShort";
            // 
            // FundingSources
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(760, 444);
            this.Controls.Add(this.tabControlFS);
            this.Name = "FundingSources";
            this.Text = "Funding Sources";
            this.tabControlFS.ResumeLayout(false);
            this.tabPageList.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.pbLast)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbPrevious)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbNext)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pbFirst)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.uwgFundingSource)).EndInit();
            this.tabPagDetails.ResumeLayout(false);
            this.tabPagDetails.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.txtAppropAmt)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.dtLiquidDate)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.dtEncumbExpDate)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		private void cbFiscalYearID_SelectedIndexChanged(object sender, System.EventArgs e)
		{
            if (cbFiscalYearID.SelectedIndex == -1)
                return;
			string fyLong = this.cbFiscalYearID.Text;
			this.txtFYShort.Text = string.Format( "{0}/{1}", fyLong.Substring( 2, 2 ), fyLong.Substring( 7, 2 ) );
		}

        private void chkIsActive_CheckedChanged(object sender, EventArgs e)
        {
            btnSave.Enabled = true;
        }

        private void uwgFundingSource_AfterCellUpdate(object sender, CellEventArgs e)
        {
            try
            {
                if (uwgFundingSource.ActiveRow.Index == -1) return;
                uwgFundingSource.EventManager.SetEnabled(GridEventIds.AfterCellUpdate, false);

                if (uwgFundingSource.ActiveRow.Cells["IsActive"].IsInEditMode == true)
                {
                    int istatOriginalFundingSource = (Convert.ToBoolean(uwgFundingSource.ActiveRow.Cells["IsActive"].OriginalValue) == true) ? 1 : 0;
                    int istatNewFundingSource = (Convert.ToBoolean(uwgFundingSource.ActiveRow.Cells["IsActive"].Value)==true) ? 1 : 0;
                    string newStatusFundingSource = istatNewFundingSource == 1 ? "Activate" : "Deactivate";

                    DialogResult intDiagResult = MessageBox.Show("Would you like to " + newStatusFundingSource + " funding source " + uwgFundingSource.ActiveRow.Cells["FundingItem"].Value + "?",
                                       "Active/Inactive  Funding Source.", MessageBoxButtons.OKCancel);
                    if (intDiagResult == DialogResult.OK)
                    {
                        string retVal = FundingSourceData.FundingSourceUpdateActivation(Convert.ToInt32(uwgFundingSource.ActiveRow.Cells["FundId"].Value), istatNewFundingSource);
                        
                        if (retVal != "success")
                            MessageBox.Show("Edit failed.", "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    else
                    {
                        e.Cell.Value = istatOriginalFundingSource;
                        e.Cell.CancelUpdate();
                        return;
                    }
                }

            }
            catch (Exception ex)
            { }
            finally
            {
                uwgFundingSource.EventManager.SetEnabled(GridEventIds.AfterCellUpdate, true);
            
            }
        }

	}
}
