using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Infragistics.Win.UltraWinGrid;

namespace CCPM.Project
{
	/// <summary>
	
	/// </summary>
	public class OpenProject : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private int projectId;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton rbActive;
		private System.Windows.Forms.RadioButton rbInactive;
		private System.Windows.Forms.RadioButton rbComplete;
		private System.Windows.Forms.RadioButton rbAll;
		//private int fileNameSelectedIndex = 0;
		//private int fileNumberSelectedIndex = 0;
		private System.Windows.Forms.Label label3;
		protected System.Windows.Forms.Button btnOpenByName;
		//private System.Windows.Forms.PictureBox pictureBox2;
		protected System.Windows.Forms.Button btnNew;
		protected System.Windows.Forms.Button btnSearch;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.PictureBox pictureBox3;
		//private string lastListSelected = "cbProjectName";
		private System.Windows.Forms.RadioButton rdSelectedProject;
		private System.Windows.Forms.RadioButton rdSelectedFile;
        protected System.Windows.Forms.Button btnRefresh;
		private Infragistics.Win.UltraWinGrid.UltraCombo cbProjectNameAutoComplete;
        private Infragistics.Win.UltraWinGrid.UltraCombo cbFileNumberAutoComplete;
        private Label label4;
        private Label label5;
        private RadioButton rbClosed;
        protected Button btnCopyProject;
        private IContainer components;
		
		public int ProjectId
		{
			get{return projectId;}
			set{projectId = value;}
		}

		public OpenProject()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            try 
            {
                PopulateOpenMenu();
            }
            catch (Exception ex) 
            {
                throw ex;
            }
            //EnableLists();
            cbProjectNameAutoComplete.Focus();
            cbProjectNameAutoComplete.Select();
        }

		public int GetStatusFilter()
		{
			int statusFilter = 0;
			if(rbInactive.Checked) statusFilter = 1;
			else if(rbComplete.Checked) statusFilter = 2;
            else if (rbClosed.Checked) statusFilter = 3;
            else if (rbAll.Checked) statusFilter = 4;

			return statusFilter;
		}
		public void PopulateOpenMenu()
		{
			RefreshLists();
			this.rdSelectedProject.Checked = true;
			this.rdSelectedFile.Checked = false;
			this.EnableLists();
		}

		public virtual void SetProjectId(int projectId)
		{
			this.ProjectId = projectId;
			if(ProjectId != 0)
			{
				this.DialogResult = DialogResult.OK;
			}
		}

		private void cbProjectNameAutoComplete_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e) 
		{ 
 
			// Hide columns that you dont want displayed in the drop down. 
			this.cbProjectNameAutoComplete.DisplayLayout.Bands[0].ColHeadersVisible = false;
			this.cbProjectNameAutoComplete.DisplayLayout.Bands[0].Columns[0].Hidden = true; 
			//this.cbProjectNameAutoComplete.DisplayLayout.Bands[0].Columns[1].Header.Caption = "Project Name";
			this.cbProjectNameAutoComplete.DisplayLayout.Bands[0].Columns[1].Width = 510;
			this.cbProjectNameAutoComplete.DisplayLayout.Bands[0].Columns[2].Hidden = true; 
 
			// Set the scroll style to immediate so when the user scrolls the drop down  
			// using scroll thumb, rows get scrolled imediately. 
			this.cbProjectNameAutoComplete.DisplayLayout.ScrollStyle = ScrollStyle.Immediate;  
		} 

		private void cbFileNumberAutoComplete_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e) 
		{
			// Hide columns that you dont want displayed in the drop down. 
			this.cbFileNumberAutoComplete.DisplayLayout.Bands[0].ColHeadersVisible = false;
			this.cbFileNumberAutoComplete.DisplayLayout.Bands[0].Columns[0].Hidden = true; 
			this.cbFileNumberAutoComplete.DisplayLayout.Bands[0].Columns[1].Header.Caption = "Project Number";
            this.cbFileNumberAutoComplete.DisplayLayout.Bands[0].Columns[1].Width = 510;
			//this.cbFileNumberAutoComplete.DisplayLayout.Bands[0].Columns[2].Hidden = true; 
 
			// Set the scroll style to immediate so when the user scrolls the drop down  
			// using scroll thumb, rows get scrolled imediately. 
			this.cbProjectNameAutoComplete.DisplayLayout.ScrollStyle = ScrollStyle.Immediate;  
		} 


		private void RefreshLists()
		{
		    System.Data.DataSet ds = CCPM.Data.ProjectData.GetProjectListEx(GetStatusFilter());
			
			//Handle empty DataTable condition
			if(ds.Tables[0].Rows.Count < 1)//Project Name
			{
				DataRow dr = ds.Tables[0].NewRow();
				dr["ProjectName"] = "N/A";
				dr["ProjectId"] = 0;
				ds.Tables[0].Rows.Add(dr);
			}
			if(ds.Tables[1].Rows.Count < 1)//Project Number
			{
				DataRow dr = ds.Tables[1].NewRow();
				dr["FileNumber"] = "N/A";
				dr["ProjectId"] = 0;
				ds.Tables[1].Rows.Add(dr);
			}

			cbProjectNameAutoComplete.DataSource = null;
			cbProjectNameAutoComplete.DataSource = ds.Tables[0];
			cbProjectNameAutoComplete.ValueMember = "ProjectId";
			cbProjectNameAutoComplete.DisplayMember = "ProjectName";
			cbProjectNameAutoComplete.DropDownStyle = UltraComboStyle.DropDown;
            cbProjectNameAutoComplete.AutoEdit = true; 
            cbProjectNameAutoComplete.SelectedRow = cbProjectNameAutoComplete.Rows[0]  ;

			//cbFileNumberAutoComplete.DataSource = null;
			cbFileNumberAutoComplete.DataSource = ds.Tables[1];
			cbFileNumberAutoComplete.ValueMember = "ProjectId";
			cbFileNumberAutoComplete.DisplayMember = "FileNumber";
            cbFileNumberAutoComplete.AutoEdit = true;   // provides 'AutoComplete' feature
            cbFileNumberAutoComplete.DropDownStyle = UltraComboStyle.DropDown;
            cbFileNumberAutoComplete.SelectedRow = cbFileNumberAutoComplete.Rows[0];
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(OpenProject));
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.rbActive = new System.Windows.Forms.RadioButton();
            this.rbInactive = new System.Windows.Forms.RadioButton();
            this.rbComplete = new System.Windows.Forms.RadioButton();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.rbClosed = new System.Windows.Forms.RadioButton();
            this.rbAll = new System.Windows.Forms.RadioButton();
            this.label3 = new System.Windows.Forms.Label();
            this.btnOpenByName = new System.Windows.Forms.Button();
            this.btnNew = new System.Windows.Forms.Button();
            this.btnSearch = new System.Windows.Forms.Button();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.pictureBox3 = new System.Windows.Forms.PictureBox();
            this.rdSelectedProject = new System.Windows.Forms.RadioButton();
            this.rdSelectedFile = new System.Windows.Forms.RadioButton();
            this.btnRefresh = new System.Windows.Forms.Button();
            this.cbProjectNameAutoComplete = new Infragistics.Win.UltraWinGrid.UltraCombo();
            this.cbFileNumberAutoComplete = new Infragistics.Win.UltraWinGrid.UltraCombo();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.btnCopyProject = new System.Windows.Forms.Button();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox3)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.cbProjectNameAutoComplete)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.cbFileNumberAutoComplete)).BeginInit();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Lucida Sans Unicode", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(262, 174);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(137, 24);
            this.label1.TabIndex = 0;
            this.label1.Text = "Project Name:";
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Lucida Sans Unicode", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(262, 205);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(143, 22);
            this.label2.TabIndex = 6;
            this.label2.Text = "Project Number:";
            // 
            // rbActive
            // 
            this.rbActive.Location = new System.Drawing.Point(13, 16);
            this.rbActive.Name = "rbActive";
            this.rbActive.Size = new System.Drawing.Size(56, 16);
            this.rbActive.TabIndex = 6;
            this.rbActive.TabStop = true;
            this.rbActive.Text = "Active";
            this.rbActive.CheckedChanged += new System.EventHandler(this.rbStatusFilter_SelectionChanged);
            // 
            // rbInactive
            // 
            this.rbInactive.Location = new System.Drawing.Point(86, 12);
            this.rbInactive.Name = "rbInactive";
            this.rbInactive.Size = new System.Drawing.Size(69, 24);
            this.rbInactive.TabIndex = 7;
            this.rbInactive.TabStop = true;
            this.rbInactive.Text = "Inactive";
            this.rbInactive.CheckedChanged += new System.EventHandler(this.rbStatusFilter_SelectionChanged);
            // 
            // rbComplete
            // 
            this.rbComplete.Location = new System.Drawing.Point(161, 12);
            this.rbComplete.Name = "rbComplete";
            this.rbComplete.Size = new System.Drawing.Size(71, 24);
            this.rbComplete.TabIndex = 8;
            this.rbComplete.TabStop = true;
            this.rbComplete.Text = "Complete";
            this.rbComplete.CheckedChanged += new System.EventHandler(this.rbStatusFilter_SelectionChanged);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.rbClosed);
            this.groupBox1.Controls.Add(this.rbAll);
            this.groupBox1.Controls.Add(this.rbActive);
            this.groupBox1.Controls.Add(this.rbInactive);
            this.groupBox1.Controls.Add(this.rbComplete);
            this.groupBox1.Location = new System.Drawing.Point(435, 244);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(547, 45);
            this.groupBox1.TabIndex = 5;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Filter By Project Status";
            // 
            // rbClosed
            // 
            this.rbClosed.Location = new System.Drawing.Point(238, 12);
            this.rbClosed.Name = "rbClosed";
            this.rbClosed.Size = new System.Drawing.Size(71, 24);
            this.rbClosed.TabIndex = 9;
            this.rbClosed.TabStop = true;
            this.rbClosed.Text = "Closed";
            // 
            // rbAll
            // 
            this.rbAll.Checked = true;
            this.rbAll.Location = new System.Drawing.Point(315, 12);
            this.rbAll.Name = "rbAll";
            this.rbAll.Size = new System.Drawing.Size(45, 24);
            this.rbAll.TabIndex = 10;
            this.rbAll.TabStop = true;
            this.rbAll.Text = "All";
            this.rbAll.CheckedChanged += new System.EventHandler(this.rbStatusFilter_SelectionChanged);
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 48F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.ForeColor = System.Drawing.Color.DarkBlue;
            this.label3.Location = new System.Drawing.Point(435, 12);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(545, 88);
            this.label3.TabIndex = 13;
            this.label3.Text = "Project Manager";
            // 
            // btnOpenByName
            // 
            this.btnOpenByName.BackColor = System.Drawing.SystemColors.Control;
            this.btnOpenByName.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnOpenByName.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.btnOpenByName.Location = new System.Drawing.Point(435, 304);
            this.btnOpenByName.Name = "btnOpenByName";
            this.btnOpenByName.Size = new System.Drawing.Size(144, 24);
            this.btnOpenByName.TabIndex = 11;
            this.btnOpenByName.Text = "&Open Selected Project";
            this.btnOpenByName.UseVisualStyleBackColor = false;
            this.btnOpenByName.Click += new System.EventHandler(this.btnOpenByName_Click);
            // 
            // btnNew
            // 
            this.btnNew.BackColor = System.Drawing.SystemColors.Control;
            this.btnNew.Font = new System.Drawing.Font("Arial", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnNew.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.btnNew.Location = new System.Drawing.Point(465, 409);
            this.btnNew.Name = "btnNew";
            this.btnNew.Size = new System.Drawing.Size(182, 34);
            this.btnNew.TabIndex = 14;
            this.btnNew.Text = "Create &New Project";
            this.btnNew.UseVisualStyleBackColor = false;
            this.btnNew.Click += new System.EventHandler(this.btnNew_Click);
            // 
            // btnSearch
            // 
            this.btnSearch.BackColor = System.Drawing.SystemColors.Control;
            this.btnSearch.Font = new System.Drawing.Font("Arial", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnSearch.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.btnSearch.Location = new System.Drawing.Point(709, 409);
            this.btnSearch.Name = "btnSearch";
            this.btnSearch.Size = new System.Drawing.Size(182, 34);
            this.btnSearch.TabIndex = 0;
            this.btnSearch.Text = "&Search Projects";
            this.btnSearch.UseVisualStyleBackColor = false;
            this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
            // 
            // pictureBox1
            // 
            this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
            this.pictureBox1.Location = new System.Drawing.Point(1, 1);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(247, 471);
            this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
            this.pictureBox1.TabIndex = 17;
            this.pictureBox1.TabStop = false;
            // 
            // pictureBox3
            // 
            this.pictureBox3.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox3.Image")));
            this.pictureBox3.Location = new System.Drawing.Point(275, 12);
            this.pictureBox3.Name = "pictureBox3";
            this.pictureBox3.Size = new System.Drawing.Size(120, 88);
            this.pictureBox3.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
            this.pictureBox3.TabIndex = 18;
            this.pictureBox3.TabStop = false;
            // 
            // rdSelectedProject
            // 
            this.rdSelectedProject.Checked = true;
            this.rdSelectedProject.Location = new System.Drawing.Point(411, 178);
            this.rdSelectedProject.Name = "rdSelectedProject";
            this.rdSelectedProject.Size = new System.Drawing.Size(16, 16);
            this.rdSelectedProject.TabIndex = 1;
            this.rdSelectedProject.TabStop = true;
            this.rdSelectedProject.CheckedChanged += new System.EventHandler(this.rdSelectedProject_CheckedChanged);
            // 
            // rdSelectedFile
            // 
            this.rdSelectedFile.Location = new System.Drawing.Point(411, 209);
            this.rdSelectedFile.Name = "rdSelectedFile";
            this.rdSelectedFile.Size = new System.Drawing.Size(16, 16);
            this.rdSelectedFile.TabIndex = 3;
            this.rdSelectedFile.TabStop = true;
            this.rdSelectedFile.CheckedChanged += new System.EventHandler(this.rdSelectedFile_CheckedChanged);
            // 
            // btnRefresh
            // 
            this.btnRefresh.BackColor = System.Drawing.SystemColors.Control;
            this.btnRefresh.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnRefresh.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.btnRefresh.Location = new System.Drawing.Point(821, 304);
            this.btnRefresh.Name = "btnRefresh";
            this.btnRefresh.Size = new System.Drawing.Size(159, 24);
            this.btnRefresh.TabIndex = 13;
            this.btnRefresh.Text = "C&lear Project Selections";
            this.btnRefresh.UseVisualStyleBackColor = false;
            this.btnRefresh.Click += new System.EventHandler(this.btnRefresh_Click);
            // 
            // cbProjectNameAutoComplete
            // 
            this.cbProjectNameAutoComplete.AlwaysInEditMode = true;
            this.cbProjectNameAutoComplete.CheckedListSettings.CheckStateMember = "";
            this.cbProjectNameAutoComplete.ImeMode = System.Windows.Forms.ImeMode.Off;
            this.cbProjectNameAutoComplete.Location = new System.Drawing.Point(435, 174);
            this.cbProjectNameAutoComplete.MaxLength = 60;
            this.cbProjectNameAutoComplete.Name = "cbProjectNameAutoComplete";
            this.cbProjectNameAutoComplete.Size = new System.Drawing.Size(547, 22);
            this.cbProjectNameAutoComplete.TabIndex = 2;
            this.cbProjectNameAutoComplete.KeyDown += new System.Windows.Forms.KeyEventHandler(this.cbProjectNameAutoComplete_KeyDown);
            this.cbProjectNameAutoComplete.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(this.cbProjectNameAutoComplete_InitializeLayout);
            // 
            // cbFileNumberAutoComplete
            // 
            this.cbFileNumberAutoComplete.CheckedListSettings.CheckStateMember = "";
            this.cbFileNumberAutoComplete.Location = new System.Drawing.Point(435, 205);
            this.cbFileNumberAutoComplete.Name = "cbFileNumberAutoComplete";
            this.cbFileNumberAutoComplete.Size = new System.Drawing.Size(547, 22);
            this.cbFileNumberAutoComplete.TabIndex = 4;
            this.cbFileNumberAutoComplete.KeyDown += new System.Windows.Forms.KeyEventHandler(this.cbFileNumberAutoComplete_KeyDown);
            this.cbFileNumberAutoComplete.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(this.cbFileNumberAutoComplete_InitializeLayout);
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(278, 112);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(91, 14);
            this.label4.TabIndex = 24;
            this.label4.Text = "Version 3.7.0";
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(278, 126);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(149, 14);
            this.label5.TabIndex = 25;
            this.label5.Text = "    November 05, 2014";
            // 
            // btnCopyProject
            // 
            this.btnCopyProject.BackColor = System.Drawing.SystemColors.Control;
            this.btnCopyProject.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnCopyProject.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.btnCopyProject.Location = new System.Drawing.Point(628, 304);
            this.btnCopyProject.Name = "btnCopyProject";
            this.btnCopyProject.Size = new System.Drawing.Size(144, 24);
            this.btnCopyProject.TabIndex = 12;
            this.btnCopyProject.Text = "&Copy Selected Project";
            this.btnCopyProject.UseVisualStyleBackColor = false;
            this.btnCopyProject.Click += new System.EventHandler(this.btnCopyProject_Click);
            // 
            // OpenProject
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.SystemColors.Control;
            this.ClientSize = new System.Drawing.Size(1006, 564);
            this.Controls.Add(this.btnCopyProject);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.cbFileNumberAutoComplete);
            this.Controls.Add(this.cbProjectNameAutoComplete);
            this.Controls.Add(this.btnRefresh);
            this.Controls.Add(this.rdSelectedFile);
            this.Controls.Add(this.rdSelectedProject);
            this.Controls.Add(this.pictureBox3);
            this.Controls.Add(this.pictureBox1);
            this.Controls.Add(this.btnSearch);
            this.Controls.Add(this.btnNew);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.btnOpenByName);
            this.Controls.Add(this.label1);
            this.KeyPreview = true;
            this.Name = "OpenProject";
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
            this.Text = "Open Project";
            this.Load += new System.EventHandler(this.OpenProject_Load);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.OpenProject_Closing);
            this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.OpenProject_KeyDown);
            this.groupBox1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox3)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.cbProjectNameAutoComplete)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.cbFileNumberAutoComplete)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void btnOpenByName_Click(object sender, System.EventArgs e)
		{
            OpenTheProject();
		}

        private void cbProjectNameAutoComplete_KeyDown(object sender, KeyEventArgs e)
        {
            //if (this.cbProjectNameAutoComplete.Textbox.SelectionLength == 0 ) {
            //    this.cbProjectNameAutoComplete.Select();
            //}
            //if (e.KeyCode == Keys.Enter)
            //{
            //    OpenTheProject();
            //}
        }

        private void cbFileNumberAutoComplete_KeyDown(object sender, KeyEventArgs e)
        {
            //if (this.cbProjectNameAutoComplete.Textbox.SelectionLength == 0)
            //{
            //    this.cbFileNumberAutoComplete.Select();
            //}
            //if (e.KeyCode == Keys.Enter)
            //{
            //    OpenTheProject();
            //}
        }

        private void OpenTheProject()
        {
            int projKey;
            if (this.rdSelectedProject.Checked)
            {
                if (this.cbProjectNameAutoComplete.Value == null)
                    projKey = 0;
                else
                    projKey = (int)this.cbProjectNameAutoComplete.Value;

                if (projKey > 0)
                {
                    SetProjectId((int)this.cbProjectNameAutoComplete.Value);
                    this.OpenProjectForm(this.ProjectId);
                }
            }

            if (this.rdSelectedFile.Checked)
            {
                if (this.cbFileNumberAutoComplete.Value == null)
                    projKey = 0;
                else
                    projKey = (int)this.cbFileNumberAutoComplete.Value;

                if (projKey > 0)
                {
                    SetProjectId((int)cbFileNumberAutoComplete.Value);
                    this.OpenProjectForm(this.ProjectId);
                }
            }
        }

		private void rbStatusFilter_SelectionChanged(object sender, EventArgs e)
		{
			//this.PopulateOpenMenu();
			RefreshLists();
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btnNew_Click(object sender, System.EventArgs e)
		{
			CCPM.Project.ProjectCreateOrUpdate newProject = new CCPM.Project.ProjectCreateOrUpdate();
			//newProject.Width = 730;
			//newProject.Height = 555;
			DialogResult dr = newProject.ShowDialog(this);
			if(dr == DialogResult.OK)
			{
				this.OpenProjectForm(newProject.ProjectId);
			}
		}

		private void btnSearch_Click(object sender, System.EventArgs e)
		{
			if( GlobalSettings.projectSearchHandle == null)
			{
				Project.ProjectSearch ps = new Project.ProjectSearch();
				GlobalSettings.projectSearchHandle = ps;
                Form1 fm = (Form1)this.MdiParent;
                fm.OpenForm(ps, "Project Search");
			}
			else
			{
				GlobalSettings.projectSearchHandle.Focus();
			}

		}
        public void CopyProjectForm(int projectId)
        {
            OpenProjectForm(projectId);
        }

		public void OpenProjectForm(int projectId)
		{
			// NOTE: This method is also in MainForm
			//If project is already open then give it focus
            if (!CCPM.Data.ProjectData.ProjectIsValid(projectId))
            {
                MessageBox.Show("Error loading project", "Invalid Project", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
			
            Form1 fm = (Form1)(this.MdiParent);
            fm.OpenProject(projectId, CCPM.Data.ProjectData.GetProjectName(projectId));
		}
		private void OpenProject_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			GlobalSettings.openProjectHandle = null;
		}

		private void rdSelectedProject_CheckedChanged(object sender, System.EventArgs e)
		{
			this.EnableLists();
		}

		private void EnableLists()
		{
			if (rdSelectedProject.Checked)
			{
				this.cbProjectNameAutoComplete.Enabled = true;
				this.cbFileNumberAutoComplete.Enabled = false;
				this.rdSelectedFile.Checked = false;
                this.cbProjectNameAutoComplete.Select();
			}
			else
			{
                this.cbProjectNameAutoComplete.Enabled = false;
				this.cbFileNumberAutoComplete.Enabled = true;
				this.rdSelectedProject.Checked = false;
                this.cbFileNumberAutoComplete.Select();
			}
		}

		private void rdSelectedFile_CheckedChanged(object sender, System.EventArgs e)
		{
			this.EnableLists();		
		}

		private void btnRefresh_Click(object sender, System.EventArgs e)
		{
			RefreshLists();
		}

        private void OpenProject_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                OpenTheProject();
            }
        }

        private void OpenProject_Load(object sender, EventArgs e)
        {

        }

        private void btnCopyProject_Click(object sender, EventArgs e)
        {
            int projKey=0;
            if (this.rdSelectedProject.Checked)
            {
                if (this.cbProjectNameAutoComplete.Value == null)
                    projKey = 0;
                else
                    projKey = (int)this.cbProjectNameAutoComplete.Value;
            }

            if (this.rdSelectedFile.Checked)
            {
                if (this.cbFileNumberAutoComplete.Value == null)
                    projKey = 0;
                else
                    projKey = (int)this.cbFileNumberAutoComplete.Value;
            }

            if (projKey > 0)
            {
                //copy from this.ProjectId 
                CCPM.Project.ProjectCreateOrUpdate copyProject = new CCPM.Project.ProjectCreateOrUpdate();
                copyProject.IsCopyMode = true;
                copyProject.ProjectCopiedId = projKey;

                DialogResult dr = copyProject.ShowDialog(this);
                if (dr == DialogResult.OK)
                {
                    this.CopyProjectForm(copyProject.ProjectId);
                }
            }
        }
	}
}
