using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace CCPM.Project
{
	/// <summary>
	
	/// </summary>
	public class OpenProjectRelated : System.Windows.Forms.Form
    {
		private System.Windows.Forms.ComboBox cbProjectName;
        private System.Windows.Forms.ComboBox cbFileNumber;
        protected System.Windows.Forms.Button btnOpenByName;
		private int projectId;
        private int type;
        private string notes;
		protected System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton rbActive;
		private System.Windows.Forms.RadioButton rbInactive;
		private System.Windows.Forms.RadioButton rbComplete;
		private System.Windows.Forms.RadioButton rbAll;
		private System.Windows.Forms.Button btnCancel;
		private int fileNameSelectedIndex = 0;
		private int fileNumberSelectedIndex = 0;
        private Label label3;
        private ComboBox cmbRelType;
        private GroupBox groupBox2;
        private TextBox txtNotes;
        private Label label5;
        private RadioButton rdoFileNumber;
        private RadioButton rdoProjectName;
        private RadioButton rbClosed;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		public int ProjectId
		{
			get{return projectId;}
			set{projectId = value;}
		}

        public int Type
        {
            get{return type;}
            set { type = value; }
        }

        public string Notes
        {
            get { return notes;}
            set { notes = value; }
        }

		public OpenProjectRelated()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            if (rdoProjectName.Checked == true)
            {
                cbProjectName.Enabled = true;
            }
            else if (rdoFileNumber.Checked == true)
            {
                cbFileNumber.Enabled = true;
            }
			PopulateOpenMenu();
		}

		public int GetStatusFilter()
		{
			int statusFilter = 0;
            if (rbInactive.Checked) statusFilter = 1;
            else if (rbComplete.Checked) statusFilter = 2;
            else if (rbAll.Checked) statusFilter = 4;
            else if (rbClosed.Checked) statusFilter = 3;

			return statusFilter;
		}
		public void PopulateOpenMenu()
		{
            
                System.Data.DataSet ds = CCPM.Data.ProjectData.GetProjectList(GetStatusFilter());
                //Handle empty DataTable condition

                //add a row to provide a blank first item in the dropdown.    
            
                if (ds.Tables[0].Rows.Count < 1)//Project Name
                {
                    DataRow dr = ds.Tables[0].NewRow();
                    dr["ProjectName"] = "N/A";
                    dr["ProjectId"] = 0;
                    ds.Tables[0].Rows.Add(dr);
                }
                if (ds.Tables[1].Rows.Count < 1)//Project Number
                {
                    DataRow dr = ds.Tables[1].NewRow();
                    dr["FileNumber"] = "N/A";
                    dr["ProjectId"] = 0;
                    ds.Tables[1].Rows.Add(dr);
                }


                cbProjectName.DataSource = null;
                cbProjectName.Items.Clear();
                cbProjectName.DataSource = ds.Tables[0];
                cbProjectName.DisplayMember = "ProjectName";
                cbProjectName.ValueMember = "ProjectId";


                cbFileNumber.DataSource = null;
                cbFileNumber.Items.Clear();
                cbFileNumber.DataSource = ds.Tables[1];
                cbFileNumber.DisplayMember = "FileNumber";
                cbFileNumber.ValueMember = "ProjectId";
           
            // Populate Relation Type Combo box
            // Added 07/16/08 -- Gatika

            System.Data.DataSet ds1 = CCPM.Data.RelatedProjectData.GetRelTypeSelectionList();
            cmbRelType.DataSource = null;
            cmbRelType.Items.Clear();
            cmbRelType.DataSource = ds1.Tables[0];
            cmbRelType.DisplayMember = "RelType";
            cmbRelType.ValueMember = "RelTypeId";
        }

		public virtual void SetProjectId(int projectId, int type, string notes)
		{
			this.ProjectId = projectId;
            this.Type = type;
            this.Notes = notes;
			if(ProjectId != 0)
			{
				this.DialogResult = DialogResult.OK;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.cbProjectName = new System.Windows.Forms.ComboBox();
            this.btnOpenByName = new System.Windows.Forms.Button();
            this.cbFileNumber = new System.Windows.Forms.ComboBox();
            this.rbActive = new System.Windows.Forms.RadioButton();
            this.rbInactive = new System.Windows.Forms.RadioButton();
            this.rbComplete = new System.Windows.Forms.RadioButton();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.rbAll = new System.Windows.Forms.RadioButton();
            this.btnCancel = new System.Windows.Forms.Button();
            this.label3 = new System.Windows.Forms.Label();
            this.cmbRelType = new System.Windows.Forms.ComboBox();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.rdoFileNumber = new System.Windows.Forms.RadioButton();
            this.rdoProjectName = new System.Windows.Forms.RadioButton();
            this.txtNotes = new System.Windows.Forms.TextBox();
            this.label5 = new System.Windows.Forms.Label();
            this.rbClosed = new System.Windows.Forms.RadioButton();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.SuspendLayout();
            // 
            // cbProjectName
            // 
            this.cbProjectName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.cbProjectName.Location = new System.Drawing.Point(15, 97);
            this.cbProjectName.MaxDropDownItems = 20;
            this.cbProjectName.Name = "cbProjectName";
            this.cbProjectName.Size = new System.Drawing.Size(418, 21);
            this.cbProjectName.TabIndex = 1;
            this.cbProjectName.SelectionChangeCommitted += new System.EventHandler(this.cbProjectName_SelectionChangeCommitted);
            this.cbProjectName.SelectedIndexChanged += new System.EventHandler(this.cbProjectName_SelectedIndexChanged);
            this.cbProjectName.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.cbProjectName_KeyPress);
            // 
            // btnOpenByName
            // 
            this.btnOpenByName.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btnOpenByName.Location = new System.Drawing.Point(65, 261);
            this.btnOpenByName.Name = "btnOpenByName";
            this.btnOpenByName.Size = new System.Drawing.Size(177, 23);
            this.btnOpenByName.TabIndex = 2;
            this.btnOpenByName.Text = "Select Existing Project to Relate";
            this.btnOpenByName.Click += new System.EventHandler(this.btnOpenByName_Click);
            // 
            // cbFileNumber
            // 
            this.cbFileNumber.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.cbFileNumber.Enabled = false;
            this.cbFileNumber.Location = new System.Drawing.Point(9, 128);
            this.cbFileNumber.MaxDropDownItems = 20;
            this.cbFileNumber.Name = "cbFileNumber";
            this.cbFileNumber.Size = new System.Drawing.Size(418, 21);
            this.cbFileNumber.TabIndex = 4;
            this.cbFileNumber.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.cbFileNumber_KeyPress);
            // 
            // rbActive
            // 
            this.rbActive.Location = new System.Drawing.Point(16, 23);
            this.rbActive.Name = "rbActive";
            this.rbActive.Size = new System.Drawing.Size(56, 16);
            this.rbActive.TabIndex = 7;
            this.rbActive.Text = "Active";
            this.rbActive.CheckedChanged += new System.EventHandler(this.rbStatusFilter_SelectionChanged);
            // 
            // rbInactive
            // 
            this.rbInactive.Location = new System.Drawing.Point(95, 19);
            this.rbInactive.Name = "rbInactive";
            this.rbInactive.Size = new System.Drawing.Size(73, 24);
            this.rbInactive.TabIndex = 8;
            this.rbInactive.Text = "InActive";
            this.rbInactive.CheckedChanged += new System.EventHandler(this.rbStatusFilter_SelectionChanged);
            // 
            // rbComplete
            // 
            this.rbComplete.Location = new System.Drawing.Point(178, 19);
            this.rbComplete.Name = "rbComplete";
            this.rbComplete.Size = new System.Drawing.Size(71, 24);
            this.rbComplete.TabIndex = 9;
            this.rbComplete.Text = "Complete";
            this.rbComplete.CheckedChanged += new System.EventHandler(this.rbStatusFilter_SelectionChanged);
            // 
            // groupBox1
            // 
            this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.groupBox1.Controls.Add(this.rbClosed);
            this.groupBox1.Controls.Add(this.rbAll);
            this.groupBox1.Controls.Add(this.rbActive);
            this.groupBox1.Controls.Add(this.rbInactive);
            this.groupBox1.Controls.Add(this.rbComplete);
            this.groupBox1.Location = new System.Drawing.Point(16, 31);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(418, 46);
            this.groupBox1.TabIndex = 10;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Filter By Project Status";
            // 
            // rbAll
            // 
            this.rbAll.Checked = true;
            this.rbAll.Location = new System.Drawing.Point(345, 19);
            this.rbAll.Name = "rbAll";
            this.rbAll.Size = new System.Drawing.Size(42, 24);
            this.rbAll.TabIndex = 10;
            this.rbAll.TabStop = true;
            this.rbAll.Text = "All";
            this.rbAll.CheckedChanged += new System.EventHandler(this.rbStatusFilter_SelectionChanged);
            // 
            // btnCancel
            // 
            this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btnCancel.Location = new System.Drawing.Point(268, 261);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(75, 23);
            this.btnCancel.TabIndex = 11;
            this.btnCancel.Text = "Cancel";
            this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(11, 157);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(160, 23);
            this.label3.TabIndex = 12;
            this.label3.Text = "Relationship Type";
            // 
            // cmbRelType
            // 
            this.cmbRelType.FormattingEnabled = true;
            this.cmbRelType.Items.AddRange(new object[] {
            "Same Project/Different Phase",
            "Similar Project/Same Location",
            "Similar Project/Different Location",
            "Programmatically Related",
            "Historically Related",
            "Other"});
            this.cmbRelType.Location = new System.Drawing.Point(11, 175);
            this.cmbRelType.Name = "cmbRelType";
            this.cmbRelType.Size = new System.Drawing.Size(200, 21);
            this.cmbRelType.TabIndex = 13;
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.rdoFileNumber);
            this.groupBox2.Controls.Add(this.rdoProjectName);
            this.groupBox2.Controls.Add(this.cmbRelType);
            this.groupBox2.Controls.Add(this.label3);
            this.groupBox2.Controls.Add(this.txtNotes);
            this.groupBox2.Controls.Add(this.btnCancel);
            this.groupBox2.Controls.Add(this.btnOpenByName);
            this.groupBox2.Controls.Add(this.label5);
            this.groupBox2.Controls.Add(this.cbFileNumber);
            this.groupBox2.Location = new System.Drawing.Point(3, 12);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(442, 304);
            this.groupBox2.TabIndex = 16;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Select an Existing Project to Relate";
            // 
            // rdoFileNumber
            // 
            this.rdoFileNumber.AutoSize = true;
            this.rdoFileNumber.Location = new System.Drawing.Point(13, 109);
            this.rdoFileNumber.Name = "rdoFileNumber";
            this.rdoFileNumber.Size = new System.Drawing.Size(98, 17);
            this.rdoFileNumber.TabIndex = 20;
            this.rdoFileNumber.Text = "Project Number";
            this.rdoFileNumber.UseVisualStyleBackColor = true;
            this.rdoFileNumber.Click += new System.EventHandler(this.rdoFileNumber_Click);
            // 
            // rdoProjectName
            // 
            this.rdoProjectName.AutoSize = true;
            this.rdoProjectName.Checked = true;
            this.rdoProjectName.Location = new System.Drawing.Point(12, 67);
            this.rdoProjectName.Name = "rdoProjectName";
            this.rdoProjectName.Size = new System.Drawing.Size(89, 17);
            this.rdoProjectName.TabIndex = 19;
            this.rdoProjectName.TabStop = true;
            this.rdoProjectName.Text = "Project Name";
            this.rdoProjectName.UseVisualStyleBackColor = true;
            this.rdoProjectName.Click += new System.EventHandler(this.rdoProjectName_Click);
            // 
            // txtNotes
            // 
            this.txtNotes.Location = new System.Drawing.Point(13, 223);
            this.txtNotes.Name = "txtNotes";
            this.txtNotes.Size = new System.Drawing.Size(168, 20);
            this.txtNotes.TabIndex = 18;
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(11, 203);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(59, 23);
            this.label5.TabIndex = 17;
            this.label5.Text = "Notes";
            // 
            // rbClosed
            // 
            this.rbClosed.Location = new System.Drawing.Point(268, 19);
            this.rbClosed.Name = "rbClosed";
            this.rbClosed.Size = new System.Drawing.Size(71, 24);
            this.rbClosed.TabIndex = 12;
            this.rbClosed.TabStop = true;
            this.rbClosed.Text = "Closed";
            this.rbClosed.CheckedChanged += new System.EventHandler(this.rbStatusFilter_SelectionChanged);
            // 
            // OpenProjectRelated
            // 
            this.AcceptButton = this.btnOpenByName;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(450, 362);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.cbProjectName);
            this.Controls.Add(this.groupBox2);
            this.Name = "OpenProjectRelated";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Add Related Project";
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

		private void btnOpenByName_Click(object sender, System.EventArgs e)
		{
            if (rdoProjectName.Checked)
            {
                if (cbProjectName.SelectedIndex < 1)
                {
                    cbProjectName.SelectedIndex = fileNameSelectedIndex;
                }
                try
                {
                    SetProjectId((int)this.cbProjectName.SelectedValue, Convert.ToInt32(this.cmbRelType.SelectedValue), this.txtNotes.Text.ToString());
                }
                catch (Exception ex)
                {
                    MessageBox.Show("You must first choose a project");
                }
            }
            else
            {
                if (cbFileNumber.SelectedIndex < 1)
                {
                    cbFileNumber.SelectedIndex = fileNumberSelectedIndex;
                }
                try
                {
                    SetProjectId((int)cbFileNumber.SelectedValue, Convert.ToInt32(this.cmbRelType.SelectedValue), this.txtNotes.Text.ToString());
                }
                catch (Exception ex)
                {
                    MessageBox.Show("You must first choose a project");
                }
            }
		    
		}


		private void rbStatusFilter_SelectionChanged(object sender, EventArgs e)
		{
			this.PopulateOpenMenu();
		}

		private void cbProjectName_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			//Autocomplete behavior ala IE address bar
			this.cbProjectName.DroppedDown = true;
			if(char.IsControl(e.KeyChar)) return;
			string toFind = this.cbProjectName.Text.Substring(0, cbProjectName.SelectionStart) + e.KeyChar;
			int index = cbProjectName.FindStringExact(toFind);
			if(index == -1) index = cbProjectName.FindString(toFind);
			if(index == -1) 
			{
				e.Handled = true;
				return;
			}
			this.fileNameSelectedIndex = index;
			cbProjectName.SelectedIndex = index;
			System.Diagnostics.Debug.WriteLine("Index: " + cbProjectName.SelectedIndex.ToString());
			cbProjectName.SelectionStart = toFind.Length;
			cbProjectName.SelectionLength = cbProjectName.Text.Length - cbProjectName.SelectionStart;
			e.Handled = true;
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void cbFileNumber_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			//Autocomplete behavior ala IE address bar
			this.cbFileNumber.DroppedDown = true;
			if(char.IsControl(e.KeyChar)) return;
			string toFind = this.cbFileNumber.Text.Substring(0, cbFileNumber.SelectionStart) + e.KeyChar;
			int index = cbFileNumber.FindStringExact(toFind);
			if(index == -1) index = cbFileNumber.FindString(toFind);
			if(index == -1) 
			{
				e.Handled = true;
				return;
			}
			this.fileNumberSelectedIndex = index;
			cbFileNumber.SelectedIndex = index;
			cbFileNumber.SelectionStart = toFind.Length;
			cbFileNumber.SelectionLength = cbFileNumber.Text.Length - cbFileNumber.SelectionStart;
			e.Handled = true;
		}

		private void cbProjectName_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			System.Diagnostics.Debug.WriteLine("Selected Index Changed: " + cbProjectName.SelectedIndex.ToString());
		}

		private void cbProjectName_SelectionChangeCommitted(object sender, System.EventArgs e)
		{
			System.Diagnostics.Debug.WriteLine("Selected Index Committed: " + cbProjectName.SelectedIndex.ToString());
		}

        private void rdoProjectName_Click(object sender, EventArgs e)
        {
            if (rdoProjectName.Checked == false)
            {
                cbProjectName.Enabled = false;
                cbFileNumber.Enabled = true;
            }
            else
            {
                cbProjectName.Enabled = true;
                cbFileNumber.Enabled = false;
            }
        }

        private void rdoFileNumber_Click(object sender, EventArgs e)
        {
            if (rdoFileNumber.Checked == false)
            {
                cbFileNumber.Enabled = false;
                cbProjectName.Enabled = true;
            }
            else
            {
                cbFileNumber.Enabled = true;
                cbProjectName.Enabled = false;
            }
        }

		
	}
}
