﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using CCPM.Data;
using Microsoft.ApplicationBlocks.Data;

namespace CCPM.Project
{
    public partial class OrganizationPicker : Form
    {
        public Authorizations MyParentForm;
        private decimal _amount = 0;

        public string Organization
        {
            get { return cmbOrganization.Text; }
        }
        public int OrgID
        {
            get { return Convert.ToInt32(cmbOrganization.Value); }
        }
        public decimal Amount
        {
            get { return GlobalCode.ToDecimal(txtAmount.Text); }
            set { _amount = value; txtAmount.Text = value.ToString(GlobalSettings.MoneyFormat); }
        }
        public OrganizationPicker()
        {
            InitializeComponent();
            DataSet ds = ProjectFundingData.GetOrgList();
            cmbOrganization.DataSource = null;
            cmbOrganization.DataSource = ds.Tables[0];
            cmbOrganization.DisplayMember = "Organization";
            cmbOrganization.ValueMember = "OrgID";

        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if (txtAmount.Text == "")
            {
                MessageBox.Show("Please enter Amount to be Reimb !!", "Data Entry Error", MessageBoxButtons.OK);
                txtAmount.Focus();
            }
            else
            {
                if (GlobalCode.ToDecimal(txtAmount.Text) > _amount)
                {
                    MessageBox.Show("Amount can't exceed " + _amount.ToString());
                    txtAmount.Focus();
                }
                else
                {
                    DialogResult = DialogResult.OK;
                    this.Close();
                }
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Project.Organizations frmOrgs = new Project.Organizations(true);

            DialogResult intDiagResult = MessageBox.Show("This will add a new organization to the Master Organization List-have you confirmed that it\ndoes not already exist ?", "Confirm",
                MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);
            
            if (intDiagResult == DialogResult.Yes)
            {
                CCPM.Contact.NewOrganization no = new CCPM.Contact.NewOrganization(0, "insert","admin");
                no.ShowDialog();
            }
            else if (intDiagResult == DialogResult.No)
            {
                CCPM.Contact.LinkOrg lo = new CCPM.Contact.LinkOrg(0);
                lo.ShowDialog();
            }

            DataSet ds = ProjectFundingData.GetOrgList();
            cmbOrganization.DataSource = ds.Tables[0];
            cmbOrganization.DisplayMember = "Organization";
            cmbOrganization.ValueMember = "OrgID";

        }

        private void cmbOrganization_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {

            // OrgID
            e.Layout.Bands[0].Columns[0].Hidden = true;

            // Organization
            e.Layout.Bands[0].Columns[1].Width = 180;
            e.Layout.Bands[0].Columns[1].Header.Caption = "Organziation";

            //Organization Type
            e.Layout.Bands[0].Columns[2].Width = 140;
            e.Layout.Bands[0].Columns[2].Header.Caption = "Organzation Type";

            
            //filter row
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.FilterClearButtonLocation = FilterClearButtonLocation.Row;
            e.Layout.Override.FilterUIType = Infragistics.Win.UltraWinGrid.FilterUIType.FilterRow;
            e.Layout.Override.FilterOperatorDefaultValue = FilterOperatorDefaultValue.Contains;

            //column sorting
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;

        }


    }
}
