using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using CCPM.Data;
using System.Data;

namespace CCPM.Project
{
	/// <summary>
	/// ProjectSearch contains SearchCriteria objects which expose sql conditions
	/// that are assembled in this class into a project search query. 
    /// uses control:  CCPM.Project.SearchCriteria
	/// </summary>
	public class ProjectSearch : System.Windows.Forms.Form
	{
		private CCPM.Project.SearchCriteria searchCriteria1;
		private CCPM.Project.SearchCriteria searchCriteria2;
		private System.Windows.Forms.Button btnSearch;
		private System.Windows.Forms.DataGrid dgProjects;
		private System.Windows.Forms.DataGridTableStyle dgProjectsTableStyle;
		private System.Windows.Forms.DataGridTextBoxColumn ProjectName;
		private System.Windows.Forms.DataGridTextBoxColumn FileNumber;
		private System.Windows.Forms.DataGridTextBoxColumn Description;
		private System.Windows.Forms.Button btnOpen;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
        private SearchCriteria searchCriteria4;
        private SearchCriteria searchCriteria3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ProjectSearch()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			searchCriteria1.LineNumber = "1.";
			searchCriteria1.ShowLineOperator = false;
			searchCriteria2.LineNumber = "2.";
            searchCriteria2.ShowLineOperator = true;
            searchCriteria3.LineNumber = "3.";
            searchCriteria3.ShowLineOperator = true;
            searchCriteria4.LineNumber = "4.";
            searchCriteria3.ShowLineOperator = true;
		}

		private void BindGrid(DataSet ds)
		{
			dgProjects.DataSource = ds;
			dgProjects.DataMember = "Table";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private ArrayList GetSelectedProject()
		{
			ArrayList al = new ArrayList();
            if (dgProjects.VisibleRowCount == 0)
                return al;

			CurrencyManager manager = (CurrencyManager)dgProjects.BindingContext[dgProjects.DataSource, "Table"];
			
			DataView dv = (DataView)manager.List;
			for(int i = 0; i < dv.Count; i++)
			{
				if(dgProjects.IsSelected(i))
				{
					al.Add(dv[i]["ProjectId"].ToString());
				}
			}
			//If selections were made then return only those items.
			if(al.Count > 0) return al;
			//If no selections were made then return all.
			for(int i = 0; i < dv.Count; i++)
			{
				al.Add(dv[i]["ProjectId"].ToString());
			}

			return al;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.btnSearch = new System.Windows.Forms.Button();
            this.dgProjects = new System.Windows.Forms.DataGrid();
            this.dgProjectsTableStyle = new System.Windows.Forms.DataGridTableStyle();
            this.ProjectName = new System.Windows.Forms.DataGridTextBoxColumn();
            this.FileNumber = new System.Windows.Forms.DataGridTextBoxColumn();
            this.Description = new System.Windows.Forms.DataGridTextBoxColumn();
            this.btnOpen = new System.Windows.Forms.Button();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.searchCriteria4 = new CCPM.Project.SearchCriteria();
            this.searchCriteria3 = new CCPM.Project.SearchCriteria();
            this.searchCriteria1 = new CCPM.Project.SearchCriteria();
            this.searchCriteria2 = new CCPM.Project.SearchCriteria();
            ((System.ComponentModel.ISupportInitialize)(this.dgProjects)).BeginInit();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.SuspendLayout();
            // 
            // btnSearch
            // 
            this.btnSearch.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.btnSearch.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btnSearch.Location = new System.Drawing.Point(612, 16);
            this.btnSearch.Name = "btnSearch";
            this.btnSearch.Size = new System.Drawing.Size(75, 23);
            this.btnSearch.TabIndex = 4;
            this.btnSearch.Text = "Search";
            this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
            // 
            // dgProjects
            // 
            this.dgProjects.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.dgProjects.CaptionText = "Click left border to select. Ctrl-Click to select multiple. Shift-Click to select" +
                " contiguous. No selection opens all.";
            this.dgProjects.DataMember = "";
            this.dgProjects.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.dgProjects.Location = new System.Drawing.Point(6, 19);
            this.dgProjects.Name = "dgProjects";
            this.dgProjects.Size = new System.Drawing.Size(588, 281);
            this.dgProjects.TabIndex = 3;
            this.dgProjects.TableStyles.AddRange(new System.Windows.Forms.DataGridTableStyle[] {
            this.dgProjectsTableStyle});
            this.dgProjects.DoubleClick += new System.EventHandler(this.dgProjects_DoubleClick);
            // 
            // dgProjectsTableStyle
            // 
            this.dgProjectsTableStyle.DataGrid = this.dgProjects;
            this.dgProjectsTableStyle.GridColumnStyles.AddRange(new System.Windows.Forms.DataGridColumnStyle[] {
            this.ProjectName,
            this.FileNumber,
            this.Description});
            this.dgProjectsTableStyle.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.dgProjectsTableStyle.MappingName = "Table";
            this.dgProjectsTableStyle.ReadOnly = true;
            // 
            // ProjectName
            // 
            this.ProjectName.Format = "";
            this.ProjectName.FormatInfo = null;
            this.ProjectName.HeaderText = "Project Name";
            this.ProjectName.MappingName = "ProjectName";
            this.ProjectName.Width = 200;
            // 
            // FileNumber
            // 
            this.FileNumber.Format = "";
            this.FileNumber.FormatInfo = null;
            this.FileNumber.HeaderText = "Project Number";
            this.FileNumber.MappingName = "FileNumber";
            this.FileNumber.Width = 75;
            // 
            // Description
            // 
            this.Description.Format = "";
            this.Description.FormatInfo = null;
            this.Description.HeaderText = "Summary";
            this.Description.MappingName = "Summary";
            this.Description.Width = 365;
            // 
            // btnOpen
            // 
            this.btnOpen.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.btnOpen.CausesValidation = false;
            this.btnOpen.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btnOpen.Location = new System.Drawing.Point(612, 56);
            this.btnOpen.Name = "btnOpen";
            this.btnOpen.Size = new System.Drawing.Size(49, 23);
            this.btnOpen.TabIndex = 5;
            this.btnOpen.Text = "Open";
            this.btnOpen.Click += new System.EventHandler(this.btnOpen_Click);
            // 
            // groupBox1
            // 
            this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.groupBox1.Controls.Add(this.btnOpen);
            this.groupBox1.Controls.Add(this.dgProjects);
            this.groupBox1.Controls.Add(this.btnSearch);
            this.groupBox1.Location = new System.Drawing.Point(10, 156);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(698, 306);
            this.groupBox1.TabIndex = 5;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Search Results";
            // 
            // groupBox2
            // 
            this.groupBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.groupBox2.Controls.Add(this.searchCriteria4);
            this.groupBox2.Controls.Add(this.searchCriteria3);
            this.groupBox2.Controls.Add(this.searchCriteria1);
            this.groupBox2.Controls.Add(this.searchCriteria2);
            this.groupBox2.Location = new System.Drawing.Point(8, 8);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(698, 142);
            this.groupBox2.TabIndex = 6;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Search Criteria";
            // 
            // searchCriteria4
            // 
            this.searchCriteria4.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.searchCriteria4.LineNumber = "4";
            this.searchCriteria4.Location = new System.Drawing.Point(2, 106);
            this.searchCriteria4.Name = "searchCriteria4";
            this.searchCriteria4.Size = new System.Drawing.Size(688, 24);
            this.searchCriteria4.TabIndex = 3;
            // 
            // searchCriteria3
            // 
            this.searchCriteria3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.searchCriteria3.LineNumber = "3";
            this.searchCriteria3.Location = new System.Drawing.Point(2, 76);
            this.searchCriteria3.Name = "searchCriteria3";
            this.searchCriteria3.Size = new System.Drawing.Size(688, 24);
            this.searchCriteria3.TabIndex = 2;
            // 
            // searchCriteria1
            // 
            this.searchCriteria1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.searchCriteria1.LineNumber = "1";
            this.searchCriteria1.Location = new System.Drawing.Point(2, 16);
            this.searchCriteria1.Name = "searchCriteria1";
            this.searchCriteria1.Size = new System.Drawing.Size(688, 24);
            this.searchCriteria1.TabIndex = 0;
            this.searchCriteria1.Load += new System.EventHandler(this.searchCriteria1_Load);
            // 
            // searchCriteria2
            // 
            this.searchCriteria2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.searchCriteria2.LineNumber = "2";
            this.searchCriteria2.Location = new System.Drawing.Point(2, 46);
            this.searchCriteria2.Name = "searchCriteria2";
            this.searchCriteria2.Size = new System.Drawing.Size(688, 24);
            this.searchCriteria2.TabIndex = 1;
            // 
            // ProjectSearch
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(720, 468);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.groupBox1);
            this.Name = "ProjectSearch";
            this.Text = "Project Search";
            this.Activated += new System.EventHandler(this.ProjectSearch_Activated);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.ProjectSearch_Closing);
            ((System.ComponentModel.ISupportInitialize)(this.dgProjects)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		private void btnSearch_Click(object sender, System.EventArgs e)
		{
            
            string sqlQuery = "SELECT DISTINCT ProjectId, ProjectName, FileNumber, Summary FROM Project ";
			string criteriaOne = this.searchCriteria1.SqlWhereCondition;
			string criteriaTwo = this.searchCriteria2.SqlWhereCondition;
            string criteriaThree = this.searchCriteria3.SqlWhereCondition;
            string criteriaFour = this.searchCriteria4.SqlWhereCondition;

			if(criteriaOne == string.Empty) return;

            //box in AuthorizationDate range
            string search = "dbo.usfDateOnly(AuthorizationDate)";
            string s = "";
            if (criteriaOne.Contains(search))
            {
                if (criteriaTwo.Contains(search))
                {
                    s = " AND ( " + criteriaTwo.Substring(criteriaTwo.IndexOf(search)) + " ";
                    criteriaOne = criteriaOne.Insert(criteriaOne.Length - 1, s);
                    criteriaTwo = "";
                }
                if (criteriaThree.Contains(search))
                {
                    s = " AND ( " + criteriaThree.Substring(criteriaThree.IndexOf(search)) + " ";
                    criteriaOne = criteriaOne.Insert(criteriaOne.Length - 1, s);
                    criteriaThree = "";
                }
                if (criteriaFour.Contains(search))
                {
                    s = " AND ( " + criteriaFour.Substring(criteriaFour.IndexOf(search)) + " ";
                    criteriaOne = criteriaOne.Insert(criteriaOne.Length - 1, s);
                    criteriaFour = "";
                }
            }
            else if (criteriaTwo.Contains(search))
            {
                if (criteriaThree.Contains(search))
                {
                    s = " AND ( " + criteriaThree.Substring(criteriaThree.IndexOf(search)) + " ";
                    criteriaTwo = criteriaTwo.Insert(criteriaTwo.Length - 1, s);
                    criteriaThree = "";
                }
                if (criteriaFour.Contains(search))
                {
                    s = " AND ( " + criteriaFour.Substring(criteriaFour.IndexOf(search)) + " ";
                    criteriaTwo = criteriaTwo.Insert(criteriaTwo.Length - 1, s);
                    criteriaFour = "";
                }
            }
            else if (criteriaThree.Contains(search))
            {
                if (criteriaFour.Contains(search))
                {
                    s = " AND ( " + criteriaFour.Substring(criteriaFour.IndexOf(search)) + " ";
                    criteriaThree = criteriaThree.Insert(criteriaThree.Length - 1, s);
                    criteriaFour = "";
                }
            }




			string sqlQueryAndCondition = string.Concat(
				sqlQuery,
				" WHERE ", 
				criteriaOne 
				);
			if(criteriaTwo != string.Empty)
			{
				sqlQueryAndCondition += string.Concat(
					searchCriteria2.LineOperator,
					criteriaTwo);
			}

            if (criteriaThree != string.Empty)
            {
                sqlQueryAndCondition += string.Concat(
                    searchCriteria3.LineOperator,
                    criteriaThree);
            }

            if(criteriaFour != string.Empty)
            {
                sqlQueryAndCondition += string.Concat(
                    searchCriteria4.LineOperator,
                    criteriaFour);
            }

			sqlQueryAndCondition += " ORDER BY ProjectName";

            try
            {
                BindGrid(ProjectData.ProjectSearch(sqlQueryAndCondition));
            }
            catch (Exception ex)
            {
                MessageBox.Show("Invalid value entered.", "Data query failure.", MessageBoxButtons.OK);
            }
		}

        private void OpenProject()
        {
            ArrayList al = GetSelectedProject();
            for (int i = 0; i < al.Count; i++)
            {
                int projectId = int.Parse(al[i].ToString());

                Form1 mainForm = (Form1)this.MdiParent;
                mainForm.OpenProject(projectId, ProjectData.GetProjectName(projectId));
            }
        }

		private void btnOpen_Click(object sender, System.EventArgs e)
		{
            OpenProject();
		}

		private void ProjectSearch_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			GlobalSettings.projectSearchHandle = null;
		}

        private void dgProjects_DoubleClick(object sender, EventArgs e)
        {
            OpenProject();
        }

        private void searchCriteria1_Load(object sender, EventArgs e)
        {

        }

        private void ProjectSearch_Activated(object sender, EventArgs e)
        {
            RestoreWindowState();
		}
        private void RestoreWindowState()
        {
            // Looking for given form among all opened forms 
            Form instance = null;
            foreach (Form form in Application.OpenForms)
                if (form is ProjectSearch && form.Text.Trim() == this.Text)
                {
                    instance = form;

                    if (instance.WindowState == FormWindowState.Minimized)
                        instance.WindowState = FormWindowState.Normal;

                    instance.BringToFront();
                    if (instance.CanFocus)
                        instance.Focus();

                    break;
                }
        }



	}
}
