using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using CCPM.Data;

namespace CCPM.ProjectImages
{
	/// <summary>
	/// Summary description for ImageUpdateName.
	/// </summary>
	public class ImageUpdateName : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private Genghis.Windows.Forms.RequiredFieldValidator requiredFieldValidator1;
		private string imageName;
		private int imageId;
		private System.Windows.Forms.TextBox txtImageName;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Button btnCancel;

		public string ImageName
		{
			get{return imageName;}
			set{imageName = value;}
		}
		public int ImageId
		{
			get{return imageId;}
			set{imageId = value;}
		}

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ImageUpdateName(int imageId, string imageName)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			ImageId = imageId; 
			ImageName = imageName;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ImageUpdateName));
			this.label1 = new System.Windows.Forms.Label();
			this.btnSave = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.requiredFieldValidator1 = new Genghis.Windows.Forms.RequiredFieldValidator();
			this.txtImageName = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.requiredFieldValidator1)).BeginInit();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 30);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 24);
			this.label1.TabIndex = 0;
			this.label1.Text = "Image Name";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// btnSave
			// 
			this.btnSave.Location = new System.Drawing.Point(104, 88);
			this.btnSave.Name = "btnSave";
			this.btnSave.TabIndex = 2;
			this.btnSave.Text = "Save";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Location = new System.Drawing.Point(256, 88);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 3;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// requiredFieldValidator1
			// 
			this.requiredFieldValidator1.ControlToValidate = this.txtImageName;
			this.requiredFieldValidator1.ErrorMessage = "Image Name is required";
			this.requiredFieldValidator1.Icon = ((System.Drawing.Icon)(resources.GetObject("requiredFieldValidator1.Icon")));
			// 
			// txtImageName
			// 
			this.txtImageName.Location = new System.Drawing.Point(104, 32);
			this.txtImageName.Name = "txtImageName";
			this.txtImageName.Size = new System.Drawing.Size(272, 20);
			this.txtImageName.TabIndex = 1;
			this.txtImageName.Text = "";
			// 
			// ImageUpdateName
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(472, 142);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnSave);
			this.Controls.Add(this.txtImageName);
			this.Controls.Add(this.label1);
			this.Name = "ImageUpdateName";
			this.Text = "Update Image Name";
			this.Load += new System.EventHandler(this.ImageUpdateName_Load);
			((System.ComponentModel.ISupportInitialize)(this.requiredFieldValidator1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void ImageUpdateName_Load(object sender, System.EventArgs e)
		{
			txtImageName.Text = ImageName;
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			txtImageName.Focus();
			if(this.requiredFieldValidator1.IsValid)
			{
				ResourceData.ImageUpdateName(imageId, txtImageName.Text);
				this.DialogResult = DialogResult.OK;
				this.Close();
			}
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
