using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;

using System.Windows.Forms;


namespace CCPM.ProjectRelated
{
	/// <summary>
	/// ManageDistricts derives from ManageBase to accomodate validation 
	/// requirements for districts.
	/// </summary>
	public class ManageDistricts : CCPM.ProjectRelated.ManageBase
	{
		private Genghis.Windows.Forms.RegularExpressionValidator revNew;
		private System.ComponentModel.IContainer components = null;
		public ManageDistricts(PopulateMethod populateMethod, InsertMethod insertMethod, UpdateMethod updateMethod, string nameCol, string idCol, string windowTitle): base(populateMethod, insertMethod, updateMethod, nameCol, idCol, windowTitle)
		{
			// This call is required by the Windows Form Designer.
			
			InitializeComponent();

			SetValidation();
		}

		protected void SetValidation()
		{
			//revNew
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ManageDistricts));
			this.revNew = new Genghis.Windows.Forms.RegularExpressionValidator();
			((System.ComponentModel.ISupportInitialize)(this.revNew)).BeginInit();
			this.revNew.ControlToValidate = this.txtNew;
			this.revNew.ErrorMessage = "Input must be a number";
			this.revNew.Icon = ((System.Drawing.Icon)(resources.GetObject("revNew.Icon")));
			this.revNew.ValidationExpression = "^\\d*$";

		}

		protected override bool ValidateNew()
		{
			if( ! base.ValidateNew()) return false;

			return revNew.IsValid; //Regex validation
		}

		protected override bool ValidateEdit()
		{
			return true; //No validation because district numbers are not editable
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		protected override void SetEditControls(int id)
		{
			txtEdit.Enabled = false;
			foreach(System.Data.DataRow dr in ds.Tables[0].Rows)
			{
				if((int)dr[idCol] == id)
				{
					txtEdit.Text = dr[nameCol].ToString();
					switch((bool)dr["IsActive"])
					{
						case true:
							rbActive.Checked = true;
							rbInactive.Checked = false;
							break;
						case false:
							rbInactive.Checked = true;
							rbActive.Checked = false;
							break;
					}
				}
			}
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// ManageDistricts
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(464, 286);
			this.Name = "ManageDistricts";

		}
		#endregion
	}
}

