using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace CCPM.RelatedProjects
{
	/// <summary>
	/// //The only difference between OpenProject and RelatedProjectPicker
	/// is the text on the buttons and window title.
	/// </summary>
	public class RelatedProjectPicker : CCPM.Project.OpenProjectRelated
	{
		private System.Windows.Forms.Button btnAdd;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private int parentProjectID = 0;

		public RelatedProjectPicker():base()
		{
			InitializeControls();
            
		}

		public RelatedProjectPicker(int projectID):base()
		{
			InitializeControls();
			parentProjectID = projectID;
		}

		private void InitializeControls()
		{
			//this.btnOpenByFileNumber.Text = "Select Project";
			this.btnOpenByName.Text = "Select Project";
			this.Text = "Link Related Project";

			// 
			// btnAdd
			// 
			this.btnAdd = new Button();
			this.btnAdd.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnAdd.Location = new System.Drawing.Point(16, 267);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.TabIndex = 4;
			this.btnAdd.Text = "Add";
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			this.Controls.Add( this.btnAdd );
		}

		public override void SetProjectId(int projectId, int type, string notes)
		{
			base.SetProjectId(projectId,type,notes);

			CCPM.Data.RelatedProjectData.RelatedProjectInsert( parentProjectID, projectId, notes, type);
			this.DialogResult= DialogResult.OK;
			this.Close();
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			if(DialogResult.OK == new CreateRelatedProject(ProjectId).ShowDialog(this))
			{
				// ADS 4-Dec-2007 - 2.10 - If the related project dlg returns okay, then return okay as well
				this.DialogResult = DialogResult.OK;
				this.Close();
			}
		}
	}
}
