using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using CCPM.Data;
using System.Text.RegularExpressions;
using System.Data;

namespace CCPM.RelatedProjects
{
	/// <summary>
	/// Derive from CreateRelatedProject to provide for updating related projects.
	/// 
	/// </summary>
	public class RelatedProjectUpdate : CCPM.RelatedProjects.CreateRelatedProject
	{
		//We don't need ProjectId here so pass 0 to base constructor.
		public RelatedProjectUpdate(int recordId):base(0)
		{
			RecordId = recordId;
			PopulateForm();
		}
		/// <summary>
		/// File number and project picker button are disabled to simplify
		/// guaranteeing file number is unique.
		/// </summary>
		public void PopulateForm()
		{
			DataRow dr = RelatedProjectData.RelatedProjectById(RecordId).Tables[0].Rows[0];
			//txtFileNumber.Text = dr["FileNumber"].ToString();
            cbFileNumber.Text = dr["FileNumber"].ToString();
			cbProjectName.Text = dr["ProjectName"].ToString() == string.Empty? "Enter Project Name" : dr["ProjectName"].ToString();
            txtNotes.Text = dr["Notes"].ToString() == string.Empty? "" : dr["Notes"].ToString();
            cmbRelType.Text = dr["RelType"].ToString() == string.Empty? " " : dr["RelType"].ToString();
			//If project is in the current database then project name is not editable
			if((int)dr["RelatedProjectId"] != 0) //Project is in the current database
			{
				txtProjectName.ReadOnly = true;
			}
			txtFileNumber.ReadOnly = true;            
			txtFileNumber.TabStop = false;
			//this.btnShowProjectPicker.Enabled = false;
		}

		protected override void Save()
		{
            int RelatedProjectid = 0;

            if (cbProjectName.Enabled == true)
            {
                RelatedProjectid =Convert.ToInt16(cbProjectName.SelectedValue);
            }
            else 
            {
                RelatedProjectid = Convert.ToInt16(cbFileNumber.SelectedValue);
            }
            RelatedProjectData.RelatedProjectUpdate(RecordId, RelatedProjectid, txtNotes.Text, Convert.ToInt32(cmbRelType.SelectedValue));
			DialogResult = DialogResult.OK;
			this.Close();
		}
	}
}
