using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Reflection;
using WrapColumn;
using CCPM.Data;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;


namespace CCPM.RelatedProjects
{
	/// <summary>
	/// Lists and provides for ediging related projects.
	/// </summary>
	public class RelatetProjectList : System.Windows.Forms.UserControl
    {
        private DataSet dsRelProject;

        private IContainer components;
        private int projectId;
        private System.Windows.Forms.DataGridTextBoxColumn colRelType;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem miAddRelatedProject;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem miUpdate;
		private System.Windows.Forms.MenuItem miDelete;
		private System.Windows.Forms.MenuItem miOpenRelatedProject;
        private System.Windows.Forms.MenuItem menuItem3;

        //Replaced Datagrid with Infragistic grid control -- 17-July-2008 --- 2.10
        private Infragistics.Win.UltraWinGrid.UltraGrid uwgRelatedProject;
        private DataGridTableStyle dataGridTableStyle1;
        private DataGrid dgRelatedProjects;
        private DataGridTextBoxColumn colRelType1;
        private DataGridTextBoxColumn colSummary;
        private DataGridTextBoxColumn colDescription;
        private DataGridTextBoxColumn colProjectName;
        private DataGridTextBoxColumn colFileNumber;
        private Button btnAddRelProject;
        private Button btnEditRelProject;
        private Button btnDeleteRelProject;
        private Button btnOpenRelProject;
		
        private DataSet dsRelTypes;

		public int ProjectId
		{
			get{return projectId;}
			set{projectId = value;}
		}

		protected int RecordId
		{
			get
            {
            //    DataRow dr = dsRelProject.Tables[0].Rows[uwgRelatedProject.ActiveRow.Cells[0]];
            //    return (int)dr["RecordId"];
                
                return Convert.ToInt32(uwgRelatedProject.ActiveRow.Cells[0].Value);
			}
		}
		public RelatetProjectList(int projectId)
		{
            
            // This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
            ProjectId = projectId;

            // Fill dataset with Relationship types
            //dsRelTypes = RelatedProjectData.GetRelTypeSelectionList();
            //uwgRelatedProject.DisplayLayout.ValueLists.Add("RelTypes");
            //for (int i = 0; i < dsRelTypes.Tables[0].Rows.Count; i++)
            //{
            //    Infragistics.Win.ValueListItem ListItem = new Infragistics.Win.ValueListItem();
            //    ListItem.DataValue = dsRelTypes.Tables[0].Rows[i].ItemArray.GetValue(0);
            //    ListItem.DisplayText = (string)dsRelTypes.Tables[0].Rows[i].ItemArray.GetValue(1);
            //    uwgRelatedProject.DisplayLayout.ValueLists["RelTypes"].ValueListItems.Add(ListItem);
            //} 

            LoadGridProject();            
		}

        private void LoadGridProject()
        {
            dsRelProject = RelatedProjectData.RelatedProjectList(ProjectId);
            uwgRelatedProject.DataSource = dsRelProject.Tables[0];
            uwgRelatedProject.DataBind();

            AutoSizeGrid();     

        }

        // Updated -- 17-July-2008
        private void AutoSizeGrid()
        {
            int numRows1 = ((DataTable)uwgRelatedProject.DataSource).Rows.Count;
           // uwgRelatedProject.DisplayLayout.Override.CellMultiLine = DefaultableBoolean.True;
            StringFormat sf = new StringFormat(StringFormat.GenericTypographic);
            SizeF descriptionSize; //description field
            SizeF nameSize; //project name field
            SizeF summarySize; // summary field
            
            Graphics g = Graphics.FromHwnd(uwgRelatedProject.Handle);

            for (int i = 0; i < numRows1; ++i)
            {
                
                nameSize = g.MeasureString(uwgRelatedProject.Rows[i].Cells[3].Value.ToString(), uwgRelatedProject.Font, 100, sf);
                int nh = Convert.ToInt32(nameSize.Height);
                
                descriptionSize = g.MeasureString(uwgRelatedProject.Rows[i].Cells[6].Value.ToString(), uwgRelatedProject.Font, 140, sf);
                int dh = Convert.ToInt32(descriptionSize.Height);

                summarySize = g.MeasureString(uwgRelatedProject.Rows[i].Cells[5].Value.ToString(), uwgRelatedProject.Font, 300, sf);
                int sh = Convert.ToInt32(summarySize.Height);

                 //determine greatest height
                int h = dh > nh ? dh : nh;
                h = sh > h ? sh : h;

                 //Little extra cellpadding space 
                h = h + 20; 
                if(h==8) h=5;

                this.uwgRelatedProject.Rows[i].Height = h;         
                
            }
            g.Dispose();            
        }

        /// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.contextMenu1 = new System.Windows.Forms.ContextMenu();
            this.miOpenRelatedProject = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.miAddRelatedProject = new System.Windows.Forms.MenuItem();
            this.miUpdate = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.miDelete = new System.Windows.Forms.MenuItem();
            this.colRelType = new System.Windows.Forms.DataGridTextBoxColumn();
            this.uwgRelatedProject = new Infragistics.Win.UltraWinGrid.UltraGrid();
            this.dataGridTableStyle1 = new System.Windows.Forms.DataGridTableStyle();
            this.colRelType1 = new System.Windows.Forms.DataGridTextBoxColumn();
            this.colSummary = new System.Windows.Forms.DataGridTextBoxColumn();
            this.colDescription = new System.Windows.Forms.DataGridTextBoxColumn();
            this.colProjectName = new System.Windows.Forms.DataGridTextBoxColumn();
            this.colFileNumber = new System.Windows.Forms.DataGridTextBoxColumn();
            this.dgRelatedProjects = new System.Windows.Forms.DataGrid();
            this.btnAddRelProject = new System.Windows.Forms.Button();
            this.btnEditRelProject = new System.Windows.Forms.Button();
            this.btnDeleteRelProject = new System.Windows.Forms.Button();
            this.btnOpenRelProject = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.uwgRelatedProject)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.dgRelatedProjects)).BeginInit();
            this.SuspendLayout();
            // 
            // contextMenu1
            // 
            this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miOpenRelatedProject,
            this.menuItem3,
            this.miAddRelatedProject,
            this.miUpdate,
            this.menuItem1,
            this.miDelete});
            // 
            // miOpenRelatedProject
            // 
            this.miOpenRelatedProject.Index = 0;
            this.miOpenRelatedProject.Text = "Open Related Project";
            this.miOpenRelatedProject.Click += new System.EventHandler(this.miOpenRelatedProject_Click);
            // 
            // menuItem3
            // 
            this.menuItem3.Index = 1;
            this.menuItem3.Text = "-";
            // 
            // miAddRelatedProject
            // 
            this.miAddRelatedProject.Index = 2;
            this.miAddRelatedProject.Text = "Link Related Project";
            this.miAddRelatedProject.Click += new System.EventHandler(this.miAddRelatedProject_Click);
            // 
            // miUpdate
            // 
            this.miUpdate.Index = 3;
            this.miUpdate.Text = "Edit Related Project";
            this.miUpdate.Click += new System.EventHandler(this.miUpdate_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 4;
            this.menuItem1.Text = "-";
            // 
            // miDelete
            // 
            this.miDelete.Index = 5;
            this.miDelete.Text = "Unlink Related Project";
            this.miDelete.Click += new System.EventHandler(this.miDelete_Click);
            // 
            // colRelType
            // 
            this.colRelType.Format = "";
            this.colRelType.FormatInfo = null;
            this.colRelType.Width = -1;
            // 
            // uwgRelatedProject
            // 
            this.uwgRelatedProject.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.uwgRelatedProject.Cursor = System.Windows.Forms.Cursors.Hand;
            this.uwgRelatedProject.DisplayLayout.AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle.ResizeAllColumns;
            this.uwgRelatedProject.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.uwgRelatedProject.Location = new System.Drawing.Point(16, 36);
            this.uwgRelatedProject.Name = "uwgRelatedProject";
            this.uwgRelatedProject.Size = new System.Drawing.Size(748, 515);
            this.uwgRelatedProject.TabIndex = 30;
            this.uwgRelatedProject.Text = "RELATED PROJECT";
            this.uwgRelatedProject.MouseDown += new System.Windows.Forms.MouseEventHandler(this.uwgRelatedProject_MouseDown);
            this.uwgRelatedProject.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(this.uwgRelatedProject_InitializeLayout_1);
            this.uwgRelatedProject.DoubleClickRow += new Infragistics.Win.UltraWinGrid.DoubleClickRowEventHandler(this.uwgRelatedProject_DoubleClickRow);
            // 
            // dataGridTableStyle1
            // 
            this.dataGridTableStyle1.DataGrid = null;
            this.dataGridTableStyle1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            // 
            // colRelType1
            // 
            this.colRelType1.Format = "";
            this.colRelType1.FormatInfo = null;
            this.colRelType1.Width = -1;
            // 
            // colSummary
            // 
            this.colSummary.Format = "";
            this.colSummary.FormatInfo = null;
            this.colSummary.Width = -1;
            // 
            // colDescription
            // 
            this.colDescription.Format = "";
            this.colDescription.FormatInfo = null;
            this.colDescription.Width = -1;
            // 
            // colProjectName
            // 
            this.colProjectName.Format = "";
            this.colProjectName.FormatInfo = null;
            this.colProjectName.Width = -1;
            // 
            // colFileNumber
            // 
            this.colFileNumber.Format = "";
            this.colFileNumber.FormatInfo = null;
            this.colFileNumber.Width = -1;
            // 
            // dgRelatedProjects
            // 
            this.dgRelatedProjects.DataMember = "";
            this.dgRelatedProjects.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.dgRelatedProjects.Location = new System.Drawing.Point(0, 0);
            this.dgRelatedProjects.Name = "dgRelatedProjects";
            this.dgRelatedProjects.Size = new System.Drawing.Size(130, 80);
            this.dgRelatedProjects.TabIndex = 0;
            // 
            // btnAddRelProject
            // 
            this.btnAddRelProject.Location = new System.Drawing.Point(184, 568);
            this.btnAddRelProject.Name = "btnAddRelProject";
            this.btnAddRelProject.Size = new System.Drawing.Size(145, 23);
            this.btnAddRelProject.TabIndex = 31;
            this.btnAddRelProject.Text = "Link Related Project";
            this.btnAddRelProject.UseVisualStyleBackColor = true;
            this.btnAddRelProject.Click += new System.EventHandler(this.btnAddRelProject_Click);
            // 
            // btnEditRelProject
            // 
            this.btnEditRelProject.Location = new System.Drawing.Point(348, 568);
            this.btnEditRelProject.Name = "btnEditRelProject";
            this.btnEditRelProject.Size = new System.Drawing.Size(145, 23);
            this.btnEditRelProject.TabIndex = 32;
            this.btnEditRelProject.Text = "Edit Related Project";
            this.btnEditRelProject.UseVisualStyleBackColor = true;
            this.btnEditRelProject.Click += new System.EventHandler(this.btnEditRelProject_Click);
            // 
            // btnDeleteRelProject
            // 
            this.btnDeleteRelProject.Location = new System.Drawing.Point(515, 569);
            this.btnDeleteRelProject.Name = "btnDeleteRelProject";
            this.btnDeleteRelProject.Size = new System.Drawing.Size(145, 23);
            this.btnDeleteRelProject.TabIndex = 33;
            this.btnDeleteRelProject.Text = "Unlink Related Project";
            this.btnDeleteRelProject.UseVisualStyleBackColor = true;
            this.btnDeleteRelProject.Click += new System.EventHandler(this.btnDeleteRelProject_Click);
            // 
            // btnOpenRelProject
            // 
            this.btnOpenRelProject.Location = new System.Drawing.Point(24, 568);
            this.btnOpenRelProject.Name = "btnOpenRelProject";
            this.btnOpenRelProject.Size = new System.Drawing.Size(145, 23);
            this.btnOpenRelProject.TabIndex = 34;
            this.btnOpenRelProject.Text = "Open Related Project";
            this.btnOpenRelProject.UseVisualStyleBackColor = true;
            this.btnOpenRelProject.Click += new System.EventHandler(this.btnOpenRelProject_Click);
            // 
            // RelatetProjectList
            // 
            this.AutoSize = true;
            this.Controls.Add(this.btnOpenRelProject);
            this.Controls.Add(this.btnDeleteRelProject);
            this.Controls.Add(this.btnEditRelProject);
            this.Controls.Add(this.btnAddRelProject);
            this.Controls.Add(this.uwgRelatedProject);
            this.Cursor = System.Windows.Forms.Cursors.Hand;
            this.Name = "RelatetProjectList";
            this.Size = new System.Drawing.Size(784, 611);
            this.Load += new System.EventHandler(this.RelatetProjectList_Load);
            ((System.ComponentModel.ISupportInitialize)(this.uwgRelatedProject)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.dgRelatedProjects)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		private void RelatetProjectList_Load(object sender, System.EventArgs e)
		{
            LoadGridProject();
		}

		public void miAddRelatedProject_Click(object sender, System.EventArgs e)
		{
			if(DialogResult.OK == new RelatedProjectPicker(ProjectId).ShowDialog(this))
			{
                LoadGridProject();
			}
		}

		public void miUpdate_Click(object sender, System.EventArgs e)
		{
			if(dsRelProject.Tables[0].Rows.Count < 1) return;
			if(DialogResult.OK == new RelatedProjectUpdate(RecordId).ShowDialog(this))
            {
                LoadGridProject();
			}
		}

		public void miDelete_Click(object sender, System.EventArgs e)
		{
            if (dsRelProject.Tables[0].Rows.Count < 1) return;
            if (DialogResult.OK == MessageBox.Show("You are about to delete a related project. This will not remove the project from the database. Do you want to continue?",
				"Related Project Delete Confirmation",
				MessageBoxButtons.OKCancel,
				MessageBoxIcon.Stop))
			{
				RelatedProjectData.RelatedProjectDelete(RecordId);
                LoadGridProject();
			}
		}

		// ADS 29-Nov-2007 - Added new feature ( 2.10.2.2 )
		private void miOpenRelatedProject_Click(object sender, System.EventArgs e)
		{
            if (dsRelProject.Tables[0].Rows.Count < 1) return;

			// Get record associated with the selected row
			//DataRow dr = dsRelProject.Tables[0].Rows[uwgRelatedProject.ActiveRow];

			// Open the project form
            ((CCPM.Form1)this.ParentForm.MdiParent).OpenProject(Convert.ToInt32(uwgRelatedProject.ActiveRow.Cells[1].Value), ProjectData.GetProjectName(Convert.ToInt32(uwgRelatedProject.ActiveRow.Cells[1].Value)));
		}

        private void uwgRelatedProject_InitializeLayout_1(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //RecordId
            e.Layout.Bands[0].Columns[0].Hidden = true;

            //RelatedProjectId
            e.Layout.Bands[0].Columns[1].Hidden = true;

            e.Layout.Bands[0].Columns[2].Width = 90;            
            e.Layout.Bands[0].Columns[2].Header.Caption = "Project Number";
            e.Layout.Bands[0].Columns[2].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Left;
            e.Layout.Bands[0].Columns[2].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[2].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[3].Width = 140;
            e.Layout.Bands[0].Columns[3].Header.Caption = "Project Name";
            e.Layout.Bands[0].Columns[3].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Left;
            e.Layout.Bands[0].Columns[3].CellMultiLine = DefaultableBoolean.True;
            e.Layout.Bands[0].Columns[3].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[3].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[3].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[3].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[4].Width = 150;
            e.Layout.Bands[0].Columns[4].Header.Caption = "Relation Type";
            e.Layout.Bands[0].Columns[4].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Left;
            e.Layout.Bands[0].Columns[4].CellMultiLine = DefaultableBoolean.True;
            e.Layout.Bands[0].Columns[4].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[4].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[4].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[4].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
            //e.Layout.Bands[0].Columns[4].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            //e.Layout.Bands[0].Columns[4].ValueList = uwgRelatedProject.DisplayLayout.ValueLists["RelTypes"];
            //e.Layout.ValueLists["RelTypes"].DisplayStyle = Infragistics.Win.ValueListDisplayStyle.DisplayText;
            //e.Layout.Bands[0].Columns[4].ValueList = uwgRelatedProject.DisplayLayout.ValueLists["RelTypes"];

            e.Layout.Bands[0].Columns[5].Width = 350;
            e.Layout.Bands[0].Columns[5].Header.Caption = "Project Summary";
            e.Layout.Bands[0].Columns[5].CellMultiLine = DefaultableBoolean.True;
            e.Layout.Bands[0].Columns[5].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Left;
            e.Layout.Bands[0].Columns[5].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[5].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[5].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[5].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;

            e.Layout.Bands[0].Columns[6].Width = 240;
            e.Layout.Bands[0].Columns[6].Header.Caption = "Notes";
            e.Layout.Bands[0].Columns[6].CellMultiLine = DefaultableBoolean.True;
            e.Layout.Bands[0].Columns[6].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Left;
            e.Layout.Bands[0].Columns[6].CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColor = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.BackColorDisabled = GlobalSettings.nonEditableBackColor;
            e.Layout.Bands[0].Columns[6].CellAppearance.ForeColorDisabled = GlobalSettings.nonEditableForeColor;
        }

        private void uwgRelatedProject_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                Point mousePoint = new Point(e.X, e.Y);
                UIElement element = ((UltraGrid)sender).DisplayLayout.UIElement.ElementFromPoint(mousePoint);

                contextMenu1.Show(uwgRelatedProject, mousePoint);
            }
        }

        private void uwgRelatedProject_DoubleClickRow(object sender, DoubleClickRowEventArgs e)
        {
            if (uwgRelatedProject.Rows.Count == 0)
                return;

            ((CCPM.Form1)this.ParentForm.MdiParent).OpenProject(Convert.ToInt32(uwgRelatedProject.ActiveRow.Cells[1].Value), CCPM.Data.ProjectData.GetProjectName(Convert.ToInt32(uwgRelatedProject.ActiveRow.Cells[1].Value)));
            
        }

        private void btnOpenRelProject_Click(object sender, EventArgs e)
        {
            if (dsRelProject.Tables[0].Rows.Count < 1) return;

            // Open the project form
            ((CCPM.Form1)this.ParentForm.MdiParent).OpenProject(Convert.ToInt32(uwgRelatedProject.ActiveRow.Cells[1].Value), CCPM.Data.ProjectData.GetProjectName(Convert.ToInt32(uwgRelatedProject.ActiveRow.Cells[1].Value)));
        }

        private void btnAddRelProject_Click(object sender, EventArgs e)
        {
            if (DialogResult.OK == new RelatedProjectPicker(ProjectId).ShowDialog(this))
            {
                LoadGridProject();
            }
        }

        private void btnEditRelProject_Click(object sender, EventArgs e)
        {
            if (dsRelProject.Tables[0].Rows.Count < 1) return;
            if (DialogResult.OK == new RelatedProjectUpdate(RecordId).ShowDialog(this))
            {
                LoadGridProject();
            }
        }

        private void btnDeleteRelProject_Click(object sender, EventArgs e)
        {
            if (dsRelProject.Tables[0].Rows.Count < 1) return;
            if (DialogResult.OK == MessageBox.Show("You are about to unlink a related project. This will not delete it from the database.",
                "Unlink Related Project",
                MessageBoxButtons.OKCancel,
                MessageBoxIcon.Stop))
            {
                RelatedProjectData.RelatedProjectDelete(RecordId);
                LoadGridProject();
            }
        }        
	}
}
