﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CCPM.Report
{
    public partial class DateRange : Form
    {
        public object completionDate1
        {
            get { return date1; }
        }
        public object completionDate2
        {
            get { return date2; }
        }
        public string type
        {
            get { return dateType; }
        }

        public DateRange()
        {
            InitializeComponent();
        }

        public DateTime date1;
        public DateTime date2;
        string dateType = "";

        private void btnOK_Click(object sender, EventArgs e)
        {
            bool blnDataValid = true;
            if (rdoCompletion.Checked == true)
            {
                if (uwdtDateCompleted1.Value == null)
                {
                    //MessageBox.Show("Please enter Completion Date Range !!", "Data Entry Error", MessageBoxButtons.OK);
                    blnDataValid = true;
                    dateType = "all";
                }
                else if (uwdtDateCompleted2.Value == null)
                {
                    uwdtDateCompleted2.Value = uwdtDateCompleted1.Value;
                    blnDataValid = true;
                    date1 = uwdtDateCompleted1.DateTime.Date;
                    date2 = uwdtDateCompleted2.DateTime.Date;
                    dateType = "Completed";
                }
                else
                {
                    blnDataValid = true;
                    date1 = uwdtDateCompleted1.DateTime.Date;
                    date2 = uwdtDateCompleted2.DateTime.Date;
                    dateType = "Completed";
                }
            }
            else if (rdoTermination.Checked == true)
            {
                if (uwdtDateTerminated1.Value == null)
                {
                    //MessageBox.Show("Please enter Termination Date Range !!", "Data Entry Error", MessageBoxButtons.OK);
                    blnDataValid = true;
                    dateType = "all";
                }
                else if (uwdtDateTerminated2.Value == null)
                {
                    uwdtDateTerminated2.Value = uwdtDateTerminated1.Value;
                    blnDataValid = true;
                    date1 = uwdtDateTerminated1.DateTime.Date;
                    date2 = uwdtDateTerminated2.DateTime.Date;
                    dateType = "Terminated";
                }
                else
                {
                    blnDataValid = true;
                    date1 = uwdtDateTerminated1.DateTime.Date;
                    date2 = uwdtDateTerminated2.DateTime.Date;
                    dateType = "Terminated";
                }
            }

            if (blnDataValid == true)
            {
                DialogResult = DialogResult.OK;
                this.Close();
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void rdoCompletion_CheckedChanged(object sender, EventArgs e)
        {
            if (rdoCompletion.Checked == true)
            {
                rdoTermination.Checked = false;
                uwdtDateTerminated1.Enabled = false;
                uwdtDateTerminated2.Enabled = false;
                uwdtDateCompleted1.Enabled = true;
                uwdtDateCompleted2.Enabled = false;
            }
           
        }

        private void rdoTermination_CheckedChanged(object sender, EventArgs e)
        {
            if (rdoTermination.Checked == true)
            {
                rdoCompletion.Checked = false;
                uwdtDateCompleted1.Enabled = false;
                uwdtDateCompleted2.Enabled = false;
                uwdtDateTerminated1.Enabled = true;
                uwdtDateTerminated2.Enabled = false;
            }
        }

        private void uwdtDateCompleted1_ValueChanged(object sender, EventArgs e)
        {
            if (uwdtDateCompleted1.Value == null)
            {
                uwdtDateCompleted2.Enabled = false;
            }
            else
            {
                uwdtDateCompleted2.Enabled = true;
            }
        }

        private void uwdtDateTerminated1_ValueChanged(object sender, EventArgs e)
        {
            if (uwdtDateTerminated1.Value == null)
            {
                uwdtDateTerminated2.Enabled = false;
            }
            else
            {
                uwdtDateTerminated2.Enabled = true;
            }
        }

        private void btnAll_Click(object sender, EventArgs e)
        {
           dateType = "all";
           DialogResult = DialogResult.OK;
           this.Close();
        }

       
    }
}
