using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace CCPM.Report
{
	/// <summary>
	/// Summary description for ReportList.
	/// </summary>
	public class ReportList : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Button btnOnePage;
		private System.Windows.Forms.GroupBox groupBox1;
		private int projectId;
		private System.Windows.Forms.PictureBox pictureBox1;
        protected Button btnContractExpirationAlert;
        protected Button button1;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		public int ProjectId
		{
			get{return projectId;}
			set{projectId = value;}
		}

		public ReportList(int projectId)
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			ProjectId = projectId;
			this.pictureBox1.Image = new Bitmap(this.GetType(), "onePage.png");

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.btnOnePage = new System.Windows.Forms.Button();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.button1 = new System.Windows.Forms.Button();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.btnContractExpirationAlert = new System.Windows.Forms.Button();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.SuspendLayout();
            // 
            // btnOnePage
            // 
            this.btnOnePage.BackColor = System.Drawing.SystemColors.Control;
            this.btnOnePage.Location = new System.Drawing.Point(134, 58);
            this.btnOnePage.Name = "btnOnePage";
            this.btnOnePage.Size = new System.Drawing.Size(219, 25);
            this.btnOnePage.TabIndex = 0;
            this.btnOnePage.Text = "External 1-Pager Report";
            this.btnOnePage.UseVisualStyleBackColor = false;
            this.btnOnePage.Click += new System.EventHandler(this.btnOnePage_Click);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.button1);
            this.groupBox1.Controls.Add(this.pictureBox1);
            this.groupBox1.Controls.Add(this.btnOnePage);
            this.groupBox1.Location = new System.Drawing.Point(16, 16);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(380, 176);
            this.groupBox1.TabIndex = 1;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "One Page Report";
            // 
            // button1
            // 
            this.button1.BackColor = System.Drawing.SystemColors.Control;
            this.button1.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button1.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.button1.Location = new System.Drawing.Point(134, 112);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(219, 24);
            this.button1.TabIndex = 1;
            this.button1.Text = "Internal Project Summary Report";
            this.button1.UseVisualStyleBackColor = false;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // pictureBox1
            // 
            this.pictureBox1.Location = new System.Drawing.Point(16, 24);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(100, 133);
            this.pictureBox1.TabIndex = 1;
            this.pictureBox1.TabStop = false;
            // 
            // btnContractExpirationAlert
            // 
            this.btnContractExpirationAlert.BackColor = System.Drawing.SystemColors.Control;
            this.btnContractExpirationAlert.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnContractExpirationAlert.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.btnContractExpirationAlert.Location = new System.Drawing.Point(16, 215);
            this.btnContractExpirationAlert.Name = "btnContractExpirationAlert";
            this.btnContractExpirationAlert.Size = new System.Drawing.Size(389, 25);
            this.btnContractExpirationAlert.TabIndex = 2;
            this.btnContractExpirationAlert.Text = "Agreement Expiration Alert and Modification Forms - All Contracts";
            this.btnContractExpirationAlert.UseVisualStyleBackColor = false;
            this.btnContractExpirationAlert.Visible = false;
            this.btnContractExpirationAlert.Click += new System.EventHandler(this.btnContractExpirationAlert_Click);
            // 
            // ReportList
            // 
            this.Controls.Add(this.btnContractExpirationAlert);
            this.Controls.Add(this.groupBox1);
            this.Name = "ReportList";
            this.Size = new System.Drawing.Size(499, 304);
            this.groupBox1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		private void btnOnePage_Click(object sender, System.EventArgs e)
		{
			CCPM.Report.OnePage onePage = new CCPM.Report.OnePage(ProjectId);
			onePage.Show();
		}

        private void btnContractExpirationAlert_Click(object sender, EventArgs e)
        {
            CCPM.Report.DateRange dr = new DateRange();
            if (dr.ShowDialog() == DialogResult.OK)
            {
                CCPM.Report.ContractExpirationReport fm = new CCPM.Report.ContractExpirationReport(dr.completionDate1, dr.completionDate2, dr.type);
                Form1 fm1 = (Form1)this.ParentForm.MdiParent;
                fm.MdiParent = fm1;
                fm.Show();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            CCPM.Report.Project_Report fm = new CCPM.Report.Project_Report();
            Form1 fm1 = (Form1)this.ParentForm.MdiParent;
            fm.MdiParent = fm1;
            fm.Show();
        }

		
	}
}
