using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using CCPM.Data;

namespace CCPM.User
{
	/// <summary>
	/// Summary description for CreateUser.
	/// </summary>
	public class CreateUser : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox cbRole;
		private System.Windows.Forms.TextBox txtUsername;
		private Genghis.Windows.Forms.RequiredFieldValidator rfvUsername;
		private Genghis.Windows.Forms.RequiredFieldValidator rfvRole;
		private int result;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.ComponentModel.IContainer components;
		public int UserInsertResult
		{
			get{return result;}
			set{result = value;}
		}

		public CreateUser()
		{
			InitializeComponent();
			
			this.Load += new System.EventHandler(this.Form_Load);
		}

		private void PopulateComboBox()
		{
			string[] enumNames = System.Enum.GetNames(typeof(UserRole));

			foreach(string name in enumNames)
			{
				if(name != "None")
					this.cbRole.Items.Add(name);
			}

			this.cbRole.Items.Insert(0, string.Empty);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(CreateUser));
			this.btnOk = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.cbRole = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.txtUsername = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.rfvUsername = new Genghis.Windows.Forms.RequiredFieldValidator();
			this.rfvRole = new Genghis.Windows.Forms.RequiredFieldValidator();
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			((System.ComponentModel.ISupportInitialize)(this.rfvUsername)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.rfvRole)).BeginInit();
			this.SuspendLayout();
			// 
			// btnOk
			// 
			this.btnOk.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.btnOk.Location = new System.Drawing.Point(88, 136);
			this.btnOk.Name = "btnOk";
			this.btnOk.TabIndex = 4;
			this.btnOk.Text = "OK";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.btnCancel.CausesValidation = false;
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(205, 136);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 5;
			this.btnCancel.Text = "Cancel";
			// 
			// txtPassword
			// 
			this.txtPassword.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.txtPassword.Location = new System.Drawing.Point(88, 56);
			this.txtPassword.MaxLength = 20;
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.Size = new System.Drawing.Size(176, 20);
			this.txtPassword.TabIndex = 2;
			this.txtPassword.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 56);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 20);
			this.label3.TabIndex = 14;
			this.label3.Text = "Password";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cbRole
			// 
			this.cbRole.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.cbRole.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbRole.Location = new System.Drawing.Point(88, 96);
			this.cbRole.Name = "cbRole";
			this.cbRole.Size = new System.Drawing.Size(176, 21);
			this.cbRole.TabIndex = 3;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 96);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 23);
			this.label1.TabIndex = 12;
			this.label1.Text = "Role";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtUsername
			// 
			this.txtUsername.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.txtUsername.Location = new System.Drawing.Point(88, 16);
			this.txtUsername.MaxLength = 50;
			this.txtUsername.Name = "txtUsername";
			this.txtUsername.Size = new System.Drawing.Size(176, 20);
			this.txtUsername.TabIndex = 1;
			this.txtUsername.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 16);
			this.label2.TabIndex = 10;
			this.label2.Text = "Username";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// rfvUsername
			// 
			this.rfvUsername.ControlToValidate = this.txtUsername;
			this.rfvUsername.ErrorMessage = "Username is required!";
			this.rfvUsername.Icon = ((System.Drawing.Icon)(resources.GetObject("rfvUsername.Icon")));
			// 
			// rfvRole
			// 
			this.rfvRole.ControlToValidate = this.cbRole;
			this.rfvRole.ErrorMessage = "Role is required";
			this.rfvRole.Icon = ((System.Drawing.Icon)(resources.GetObject("rfvRole.Icon")));
			// 
			// toolTip1
			// 
			this.toolTip1.AutoPopDelay = 15000;
			this.toolTip1.InitialDelay = 500;
			this.toolTip1.ReshowDelay = 100;
			this.toolTip1.ShowAlways = true;
			// 
			// CreateUser
			// 
			this.AcceptButton = this.btnOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(290, 174);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.txtPassword,
																		  this.label3,
																		  this.cbRole,
																		  this.label1,
																		  this.txtUsername,
																		  this.label2,
																		  this.btnOk,
																		  this.btnCancel});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "CreateUser";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Create User";
			((System.ComponentModel.ISupportInitialize)(this.rfvUsername)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.rfvRole)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void Form_Load(object sender, EventArgs e)
		{
			this.PopulateComboBox();
			string usernameTooltip = string.Concat(
				"The computer name.",
				"\nMy Computer properties > Computer Name tab \nOptionally ",
				"an arbitrary username.");
			string passwordTooltip = string.Concat(
				"Not required for Log On user authentication. \n",
				"Required for roaming user authentication. \n",
				"Enter Log On user password or arbitrary password.");
			string roleTooltip = "The security level granted to a user";

			this.toolTip1.SetToolTip(this.txtUsername, usernameTooltip);
			this.toolTip1.SetToolTip(this.txtPassword, passwordTooltip);
			this.toolTip1.SetToolTip(this.cbRole, roleTooltip);
		}

		private void btnOk_Click(object sender, System.EventArgs e)
		{
			bool isValid = true;

			foreach(Control cntrl in this.Controls)
			{
				cntrl.Focus();
			}

			if(! rfvUsername.IsValid)
			{
				txtUsername.Focus();
				isValid = false;
			}
			else if( ! rfvRole.IsValid)
			{
				cbRole.Focus();
				isValid = false;
			}

			if(isValid)
			{
				string role = cbRole.SelectedItem.ToString();
				int roleId = (int)(UserRole)System.Enum.Parse(typeof(UserRole), role , true);
				result = UserData.InsertUser(txtUsername.Text, txtPassword.Text, roleId);
				if(result == 0)
				{
					MessageBox.Show("Username is not unique! \nPlease enter a different username");
				}
				else
				{
					this.DialogResult = DialogResult.OK;
				}
			}
		}
	}
}
