using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using CCPM.Data;

namespace CCPM.User
{
	/// <summary>
	/// Summary description for UCEditUser.
	/// </summary>
	public class UCEditUser : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Button btnDelete;
		private System.Windows.Forms.Button btnUpdate;
		public System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.Label label3;
		public System.Windows.Forms.ComboBox cbRole;
		private System.Windows.Forms.Label label1;
		public System.Windows.Forms.TextBox txtUsername;
		private System.Windows.Forms.Label label2;
		private Genghis.Windows.Forms.RequiredFieldValidator rfvUsername;
		private Genghis.Windows.Forms.RequiredFieldValidator rfvRole;
		private CCPM.User.UpdateDeleteUser parent;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UCEditUser()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			this.Load += new System.EventHandler(this.UCEditUser_Load);

		}

		private void PopulateUserRole()
		{
			string[] enumNames = System.Enum.GetNames(typeof(UserRole));

			foreach(string name in enumNames)
			{
				this.cbRole.Items.Add(name);
			}

			this.cbRole.Items.Insert(0, string.Empty);
		}


		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(UCEditUser));
			this.btnDelete = new System.Windows.Forms.Button();
			this.btnUpdate = new System.Windows.Forms.Button();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.cbRole = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.txtUsername = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.rfvUsername = new Genghis.Windows.Forms.RequiredFieldValidator();
			this.rfvRole = new Genghis.Windows.Forms.RequiredFieldValidator();
			((System.ComponentModel.ISupportInitialize)(this.rfvUsername)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.rfvRole)).BeginInit();
			this.SuspendLayout();
			// 
			// btnDelete
			// 
			this.btnDelete.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.btnDelete.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.btnDelete.Location = new System.Drawing.Point(92, 176);
			this.btnDelete.Name = "btnDelete";
			this.btnDelete.Size = new System.Drawing.Size(95, 23);
			this.btnDelete.TabIndex = 33;
			this.btnDelete.Text = "Delete";
			this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
			// 
			// btnUpdate
			// 
			this.btnUpdate.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.btnUpdate.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.btnUpdate.Location = new System.Drawing.Point(92, 136);
			this.btnUpdate.Name = "btnUpdate";
			this.btnUpdate.Size = new System.Drawing.Size(95, 23);
			this.btnUpdate.TabIndex = 32;
			this.btnUpdate.Text = "Update";
			this.btnUpdate.Click += new System.EventHandler(this.btnUpdate_Click);
			// 
			// txtPassword
			// 
			this.txtPassword.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.txtPassword.Location = new System.Drawing.Point(92, 56);
			this.txtPassword.MaxLength = 20;
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.Size = new System.Drawing.Size(212, 20);
			this.txtPassword.TabIndex = 30;
			this.txtPassword.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(25, 56);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 20);
			this.label3.TabIndex = 36;
			this.label3.Text = "Password";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cbRole
			// 
			this.cbRole.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.cbRole.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.cbRole.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbRole.Location = new System.Drawing.Point(92, 96);
			this.cbRole.Name = "cbRole";
			this.cbRole.Size = new System.Drawing.Size(212, 21);
			this.cbRole.TabIndex = 31;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(25, 96);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 23);
			this.label1.TabIndex = 35;
			this.label1.Text = "Role";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtUsername
			// 
			this.txtUsername.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.txtUsername.Location = new System.Drawing.Point(92, 16);
			this.txtUsername.MaxLength = 50;
			this.txtUsername.Name = "txtUsername";
			this.txtUsername.Size = new System.Drawing.Size(212, 20);
			this.txtUsername.TabIndex = 29;
			this.txtUsername.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(25, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 16);
			this.label2.TabIndex = 34;
			this.label2.Text = "Username";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// rfvUsername
			// 
			this.rfvUsername.ControlToValidate = this.txtUsername;
			this.rfvUsername.ErrorMessage = "Username is required!";
			this.rfvUsername.Icon = ((System.Drawing.Icon)(resources.GetObject("rfvUsername.Icon")));
			// 
			// rfvRole
			// 
			this.rfvRole.ControlToValidate = this.cbRole;
			this.rfvRole.ErrorMessage = "Role is required";
			this.rfvRole.Icon = ((System.Drawing.Icon)(resources.GetObject("rfvRole.Icon")));
			// 
			// UCEditUser
			// 
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.btnDelete,
																		  this.btnUpdate,
																		  this.txtPassword,
																		  this.label3,
																		  this.cbRole,
																		  this.label1,
																		  this.txtUsername,
																		  this.label2});
			this.Name = "UCEditUser";
			this.Size = new System.Drawing.Size(344, 224);
			((System.ComponentModel.ISupportInitialize)(this.rfvUsername)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.rfvRole)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void UCEditUser_Load(object sender, System.EventArgs e)
		{
			PopulateUserRole();
			parent = ((CCPM.User.ManageUserForm)this.FindForm()).updateDeleteUser;
		}
		
		private void btnUpdate_Click(object sender, System.EventArgs e)
		{
			bool isValid = true;

			foreach(Control cntrl in this.Controls)
			{
				cntrl.Focus();
			}

			if(! rfvUsername.IsValid)
			{
				txtUsername.Focus();
				isValid = false;
			}
			else if( ! rfvRole.IsValid)
			{
				cbRole.Focus();
				isValid = false;
			}

			if(isValid)
			{
				string role = cbRole.SelectedItem.ToString();
				int roleId = (int)(UserRole)System.Enum.Parse(typeof(UserRole), role , true);
				int result = UserData.UpdateUser(txtUsername.Text, txtPassword.Text, roleId, parent.userId);
				if(result == 0)
				{
					MessageBox.Show("Username is not unique! \nPlease enter a different username");
				}
				else
				{
					parent.isLoaded = false;
					parent.PopulateUserList();
					parent.isLoaded = true;
					parent.SetUserDisplay();
				}
			}

		}

		private void btnDelete_Click(object sender, System.EventArgs e)
		{
			DeleteAlert deleteAlert = new DeleteAlert();
			DialogResult dialogResult = deleteAlert.ShowDialog(this.FindForm());
			if(dialogResult == DialogResult.OK)
			{
				UserData.DeleteUser(parent.userId);
				parent.currentSelectedIndex = 0;
				parent.PopulateUserList();
				parent.SetUserDisplay();
			}
		}
	}
}
