using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using CCPM.Data;

namespace CCPM.User
{
	/// <summary>
	/// Summary description for UpdateDeleteUser.
	/// </summary>
	public class UpdateDeleteUser : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.GroupBox gbSelect;
		private System.Windows.Forms.ListBox lbSelectUser;
		public bool isLoaded = false;
		private DataSet dsUsers = null;
		public int userId = 0;
		private System.Windows.Forms.GroupBox gbUserDetails;
		private CCPM.User.UCEditUser ucEditUser;
		private DisplayUser displayUser;
		public int currentSelectedIndex = 0;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UpdateDeleteUser()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitForm call

		}

		public void PopulateUserList()
		{
			dsUsers = UserData.GetAllUsers();
			lbSelectUser.ValueMember = "User.UserId";
			lbSelectUser.DisplayMember = "User.Username";
			lbSelectUser.DataSource = dsUsers;

			for(int i = 0; i < lbSelectUser.Items.Count; i++)
			{
				if(((DataRowView)lbSelectUser.Items[i])["UserId"].ToString() == this.userId.ToString())
				{
					lbSelectUser.SelectedIndex = i;
					break;
				}
			}
		}


		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gbSelect = new System.Windows.Forms.GroupBox();
			this.lbSelectUser = new System.Windows.Forms.ListBox();
			this.gbUserDetails = new System.Windows.Forms.GroupBox();
			this.gbSelect.SuspendLayout();
			this.SuspendLayout();
			// 
			// gbSelect
			// 
			this.gbSelect.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left);
			this.gbSelect.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.lbSelectUser});
			this.gbSelect.Location = new System.Drawing.Point(10, 21);
			this.gbSelect.Name = "gbSelect";
			this.gbSelect.Size = new System.Drawing.Size(200, 390);
			this.gbSelect.TabIndex = 0;
			this.gbSelect.TabStop = false;
			this.gbSelect.Text = "Select User";
			// 
			// lbSelectUser
			// 
			this.lbSelectUser.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.lbSelectUser.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lbSelectUser.Location = new System.Drawing.Point(3, 16);
			this.lbSelectUser.Name = "lbSelectUser";
			this.lbSelectUser.Size = new System.Drawing.Size(194, 368);
			this.lbSelectUser.TabIndex = 0;
			this.lbSelectUser.SelectedIndexChanged += new System.EventHandler(this.lbSelectUser_SelectedIndexChanged);
			// 
			// gbUserDetails
			// 
			this.gbUserDetails.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gbUserDetails.Location = new System.Drawing.Point(221, 21);
			this.gbUserDetails.Name = "gbUserDetails";
			this.gbUserDetails.Size = new System.Drawing.Size(355, 232);
			this.gbUserDetails.TabIndex = 2;
			this.gbUserDetails.TabStop = false;
			this.gbUserDetails.Text = "User Details";
			// 
			// UpdateDeleteUser
			// 
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gbSelect,
																		  this.gbUserDetails});
			this.DockPadding.All = 10;
			this.Name = "UpdateDeleteUser";
			this.Size = new System.Drawing.Size(592, 424);
			this.Load += new System.EventHandler(this.UpdateDeleteUser_Load);
			this.gbSelect.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void UpdateDeleteUser_Load(object sender, System.EventArgs e)
		{
			displayUser = new DisplayUser();
//			gbUserDetails.Controls.Add(displayUser);
//			displayUser.Dock = DockStyle.Fill;
			PopulateUserList();
			this.isLoaded = true;
			SetUserDisplay();
		}

		public void PopulateEditDisplay()
		{
			ucEditUser = new CCPM.User.UCEditUser();
			gbUserDetails.Controls.Clear();
			gbUserDetails.Controls.Add(ucEditUser);
			ucEditUser.Dock = DockStyle.Fill;

			DataViewManager dvm = dsUsers.DefaultViewManager;
			DataView dv = dvm.CreateDataView(dsUsers.Tables[0]);
			dv.RowFilter = string.Format("UserId = {0}", this.lbSelectUser.SelectedValue.ToString());
			DataRowView drv = dv[0];
			this.userId = (int)drv["UserId"];
			ucEditUser.txtUsername.Text = drv["Username"].ToString();
			ucEditUser.txtPassword.Text = drv["Password"].ToString();
			UserRole role = (UserRole)(int)drv["RoleId"];
			for(int i = 0; i < ucEditUser.cbRole.Items.Count; i++)
			{
				object obj = ucEditUser.cbRole.Items[i];
				if(role.ToString() == obj.ToString())
				{
					ucEditUser.cbRole.SelectedIndex = i;
					break;
				}
			}
		}

		public void SetUserDisplay()
		{
			gbUserDetails.Controls.Clear();
			gbUserDetails.Controls.Add(displayUser);
			displayUser.Dock = DockStyle.Fill;

			DataViewManager dvm = dsUsers.DefaultViewManager;
			DataView dv = dvm.CreateDataView(dsUsers.Tables[0]);
			dv.RowFilter = string.Format("UserId = {0}", this.lbSelectUser.SelectedValue.ToString());
			DataRowView drv = dv[0];
			this.userId = (int)drv["UserId"];
			displayUser.lblShowUsername.Text = drv["Username"].ToString();
			displayUser.lblShowPassword.Text = drv["Password"].ToString();
			UserRole role = (UserRole)(int)drv["RoleId"];
			displayUser.lblShowRole.Text = role.ToString();
		}

		private void lbSelectUser_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(isLoaded)
			{
				SetUserDisplay();
				//TODO: Use userId instead of selected index
				currentSelectedIndex = lbSelectUser.SelectedIndex; 
			}
		}

		private void btnUpdate_Click(object sender, System.EventArgs e)
		{
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.FindForm().DialogResult = DialogResult.Cancel;
		}

		private void gbUserDetails_Enter(object sender, System.EventArgs e)
		{
		
		}
	}
}
